/*
 *  TOPPERS/OSEK COM
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK COM
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *	COMG[`FbNp}N
 *		2005.4.18 OʐMΉ
 *			 5.30 _Ci~bNbZ[W̃f[^`FbNC
 *
 *	̃t@CɋLqĂ}N
 *	ECOM API ɓnꂽ͈ɂExtendedG[ł邩`FbN
 *	ECOMR[x̃`FbN
 */

#ifndef _COM_CHECK_H_
#define _COM_CHECK_H_

#include "osek_com.h"

/*
 *  e`FbNp}N
 */

/*
 *  ӓ_
 *  E|C^œnNULLł邩̃`FbN͂Ȃ
 *  Ef[^̓oCgňD
 *    OILł̓rbg\L̂߁CWŊ|ĂrĂD
 */

/* AvP[V[h̃`FbN */
#define CHECK_COMAPPMODE(mode) do { 	\
	if (0 == ((mode) & COMAPPMODE)) {	\
		ercd = E_COM_ID;				\
		goto error_exit;				\
	}									\
} while(0)

/* Vbg_E[h̃`FbN */
#define CHECK_COMSTOPMODE(stop_mode) do {			\
	if (0 == ((stop_mode) & COM_SHUTDOWN)) {		\
		ercd = E_COM_ID;							\
		goto error_exit;							\
	}												\
} while(0)

/* M-ʏ탁bZ[WȊO̓G[ */
#define	CHECK_RECVMSG(msgid) do {		\
	if ((0 == ((msgid) & MSG_RCV_MASK)) || (MSG_NULL == (msgid))) {	\
		ercd = E_COM_ID;				\
		goto error_exit;				\
	}									\
} while (0)
	
/* M-ʏ탁bZ[WȊO̓G[ */
#define CHECK_SENDMSG(msgid) do{		\
	if ((0 == ((msgid) & MSG_SND_MASK)) || (MSG_NULL == (msgid))) {	\
		ercd = E_COM_ID;				\
		goto error_exit;				\
	}									\
} while(0)

/* L[bZ[WȊO̓G[ */
#define	CHECK_QUEMSG(msgid)	do {	\
	if ((0 == ((msgid) & MSG_RCV_QUED)) || (MSG_NULL == (msgid))) {	\
		ercd = E_COM_ID;			\
		goto error_exit;			\
	}								\
} while(0)

/* L[bZ[W̏ꍇL[łȂ */
/*
 *  WG[Ȃ̂Ń`FbN}N͎gȂ
 */

/* ғǂ̃`FbN */
#define CHECK_COMCALLEVEL(comclmask) do {	\
	if (0 == (comcallevel & (comclmask))) {	\
		ercd = E_COM_SYS_CALLEVEL;			\
		goto error_exit;					\
	}										\
} while(0)

/* M-_Ci~bNbZ[WȊO̓G[ */
#define CHECK_SND_DYNAMIC(msgid) do {	\
	if ((MSG_SND_DYNA != ((msgid) & MSG_SND_DYNA)) || (MSG_NULL == (msgid))) {	\
		ercd = E_COM_ID;							\
		goto error_exit;							\
	}												\
} while(0)

/* M-_Ci~bNbZ[WȊO̓G[ */
#define CHECK_RCV_DYNAMIC(msgid) do {	\
	if ((MSG_RCV_DYNA != ((msgid) & MSG_RCV_DYNA)) || (MSG_NULL == (msgid))) {	\
		ercd = E_COM_ID;							\
		goto error_exit;							\
	}												\
} while(0)

/* M-[bZ[WȊO̓G[ */
#define CHECK_SND_ZERO(msgid) do { \
	if ((MSG_SND_ZERO != ((msgid) & MSG_SND_ZERO))||\
		(MSG_SND_DYNA == ((msgid) & MSG_SND_DYNA))||\
 			(MSG_NULL == (msgid))) { \
			 ercd = E_COM_ID;  \
			 goto error_exit;  \
	}       \
} while(0) 

/*
 *  OX`FbNiMj
 *  msgiduM_Ci~bNbZ[Wvł邱ƂO
 *  ȊÕbZ[W̏ꍇC͕s
 */
#define CHECK_SND_LENGTH(msgid, p_len) do {	\
	if (MSG_SND_PEND == ((msgid) & MSG_SND_PEND)) {	\
		if (((*(p_len) * 8) <= 0) || 		\
			(bitsize_snd_ex_pend_dyna[((msgid) & MSG_ID_MASK)] < (*(p_len) * 8))) {	\
			ercd = E_COM_LENGTH;		\
			goto error_exit;			\
		}								\
	}									\
	else {								\
		if (((*(p_len) * 8) <= 0) || 	\
			(bitsize_snd_ex_trig_dyna[((msgid) & MSG_ID_MASK)] < (*(p_len) * 8))) {	\
			ercd = E_COM_LENGTH;		\
			goto error_exit;			\
		}								\
	}									\
} while(0)

/*
 *  bZ[WIDȏꍇG[
 */
#define CHECK_VALID_MSGID(msgid) do {	\
	if (MSG_NULL == (msgid)) {			\
		ercd = E_COM_ID;				\
		goto error_exit;				\
	}									\
} while(0)

/*
 *  bZ[WIDl`FbN
 */
/* MbZ[W */
#define CHECK_MAX_RCV_NORM( msgid_no ) do {		\
	if ( (msgid_no) > tnum_rcv_unq_norm ) {		\
		ercd = E_COM_ID;						\
		goto d_error_exit;						\
	}											\
} while(0)

#define CHECK_MAX_RCV_ZERO( msgid_no ) do {		\
	if ( (msgid_no) > tnum_rcv_unq_zero ) {		\
		ercd = E_COM_ID;						\
		goto error_exit;						\
	}											\
} while(0)

#define CHECK_MAX_RCV_DYNA( msgid_no ) do {		\
	if ( (msgid_no) > tnum_rcv_unq_dyna ) {		\
		ercd = E_COM_ID;						\
		goto d_error_exit;						\
	}											\
} while(0)

#define CHECK_MAX_RCV_DYNA_EI( msgid_no ) do {	\
	if ( (msgid_no) > tnum_rcv_unq_dyna ) {		\
		ercd = E_COM_ID;						\
		goto error_exit;						\
	}											\
} while(0)

#define CHECK_MAX_RCV_QUED( msgid_no ) do {		\
	if ( (msgid_no) > tnum_rcv_que_norm ) {		\
		ercd = E_COM_ID;						\
		goto d_error_exit;						\
	}											\
} while(0)

/* IPDUMbZ[W */
#define CHECK_MAX_RCV_IPDU_NORM( msgid_no ) do {	\
	if ( (msgid_no) > tnum_rcv_ipdu_norm ) {		\
		ercd = E_COM_ID;							\
		goto error_exit;							\
	}												\
} while(0)

#define CHECK_MAX_RCV_IPDU_ZERO( msgid_no ) do {	\
	if ( (msgid_no) > tnum_rcv_ipdu_zero ) {		\
		ercd = E_COM_ID;							\
		goto error_exit;							\
	}												\
} while(0)

#define CHECK_MAX_RCV_IPDU_DYNA( msgid_no ) do {	\
	if ( (msgid_no) > tnum_rcv_ipdu_dyna ) {		\
		ercd = E_COM_ID;							\
		goto error_exit;							\
	}												\
} while(0)

/* MbZ[W */
#define CHECK_MAX_SND_NORM( msgid_no ) do {		\
	if ( (msgid_no) > tnum_snd_in_norm ) {		\
		ercd = E_COM_ID;						\
		goto d_error_exit;						\
	}											\
} while(0)

#define CHECK_MAX_SND_ZERO( msgid_no ) do {		\
	if ( (msgid_no) > tnum_snd_in_zero ) {		\
		ercd = E_COM_ID;						\
		goto d_error_exit;						\
	}											\
} while(0)

/* OMbZ[W */
#define CHECK_MAX_SND_TRIG_NORM( msgid_no ) do {	\
	if ( (msgid_no) > tnum_snd_ex_trig_norm ) {		\
		ercd = E_COM_ID;							\
		goto d_error_exit;							\
	}												\
} while(0)

#define CHECK_MAX_SND_PEND_NORM( msgid_no ) do {	\
	if ( (msgid_no) > tnum_snd_ex_pend_norm ) {		\
		ercd = E_COM_ID;							\
		goto d_error_exit;							\
	}												\
} while(0)

#define CHECK_MAX_SND_TRIG_ZERO( msgid_no ) do {	\
	if ( (msgid_no) > tnum_snd_ex_trig_zero ) {		\
		ercd = E_COM_ID;							\
		goto d_error_exit;							\
	}												\
} while(0)

#define CHECK_MAX_SND_TRIG_DYNA( msgid_no ) do {	\
	if ( (msgid_no) > tnum_snd_ex_trig_dyna ) {		\
		ercd = E_COM_ID;							\
		goto d_error_exit;							\
	}												\
} while(0)

#define CHECK_MAX_SND_PEND_DYNA( msgid_no ) do {	\
	if ( (msgid_no) > tnum_snd_ex_pend_dyna ) {		\
		ercd = E_COM_ID;							\
		goto d_error_exit;							\
	}												\
} while(0)

#define CHECK_SND_DYNA(msgid) do {						\
	if (MSG_SND_PEND == ((msgid) & MSG_SND_PEND)) {		\
		if ( msgid_no > tnum_snd_ex_pend_dyna ) {		\
			ercd = E_COM_ID;							\
			goto error_exit;							\
		}												\
	}													\
	else {												\
		if ( msgid_no > tnum_snd_ex_trig_dyna ) {		\
			ercd = E_COM_ID;							\
			goto error_exit;							\
		}												\
	}													\
} while(0)

#endif /* _COM_CHECK_H_ */
