/*
 *  TOPPERS/OSEK COM
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK COM
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *  CN[h
 */
#include	"osek_com.h"
#include	"com_timer.h"
#include	"com_interrupt.h"

/*
 *  \̒`
 */
/* MESSAGECIPDUXVɕKvȏ */
typedef	struct {
	UINT32	m_sizeinbits;			/* MESSGAE.SIZEINBITS					 */
	UINT32	m_bitposition;			/* NETWORKMESSAGE.BITPOSITION			 */
	UINT32	m_cdatasize;			/* MESSAGE.CDATATYPE					 */
	BOOL	m_byteorder;			/* NETWORKMESSAGE.DATAINTERPRETATION	 */
									/*	TRUE:UNSIGNEDINTEGER FALSE:BYTEARRAY */
	BOOL	m_bitorder;				/* NETWORKMESSAGE.BITORDERING			 */
									/*	TRUE:BIGENDIAN FALSE:LITTLEENDIAN	 */
	BOOL	m_bytebigendian_local;	/* [JCPŨoCgGfBA	 	 */
									/*	TRUE:BIGENDIAN FALSE:LITTLEENDIAN	 */
} UpdateParam ;

/*
 *  vg^Cv錾
 */
static StatusType	update_Ipdu_bitlittle(		MessageIdentifier msgid,
												UINT8* p_msg,
												UINT8* p_ipdu,
												const UpdateParam* para );
static StatusType	update_Ipdu_bitbig(			MessageIdentifier msgid,
												UINT8* p_msg,
												UINT8* p_ipdu,
												const UpdateParam* para );
static StatusType	update_Message_bitlittle(	MessageIdentifier msgid,
												UINT8* p_ipdu,
												UINT8* p_msg,
												const UpdateParam* para );
static StatusType	update_Message_bitbig(		MessageIdentifier msgid,
												UINT8* p_ipdu,
												UINT8* p_msg,
												const UpdateParam* para );
static BOOL			check_ByteBigEndian(void);

/*
 *  }N`
 */
/* src̃rbgVtgsC8bit̒lԂ */
#define  SHL16HIGH( src, dest, shift ) do { \
    (src) <<= (shift);						\
    *(UINT8*)(dest) = (UINT8)((src)>>8);    \
}while(0)

/* src̃rbgEVtgsC8bit̒lԂ */
#define  SHR16LOW( src, dest, shift )  do { \
    (src) >>= (shift);						\
    *(UINT8*)(dest) = (UINT8)(src);         \
}while(0)

/* 8bitl rbgGfBAϊ */
#define CHG_BITORDER( ui8para )   do {		\
   ui8low = (ui8para) & 0x0f;				\
   (ui8para) >>= 4;							\
   ui8last = (bitendian_change[ui8low]<<4); \
   ui8last |= bitendian_change[(ui8para)];  \
}while(0)

/*
 *  constl`
 */
/* rbgGfBAϊe[uiSrbĝݑΉj */
static const UINT8 bitendian_change[16] = 
{	0x00, 0x08, 0x04, 0x0C, 0x02, 0x0A, 0x06, 0x0E,
	0x01, 0x09, 0x05, 0x0D, 0x03, 0x0B, 0x07, 0x0f
};

/*--------------------------------------------------------------------
 * Tv      FMESSAGEIuWFNg̃oCgI[_[ϊ֐
 * @\      Fw肳ꂽf[^p_srcoCgI[_[ϊCp_destɔzuD
 * (in)  F<msgid>     bZ[WID
 *           F<p_src>     ϊ|C^
 *           F<p_dest>    ϊʏo͐|C^
 *     (out) FȂ
 * ߂l    FE_OK        I
 * l      FoCgI[_[ΐCMESSAGẼTCYŜ̃oCgʒut]D
 *           F擪̃oCgŌɔzuCŌ̃oCg擪ɔzuD
 *           F܂CϊΏۊOmsgid̏ꍇCp_destɂ͉zuCE_OKԂD
 *-------------------------------------------------------------------*/
StatusType
convert_byteorder( MessageIdentifier msgid, const UINT8* p_src, UINT8* p_dest )
{
	StatusType	ercd		= E_OK;
	UINT32		cdatasize	= 0;
	INT32		direction	= 0;
	UINT32		i			= 0;
	BOOL		byteorder	= TRUE;

	if( ( ( MSG_SND_NORM | MSG_SND_EXT | MSG_SND_PEND ) )
		== ( msgid & MSG_SND_MASK ) ) 
	{
		cdatasize	= msgsize_snd_ex_pend_norm[(msgid & MSG_ID_MASK)];
		byteorder	= (BOOL)byteorder_snd_ex_pend_norm[(msgid & MSG_ID_MASK)];
	}
	else if( ( MSG_SND_NORM | MSG_SND_EXT )
		== ( msgid & MSG_SND_MASK ) ) 
	{
		cdatasize	= msgsize_snd_ex_trig_norm[(msgid & MSG_ID_MASK)];
		byteorder	= (BOOL)byteorder_snd_ex_trig_norm[(msgid & MSG_ID_MASK)];
	}
	else if( ( MSG_RCV_NORM | MSG_RCV_IPDU )
		== ( msgid & ( MSG_RCV_MASK ) ) ) 
	{
		cdatasize	= bytesize_rcv_ipdu_norm[(msgid & MSG_ID_MASK)];
		byteorder	= (BOOL)byteorder_rcv_ipdu_norm[(msgid & MSG_ID_MASK)];
	}
	else {
		goto error_exit;
	}
	direction	= 1;
	
	if(TRUE == byteorder) {
		p_src		+= (cdatasize-1);
		direction	= -1;
	}

	/* obt@ */
	for( i = 0 ; i < cdatasize ; i++ ){
		*p_dest =0;
		p_dest++;
	}
	p_dest -= cdatasize;
	
	for( i = 0 ; i < cdatasize ; i++ ){

		*p_dest	= *p_src;
		p_dest++;
		p_src 	+= direction;
	}
  exit:
  error_exit:
	return(ercd);
}

/*--------------------------------------------------------------------
 * Tv      FDYNAMICbZ[WpIPDUXV֐
 * @\      FDYNAMICbZ[WIPDUIuWFNgɔzuD
 * (in)  F<msgid>     bZ[WID
 *           F<p_msg>     ϊ|C^iMESSAGEIuWFNgj
 *           F<p_ipdu>    ϊʏo͐|C^iIPDUIuWFNgj
 *           F<p_len>     MESSAGẼoCg
 *     (out) FȂ
 * ߂l    FE_OK        I
 * l      Fmsgid͑M-ʏ탁bZ[ŴݍXVΏۂƂD
 *           FΏۊOmsgid̏ꍇCp_ipduɂ͉o͂CE_OKԂD
 *------------------------------------------------------------------*/
StatusType
update_Ipdu_Dyna( MessageIdentifier msgid, const UINT8* p_msg, UINT8* p_ipdu,
														LengthRef p_len )
{
	StatusType	ercd = E_OK;
	UpdateParam	para;

	UINT32 len=0;
	UINT32 i;
	UINT8 bit=0;
	UINT8 bit_end=0;
	UINT8 bit_pos=0;

	/* IPDUXV֐gp̂߂ɁCݎgĂȂϐXV */
	if( ( MSG_SND_DYNA | MSG_SND_EXT ) == ( msgid & MSG_SND_MASK ) ) {
		para.m_cdatasize	 = *p_len;
		para.m_sizeinbits	 = (((UINT32)(*p_len)) << 3);
		para.m_bitposition = offset_snd_ex_trig_dyna[(msgid & MSG_ID_MASK)];
		para.m_byteorder	 = TRUE;
		para.m_bitorder	 = (BOOL)bitorder_snd_ex_trig_dyna[(msgid & MSG_ID_MASK)];
	}
	else if( ( MSG_SND_DYNA | MSG_SND_EXT | MSG_SND_PEND )
				 == ( msgid & MSG_SND_MASK ) ) {
		para.m_cdatasize	 = *p_len;
		para.m_sizeinbits	 = (((UINT32)(*p_len)) << 3);
		para.m_bitposition = offset_snd_ex_pend_dyna[(msgid & MSG_ID_MASK)];
		para.m_byteorder	 = TRUE;
		para.m_bitorder	 = (BOOL)bitorder_snd_ex_pend_dyna[(msgid & MSG_ID_MASK)];
	}
	else {
		goto error_exit;
	}

	/* bZ[WItZbgֈړ */
	p_ipdu += (para.m_bitposition/8);

	/* Rs[X^[gʒǔvZ */
	bit_pos = (UINT8)(para.m_bitposition % 8);

	/* bZ[WTCY */
	len = para.m_sizeinbits / 8;
	if(len==0)
	{
		len=1;
	}else
	{
		len++;
	}
	/* IBITvZ */
	bit_end = (UINT8)(para.m_sizeinbits % 8);

	/* IPDUփRs[ */
	for(i=0;i<len;i++)
	{
		for( bit=0; bit <((i==(len-1))?bit_end:8) ; bit++ )
		{
			/* IPDU̎bZ[W̏ */
			*p_ipdu = (UINT8)(*p_ipdu & (UINT8)(0xFF ^ (0x80 >> bit_pos)));

			if( 0x00 != (*p_msg & (0x80 >> bit)))
			{
				*p_ipdu = (UINT8)(*p_ipdu | (0x80 >> bit_pos));		/* IPDU̎bZ[W̃Zbg */
			}
			
			bit_pos++;
			
			if( bit_pos == 8 )
			{
				p_ipdu++;
				bit_pos=0;
			}
		}
		p_msg++;
	}

  exit:
  error_exit:
	return(ercd);
}

/*--------------------------------------------------------------------
 * Tv      FIPDUXV֐
 * @\      FMESSAGEIuWFNgIPDUIuWFNgɔzu
 * (in)  F<msgid>     bZ[WID
 *           F<p_msg>     ϊ|C^iMESSAGEIuWFNgj
 *           F<p_ipdu>    ϊʏo͐|C^iIPDUIuWFNgj
 *           F<para>      IPDUXVɕKvȏ
 *     (out) FȂ
 * ߂l    FE_OK        I
 * l      Fmsgid͑M-ʏ탁bZ[ŴݍXVΏۂƂD
 *           FΏۊOmsgid̏ꍇCp_ipduɂ͉o͂CE_OKԂD
 *------------------------------------------------------------------*/
StatusType
update_Ipdu( MessageIdentifier msgid, const UINT8* p_msg, UINT8* p_ipdu )
{
	StatusType	ercd = E_OK;
	UpdateParam	para;

	UINT32 len=0;
	UINT32 i;
	UINT8 bit=0;
	UINT8 bit_end=0;
	UINT8 bit_pos=0;

	/* IPDUXV֐gp̂߂ɁCݎgĂȂϐXV */
	if( (( MSG_SND_NORM | MSG_SND_EXT | MSG_SND_PEND ))
			== ( msgid & MSG_SND_MASK ) ) 
	{
		/* ʏ yfBO */
		para.m_cdatasize	 = msgsize_snd_ex_pend_norm[(msgid & MSG_ID_MASK)];
		para.m_sizeinbits	 = bitsize_snd_ex_pend_norm[(msgid & MSG_ID_MASK)];
		para.m_bitposition = offset_snd_ex_pend_norm[(msgid & MSG_ID_MASK)];
		
		para.m_byteorder	 = (BOOL)byteorder_snd_ex_pend_norm[(msgid & MSG_ID_MASK)];
		para.m_bitorder	 = (BOOL)bitorder_snd_ex_pend_norm[(msgid & MSG_ID_MASK)];
	}
	else if( ( ( MSG_SND_NORM | MSG_SND_EXT ) ) == ( msgid & MSG_SND_MASK ) )
	{
		/* ʏ gK */
		para.m_cdatasize	 = msgsize_snd_ex_trig_norm[(msgid & MSG_ID_MASK)];
		para.m_sizeinbits	 = bitsize_snd_ex_trig_norm[(msgid & MSG_ID_MASK)];
		para.m_bitposition = offset_snd_ex_trig_norm[(msgid & MSG_ID_MASK)];
		
		para.m_byteorder	 = (BOOL)byteorder_snd_ex_trig_norm[(msgid & MSG_ID_MASK)];
		para.m_bitorder	 = (BOOL)bitorder_snd_ex_trig_norm[(msgid & MSG_ID_MASK)];
	}
	else {
		goto error_exit;
	}
	if( !(para.m_sizeinbits) ) {
		goto error_exit;
	}

	/* bZ[WItZbgֈړ */
	p_ipdu += (para.m_bitposition/8);

	/* Rs[X^[gʒǔvZ */
	bit_pos = (UINT8)(para.m_bitposition % 8);
	
	/* bZ[WTCY */
	len = para.m_sizeinbits / 8;
	if(len==0)
	{
		len=1;
	}else
	{
		len++;
	}
	/* IBITvZ */
	bit_end = (UINT8)(para.m_sizeinbits % 8);
	
	/* IPDUփRs[ */
	for(i=0;i<len;i++)
	{
		for( bit=0; bit <((i==(len-1))?bit_end:8) ; bit++ )
		{
			/* IPDU̎bZ[W̏ */
			*p_ipdu = (UINT8)(*p_ipdu & (UINT8)(0xFF ^ (0x80 >> bit_pos)));

			if( 0x00 != (*p_msg & (0x80 >> bit)))
			{
				*p_ipdu = (UINT8)(*p_ipdu | (0x80 >> bit_pos));		/* IPDU̎bZ[W̃Zbg */
			}
			
			bit_pos++;
			
			if( bit_pos == 8 )
			{
				p_ipdu++;
				bit_pos=0;
			}
		}
		p_msg++;
	}

  exit:
  error_exit:
	return(ercd);
}

/*--------------------------------------------------------------------
 * Tv      FIPDUXV֐(BITORDERING = LITTLEENDIAN)
 * @\      FMESSAGEIuWFNgIPDUIuWFNgɔzu
 * (in)  F<msgid>     bZ[WID
 *           F<p_msg>     ϊ|C^iMESSAGEIuWFNgj
 *           F<p_ipdu>    ϊʏo͐|C^iIPDUIuWFNgj
 *           F<para>      IPDUXVɕKvȏ
 *     (out) FȂ
 * ߂l    FE_OK        I
 * l      Fmsgidɒʏ탁bZ[WȊOw肵Ă͂ȂȂD
 *           F̏ꍇCۏ؂łȂD
 *           F̊gpD
 *------------------------------------------------------------------*/
static StatusType
update_Ipdu_bitlittle(	MessageIdentifier msgid,
						UINT8* p_msg, UINT8* p_ipdu, const UpdateParam* para )
{
	StatusType	ercd			= E_OK;
	UINT16		ui16work		= 0;	/* ϊpf[^[N				*/
	UINT8		ui8work			= 0;	/* IPDUXVl					*/
	UINT8		bit_shift		= 0;	/* rbgVtgl					*/
	UINT32		x				= 0;	/* ŏ̃oCg̍XVrbg		*/
	UINT32		y				= 0;	/* Ԃ̃oCg					*/
	UINT32		z				= 0;	/* ŏĨoCg̍XVrbg		*/
	INT32		msg_direction	= 0;	/* p_msg|C^XV			*/
	INT32		ipdu_direction	= 0;	/* p_ipdu|C^XV			*/

	msg_direction	= 1;
	ipdu_direction	= 1;
	p_ipdu 			= p_ipdu + (para->m_bitposition >> 3);
	if( para->m_bytebigendian_local != para->m_byteorder ){
		/* byte endian big */
		msg_direction	= -1;
		p_msg 			= (p_msg + para->m_cdatasize) - 1;
		ipdu_direction	= -1;
	}
	/*
	 * IPDUŉoCgKv߁C
	 * 		Fŏ̃oCg̍XVrbg
	 * 		FԂ̃oCg̍XVoCg
	 * 		FŌ̃oCg̍XVrbg
	 * ɕčl
	 */
	#ifdef	_COM_SIZEINBITS_8BIT_TYPE_ONLY_
	/*
	 *	bZ[WWrbgPʂBITPOSITIONW̔{݂̂̏ꍇ̃R[h
	 */
	y = para->m_sizeinbits >> 3;
	/* pxȂƍlp^[ŏxコD */
	/* BITPOSITIONW̔{ŁCbZ[W̃oCgPʂ̃f[^C */
	/*  IPDUŃoCg܂肵Ȃꍇ͏xコD   */
	if( 8 >= y ) { /* WoCgȉ̏ꍇ͂ɏxシD */
		/* for[v̏邽switchgp */
		switch(y) {
		case 8:
			*p_ipdu 	= *p_msg;
			p_msg		+= msg_direction;
			p_ipdu		+= ipdu_direction;
		case 7:
			*p_ipdu 	= *p_msg;
			p_msg		+= msg_direction;
			p_ipdu		+= ipdu_direction;
		case 6:
			*p_ipdu 	= *p_msg;
			p_msg		+= msg_direction;
			p_ipdu		+= ipdu_direction;
		case 5:
			*p_ipdu 	= *p_msg;
			p_msg		+= msg_direction;
			p_ipdu		+= ipdu_direction;
		case 4:
			*p_ipdu 	= *p_msg;
			p_msg		+= msg_direction;
			p_ipdu		+= ipdu_direction;
		case 3:
			*p_ipdu 	= *p_msg;
			p_msg		+= msg_direction;
			p_ipdu		+= ipdu_direction;
		case 2:
			*p_ipdu 	= *p_msg;
			p_msg		+= msg_direction;
			p_ipdu		+= ipdu_direction;
		case 1:
			*p_ipdu 	= *p_msg;
			p_ipdu		+= ipdu_direction;
			break;
		default:
			break;
		}
	}
	else {
		for( ; 0<y ; y-- ) {
			*p_ipdu 	= *p_msg;
			p_msg		+= msg_direction;
			p_ipdu		+= ipdu_direction;
		}
		p_msg		-= msg_direction;
	}
	#else	/*	_COM_SIZEINBITS_8BIT_TYPE_ONLY_	*/
	/*
	 *	bZ[WCӃrbgPʂBITPOSITIONCӂ̏ꍇ̃R[h
	 */
	
	x			= 8 - ( (para->m_bitposition) & 0x00000007 );	
	if( x >= para->m_sizeinbits ) {
		y			= 0;
		z			= 0;
	}
	else {
		y			= (para->m_sizeinbits - x) >> 3;	
		z			= (para->m_sizeinbits - x) & 0x00000007;
	}
	bit_shift	= (UINT8)(para->m_bitposition & 0x00000007);

	/* IPDU̍ŏ̃oCg̍XV	 rbg̓] */
	if( 0 != bit_shift ) {
		ui16work 	= (UINT16)((UINT16)(*p_msg)<< 8);
		if( para->m_sizeinbits < 8 ) {
			ui16work 	= (UINT16)((UINT16)((*p_msg)&(0xff>>(8-para->m_sizeinbits)))<<8);
		}
		SHL16HIGH( ui16work, &ui8work, bit_shift );
		*p_ipdu 	= (UINT8)((*p_ipdu & ( 0xff >> ( 8 - bit_shift ) ) ) | ui8work);
		p_ipdu		+= ipdu_direction;
	}
	else {
		/* ŏ̃oCg */
		if( 8 <= para->m_sizeinbits ) {
			/* ŏ̃oCgWrbg̏ꍇ́CԂ̃oCgƂĈD */
			y			+= 1;
		}
		else {
			*p_ipdu		= (UINT8)((*p_ipdu & (UINT8)( 0xff << para->m_sizeinbits ))
						| ( (*p_msg) & ( 0xff >> (8 - para->m_sizeinbits) ) ));
			p_ipdu		+= ipdu_direction;
		}
		/* pxȂƍlp^[ŏxコ */
		/* BITPOSITIONW̔{ŁCbZ[W̃oCgPʂ̃f[^C */
		/*  IPDUŃoCg܂肵Ȃꍇ͏xコD   */

		p_ipdu = (p_ipdu+y)-1;

		if( 8 >= y ) { /* WoCgȉ̏ꍇ͂ɏxシ */
			/* for[v̏邽switchgp */
			switch(y) {
			case 8:
				*p_ipdu 	= *p_msg;
				p_msg		+= msg_direction;
				p_ipdu		+= ipdu_direction;
			case 7:
				*p_ipdu 	= *p_msg;
				p_msg		+= msg_direction;
				p_ipdu		+= ipdu_direction;
			case 6:
				*p_ipdu 	= *p_msg;
				p_msg		+= msg_direction;
				p_ipdu		+= ipdu_direction;
			case 5:
				*p_ipdu 	= *p_msg;
				p_msg		+= msg_direction;
				p_ipdu		+= ipdu_direction;
			case 4:
				*p_ipdu 	= *p_msg;
				p_msg		+= msg_direction;
				p_ipdu		+= ipdu_direction;
			case 3:
				*p_ipdu 	= *p_msg;
				p_msg		+= msg_direction;
				p_ipdu		+= ipdu_direction;
			case 2:
				*p_ipdu 	= *p_msg;
				p_msg		+= msg_direction;
				p_ipdu		+= ipdu_direction;
			case 1:
				*p_ipdu 	= *p_msg;
				p_ipdu		+= ipdu_direction;
				break;
			default:
				break;
			}
			y=0;
		}
		else {
			for( ; 0<y ; y-- ) {
				*p_ipdu 	= *p_msg;
				p_msg		+= msg_direction;
				p_ipdu		+= ipdu_direction;
			}
			p_msg		-= msg_direction;
		}
	}
	
	/* IPDU̒Ԃ̃oCg̍XV	 Wrbg̓] */
	for( ; 0<y ; y-- ) {
		ui16work = (UINT16)*p_msg;
		p_msg		+= msg_direction;
		ui16work	= (UINT16)(ui16work	| (((UINT16)*p_msg) << 8));
		SHL16HIGH( ui16work, p_ipdu, bit_shift );
		p_ipdu		+= ipdu_direction;
	}
	/* IPDU̍Ō̃oCg̍XV	 rbg̓] */
	if( 0 < z ) {
		ui16work	= ((UINT16)*p_msg);
		if( ((para->m_sizeinbits & 0x0000007) < z) || (0 == bit_shift) ) {
			p_msg		+= msg_direction;
			ui16work	= (UINT16)(ui16work	| (((UINT16)*p_msg) << 8));
		}
		SHL16HIGH( ui16work, &ui8work, bit_shift );
		*p_ipdu		= (UINT8)((*p_ipdu & (UINT8)( 0xff << z )) 
						| ( ui8work & ( 0xff >> (8 - z) ) ));
	}
	#endif	/*	_COM_SIZEINBITS_8BIT_TYPE_ONLY_	*/
  exit:
  error_exit:
	return(ercd);
}

/*--------------------------------------------------------------------
 * Tv      FIPDUXV֐(BITORDERING = BIGENDIAN)
 * @\      FMESSAGEIuWFNgIPDUIuWFNgɔzuD
 * (in)  F<msgid>     bZ[WID
 *           F<p_msg>     ϊ|C^iMESSAGEIuWFNgj
 *           F<p_ipdu>    ϊʏo͐|C^iIPDUIuWFNgj
 *     (out) FȂ
 * ߂l    FE_OK        I
 * l      Fmsgidɒʏ탁bZ[WȊOw肵Ă͂ȂȂD
 *           F̏ꍇCۏ؂łȂD
 *           F̊gpD
 *------------------------------------------------------------------*/
static StatusType
update_Ipdu_bitbig( MessageIdentifier msgid,
						UINT8* p_msg, UINT8* p_ipdu, const UpdateParam* para )
{
	StatusType	ercd			= E_OK;
	UINT16		ui16work		= 0; /* ϊpf[^[N			 */
	UINT8		ui8work			= 0; /* IPDUXVl			 */
	UINT8		ui8last			= 0; /* rbgGfBAύX[N */
	UINT8		ui8low			= 0; /* rbgGfBAύX[N */
	UINT8		ui8high			= 0; /* rbgGfBAύX[N */
	UINT32		x				= 0; /* ŏ̃oCg̍XVrbg */
	UINT32		y				= 0; /* Ԃ̃oCg				 */
	UINT32		z				= 0; /* ŏĨoCg̍XVrbg */
	UINT8		bit_shift		= 0; /* rbgVtgl				 */
	INT32		ipdu_direction	= 0;
	INT32		msg_direction	= 0;

	msg_direction	= 1;
	ipdu_direction	= 1;
	p_ipdu 			= p_ipdu +(para->m_bitposition >> 3);
	if( para->m_bytebigendian_local != para->m_byteorder ){
		/* byte endian big */
		msg_direction	= -1;
		p_msg 			= (p_msg + para->m_cdatasize) - 1;
		ipdu_direction	= -1;
	}
	/*
	 * IPDUŉoCgKv߁C
	 * 		Fŏ̃oCg̍XVrbg
	 * 		FԂ̃oCg̍XVoCg
	 * 		FŌ̃oCg̍XVrbg
	 * ɕčl
	 */
	x			= ( (para->m_bitposition) & 0x00000007 ) + 1;
	if( x >= para->m_sizeinbits ) {
		y				= 0;
		z				= 0;
	}
	else {
		y			= (para->m_sizeinbits - x) >> 3;
		z			= (para->m_sizeinbits - x) & 0x00000007;
	}
	bit_shift	= (UINT8)(7 - (para->m_bitposition & 0x00000007));

	/* IPDU̍ŏ̃oCg̍XV	 rbg̓] */
	ui16work	= (UINT16)(*p_msg);
	if( para->m_sizeinbits < 8 ) {
		ui16work 	= (UINT16)((UINT16)((*p_msg)&(0xff>>(8-para->m_sizeinbits)))<<8);
	}
	ui8high		= *p_msg;
	CHG_BITORDER(ui8high);
	ui16work	= (UINT16)ui8last;
	SHR16LOW( ui16work, &ui8work, bit_shift );
	*p_ipdu		= (UINT8)((*p_ipdu & (UINT8)( 0xff << bit_shift ) ) | ui8work);

	/* IPDU̒Ԃ̃oCg̍XV	 Wrbg̓] */
	for( ; 0<y ; y-- ) {
		p_msg		+= msg_direction;
		ui16work	= (UINT16)(((UINT16)ui8last) << 8);
		ui8high		= *p_msg;
		CHG_BITORDER(ui8high);
		ui16work	= (UINT16)(ui16work | ui8last);
		p_ipdu		+= ipdu_direction;
		SHR16LOW( ui16work, p_ipdu, bit_shift );
	}
	
	/* IPDU̍Ō̃oCg̍XV	 rbg̓] */
	if( 0 < z ) {
		ui16work	= (UINT16)(((UINT16)ui8last) << 8);
		p_msg		+= msg_direction;
		ui8high		= *p_msg;
		CHG_BITORDER(ui8high);
		ui16work	= (UINT16)(ui16work | ui8last);
		SHR16LOW( ui16work, &ui8work, bit_shift );
		p_ipdu		+= ipdu_direction;
		*p_ipdu		= (UINT8)(((*p_ipdu) & (0xff >> z))
						| ( ui8work & (UINT8)( 0xff << (8 - z) ) ));
	}
  exit:
  error_exit:
	return(ercd);
}

/*--------------------------------------------------------------------
 * Tv      FMESSAGEXV֐
 * @\      FIPDUIuWFNgMESSAGEIuWFNgɔzu
 * (in)  F<msgid>     bZ[WID
 *           F<p_ipdu>    ϊ|C^iIPDUIuWFNgj
 *           F<p_msg>     ϊʏo͐|C^iNETWORKMESSAGEIuWFNgj
 *           F<p_bitlen>  DynamicbZ[W̃rbgTCY
 *     (out) FȂ
 * ߂l    FE_OK        I
 * l      Fmsgid͎M-ʏCM-_Ci~bNbZ[ŴݍXVΏۂƂD
 *           FΏۊOmsgid̏ꍇCp_ipduɂ͉o͂	E_OKԂD
 *           Fp_msgSIZEINBITŜݍXVD
 *           F̊gpD
 *------------------------------------------------------------------*/
StatusType
update_Message( MessageIdentifier msgid, 
				const UINT8* p_ipdu, UINT8* p_msg, const UINT32* p_bitlen )
{
	StatusType	ercd = E_OK;
	UpdateParam	para;

	UINT32 len=0;
	UINT32 i;
	UINT8 bit=0;
	UINT8 bit_end=0;
	UINT8 bit_pos=0;

	/* MESSAGEXV֐gp̂߂ɁCݎgĂȂϐXV */
	if( (MSG_RCV_NORM | MSG_RCV_IPDU) == ( msgid & MSG_RCV_MASK ) ) {
		para.m_sizeinbits		= bitsize_rcv_ipdu_norm[(msgid & MSG_ID_MASK)];
		para.m_bitposition	= offset_rcv_ipdu_norm[(msgid & MSG_ID_MASK)];
		para.m_byteorder		= (BOOL)byteorder_rcv_ipdu_norm[(msgid & MSG_ID_MASK)];
		para.m_bitorder		= (BOOL)bitorder_rcv_ipdu_norm[(msgid & MSG_ID_MASK)];
	}
	else if( (MSG_RCV_DYNA | MSG_RCV_IPDU) == ( msgid & MSG_RCV_MASK ) )  {
		para.m_sizeinbits		= *p_bitlen;
		para.m_bitposition	= offset_rcv_ipdu_dyna[(msgid & MSG_ID_MASK)];
		para.m_byteorder 		= FALSE;
		para.m_bitorder		= (BOOL)bitorder_rcv_ipdu_dyna[(msgid & MSG_ID_MASK)];
	}
	else {
		goto error_exit;
	}
	if( !(para.m_sizeinbits) ) {
		goto error_exit;
	}

	/*  */
	len = (*p_bitlen)/8;
	for(i=0;i<len;i++){		
		*p_msg = 0;
		p_msg++;
	}	
	p_msg-=len;

	/* bZ[WItZbgֈړ */
	p_ipdu += (para.m_bitposition/8);

	/* Rs[X^[gʒǔvZ */
	bit_pos = (UINT8)(para.m_bitposition % 8);
	
	/* bZ[WTCY */
	len = para.m_sizeinbits / 8;
	if(len==0)
	{
		len=1;
	}
	else{
		len++;
	}

	bit_end = (UINT8)(para.m_sizeinbits % 8);


	/* IPDURs[ */
	for(i=0;i<len;i++)
	{
		for( bit=0; bit <((i==(len-1))?bit_end:8) ; bit++ )
		{
			if( 0x00 != (*p_ipdu & (0x80 >> bit_pos)))
			{
				*p_msg = (UINT8)(*p_msg | (0x80 >> bit));		/* IPDU̎bZ[W̃Zbg */
			}
			bit_pos++;
			
			if( bit_pos == 8 )
			{
				p_ipdu++;
				bit_pos=0;
			}
		}
		p_msg++;
	}

  exit:
  error_exit:
	return(ercd);
}

/*--------------------------------------------------------------------
 * Tv      FMESSAGEXV֐(BITORDERING = LITTLEENDIAN)
 * @\      FMESSAGEIuWFNgIPDUIuWFNgɔzuD
 * (in)  F<msgid>     bZ[WID
 *           F<p_ipdu>    ϊ|C^iIPDUIuWFNgj
 *           F<p_msg>     ϊʏo͐|C^iNETWORKMESSAGEIuWFNgj
 *           F<para>      MESSAGEXVɕKvȏ
 *     (out) FȂ
 * ߂l    FE_OK        I
 * l      Fmsgidɒʏ탁bZ[WȊOw肵Ă͂ȂȂD
 *           F̏ꍇCۏ؂łȂD
 *           F̊gpD
 *------------------------------------------------------------------*/
static StatusType
update_Message_bitlittle( MessageIdentifier msgid,
							UINT8* p_ipdu, UINT8* p_msg, const UpdateParam* para )
{
	StatusType	ercd			= E_OK;
	UINT16		ui16work		= 0;	/* ϊpf[^[N			*/
	UINT8		ui8work			= 0;	/* IPDUXVl				*/
	UINT8		bit_shift		= 0;	/* rbgVtgl				*/
	UINT32		y				= 0;	/* Ԃ̃oCg				*/
	UINT32		z				= 0;	/* ŏĨoCg̍XVrbg	*/
	BOOL		divide_InIpdu	= TRUE;	/* MESSAGE̍Ō̃oCgIPDUŁC */
										/*  oCg܂肷ꍇTRUED     */
	INT32		ipdu_direction	= 0;
	INT32		msg_direction	= 0;

	msg_direction		= 1;
	ipdu_direction	= 1;
	p_ipdu				= p_ipdu + (para->m_bitposition >> 3);
	if( para->m_bytebigendian_local != para->m_byteorder ){
		/* byte endian big */
		ipdu_direction	= -1;
	}

	#ifdef	_COM_SIZEINBITS_8BIT_TYPE_ONLY_
	/*
	 *	bZ[WWrbgPʂBITPOSITIONW̔{݂̂̏ꍇ̃R[h
	 */
	y		= para->m_sizeinbits >> 3;
	/* pxȂƍlp^[ŏxコD */
	/* BITPOSITIONW̔{ŁCbZ[W̃oCgPʂ̃f[^C */
	/*  IPDUŃoCg܂肵Ȃꍇ͏xコD   */
	if( 8 >= y ) { /* WoCgȉ̏ꍇ͂ɏxシD */
		/* for[v̏邽switchgp */
		switch(y) {
		case 8:
			*p_msg 		= *p_ipdu;
			p_msg		+= msg_direction;
			p_ipdu		+= ipdu_direction;
		case 7:
			*p_msg 		= *p_ipdu;
			p_msg		+= msg_direction;
			p_ipdu		+= ipdu_direction;
		case 6:
			*p_msg 		= *p_ipdu;
			p_msg		+= msg_direction;
			p_ipdu		+= ipdu_direction;
		case 5:
			*p_msg 		= *p_ipdu;
			p_msg		+= msg_direction;
			p_ipdu		+= ipdu_direction;
		case 4:
			*p_msg 		= *p_ipdu;
			p_msg		+= msg_direction;
			p_ipdu		+= ipdu_direction;
		case 3:
			*p_msg 		= *p_ipdu;
			p_msg		+= msg_direction;
			p_ipdu		+= ipdu_direction;
		case 2:
			*p_msg 		= *p_ipdu;
			p_msg		+= msg_direction;
			p_ipdu		+= ipdu_direction;
		case 1:
			*p_msg 		= *p_ipdu;
			p_msg		+= msg_direction;
			p_ipdu		+= ipdu_direction;
			break;
		default:
			break;
		}
	}
	else {
		for( ; 0<y ; y-- ) {
			*p_msg 		= *p_ipdu;
			p_msg		+= msg_direction;
			p_ipdu		+= ipdu_direction;
		}
	}
	#else	/*	_COM_SIZEINBITS_8BIT_TYPE_ONLY_	*/
	/*
	 *  bZ[WCӃrbgPʂBITPOSITIONCӂ̏ꍇ̃R[h
	 */
	/* IPDUMESSAGE̍Ō̃oCg̃rbgTCY߁C                  */
	/*  MESSAGE̍Ō̃oCg̃rbgoCg܂肵Ă邩mFD */
	divide_InIpdu = FALSE;
	if( (8 - (para->m_bitposition & 0x00000007)) 
				< ((para->m_sizeinbits) & 0x00000007) ) 
	{
		divide_InIpdu	= TRUE;
	}
	/* 
	 * MESSAGEŉoCgKv߁C
	 *	AoCg(8bitŒ)	
	 *	Ō̃oCg(8bit)		
	 * ɕčl
	 */
	z			= (para->m_sizeinbits) & 0x00000007;
	if( 8 > para->m_sizeinbits ) {
		y			= 0;
	}
	else {
		y			= para->m_sizeinbits >> 3;
	}
	bit_shift	= (UINT8)(para->m_bitposition & 0x00000007);
	if( 0 != bit_shift ) {
		for( ; 1<y ; y-- ) {
			ui16work	= (UINT16)(*p_ipdu);
			p_ipdu		+= ipdu_direction;
			ui16work	= (UINT16)(ui16work | ((UINT16)(*p_ipdu) << 8));
			SHR16LOW( ui16work, &ui8work, bit_shift );
			*p_msg		= ui8work;
			p_msg		+= msg_direction;
		}
		if( 0 != y ) {
			ui16work	= (UINT16)(*p_ipdu);
			if( 0 != (para->m_bitposition & 0x00000007) ) {
				p_ipdu		+= ipdu_direction;
				ui16work	= (UINT16)(ui16work | ((UINT16)(*p_ipdu) << 8));
			}
			SHR16LOW( ui16work, &ui8work, bit_shift );
			*p_msg		= ui8work;
			p_msg		+= msg_direction;
		}
	}
	else {
		/* pxȂƍlp^[ŏxコD */
		/* BITPOSITIONW̔{ŁCbZ[W̃oCgPʂ̃f[^C */
		/*  IPDUŃoCg܂肵Ȃꍇ͏xコD   */
		if( 8 >= y ) { /* WoCgȉ̏ꍇ͂ɏxシD */
			/* for[v̏邽switchgpD */
			switch(y) {
			case 8:
				*p_msg 		= *p_ipdu;
				p_msg		+= msg_direction;
				p_ipdu		+= ipdu_direction;
			case 7:
				*p_msg 		= *p_ipdu;
				p_msg		+= msg_direction;
				p_ipdu		+= ipdu_direction;
			case 6:
				*p_msg 		= *p_ipdu;
				p_msg		+= msg_direction;
				p_ipdu		+= ipdu_direction;
			case 5:
				*p_msg 		= *p_ipdu;
				p_msg		+= msg_direction;
				p_ipdu		+= ipdu_direction;
			case 4:
				*p_msg 		= *p_ipdu;
				p_msg		+= msg_direction;
				p_ipdu		+= ipdu_direction;
			case 3:
				*p_msg 		= *p_ipdu;
				p_msg		+= msg_direction;
				p_ipdu		+= ipdu_direction;
			case 2:
				*p_msg 		= *p_ipdu;
				p_msg		+= msg_direction;
				p_ipdu		+= ipdu_direction;
			case 1:
				*p_msg 		= *p_ipdu;
				p_msg		+= msg_direction;
				p_ipdu		+= ipdu_direction;
				break;
			default:
				break;
			}

		}
		else {
			for( ; 0<y ; y-- ) {
				*p_msg 		= *p_ipdu;
				p_msg		+= msg_direction;
				p_ipdu		+= ipdu_direction;
			}
		}
	}
	/* IPDU̍Ō̃oCg̍XV	 rbg̓] */
	if( 0 != z ) {
		ui16work	= (UINT16)(*p_ipdu);
		if( TRUE == divide_InIpdu ) {
			p_ipdu		+= ipdu_direction;
			ui16work	= (UINT16)(ui16work | ((UINT16)(*p_ipdu) << 8));
		}
		SHR16LOW( ui16work, &ui8work, bit_shift );
		*p_msg		= (UINT8)(((*p_msg) & (UINT8)(0xff << z)) 
						| ( ui8work & ( 0xff >> (8 - z)) ));
	}
	#endif	/*	_COM_SIZEINBITS_8BIT_TYPE_ONLY_	*/
  exit:
  error_exit:
	return(ercd);
}

/*--------------------------------------------------------------------
 * Tv      FMESSAGEXV֐(BITORDERING = BIGENDIAN)
 * @\      FMESSAGEIuWFNgIPDUIuWFNgɔzuD
 * (in)  F<msgid>     bZ[WIDiIPDUIuWFNgj
 *           F<p_ipdu>    ϊ|C^
 *           F<p_msg>     ϊʏo͐|C^iNETWORKMESSAGEIuWFNgj
 *           F<para>      MESSAGEXVɕKvȏ
 *     (out) FȂ
 * ߂l    FE_OK        I
 * l      Fmsgidɒʏ탁bZ[WȊOw肵Ă͂ȂȂD
 *           F̏ꍇCۏ؂łȂD
 *           F̊gpD
 *------------------------------------------------------------------*/
static StatusType
update_Message_bitbig( MessageIdentifier msgid,
						UINT8* p_ipdu, UINT8* p_msg, const UpdateParam* para )
{
	StatusType	ercd			= E_OK;
	UINT16		ui16work		= 0; /* ϊpf[^[N				*/
	UINT8		ui8work			= 0; /* IPDUXVl				*/
	UINT8		ui8last			= 0; /* rbgGfBAύX[N	*/
	UINT8		ui8low			= 0; /* rbgGfBAύX[N	*/
	UINT8		bit_shift		= 0; /* rbgVtgl					*/
	UINT32		y				= 0; /* Ԃ̃oCg					*/
	UINT32		z				= 0; /* ŏĨoCg̍XVrbg	*/
	INT32		ipdu_direction	= 0;
	INT32		msg_direction	= 0;

	msg_direction	= 1;
	ipdu_direction	= 1;
	p_ipdu				= p_ipdu + (para->m_bitposition >> 3);
	if( para->m_bytebigendian_local != para->m_byteorder ){
		/* byte endian big */
		ipdu_direction	= -1;
	}

	/*
	 *  MESSAGEŉoCgKv߁C
	 *  AoCg(8bitŒ)	
	 *  Ō̃oCg(8bit)		
	 *  ɕčl
	 */
	z			= para->m_sizeinbits & 0x00000007 ;
	if( 8 > para->m_sizeinbits ) {
		y			= 0;
	}
	else {
		y			= para->m_sizeinbits >> 3;
	}
	bit_shift		= (UINT8)(7 - (para->m_bitposition & 0x00000007));

	for( ; 1<y ; y-- ) {
		ui16work	= (UINT16)((UINT16)*p_ipdu << 8);
		p_ipdu		+= ipdu_direction;
		ui16work	= (UINT16)(ui16work | (UINT16)(*p_ipdu));
		SHL16HIGH( ui16work, &ui8work, bit_shift );
		CHG_BITORDER(ui8work);
		*p_msg		= ui8last;
		p_msg		+= msg_direction;
	}
	if( 0 != y ) {
		ui16work	= (UINT16)((UINT16)(*p_ipdu) << 8);
		if( 0 != bit_shift ) {
			p_ipdu		+= ipdu_direction;
			ui16work	= (UINT16)(ui16work |(UINT16)(*p_ipdu));
		}
		SHL16HIGH( ui16work, &ui8work, bit_shift );
		CHG_BITORDER(ui8work);
		*p_msg		= ui8last;
		p_msg		+= msg_direction;
	}
	if( 0 < z ) {
		ui16work	= (UINT16)((UINT16)(*p_ipdu) << 8);
		/* MESSAGE̍Ō̃oCg̃rbgC   */
		/*  IPDUŃoCg܂肵Ă邩mFD */
		if( ((para->m_bitposition & 0x00000007) + 1)
				< ((para->m_sizeinbits) & 0x00000007) ) 
		{
			p_ipdu		+= ipdu_direction;
			ui16work	= (UINT16)(ui16work	| (UINT16)(*p_ipdu));
		}
		SHL16HIGH( ui16work, &ui8work, bit_shift );
		CHG_BITORDER(ui8work);
		*p_msg		= (UINT8)(((*p_msg) & (UINT8)(0xff << z)) 
						| ( ui8last & ( 0xff >> (8 - z)) ));
	}
  exit:
  error_exit:
	return(ercd);
}


/*--------------------------------------------------------------------
 * Tv      FoCgGfBArbÕ`FbN֐
 * @\      F[Jbot̃oCgGfBArbÕ`FbND
 * (in)  FȂ
 *     (out) FȂ
 * ߂l    FTRUE        BIGENDIAN
 *           FFALSE       LITTLEENDIAN
 * l      F̊gpD
 *------------------------------------------------------------------*/
static BOOL
check_ByteBigEndian(void)
{
	union {
		UINT32		m_dummy32;
		UINT8		m_dummy8[4];
	} chk_array	= { 0x12345678 };
	BOOL	bigendian = TRUE;
	if( 0x78 == chk_array.m_dummy8[0] ){
		bigendian = FALSE;
	}
	return(bigendian);
}

