/*
 *  TOPPERS/OSEK COM
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK COM
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *  com_manage.c
 *
 *  StartCOM, StopCOM, StartPeriodic, StopPeriodic, GetCOMApplicationMode
 * 
 */

#include "osek_com.h"
#include "com_timer_user.h"
#include "com_hw_timer.h"
#include "com_memory.h"
#include "com_interrupt.h"
#include "com_check.h"
#include "com_cfg.h"					/* COMAPPMODE`FbN̂ */

COMApplicationModeType	comappmode;		/* COMAvP[V[h */

/*
 *  StopCOMŐݒ肳ȊOgp邱Ƃ̂ȂϐD
 *  sȂɃ[UQƂ邱ƂȂD
 *  dlɂ̂łƂ肠쐬Ă邪C
 *  KviKł͌ĂȂD
 */
COMShutdownModeType		comstopmode;	/* COMVbg_E[h */

/* comcallevel̏ COMCL_STOPŏ */
UINT8					comcallevel	= COMCL_STOP;

/*
 *  G[tbN̏QƗpϐ
 */
COMServiceIdType		_com_errorhook_svcid;
_COMErrorHook_Par		_com_errorhook_par1, _com_errorhook_par2,
						_com_errorhook_par3;

/*
 *  IPDU ID 󂯓npϐ
 */
extern IPDUType rcv_ipdu_id[TNUM_RCV_IPDU+RCV_IPDU_BUF_ADD];	/* MIPDUIDM^XN֓n߂̕ϐ */
extern UINT8 setpoint_rcv_ipdu_id;				/* rcv_ipdu_id̃f[^ݒʒu		*/
extern UINT8 getpoint_rcv_ipdu_id;				/* rcv_ipdu_id̃f[^oʒu	*/

/*
 *  IPDUM֐ipjvg^Cv錾
 */
static void TimerCallback_IPDUTransmission(UINT8 ipdu_id);

/*--------------------------------------------------------------------
 * Tv      FCOM̏Ǝw肳ꂽCOMAvP[V[hŃT[rXJn
 * @\      FCOMiobt@̈CǗf[^CUL֐Ăяoj
 *           Fw肳ꂽAvP[V[h̐ݒ
 *           FMfbhC^C}̃X^[g
 *           FStartCOMExtensionĂяo
 * (in)  F<mode>  COMAvP[V[h
 *     (out) FȂ
 * ߂l    F
 *   StandardFE_OK
 *   ExtendedFE_COM_ID       w肳ꂽCOMAvP[V[h͈͊O
 *           F<StartCOMExtension̖߂l>  E_OKȊȌꍇ
 *           FEƎ
 *           FE_COM_SYS_INTERRUPT   ݋֎~ɌĂяo
 *           FE_COM_SYS_CALLEVEL    COMNς
 *           FE_COM_SYS_ERR         ̑G[DO}NɂēG[R[hQ
 *           FEG[R[h
 *           FE_IL_SIZEOVER         CDATATYPẼTCY傫
 *           F<StartUL̖߂l>     ULsȂ
 *           F<SetRelTimer̖߂l> MfbhC^C}̐ݒ莸s
 * l      Fӓ_
 *           FEHW̏͂炩ߍsĂ邱
 *           FE^XNĂяoȂ΂ȂȂ
 *           FEM͊JnȂDKvȂStartCOMExtensionɂ
 *           F  StartPeriodicĂԂƁD
 *           FEStartCOMExtensionE_OKȊO̖߂lԂꍇC
 *           FStartCOM̖߂lƂĕԂD
 *           Fɂ钍ӓ_
 *           FEM-O-ʏ탁bZ[ẂCCDATATYPEɂĐݒ肳ꂽ^CCOM
 *           F  obt@傫TCYꍇCI[o[t[Ă܂߁C
 *           F  TCỸ`FbNsĂD
 *           F  ̎̓G[R[h́CE_IL_SIZEOVER
 *           F  iCDATATYPEɃRs[֐SGo͂Ă炤߁DM-O-ʏ
 *           F  bZ[W̏ꍇCCDATATYPE^̃obt@mۂ邽߁CI[o[t[
 *           F  ͋NȂDj
 *------------------------------------------------------------------*/
StatusType
StartCOM (COMApplicationModeType mode)
{
	StatusType ercd = E_OK;
	UINT8 	msgid_no;

	UINT8 	ipdu_id = 0;
	UINT32 	ipdu_arr = 0;

	LOG_STARTCOM_ENTER(mode);

	CHECK_INTERRUPT();
	CHECK_COMCALLEVEL(COMCL_STOP);
	CHECK_COMAPPMODE(mode);

	ENTER_CRITICALSECTION();

	comappmode = mode;

	/*
	 *  ^C}i
	 */
	com_init_timer();

	/*
	 *  ϐ
	 */
	/* M[N */
	(void)com_local_memset(msgbuf_snd_tmp, 0, bytesize_snd_max);
	(void)com_local_memset(msgbuf_snd_after_swapbytes, 0, bytesize_snd_max);
	/* IPDUMǗtO */
	(void)com_local_memset(flg_snd_ipdu, 0, tnum_snd_ipdu);
	/* Mf[^ւ̃|C^iR[AEgpj */
	_callout_snddata_addr = NULL;
	/* M[N */
	(void)com_local_memset(ipdubuf_rcv_tmp, 0, bytesize_rcv_max);
	(void)com_local_memset(msgbuf_rcv_ipdu_tmp, 0, bytesize_rcv_max);
	(void)com_local_memset(msgbuf_rcv_after_swapbytes, 0, bytesize_rcv_max);
	/* Mf[^ւ̃|C^iR[AEgpj */
	_callout_rcvdata_addr = NULL;
	/* MIPDUIDM^XN֓n߂̕ϐ */
	(void)com_local_memset(rcv_ipdu_id, IPDU_NULL, TNUM_RCV_IPDU);
	setpoint_rcv_ipdu_id = 0;
	getpoint_rcv_ipdu_id = 0;

	/* MQUEUEDbZ[Wf[^i[̈̏ */
	for (msgid_no = 0; msgid_no < tnum_rcv_que_norm; msgid_no ++) {
		/* Ǘf[^ */
		msgque_cnt[msgid_no] = 0;
		msgque_get_addr[msgid_no] = msgbuf_head_que_norm[msgid_no];
		msgque_put_addr[msgid_no] = msgbuf_head_que_norm[msgid_no];
		/* tB^ */
		if (filter_init_rcv_que_norm[msgid_no] != INIFILTFP_NULL) {
			(*filter_init_rcv_que_norm[msgid_no])
								((ApplicationDataRef)(&initialvalue_rcv_que_norm[msgid_no]));
		}
	}

	/* MUNQUEUEDbZ[W̏ */
	unque_init();
	for (msgid_no = 0; msgid_no < tnum_rcv_unq_norm; msgid_no ++) {
		/* tB^ */
		if (filter_init_rcv_unq_norm[msgid_no] != INIFILTFP_NULL) {
			(*filter_init_rcv_unq_norm[msgid_no])( 
								((ApplicationDataRef)(&initialvalue_rcv_unq_norm[msgid_no])));
		}
	}

	/* M_Ci~bNbZ[W̏ */
	for (msgid_no = 0; msgid_no < tnum_rcv_unq_dyna; msgid_no++) {
		/* f[^őɃZbg */
		*msglength_rcv_unq_dyna[msgid_no] = (COMLengthType)msgsize_rcv_unq_dyna[msgid_no];

		/* lΓKpCȂ0Zbg */
		if (0 == initialvalue_rcv_unq_dyna[msgid_no]) {
			(void)com_local_memset ((VP)(msgbuf_rcv_unq_dyna[msgid_no]),
									0, msgsize_rcv_unq_dyna[msgid_no]);
		}
		else {
			(void)com_local_memcpy ((VP)(msgbuf_rcv_unq_dyna[msgid_no]),
								(VP)(&initialvalue_rcv_unq_dyna[msgid_no]),
								msgsize_rcv_unq_dyna[msgid_no]);
		}
	}

	/* MOʏ탁bZ[W̃TCY`FbNƃtB^ */
	/* gK[h */
	for (msgid_no = 0; msgid_no < tnum_snd_ex_trig_norm; msgid_no ++) {
		if (msgsize_snd_ex_trig_norm[msgid_no] > bytesize_snd_max) {
			ercd = E_IL_SIZEOVER;
			LOG_STARTCOM_ERROR(ercd);
			ercd = E_COM_SYS_ERR;
			goto d_error_exit;
		}
		if (filter_init_snd_ex_trig_norm[msgid_no] != INIFILTFP_NULL) {
			(*filter_init_snd_ex_trig_norm[msgid_no])( 
							(ApplicationDataRef)(&initialvalue_snd_ex_trig_norm[msgid_no]));
		}
	}

	/* yfBO */
	for (msgid_no = 0; msgid_no < tnum_snd_ex_pend_norm; msgid_no ++) {
		if (msgsize_snd_ex_pend_norm[msgid_no] > bytesize_snd_max) {
			ercd = E_IL_SIZEOVER;
			LOG_STARTCOM_ERROR(ercd);
			ercd = E_COM_SYS_ERR;
			goto d_error_exit;
		}
		if (filter_init_snd_ex_pend_norm[msgid_no] != INIFILTFP_NULL) {
			(*filter_init_snd_ex_pend_norm[msgid_no])( 
							(ApplicationDataRef)(&initialvalue_snd_ex_pend_norm[msgid_no]));
		}
	}

	/* IPDU */
	for (ipdu_id = 0; ipdu_id < tnum_snd_ipdu; ipdu_id ++) {
		ipdu_snd_dlc[ipdu_id] = (UINT8)(bytesize_snd_ipdu[ipdu_id]);
		for (ipdu_arr = 0; ipdu_arr < bytesize_snd_ipdu[ipdu_id]; ipdu_arr ++) {
			msgbuf_snd_ipdu[ipdu_id][ipdu_arr] = 0;
		}
	}

	for (ipdu_id = 0; ipdu_id < tnum_rcv_ipdu; ipdu_id ++) {
		for (ipdu_arr = 0; ipdu_arr < bytesize_rcv_ipdu[ipdu_id]; ipdu_arr ++) {
			msgbuf_rcv_ipdu[ipdu_id][ipdu_arr] = 0;
		}
	}

	/* ReadFlag */
	init_flags();

	/* UL */
	ercd = StartUL(	il_snd_fin_func,
					il_rcv_fin_func,
					il_snd_err_func,
					il_rcv_err_func );

	if (E_OK != ercd) {
		LOG_STARTCOM_ERROR(ercd);
		ercd = E_COM_SYS_ERR;
		goto d_error_exit;
	}

	/* R[xݒ */
	comcallevel = COMCL_START;

	/* StartCOMExtension Ăяo */
	if (FP_NULL != ((FP) StartCOMExtension)) {
		LEAVE_CRITICALSECTION();
		
		ercd = StartCOMExtension();
		
		if (E_OK != ercd) {
			goto error_exit;
		}
		ENTER_CRITICALSECTION();
	}

	/* MfbhCj^O ^C}X^[g */
	for (ipdu_id = 0; ipdu_id < tnum_rcv_ipdu; ipdu_id++) {
		if (0 != timeout_rcv_ipdu[ipdu_id]) {
			ercd = SetRelTimer (timer_rcv_ctrl[ipdu_id],
								firsttimeout_rcv_ipdu[ipdu_id],
								timeout_rcv_ipdu[ipdu_id],
								rcv_deadline_timeup,
								ipdu_id );

			if (E_OK != ercd) {
				LOG_STARTCOM_ERROR(ercd);
				ercd = E_COM_SYS_ERR;
				goto d_error_exit;
			}
		}
	}

  exit:
	LEAVE_CRITICALSECTION();
	LOG_STARTCOM_LEAVE(ercd);
	return(ercd);

  error_exit:
	ENTER_CRITICALSECTION();
  d_error_exit:
	_com_errorhook_par1.m_mode = comappmode;
	call_com_errorhook(ercd, COMServiceId_StartCOM);
	goto exit;
}

/*--------------------------------------------------------------------
 * Tv      FCOM̒~
 * @\      FCOM̒~CMɒ~D
 *           Ff[^̏肤D
 *           FIꍇCStartCOMɂčď\ȏԂƂȂD
 * (in)  F<mode>  COM_SHUTDOWN_IMMEDIATE
 *           F        ɒ~ȉ҂Ȃj
 *     (out) FȂ
 * ߂l    F
 *   StandardFE_OK
 *   ExtendedFE_COM_ID             w肳ꂽCOMAvP[V[h͈͊O
 *           FEƎ
 *           FE_COM_SYS_INTERRUPT  ݋֎~ɌĂяo
 *           FE_COM_SYS_CALLEVEL   COMNO
 *           FE_COM_SYS_ERR        ̑G[iM~sj
 *           FEG[R[h
 *           F<StopPeriodic̖߂l> ȂD`FbN}ŇĂяoȂ̂ŁCKE_OK
 * l      FUL̒~֐ĂяoƂƁCCOMR[x̐ݒCM~̂݁D
 *           Fobt@̃NACǗ͍̏sȂD
 *           FStopPeriodićCݏԃ`FbNCCOMR[x`FbN
 *           FsꂽɌĂяoĂ邽߁Cł͕K E_OKƂȂD
 *------------------------------------------------------------------*/
StatusType
StopCOM (COMShutdownModeType mode)
{
	StatusType ercd = E_OK;
	UINT8 	ipdu_id = 0;

	LOG_STOPCOM_ENTER(mode);

	CHECK_INTERRUPT();
	CHECK_COMCALLEVEL(COMCL_START);
	CHECK_COMSTOPMODE(mode);

	/* MfbhCj^O ^C}~ */
	for (ipdu_id = 0; ipdu_id < tnum_rcv_ipdu; ipdu_id++) {

		if (0 != timeout_rcv_ipdu[ipdu_id]) {

			/* LZ */
			ercd = CancelTimer(timer_rcv_ctrl[ipdu_id]);
			if ((E_OK == ercd) || (E_TIM_NOFUNC == ercd)) {
				/* ̏ꍇOKĈ܂܎ */
				ercd = E_OK;
			}
			else {
				/* G[(ɂ͗Ȃ͂) */
				LOG_STOPPERIODIC_ERROR(ercd);
				ercd = E_COM_SYS_ERR;
				goto error_exit;
			}
		}
	}

	ercd = StopPeriodic();
	if (E_OK != ercd) {
		LOG_STOPCOM_ERROR(ercd);
		ercd = E_COM_SYS_ERR;
		goto error_exit;
	}

	ENTER_CRITICALSECTION();

	/*
	 *  ULI
	 */
	ercd = StopUL();
	if (E_OK != ercd) {
		LOG_STOPCOM_ERROR(ercd);
		ercd = E_COM_SYS_ERR;
		goto error_exit;
	}

	/*
	 *  ^C}iI
	 */
	com_term_timer();

	comstopmode = mode;
	comcallevel = COMCL_STOP;

  exit:
	LEAVE_CRITICALSECTION();
	LOG_STOPCOM_LEAVE(ercd);
	return(ercd);

  error_exit:
	ENTER_CRITICALSECTION();
	_com_errorhook_par1.m_mode = mode;
	call_com_errorhook(ercd, COMServiceId_StopCOM);
	goto exit;
}


/*--------------------------------------------------------------------
 * Tv      FM̊Jn
 * @\      FPeriodic ܂ Mixed M[hIPDU̎M̊JnD
 *           FɎMJnĂ邩ǂɊւ炸JnD
 * (in)  FȂ
 *     (out) FȂ
 * ߂l    F
 *   StandardFE_OK
 *   ExtendedFȂ
 *           FEƎ
 *           FE_COM_SYS_INTERRUPT  ݋֎~ɌĂяo
 *           FE_COM_SYS_CALLEVEL   COMNO
 *           FE_COM_SYS_ERR        ̑G[i^C}ݒ莸sj
 *           FEG[R[h
 *           FE_TIM_NOFUNC <CancelTimer̖߂l>  w̃^C}gp(Oo͂Ȃ)
 *           FE_TIM_STATE  <SetRelTimer̖߂l>  ^C}gp
 * l      F{APIĂяoꂽꍇCM͍ďCăX^[gD
 *           FStartCOMł邱ƁCx͐f[^Ă邱ƂKvD
 *           F(f[^ĂȂƁCsIPDU𑗐M邩ƎvDj
 *           F(p.23  2.3.5 Activation/Deactibation of periodic transmission mechanism)
 *------------------------------------------------------------------*/
StatusType
StartPeriodic(void)
{
	StatusType	ercd = E_OK;
	IPDUType	ipduid;
	TimerType	timid;

	LOG_STARTPERIODIC_ENTER();

	CHECK_INTERRUPT();
	CHECK_COMCALLEVEL(COMCL_START);

	ENTER_CRITICALSECTION();

	for (ipduid = 0; ipduid < tnum_snd_ipdu; ipduid++) {

		/* Direct IPDU͏O */
		if (COM_IPDU_DIRECT != transmode_snd_ipdu[ipduid]) {

			/*	^C}ID擾	timer_snd_periodic */
			timid = timer_snd_periodic[ipduid];

			/* ܂LZ */
			ercd = CancelTimer(timid);
			/*
			 *  E_OK        FLZłĈ܂܃^C}ZbgցD
			 *  E_TIM_NOFUNCF^C}gĂȂĈ܂܃^C}ZbgցD
			 */
			if ((E_OK == ercd) || (E_TIM_NOFUNC == ercd)) {
				/* ̏ꍇOKĈ܂܎ */
				ercd = E_OK;
			}
			else {
				LOG_STARTPERIODIC_ERROR(ercd);
				ercd = E_COM_SYS_ERR;
				goto d_error_exit;
			}

			ercd = SetRelTimer(timer_snd_periodic[ipduid],	/* Mp^C}ID */
							timeoffset_snd_ipdu[ipduid],	/* GNXpCA */
							timeperiod_snd_ipdu[ipduid],	/* ̊Ԋu */
							TimerCallback_IPDUTransmission,	/* IPDUMv֐ */
							ipduid);	/* IPDUMv֐ɓnp[^ */

			if (E_OK != ercd) {
				/* G[ */
				LOG_STARTPERIODIC_ERROR(ercd);
				ercd = E_COM_SYS_ERR;
				goto d_error_exit;
			}
		}
	}
  exit:
	LEAVE_CRITICALSECTION();
	LOG_STARTPERIODIC_LEAVE(ercd);
	return(ercd);

  error_exit:
	ENTER_CRITICALSECTION();
  d_error_exit:
	call_com_errorhook(ercd, COMServiceId_StartPeriodic);
	goto exit;
}

/*--------------------------------------------------------------------
 * Tv      FIPDUMiMOj
 * @\      FMvtO𗧂Ă
 *           FIPDUMv֐Ăяo
 * (in)  Fipduid  MIPDUID
 *     (out) FȂ
 * ߂l    FȂ
 * l      FRequestTransmission()Ŗ߂lԂĂȂD
 *------------------------------------------------------------------*/
static void
TimerCallback_IPDUTransmission(UINT8 ipdu_id)
{
	flg_snd_ipdu[ipdu_id] |= IPDU_SEND_REQUEST;
	(void)RequestTransmission(ipdu_id);
}

/*--------------------------------------------------------------------
 * Tv      FM̒~
 * @\      FPeriodic ܂ Mixed M[hIPDU̎M̒~
 *           FɎM~Ă邩ǂɊւ炸Ăяo\
 * (in)  FȂ
 *     (out) FȂ
 * ߂l    F
 *   StandardFE_OK
 *   ExtendedFȂ
 *           FEƎ
 *           FE_COM_SYS_INTERRUPT  ݋֎~ɌĂяo
 *           FE_COM_SYS_CALLEVEL   COMNO
 *           FE_COM_SYS_ERR        ̑G[iCancelTimer̃G[(Ȃ)j
 *           FEG[R[h
 *           FE_TIM_NOFUNC <CancelTimer̖߂l>  w̃^C}gp(Oo͂Ȃ)
 * l      F{APIɊCStartPeriodicɂďCăX^[g\D
 *           FG[R[h̃Oo͂ƁCE_COM_SYS_ERRԂdlƂĂ邪C
 *           F̃^C}i̎ł́CE_OK ܂ E_TIM_NOFUNC ߂lłC
 *           FE_TIM_NOFUNC͐툵Ȃ̂ŁCIɓG[R[h݂͑ȂD
 *           FC^C}ĩG[R[h̎ނƂ̂߁C
 *           FAPIƓl̍\ƂĂD
 *------------------------------------------------------------------*/
StatusType
StopPeriodic(void)
{
	StatusType	ercd = E_OK;
	IPDUType	ipduid;
	TimerType	timid;

	LOG_STOPPERIODIC_ENTER();

	CHECK_INTERRUPT();
	CHECK_COMCALLEVEL(COMCL_START);

	ENTER_CRITICALSECTION();

	for (ipduid = 0; ipduid < tnum_snd_ipdu; ipduid++) {
		/* Direct IPDU͏O */
		if (COM_IPDU_DIRECT != transmode_snd_ipdu[ipduid]) {

			/*	^C}ID擾	timer_snd_periodic */
			timid = timer_snd_periodic[ipduid];

			/* LZ */
			ercd = CancelTimer(timid);
			if ((E_OK == ercd) || (E_TIM_NOFUNC == ercd)) {
				/* ̏ꍇOKĈ܂܎ */
				ercd = E_OK;
			}
			else {
				/* G[(ɂ͗Ȃ͂) */
				LOG_STOPPERIODIC_ERROR(ercd);
				ercd = E_COM_SYS_ERR;
				goto d_error_exit;
			}
		}
	}
  exit:
	LEAVE_CRITICALSECTION();
	LOG_STOPPERIODIC_LEAVE(ercd);
	return(ercd);

  error_exit:
	ENTER_CRITICALSECTION();
  d_error_exit:
	call_com_errorhook(ercd, COMServiceId_StopPeriodic);
	goto exit;
}

/*--------------------------------------------------------------------
 * Tv      FG[tbŇĂяo
 * @\      FCOMErrorHooǩĂяo
 *           FG[tbN[`G[擾邱Ƃł悤
 *           FG[ǗϐցCCOM API֓nꂽZbgD
 * (in)  F<ercd>       G[̃G[R[h
 *           F<com_svcid>  G[APIID
 *     (out) FȂ
 * ߂l    FȂ
 * l      FG[tbÑlXg͋֎~ĂD
 *           FCOM API̖߂lE_OKȊO̎ĂяoD
 *------------------------------------------------------------------*/
void
call_com_errorhook(StatusType ercd, COMServiceIdType com_svcid)
{
	UINT8	saved_comcallevel;		/* COMR[xޔĂϐ */

	if (FP_NULL != ((FP) COMErrorHook)) {
		/* G[tbÑlXeBO͍sȂ */
		if (0 == (comcallevel & COMCL_ERRHOOK)) {
			_com_errorhook_svcid = com_svcid;	/* COM API IDݒ */

			saved_comcallevel = comcallevel;	/* ޔ */
			comcallevel = COMCL_ERRHOOK;		/* COMR[x COMCL_ERRHOOK  */
			COMErrorHook(ercd);
			comcallevel = saved_comcallevel;	/* COMR[x ޔ֖̂߂ */
		}
	}
}


/*--------------------------------------------------------------------
 * Tv      F݂COMAvP[V[ho
 * @\      F݂COMAvP[V[ho
 * (in)  FȂ
 *     (out) FȂ
 * ߂l    F݂COMAvP[V[h
 * l      FStartCOMȍ~Ɏgp
 *------------------------------------------------------------------*/
COMApplicationModeType
GetCOMApplicationMode (void)
{
	COMApplicationModeType	commode;

	LOG_GETCOMAPPLICATIONMODE_ENTER();
	commode = comappmode;
	LOG_GETCOMAPPLICATIONMODE_LEAVE(commode);
	return(commode);
}
