/*
 *  TOPPERS/OSEK COM
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK COM
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 * com_msgctrl.c
 */

#include	"osek_com.h"
#include	"com_timer_user.h"
#include	"com_interrupt.h"
#include	"com_check.h"

/*
 *  static֐̃vg^Cv錾
 */
static void		snd_deadline_timeup(IPDUType ipdu_id);
static void		snd_minimumdelay_timeup(IPDUType ipdu_id);
static void		exec_notification4(IPDUType ipdu_id);
static void		exec_notification2(IPDUType ipdu_id);	/* ʒmNX2 */
static void		exec_resetflag2(IPDUType ipdu_id);		/* ʒmNX2 */
static void		exec_resetflag4(IPDUType ipdu_id);		/* ʒmNX4 */

static StatusType	InitSndExTrigNorm(MessageIdentifier msgid,
									ApplicationDataRef p_data);
static StatusType	InitSndExPendNorm(MessageIdentifier msgid,
									ApplicationDataRef p_data);
static StatusType	InitSndExTrigDyna(MessageIdentifier msgid,
									ApplicationDataRef p_data, LengthRef p_len);
static StatusType	InitSndExPendDyna(MessageIdentifier msgid, 
									ApplicationDataRef p_data, LengthRef p_len);


/*--------------------------------------------------------------------
 * Tv      FbZ[Ww肳ꂽf[^ŏ
 * @\      Fw肳ꂽbZ[W̃obt@Cw̃f[^ŏ
 *           F_Ci~bNbZ[WɂẮCő咷ƂȂ
 *           FIPDȖMbZ[WꍇCoCgI[_[ϊC
 *           FCPU-order Callout, Network-order Callout Ăяo
 * (in)  F<msgid>       郁bZ[WID
 *           F<p_data>      Kpf[^ւ̃|C^
 *     (out) FȂ
 * ߂l    F
 *   StandardFE_OK
 *   ExtendedFE_COM_ID      w肳ꂽbZ[WID͈͊O
 *           FEƎ
 *           FE_COM_SYS_ERR ̑G[
 *           F      ioCgI[_ϊsCIPDUփf[^i[sj
 * l      FȂ
 *------------------------------------------------------------------*/
StatusType
InitMessage (MessageIdentifier msgid, ApplicationDataRef p_data)
{
	StatusType 			ercd = E_OK;
	UINT8				msgid_no = 0;
	UINT8				cnt = 0;

	LOG_INITMESSAGE_ENTER(msgid,p_data);

	CHECK_INTERRUPT();
	CHECK_COMCALLEVEL(COMCL_START);
	CHECK_VALID_MSGID(msgid);

	ENTER_CRITICALSECTION();

	msgid_no = (UINT8)(msgid & MSG_ID_MASK);

	/*bZ[WID瑀Ώۂ̃bZ[W֐肷*/
	/*----------------------------------------
	 * M ʏ탁bZ[W L[L
	 *---------------------------------------*/
	if ((MSG_RCV_NORM | MSG_RCV_QUED) == (msgid & MSG_RCV_MASK)) {
		CHECK_MAX_RCV_QUED(msgid_no);
		msgque_cnt[msgid_no] = 0;
		msgque_get_addr[msgid_no] = msgbuf_head_que_norm[msgid_no];
		msgque_put_addr[msgid_no] = msgbuf_head_que_norm[msgid_no];
		if (INIFILTFP_NULL != filter_init_rcv_que_norm[msgid_no]) {
			(*filter_init_rcv_que_norm[msgid_no])(p_data);
		}
	}
	/*----------------------------------------
	 * M ʏ탁bZ[W L[
	 *---------------------------------------*/
	else if (MSG_RCV_NORM == (msgid & MSG_RCV_MASK)) {
		CHECK_MAX_RCV_NORM(msgid_no);
		(*copyfunc_rcv_unq_norm[msgid_no])(((ApplicationDataRef)(msgbuf_rcv_unq_norm[msgid_no])),
											((ApplicationDataRef)(p_data)));
		if (INIFILTFP_NULL != filter_init_rcv_unq_norm[msgid_no]) {
			(*filter_init_rcv_unq_norm[msgid_no])(p_data);
		}
	}
	/*----------------------------------------
	 * M _Ci~bNbZ[W
	 *---------------------------------------*/
	else if (MSG_RCV_DYNA == (msgid & MSG_RCV_MASK)) {
		CHECK_MAX_RCV_DYNA(msgid_no);
		/* f[^͍ő */
		*msglength_rcv_unq_dyna[msgid_no] = (COMLengthType)msgsize_rcv_unq_dyna[msgid_no];
		/* f[^Rs[ */
		for (cnt = 0; cnt < msgsize_rcv_unq_dyna[msgid_no]; cnt++) {
			*((UINT8 *)msgbuf_rcv_unq_dyna[msgid_no] + cnt) 
											= *((UINT8 *)p_data + cnt);
		}
	}
	/*----------------------------------------
	 * M O ʏ yfBO
	 *---------------------------------------*/
	else if ((MSG_SND_NORM | MSG_SND_EXT | MSG_SND_PEND)
										== (msgid & MSG_SND_MASK)) {
		CHECK_MAX_SND_PEND_NORM(msgid_no);
		/* IPDUf[^Zbg܂ł̈Ȁ */
		ercd = InitSndExPendNorm( msgid, p_data );

		if (E_OK == ercd) {
			/*  */
		}
		else if (E_IL_CALLOUTFALSE == ercd) {
			/* R[AEgɂăJbg */
			LOG_INITMESSAGE_CALLOUTFALSE(msgid);
			ercd = E_OK;
			goto exit;
		}
		else if (E_IL_FILTERED == ercd) {
			/* tB^ɂăJbg */
			LOG_INITMESSAGE_FILTERED(msgid);
			ercd = E_OK;
			goto exit;
		}
		else {
			/* ̑G[ */
			LOG_INITMESSAGE_ERROR(ercd, msgid);
			ercd = E_COM_SYS_ERR;
			goto d_error_exit;
		}
	}
	/*----------------------------------------
	 * M O ʏ gK
	 *---------------------------------------*/
	else if ((MSG_SND_NORM | MSG_SND_EXT) == (msgid & MSG_SND_MASK)) {
		CHECK_MAX_SND_TRIG_NORM(msgid_no);
		/* IPDUf[^Zbg܂ł̈Ȁ */
		ercd = InitSndExTrigNorm( msgid, p_data );

		if (E_OK == ercd) {
			/*  */
		}
		else if (E_IL_CALLOUTFALSE == ercd) {
			/* R[AEgɂăJbg */
			LOG_INITMESSAGE_CALLOUTFALSE(msgid);
			ercd = E_OK;
			goto exit;
		}
		else if (E_IL_FILTERED == ercd) {
			/* tB^ɂăJbg */
			LOG_INITMESSAGE_FILTERED(msgid);
			ercd = E_OK;
			goto exit;
		}
		else {
			/* ̑G[ */
			LOG_INITMESSAGE_ERROR(msgid, ercd);
			ercd = E_COM_SYS_ERR;
			goto d_error_exit;
		}
	}
	/*----------------------------------------
	 * M O _Ci~bN yfBO
	 *---------------------------------------*/
	else if ((MSG_SND_DYNA | MSG_SND_EXT | MSG_SND_PEND) 
										== (msgid & MSG_SND_MASK)){
		CHECK_MAX_SND_PEND_DYNA(msgid_no);
		/* IPDUփf[^Zbg̈Ȁ */
		/* _Ci~bNbZ[W̃TCY͍ől */
		/* 1oCgPʂŃbZ[Wobt@Cs߁C       */
		/*  bZ[Wobt@(UINT8*)^̃|C^ƂĈɓnD */
		ercd = InitSndExPendDyna (msgid, 
								p_data, 
								(LengthRef)&msgsize_snd_ex_pend_dyna[msgid_no]);

		if (E_OK == ercd) {
			/*  */
		}
		else if (E_IL_CALLOUTFALSE == ercd) {
			LOG_INITMESSAGE_CALLOUTFALSE(msgid);
			ercd = E_OK;
			goto exit;
		}
		else {
			LOG_INITMESSAGE_ERROR(ercd, msgid);
			ercd = E_COM_SYS_ERR;
			goto d_error_exit;
		}
	}
	/*----------------------------------------
	 * M O _Ci~bN gK
	 *---------------------------------------*/
	else if ((MSG_SND_DYNA | MSG_SND_EXT) == (msgid & MSG_SND_MASK)) {
		CHECK_MAX_SND_TRIG_DYNA(msgid_no);
		/* _Ci~bNbZ[W̃TCY͍ől */
		/* 1oCgPʂŃbZ[Wobt@Cs߁C       */
		/*  bZ[Wobt@(UINT8*)^̃|C^ƂĈɓnD */
		ercd = InitSndExTrigDyna (msgid, 
								p_data, 
								(LengthRef)&msgsize_snd_ex_trig_dyna[msgid_no]);

		if (E_OK == ercd) {
			/*  */
		}
		else if (E_IL_CALLOUTFALSE == ercd) {
			LOG_INITMESSAGE_CALLOUTFALSE(msgid);
			ercd = E_OK;
			goto exit;
		}
		else {
			LOG_INITMESSAGE_ERROR(ercd, msgid);
			ercd = E_COM_SYS_ERR;
			goto d_error_exit;
		}
	}
	/*----------------------------------------
	 * ΏۊÕbZ[WID
	 *---------------------------------------*/
	else {
		ercd = E_COM_ID;
		goto d_error_exit;
	}

  exit:
	LEAVE_CRITICALSECTION();
	LOG_INITMESSAGE_LEAVE(ercd);
	return(ercd);

  error_exit:
	ENTER_CRITICALSECTION();
  d_error_exit:
	_com_errorhook_par1.m_msgid = msgid;
	_com_errorhook_par2.m_p_data = p_data;
	call_com_errorhook(ercd, COMServiceId_InitMessage);
	goto exit;
}

/*--------------------------------------------------------------------
 * Tv      FO-gK-ʏ탁bZ[WIPDU֊i[
 * @\      FbZ[WIPDU֊i[D
 * (in)  F<msgid>   ΏۂƂMbZ[WIuWFNgID
 *           F<p_data>  IPDU֊i[f[^ւ̃|C^
 *     (out) FȂ
 * ߂l    FE_OK
 *           FE_IL_FILTERED
 *           FE_IL_CALLOUTFALSE
 *           FĂяo֐
 *           FEtB^֐  E_OK or E_IL_FILTERED
 *           FER[AEg  COM_TRUE or COM_FALSEiE_IL_CALLOUTFALSE)
 *           FEoCgI[_[ϊ  G[R[h󂯌p  E_OK ̂
 *           FEIPDUփf[^Zbg  G[R[h󂯌p  E_OK ̂
 * Tv      F݋֎~ԂŌĂяo邱ƁD
 *           FoCgI[_[ϊCIPDUi[֐msgidKvȂ̂ŁCmsgiď`ł炤D
 *           FIPDUIDʂŎgp̂ŃZbgD
 *           F֐̂߁CO}NŃG[eo͂̂ł͂ȂC
 *           F{IɏʑwփG[R[hԂCʑwɈ䂾˂D
 *-------------------------------------------------------------------*/
static StatusType
InitSndExTrigNorm (MessageIdentifier msgid, ApplicationDataRef p_data)
{
	StatusType			ercd = E_OK;
	CalloutReturnType	cocd = COM_TRUE;
	IPDUType			ipduid = IPDU_NULL;
	UINT8				msgid_no = 0;

	msgid_no = (UINT8)(msgid & MSG_ID_MASK);

	/* f[^̃Rs[*/
	(*copyfunc_snd_ex_trig_norm[msgid_no] )( msgbuf_snd_tmp, p_data );

	/* tB^֐L	*/
	if( INIFILTFP_NULL != filter_init_snd_ex_trig_norm[msgid_no] ){
		/* old_value			*/
		(*filter_init_snd_ex_trig_norm[msgid_no])(msgbuf_snd_tmp);
	}

	/* cpu_order bZ[W R[AEgs */
	if( CALLOUTFP_NULL != callout_cpuorder_snd_ex_trig_norm[msgid_no] ){
		_callout_snddata_addr = msgbuf_snd_tmp;	/* bZ[Wւ̃|C^ێ */
		cocd = (*callout_cpuorder_snd_ex_trig_norm[msgid_no])();
		if (COM_FALSE == cocd) {
			ercd = E_IL_CALLOUTFALSE;
			goto exit;
		}	
	}

	/* oCgI[_[ϊ */
	/* 1oCgPʂŃbZ[Wobt@Cs߁C       */
	/*  bZ[Wobt@(UINT8*)^̃|C^ƂĈɓnD */
	ercd = convert_byteorder( msgid, (UINT8*)msgbuf_snd_tmp, 
									(UINT8*)msgbuf_snd_after_swapbytes);
	if (E_OK != ercd) {
		goto error_exit;
	}

	/* network_order bZ[W R[AEgs */
	if( CALLOUTFP_NULL != callout_netorder_snd_ex_trig_norm[msgid_no] ){
		_callout_snddata_addr = msgbuf_snd_after_swapbytes;
		cocd = (*callout_netorder_snd_ex_trig_norm[msgid_no])();
		if (COM_FALSE == cocd) {
			ercd = E_IL_CALLOUTFALSE;
			goto exit;
		}	
	}

	ipduid = ipduid_snd_ex_trig_norm[msgid_no];
	/* IPDUփf[^Zbg */
	/* 1oCgPʂŃbZ[Wobt@Cs߁C       */
	/*  bZ[Wobt@(UINT8*)^̃|C^ƂĈɓnD */
	ercd = update_Ipdu( msgid, (UINT8*)msgbuf_snd_after_swapbytes, 
												msgbuf_snd_ipdu[ipduid]);
	if (E_OK != ercd) {
		goto error_exit;
	}

  exit:
	return(ercd);

  error_exit:
	goto exit;
}

/*--------------------------------------------------------------------
 * Tv      FO-yfBO-ʏ탁bZ[WIPDU֊i[
 * @\      FbZ[WIPDU֊i[D
 * (in)  F<msgid>   ΏۂƂMbZ[WIuWFNgID
 *           F<p_data>  IPDU֊i[f[^ւ̃|C^
 *     (out) FȂ
 * ߂l    FE_OK
 *           FE_IL_FILTERED
 *           FE_IL_CALLOUTFALSE
 *           FĂяo֐
 *           FEtB^֐  E_OK or E_IL_FILTERED
 *           FER[AEg  COM_TRUE or COM_FALSEiE_IL_CALLOUTFALSE)
 *           FEoCgI[_[ϊ  G[R[h󂯌p  E_OK ̂
 *           FEIPDUփf[^Zbg  G[R[h󂯌p  E_OK ̂
 * Tv      F݋֎~ԂŌĂяo邱ƁD
 *           FoCgI[_[ϊCIPDUi[֐msgidKvȂ̂ŁCmsgiď`ł炤D
 *           F֐̂߁CO}NŃG[eo͂̂ł͂ȂC
 *           F{IɏʑwփG[R[hԂCʑwɈ䂾˂D
 *-------------------------------------------------------------------*/
static StatusType
InitSndExPendNorm (MessageIdentifier msgid, ApplicationDataRef p_data)
{
	StatusType			ercd = E_OK;
	CalloutReturnType	cocd = COM_TRUE;
	IPDUType			ipduid = IPDU_NULL;
	UINT8				msgid_no = 0;

	msgid_no = (UINT8)(msgid & MSG_ID_MASK);

	/* f[^̃Rs[ */
	(*copyfunc_snd_ex_pend_norm[msgid_no])(msgbuf_snd_tmp, p_data);

	/* tB^֐L	*/
	if( INIFILTFP_NULL != filter_init_snd_ex_pend_norm[msgid_no] ){
		/* old_value			*/
		(*filter_init_snd_ex_pend_norm[msgid_no])(msgbuf_snd_tmp);
	}

	/* cpu_order bZ[W R[AEgs	*/
	if( CALLOUTFP_NULL != callout_cpuorder_snd_ex_pend_norm[msgid_no] ){
		_callout_snddata_addr = msgbuf_snd_tmp;
		cocd = (*callout_cpuorder_snd_ex_pend_norm[msgid_no])();
		if (COM_FALSE == cocd) {
			ercd = E_IL_CALLOUTFALSE;
			goto exit;
		}
	}

	/* oCgI[_[ϊ */
	/* 1oCgPʂŃbZ[Wobt@Cs߁C       */
	/*  bZ[Wobt@(UINT8*)^̃|C^ƂĈɓnD */
	ercd = convert_byteorder( msgid, (UINT8*)msgbuf_snd_tmp, 
									(UINT8*)msgbuf_snd_after_swapbytes);
	if (E_OK != ercd) {
		goto error_exit;
	}

	/* network_order bZ[W R[AEgs */
	if( CALLOUTFP_NULL != callout_netorder_snd_ex_pend_norm[msgid_no] ){
		_callout_snddata_addr = msgbuf_snd_after_swapbytes;
		cocd = (*callout_netorder_snd_ex_pend_norm[msgid_no])();
		if (COM_FALSE == cocd) {
			ercd = E_IL_CALLOUTFALSE;
			goto exit;
		}	
	}

	/* IPDUɃf[^i[ */
	ipduid = ipduid_snd_ex_pend_norm[msgid_no];	
	/* 1oCgPʂŃbZ[Wobt@Cs߁C       */
	/*  bZ[Wobt@(UINT8*)^̃|C^ƂĈɓnD */
	ercd = update_Ipdu( msgid, (UINT8*)msgbuf_snd_after_swapbytes, 
										msgbuf_snd_ipdu[ipduid]);
	if (E_OK != ercd) {
		goto error_exit;
	}

  exit:
	return(ercd);

  error_exit:

	goto exit;
}

/*--------------------------------------------------------------------
 * Tv      FO-gK-_Ci~bNbZ[WIPDU֊i[
 * @\      FbZ[WIPDU֊i[D
 * (in)  F<msgid>   ΏۂƂMbZ[WIuWFNgID
 *           F<p_data>  IPDU֊i[f[^ւ̃|C^
 *           F<p_len>   IPDU֊i[f[^̃f[^ւ̃|C^
 *      (out)FȂ
 * ߂l    FE_OK
 *           FE_IL_CALLOUTFALSE
 *           FĂяo֐
 *           FER[AEg  COM_TRUE or COM_FALSEiE_IL_CALLOUTFALSE)
 *           FEIPDUփf[^Zbg  G[R[h󂯌p  E_OK ̂
 * Tv      F݋֎~ԂŌĂяo邱ƁD
 *           FIPDUi[֐msgidKvȂ̂ŁCmsgiď`ł炤D
 *           F֐̂߁CO}NŃG[eo͂̂ł͂ȂC
 *           F{IɏʑwփG[R[hԂCʑwɈ䂾˂D
 *-------------------------------------------------------------------*/
static StatusType
InitSndExTrigDyna(MessageIdentifier msgid, 
					ApplicationDataRef p_data, LengthRef p_len)
{
	StatusType			ercd = E_OK;
	CalloutReturnType	cocd = COM_FALSE;
	IPDUType			ipduid = IPDU_NULL;
	UINT8				msgid_no = 0;
	UINT8				cnt = 0;

	msgid_no = (UINT8)(msgid & MSG_ID_MASK);

	/* PoCgRs[ */
	for (cnt = 0; cnt < *p_len; cnt++) {
		/* PoCgRs[邽߁C(UINT8*)^ɃLXg */
		*((UINT8 *)msgbuf_snd_tmp + cnt) = *((UINT8 *)p_data + cnt);
	}

	/* cpu_order bZ[W R[AEgs */
	if( CALLOUTFP_NULL != callout_cpuorder_snd_ex_trig_dyna[msgid_no] ){
		/*[U`֐R[*/
		_callout_snddata_addr = msgbuf_snd_tmp;
		cocd = (*callout_cpuorder_snd_ex_trig_dyna[msgid_no])();
		if (COM_FALSE == cocd) {
			ercd = E_IL_CALLOUTFALSE;
			goto exit;
		}
	}

	/* network_order bZ[W R[AEgs */
	if( CALLOUTFP_NULL != callout_netorder_snd_ex_trig_dyna[msgid_no] ){
		_callout_snddata_addr = msgbuf_snd_tmp;
		cocd = (*callout_netorder_snd_ex_trig_dyna[msgid_no])();
		if (COM_FALSE == cocd) {
			ercd = E_IL_CALLOUTFALSE;
			goto exit;
		}
	}

	ipduid = ipduid_snd_ex_trig_dyna[msgid_no];
	/* IPDUփf[^i[ */
	/* 1oCgPʂŃbZ[Wobt@Cs߁C       */
	/*  bZ[Wobt@(UINT8*)^̃|C^ƂĈɓnD */
	ercd = update_Ipdu_Dyna( msgid, (UINT8*)msgbuf_snd_tmp, 
										msgbuf_snd_ipdu[ipduid], p_len);
	if (E_OK != ercd) {
		goto error_exit;
	}

	ipdu_snd_dlc[ipduid] = ((UINT8)(bytesize_snd_ipdu[ipduid] - 
								msgsize_snd_ex_trig_dyna[msgid_no]) + (UINT8)(*p_len));

  exit:
	return(ercd);

  error_exit:
	goto exit;
}

/*--------------------------------------------------------------------
 * Tv      FO-yfBO-_Ci~bNbZ[WIPDU֊i[
 * @\      FbZ[WIPDU֊i[D
 * (in)  F<msgid>   ΏۂƂMbZ[WIuWFNgID
 *           F<p_data>  IPDU֊i[f[^ւ̃|C^
 *           F<p_len>   IPDU֊i[f[^̃f[^ւ̃|C^
 *     (out) FȂ
 * ߂l    FE_OK
 *           FE_IL_CALLOUTFALSE
 *           FĂяo֐
 *           FER[AEg  COM_TRUE or COM_FALSEiE_IL_CALLOUTFALSE)
 *           FEIPDUփf[^Zbg  G[R[h󂯌p  E_OK ̂
 * l      F݋֎~ԂŌĂяo邱
 *           FIPDUi[֐msgidKvȂ̂ŁCmsgiď`ł炤
 *           F֐̂߁CO}NŃG[eo͂̂ł͂ȂC
 *           F{IɏʑwփG[R[hԂCʑwɈ䂾˂D
 *-------------------------------------------------------------------*/
static StatusType
InitSndExPendDyna(MessageIdentifier msgid, 
					ApplicationDataRef p_data, LengthRef p_len)
{
	StatusType			ercd = E_OK;
	CalloutReturnType	cocd = COM_FALSE;
	UINT8				msgid_no = 0;
	UINT8				cnt = 0;
	IPDUType			ipduid = 0;

	msgid_no = (UINT8)(msgid & MSG_ID_MASK);

	/* PoCgRs[ */
	for (cnt = 0; cnt < *p_len; cnt++) {
		/* PoCgRs[邽߁C(UINT8*)^ɃLXg */
		*((UINT8 *)msgbuf_snd_tmp + cnt) = *((UINT8 *)p_data + cnt);
	}

	/* cpu_order bZ[W R[AEgs */
	if( CALLOUTFP_NULL != callout_cpuorder_snd_ex_pend_dyna[msgid_no] ){
		_callout_snddata_addr = msgbuf_snd_tmp;
		cocd = (*callout_cpuorder_snd_ex_pend_dyna[msgid_no])();
		if (COM_FALSE == cocd) {
			ercd = E_IL_CALLOUTFALSE;
			goto exit;
		}
	}

	/* network_order bZ[W R[AEgs */
	if( CALLOUTFP_NULL != callout_netorder_snd_ex_pend_dyna[msgid_no] ){
		_callout_snddata_addr = msgbuf_snd_tmp;
		cocd = (*callout_netorder_snd_ex_pend_dyna[msgid_no])();
		if (COM_FALSE == cocd) {
			ercd = E_IL_CALLOUTFALSE;
			goto exit;
		}
	}

	ipduid = ipduid_snd_ex_pend_dyna[msgid_no];
	/* IPDUփf[^i[ */
	/* 1oCgPʂŃbZ[Wobt@Cs߁C       */
	/*  bZ[Wobt@(UINT8*)^̃|C^ƂĈɓnD */
	ercd = update_Ipdu_Dyna( msgid, (UINT8*)msgbuf_snd_tmp, 
										msgbuf_snd_ipdu[ipduid], p_len);
	if (E_OK != ercd) {
		goto error_exit;
	}

	ipdu_snd_dlc[ipduid] = ((UINT8)(bytesize_snd_ipdu[ipduid] - 
							msgsize_snd_ex_pend_dyna[msgid_no]) + (UINT8)(*p_len));

  exit:
	return(ercd);

  error_exit:
	goto exit;
}


/*--------------------------------------------------------------------
 * Tv      FQUEUEDbZ[W̃Xe[^X擾
 * @\      Fw肳ꂽQUEUEDbZ[W̃Xe[^XԂD
 * (in)  F<Message>  Ԏ擾郁bZ[WID
 *     (out) FȂ
 * ߂l    F
 *   StandardFE_OK         
 *           FE_COM_NO_MSG  L[
 *           FE_COM_LIMIT   ŌReceiveMessagesꂽL[ꂽ
 *   ExtendedFE_COM_ID      ͈͊ÕbZ[WID܂QUEUEDbZ[WȊOw
 *           FEƎ
 *           FE_COM_SYS_ERR ̑G[
 *           F     ioCgI[_ϊsCIPDUփf[^i[sj
 * l      FȂ
 *------------------------------------------------------------------*/
StatusType
GetMessageStatus (MessageIdentifier msgid)
{
	StatusType 	ercd = E_OK;
	UINT8		msgid_no = 0;
	UINT8 		quecnt = 0;
	
	LOG_GETMESSAGESTATUS_ENTER(msgid);
	
	CHECK_INTERRUPT();
	CHECK_COMCALLEVEL(COMCL_START);
	CHECK_QUEMSG(msgid);

	ENTER_CRITICALSECTION();
	
	msgid_no = (UINT8)(msgid & MSG_ID_MASK);

	quecnt = msgque_cnt[msgid_no];
		
	if (quecnt == 0) {
		ercd = E_COM_NOMSG;
	}
	else if (quecnt > tnum_que_elem[msgid_no]) {
		ercd = E_COM_LIMIT;
	}
	else {
		/* ʏ̃L[͈͓̔Ɏ܂Ă */
	}

  exit:
	LEAVE_CRITICALSECTION();
	LOG_GETMESSAGESTATUS_LEAVE(ercd);
	return(ercd);

  error_exit:
	ENTER_CRITICALSECTION();
	_com_errorhook_par1.m_msgid = msgid;
	call_com_errorhook(ercd, COMServiceId_GetMessageStatus);
	goto exit;
}


/*--------------------------------------------------------------------
 * Tv      FMʒmR[obN֐
 * @\      FSndULŗvMƂɋN鏈
 * (in)  F<ipdu_id>  MIPDUID
 *     (out) FȂ
 * ߂l    FȂ
 * l      FSndCancelULƃNXV[PXƂȂꍇ͖{ʒm𖳎邱ƁD
 *------------------------------------------------------------------*/
void
il_snd_fin_func(IPDUType ipdu_id)
{
	StatusType			ercd;
	
	if( IPDU_SENDING == (IPDU_SENDING & flg_snd_ipdu[ipdu_id]) ) {
		if( 0 != delaytime_snd_ipdu[ipdu_id] ) {
			/* MfbhCj^ ^C}Cancel */
			ercd = CancelTimer( timer_snd_ctrl[ipdu_id] );
			if ((E_OK == ercd) || (E_TIM_NOFUNC == ercd)) {
				ercd = E_OK;
			}
			else {
				ercd = E_COM_SYS_ERR;
				goto d_error_exit;
			}
			/* MinimumDelay ^C}Reset */
			ercd = SetRelTimer( timer_snd_ctrl[ipdu_id],
								delaytime_snd_ipdu[ipdu_id],
								0,
								(TIMFP)snd_minimumdelay_timeup,
								ipdu_id );
			if (E_OK != ercd) {
				ercd = E_COM_SYS_ERR;
				goto d_error_exit;
			}
		}
		else {
			snd_minimumdelay_timeup(ipdu_id);
		}
		/* M */
		exec_notification2(ipdu_id);	/* ʒmNX2 */
		exec_resetflag4(ipdu_id);		/* ʒmNX4NA */

	}

  exit:
	return;

  d_error_exit:/* G[ */
	call_com_errorhook(ercd, COMServiceId_CallCOMSndMsgDRV);
	goto exit;
}

/*--------------------------------------------------------------------
 * Tv      FMG[ʒmR[obN֐
 * @\      FSndULŗvꂽf[^̑MɂăG[ƂȂꍇN鏈
 * (in)  F<ipdu_id>        MG[IPDUID
 *           F<err_status>     G[
 *           F                   E_UL_STOP   FʐMhCo~
 *           F                   E_UL_BIT    FMrbgG[
 *           F                   E_UL_NO_RES FMG[
 *     (out) FȂ
 * ߂l    FȂ
 * l      Ferr_status̏ڍ
 *           FE_UL_STOP   FʐMfoCXŜ~G[ɑMvꍇ
 *           FE_UL_BIT    FMf[^ʐMBusŕsƂȂĂꍇ
 *           FE_UL_NO_RES FMOɒʐMBusŎ̑MJnĂ܂ꍇ
 *------------------------------------------------------------------*/
void
il_snd_err_func(IPDUType ipdu_id,StatusType err_status)
{
	StatusType			ercd;
	
	if (IPDU_SENDING == (IPDU_SENDING & flg_snd_ipdu[ipdu_id])) {
		flg_snd_ipdu[ipdu_id] &= IPDU_NO_REQUEST;	/* MOFF */
		ercd = CancelTimer (timer_snd_ctrl[ipdu_id]);		/* TIMEOUTMINIMUMDELAYTIME҂Ol߂lQƂȂ */
		exec_notification4(ipdu_id);						/* G[ */
	}
}

/*--------------------------------------------------------------------
 * Tv      FIPDUMv֐		
 * @\      FUL^IPDȔԂɏ]CULND
 *           FTIMEOUT̎w肪OȊOł΁CfbhCj^p^C}X^[gD
 * (in)  F<ipdu_id>             MvIPDUID
 *     (out) FȂ
 * ߂l    FE_OK                  I
 *           FE_IPDU_SENDING        M
 *           FE_IPDU_NOREQUEST      MvȂ
 *           F<SndUL>̖߂l
 *           F<SetRelTimer>̖߂l
 * l      FG[Xe[^X͂̂܂܏ʂ֕ԂD
 *           FR[AEg̓G[ł͂ȂD
 *------------------------------------------------------------------*/
StatusType
RequestTransmission (IPDUType ipdu_id)
{
	StatusType	ercd = E_OK;
	
	if (IPDU_SEND_REQUEST != (IPDU_SEND_REQUEST & flg_snd_ipdu[ipdu_id])) {
		/* MvĂȂ */
		ercd = E_IPDU_NOREQUEST;
	}
	else if (IPDU_SENDING == (IPDU_SENDING & flg_snd_ipdu[ipdu_id])) {
		/* M */
		ercd = E_IPDU_SENDING;
	}
	else {
		/* IPDU-Callout */
		if (CALLOUTFP_NULL != callout_snd_ipdu[ipdu_id]) {
			if (COM_FALSE == (*callout_snd_ipdu[ipdu_id])() ) {
				ercd = E_IL_CALLOUTFALSE;
				goto exit;
			}	
		}
		/* IPDUUL֑M */
		ercd = SndUL(ipdu_id, msgbuf_snd_ipdu[ipdu_id], 
										ipdu_snd_dlc[ipdu_id]);
		if (E_OK == ercd) {
			if (0 != (timeout_snd_ipdu[ipdu_id])) {
				/* fbhCj^ꍇ^C}Zbg */
				ercd = SetRelTimer( timer_snd_ctrl[ipdu_id], 
										timeout_snd_ipdu[ipdu_id], 
										0, 
										(TIMFP)snd_deadline_timeup, 
										ipdu_id);
			}
		}
		/* G[ƂCtO𑗐MɃZbg */
		if (E_OK == ercd) {
			flg_snd_ipdu[ipdu_id] = IPDU_SENDING;
			exec_resetflag2(ipdu_id);

		}
	}
  exit:
	return(ercd);
}

/*--------------------------------------------------------------------
 * Tv      FMINIMUMDELAYTIME ^CAbv
 * @\      FMINIMUMDELAYTIMẼ^CAbvsD
 *           FM  MvIPDUMv֐ND
 * (in)  F<ipdu_id>      IPDU ID
 *     (out) FȂ
 * ߂l    FȂ
 * l      FRequestTransmission()Ŗ߂lԂĂȂD
*------------------------------------------------------------------*/
static void
snd_minimumdelay_timeup (IPDUType ipdu_id)
{
	StatusType			ercd;
	UINT8				flg;
	
	ercd = CancelTimer (timer_snd_ctrl[ipdu_id]);
	flg = flg_snd_ipdu[ipdu_id];
	if (IPDU_SENDING == (IPDU_SENDING & flg)) {
		flg_snd_ipdu[ipdu_id] &= IPDU_NO_REQUEST;	/* MOFF */
		/* M */
		if (IPDU_SEND_REQUEST == (IPDU_SEND_REQUEST & flg)) {
			/* Mv */
			flg_snd_ipdu[ipdu_id] |= IPDU_SEND_REQUEST;

			(void)RequestTransmission(ipdu_id);
		}
	}
}

/*--------------------------------------------------------------------
 * Tv      FMpfbhCj^^C} ^CAbv
 * @\      FfbhCj^^C}̃^CAbv
 *           Fipdu_idMESSAGEɓo^ꂽNotification֐ĂяoD
 * (in)  F<ipdu_id>      IPDU ID
 *     (out) FȂ
 * ߂l    FȂ
 * l      FȂ
 *------------------------------------------------------------------*/
static void
snd_deadline_timeup (IPDUType ipdu_id)
{
	StatusType			ercd;

	flg_snd_ipdu[ipdu_id] &= IPDU_NO_REQUEST;	/* MOFF	*/
	ercd = SndCancelUL(ipdu_id);				/* ULLZ	*/
	exec_notification4(ipdu_id);				/* G[	*/
}

/*--------------------------------------------------------------------
 * Tv      FMp(ʒmNX2)
 * @\      Fipdu_idMESSAGEɓo^ꂽNotification֐ĂяoD
 * (in)  F<ipdu_id>      IPDU ID
 *     (out) FȂ
 * ߂l    FȂ
 * l      FȂ
 *------------------------------------------------------------------*/
static void
exec_notification2 (IPDUType ipdu_id)
{
	MessageIdentifier	msgid = MSG_NULL;
	UINT8				msgid_no = 0;
	UINT8				cnt = 0;
	FP					fp = FP_NULL;

	/* MESSAGENotification */
	for (cnt=0; MSG_NULL != (msgid = (sndlist_snd_ipdu[ipdu_id])[cnt]); cnt++) {

		msgid_no = (UINT8)(msgid & MSG_ID_MASK);

		if ((MSG_SND_NORM | MSG_SND_EXT | MSG_SND_PEND) 
												== (msgid & MSG_SND_MASK)) {
			fp = notification2_snd_ex_pend_norm[msgid_no];
		}
		else if ((MSG_SND_NORM | MSG_SND_EXT) == (msgid & MSG_SND_MASK)) {
			fp = notification2_snd_ex_trig_norm[msgid_no];
		}
		else if ((MSG_SND_DYNA | MSG_SND_EXT) == (msgid & MSG_SND_MASK)) {
			fp = notification2_snd_ex_trig_dyna[msgid_no];
		}
		else if ((MSG_SND_DYNA | MSG_SND_EXT | MSG_SND_PEND) 
												== (msgid & MSG_SND_MASK)) {
			fp = notification2_snd_ex_pend_dyna[msgid_no];
		}
		else if ((MSG_SND_ZERO | MSG_SND_EXT) == (msgid & MSG_SND_MASK)) {
			fp = notification2_snd_ex_trig_zero[msgid_no];
		}
		else {
			/* msgids */
		}

		if (FP_NULL != fp) {
			LEAVE_CRITICALSECTION();
			fp();
			ENTER_CRITICALSECTION();

			fp = FP_NULL;
		}
	}
}

/*--------------------------------------------------------------------
 * Tv      FMpG[
 * @\      Fipdu_idMESSAGEɓo^ꂽNotification֐ĂяoD
 * (in)  F<ipdu_id>      IPDU ID
 *     (out) FȂ
 * ߂l    FȂ
 * l      FȂ
 *------------------------------------------------------------------*/
static void
exec_notification4 (IPDUType ipdu_id)
{
	MessageIdentifier	msgid = MSG_NULL;
	UINT8				msgid_no = 0;
	UINT8				cnt = 0;
	FP					fp = FP_NULL;

	/* MESSAGENotification */
	for (cnt=0; MSG_NULL != (msgid = (sndlist_snd_ipdu[ipdu_id])[cnt]); cnt++) {

		msgid_no = (UINT8)(msgid & MSG_ID_MASK);

		if ((MSG_SND_NORM | MSG_SND_EXT | MSG_SND_PEND) 
												== (msgid & MSG_SND_MASK)) {
			fp = notification4_snd_ex_pend_norm[msgid_no];
		}
		else if ((MSG_SND_NORM | MSG_SND_EXT) == (msgid & MSG_SND_MASK)) {
			fp = notification4_snd_ex_trig_norm[msgid_no];
		}
		else if ((MSG_SND_DYNA | MSG_SND_EXT) == (msgid & MSG_SND_MASK)) {
			fp = notification4_snd_ex_trig_dyna[msgid_no];
		}
		else if ((MSG_SND_DYNA | MSG_SND_EXT | MSG_SND_PEND) 
												== (msgid & MSG_SND_MASK)) {
			fp = notification4_snd_ex_pend_dyna[msgid_no];
		}
		else if ((MSG_SND_ZERO | MSG_SND_EXT) == (msgid & MSG_SND_MASK)) {
			fp = notification4_snd_ex_trig_zero[msgid_no];
		}
		else {
			/* msgids */
		}

		if (FP_NULL != fp) {
			LEAVE_CRITICALSECTION();
			fp();
			ENTER_CRITICALSECTION();
			fp = FP_NULL;
		}
	}
}

/*--------------------------------------------------------------------
 * Tv      FMp(ʒmNX2)
 * @\      Fipdu_idMESSAGEɓo^ꂽresetflag֐ĂяoD
 * (in)  F<ipdu_id>      IPDU ID
 *     (out) FȂ
 * ߂l    FȂ
 * l      FȂ
 *------------------------------------------------------------------*/
static void
exec_resetflag2 (IPDUType ipdu_id)
{
	MessageIdentifier	msgid = MSG_NULL;
	UINT8				msgid_no = 0;
	UINT8				cnt = 0;
	FP					fp = FP_NULL;

	/* MESSAGEresetflag */
	for (cnt=0; MSG_NULL != (msgid = (sndlist_snd_ipdu[ipdu_id])[cnt]); cnt++) {

		msgid_no = (UINT8)(msgid & MSG_ID_MASK);

		if ((MSG_SND_NORM | MSG_SND_EXT | MSG_SND_PEND) 
												== (msgid & MSG_SND_MASK)) {
			fp = resetflag2_snd_ex_pend_norm[msgid_no];
		}
		else if ((MSG_SND_NORM | MSG_SND_EXT) == (msgid & MSG_SND_MASK)) {
			fp = resetflag2_snd_ex_trig_norm[msgid_no];
		}
		else if ((MSG_SND_DYNA | MSG_SND_EXT) == (msgid & MSG_SND_MASK)) {
			fp = resetflag2_snd_ex_trig_dyna[msgid_no];
		}
		else if ((MSG_SND_DYNA | MSG_SND_EXT | MSG_SND_PEND) 
												== (msgid & MSG_SND_MASK)) {
			fp = resetflag2_snd_ex_pend_dyna[msgid_no];
		}
		else if ((MSG_SND_ZERO | MSG_SND_EXT) == (msgid & MSG_SND_MASK)) {
			fp = resetflag2_snd_ex_trig_zero[msgid_no];
		}
		else {
			/* msgids */
		}

		if (FP_NULL != fp) {
			LEAVE_CRITICALSECTION();
			fp();
			ENTER_CRITICALSECTION();
			fp = FP_NULL;
		}
	}
}

/*--------------------------------------------------------------------
 * Tv      FMpG[
 * @\      Fipdu_idMESSAGEɓo^ꂽresetflag֐ĂяoD
 * (in)  F<ipdu_id>      IPDU ID
 *     (out) FȂ
 * ߂l    FȂ
 * l      FȂ
 *------------------------------------------------------------------*/
static void
exec_resetflag4 (IPDUType ipdu_id)
{
	MessageIdentifier	msgid = MSG_NULL;
	UINT8				msgid_no = 0;
	UINT8				cnt = 0;
	FP					fp = FP_NULL;

	/* MESSAGEresetflag	*/
	for (cnt=0; MSG_NULL != (msgid = (sndlist_snd_ipdu[ipdu_id])[cnt]); cnt++) {

		msgid_no = (UINT8)(msgid & MSG_ID_MASK);

		if ((MSG_SND_NORM | MSG_SND_EXT | MSG_SND_PEND) 
												== (msgid & MSG_SND_MASK)) {
			fp = resetflag4_snd_ex_pend_norm[msgid_no];
		}
		else if ((MSG_SND_NORM | MSG_SND_EXT) == (msgid & MSG_SND_MASK)) {
			fp = resetflag4_snd_ex_trig_norm[msgid_no];
		}
		else if ((MSG_SND_DYNA | MSG_SND_EXT) == (msgid & MSG_SND_MASK)) {
			fp = resetflag4_snd_ex_trig_dyna[msgid_no];
		}
		else if ((MSG_SND_DYNA | MSG_SND_EXT | MSG_SND_PEND) 
												== (msgid & MSG_SND_MASK)) {
			fp = resetflag4_snd_ex_pend_dyna[msgid_no];
		}
		else if ((MSG_SND_ZERO | MSG_SND_EXT) == (msgid & MSG_SND_MASK)) {
			fp = resetflag4_snd_ex_trig_zero[msgid_no];
		}
		else {
			/* msgids */
		}

		if (FP_NULL != fp) {
			LEAVE_CRITICALSECTION();
			fp();
			ENTER_CRITICALSECTION();
			fp = FP_NULL;
		}
	}
}



/*--------------------------------------------------------------------
 * Tv      FMpfbhCj^^C} ^CAbv
 * @\      FfbhCj^^C}̃^CAbvsD
 *           Fipdu_idMESSAGEɓo^ꂽNotification֐ĂяoD
 * (in)  F<ipdu_id>      IPDU ID
 *     (out) FȂ
 * ߂l    FȂ
 * l      FȂ
 *------------------------------------------------------------------*/
void
rcv_deadline_timeup(UINT8 ipdu_id)
{
	MessageIdentifier	msgid = MSG_NULL;
	UINT8				msgid_no = 0;
	UINT8				cnt = 0;
	FP					fp = FP_NULL;
	UINT8				msg_cnt = 0;
	
	/* ULLZ	*/
	/* MESSAGENotification	*/
	for( cnt=0; MSG_NULL != (msgid = (sndlist_rcv_ipdu[ipdu_id])[cnt]); cnt++) {
		msgid_no = (UINT8)(msgid & MSG_ID_MASK);
		if ((MSG_RCV_NORM | MSG_RCV_IPDU) == (msgid & MSG_RCV_MASK)) {
			/* IPDUbZ[Wilbg[NbZ[WjCM-ʏ탁bZ[WID擾 */
			for (msg_cnt = 0; 
				 MSG_NULL != (msgid = (sndlist_rcv_ipdu_norm[msgid_no])[msg_cnt]);
																	msg_cnt++) {
				msgid_no = (UINT8)(msgid & MSG_ID_MASK);
				
				/* QUEUED UNQUEUED ̐؂蕪 */
				if (MSG_RCV_QUED == (msgid & MSG_RCV_QUED)) {
					fp = notification3_rcv_que_norm[msgid_no];
				}
				else {
					fp = notification3_rcv_unq_norm[msgid_no];
				}
			}
		}
		else if ((MSG_RCV_ZERO | MSG_RCV_IPDU) == (msgid & MSG_RCV_MASK)) {
			fp = notification3_rcv_unq_zero[msgid_no];
		}
		else if ((MSG_RCV_DYNA | MSG_RCV_IPDU) == (msgid & MSG_RCV_MASK)) {
			fp = notification3_rcv_unq_dyna[msgid_no];
		}
		else {
			/* msgids */
		}

		if (FP_NULL != fp) {
			LEAVE_CRITICALSECTION();
			fp();
			ENTER_CRITICALSECTION();
			fp = FP_NULL;
		}
	}
}

/*--------------------------------------------------------------------
 * Tv      FMbZ[WIuWFNgփf[^Zbg
 * @\      Fw肳ꂽMʏ탁bZ[WIuWFNgiO^Ƃj
 *           Fw肳ꂽf[^ZbgD
 * (in)  F<msgid>      f[^Zbg郁bZ[WID
 *     (out) F<p_data>     f[^ZbgAhX
 * ߂l    FE_OK           I
 *           FE_IL_FILTERED  tB^ʉ߂
 * l      FSendMessage̓ʐMƎM^XÑf[^ZbgɂĎgpD
 *------------------------------------------------------------------*/

StatusType
SetRcvMsg (MessageIdentifier msgid, ApplicationDataRef p_data)
{
	
	StatusType	ercd		= E_OK;
	UINT8 		msgid_no	= IPDU_NULL;
	FP			fp			= FP_NULL;
	
	msgid_no = (UINT8)(msgid & MSG_ID_MASK);	/* IDAԕo */
	
	/*----------------
		 L[
	 -----------------*/
	if (MSG_RCV_QUED == (msgid & MSG_RCV_QUED)) {
		/* tB^O */
		if (FILTFP_NULL != filter_rcv_que_norm[msgid_no]) {
			if (E_OK != (*filter_rcv_que_norm[msgid_no])(p_data)) {
				ercd = E_IL_FILTERED;
				goto exit;
			}
		}
		if (msgque_cnt[msgid_no] < tnum_que_elem[msgid_no]) {
			/* bZ[Wi[ */
			(*copyfunc_rcv_que_norm[msgid_no])(
										msgque_put_addr[msgid_no], p_data);

			/* L[obt@ŏIʒu܂ŗƂC擪AhXZbg */
			msgque_put_addr[msgid_no] = (ApplicationDataRef)(
				(UINT8*)(msgque_put_addr[msgid_no]) + msgsize_que_norm[msgid_no]);
			if (msgque_put_addr[msgid_no] > msgbuf_end_que_norm[msgid_no]) {
				msgque_put_addr[msgid_no] = msgbuf_head_que_norm[msgid_no];
			}
			msgque_cnt[msgid_no]++;

			/* notification if[^obt@Ɋi[ꂽシj*/
			/* f[^obt@Ɋi[łƂ̂ݒʒm */
			fp = notification1_rcv_que_norm[msgid_no];
		}
		else {
			/* L[bZ[Wi[L[I[o[ݒ */
			msgque_cnt[msgid_no] = tnum_que_elem[msgid_no] + ((UINT8) 1);
		}
	}
	else {
	/*----------------
		 L[
	 -----------------*/
		/* tB^O */
		if (FILTFP_NULL != filter_rcv_unq_norm[msgid_no]) {
			if (E_OK != (*filter_rcv_unq_norm[msgid_no])(p_data)) {
				ercd = E_IL_FILTERED;
				goto exit;
			}
		}

		/* bZ[Wi[ */
		(*copyfunc_rcv_unq_norm[msgid_no])(
								((ApplicationDataRef)(msgbuf_rcv_unq_norm[msgid_no])),((ApplicationDataRef)(p_data)));

		fp = notification1_rcv_unq_norm[msgid_no];
	}
	
  exit:
	/* notification֐ݒ肳ĂΎs */
	if ((FP_NULL != fp)  &&  (E_OK == ercd)) {
		(*fp)();
	}
	return ercd;
}

/*--------------------------------------------------------------------
 * Tv      FMbZ[WIuWFNgփf[^Zbg
 * @\      Fw肳ꂽMʏ탁bZ[WIuWFNgiO^Ƃj
 *           Fw肳ꂽf[^ZbgD
 * (in)  F<Message>   f[^Zbg郁bZ[WID
 *     (out) FȂ
 * ߂l    FE_OK        I
 * l      FSendZeroMessage̓ʐMƎM^XÑCxgʒmŎgpD
 *------------------------------------------------------------------*/

StatusType
SetRcvZeroMsg (MessageIdentifier msgid)
{
	
	StatusType	ercd		= E_OK;
	UINT8 		msgid_no	= IPDU_NULL;
	FP			fp			= FP_NULL;
	
	msgid_no = (UINT8)(msgid & MSG_ID_MASK);	/* IDAԕo */
	
	fp = notification1_rcv_unq_zero[msgid_no];

	/* notification֐ݒ肳ĂΎs */
	if (FP_NULL != fp) {
		(*fp)();
	}
	return ercd;
}

