/*
 *  TOPPERS/OSEK COM
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK COM
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/* 
 * com_reception.c
 * 
 * ReceiveMessage, ReceiveDynamicMessage, M^XN(COMReceiveTask)
 * 
 */

#include "osek_com.h"
#include "com_timer_user.h"
#include "com_interrupt.h"
#include "com_check.h"

#include "can_cmn.h"
#include "com_cfg.h"			/* TNUM_RCV_IPDU`FbN̂ */

/*
 *	vg^Cv錾
 */
DeclareTask(COMReceiveTask);

/* 
 * O[oϐ
 */
/* MIPDUIDM^XN֓n߂̕ϐ */
IPDUType rcv_ipdu_id[TNUM_RCV_IPDU+RCV_IPDU_BUF_ADD];

UINT8 setpoint_rcv_ipdu_id;		/* rcv_ipdu_id̃f[^ݒʒu		*/
UINT8 getpoint_rcv_ipdu_id;		/* rcv_ipdu_id̃f[^oʒu	*/
void *_callout_rcvdata_addr;	/* R[AEg̃f[^obt@ւ̃|C^ */

/*--------------------------------------------------------------------
 * Tv      FUL̎Mʒm̎󂯌
 * @\      FULIPDUMƂɌĂяoD
 *           F󂯓npϐ֎MIPDUIDZbgĎM^XNND
 * (in)  F<ipdu_id>              MIPDUID
 *     (out) FȂ
 * ߂l    FȂ
 * l      FOSEKł̓^XNɈnċN邱ƂłȂ߁C
 *           F󂯓np̃O[oϐāCMIPDUIDnĂD
 *------------------------------------------------------------------*/
void il_rcv_fin_func (IPDUType ipdu_id)
{
	StatusType	ercd;

	/* MfbhCj^^C}Cancel&Reset */
	if( 0 != timeout_rcv_ipdu[ipdu_id] ){
		/* Cancel */
		ercd = CancelTimer( timer_rcv_ctrl[ipdu_id] );
		if ((E_OK == ercd) || (E_TIM_NOFUNC == ercd)) {
			ercd = E_OK;
		}
		else {
			ercd = E_COM_SYS_ERR;
			goto d_error_exit;
		}
		/* Reset */
		ercd = SetRelTimer( timer_rcv_ctrl[ipdu_id],
							timeout_rcv_ipdu[ipdu_id],
							timeout_rcv_ipdu[ipdu_id],
							rcv_deadline_timeup,
							ipdu_id );
		if (E_OK != ercd) {
			ercd = E_COM_SYS_ERR;
			goto d_error_exit;
		}
	}

	/* O[oϐIPDUIDZbg   */
	/* ̐ݒʒuֈڍs			*/
	setpoint_rcv_ipdu_id++;
		/* f[^ݒʒuO񂪍Ō̈ʒuHH	*/

	if (setpoint_rcv_ipdu_id > TNUM_RCV_IPDU) {

		/* ɖ߂						*/
		setpoint_rcv_ipdu_id = 0;
	}
	/* O[oϐIPDUIDZbg */
		/* f[^ݒʒu肪i㏑h~j	*/
	if (setpoint_rcv_ipdu_id == getpoint_rcv_ipdu_id ) {

		/* err MIPDU󂯓nGAI[o[t[		*/
		ercd = E_COM_SYS_ERR;
		goto d_error_exit;
	}
	else {
		/* MZbg			*/
		rcv_ipdu_id[setpoint_rcv_ipdu_id] = ipdu_id;
	}

	/* M^XNN */
	(void)ActivateTask(COMReceiveTask);


  exit:
	return;

  d_error_exit:/* G[ */
	call_com_errorhook(ercd, COMServiceId_CallCOMRcvMsgDRV);
	goto exit;
}

/*--------------------------------------------------------------------
 * Tv      FUL̎MG[ʒm̎󂯌
 * @\      FMG[ULND
 *           FYIPDŨbZ[W Notification Class 3 sD
 * (in)  F<ipdu_id>              MIPDUID
 *           F<err_status>           MG[̃Xe[^X
 *     (out) FȂ
 * ߂l    FȂ
 * l      FȂ
 *------------------------------------------------------------------*/
void il_rcv_err_func(IPDUType ipdu_id, StatusType err_status)
{
	MessageIdentifier	recvid 	= MSG_NULL;	/* IPDUɊi[ꂽbZ[WID */
	MessageIdentifier	msgid 	= MSG_NULL;	/* MbZ[WID */
	UINT8				recv_cnt 	= 0;	/* IPDUbZ[WID擾pJE^ */
	UINT8				msg_cnt  	= 0;	/* MbZ[WID擾pJE^ */
	UINT8				recvid_no 	= 0;	/* ID̃CfbNX */
	UINT8				msgid_no 	= 0;	/* ID̃CfbNX */


	/*---------------------------------------
		IPDUi[bZ[WPʂ̃[v
	 --------------------------------------*/
	/* IPDUIPDUbZ[WiNETWORKbZ[WjID擾 */
	for(recv_cnt = 0; 
			MSG_NULL != (recvid = (sndlist_rcv_ipdu[ipdu_id])[recv_cnt]); 
															recv_cnt++ ){
		recvid_no = (UINT8)(recvid & MSG_ID_MASK);
		/*-----------------------------------------------
			bZ[WނŐ؂蕪Fʏ탁bZ[W
		 ----------------------------------------------*/
		if((MSG_RCV_NORM | MSG_RCV_IPDU) == (recvid & MSG_RCV_MASK)){
			/* 
			 *  IPDUbZ[Wilbg[NbZ[WjC
			 *  M-ʏ탁bZ[WID擾
			 */
			for (msg_cnt = 0; 
				MSG_NULL != (msgid = (sndlist_rcv_ipdu_norm[recvid_no])[msg_cnt]);
																	msg_cnt++) {
				msgid_no = (UINT8)(msgid & MSG_ID_MASK);

				/* QUEUED UNQUEUED ̐؂蕪 */
				if (MSG_RCV_QUED == (msgid & MSG_RCV_QUED)) {
					if (FP_NULL != notification3_rcv_que_norm[msgid_no]) {
						(*notification3_rcv_que_norm[msgid_no])();
					}
				}
				else {
					if (FP_NULL != notification3_rcv_unq_norm[msgid_no]) {
						(*notification3_rcv_unq_norm[msgid_no])();
					}
				}
			}
		}
		/*-----------------------------------------------
			bZ[WނŐ؂蕪F[OX
		 ----------------------------------------------*/
		else if((MSG_RCV_ZERO | MSG_RCV_IPDU) == (recvid & MSG_RCV_MASK) ){
			/*
			 *  IPDUbZ[Wilbg[NbZ[WjC
			 *	M-[̃bZ[WID擾D
			 */
			msgid = sndlist_rcv_ipdu_zero[recvid_no];
			/* IDAԕo */
			msgid_no = (UINT8)(msgid & MSG_ID_MASK);
			if( FP_NULL != notification3_rcv_unq_zero[msgid]) {
				(*notification3_rcv_unq_zero[msgid_no])();
			}
		}
		/*-----------------------------------------------
			bZ[WނŐ؂蕪F_Ci~bNbZ[W
	 	----------------------------------------------*/
		else if((MSG_RCV_DYNA | MSG_RCV_IPDU) == (recvid & MSG_RCV_MASK) ){
			/*
			 * IPDUbZ[Wilbg[NbZ[WjC
			 *  M-_Ci~bÑbZ[WID擾D
			 */

			for (msg_cnt = 0; 
				MSG_NULL != (msgid = (sndlist_rcv_ipdu_dyna[recvid_no])[msg_cnt]);
				 													msg_cnt++) {
				/* IDAԕo */
				msgid_no = (UINT8)(msgid & MSG_ID_MASK);
				if( FP_NULL != notification3_rcv_unq_dyna[msgid_no]) {
					(*notification3_rcv_unq_dyna[msgid_no])();
				}
			}
		}
		else {
		}
	}
}

/*--------------------------------------------------------------------
 * Tv      FMIPDUMbZ[WIuWFNgփf[^i[D
 * @\      FIPDU烁bZ[Wf[^o
 *           FeR[AEgsiIPDU, Network-order, CPU-orderj
 *           FoCgI[_ϊs
 *           FMbZ[WIuWFNgփf[^i[
 *           FiQUEUEDCUNQUEUEDC_Ci~bNC[j
 * (in)  F<COMReceiveTask>      COMM^XN
 *     (out) FȂ
 * l      FDxmvGveBuł̓z肵ĂD
 *------------------------------------------------------------------*/
TASK(COMReceiveTask)
{
	MessageIdentifier	recvid 	= MSG_NULL;	/* IPDUɊi[ꂽbZ[WID */
	MessageIdentifier	msgid 	= MSG_NULL;	/* MbZ[WID */
	UINT8	recv_cnt 	= 0;	/* [IPDUbZ[W]ID擾pJE^ */
	UINT8	msg_cnt 	= 0;	/* [MbZ[W]ID擾pJE^ */
	UINT8	recvid_no 	= 0;	/* [IPDUbZ[W]IDAԂ̂ݎo */
	UINT8	msgid_no 	= 0;	/* [MbZ[W]IDAԂ̂ݎo */

	UINT8	rcv_data_len = 0;	/* MIPDŨf[^ */
	UINT32	bitlen		= 0;	/* _Ci~bÑrbg */

	IPDUType		ipdu_id	= IPDU_NULL;	/* MIPDUID */
	StatusType		ercd 	= E_OK;

	UINT8	copy_cnt = 0;	/* _Ci~bNbZ[WRs[p */

	LOG_COMRECEIVETASK_ENTER();

/* 
 * [JϐIPDUIDRs[D
 * VɎMC󂯌Ă΂ꂽƂCrcv_ipdu_id͍XVĂ܂߁D
 */
	/* O[oϐIPDUIDo  */
	/* ̎oʒuֈڍs			*/
	getpoint_rcv_ipdu_id++;
	/* f[^oʒuO񂪍Ō̈ʒuHH	*/

	if (getpoint_rcv_ipdu_id > TNUM_RCV_IPDU) {

		/* ɖ߂						*/
		getpoint_rcv_ipdu_id = 0;
	}

	/* O[oϐIPDUIDo */
	ipdu_id = rcv_ipdu_id[getpoint_rcv_ipdu_id];

/* 
 * R[AEgf[^QƂ邱ƂlCR[AEgOɃf[^Rs[
 */
	/* 1oCgPʂŃbZ[Wobt@Cs߁C       */
	/*  bZ[Wobt@(UINT8*)^̃|C^ƂĈɓnD */
	ercd = RcvUL( ipdu_id, (UINT8*)ipdubuf_rcv_tmp, &rcv_data_len);
	if (E_OK != ercd) {
		/* G[ */
		LOG_COMRECEIVETASK_ERROR(ercd, ipdu_id);
		ercd = E_COM_SYS_ERR;
		goto error_exit;
	}

	/*IPDUR[AEg*/
	if (CALLOUTFP_NULL != callout_rcv_ipdu[ipdu_id]) {
		/* R[AEgŃf[^փANZXł悤ɁC|C^ێ */
		_callout_rcvdata_addr = ipdubuf_rcv_tmp;
		/* R[AEg̖߂l */
		if (COM_FALSE == (*callout_rcv_ipdu[ipdu_id])()) {
			LOG_COMRECEIVETASK_CALLOUTFALSE(ipdu_id);
			ercd = E_OK;
			goto exit;
		}	
	}

	/*---------------------------------------
		IPDUi[bZ[WPʂ̃[v
	 --------------------------------------*/
	/* IPDUIPDUbZ[WiNETWORKbZ[WjID擾 */
	for(recv_cnt = 0; 
			MSG_NULL != (recvid = (sndlist_rcv_ipdu[ipdu_id])[recv_cnt]); 
																recv_cnt++ ){
		
		recvid_no = (UINT8)(recvid & MSG_ID_MASK);

		/*-----------------------------------------------
			bZ[WނŐ؂蕪Fʏ탁bZ[W
		 ----------------------------------------------*/
		if((MSG_RCV_NORM | MSG_RCV_IPDU) == (recvid & MSG_RCV_MASK)){

			CHECK_MAX_RCV_IPDU_NORM(recvid_no);
			/* rbg(ʏ탁bZ[Wł͕sgp) */
			bitlen = ((UINT32)rcv_data_len * 8);

			/* IPDUf[^o */
			/* 1oCgPʂŃbZ[Wobt@Cs߁C       */
			/*  bZ[Wobt@(UINT8*)^̃|C^ƂĈɓnD */
			ercd = update_Message(recvid, 
									(UINT8 *)ipdubuf_rcv_tmp, 
									(UINT8 *)msgbuf_rcv_ipdu_tmp,
									&bitlen);
			if (E_OK != ercd) {
				LOG_COMRECEIVETASK_ERROR(ercd, recvid);
				ercd = E_COM_SYS_ERR;
				goto error_exit;
			}

			/* networkorderR[AEg */
			if (CALLOUTFP_NULL != callout_netorder_rcv_ipdu_norm[recvid_no]) {
				_callout_rcvdata_addr = msgbuf_rcv_ipdu_tmp;
				if (COM_FALSE 
						== (*callout_netorder_rcv_ipdu_norm[recvid_no])()) {
					LOG_COMRECEIVETASK_CALLOUTFALSE(recvid);
					continue;
				}	
			}
			
			/* oCgI[_[ϊ */
			/*
			 *	ŕϊ̔fsDϊLɂ炸C
			 *	p_destɃf[^͊i[
			 */
			/* 1oCgPʂŃbZ[Wobt@Cs߁C       */
			/*  bZ[Wobt@(UINT8*)^̃|C^ƂĈɓnD */
			ercd = convert_byteorder( recvid, 
										(UINT8*)msgbuf_rcv_ipdu_tmp, 
										(UINT8*)msgbuf_rcv_after_swapbytes );
			if (E_OK != ercd) {
				LOG_COMRECEIVETASK_ERROR(ercd, recvid);
				ercd = E_COM_SYS_ERR;
				goto error_exit;
			}

			/* CPU-orderR[AEg */
			if (CALLOUTFP_NULL != callout_cpuorder_rcv_ipdu_norm[recvid_no]) {
				_callout_rcvdata_addr = msgbuf_rcv_after_swapbytes;
				if (COM_FALSE 
						== (*callout_cpuorder_rcv_ipdu_norm[recvid_no])()) {
					LOG_COMRECEIVETASK_CALLOUTFALSE(recvid);
					continue;
				}	
			}
			
			/* IPDUbZ[WMbZ[W֊i[ */
			/*  
			 *  IPDUbZ[Wilbg[NbZ[WjC
			 *  MbZ[WID擾
			 */
			for (msg_cnt = 0; 
					MSG_NULL != (msgid 
								= (sndlist_rcv_ipdu_norm[recvid_no])[msg_cnt]);
					msg_cnt++) {
				
				/* MbZ[Wi[֐Ăяo */
				ercd = SetRcvMsg(msgid, msgbuf_rcv_after_swapbytes);
				if (E_IL_FILTERED == ercd) {
					/* tB^ŃJbgꂽ */
					LOG_COMRECEIVETASK_FILTERED(msgid);
				}
			}
		}
		/*-----------------------------------------------
			bZ[WނŐ؂蕪F[OX
		 ----------------------------------------------*/
		else if((MSG_RCV_ZERO | MSG_RCV_IPDU) == (recvid & MSG_RCV_MASK) ){

			CHECK_MAX_RCV_IPDU_ZERO(recvid_no);
			/* network-orderR[AEg */
			if( CALLOUTFP_NULL != callout_netorder_rcv_ipdu_zero[recvid_no] ){
				if( COM_FALSE == (*callout_netorder_rcv_ipdu_zero[recvid_no])() ){
					LOG_COMRECEIVETASK_CALLOUTFALSE(recvid);
					continue;
				}	
			}
			
			/* cpu-orderR[AEg */
			if( CALLOUTFP_NULL != callout_cpuorder_rcv_ipdu_zero[recvid_no] ){
				if( COM_FALSE == (*callout_cpuorder_rcv_ipdu_zero[recvid_no])() ){
					LOG_COMRECEIVETASK_CALLOUTFALSE(recvid);
					continue;
				}
			}

			/* M-[̃bZ[WID擾 */
			msgid = sndlist_rcv_ipdu_zero[recvid_no];

			/* ADD	[bZ[ŴƂmsgid_no	*/
			/* IDAԕo */
			msgid_no = (UINT8)(msgid & MSG_ID_MASK);
			CHECK_MAX_RCV_ZERO(msgid_no);

			if( FP_NULL != notification1_rcv_unq_zero[msgid_no]) {
				(*notification1_rcv_unq_zero[msgid_no])();
			}
		}
		/*-----------------------------------------------
			bZ[WނŐ؂蕪F_Ci~bNbZ[W
	 	----------------------------------------------*/
		else if((MSG_RCV_DYNA | MSG_RCV_IPDU) == (recvid & MSG_RCV_MASK) ){

			CHECK_MAX_RCV_IPDU_DYNA(recvid_no);
			/* _Ci~bNbZ[W̃rbgvZ */
			bitlen = (rcv_data_len * 8) - offset_rcv_ipdu_dyna[recvid_no];

			/* IPDUf[^Rs[ */
			/* 1oCgPʂŃbZ[Wobt@Cs߁C       */
			/*  bZ[Wobt@(UINT8*)^̃|C^ƂĈɓnD */
			ercd = update_Message(recvid, 
									(UINT8 *)ipdubuf_rcv_tmp, 
									(UINT8 *)msgbuf_rcv_ipdu_tmp,
									&bitlen);

			/* f[^ZbgiPʁFoCgj */
			*msglength_rcv_unq_dyna[recvid_no] = (COMLengthType)((bitlen + 7) / 8);

			/* R[AEg */
			if( CALLOUTFP_NULL != callout_netorder_rcv_ipdu_dyna[recvid_no]){
				_callout_rcvdata_addr = msgbuf_rcv_ipdu_tmp;
				if( COM_FALSE == (*callout_netorder_rcv_ipdu_dyna[recvid_no])()){
					LOG_COMRECEIVETASK_CALLOUTFALSE(recvid);
					continue;
				}	
			}
			
			/* R[AEg */
			if( CALLOUTFP_NULL != callout_cpuorder_rcv_ipdu_dyna[recvid_no]){
				_callout_rcvdata_addr = msgbuf_rcv_ipdu_tmp;
				if( COM_FALSE == (*callout_cpuorder_rcv_ipdu_dyna[recvid_no])()){
					LOG_COMRECEIVETASK_CALLOUTFALSE(recvid);
					continue;
				}	
			}
			/*-----------------------------------------------
				IPDUbZ[Wi_Ci~bNj
				M_Ci~bNbZ[W֊i[
			 ----------------------------------------------*/
			for (msg_cnt = 0; 
					MSG_NULL != (msgid 
								= (sndlist_rcv_ipdu_dyna[recvid_no])[msg_cnt]);
																	msg_cnt++) {
				/* IDAԕo */
				msgid_no = (UINT8)(msgid & MSG_ID_MASK);
				CHECK_MAX_RCV_DYNA_EI(msgid_no);
				/* M_Ci~bNbZ[W֊i[ */
				for (copy_cnt = 0; 
						copy_cnt < *(msglength_rcv_unq_dyna[msgid_no]); 
															copy_cnt++) {
					/* PoCgRs[邽߁C(UINT8*)^ɃLXg */
					*((UINT8 *)msgbuf_rcv_unq_dyna[msgid_no] + copy_cnt) 
										= *((UINT8 *)msgbuf_rcv_ipdu_tmp + copy_cnt);
				}
				/* f[^Zbg */
				/*
				 *  IPDU̒ƃ_Ci~bNbZ[W̃rbg|WV
				 *  _Ci~bNbZ[W̒擾
				 *  擾f[^́Cmsglength_rcv_unq_dyne[]փZbg
				 *  oCgPʂ֐؂グ邱ƂƂ
				 */

				if( FP_NULL != notification1_rcv_unq_dyna[msgid_no]) {
					(*notification1_rcv_unq_dyna[msgid_no])();
				}
			}
		}
		/* ȃbZ[WID */
		else{
			ercd = E_COM_ID;
			LOG_COMRECEIVETASK_ERROR(ercd, recvid);
			goto error_exit;
		}	
	}

	/* I */
  exit:
	LOG_COMRECEIVETASK_LEAVE(ercd);
	(void)TerminateTask();
	/* ɂ͖߂ĂȂ */
	return;

  error_exit:
	goto exit;
}

/*--------------------------------------------------------------------
 * Tv      FMʏ(Œ蒷)bZ[WIuWFNgf[^o
 * @\      FMʏ(Œ蒷)bZ[WIuWFNgf[^擾C
 *           FŎw肳ꂽAvP[V̗̈Ɋi[D
 *           FNotification(Class1 Class3)Őݒ肳ꂽtONAD
 * (in)  F<Message>  ΏۂƂMbZ[WIuWFNgID
 *     (out) F<DataRef>  擾f[^̃AvP[Vi[ꏊ
 * ߂l    F
 *   StandardFE_OK
 *           FE_COM_NOMSG          queued̂݁Df[^Ƃ
 *           FE_COM_LIMIT          queued̂݁DߋML[ꂽ
 *   ExtendedFE_COM_ID             ID͈͊OCMCM_Ci~bNCM[Q
 *           FEƎ
 *           FE_COM_SYS_INTERRUPT  ֎~ɃR[
 *           FE_COM_SYS_CALLEVEL   COMR[x̕s
 *           FE_COM_SYS_ERR        ̑G[
 * l      FȂ
 *------------------------------------------------------------------*/
StatusType 
ReceiveMessage(MessageIdentifier msgid, ApplicationDataRef p_data)
{
	StatusType	ercd = E_OK;
	UINT8	msgid_no = 0;

	LOG_RECEIVEMESSAGE_ENTER(msgid, p_data);

	CHECK_INTERRUPT();
	CHECK_COMCALLEVEL(COMCL_START);
	CHECK_RECVMSG(msgid);

	ENTER_CRITICALSECTION();

	msgid_no = (UINT8)(msgid & MSG_ID_MASK);

	if ((MSG_RCV_NORM | MSG_RCV_QUED) == (msgid & MSG_RCV_MASK)) {
		CHECK_MAX_RCV_QUED(msgid_no);
		if (0 < msgque_cnt[msgid_no]) {
			/* bZ[Wi[ */
			(*copyfunc_rcv_que_norm[msgid_no])(p_data, 
												msgque_get_addr[msgid_no]);

			/* ̃f[^i[ʒuݒ */
			msgque_get_addr[msgid_no] = (ApplicationDataRef)(
				(UINT8*)(msgque_get_addr[msgid_no]) + msgsize_que_norm[msgid_no]);
			/* L[ŏIvfi[ʒȕꍇCvfi[ʒu擪ɂ */
			if (msgque_get_addr[msgid_no] > msgbuf_end_que_norm[msgid_no]) {
				msgque_get_addr[msgid_no] = msgbuf_head_que_norm[msgid_no];
			}
		}
		else {
			/* bZ[ŴƂ̓G[s */
			ercd = E_COM_NOMSG;
			goto d_error_exit;
		}

		/* {APICALLOɃL[Ăꍇ̓G[sD	*/
		/* CALLOɃL[󂾂ꍇ͂֗OɃG[		*/
		/* Wv邽߂ɂ͓ĂȂ悤ɂȂĂD		*/
		/* CƂ̗͂ꂪȂ悤ɒӂKvłD		*/
		if (tnum_que_elem[msgid_no] < msgque_cnt[msgid_no]) {
			/* L[ւ̃bZ[Wi[ő吔ɐݒ */
			msgque_cnt[msgid_no] = tnum_que_elem[msgid_no] - ((UINT8) 1);
			ercd = E_COM_LIMIT;
			goto d_error_exit;
		}
		else {
			msgque_cnt[msgid_no]--;
		}
		/* notificationtOZbg */
	/*
	 *  class1 class3 notificationtOZbgD
	 *  ꂼʂ̃tOݒ\Ȃ̂ŁCꂼꃊZbgsD
	 */
		if (FP_NULL != resetflag1_rcv_que_norm[msgid_no]) {
			LEAVE_CRITICALSECTION();
			(*resetflag1_rcv_que_norm[msgid_no])();
			ENTER_CRITICALSECTION();
		}
		if (FP_NULL != resetflag3_rcv_que_norm[msgid_no]) {
			LEAVE_CRITICALSECTION();
			(*resetflag3_rcv_que_norm[msgid_no])();
			ENTER_CRITICALSECTION();
		}
	}
			/* API̎dl Extended̏ */
			/* [E_Ci~bNbZ[ŴƂ */
	else if ((MSG_RCV_ZERO == (msgid & MSG_RCV_MASK))||
			 (MSG_RCV_DYNA == (msgid & MSG_RCV_MASK))){
			ercd = E_COM_ID;	/* Extended */
			goto exit;
	}
	/* AL[bZ[ŴƂ */
	else {
		CHECK_MAX_RCV_NORM(msgid_no);
		/* bZ[Wi[ */
		(*copyfunc_rcv_unq_norm[msgid_no])(p_data, 
											(ApplicationDataRef)msgbuf_rcv_unq_norm[msgid_no]);
		/* notificationtOZbg */
		if (FP_NULL != resetflag1_rcv_unq_norm[msgid_no]) {
			LEAVE_CRITICALSECTION();
			(*resetflag1_rcv_unq_norm[msgid_no])();
			ENTER_CRITICALSECTION();
		}
		if (FP_NULL != resetflag3_rcv_unq_norm[msgid_no]) {
			LEAVE_CRITICALSECTION();
			(*resetflag3_rcv_unq_norm[msgid_no])();
			ENTER_CRITICALSECTION();
		}
	}


  exit:
	LEAVE_CRITICALSECTION();

	LOG_RECEIVEMESSAGE_LEAVE(ercd);
	return(ercd);

  error_exit:
	ENTER_CRITICALSECTION();
  d_error_exit:
	_com_errorhook_par1.m_msgid = msgid;
	_com_errorhook_par2.m_p_data = p_data;
	call_com_errorhook(ercd, COMServiceId_ReceiveMessage);
	goto exit;
}

/*--------------------------------------------------------------------
 * Tv      FMʏ(Œ蒷)bZ[WIuWFNgf[^o
 * @\      FM_Ci~bNbZ[WIuWFNgf[^擾C
 *           FŎw肳ꂽAvP[V̗̈Ɋi[D
 *           Ff[^͈Ŏw肳ꂽ|C^ŎQƂϐ֊i[D
 *           FNotification(Class1 Class3)Őݒ肳ꂽtONAD
 * (in)  F<Message>            ΏۂƂMbZ[WIuWFNgID
 *     (out) F<DataRef>            擾f[^̃AvP[Vi[ꏊ
 *           F<LengthRef>          擾f[^̃f[^̃AvP[V
 *           F                     i[ꏊiPʁFoCgiɂ茈߂jj
 * ߂l    F
 *   StandardFE_OK
 *   ExtendedFE_COM_ID             ID͈͊OCMCQUEUEDCŒ蒷CM[Q
 *           FEƎ
 *           FE_COM_SYS_INTERRUPT  ֎~ɃR[
 *           FE_COM_SYS_CALLEVEL   COMR[x̕s
 * l      FȂ
 *------------------------------------------------------------------*/
StatusType
ReceiveDynamicMessage(MessageIdentifier msgid, 
						ApplicationDataRef p_data, LengthRef p_len)
{
	StatusType	ercd = E_OK;
	UINT8		msgid_no = 0;
	UINT8		cnt = 0;

	LOG_RECEIVEDYNAMICMESSAGE_ENTER(msgid, p_data, p_len);

	CHECK_INTERRUPT();
	CHECK_COMCALLEVEL(COMCL_START);
	CHECK_RCV_DYNAMIC(msgid);

	ENTER_CRITICALSECTION();

	msgid_no = (UINT8)(msgid & MSG_ID_MASK);
	CHECK_MAX_RCV_DYNA(msgid_no);

	/* f[^Zbg */
		*p_len = *msglength_rcv_unq_dyna[msgid_no];


	for (cnt = 0; cnt < *p_len; cnt++) {
		/* PoCgRs[ */
		*((UINT8 *)p_data + cnt) 
				= *((UINT8 *)msgbuf_rcv_unq_dyna[msgid_no] + cnt);
	}

	/* notificationtOZbg */
	if (FP_NULL != resetflag1_rcv_unq_dyna[msgid_no]) {
		LEAVE_CRITICALSECTION();
		(*resetflag1_rcv_unq_dyna[msgid_no])();
		ENTER_CRITICALSECTION();
	}
	if (FP_NULL != resetflag3_rcv_unq_dyna[msgid_no]) {
		LEAVE_CRITICALSECTION();
		(*resetflag3_rcv_unq_dyna[msgid_no])();
		ENTER_CRITICALSECTION();
	}

  exit:
	/* NeBJZNV */
	LEAVE_CRITICALSECTION();

	LOG_RECEIVEDYNAMICMESSAGE_LEAVE(ercd);
	return(ercd);

  error_exit:
	/* G[̓NeBJZNVɂG[tbNCALL */
	ENTER_CRITICALSECTION();
  d_error_exit:
	_com_errorhook_par1.m_msgid = msgid;
	_com_errorhook_par2.m_p_data = p_data;
	_com_errorhook_par3.m_p_len = p_len;
	call_com_errorhook(ercd, COMServiceId_ReceiveDynamicMessage);
	goto exit;
}

