/*
 *  TOPPERS/OSEK COM
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK COM
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *	^C}@\
 */

#include	"osek_com.h"
#include	"com_interrupt.h"
#include	"com_timer.h"

#include	"com_hw_timer.h"


/*
 *  JEg\[XPɌ肵߁CSGo͔p~
 */
const UINT8 tnum_tick = TNUM_COM_COUNTER;
const TimerTickType tickinib_maxval[TNUM_COM_COUNTER] = {10000};
const TimerTickType tickinib_tickbase[TNUM_COM_COUNTER] = {1};
const TimerTickType tickinib_mincyc[TNUM_COM_COUNTER] = {1};

TimerType tickcb_timque[TNUM_COM_COUNTER] = { TIMID_NULL };
TimerTickType tickcb_curval[TNUM_COM_COUNTER] = { 0u };		/* TICKIĎݒlieBbNj */


/*
 *  X^eBbN֐̃vg^Cv錾
 */
Inline TimerTickType	add_tick_tim(TimerTickType timval, 
									TimerTickType incr, TimerTickType maxval);
static void	enqueue_timer(TimerType timid, TickCounterType tickid);
static void	dequeue_timer(TimerType timid, TickCounterType tickid);


/*--------------------------------------------------------------------
 * Tv      FeBbNl̉Z
 * @\      FeBbNlZD
 * (in)  F<timval>    eBbNl
 *           F<incr>      eBbNɉZl
 *           F<maxval>    eBbN̍ől
 *     (out) FȂ
 * ߂l    F<ticktim> Z̃eBbNl
 * l      Ftimval  incr ZeBbNlԂDZeBbNlC
 *           Fmaxval 𒴂ꍇɂ́C(maxval + 1) lԂD
 *-------------------------------------------------------------------*/
Inline TimerTickType
add_tick_tim(TimerTickType timval, TimerTickType incr, TimerTickType maxval)
{
	TimerTickType ticktim;
	/*
	 *  fȏ timval + incr <= maxval ł邪C̏
	 *  ł́Ctimval + incr  TimerTickType ŕ\͈͂𒴂ꍇ
	 *  łȂȂ邽߁C̏ƂĂD
	 */
	if (incr <= (maxval - timval)) {
		ticktim = timval + incr;
	}
	else {
		ticktim = (timval + incr) - (maxval + 1);
	}
	return(ticktim);
}

/*--------------------------------------------------------------------
 * Tv      F^C}L[ւ̑}
 * @\      F^C}L[֑}D
 * (in)  F<timid>     ^C}ID
 *           F<tickid>    JE^ID
 *     (out) FȂ
 * ߂l    FȂ 
 * l      Ftimid Ŏw肳^C}Ctickid Ŏw肳JE^̃^C}
 *           FL[ɑ}DݒlɈvĺC^C}L[̖ɑ}
 *           FD܂C^C}L[ɓ̃^C}ꍇɂ́C
 *           Fɑ}i擪łxȂƎvjD
 *-------------------------------------------------------------------*/
static void
enqueue_timer(TimerType timid, TickCounterType tickid)
{
	TimerTickType	timval, curval;
	TimerType	next, prev;

	timval = timcb_timval[timid];
	curval = tickcb_curval[tickid];

	/*
	 *  }ꏊ̃T[`
	 */
	next = tickcb_timque[tickid];
	prev = TIMID_NULL;
	if (curval < timval) {
		/*
		 *  timval  curval 傫DƁC
		 *  eBbN^C}̎weBbN܂ł̊ԂɁCJE
		 *  ^̃I[ot[iől𒴂āC0 ɖ߂邱Ɓj
		 *  NȂꍇD
		 */
			/* lΉ									*/
		while ((next != TIMID_NULL) && ((curval <= timcb_timval[next])
					&& (timcb_timval[next] <= timval))) {
			prev = next;
			next = timcb_next[prev];
		}
	}
	else {
		/*
		 *  ȊO̎DƁC݃eBbNA[
		 *  ̎weBbN܂ł̊ԂɁCJE^̃I[ot[
		 *  NꍇD
		 */
			/* lΉ									*/
		while ((next != TIMID_NULL) && ((curval <= timcb_timval[next])
					|| (timcb_timval[next] <= timval))) {
			prev = next;
			next = timcb_next[prev];
		}
	}

	/*
	 *  L[̂Ȃ
	 */
	timcb_next[timid] = next;
	timcb_prev[timid] = prev;
	if (prev != TIMID_NULL) {
		timcb_next[prev] = timid;
	}
	else {
		tickcb_timque[tickid] = timid;
	}
	if (next != TIMID_NULL) {
		timcb_prev[next] = timid;
	}
}


/*--------------------------------------------------------------------
 * Tv      F^C}L[̍폜
 * @\      F^C}L[폜D
 * (in)  F<timid>     ^C}ID
 *           F<tickid>    JE^ID
 *     (out) FȂ
 * ߂l    FȂ
 * l      Ftimid Ŏw肳^C}Ctickid Ŏw肳JE^̃A[
 *           FL[폜D
 *-------------------------------------------------------------------*/
static void
dequeue_timer(TimerType timid, TickCounterType tickid)
{
	TimerType	next, prev;

	next = timcb_next[timid];
	prev = timcb_prev[timid];
	if (prev != TIMID_NULL) {
		timcb_next[prev] = next;
	}
	else {
		tickcb_timque[tickid] = next;
	}
	if (next != TIMID_NULL) {
		timcb_prev[next] = prev;
	}
	timcb_next[timid] = timid;
}

/*--------------------------------------------------------------------
 * Tv      F^C}@\̏
 * @\      F^C}@\D
 * (in)  FȂ
 *     (out) FȂ
 * ߂l    FȂ
 * l      FȂ
 *-------------------------------------------------------------------*/
void
timer_initialize(void)
{
	TickCounterType	tickid;
	TimerType	timid;

	for (tickid = 0; tickid < tnum_tick; tickid++) {
		tickcb_curval[tickid] = 0u;
		tickcb_timque[tickid] = TIMID_NULL;
	}
	for(timid = 0; timid < tnum_timer; timid++) {
		timcb_next[timid] = timid;
		timcb_timval[timid] = 0u;
		timcb_cycle[timid] = 0u;
		timcb_cback[timid] = TIMFP_NULL;
	}
}

/*--------------------------------------------------------------------
 * Tv      F^C}̐ݒiΒlj
 * @\      F^C}ݒ肷D
 * (in)  F<timid>     ^C}ID
 *           F<first>     ݒl
 *           F<cycle>     ^C}̎
 *           F<param>     R[obN֐̈
 *     (out) FȂ
 * ߂l    FE_OK 
 *           FE_TIM_STATE 
 * l      FȂ
 *-------------------------------------------------------------------*/
StatusType
SetRelTimer(TimerType timid, TimerTickType first, 
							TimerTickType cycle, TIMFP func, UINT8 param)
{
	StatusType	ercd = E_OK;
	TickCounterType	tickid;
	TimerTickType	maxval;

	tickid = timinib_tickid[timid];
	maxval = tickinib_maxval[tickid];
	if (timcb_next[timid] != timid) {
		ercd = E_TIM_STATE;	/* ^C}gp */
		goto error_exit;
	}
	timcb_timval[timid] = add_tick_tim(tickcb_curval[tickid], first, maxval);
	timcb_cycle[timid] = cycle;
	enqueue_timer(timid, tickid);
	timcb_cback[timid] = func;					/* ^CAbv̏o^ */
	timcb_param[timid] = param;
  exit:
	return(ercd);

  error_exit:
	goto exit;
}

/*--------------------------------------------------------------------
 * Tv      F^C}̃LZ
 * @\      F^C}LZD
 * (in)  F<timid>     ^C}ID
 *     (out) FȂ
 * ߂l    FE_OK
 *           FE_TIM_NOFUNC
 * l      FȂ
 *-------------------------------------------------------------------*/
StatusType
CancelTimer(TimerType timid)
{
	StatusType	ercd = E_OK;

	if (timcb_next[timid] == timid) {
		ercd = E_TIM_NOFUNC;
		goto error_exit;
	}
	dequeue_timer(timid, timinib_tickid[timid]);

	/*
	 *  ^C}R[obN̒C^C} SetRelTimer
	 *  SetAbsTimer  CancelTimer 󋵁iOSEKdlł͋
	 *  ĂȂCTOPPERS_OSEKJ[lł͋ĂjŁC
	 *  ^C}^C}L[ɍđ}̂h߂ɁC
	 *  timcb_cycle[timid]  0 ɂĂD
	 */
	timcb_cycle[timid] = 0u;
	timcb_cback[timid] = TIMFP_NULL;
  exit:
	return(ercd);

  error_exit:
	goto exit;
}

/*--------------------------------------------------------------------
 * Tv      FJE^i߂
 * @\      FJE^i߂D
 * (in)  F<tickid> JE^ID
 *     (out) FȂ
 * ߂l    FE_OK
 * l      FȂ
 *-------------------------------------------------------------------*/
StatusType
SignalTimeTick(TickCounterType tickid)
{
	StatusType	ercd = E_OK;
	TimerTickType	newval;
	TimerType	timid, next;

	ENTER_CRITICALSECTION();

	/*
	 *  XṼJE^l߂
	 */
	newval = add_tick_tim(tickcb_curval[tickid], 1, tickinib_maxval[tickid]);

	/*
	 *  JE^̌ݒl̍XV
	 */
	tickcb_curval[tickid] = newval;

	/*
	 *  ^C} expire 
	 */
	while (((timid = tickcb_timque[tickid]) != TIMID_NULL)
				&& (timcb_timval[timid] == newval)) {
		/*
		 *  ^C}L[̐擪̃^C}CL[OD
		 */
		next = timcb_next[timid];
		tickcb_timque[tickid] = next;
		if (next != TIMID_NULL) {
			timcb_prev[next] = TIMID_NULL;
		}
		timcb_next[timid] = timid;

		/*
		 *  ^C}R[obŇĂяo
		 */
		if( TIMFP_NULL != timcb_cback[timid] ) {
			LEAVE_CRITICALSECTION();
			(*timcb_cback[timid])(timcb_param[timid]);
			ENTER_CRITICALSECTION();
		}

		/*
		 *  ^C}L[ւ̍đ}i^C}̏ꍇj
		 *
		 *  ^C}R[obN̒Ŏ^C} SetRelTimer/
		 *  SetAbsTimer 󋵁iOSEKdlł͋ĂȂC
		 *  TOPPERS/OSEKJ[lł͋ĂjŁC^C}L[
		 *  ւ̍đ}h߂ɁCtimcb_next[timid] == timid
		 *  ̏ꍇ̂ݍđ}D
		 */
		if ((timcb_next[timid] == timid)
					&& (timcb_cycle[timid] > 0u)) {
			timcb_timval[timid] = add_tick_tim(timcb_timval[timid], 
				timcb_cycle[timid], tickinib_maxval[tickid]);
			enqueue_timer(timid, tickid);
		}
	}
  exit:
	LEAVE_CRITICALSECTION();
	return(ercd);
}

/*--------------------------------------------------------------------
 * Tv      F^C}i
 * @\      F^C}iD
 * (in)  FȂ
 *     (out) FȂ
 * ߂l    FȂ
 * l      FȂ
 *-------------------------------------------------------------------*/
void com_init_timer(void)
{
	/* ^C}i */
	hw_com_timer_initialize();
	timer_initialize();
}

/*--------------------------------------------------------------------
 * Tv      F^C}iI
 * @\      F^C}iID
 * (in)  FȂ
 *     (out) FȂ
 * ߂l    FȂ
 * l      FȂ
 *-------------------------------------------------------------------*/
void com_term_timer(void)
{
	/* ^C}iI */
	hw_com_timer_terminate();
}

