/*
 *  TOPPERS/OSEK COM
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK COM
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *	bZ[WM
 */
#include	"osek_com.h"
#include	"com_check.h"
#include	"com_interrupt.h"

/*
 *  Callout[`f[^ANZX邽߂̃|C^
 */
void * _callout_snddata_addr;

/*--------------------------------------------------------------------
 * Tv      FMʏ(Œ蒷)bZ[W̑M
 * @\      FMʏ(Œ蒷)bZ[W𑗐MD
 *           FNotification(Class2 Class4)Őݒ肳ꂽtONAD
 *           FgKƃyfBO
 * (in)  F<Message> ΏۂƂ鑗MbZ[WIuWFNgID
 *           F<DataRef> MAvP[VbZ[Wf[^̊i[ꏊ
 *     (out) FȂ
 * ߂l    F
 *   StandardFE_OK
 *   ExtendedFE_COM_ID            ID͈͊OCMC_Ci~bNC[Q
 *           FEƎ
 *           FE_COM_SYS_INTERRUPT ֎~ɃR[
 *           FE_COM_SYS_CALLEVEL  COMR[x̕s
 *           FE_COM_SYS_ERR       ̑G[
 *           FEG[R[h
 *           F<SetSndExTrigNorm><SetSndExPendNorm>
 *           FE_IL_FILTERED       tB^ɂďO
 *           FE_IL_CALLOUTFALSE   R[AEg̖߂肪s
 *           F<RequestTransmission>
 *           FE_IPDU_NOREQUEST    ĩR[hԂĂ鎖͖j
 *           FE_IPDU_SENDING      MC
 *           FE_IL_CALLOUTFALSE   R[AEg̖߂肪s
 *           F<SendUL>̖߂l
 *           F<SetRelTimer>̖߂l
 * l      FȂ
 *------------------------------------------------------------------*/
StatusType
SendMessage(MessageIdentifier msgid, ApplicationDataRef p_data)
{
	MessageIdentifier	recvid = MSG_NULL;	/* ʐM̎MbZ[WID */
	UINT8		msgid_no = 0;	/* msgid瑮ƂCAԕ̂ */
	UINT8		recv_cnt = 0;
	IPDUType	ipduid = IPDU_NULL;

	StatusType	ercd = E_OK;

	LOG_SENDMESSAGE_ENTER(msgid, p_data);

	/*
	 *  OS̏ԂKvD
	 *  {݋֎~APICALLĂ͂Ȃ
	 *  ɗ͏ɂ邽ߊ荞ݏԂ̃`FbNsD
     */
	/* ݋֎~ԂŌĂ΂ꂽ`FbND */
	CHECK_INTERRUPT();

	CHECK_COMCALLEVEL(COMCL_START);
	/* SendMessageėǂ`FbND */
	CHECK_SENDMSG(msgid);

	ENTER_CRITICALSECTION();

	/* Aԕ̂ݎo */
	msgid_no = (UINT8)(msgid & MSG_ID_MASK);

	/*----------------------------------------------------------
	 *	O-gK
	 *---------------------------------------------------------*/
	if ((MSG_SND_NORM | MSG_SND_EXT) == (msgid & MSG_SND_MASK)) {

		CHECK_MAX_SND_TRIG_NORM(msgid_no);
		/* IPDUf[^Zbg܂ł̈Ȁ */
		ercd = SetSndExTrigNorm( msgid, p_data, &ipduid);

		if (E_OK == ercd) {
			/*  */
		}
		else if (E_IL_CALLOUTFALSE == ercd) {
			/* R[AEgɂăJbg */
			LOG_SENDMESSAGE_CALLOUTFALSE(msgid);
			goto exit;
		}
		else if (E_IL_FILTERED == ercd) {
			/* tB^ɂăJbg */
			LOG_SENDMESSAGE_FILTERED(msgid);
			goto exit;
		}
		else {
			/* ̑G[ */
			LOG_SENDMESSAGE_ERROR(msgid, ercd);
			ercd = E_COM_SYS_ERR;
			goto d_error_exit;
		}

		/* IPDUM[hmF */
		if (COM_IPDU_PERIODIC != transmode_snd_ipdu[ipduid]) {

			/* MvtO𗧂ĂāCMv֐ďo */
			flg_snd_ipdu[ipduid] |= IPDU_SEND_REQUEST;
			ercd = RequestTransmission(ipduid);

			if (E_OK == ercd) {
				/*  */
			}
			else if (E_IPDU_SENDING == ercd) {
				/* M  MɍđM */
				ercd = E_OK;
				goto exit;
			}
			else {
				LOG_SENDMESSAGE_ERROR(ercd, msgid);
				ercd = E_COM_SYS_ERR;
				goto d_error_exit;
			}
		}
	}
	/*----------------------------------------------------------
	 *	O-yfBO
	 *---------------------------------------------------------*/
	else if ((MSG_SND_NORM | MSG_SND_EXT | MSG_SND_PEND) 
											== (msgid & MSG_SND_MASK)) {

		CHECK_MAX_SND_PEND_NORM(msgid_no);
		/* IPDUf[^Zbg܂ł̈Ȁ */
		ercd = SetSndExPendNorm( msgid, p_data);

		if (E_OK == ercd) {
			/*  */
		}
		else if (E_IL_CALLOUTFALSE == ercd) {
			/* R[AEgɂăJbg */
			LOG_SENDMESSAGE_CALLOUTFALSE(msgid);
			goto exit;
		}
		else if (E_IL_FILTERED == ercd) {
			/* tB^ɂăJbg */
			LOG_SENDMESSAGE_FILTERED(msgid);
			goto exit;
		}
		else {
			/* ̑G[ */
			LOG_SENDMESSAGE_ERROR(ercd, msgid);
			ercd = E_COM_SYS_ERR;
			goto d_error_exit;
		}
	}
	/*----------------------------------------------------------
	 *	
	 *---------------------------------------------------------*/
	/* M--ʏ탁bZ[W */
	else if (MSG_SND_NORM ==  (msgid & MSG_SND_MASK)) {

		CHECK_MAX_SND_NORM(msgid_no);
		/* MŏIʒu܂ŎMbZ[WID擾 */
		for (recv_cnt =0; 
				MSG_NULL != (recvid 
							= ((sndlist_snd_in_norm[msgid_no])[recv_cnt]));
				 												recv_cnt++) {
			LEAVE_CRITICALSECTION();

			/* MbZ[WփZbg */
			ercd = SetRcvMsg(recvid, p_data);
			
			ENTER_CRITICALSECTION();

			if (E_OK == ercd) {
				/*  */
			}
			else if (E_IL_FILTERED == ercd) {
				LOG_SENDMESSAGE_FILTERED(recvid);
				ercd = E_OK;
			}
			else {
				/* G[ */
				LOG_SENDMESSAGE_ERROR(ercd, recvid);
				ercd = E_COM_SYS_ERR;
				goto d_error_exit;
			}
		}
	}
	/* ȃbZ[WID */
	else{
		ercd = E_COM_ID;
		goto d_error_exit;
	}

  exit:
	LEAVE_CRITICALSECTION();

	LOG_SENDMESSAGE_LEAVE(ercd);
	return(ercd);

  error_exit:
	/* G[̓NeBJZNV擾G[tbNCALL */
	ENTER_CRITICALSECTION();
  d_error_exit:
	_com_errorhook_par1.m_msgid = msgid;
	_com_errorhook_par2.m_p_data = p_data;
	call_com_errorhook(ercd, COMServiceId_SendMessage);
	goto exit;
}

/*--------------------------------------------------------------------
 * Tv      FO-gK-ʏ탁bZ[WIPDU֊i[
 * @\      FO-gK-ʏ탁bZ[WIPDU֊i[D
 * (in)  F<msgid>     ΏۂƂ鑗MbZ[WIuWFNgID
 *           F<p_data>    IPDU֊i[f[^ւ̃|C^
 *     (out) F<p_ipduid>  ΏIPDUID(msgid犄o)ւ̃|C^
 * ߂l    FE_OK
 *           FE_IL_FILTERED       tB^ɂďO
 *           FE_IL_CALLOUTFALSE   R[AEg̖߂肪s
 *           FĂяo֐
 *           FEtB^֐  E_OK or E_IL_FILTERED
 *           FER[AEg  COM_TRUE or COM_FALSEiE_IL_CALLOUTFALSE)
 *           FEoCgI[_[ϊ  G[R[h󂯌p  E_OK ̂
 *           FEIPDUփf[^Zbg  G[R[h󂯌p  E_OK ̂
 * l      F݋֎~ԂŌĂяo邱ƁD
 *           FoCgI[_[ϊCIPDUi[֐msgidKvȂ̂ŁCmsgiď`ł炤D
 *           FIPDUIDʂŎgp̂ŃZbgD
 *           F֐̂߁CO}NŃG[eo͂̂ł͂ȂC
 *           F{IɏʑwփG[R[hԂCʑwɈ䂾˂D
 *-------------------------------------------------------------------*/
StatusType
SetSndExTrigNorm (MessageIdentifier msgid, 
					ApplicationDataRef p_data, IPDUType *p_ipduid)
{
	StatusType			ercd = E_OK;
	CalloutReturnType	cocd = COM_TRUE;
	UINT8				msgid_no = 0;

	msgid_no = (UINT8)(msgid & MSG_ID_MASK);

	/* f[^̃Rs[ */
	(*copyfunc_snd_ex_trig_norm[msgid_no] )( msgbuf_snd_tmp, p_data );

	/* tB^֐L */
	if( FILTFP_NULL != filter_snd_ex_trig_norm[msgid_no] ){
		/* tB^֐R[ */
		ercd = (*filter_snd_ex_trig_norm[msgid_no])(msgbuf_snd_tmp);
		if (E_OK != ercd) {
			goto exit;
		}
	}
	/* cpu_order bZ[W R[AEgs */
	if( CALLOUTFP_NULL != callout_cpuorder_snd_ex_trig_norm[msgid_no] ){
		_callout_snddata_addr = msgbuf_snd_tmp;	/* bZ[Wւ̃|C^ێ */
		cocd = (*callout_cpuorder_snd_ex_trig_norm[msgid_no])();
		if (COM_FALSE == cocd) {
			ercd = E_IL_CALLOUTFALSE;
			goto exit;
		}	
	}
	
	/* oCgI[_[ϊ */
	/* 1oCgPʂŃbZ[Wobt@Cs߁C       */
	/*  bZ[Wobt@(UINT8*)^̃|C^ƂĈɓnD */
	ercd = convert_byteorder( msgid, (UINT8*)msgbuf_snd_tmp, 
									(UINT8*)msgbuf_snd_after_swapbytes);
	if (E_OK != ercd) {
		goto error_exit;
	}

	/* network_order bZ[W R[AEgs */
	if( CALLOUTFP_NULL != callout_netorder_snd_ex_trig_norm[msgid_no] ){
		_callout_snddata_addr = msgbuf_snd_after_swapbytes;
		cocd = (*callout_netorder_snd_ex_trig_norm[msgid_no])();
		if (COM_FALSE == cocd) {
			ercd = E_IL_CALLOUTFALSE;
			goto exit;
		}	
	}

	*p_ipduid = ipduid_snd_ex_trig_norm[msgid_no];
	/* IPDUփf[^Zbg */
	/* 1oCgPʂŃbZ[Wobt@Cs߁C       */
	/*  bZ[Wobt@(UINT8*)^̃|C^ƂĈɓnD */
	ercd = update_Ipdu( msgid, (UINT8*)msgbuf_snd_after_swapbytes, 
												msgbuf_snd_ipdu[*p_ipduid]);
	if (E_OK != ercd) {
		goto error_exit;
	}
	
  exit:
	return(ercd);

  error_exit:
	goto exit;
}

/*--------------------------------------------------------------------
 * Tv      FO-yfBO-ʏ탁bZ[WIPDU֊i[
 * @\      FO-yfBO-ʏ탁bZ[WIPDU֊i[D
 * (in)  F<msgid>   ΏۂƂ鑗MbZ[WIuWFNgID
 *           F<p_data>  IPDU֊i[f[^ւ̃|C^
 *     (out) FȂ
 * ߂l    FE_OK
 *           FE_IL_FILTERED       tB^ɂďO
 *           FE_IL_CALLOUTFALSE   R[AEg̖߂肪s
 *           FĂяo֐
 *           FEtB^֐  E_OK or E_IL_FILTERED
 *           FER[AEg  COM_TRUE or COM_FALSEiE_IL_CALLOUTFALSE)
 *           FEoCgI[_[ϊ  G[R[h󂯌p  E_OK ̂
 *           FEIPDUփf[^Zbg  G[R[h󂯌p  E_OK ̂
 * l      F݋֎~ԂŌĂяo邱ƁD
 *           FoCgI[_[ϊCIPDUi[֐msgidKvȂ̂ŁCmsgiď`ł炤D
 *           F֐̂߁CO}NŃG[eo͂̂ł͂ȂC
 *           F{IɏʑwփG[R[hԂCʑwɈ䂾˂D
 *-------------------------------------------------------------------*/
StatusType
SetSndExPendNorm (MessageIdentifier msgid, ApplicationDataRef p_data)
{
	StatusType			ercd = E_OK;
	CalloutReturnType	cocd = COM_TRUE;
	IPDUType			ipduid = IPDU_NULL;
	UINT8				msgid_no = 0;

	msgid_no = (UINT8)(msgid & MSG_ID_MASK);

	/* f[^̃Rs[ */
	(*copyfunc_snd_ex_pend_norm[msgid_no])(msgbuf_snd_tmp, p_data);

	/* tB^֐L */
	if( FILTFP_NULL != filter_snd_ex_pend_norm[msgid_no] ){
		ercd = (*filter_snd_ex_pend_norm[msgid_no])(msgbuf_snd_tmp);
		if (E_OK != ercd) {
			goto exit;
		}
	}
	/* cpu_order bZ[W R[AEgs */
	if( CALLOUTFP_NULL != callout_cpuorder_snd_ex_pend_norm[msgid_no] ){
		_callout_snddata_addr = msgbuf_snd_tmp;
		cocd = (*callout_cpuorder_snd_ex_pend_norm[msgid_no])();
		if (COM_FALSE == cocd) {
			ercd = E_IL_CALLOUTFALSE;
			goto exit;
		}	
	}
	/* oCgI[_[ϊ */
	/* 1oCgPʂŃbZ[Wobt@Cs߁C       */
	/*  bZ[Wobt@(UINT8*)^̃|C^ƂĈɓnD */
	ercd = convert_byteorder( msgid, (UINT8*)msgbuf_snd_tmp, 
									(UINT8*)msgbuf_snd_after_swapbytes);
	if (E_OK != ercd) {
		goto error_exit;
	}

	/* network_order bZ[W R[AEgs */
	if( CALLOUTFP_NULL != callout_netorder_snd_ex_pend_norm[msgid_no] ){
		_callout_snddata_addr = msgbuf_snd_after_swapbytes;
		cocd = (*callout_netorder_snd_ex_pend_norm[msgid_no])();
		if (COM_FALSE == cocd) {
			ercd = E_IL_CALLOUTFALSE;
			goto exit;
		}	
	}

	/* IPDUɃf[^i[ */
	ipduid = ipduid_snd_ex_pend_norm[msgid_no];
	/* 1oCgPʂŃbZ[Wobt@Cs߁C       */
	/*  bZ[Wobt@(UINT8*)^̃|C^ƂĈɓnD */
	ercd = update_Ipdu( msgid, (UINT8*)msgbuf_snd_after_swapbytes, 
										msgbuf_snd_ipdu[ipduid]);
	if (E_OK != ercd) {
		goto error_exit;
	}

  exit:
	return(ercd);

  error_exit:
	goto exit;
}

/*--------------------------------------------------------------------
 * Tv      FM_Ci~bNbZ[W̑M
 * @\      FM_Ci~bNbZ[W𑗐MD
 *           FNotification(Class2 Class4)Őݒ肳ꂽtONA
 *           FgKƃyfBO
 * (in)  F<DataRef>  MAvP[VbZ[Wf[^̎Q
 *           F<LengthRef> M_Ci~bNbZ[W
 *           F           TCYĂϐւ̃|C^
 *           F<Message>  ΏۂƂ鑗M_Ci~bNbZ[WID
 *     (out) FȂ
 * ߂l    F
 *   StandardFE_OK
 *   ExtendedFE_COM_ID     <Message>͈͊OCMC_Ci~bNC[Q
 *           FE_COM_LENGTH <LengthRef>f[^0ő咷͈̔͊O
 *           FEƎ
 *           FE_COM_SYS_INTERRUPT  ֎~ɃR[
 *           FE_COM_SYS_CALLEVEL   COMR[x̕s
 *           FE_COM_SYS_ERR        ̑G[
 *           FEG[R[h
 *           F<SetSndExTrigDyna>  <SetSndExPendDyna>
 *           FE_IL_CALLOUTFALSE
 *           F<RequestTransmission>
 *           FE_IPDU_NOREQUEST    ĩR[hԂĂ鎖͖j
 *           FE_IPDU_SENDING      MC
 *           FE_IL_CALLOUTFALSE   
 *           F<SendUL>̖߂l
 *           F<SetRelTimer>̖߂l
 * l      FȂ
 *------------------------------------------------------------------*/
StatusType
SendDynamicMessage(MessageIdentifier msgid, 
							ApplicationDataRef p_data, LengthRef p_len)
{
	StatusType			ercd = E_OK;
	IPDUType			ipduid = IPDU_NULL;
	UINT8				msgid_no = 0;

	msgid_no = (UINT8)(msgid & MSG_ID_MASK);

	CHECK_SND_DYNA(msgid_no);
	LOG_SENDDYNAMICMESSAGE_ENTER(msgid, p_data, p_len);
	CHECK_INTERRUPT();
	CHECK_COMCALLEVEL(COMCL_START);
	CHECK_SND_DYNAMIC(msgid);
	CHECK_SND_LENGTH(msgid, p_len);

	ENTER_CRITICALSECTION();

	/* gK */
	if ((MSG_SND_DYNA | MSG_SND_EXT) == (msgid & MSG_SND_MASK)) {

		CHECK_MAX_SND_TRIG_DYNA(msgid_no);
		/* IPDUփf[^Zbg̈Ȁ */
		ercd = SetSndExTrigDyna (msgid, p_data, p_len, &ipduid);

		if (E_OK == ercd) {
			/*  */
		}
		else if (E_IL_CALLOUTFALSE == ercd) {
			LOG_SENDDYNAMICMESSAGE_CALLOUTFALSE(msgid);
			ercd = E_OK;
			goto exit;
		}
		else {
			LOG_SENDDYNAMICMESSAGE_ERROR(ercd, msgid);
			ercd = E_COM_SYS_ERR;
			goto d_error_exit;
		}

		/* IPDUM[h */
		if (COM_IPDU_PERIODIC != transmode_snd_ipdu[ipduid]) {
			/* MvtO𗧂ĂāCMv֐Ăяo */
			flg_snd_ipdu[ipduid] |= IPDU_SEND_REQUEST;
			ercd = RequestTransmission(ipduid);

			if (E_OK == ercd) {
				/*  */
			}
			else if (E_IPDU_SENDING == ercd) {
				/* M MɍđM */
				ercd = E_OK;
				goto exit;
			}
			else {
				LOG_SENDDYNAMICMESSAGE_ERROR(ercd, msgid);
				ercd = E_COM_SYS_ERR;
				goto d_error_exit;
			}
		}
	}
	/* yfBO */
	else {
		CHECK_MAX_SND_PEND_DYNA(msgid_no);
		/* IPDUփf[^Zbg̈Ȁ */
		ercd = SetSndExPendDyna (msgid, p_data, p_len);

		if (E_OK == ercd) {
			/*  */
		}
		else if (E_IL_CALLOUTFALSE == ercd) {
			LOG_SENDDYNAMICMESSAGE_CALLOUTFALSE(msgid);
			ercd = E_OK;
			goto exit;
		}
		else {
			LOG_SENDDYNAMICMESSAGE_ERROR(ercd, msgid);
			ercd = E_COM_SYS_ERR;
			goto d_error_exit;
		}
	}

  exit:
	LEAVE_CRITICALSECTION();

	LOG_SENDDYNAMICMESSAGE_LEAVE(ercd);
	return(ercd);

  error_exit:
	/* G[̓NeBJZNV擾G[tbNCALL */
	ENTER_CRITICALSECTION();
  d_error_exit:
	_com_errorhook_par1.m_msgid = msgid;
	_com_errorhook_par2.m_p_data = p_data;
	_com_errorhook_par3.m_p_len = p_len;
	call_com_errorhook(ercd, COMServiceId_SendDynamicMessage);
	goto exit;
}

/*--------------------------------------------------------------------
 * Tv      FO-gK-_Ci~bNbZ[WIPDU֊i[
 * @\      FO-gK-_Ci~bNbZ[WIPDU֊i[D
 * (in)  F<msgid>     ΏۂƂ鑗MbZ[WIuWFNgID
 *           F<p_data>    IPDU֊i[f[^ւ̃|C^
 *           F<p_len>     IPDU֊i[f[^̃f[^ւ̃|C^
 *     (out) F<p_ipduid>  ΏIPDUID(msgid犄o)ւ̃|C^
 * ߂l    FE_OK
 *           FE_IL_CALLOUTFALSE   R[AEg̖߂肪s
 *           FĂяo֐
 *           FER[AEg  COM_TRUE or COM_FALSEiE_IL_CALLOUTFALSE)
 *           FEIPDUփf[^Zbg  G[R[h󂯌p  E_OK ̂
 * l      F݋֎~ԂŌĂяo邱ƁD
 *           FIPDUi[֐msgidKvȂ̂ŁCmsgiď`ł炤D
 *           F֐̂߁CO}NŃG[eo͂̂ł͂ȂC
 *           F{IɏʑwփG[R[hԂCʑwɈ䂾˂D
 *-------------------------------------------------------------------*/
StatusType
SetSndExTrigDyna(MessageIdentifier msgid, 
					ApplicationDataRef p_data, LengthRef p_len, IPDUType *p_ipduid)
{
	StatusType			ercd = E_OK;
	CalloutReturnType	cocd = COM_FALSE;
	UINT8				msgid_no = 0;
	UINT8				cnt = 0;

	msgid_no = (UINT8)(msgid & MSG_ID_MASK);

	/* PoCgRs[ */
	for (cnt = 0; cnt < *p_len; cnt++) {
		/* PoCgRs[邽߁C(UINT8*)^ɃLXg */
		*((UINT8 *)msgbuf_snd_tmp + cnt) = *((UINT8 *)p_data + cnt);
	}

	/* cpu_order bZ[W R[AEgs */
	if( CALLOUTFP_NULL != callout_cpuorder_snd_ex_trig_dyna[msgid_no] ){
		/* [U`֐R[ */
		_callout_snddata_addr = msgbuf_snd_tmp;
		cocd = (*callout_cpuorder_snd_ex_trig_dyna[msgid_no])();
		if (COM_FALSE == cocd) {
			ercd = E_IL_CALLOUTFALSE;
			goto exit;
		}	
	}

	/* network_order bZ[W R[AEgs */
	if( CALLOUTFP_NULL != callout_netorder_snd_ex_trig_dyna[msgid_no] ){
		_callout_snddata_addr = msgbuf_snd_tmp;
		cocd = (*callout_netorder_snd_ex_trig_dyna[msgid_no])();
		if (COM_FALSE == cocd) {
			ercd = E_IL_CALLOUTFALSE;
			goto exit;
		}	
	}

	*p_ipduid = ipduid_snd_ex_trig_dyna[msgid_no];
	/* IPDUփf[^i[ */
	/* 1oCgPʂŃbZ[Wobt@Cs߁C       */
	/*  bZ[Wobt@(UINT8*)^̃|C^ƂĈɓnD */
	ercd = update_Ipdu_Dyna( msgid, (UINT8*)msgbuf_snd_tmp, 
										msgbuf_snd_ipdu[*p_ipduid], p_len);
	if (E_OK != ercd) {
		goto error_exit;
	}
	ipdu_snd_dlc[*p_ipduid] = ((UINT8)(bytesize_snd_ipdu[*p_ipduid] - 
								msgsize_snd_ex_trig_dyna[msgid_no]) + (UINT8)(*p_len));

  exit:
	return(ercd);

  error_exit:
	goto exit;
}

/*--------------------------------------------------------------------
 * Tv      FO-yfBO-_Ci~bNbZ[WIPDU֊i[
 * @\      FO-yfBO-_Ci~bNbZ[WIPDU֊i[D
 * (in)  F<msgid>   ΏۂƂ鑗MbZ[WIuWFNgID
 *           F<p_data>  IPDU֊i[f[^ւ̃|C^
 *           F<p_len>   IPDU֊i[f[^̃f[^ւ̃|C^
 *     (out) FȂ
 * ߂l    FE_OK
 *           FE_IL_CALLOUTFALSE   R[AEg̖߂肪s
 *           FĂяo֐
 *           FER[AEg  COM_TRUE or COM_FALSEiE_IL_CALLOUTFALSE)
 *           FEIPDUփf[^Zbg  G[R[h󂯌p  E_OK ̂
 * l      F݋֎~ԂŌĂяo邱ƁD
 *           FIPDUi[֐msgidKvȂ̂ŁCmsgiď`ł炤D
 *           F֐̂߁CO}NŃG[eo͂̂ł͂ȂC
 *           F{IɏʑwփG[R[hԂCʑwɈ䂾˂D
 *-------------------------------------------------------------------*/
StatusType
SetSndExPendDyna(MessageIdentifier msgid, 
					ApplicationDataRef p_data, LengthRef p_len)
{
	StatusType			ercd = E_OK;
	CalloutReturnType	cocd = COM_FALSE;
	UINT8				msgid_no = 0;
	UINT8				cnt = 0;
	IPDUType			ipduid = 0;

	msgid_no = (UINT8)(msgid & MSG_ID_MASK);

	/* PoCgRs[ */
	for (cnt = 0; cnt < *p_len; cnt++) {
		/* PoCgRs[邽߁C(UINT8*)^ɃLXg */
		*((UINT8 *)msgbuf_snd_tmp + cnt) = *((UINT8 *)p_data + cnt);
	}

	/* cpu_order bZ[W R[AEgs */
	if( CALLOUTFP_NULL != callout_cpuorder_snd_ex_pend_dyna[msgid_no] ){
		_callout_snddata_addr = msgbuf_snd_tmp;
		cocd = (*callout_cpuorder_snd_ex_pend_dyna[msgid_no])();
		if (COM_FALSE == cocd) {
			ercd = E_IL_CALLOUTFALSE;
			goto exit;
		}	
	}

	/* network_order bZ[W R[AEgs */
	if( CALLOUTFP_NULL != callout_netorder_snd_ex_pend_dyna[msgid_no] ){
		_callout_snddata_addr = msgbuf_snd_tmp;
		cocd = (*callout_netorder_snd_ex_pend_dyna[msgid_no])();
		if (COM_FALSE == cocd) {
			ercd = E_IL_CALLOUTFALSE;
			goto exit;
		}	
	}

	ipduid = ipduid_snd_ex_pend_dyna[msgid_no];
	/* IPDUփf[^i[ */
	/* 1oCgPʂŃbZ[Wobt@Cs߁C       */
	/*  bZ[Wobt@(UINT8*)^̃|C^ƂĈɓnD */
	ercd = update_Ipdu_Dyna( msgid, (UINT8*)msgbuf_snd_tmp, 
										msgbuf_snd_ipdu[ipduid], p_len);
	if (E_OK != ercd) {
		goto error_exit;
	}
	ipdu_snd_dlc[ipduid] = ((UINT8)(bytesize_snd_ipdu[ipduid] - 
							msgsize_snd_ex_pend_dyna[msgid_no]) + (UINT8)(*p_len));

  exit:
	return(ercd);

  error_exit:
	goto exit;
}

/*--------------------------------------------------------------------
 * Tv      FM[bZ[W̑M
 * @\      FM[OXbZ[W𑗐MD
 *           FNotification(Class2 Class4)Őݒ肳ꂽtONAD
 *           FgKƃyfBO
 * (in)  F<Message>  ΏۂƂ鑗M[bZ[WID
 *    (out)  FȂ
 * ߂l    F
 *   StandardFE_OK
 *   ExtendedFE_COM_ID            ID͈͊OCM[OXbZ[WȊOQ
 *           FEƎ
 *           FE_COM_SYS_INTERRUPT ֎~ɃR[
 *           FE_COM_SYS_CALLEVEL  COMR[x̕s
 *           FE_COM_SYS_ERR       ̑G[
 *           FEG[R[h
 *           F<RequestTransmission>
 *           FE_IPDU_NOREQUEST    ĩR[hԂĂ鎖͖j
 *           FE_IPDU_SENDING      MC
 *           FE_IL_CALLOUTFALSE   R[AEg̖߂肪s
 *           F<SendUL>̖߂l
 *           F<SetRelTimer>̖߂l
 * l      FȂ
 *------------------------------------------------------------------*/
StatusType
SendZeroMessage(MessageIdentifier msgid)
{
	MessageIdentifier	recvid = MSG_NULL;	/* ʐM̎MbZ[WID */
	StatusType			ercd = E_OK;
	CalloutReturnType	cocd = COM_TRUE;
	UINT8				msgid_no = 0;
	UINT8				recv_cnt = 0;
	IPDUType			ipduid = IPDU_NULL;

	LOG_SENDZEROMESSAGE_ENTER(msgid);
	CHECK_INTERRUPT();
	CHECK_COMCALLEVEL(COMCL_START);
	CHECK_SND_ZERO(msgid);

	/* ݋֎~͈ӖH */
	ENTER_CRITICALSECTION();

	/*----------------------------------------------------------
	 *	O-gK
	 *---------------------------------------------------------*/
	if((MSG_SND_ZERO|MSG_SND_EXT)==(msgid & MSG_SND_MASK)) {

		msgid_no = (UINT8)(msgid & MSG_ID_MASK);
		CHECK_MAX_SND_TRIG_ZERO(msgid_no);
		_callout_snddata_addr = NULL;	/* bZ[Wւ̃|C^NULL */

		if( CALLOUTFP_NULL != callout_cpuorder_snd_ex_trig_zero[msgid_no] ){
			/* [U`֐R[ */
			cocd = (*callout_cpuorder_snd_ex_trig_zero[msgid_no])();
			if (COM_FALSE == cocd) {
				/* R[AEgsʁCCOM_FALSEȂ珈I */
				LOG_SENDZEROMESSAGE_CALLOUTFALSE(msgid);
				ercd = E_OK;
				goto exit;
			}	
		}

		/* network_order bZ[W R[AEgs */
		if( CALLOUTFP_NULL != callout_netorder_snd_ex_trig_zero[msgid_no] ){
			/* [U`֐R[ */
			cocd = (*callout_netorder_snd_ex_trig_zero[msgid_no])();
			if (COM_FALSE == cocd) {
				LOG_SENDZEROMESSAGE_CALLOUTFALSE(msgid);
				ercd = E_OK;
				goto exit;
			}	
		}

		ipduid = ipduid_snd_ex_trig_zero[msgid_no];

		/* IPDUM[h */
		if( COM_IPDU_PERIODIC != transmode_snd_ipdu[ipduid]) {
			/* MvtO𗧂ĂāCMv֐Ăяo */
			flg_snd_ipdu[ipduid] |= IPDU_SEND_REQUEST;

			ercd = RequestTransmission(ipduid);

			if (E_OK == ercd) {
				/*  */
			}
			else if (E_IPDU_SENDING == ercd) {
				/* M  MɍđM */
				ercd = E_OK;
				goto exit;
			}
			else {
				LOG_SENDZEROMESSAGE_ERROR(ercd, msgid);
				ercd = E_COM_SYS_ERR;
				goto d_error_exit;
			}
		}
	}
	/*----------------------------------------------------------
	 *	
	 *---------------------------------------------------------*/
	/* M--ʏ탁bZ[W */
	else if (MSG_SND_ZERO ==  (msgid & MSG_SND_MASK)) 
	{
		msgid_no = (UINT8)(msgid & MSG_ID_MASK);
		CHECK_MAX_SND_ZERO(msgid_no);
		/* MŏIʒu܂ŎMbZ[WID擾 */
		for (recv_cnt =0; 
				MSG_NULL != (recvid 
							= ((sndlist_snd_in_zero[msgid_no])[recv_cnt]));
				 												recv_cnt++) {
			LEAVE_CRITICALSECTION();

			/* MbZ[WփZbg */
			ercd = SetRcvZeroMsg(recvid);
			
			ENTER_CRITICALSECTION();

			if (E_OK == ercd) {
				/*  */
			}
			else if (E_IL_FILTERED == ercd) {
				LOG_SENDZEROMESSAGE_FILTERED(recvid);
				ercd = E_OK;
			}
			else {
				/* G[ */
				LOG_SENDZEROMESSAGE_ERROR(ercd, recvid);
				ercd = E_COM_SYS_ERR;
				goto d_error_exit;
			}
		}
	}
	else
	{
	}

  exit:
	LEAVE_CRITICALSECTION();
	LOG_SENDZEROMESSAGE_LEAVE(ercd);
	return(ercd);

  error_exit:
	ENTER_CRITICALSECTION();
  d_error_exit:
	_com_errorhook_par1.m_msgid = msgid;
	call_com_errorhook(ercd, COMServiceId_SendZeroMessage);
	goto exit;
}

