/*
 *  TOPPERS/OSEK COM
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK COM
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *  ^C}i [UCN[ht@C
 *  com_timer_user.h
*/
#ifndef _COM_TIMER_USER_H_
#define _COM_TIMER_USER_H_

/*
 *  ^C}iL`
 */
typedef void 	(*TIMFP)(UINT8 ipdu_id);		/* ^C}GNXpCAĂяo֐ */

typedef UINT8		TimerType;					/* ^C}ID 	AlarmType			*/
typedef UINT32		TimerTickType;				/* ^C}lieBbNPʁjTickType	*/
typedef UINT8		TickCounterType;			/* JE^ID	CounterType			*/

typedef struct {
	TimerTickType m_maxallowedvalue;				/* JE^w̍ől 		*/
	TimerTickType m_ticksperbase;					/* PʂɒB܂ł̃eBbN */
	TimerTickType m_mincycle;						/* TCNw̍ŏl 		*/
} TimerBaseType;

typedef TimerBaseType	*TimerBaseRefType;

/*
 *  ^C}iG[R[h
 */
#define E_TIM_NOFUNC	(UINT8)60
#define E_TIM_STATE		(UINT8)61

#define TIMFP_NULL	((TIMFP) 0)						/* o^֐|C^ */

/*
 *  ^C}iC^tF[X
 */
extern void timer_initialize(void);
extern StatusType SetRelTimer(TimerType , TimerTickType , TimerTickType , TIMFP, UINT8 );
extern StatusType CancelTimer(TimerType );
extern void com_init_timer(void);
extern void com_term_timer(void);

/*
 *  ^CeBbN
 */
extern StatusType SignalTimeTick(TickCounterType tickid);

/* ^C}i */
extern const UINT8 tnum_timer;					/* ^C}̐ 				*/
extern const TickCounterType timinib_tickid[];	/* tĂJE^ 	*/
extern TimerType timcb_next[];					/* ^C}L[ 			*/
extern TimerType timcb_prev[];					/* ^C}L[ 			*/
extern TimerTickType timcb_timval[];			/* expire eBbNl */
extern TimerTickType timcb_cycle[];				/* ^C}̎ 			*/
extern TIMFP timcb_cback[];						/* ^C}R[obN		*/
extern UINT8 timcb_param[];
extern TimerType timer_snd_ctrl[];
extern TimerType timer_snd_periodic[];
extern TimerType timer_rcv_ctrl[];

#endif /* _COM_TIMER_USER_H_ */
