/*
 *  TOPPERS/OSEK COM
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK COM
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Witz Corporation, JAPAN
 *  Copyright (C) 2004-2007 by Tokai-Soft Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 * ul.c
 *
 * StartUL, StopUL, SndUL, SndCancelUL, RcvUL
 * 
 */
/*---------------------------------------------------------------------------*
 * inculde files
 *---------------------------------------------------------------------------*/
#include "osek_com.h"
#include "com_interrupt.h"
#include "com_cfg.h"
#include "ul_can.h"


/*---------------------------------------------------------------------------*
 * function prototype definition
 *---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*
 * variable
 *---------------------------------------------------------------------------*/
ULCompCBFType	snd_fin_cbf;
ULCompCBFType	rcv_fin_cbf;
ULErrCBFType	snd_err_cbf;
ULErrCBFType	rcv_err_cbf;

/*---------------------------------------------------------------------------*
 * data table definition
 *---------------------------------------------------------------------------*/
extern const ULSndFunc			snd_ul_func[];
extern const ULSndCancelFunc	snd_cancel_ul_func[];
extern const ULRcvFunc			rcv_ul_func[];
extern UINT8					ulpdu_rcv_dlc[];

/*---------------------------------------------------------------------------*
 * function
 *---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*
 * kernel object
 *---------------------------------------------------------------------------*/
ISR(CANReceiveInt);
ISR(CANSndInt);


/*--------------------------------------------------------------------
 *
 * Tv       FUL
 *            F
 * @\       FʐMhCo
 *            FUL̓ϐ
 *            FR[obNʒmݒ
 *        F
 *   (in)     F<p_snd_fin_func>	Mʒm
 *            F<p_rcv_fin_func>	Mʒm
 *            F<p_snd_err_func>	MG[ʒm
 *            F<p_rcv_err_func>	MG[ʒm
 *   (out)    FȂ
 * ߂l     F
 *   Standard FE_OK
 *   Extended FE_UL_STOP           ULs
 *            F
 * l       F
 *------------------------------------------------------------------*/
StatusType
StartUL( ULCompCBFType p_snd_fin_func,
		 ULCompCBFType p_rcv_fin_func,
		 ULErrCBFType p_snd_err_func,
		 ULErrCBFType p_rcv_err_func )
{
	StatusType	ercd = E_OK;
	UINT8	ipdu_cnt;


	/* eʐMhCoN		*/
#ifdef UL_SUPPORT_CAN
	ercd = ul_can_initialize();
#endif	/* UL_SUPPORT_CAN	*/
#ifdef UL_SUPPORT_LIN
	lin_initialize();
#endif	/* UL_SUPPORT_LIN	*/
#ifdef UL_SUPPORT_BEAN
	bean_initialize();
#endif	/* UL_SUPPORT_BEAN	*/

	/* Mobt@񏉊	*/
	for( ipdu_cnt = 0; ipdu_cnt < tnum_rcv_ipdu; ipdu_cnt++ ){
		ulpdu_rcv_dlc[ipdu_cnt] = 0;	/* f[^=0(f[^)	*/
	}

	/* R[obN֐ێ		*/
	snd_fin_cbf = p_snd_fin_func;
	rcv_fin_cbf = p_rcv_fin_func;
	snd_err_cbf = p_snd_err_func;
	rcv_err_cbf = p_rcv_err_func;

	return ercd;
}

/*--------------------------------------------------------------------
 *
 * Tv       FULI
 *            F
 * @\       FʐMhCo~
 *            FR[obNʒmNA
 *        F
 *   (in)     FȂ
 *   (out)    FȂ
 * ߂l     F
 *   Standard FE_OK
 *   Extended FE_UL_BUSY       ULIs
 *            F
 * l       F
 *------------------------------------------------------------------*/
StatusType
StopUL( void )
{
	StatusType	ercd;

	/* eʐMhCo~		*/
#ifdef UL_SUPPORT_CAN
	ercd = ul_can_terminate();
#endif	/* UL_SUPPORT_CAN	*/
#ifdef UL_SUPPORT_LIN
	lin_terminate();
#endif	/* UL_SUPPORT_LIN	*/
#ifdef UL_SUPPORT_BEAN
	bean_terminate();
#endif	/* UL_SUPPORT_BEAN	*/

	/* R[obN֐NA	*/
	snd_fin_cbf = (ULCompCBFType)FP_NULL;
	rcv_fin_cbf = (ULCompCBFType)FP_NULL;
	snd_err_cbf = (ULErrCBFType)FP_NULL;
	rcv_err_cbf = (ULErrCBFType)FP_NULL;

	return ercd;
}

/*--------------------------------------------------------------------
 *
 * Tv       FULM
 *            F
 * @\       FIL瑗Mw߂󂯂IPDU𑗐M
 *            FwʐMhCȏMR[
 *            F
 *        F
 *   (in)     F<ipdu_id>	MvIPDU-ID
 *            F<p_message>	MbZ[W|C^
 *            F<dlc>	    Mf[^
 *   (out)    FȂ
 * ߂l     F
 *   Standard FE_OK
 *   Extended FE_UL_CHECK 	Mf[^ُ
 *			@F			MDLCُ
 *			  FE_UL_BUSY  	ML[I[o[t[
 *			  F			ʐMhCoMs
 *			  FE_UL_STOP	ʐMhCo~
 *            F
 * l       F
 *------------------------------------------------------------------*/
StatusType
SndUL( IPDUType ipdu_id, UINT8 *p_message, UINT8 dlc )
{
	StatusType	ercd;
	ENTER_CRITICALSECTION();

	ercd = snd_ul_func[ipdu_id]( ipdu_id, p_message, dlc );

	LEAVE_CRITICALSECTION();
	return ercd;
}

/*--------------------------------------------------------------------
 *
 * Tv       FULMLZ
 *            F
 * @\       FIL瑗MLZw߂󂯂IPDȖMLZ
 *            FwʐMhCȏMLZR[
 *            F
 *        F
 *   (in)     F<ipdu_id>	MLZvIPDU-ID
 *   (out)    FȂ
 * ߂l     F
 *   Standard FE_OK
 *            F
 * l       F
 *------------------------------------------------------------------*/
StatusType
SndCancelUL( IPDUType ipdu_id )
{
	StatusType	ercd;
	ENTER_CRITICALSECTION();

	ercd = snd_cancel_ul_func[ipdu_id]( ipdu_id );

	LEAVE_CRITICALSECTION();
	return ercd;
}


/*--------------------------------------------------------------------
 *
 * Tv       FULM
 *            F
 * @\       FIL̎M^XNw߂󂯂
 *            FwʐMhCõbZ[WM
 *            F
 *        F
 *   (in)     FȂ
 *   (out)    F<ipdu_id>	MIPDU-ID
 *            F<p_message>	Mobt@|C^
 *            F<dlc>	    Mf[^|C^
 * ߂l     F
 *   Standard FE_OK
 *   Extended FE_UL_NO_DATA MbZ[WȂ
 *            F
 * l       F
 *------------------------------------------------------------------*/
StatusType
RcvUL( IPDUType ipdu_id, UINT8 *p_message, UINT8 *p_dlc )
{
	StatusType	ercd;


	ercd = rcv_ul_func[ipdu_id]( ipdu_id, p_message, p_dlc);

	return ercd;
}

/*
 *  CANM
 */
ISR(CANReceiveInt)
{
	FncCANRcvIntDRV();	/* M	*/
}

/*
 *  CANM
 */
ISR(CANSndInt)
{
    FncCANSndIntDRV();	/* M	*/
}

