/*
 *  TOPPERS/OSEK COM
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK COM
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Witz Corporation, JAPAN
 *  Copyright (C) 2004-2007 by Tokai-Soft Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

#ifndef _UL_H_
#define _UL_H_


/*---------------------------------------------------------------------------*
 * inculde files
 *---------------------------------------------------------------------------*/
#ifdef UL_SUPPORT_CAN
#include "ul_can.h"
#endif	/* UL_SUPPORT_CAN	*/
#ifdef UL_SUPPORT_LIN
#include "lin.h"
#endif	/* UL_SUPPORT_LIN	*/


/*---------------------------------------------------------------------------*
 * Constant definition
 *---------------------------------------------------------------------------*/
/*
 * ULG[R[h
 */
#define	E_UL_BUSY		(StatusType)0x81	/* O				*/
#define	E_UL_STOP		(StatusType)0x82	/* ʐMhCo~		*/
#define	E_UL_NO_DATA	(StatusType)0x83	/* MbZ[WȂ		*/
#define	E_UL_OVER_RUN	(StatusType)0x84	/* Mf[^I[o[	*/
#define	E_UL_CHECK		(StatusType)0x85	/* Mf[^茟G[	*/
#define	E_UL_BIT		(StatusType)0x86	/* MrbgG[			*/
#define	E_UL_NO_RES		(StatusType)0x87	/* MG[		*/
#define	E_UL_NON_CTL	(StatusType)0x88	/* foCXs\G[	*/


/*---------------------------------------------------------------------------*
 * data type definition
 *---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*
 * function type definition
 *---------------------------------------------------------------------------*/
typedef	void	( *ULCompCBFType )( IPDUType/* ipdu_id*/ );
typedef	void	( *ULErrCBFType )( IPDUType ipdu_id, StatusType err_status );

typedef	StatusType	(*ULSndFunc)( IPDUType ipdu_id, UINT8 *p_message, UINT8 dlc );
typedef	StatusType	(*ULSndCancelFunc)( IPDUType ipdu_id );
typedef	StatusType	(*ULRcvFunc)( IPDUType ipdu_id,UINT8 *p_message,UINT8 *p_dlc );


/*---------------------------------------------------------------------------*
 * function prototype definition
 *---------------------------------------------------------------------------*/
StatusType	StartUL( ULCompCBFType p_snd_fin_func,
					 ULCompCBFType p_rcv_fin_func,
					 ULErrCBFType p_snd_err_func,
					 ULErrCBFType p_rcv_err_func );
StatusType	StopUL( void );
StatusType	SndUL( IPDUType ipdu_id, UINT8 *p_message, UINT8 dlc );
StatusType	RcvUL( IPDUType ipdu_id, UINT8 *p_message, UINT8 *p_dlc );
StatusType	SndCancelUL( IPDUType ipdu_id );


#endif /* _UL_H_ */


