/*
 *  TOPPERS/OSEK COM
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK COM
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Witz Corporation, JAPAN
 *  Copyright (C) 2004-2007 by Tokai-Soft Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 * ul_can.c
 */

/*---------------------------------------------------------------------------*
 * inculde files
 *---------------------------------------------------------------------------*/
#include "com_cfg.h"
#include "osek_com.h"
#include "kernel_id.h"
#include "com_interrupt.h"

/*---------------------------------------------------------------------------*
 * function prototype definition
 *---------------------------------------------------------------------------*/
static StatusType	snd_ul_can_putmsg( void );				     /* bZ[WM(֐)	*/
static StatusType	snd_ul_can_setmsg( void );				     /* bZ[Wݒ(֐)	*/

extern UINT8 fget_snd_ul_canmessage_num(  UINT8  canmsg_idx,     /* CANM擾			*/
										  UINT8  dlc,
										  UINT8* div_num );
extern UINT8 fget_snd_ul_canmessage_once( const UINT8* pmsg_head,/* CANPꑗMbZ[W擾	*/
									 	  const ULCANWorkInfo* snd_info, 
									 	  UINT8* pmsg_snd );
extern UINT8 fget_snd_ul_canmessage_div( const UINT8* pmsg_head, /* CANMbZ[W擾	*/
									 	  ULCANWorkInfo* snd_info, 
									 	  UINT8* pmsg_snd );
extern UINT8 fget_rcv_ul_canmessage_num(  UINT8  canmsg_idx,     /* CANM擾			*/
										  const UINT8* pmsg,
										  UINT8* div_num );
extern UINT8 fget_rcv_ul_canmessage_once( const UINT8* pmsg_rcv, /* CANPMbZ[W擾	*/
									 	  const ULCANWorkInfo* rcv_info, 
									 	  UINT8* pmsg_head );
extern UINT8 fget_rcv_ul_canmessage_div( const UINT8* pmsg_rcv,  /* CANMbZ[W擾	*/
									 	  ULCANWorkInfo* rcv_info, 
									 	  UINT8* pmsg_head );

/*---------------------------------------------------------------------------*
 * variable
 *---------------------------------------------------------------------------*/
/* UL */
extern ULCompCBFType	snd_fin_cbf;			/* IL֑Mʒm	*/
extern ULCompCBFType	rcv_fin_cbf;			/* IL֎Mʒm	*/
extern ULErrCBFType		snd_err_cbf;			/* IL֑MG[ʒm	*/
extern ULErrCBFType		rcv_err_cbf;			/* IL֎MG[ʒm	*/

extern UINT8* const	ulpdu_snd_buf_addr[];		/* MUL-PDUobt@	*/
extern UINT8  ulpdu_snd_dlc[];					/* MUL-PDU DLC		*/
extern UINT8* const	ulpdu_rcv_buf_addr[];		/* MUL-PDUobt@	*/
extern UINT8  ulpdu_rcv_dlc[];					/* MUL-PDU DLC		*/

/* UL-CAN */
extern const UINT8 tnum_snd_can;				/* UL-CANMf[^		 */
extern const UINT8 tnum_rcv_can;				/* UL-CANMf[^		 */
extern const CANType 	can_id_snd[];			/* IPDU-ID <--> CAN-ID		 */
extern const CANType 	can_id_rcv[];			/* IPDU-ID <--> CAN-ID		 */

/* UL-CANMf[^obt@ */
UINT8	ulcan_snd_buf[CAN_DATA_DLC_DRV];

/* CAN resource */
DeclareResource(COMReceiveRes);

/* UL-CANMp[Nϐ */
static ULCANWorkInfo	ulcan_snd_info;					/* CANMs		*/
static UINT8    ulcan_snd_queue_cnt;					/* CANMQUEUEJE^	*/
static UINT8    ulcan_snd_enque_point;					/* CANM ENQUEUEʒu	*/
static UINT8    ulcan_snd_deque_point;					/* CANM DEQUEUEʒu	*/
static UINT16   ulcan_drv_sts;							/* CANDriverԃtO	*/

/* ȉ̃[Nobt@SGo */
extern ULCANWorkInfo	ulcan_rcv_info[];				/* CANMs		*/
extern IPDUType			ulcan_snd_queue[];				/* CANMQUEUE			*/

/*---------------------------------------------------------------------------*
 * macro
 *---------------------------------------------------------------------------*/
/* M^M Ԑݒ */
#define	SET_COM_EMPTY( info ) do { 							\
	((ULCANWorkInfo *)(info))->m_sts = UL_CAN_COM_EMPTY;	\
	((ULCANWorkInfo *)(info))->m_dlc = 0;					\
	((ULCANWorkInfo *)(info))->m_dlc_num = 0;				\
	((ULCANWorkInfo *)(info))->m_div_num = 0;				\
	((ULCANWorkInfo *)(info))->m_div_cnt = 0;				\
	((ULCANWorkInfo *)(info))->m_off_point = 0;				\
	((ULCANWorkInfo *)(info))->m_ipdu_id = 0;				\
	((ULCANWorkInfo *)(info))->m_can_id = 0;				\
} while(0)

/* M҂^M҂ Ԑݒ */
#define	SET_COM_WAIT( info ) do { 						\
	((ULCANWorkInfo *)(info))->m_sts = UL_CAN_COM_WAIT;	\
} while(0)

/* M^M Ԑݒ */
#define	SET_COM_WORK( info ) do { 						\
	((ULCANWorkInfo *)(info))->m_sts = UL_CAN_COM_WORK;	\
} while(0)

/* M^M Ԑݒ */
#define	SET_COM_END( info ) do { 						\
	((ULCANWorkInfo *)(info))->m_sts = UL_CAN_COM_END;	\
} while(0)

/* CAN`FbN */
#define CHECK_DRV_INIT(mode) do { 						\
	if (UL_CAN_DRV_NON == ((mode) & UL_CAN_DRV_INIT)) {	\
		ercd = E_UL_STOP;								\
		goto error_exit;								\
	}													\
} while(0)

/* ML[ QUEUEING */
#define	UL_SND_QUEUEING( q_point ) do { 				\
	(q_point)++;										\
	if( TNUM_SND_CAN == (q_point) ){					\
		(q_point) = 0;									\
	}													\
} while(0)

/*---------------------------------------------------------------------------*
 * function
 *---------------------------------------------------------------------------*/

/*-- ILƂI/F -------------------------------------------------------------*/

/*--------------------------------------------------------------------
 *
 * Tv       FUL-CAN
 *            F
 * @\       FUL-CAN̓ϐ
 *            FCANʐMhCo
 *        F
 *   (in)     FȂ
 *   (out)    FȂ
 * ߂l     F
 *   Standard FE_OK
 *   Extended FE_UL_STOP     UL-CANs
 *            F
 * l       F
 *------------------------------------------------------------------*/
StatusType
ul_can_initialize( void )
{
	UINT8	can_cnt;
	StatusType	ercd = E_OK;
	StatusType	ercd_can = CAN_E_OK;
	
	/* ϐ */	
	ulcan_drv_sts = UL_CAN_DRV_NON;				/* CANDrivertO	*/
	
												/* CANMQUEUE		*/
	for( can_cnt = 0; can_cnt < tnum_snd_can; can_cnt++ ){
		ulcan_snd_queue[can_cnt] = IPDU_NULL;	
	}
	ulcan_snd_queue_cnt = 0;
	ulcan_snd_enque_point = 0;
	ulcan_snd_deque_point = 0;

	SET_COM_EMPTY( &ulcan_snd_info );			/* CANMs	*/
	
												/* CANMs	*/
	for( can_cnt = 0; can_cnt < tnum_rcv_can; can_cnt++ ){
		SET_COM_EMPTY( &(ulcan_rcv_info[can_cnt]) );
	}

	/* CANhCo */
	(void)FncSetCANIntLVLDRV();
    ercd_can = FncCANResetDRV();/* 荞݋֎~ƃhCõZbg	*/
	if( CAN_E_OK == ercd_can ){
		ercd_can = FncChgModCAN(CAN_DRV_CAN_RUN);
		if(  CAN_E_OK == ercd_can )
		{
			ercd_can = FncEnCANRcvInt();
			ercd_can = FncEnCANSndInt();
			ercd_can = FncEnCANErrInt();
		}
	}

	/* CANhCo */
	if( CAN_E_OK == ercd_can ){
		/* tO𗧂Ă */								
		ulcan_drv_sts = (UINT16)(ulcan_drv_sts | UL_CAN_DRV_INIT);
		ercd = E_OK;	
	}
	/* CANhCos */
	else{
		ercd = E_UL_STOP;
	}

	return ercd;
}

/*--------------------------------------------------------------------
 *
 * Tv       FUL-CANI
 *            F
 * @\       FCANʐMhCoI
 *        F
 *   (in)     FȂ
 *   (out)    FȂ
 * ߂l     F
 *   Standard FE_OK
 *   Extended FE_UL_BUSY     UL-CANIs
 *            F
 * l       F
 *------------------------------------------------------------------*/
StatusType
ul_can_terminate( void )
{
	StatusType	ercd = E_OK;
	StatusType	ercd_can = CAN_E_OK;

	/* CANhCoI */
	ercd_can = FncCANResetDRV();
	
	/* CANhCoI */
	if( CAN_E_OK == ercd_can ){
		ercd = E_OK;	
	}
	/* CANhCoIs */
	else{
		ercd = E_UL_BUSY;
	}

	return ercd;
}

/*--------------------------------------------------------------------
 *
 * Tv       FUL-CANM
 *            F
 * @\       FMUL-PDUobt@֑MIPDUIDݒ
 *            FML[֑Mf[^ݒ
 *            FUL_CAN bZ[WM
 *        F
 *   (in)     F<ipdu_id>	MIPDUID
 *            F<p_message>	Mf[^|C^
 *            F<dlc>	    Mf[^
 *   (out)    FȂ
 * ߂l     F
 *   Standard FE_OK
 *   Extended FE_UL_STOP   ʐMhCoMs
 *            FE_UL_CHECK  Mf[^ُEMf[^ُ
 *            FE_UL_BUSY   ML[I[o[t[
 *            F
 * l       F
 *------------------------------------------------------------------*/
StatusType
snd_ul_can( IPDUType ipdu_id, const UINT8 *p_message, UINT8 dlc )
{
	UINT8	cpy_cnt;
	UINT8*	p_addr = NULL;
	UINT8	m_drv_sts = CAN_DRV_BUSOFF;	
	StatusType	ercd = E_OK;
	
	/* CANhCo`FbN */
	CHECK_DRV_INIT(ulcan_drv_sts);

	/* CANoXIt`FbN */
	FncGetBusoffStsDRV(&m_drv_sts);
	if( CAN_DRV_BUSOFF == m_drv_sts ){
		ercd = E_UL_STOP;
		goto error_exit;
	}

	/* CANML[I[o[t[`FbN */
	if( ulcan_snd_queue_cnt >= tnum_snd_can ){
		ercd = E_UL_BUSY;
		goto error_exit;
	}
	
	/* dlc`FbN */
	if( 0 >= dlc ){
		ercd = E_UL_CHECK;
		goto error_exit;
	}
		
	/* MUL-PDUobt@֑Mf[^ݒ */
	p_addr = ulpdu_snd_buf_addr[ipdu_id];
	for( cpy_cnt = 0; cpy_cnt < dlc; cpy_cnt++ ){
		p_addr[cpy_cnt] = p_message[cpy_cnt];
	}
	ulpdu_snd_dlc[ipdu_id] = dlc;
	
	/* ML[֒ǉ */	
	ulcan_snd_queue[ulcan_snd_enque_point] = ipdu_id;
	UL_SND_QUEUEING( ulcan_snd_enque_point); /* ML[ENQUEUE */
	ulcan_snd_queue_cnt++;
		
	/* bZ[WM */
	ercd = snd_ul_can_putmsg();
	if( E_OK != ercd ){
		goto error_exit;
	}

  exit:
	return ercd;

  error_exit:
	goto exit;
}

/*--------------------------------------------------------------------
 *
 * Tv       FUL-CANMLZ
 *            F
 * @\       FMԂł΁A
 *            FCANhCo֑Mt[~v
 *            FMԂł΁A
 *            FML[YbZ[W폜
 *        F
 *   (in)     F<ipdu_id>	MLZIPDUID
 *   (out)    FȂ
 * ߂l     F
 *   Standard FE_OK
 *            F
 * l       F
 *------------------------------------------------------------------*/
StatusType
snd_ul_can_cancel( IPDUType ipdu_id )
{
	UINT8		que_cnt;
	UINT8		que_point;
	UINT8		nxt_point;
	UINT8		que_rf_size;
	UINT8		que_rf_cnt;
	UINT16		com_sts;
	StatusType	ercd = E_OK;

	/* CANhCo`FbN */
	CHECK_DRV_INIT(ulcan_drv_sts);

	/* M̃bZ[WLZ */
	com_sts = UL_CAN_COM_WAIT | UL_CAN_COM_WORK;
	if( (com_sts == ( ulcan_snd_info.m_sts & com_sts )) &&
	    ( ipdu_id == ulcan_snd_info.m_ipdu_id ) ){

		/* COMMf[^A{[g */
		FncAbtCOMSndMsgDRV();
		/* M(CANMsNA) */
		SET_COM_EMPTY( &ulcan_snd_info );

	}
	/* ML[̃bZ[WLZ */
	else{
		
		/* ML[ */
		que_point = ulcan_snd_deque_point;
		for( que_cnt =1; que_cnt <= ulcan_snd_queue_cnt; que_cnt++ ){
			if( ipdu_id == ulcan_snd_queue[que_point] ){ /* ݂ */
				ulcan_snd_queue[que_point] = IPDU_NULL;
				break;
			}
			if( tnum_snd_can == que_point ){
				que_point = 0;
			}
			que_point++;
		}
		/* ML[̃tbV */
		que_rf_size = ulcan_snd_queue_cnt - que_cnt;
		if (0 != que_rf_size) {
			nxt_point = que_point;
			
			for (que_rf_cnt = 0; que_rf_cnt < que_rf_size; que_rf_cnt++) {
				que_point = nxt_point;
				/* of[^ʒu̎Zo */
		    	UL_SND_QUEUEING(nxt_point);
				ulcan_snd_queue[que_point] = ulcan_snd_queue[nxt_point];
			}
		 
			ulcan_snd_enque_point = que_point;
			ulcan_snd_queue_cnt++;
		} 

	}

  exit:
	return ercd;

  error_exit:
	goto exit;
}

/*--------------------------------------------------------------------
 *
 * Tv       FUL-CANM
 *            F
 * @\       FMUL-PDUobt@AwIPDU-ID
 *            FMf[^ƎMf[^擾
 *        F
 *   (in)     F<ipdu_id>	MIPDUID
 *   (out)    F<p_message>	Mf[^|C^
 *            F<p_dlc>	    Mf[^|C^
 * ߂l     F
 *   Standard FE_OK
 *   Extended FE_UL_STOP    ʐMhCoMs
 *            FE_UL_NO_DATA Mf[^
 *            F
 * l       F
 *------------------------------------------------------------------*/
StatusType
rcv_ul_can( IPDUType ipdu_id, UINT8 *p_message, UINT8 *p_dlc )
{
	UINT8	cpy_cnt;
	UINT8	can_cnt;
	UINT8	msg_idx;	
	UINT8*	p_addr = NULL;
	StatusType	ercd = E_OK;

	/* CANhCo`FbN */
	CHECK_DRV_INIT(ulcan_drv_sts);

	/* MbZ[WL`FbN */
	msg_idx  = ipdu_id - OFFSET_RCV_IPDU_CAN;
	if( ( tnum_rcv_can <= msg_idx )||
	    ( UL_CAN_COM_EMPTY == (ulcan_rcv_info[msg_idx].m_sts & UL_CAN_COM_EMPTY) ) ){
		
		ercd = E_UL_NO_DATA;
		goto error_exit;
	}
	
	(void)GetResource( COMReceiveRes );		/* \[Xm */

	/* MUL-PDUobt@Mf[^擾 */
	*p_dlc = ulpdu_rcv_dlc[ipdu_id];
	ulpdu_rcv_dlc[ipdu_id] = 0;
	p_addr = ulpdu_rcv_buf_addr[ipdu_id];
	for( cpy_cnt = 0; cpy_cnt < *p_dlc; cpy_cnt++ ){
		p_message[cpy_cnt] = p_addr[cpy_cnt];
	}

	(void)ReleaseResource( COMReceiveRes );	/* \[X */

  exit:
	/* M(CANMsNA) */								
	for( can_cnt = 0; can_cnt < tnum_rcv_can; can_cnt++ ){
		SET_COM_EMPTY( &(ulcan_rcv_info[can_cnt]) );
	}
	return ercd;

  error_exit:
	goto exit;
}

/*-- CANDriverƂI/F ------------------------------------------------------*/

/*--------------------------------------------------------------------
 *
 * Tv       FCANDrv瑗Mʒm
 *            F
 * @\       FSpPbg̑Mł΁A
 *            FIL֑Mʒm
 *            FSpPbg̑Mł΁A
 *            FpPbgUL_CAN bZ[WM
 *        FȂ
 * ߂l     F
 *   Standard FE_OK
 *            F
 * l       FMbZ[WĩpPbgőMjɑΉ
 *------------------------------------------------------------------*/
void
CallCOMSndMsgDRV(void)
{

	StatusType	ercd = E_OK;

	CHECK_INTERRUPT();
	ENTER_CRITICALSECTION(); /* ݋֎~ */

	/* MpPbgJEgAbv */
	ulcan_snd_info.m_div_cnt++;
	if( ulcan_snd_info.m_div_num >= ulcan_snd_info.m_div_cnt ){

		/* SpPbgM */
		if( ulcan_snd_info.m_div_num == ulcan_snd_info.m_div_cnt ){

			/* IL֑Mʒm */
			if( FP_NULL != (FP)snd_fin_cbf ){
				snd_fin_cbf( ulcan_snd_info.m_ipdu_id );
			}
			/* M(CANMsNA) */
			SET_COM_EMPTY( &ulcan_snd_info );

		}
		/* SpPbgM */
		else{
			
			/* ̑MpPbgݒ */
			ulcan_snd_info.m_dlc =
			fget_snd_ul_canmessage_div(	/* CANMbZ[W */
			 			(UINT8*)ulpdu_snd_buf_addr[ulcan_snd_info.m_ipdu_id],/* (in)MUL-PDUobt@ */
						(ULCANWorkInfo*)&ulcan_snd_info,                     /* (in/out)M       */
						(UINT8*)ulcan_snd_buf );                             /* (out)CANMbZ[W */
			
			/* M҂ */
			SET_COM_WAIT( &ulcan_snd_info );

		}
		
		/* ̑M */
		(void)snd_ul_can_putmsg();

	}

	LEAVE_CRITICALSECTION();
}

/*--------------------------------------------------------------------
 *
 * Tv       FCANDrvoXG[ʒm
 *            FNMoXG[ʒm
 *            F
 * @\       FMIPDUɑ΂A
 *            FECANhCo֑Mt[~v
 *            FEIL֑MG[ʒm
 *            FMiM҂jIPDUɑ΂A
 *            FEML[YbZ[W폜
 *            FEIL֑MG[ʒm
 *        FȂ
 * ߂l     FȂ
 *            F
 * l       F
 *------------------------------------------------------------------*/
void
#if CAN_DRV_NM_RCV == CAN_TRUE
CallErrIntNM(void)
#else
CallErrIntDRV(void)
#endif
{
	IPDUType	work_ipduid;
	UINT16		com_sts;
	
	/* ݑMIPDUɑ΂đMG[ʒm */
	com_sts = UL_CAN_COM_WAIT | UL_CAN_COM_WORK;
	if(  com_sts == (ulcan_snd_info.m_sts & com_sts) ){
		
		/* IL֑MG[ʒm */
		if( FP_NULL != (FP)snd_err_cbf ){
			snd_err_cbf( ulcan_snd_info.m_ipdu_id, E_UL_STOP );
		}

		/* COMMf[^A{[g */
		FncAbtCOMSndMsgDRV();

		/* M(CANMsNA) */
		SET_COM_EMPTY( &ulcan_snd_info );
	}

	/* L[ɑ݂IPDUɑ΂đMG[ʒm */
	while(ulcan_snd_queue_cnt > (UINT8)0){
		
		/* ML[IPDU擾 */
		work_ipduid = ulcan_snd_queue[ulcan_snd_deque_point];

		/* IL֑MG[ʒm */
		if( FP_NULL != (FP)snd_err_cbf ){
			snd_err_cbf( work_ipduid, E_UL_STOP );
		}

		/* ML[IPDU폜 */
		ulcan_snd_queue[ulcan_snd_deque_point] = IPDU_NULL;

		/* ML[DEQUEUE */
		UL_SND_QUEUEING( ulcan_snd_deque_point);
		ulcan_snd_queue_cnt --;
	}
}

/*--------------------------------------------------------------------
 *
 * Tv       FCANDrvMʒm
 *            F
 * @\       FMCANbZ[W`FbN
 *            FMCAN-IDIPDU-ID֕ϊ
 *            FMCANbZ[W̊i[ibZ[W̌j
 *            FIL֎Mʒm܂͎MG[ʒm
 *        F
 *   (in)     F<can_id>	MCAN-ID
 *   @@@   F<dlc>	    MCANbZ[W
 *            F<buff>	    MCANbZ[W|C^
 *   (out)    FȂ
 * ߂l     FȂ
 *            F
 * l       F
 *------------------------------------------------------------------*/
void
CallCOMRcvMsgDRV(UINT32 can_id, UINT8 dlc, const UINT8 *buff)
{
	UINT8		msg_idx		= 0;
	UINT8		msgkind		= 0;
	UINT8		work_dlc	= 0;
	IPDUType	work_ipduid	= 0;
	StatusType	ercd = E_OK;


	CHECK_INTERRUPT();
	
	/* \[Xm */
	(void)GetResource( COMReceiveRes );

	/* CAN-ID to IPDU-ID */
	for( msg_idx = 0; msg_idx < tnum_rcv_can; msg_idx++ ){
		if( can_id == (UINT32)(can_id_rcv[msg_idx]) ){
				work_ipduid = msg_idx + OFFSET_RCV_IPDU_CAN; /* IPDU_idݒ */
				ulcan_rcv_info[msg_idx].m_ipdu_id =work_ipduid;
				break;
		}
	}

	/* MCAN-ID͈͊O */
	if(  tnum_rcv_can <= msg_idx ){
		ercd = E_UL_CHECK;/* Mf[^G[ */
		goto error_exit;
	}
	
	/* DLC`FbN */
	if( ( 0 >= dlc ) ){
		ercd = E_UL_CHECK;/* Mf[^G[ */
		goto error_exit;
	}

	/* MȂ */
	if( UL_CAN_COM_END == (ulcan_rcv_info[msg_idx].m_sts & UL_CAN_COM_END) ){
		ercd = E_UL_OVER_RUN;/* I[o[CgG[ */
		goto error_exit;
	}

	/* MȂ */
	if( UL_CAN_COM_EMPTY == (ulcan_rcv_info[msg_idx].m_sts & UL_CAN_COM_EMPTY) ){

		/* MpPbgJE^ */						
		ulcan_rcv_info[msg_idx].m_div_cnt = 0;
		
		/* bZ[W擪̃ItZbgʒu	*/
		ulcan_rcv_info[msg_idx].m_off_point = 0;
		
		/* bZ[W擾 */
		msgkind =
		fget_rcv_ul_canmessage_num( msg_idx, buff, &(ulcan_rcv_info[msg_idx].m_div_num) );
		if( 0 == ulcan_rcv_info[msg_idx].m_div_num ){
			ercd = E_UL_CHECK;	/* Mf[^G[	*/
		 	goto error_exit;
		}
	}

	/* bZ[Wo */
	if( UL_CAN_COM_WORK == (ulcan_rcv_info[msg_idx].m_sts & UL_CAN_COM_WORK) ){
		 msgkind = ulcan_rcv_info[msg_idx].m_div_num;
	}

	/* MUL-PDU擾(PꃁbZ[W) */
	if( UL_CAN_MSG_ONCE_FRAME == (msgkind & UL_CAN_MSG_ONCE_FRAME) ){
		
		/* MDLC */
		ulcan_rcv_info[msg_idx].m_dlc = dlc;	/* 0`8	*/
		
		/* CANPMbZ[W */	
		work_dlc =
		fget_rcv_ul_canmessage_once(									
					buff,										/* (in)CANMbZ[W   */
					(ULCANWorkInfo*)&ulcan_rcv_info[msg_idx],	/* (in/out)M        */
					(UINT8*)ulpdu_rcv_buf_addr[work_ipduid] );	/* (out)MUL-PDUobt@ */
	}
	/* MUL-PDU擾(bZ[W) */
	else if( UL_CAN_MSG_DIV_FRAME == (msgkind & UL_CAN_MSG_DIV_FRAME) ){
		
		/* MDLC */
		dlc=dlc-1;
		ulcan_rcv_info[msg_idx].m_dlc = dlc;	/* 0`8	*/
	 	
		/* CANMbZ[W */
		work_dlc =
		fget_rcv_ul_canmessage_div(
					buff,										/* (in)CANMbZ[W   */
					(ULCANWorkInfo*)&ulcan_rcv_info[msg_idx],	/* (in/out)M        */
					(UINT8*)ulpdu_rcv_buf_addr[work_ipduid] );	/* (out)MUL-PDUobt@ */
	}
	else{
		ercd = E_UL_CHECK;/* Mf[^G[ */
		goto error_exit;
		
	}

	if(work_dlc != dlc ){
		ercd = E_UL_CHECK;/* Mf[^G[ */
		goto error_exit;
	}
	
	/* MUL-PDUDLC */
 	ulpdu_rcv_dlc[work_ipduid] += work_dlc;
	/* MpPbgJEgAbv */
	ulcan_rcv_info[msg_idx].m_div_cnt++;
	
	/* SpPbgf[^M */
	if( ulcan_rcv_info[msg_idx].m_div_num == ulcan_rcv_info[msg_idx].m_div_cnt ){
		
		/* IL֎MIʒm */
		if( FP_NULL != (FP)rcv_fin_cbf ){
			rcv_fin_cbf( ulcan_rcv_info[msg_idx].m_ipdu_id );
		}
		/* M */
		SET_COM_END( &ulcan_rcv_info[msg_idx] );		
	}
	/* SpPbgf[^M */
	else{
		/* M */
		SET_COM_WORK( &ulcan_rcv_info[msg_idx] );
	}

  exit:
	(void)ReleaseResource( COMReceiveRes ); /* \[X */

	return;

  error_exit:
  d_error_exit:
	call_com_errorhook(ercd, COMServiceId_CallCOMRcvMsgDRV);

	/* IL֎MG[ʒm */
	if( FP_NULL != (FP)rcv_err_cbf ){
		rcv_err_cbf( ulcan_rcv_info[msg_idx].m_ipdu_id, ercd );
	}
	goto exit;

}

/*-- ֐ --------------------------------------------------------------*/

/*--------------------------------------------------------------------
 *
 * Tv       FUL_CAN bZ[WM(֐)
 *            F
 * @\       FCANMbZ[Wݒ菈
 *            FhCoCANMbZ[W
 *        F
 *   (in)     FȂ
 *   (out)    FȂ
 * ߂l     F
 *   Standard FE_OK
 *   Extended FE_UL_CHECK   MbZ[Wُ
 *            F
 * l       F
 *------------------------------------------------------------------*/
static StatusType
snd_ul_can_putmsg( void )
{
	StatusType	ercd = E_OK;	
	
	/* M̏ꍇ */
	if( UL_CAN_COM_EMPTY == (ulcan_snd_info.m_sts & UL_CAN_COM_EMPTY) ){
		
		/* MbZ[Wݒ */
		ercd = snd_ul_can_setmsg(); 
		if( E_OK != ercd ){
			if( E_UL_NO_DATA == ercd ){
				ercd = E_OK; /* Mf[^݂ȂꍇOKԂ */
				goto exit;
			}
			goto error_exit; /* ȊÕG[NGԂ */
		}
		
	}
	
	/* M */
	SET_COM_WORK( &ulcan_snd_info );
	
	/* Drv COMMbZ[W */
	if( CAN_E_OK != FncWrCOMMsgDRV( (UINT32)(ulcan_snd_info.m_can_id),	/* CAN-ID         */
								 (UINT8) (ulcan_snd_info.m_dlc),		/* DLC            */
								 (UINT8*)(ulcan_snd_buf) ) )			/* MbZ[W */
	{
		/* M҂ */
		SET_COM_WAIT( &ulcan_snd_info );
		ercd = E_OK;
		goto exit;
	}

  exit:
	return ercd;

  error_exit:
	goto exit;
}

/*--------------------------------------------------------------------
 *
 * Tv       FUL_CAN MbZ[Wݒ(֐)
 *            F
 * @\       FML[烁bZ[Wo
 *            FCANMbZ[W肷
 *        F
 *   (in)     FȂ
 *   (out)    FȂ
 * ߂l     F
 *   Standard FE_OK
 *   Extended FE_UL_NO_DATA MbZ[W
 *            FE_UL_CHECK   MbZ[Wُ
 *            F
 * l       F
 *------------------------------------------------------------------*/
static StatusType
snd_ul_can_setmsg( void )
{
	IPDUType	work_ipduid;
	UINT8       msg_idx;
	UINT8		msgkind = 0;
	StatusType	ercd = E_UL_NO_DATA;/* MbZ[W */
	
	/* ML[ */
	while( ulcan_snd_queue_cnt > 0 ){
		
		/* ML[擾 */
		work_ipduid = ulcan_snd_queue[ulcan_snd_deque_point];
		msg_idx = (UINT8)work_ipduid - OFFSET_SND_IPDU_CAN;
		
		/* ML[DEQUEUE */
		UL_SND_QUEUEING( ulcan_snd_deque_point);
		ulcan_snd_queue_cnt--;
		
		/* 擾ML[f[^LȂ */
		if( ( IPDU_NULL != work_ipduid ) && ( tnum_snd_can > msg_idx ) ){
			
			ulcan_snd_info.m_ipdu_id = work_ipduid;					/* IPDU-ID	*/
			ulcan_snd_info.m_can_id = can_id_snd[msg_idx];			/* CAN-ID	*/
			ulcan_snd_info.m_dlc_num = ulpdu_snd_dlc[work_ipduid];	/* DLC		*/

			
 			ulcan_snd_info.m_div_cnt = 0;	/* MpPbgJE^			*/
			ulcan_snd_info.m_off_point = 0;	/* 擪̃ItZbgʒu	*/
			
			/* bZ[W */
			msgkind =
			fget_snd_ul_canmessage_num( msg_idx,
										 ulcan_snd_info.m_dlc_num,
										 &(ulcan_snd_info.m_div_num) );
			if( 0 == ulcan_snd_info.m_div_num ){
				ercd = E_UL_CHECK;/* MbZ[WG[ */
				goto error_exit;
			}
			
			/* CANMbZ[W(PꃁbZ[W) */
			if( UL_CAN_MSG_ONCE_FRAME == (msgkind & UL_CAN_MSG_ONCE_FRAME) ){
				
				/* CANPꑗMbZ[W */
				ulcan_snd_info.m_dlc =
				fget_snd_ul_canmessage_once(
				 			(UINT8*)ulpdu_snd_buf_addr[work_ipduid],	/* (in)MUL-PDUobt@ */
							(ULCANWorkInfo*)&ulcan_snd_info,			/* (in/out)M       */
							(UINT8*)ulcan_snd_buf );					/* (out)CANMbZ[W */
			}
			/* CANMbZ[W(bZ[W) */
			else if( UL_CAN_MSG_DIV_FRAME == (msgkind & UL_CAN_MSG_DIV_FRAME) ){
				
				/* CANMbZ[W */
				ulcan_snd_info.m_dlc =
				fget_snd_ul_canmessage_div(
							(UINT8*)ulpdu_snd_buf_addr[work_ipduid],	/* (in)MUL-PDUobt@ */
							(ULCANWorkInfo*)&ulcan_snd_info,			/* (in/out)M       */
							(UINT8*)ulcan_snd_buf );					/* (out)CANMbZ[W */
			}
			else{
				ercd = E_UL_CHECK;/* MbZ[WG[ */
				goto error_exit;
				
			}
			if( 0 == ulcan_snd_info.m_dlc ){
				ercd = E_UL_CHECK;/* MbZ[WG[ */
				goto error_exit;
			}			
			
			/* M҂ */
			SET_COM_WAIT( &ulcan_snd_info );
			ercd = E_OK;
			goto exit;
		}
		
	}

  exit:
	return ercd;

  error_exit:
	goto exit;
}

