/*
 *  TOPPERS/OSEK COM
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK COM
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Witz Corporation, JAPAN
 *  Copyright (C) 2004-2007 by Tokai-Soft Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 * ul_can.h
 */
#ifndef _UL_CAN_H_
#define _UL_CAN_H_


/*---------------------------------------------------------------------------*
 * inculde files
 *---------------------------------------------------------------------------*/
#include "ul_can_drv.h"/* CANDriverwb_*/

/*---------------------------------------------------------------------------*
 * Constant definition
 *---------------------------------------------------------------------------*/
/*
 * CANhCoĎ
 */
#define	UL_CAN_DRV_NON			((UINT16)0x0000)
#define	UL_CAN_DRV_INIT			((UINT16)0x1000) /* 			*/

/*
 * UL-CANM
 */
#define	UL_CAN_COM_NON			((UINT16)0x0000)
#define	UL_CAN_COM_EMPTY		((UINT16)0x0001) /* M^M		*/
#define	UL_CAN_COM_WAIT			((UINT16)0x0010) /* M҂^M҂	*/
#define	UL_CAN_COM_WORK			((UINT16)0x0020) /* M^M		*/
#define	UL_CAN_COM_END			((UINT16)0x0080) /* M^M	*/

/*
 * UL-CANMbZ[W
 */
#define	UL_CAN_MSG_ONCE_FRAME	((UINT8)0x01) /* Pt[     */
#define	UL_CAN_MSG_DIV_FRAME	((UINT8)0x02) /* t[ */

/*---------------------------------------------------------------------------*
 * data type definition
 *---------------------------------------------------------------------------*/
typedef	UINT32		CANType;

typedef	struct {
	UINT16		m_sts;		/* M										*/
	UINT8		m_dlc;		/* MbZ[ŴPpPbgf[^			*/
	UINT8		m_dlc_num;	/* MbZ[W̃f[^S					*/
	UINT8		m_div_num;	/* MbZ[W							*/
	UINT8		m_div_cnt;	/* MpPbgJE^							*/
	UINT8		m_off_point;/* MbZ[W擪̃ItZbgʒu		*/
	IPDUType	m_ipdu_id;	/* MIPDU-ID									*/
	CANType		m_can_id;	/* MCAN-ID									*/
} ULCANWorkInfo ;

/*---------------------------------------------------------------------------*
 * function type definition
 *---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*
 * function prototype definition
 *---------------------------------------------------------------------------*/
StatusType	ul_can_initialize( void );
StatusType	ul_can_terminate( void );
StatusType	snd_ul_can( IPDUType ipdu_id, const UINT8 *p_message, UINT8 dlc );
StatusType	snd_ul_can_cancel( IPDUType ipdu_id );
StatusType	rcv_ul_can( IPDUType ipdu_id, UINT8 *p_message, UINT8 *p_dlc );


#endif /* _UL_CAN_H_ */
