/*
 *  TOPPERS/OSEK COM
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK COM
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Witz Corporation, JAPAN
 *  Copyright (C) 2004-2007 by Tokai-Soft Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/* 																			*
 * ul_can_ext.c																*
 * bZ[W̕@\											*
 *  COMMbZ[W CANDriverMbZ[W()ϊ					*
 *  CANDriverMbZ[W COMMbZ[W()ϊ					*
 *																			*
 *				*				*				*				*			*
 *																			*
 *  ECANbZ[W̃tH[}bgéH									*
 *  E8Byte蒷COMbZ[W݂邩ۂH							*
 *  E݂ꍇA̕/̐ǂ̂悤ɕێ邩H			*
 *  ɂĂ {A													*
 *  gpCANDriver y ڋqdlɑ傫ˑ镔łB				*
 *  {W[ł́Ȁ̈̂ƂB						*
 *																			*
 *				*				*				*				*			*
 *																			*
 *  {W[ł́A														*
 *  CANMbZ[WDataField(8oCg)̃tH[}bgƂ				*
 *																			*
 *  1(for Pt[Message)F										*
 *    Data1`Data8(8byte):	f[^̈										*
 *																			*
 *  2(for t[Message)F										*
 *    Msg-ID(1byte):		/ 									*
 *							4bitEEEM							*
 *							4bitEEEpPbgԍ						*
 *    Data2`Data8(7byte):	f[^̈										*
 *																			*
 *  ȏ̂QނpӂA													*
 *  ǂ̏gp邩ɂĂ										*
 *  [UŎw(SGo)ACAN-IDMessageʏ					*
 *	ɏ]ƂƂB														*
 *																			*
 *																			*/

/*---------------------------------------------------------------------------*
 * inculde files
 *---------------------------------------------------------------------------*/
#include "com_cfg.h"
#include "osek_com.h"

/*---------------------------------------------------------------------------*
 * function prototype definition
 *---------------------------------------------------------------------------*/
UINT8 fget_snd_ul_canmessage_num( UINT8  canmsg_idx,
								  UINT8  dlc,
								  UINT8* div_num );
UINT8 fget_snd_ul_canmessage_once( const UINT8* pmsg_head,
								   const ULCANWorkInfo* snd_info, 
								   UINT8* pmsg_snd );
UINT8 fget_snd_ul_canmessage_div( const UINT8* pmsg_head,
								   ULCANWorkInfo* snd_info, 
								   UINT8* pmsg_snd );
UINT8 fget_rcv_ul_canmessage_num( UINT8  canmsg_idx,
								  const UINT8* pmsg,
								  UINT8* div_num );
UINT8 fget_rcv_ul_canmessage_once( const UINT8* pmsg_rcv,
							 	   const ULCANWorkInfo* rcv_info, 
							 	   UINT8* pmsg_head );
UINT8 fget_rcv_ul_canmessage_div( const UINT8* pmsg_rcv,
							 	   ULCANWorkInfo* rcv_info, 
							 	   UINT8* pmsg_head );

/*---------------------------------------------------------------------------*
 * variable
 *---------------------------------------------------------------------------*/
extern const UINT8 can_snd_msgkind[];	/* MMessageʏ	*/
extern const UINT8 can_rcv_msgkind[];	/* MMessageʏ	*/

/* CANhCof[^ */
static const UINT8 can_data_dlc_drv = (UINT8)CAN_DATA_DLC_DRV;

/* CAN_Ci~bNbZ[Wf[^ */
#define CAN_DATA_DLC_DYN (CAN_DATA_DLC_DRV-1)
static const UINT8 can_data_dlc_dyn = (UINT8)CAN_DATA_DLC_DYN;


/*---------------------------------------------------------------------------*
 * Constant definition
 *---------------------------------------------------------------------------*/
/*
 * 2 Msg-id }XN
 */
#define	UL_CAN_PNUM_MASK	((UINT8)0xf0) /* pPbg */
#define	UL_CAN_PNO_MASK		((UINT8)0x0f) /* pPbgԍ */

/*---------------------------------------------------------------------------*
 * function
 *---------------------------------------------------------------------------*/

/*--------------------------------------------------------------------
 *
 * Tv       FCANbZ[WM擾
 *            F
 * @\       FwCAN-ID̃bZ[WM擾
 *        F
 *   (in)     F<canmsg_idx>	MbZ[Wcan-idCfbNX
 *            F<dlc>			MbZ[WS(byte)
 *   (out)    F<*div_num>		MbZ[W̕	
 * ߂l     FUL_CAN_MSG_ONCE_FRAME	Pt[bZ[W
 *            FUL_CAN_MSG_DYNA			t[bZ[W
 *            F
 * l       Fdlc=0͍lĂȂ
 *------------------------------------------------------------------*/
UINT8
fget_snd_ul_canmessage_num( UINT8 canmsg_idx, UINT8 dlc, UINT8* div_num )
{
	*div_num = 0;
	
	/* PꑗM */
	if( UL_CAN_MSG_ONCE_FRAME == (can_snd_msgkind[canmsg_idx] & UL_CAN_MSG_ONCE_FRAME) ){
		*div_num = 1;
	}
	/* M */
	else if( UL_CAN_MSG_DIV_FRAME == (can_snd_msgkind[canmsg_idx] & UL_CAN_MSG_DIV_FRAME) ){
		if( 0 < dlc ){
			*div_num = dlc / (can_data_dlc_dyn);
			if( 0 < (dlc % (can_data_dlc_dyn)) ){
				(*div_num)++;
			}
		}
	}
	else {
	}
		
	return can_snd_msgkind[canmsg_idx];
}

/*--------------------------------------------------------------------
 *
 * Tv       FCANPꑗMbZ[W擾(1)
 *            F
 * @\       FMf[^A1CANMbZ[W쐬
 *        F
 *   (in)     F<*pmsg_head>	Mf[^̐擪AhX
 *   (in/out) F<*snd_info>		M
 *   (out)    F<*pmsg_snd>		CANMbZ[Wi[	
 * ߂l     FMsDLC
 *            F
 * l       F
 *------------------------------------------------------------------*/
UINT8
fget_snd_ul_canmessage_once( const UINT8* pmsg_head, const ULCANWorkInfo* snd_info, UINT8* pmsg_snd )
{
	UINT8  msg_cnt = 0;
	UINT8  msg_end;

	/* CANMbZ[Wփf[^Rs[ */

	/* Rs[f[^擾 */
	msg_end = snd_info->m_dlc_num;
	if( can_data_dlc_drv < msg_end ){
		/* MbZ[WTCYI[o[ */
		goto error_exit;
	}	
	
	/* f[^Rs[ */
	for( msg_cnt = 0; msg_cnt < msg_end; msg_cnt++ ){
		pmsg_snd[msg_cnt] = pmsg_head[msg_cnt];
	}
	
	exit:
	return msg_cnt;

	error_exit:
	goto exit;
}

/*--------------------------------------------------------------------
 *
 * Tv       FCANMbZ[W擾(2)
 *            F
 * @\       FMf[^A2CANMbZ[W쐬
 *        F
 *   (in)     F<*pmsg_head>	Mf[^̐擪AhX
 *   (in/out) F<*snd_info>		M
 *   (out)    F<*pmsg_snd>		CANMbZ[Wi[	
 * ߂l     FMsDLC
 *            F
 * l       F
 *------------------------------------------------------------------*/
UINT8
fget_snd_ul_canmessage_div( const UINT8* pmsg_head, ULCANWorkInfo* snd_info, UINT8* pmsg_snd )
{
	UINT8  msg_cnt = 0;
	UINT8  msg_end;
	UINT8  off_point;
	
	/* CANMbZ[W֐ݒ */
	pmsg_snd[0] = ( (((UINT8)(snd_info->m_div_num<<4))&UL_CAN_PNUM_MASK) | 
				    (((UINT8)(snd_info->m_div_cnt+1))&UL_CAN_PNO_MASK)   );

	/* CANMbZ[Wփf[^Rs[ */
    
	off_point = snd_info->m_off_point; /* f[^Rs[Jnʒu */
	
	/* Rs[f[^擾 */
	msg_end = snd_info->m_dlc_num - off_point;
	if( can_data_dlc_dyn < msg_end ){
		msg_end = can_data_dlc_dyn;
	}	
	
	/* f[^Rs[ */
	for( msg_cnt = 1; msg_cnt <= msg_end; msg_cnt++ ){
		pmsg_snd[msg_cnt] = pmsg_head[off_point];
		off_point++;
	}
    
	snd_info->m_off_point = off_point; /* Rs[Jnʒu */
	
	return msg_cnt;
}


/*--------------------------------------------------------------------
 *
 * Tv       FCANbZ[WM擾
 *            F
 * @\       FwCAN-ID̃bZ[WM擾
 *        F
 *   (in)     F<canmsg_idx>	MbZ[Wcan-idCfbNX
 *            F<*pmsg>			MbZ[W
 *   (out)    F<*div_num>		MbZ[W̕	
 * ߂l     FUL_CAN_MSG_ONCE_FRAME	Pt[bZ[W
 *            FUL_CAN_MSG_DYNA			t[bZ[W
 *            F
 * l       F
 *------------------------------------------------------------------*/
UINT8
fget_rcv_ul_canmessage_num( UINT8 canmsg_idx, const UINT8* pmsg, UINT8* div_num )
{
	*div_num = 0;
	
	/* PM */
	if( UL_CAN_MSG_ONCE_FRAME == (can_rcv_msgkind[canmsg_idx] & UL_CAN_MSG_ONCE_FRAME) ){
		*div_num = 1;
	}
	/* M */
	else if( UL_CAN_MSG_DIV_FRAME == (can_rcv_msgkind[canmsg_idx] & UL_CAN_MSG_DIV_FRAME) ){
		*div_num = ( ((UINT8)(pmsg[0]>>4))&UL_CAN_PNO_MASK );
	}
	else {
	}	

	return can_rcv_msgkind[canmsg_idx];
}
		
/*--------------------------------------------------------------------
 *
 * Tv       FCANPMbZ[W擾(1)
 *            F
 * @\       F1CANMbZ[WAMf[^𒊏o
 *        F
 *   (in)     F<*pmsg_head>	CANMbZ[W
 *   (in/out) F<*snd_info>		M
 *   (out)    F<*pmsg_snd>		Mf[^i[̐擪AhX	
 * ߂l     FMsDLC
 *            F
 * l       F
 *------------------------------------------------------------------*/
UINT8
fget_rcv_ul_canmessage_once( const UINT8* pmsg_rcv, const ULCANWorkInfo* rcv_info, UINT8* pmsg_head )
{
	UINT8  msg_cnt = 0;
	UINT8  msg_end;

	/* CANMbZ[Wf[^Rs[ */

	/* Rs[f[^擾 */
	msg_end = rcv_info->m_dlc;
	if( can_data_dlc_drv < msg_end ){
		msg_end = can_data_dlc_drv;
	}
	/* f[^Rs[ */
	for( msg_cnt = 0; msg_cnt < msg_end; msg_cnt++ ){
		pmsg_head[msg_cnt] = pmsg_rcv[msg_cnt];
	}

    return msg_cnt;
}

/*--------------------------------------------------------------------
 *
 * Tv       FCANMbZ[W擾(2)
 *            F
 * @\       F2CANMbZ[WAMf[^𒊏o
 *        F
 *   (in)     F<*pmsg_head>	CANMbZ[W
 *   (in/out) F<*snd_info>		M
 *   (out)    F<*pmsg_snd>		Mf[^i[̐擪AhX	
 * ߂l     FMsDLC
 *            F
 * l       F
 *------------------------------------------------------------------*/
UINT8
fget_rcv_ul_canmessage_div( const UINT8* pmsg_rcv, ULCANWorkInfo* rcv_info, UINT8* pmsg_head )
{
	
	UINT8  msg_cnt = 0;
	UINT8  div_cnt;
	UINT8  msg_end;
	UINT8  off_point;
	
	/* CANMbZ[W琧擾 */
	div_cnt = pmsg_rcv[0]&UL_CAN_PNO_MASK;
	
	/* pPbgԍ */
	if( div_cnt != ( rcv_info->m_div_cnt+1 ) ){
		goto error_exit;
	}

	/* CANMbZ[Wf[^Rs[ */

	off_point = rcv_info->m_off_point;	/* f[^Rs[Jnʒu */
	
	/* Rs[f[^擾 */
	msg_end = rcv_info->m_dlc;		
	if( can_data_dlc_dyn < msg_end ){
		msg_end = can_data_dlc_dyn;
	}
	
	/* f[^Rs[ */
	for( msg_cnt = 0; msg_cnt < msg_end; msg_cnt++ ){
		pmsg_head[off_point] = pmsg_rcv[msg_cnt+1];
		off_point++;
	}
	
	rcv_info->m_off_point = off_point;	/* Rs[Jnʒu */

	exit:
	return msg_cnt;

	error_exit:
	goto exit;
	
}

