/*
 *  TOPPERS/OSEK COM
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK COM
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *	^[Qbgˑ^C}W[(s810-clg3-85)
 */
#include	"osek_kernel.h"
#include	"sfrm32c85.h"

#include	"com_hw_timer.h"
#include	"com_timer.h"
#include	"can_cmn.h"
#include	"can_drv_def.h"
#if CAN_DRV_NM_RCV == CAN_TRUE
#include	"nm_timer.h"
#endif


#define TIMER_DWCOUNT ((UINT8)0xfd)

/*
 *  ^C}[݃nh
 */
ISR(COMAlarmTimer)
{
	(void)SignalTimeTick(COM_COUNTER_ID);	/* JE^Zʒm	*/
#if CAN_DRV_NM_RCV == CAN_TRUE
	(void)NMSignalTimeTick(NM_COUNTER_ID);	/* JE^Zʒm	*/
#endif
}

/*
 *  HW^C}̏iP߂̃eBbNpj
 */
void hw_com_timer_initialize(void)
{
	volatile UINT8	ui8;

	TA1S		= (UINT8)0;			/* ^C}JEg~				*/
	/* UDFmov߂Őݒ肷Kv
	 * (M32C/83O[vn[hEGA}jÃAbv_EtOɋLڂ)*/
	ui8			= UDF;
	ui8			= (UINT8)(ui8 & TIMER_DWCOUNT);
	UDF			= ui8;				/* _EJEg					*/
	TA1MR		= (UINT8)0;			/* ^C}[h, JEg\[Xf1/1	*/
	/*
	 *  WX^ݒl̓VXeNbNɑJEg
	 *  }CiX1.
	 */
	TA1			= TICKOBJ1_TIMER_CLOCK - (UINT16)1;

	/*  荞ݗD惌xݒ  */
	TA1IC		= (UINT8)CFG_INTLVL_TICKOBJ1;
	IR_TA1IC	= 0;				/* ݗvNA 				*/
	nop();
	nop();

	TA1S		= 1;				/* JEgJn 					*/

}

/*
 *  COM^C}~֐
 */
void hw_com_timer_terminate(void)
{
	TA1S = 0;						/* JEg~		*/
	TA1IC = (UINT8)0;				/* ݃}XN		*/
}

