/*
 *	TOPPERS/Non-OS CAN Middleware DRV
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		Non-OS CAN Middleware DRV
 * 
 *	Copyright (C) 2007 Sunny Giken Inc.
 * 
 *	L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *	ɂČ\Ă GNU General Public License  Version 2 ɋL
 *	qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *	ς̂܂ށDȉjgpEEρEĔzziȉC
 *	pƌĂԁj邱Ƃ𖳏ŋD
 *	(1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *		\C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *		XR[hɊ܂܂Ă邱ƁD
 *	(2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *		pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *		҃}jAȂǁjɁCL̒쌠\C̗pщL
 *		̖ۏ؋Kfڂ邱ƁD
 *	(3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *		płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *		ƁD
 *	  (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *		  쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *	  (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *		  񍐂邱ƁD
 *	(4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *		QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *	{\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *	TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *	܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *	ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */
/*
 *@Version 0.01  2007.04.04
 */

/*
 *	CMW-DRVW[
 */

/*---------------------------------------------------------------------------*/
/*	wb_t@C̃CN[h											 */
/*---------------------------------------------------------------------------*/
#include	"can_cmn.h" 			/* lbg[NOSpeݒt@C 	 */
#include	"can_drv_csw.h" 		/* DRV֘ARpCXCb`pt@C	 */
#include	"can_drv_def.h" 		/* DRV֘Aݒt@C					 */
#include	"can_drv_ext.h" 		/* DRVO[o`t@C			 */
#include	"can_drv_sfr.h" 		/* CAN SFR`t@C					 */
#include	"can_drv.h" 			/* DRV`t@C						 */

/*---------------------------------------------------------------------------*/
/*	DRV֐prototype錾											 */
/*---------------------------------------------------------------------------*/
static StatusType FncInitCAN( void );			 /* CAN֐					   */
static StatusType SetCANPortDRV(void) ; 		 /* CAN|[g̐ݒ֐ 			   */
static StatusType SetCANBaudRateDRV(void) ; 	 /* CAN{[[gݒ֐			   */
static StatusType SetMaskRegDRV(void) ; 		 /* }XNWX^̐ݒ֐		   */
static StatusType SetRcvSlotIDDRV(void);		 /* Xbg̐ݒ					   */
static StatusType SetCANIntRegDRV(void);		 /* G[WX^̐ݒ			   */
static StatusType SetCANOtherRegDRV(void);		 /* CANWX^̐ݒ				   */
static StatusType ClrSlotMsgRegDRV(void);		 /* CANXbg䃌WX^NA֐  */
static StatusType SetSlotMsgRegDRV( void ); 	 /* CANXbg䃌WX^ Mݒ */

/* f[^Rs[֐ */
#if CAN_DRV_RCVINT == CAN_TRUE
static void CANDataRd0DRV( UINT8 * );
#endif
#if CAN_DRV_POL_RCV == CAN_TRUE
static void CANDataRd1DRV( UINT8 * );
#endif
static void CANDataWr1DRV( const UINT8 * );

/*---------------------------------------------------------------------------*/
/*	^`																	 */
/*---------------------------------------------------------------------------*/
static union  CAN_DRV_Status	 CAN_DRV_STATUS_Flg ;			   /* NM,COMM֘AtO */
#define CAN_DRV_SndNMDataSts	CAN_DRV_STATUS_Flg.bit.SndCompNM   /* NMM		   */
#define CAN_DRV_SndCOMDataSts	CAN_DRV_STATUS_Flg.bit.SndCompCOM  /* COMM		   */
#define CAN_DRV_CANBusOffSts	CAN_DRV_STATUS_Flg.bit.BusOff	   /* CANoXIt		   */
#define CAN_DRV_InvalNMDataSts	CAN_DRV_STATUS_Flg.bit.InvalNM	   /* NMM			   */
#define CAN_DRV_InvalCOMDataSts CAN_DRV_STATUS_Flg.bit.InvalCOM    /* COMM 		   */


/*---------------------------------------------------------------------------*/
/*	֐																	 */
/*---------------------------------------------------------------------------*/
/*****************************************************************************/
/*	Function name : static StatusType FncInitCAN( void )					 */
/*---------------------------------------------------------------------------*/
/*	Description : CANRg[ݒ									 */
/*				  s^C~O:p[ON 								 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : CAN_E_OK	  : 										 */
/*				CAN_E_NG	  : ُ										 */
/*****************************************************************************/
static StatusType FncInitCAN( void )
{
	/* ----- ϐ ----- */
	UINT8  lp_cnt = (UINT8)CAN_CLR ;
	StatusType	m_sts = CAN_E_NG ;
	/* ----- ----- */
	CAN_DRV_STATUS_Flg.byte  = (UINT8)CAN_CLR;

	can_slpr.bit.sleep = CAN_ON ;
	can_ctlr0.word |= CAN_DRV_RESET;
	while((can_str.bit.state_reset == (UINT8)CAN_OFF) && (lp_cnt < WaitChgMsg))
	{
		lp_cnt++ ;
	}
	if(lp_cnt<WaitChgMsg)					   /* ^CAEgH		 */
	{
		m_sts = SetCANPortDRV();
		can_ctlr0.word = CAN_DRV_SET_MOD ;
		/* CAN䃌WX^W/R`FbN */
		if((can_ctlr0.word & CAN_DRV_SET_MOD_MASK )!=CAN_DRV_SET_MOD)  
		{
			m_sts = CAN_E_NG ;
		}
		if(m_sts == CAN_E_OK)
		{
			m_sts = SetCANBaudRateDRV();
		}
		if(m_sts == CAN_E_OK)
		{
			m_sts = SetMaskRegDRV();
		}
		if(m_sts == CAN_E_OK)
		{
			m_sts = SetRcvSlotIDDRV();
		}
		if(m_sts == CAN_E_OK)
		{
			m_sts = SetCANIntRegDRV();
		}
		if(m_sts == CAN_E_OK)
		{
			m_sts = SetCANOtherRegDRV();
		}
		
	}
	return	m_sts ;
}

/*****************************************************************************/
/*	Function name : static StatusType SetCANPortDRV(void)					 */
/*---------------------------------------------------------------------------*/
/*	Description : |[g̏											 */
/*				  s^C~O: FncInitCANR[						 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : CAN_E_OK	  : 										 */
/*				CAN_E_NG	  : ُ										 */
/*****************************************************************************/
static StatusType SetCANPortDRV(void)
{
	/* ----- ϐ ----- */
	StatusType m_sts = CAN_E_OK ;

#if CAN_CH == CAN_DRV_CH0
	#if CAN_PORT_IN == CAN_DRV_USE_P77		/* P77IĂꍇ */
		can_pd7.bit.b7 = CAN_OFF ;
		can_ps1.bit.b7 = CAN_OFF ;
		can_ips.bit.b3 = CAN_OFF ;
		/* Ǎ݃`FbN */
		if((can_ps1.bit.b7 == CAN_ON) || (can_ips.bit.b3 == CAN_ON) \
		 || (can_pd7.bit.b7 == CAN_ON ))
		{
			m_sts = CAN_E_NG ;
		}
	#elif CAN_PORT_IN == CAN_DRV_USE_P83	/* P83IĂꍇ */
		can_pd8.bit.b3 = CAN_OFF ;
		can_ips.bit.b3 = CAN_ON ;
		/* Ǎ݃`FbN */
		if((can_ips.bit.b3 == CAN_OFF) || (can_pd8.bit.b3 == CAN_ON))
		{
			m_sts = CAN_E_NG ;
		}
	#else
		/* P77/P83ȊOI(Ȃ) */
	#endif
	#if CAN_PORT_OUT == CAN_DRV_USE_P76 	/* P76IĂꍇ */
		can_p7.bit.b6 = CAN_ON ;
		can_pd7.bit.b6 = CAN_ON ;
		can_psc.bit.b6 = CAN_ON ;
		can_psl1.bit.b6 = CAN_OFF ;
		can_ps1.bit.b6 = CAN_ON ;
		/* Ǎ݃`FbN */
		if(( can_p7.bit.b6 == CAN_OFF ) || ( can_pd7.bit.b6 == CAN_OFF ) \
		 || ( can_ps1.bit.b6 == CAN_OFF ) || ( can_psl1.bit.b6 == CAN_ON ) \
		 || ( can_psc.bit.b6 == CAN_OFF ))
		{
			m_sts = CAN_E_NG ;
		}
	#elif CAN_PORT_OUT == CAN_DRV_USE_P82	/* P82IĂꍇ */
		can_p8.bit.b2 = CAN_ON ;
		can_pd8.bit.b2 = CAN_ON ;
		can_psc2.bit.b2 = CAN_OFF ;
		can_psl2.bit.b2 = CAN_ON ;
		can_ps2.bit.b2 = CAN_ON ;
		/* Ǎ݃`FbN */
		if(( can_p8.bit.b2 == CAN_OFF ) || ( can_pd8.bit.b2 == CAN_OFF ) \
		 || ( can_ps2.bit.b2 == CAN_OFF ) || ( can_psl2.bit.b2 == CAN_OFF ) \
		 || ( can_psc2.bit.b2 == CAN_ON ))
		{
			m_sts = CAN_E_NG ;
		}
	#else
		/* P76/P82ȊOI(Ȃ) */
	#endif

#elif CAN_CH == CAN_DRV_CH1
	#if CAN_PORT_IN == CAN_DRV_USE_P83		/* P83IĂꍇ */
		can_pd8.bit.b3 = CAN_OFF ;
		can_ipsa.bit.b3 = CAN_ON ;
		/* Ǎ݃`FbN */
		if((can_ipsa.bit.b3 == CAN_OFF) || (can_pd8.bit.b3 == CAN_ON))
		{
			m_sts = CAN_E_NG ;
		}
	#elif CAN_PORT_IN == CAN_DRV_USE_P95	/* P95IĂꍇ */
		can_prcr.bit.prc2 = CAN_ON ;
		can_pd9.bit.b5 = CAN_OFF ;
		can_psl3.bit.b5 = CAN_OFF ;
		can_prcr.bit.prc2 = CAN_ON ;
		can_ps3.bit.b5 = CAN_OFF ;
		can_ipsa.bit.b3 = CAN_OFF ;
		/* Ǎ݃`FbN */
		if((can_ps3.bit.b5 == CAN_ON) || (can_psl3.bit.b5 == CAN_ON) \
		 || (can_ipsa.bit.b3 == CAN_ON ) || (can_pd9.bit.b5 == CAN_ON ) )
		{
			m_sts = CAN_E_NG ;
		}
	#else
		/* P83/P95ȊOI(Ȃ) */
	#endif

	#if CAN_PORT_OUT == CAN_DRV_USE_P82 	/* P82IĂꍇ */
		can_p8.bit.b2 = CAN_ON ;
		can_pd8.bit.b2 = CAN_ON ;
		can_psc2.bit.b2 = CAN_ON ;
		can_psl2.bit.b2 = CAN_ON ;
		can_ps2.bit.b2 = CAN_ON ;
		/* Ǎ݃`FbN */
		if(( can_p8.bit.b2 == CAN_OFF ) || ( can_pd8.bit.b2 == CAN_OFF ) \
		 || ( can_ps2.bit.b2 == CAN_OFF ) || ( can_psl2.bit.b2 == CAN_OFF ) \
		 || ( can_psc2.bit.b2 == CAN_OFF ))
		{
			m_sts = CAN_E_NG ;
		}
	#elif CAN_PORT_OUT == CAN_DRV_USE_P96	/* P96IĂꍇ */
		can_p9.bit.b6 = CAN_ON ;
		can_prcr.bit.prc2 = CAN_ON ;
		can_pd9.bit.b6 = CAN_ON ;
		can_psc3.bit.b6 = CAN_ON ;
		can_prcr.bit.prc2 = CAN_ON ;
		can_ps3.bit.b6 = CAN_ON ;
		/* Ǎ݃`FbN */
		if(( can_p9.bit.b6 == CAN_OFF ) || ( can_pd9.bit.b6 == CAN_OFF ) \
		 || ( can_ps3.bit.b6 == CAN_OFF ) || ( can_psc3.bit.b6 == CAN_OFF ) )
		{
			m_sts = CAN_E_NG ;
		}
	#else
		/* P82/P96ȊOI(Ȃ) */
	#endif

#else
	/* CH0/CH1ȊOI(Ȃ) */
#endif

	return m_sts;
}

/*****************************************************************************/
/*	Function name : static StatusType  SetCANBaudRateDRV(void)				 */
/*---------------------------------------------------------------------------*/
/*	Description :  ݒ֐Ăяo									 */
/*				   s^C~O: FncInitCANR[{[[g̐ݒ肪 	 */
/*				   250Kbpsł500Kbpsłꍇ͉ݒ肵܂ 		 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : CAN_E_OK	  : 										 */
/*				CAN_E_NG	  : ُ										 */
/*****************************************************************************/
static StatusType  SetCANBaudRateDRV(void)
{
	/* ----- ϐ ----- */
	StatusType m_sts = CAN_E_OK ;
	/* -----  ----- */
	can_conr.word = CAN_CONR_MAT ;
	can_brp.byte = CAN_BRP;
	/* CANoX^C~O䃌WX^`FbN */
	if( (can_conr.word != CAN_CONR_MAT) || (can_brp.byte != CAN_BRP) )
	{
		m_sts = CAN_E_NG ;
	}
	return	m_sts ;
}

/*****************************************************************************/
/*	Function name : static StatusType  SetMaskRegDRV( void )				 */
/*---------------------------------------------------------------------------*/
/*	Description :  Xbg̐ݒ											 */
/*				   s^C~O: FncInitCANR[						 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : CAN_E_OK	  : 										 */
/*				CAN_E_NG	  : ُ										 */
/*****************************************************************************/
static StatusType  SetMaskRegDRV( void )
{
	/* ----- ϐ ----- */
	UINT8  lp_cnt ;
	StatusType m_sts = CAN_E_OK ;
	/* ----- ----- */
	can_ctlr1.bit.banksel = CAN_ON;

	/* O[o}XN */
	can_gmr.byte.sidh = (UINT8)((CAN_SLOTMASK_TABLE[0] >> CAN_DRV_SIDH_SIFT) & CAN_DRV_SIDH_MASK);
	can_gmr.byte.sidl = (UINT8)(CAN_SLOTMASK_TABLE[0] & CAN_DRV_SIDL_MASK);
	if( (can_gmr.byte.sidh 
		!= (UINT8)((CAN_SLOTMASK_TABLE[0] >> CAN_DRV_SIDH_SIFT) & CAN_DRV_SIDH_MASK))
	  ||(can_gmr.byte.sidl != (UINT8)(CAN_SLOTMASK_TABLE[0] & CAN_DRV_SIDL_MASK))
	)
	{
		m_sts = CAN_E_NG;
	}
	/* [J}XNA */
	can_lmar.byte.sidh = (UINT8)((CAN_SLOTMASK_TABLE[1] >> CAN_DRV_SIDH_SIFT) & CAN_DRV_SIDH_MASK);
	can_lmar.byte.sidl = (UINT8)(CAN_SLOTMASK_TABLE[1] & CAN_DRV_SIDL_MASK);
	if( (can_lmar.byte.sidh 
		!= (UINT8)((CAN_SLOTMASK_TABLE[1] >> CAN_DRV_SIDH_SIFT) & CAN_DRV_SIDH_MASK))
	  ||(can_lmar.byte.sidl != (UINT8)(CAN_SLOTMASK_TABLE[1] & CAN_DRV_SIDL_MASK))
	)
	{
		m_sts = CAN_E_NG;
	}
	/* [J}XNB */
	can_lmbr.byte.sidh = (UINT8)((CAN_SLOTMASK_TABLE[2] >> CAN_DRV_SIDH_SIFT) & CAN_DRV_SIDH_MASK);
	can_lmbr.byte.sidl = (UINT8)(CAN_SLOTMASK_TABLE[2] & CAN_DRV_SIDL_MASK);
	if( (can_lmbr.byte.sidh 
		!= (UINT8)((CAN_SLOTMASK_TABLE[2] >> CAN_DRV_SIDH_SIFT) & CAN_DRV_SIDH_MASK))
	  ||(can_lmbr.byte.sidl != (UINT8)(CAN_SLOTMASK_TABLE[2] & CAN_DRV_SIDL_MASK))
	)
	{
		m_sts = CAN_E_NG;
	}
	
	can_ctlr1.bit.banksel = CAN_OFF;
	
	return	m_sts ;
}

/*****************************************************************************/
/*	Function name : static StatusType SetRcvSlotIDDRV( void )				 */
/*---------------------------------------------------------------------------*/
/*	Description :  Xbg̐ݒ											 */
/*				   s^C~O: 샂[hڍs 						 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : CAN_E_OK	  : 										 */
/*				CAN_E_NG	  : ُ										 */
/*****************************************************************************/
static StatusType SetRcvSlotIDDRV( void )
{
	/* ----- ϐ ----- */
	UINT8  lp_cnt ; 								   /* [vJE^ */
	UINT8  m_buff = (UINT8)CAN_CLR ;				   /* IDێobt@ */
	StatusType m_sts = CAN_E_OK ;
	/* ----- ----- */
	/* CAN SLOTől܂ŌJԂ */
	for(lp_cnt=(UINT8)CAN_CLR ; (lp_cnt<CAN_DRV_MAX_SLOTNUM)&&(m_sts == CAN_E_OK) ; lp_cnt++)
	{
		m_buff = (UINT8)((CAN_SLOTID_TABLE[lp_cnt] >> CAN_DRV_SIDH_SIFT) & CAN_DRV_SIDH_MASK) ;
		can_sbs.bit.sbs0 = lp_cnt;
		can_slot_buf0.byte.sidh = m_buff ;
		/* Ǎ݃`FbN */
		if( can_slot_buf0.byte.sidh != m_buff )
		{
			m_sts = CAN_E_NG ;
		}
		m_buff = (UINT8)( CAN_SLOTID_TABLE[lp_cnt] & CAN_DRV_SIDL_MASK ) ;
		can_slot_buf0.byte.sidl = m_buff ;
		if( can_slot_buf0.byte.sidl != m_buff )
		{
			m_sts = CAN_E_NG ;
		}
	}
	return	m_sts ;
}

/*****************************************************************************/
/*	Function name : static StatusType SetCANIntRegDRV( void )				 */
/*---------------------------------------------------------------------------*/
/*	Description :  荞݃WX^̐ݒ									 */
/*				   s^C~O: 샂[hڍs 						 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : CAN_E_OK	  : 										 */
/*				CAN_E_NG	  : ُ										 */
/*****************************************************************************/
static StatusType SetCANIntRegDRV( void )
{

	/* ----- ϐ ----- */
	StatusType m_sts = CAN_E_OK ;

	can_ctlr1.bit.intsel = CAN_ON;
	can_eimkr.byte = CAN_DRV_ERRINT;

	/* n[hEFA`FbN */
	if( ( can_ctlr1.bit.intsel != CAN_ON ) \
	 || ( (can_eimkr.byte & CAN_DRV_EIMKRMASK) != CAN_DRV_ERRINT ) )
	{
		m_sts = CAN_E_NG ;
	}

	return	m_sts ;
}

/*****************************************************************************/
/*	Function name : static StatusType SetCANOtherRegDRV( void ) 			 */
/*---------------------------------------------------------------------------*/
/*	Description :  CANWX^̐ݒ										 */
/*				   s^C~O: 샂[hڍs 						 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : CAN_E_OK	  : 										 */
/*				CAN_E_NG	  : ُ										 */
/*****************************************************************************/
static StatusType SetCANOtherRegDRV( void )
{
	/* ----- ϐ ----- */
	StatusType m_sts = CAN_E_OK ;

	/* ----- ----- */
	can_idr.word = (UINT16)CAN_CLR;
	can_mdr.byte = (UINT8)CAN_CLR;

	/* n[hEFA`FbN */
	if( (can_idr.word != (UINT16)CAN_CLR) 
		|| ( (can_mdr.byte & CAN_DRV_MDR_MASK ) != (UINT8)CAN_CLR) )
	{
		m_sts = CAN_E_NG;
	}

	return m_sts;

}

/*****************************************************************************/
/*	Function name : static StatusType ClrSlotMsgRegDRV( void )				 */
/*---------------------------------------------------------------------------*/
/*	Description :  bZ[W䃌WX^ NA							 */
/*				   s^C~O: Run->Config/SleepڍsɃR[			 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : CAN_E_OK	  : 										 */
/*				CAN_E_NG	  : ُ										 */
/*****************************************************************************/
static StatusType ClrSlotMsgRegDRV( void )
{
	/* ----- ϐ ----- */
	StatusType m_sts = CAN_E_OK ;
	UINT16	lp_cnt ;
	UINT16	lp_frame ;
	/* ----- ----- */
	can_ctlr1.bit.banksel = CAN_OFF;

	can_mctl[0].byte = (UINT8)CAN_CLR;
	can_mctl[1].byte = (UINT8)CAN_CLR;
	can_mctl[2].byte = (UINT8)CAN_CLR;
	can_mctl[3].byte = (UINT8)CAN_CLR;
	can_mctl[4].byte = (UINT8)CAN_CLR;
	can_mctl[5].byte = (UINT8)CAN_CLR;
	can_mctl[6].byte = (UINT8)CAN_CLR;
	can_mctl[7].byte = (UINT8)CAN_CLR;
	can_mctl[8].byte = (UINT8)CAN_CLR;
	can_mctl[9].byte = (UINT8)CAN_CLR;
	can_mctl[10].byte = (UINT8)CAN_CLR;
	can_mctl[11].byte = (UINT8)CAN_CLR;
	can_mctl[12].byte = (UINT8)CAN_CLR;
	can_mctl[13].byte = (UINT8)CAN_CLR;
	can_mctl[14].byte = (UINT8)CAN_CLR;
	can_mctl[15].byte = (UINT8)CAN_CLR;

	/* A{[g */
	/* "00h"łȂ΃NA{ */
	for(lp_cnt=(UINT16)CAN_CLR ; lp_cnt<CAN_DRV_MAX_SLOTNUM ; lp_cnt++)
	{
		lp_frame = (UINT16)CAN_CLR;
		while( (can_mctl[lp_cnt].byte!=(UINT8)CAN_CLR) && (lp_frame<WaitFrameEnd) ) 
		{
			can_mctl[lp_cnt].byte = (UINT8)CAN_CLR;
			lp_frame++;
		}
	}

	return m_sts;

}

/*****************************************************************************/
/*	Function name :static StatusType  SetSlotMsgRegDRV( void )				 */
/*---------------------------------------------------------------------------*/
/*	Description :  CANRg[샂[hύX							 */
/*				   s^C~O: C 									 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : CAN_E_OK	  : 										 */
/*				CAN_E_NG	  : ُ										 */
/*****************************************************************************/
static StatusType  SetSlotMsgRegDRV( void )
{
	/* ----- ϐ ----- */
	UINT8  lp_cnt ; 				   /* [vJE^					 */
	StatusType m_sts = CAN_E_OK ;
	/* ----- ----- */

	can_ctlr1.bit.banksel = CAN_OFF;
	can_ssctlr.word = (UINT16)CAN_CLR;
	/* CAN SLOTől܂ŌJԂ */
	for(lp_cnt=(UINT8)CAN_CLR ; lp_cnt<CAN_DRV_MAX_SLOTNUM ; lp_cnt++)
	{
		/* NMMpXbg COMMpXbgReserv */
		if( (lp_cnt == CAN_DRV_NMSND_SLOT_NUM)
		 || (lp_cnt == CAN_DRV_COMSND_SLOT_NUM)
		 || (lp_cnt == CAN_DRV_RESERV_SLOT_NUM) )
		{
			can_mctl[lp_cnt].byte = (UINT8)CAN_CLR ;
		}
		else
		{
			/* XbgɐݒlL */
			if(CAN_SLOTID_TABLE[lp_cnt] != CAN_DRV_NO_USE)
			{
#if CAN_DRV_RCVINT == CAN_TRUE
				/* NMpMSLOT̏ꍇ */
				if( (lp_cnt==CAN_DRV_SLOT14) || (lp_cnt==CAN_DRV_SLOT15) )
				{
					can_simkr.word =(can_simkr.word | (CAN_DRV_INTMASK>>lp_cnt));
				}
#endif
				can_mctl[lp_cnt].byte = CAN_DRV_SET_RCV ;
			}/* (CAN_EN_SLOT[lp_cnt]==CAN_TRUE) */
			else
			{
				can_mctl[lp_cnt].byte = (UINT8)CAN_CLR ;
			}
		}
	}/* for END */
	
	return	m_sts ;
}

/*****************************************************************************/
/*	Function name :static void CANDataRd0DRV( UINT8 *dst_ptr )				 */
/*---------------------------------------------------------------------------*/
/*	Description :  Xbgobt@0]AhXɃRs[(qȂ)	 */
/*				   s^C~O: C 									 */
/*---------------------------------------------------------------------------*/
/*	parameter : UINT8: *dst_ptr : ]|C^l							 */
/*	result	  : none														 */
/*****************************************************************************/
#if CAN_DRV_RCVINT == CAN_TRUE
static void CANDataRd0DRV( UINT8 *dst_ptr )
{

	/* ----- ----- */
	dst_ptr[0] = can_slot_buf0.byte.data[0];
	dst_ptr[1] = can_slot_buf0.byte.data[1];
	dst_ptr[2] = can_slot_buf0.byte.data[2];
	dst_ptr[3] = can_slot_buf0.byte.data[3];
	dst_ptr[4] = can_slot_buf0.byte.data[4];
	dst_ptr[5] = can_slot_buf0.byte.data[5];
	dst_ptr[6] = can_slot_buf0.byte.data[6];
	dst_ptr[7] = can_slot_buf0.byte.data[7];
}
#endif

/*****************************************************************************/
/*	Function name :static void CANDataRd1DRV( UINT8 *dst_ptr )				 */
/*---------------------------------------------------------------------------*/
/*	Description :  Xbgobt@1]AhXɃRs[(qȂ)	 */
/*				   s^C~O: C 									 */
/*---------------------------------------------------------------------------*/
/*	parameter : UINT8: *dst_ptr : ]|C^l							 */
/*	result	  : none														 */
/*****************************************************************************/
#if CAN_DRV_POL_RCV == CAN_TRUE
static void CANDataRd1DRV( UINT8 *dst_ptr )
{

	/* ----- ----- */
	dst_ptr[0] = can_slot_buf1.byte.data[0];
	dst_ptr[1] = can_slot_buf1.byte.data[1];
	dst_ptr[2] = can_slot_buf1.byte.data[2];
	dst_ptr[3] = can_slot_buf1.byte.data[3];
	dst_ptr[4] = can_slot_buf1.byte.data[4];
	dst_ptr[5] = can_slot_buf1.byte.data[5];
	dst_ptr[6] = can_slot_buf1.byte.data[6];
	dst_ptr[7] = can_slot_buf1.byte.data[7];
}
#endif

/*****************************************************************************/
/*	Function name :static void CANDataWr1DRV( const UINT8 *src_ptr )		 */
/*---------------------------------------------------------------------------*/
/*	Description :  ]AhXXbgobt@1ɃRs[(qȂ)	 */
/*				   s^C~O: C 									 */
/*---------------------------------------------------------------------------*/
/*	parameter : UINT8 : *src_ptr : ]|C^l 						 */
/*	result	  : none														 */
/*****************************************************************************/
static void CANDataWr1DRV( const UINT8 *src_ptr )
{
	/* ----- ----- */
	can_slot_buf1.byte.data[0] = src_ptr[0];
	can_slot_buf1.byte.data[1] = src_ptr[1];
	can_slot_buf1.byte.data[2] = src_ptr[2];
	can_slot_buf1.byte.data[3] = src_ptr[3];
	can_slot_buf1.byte.data[4] = src_ptr[4];
	can_slot_buf1.byte.data[5] = src_ptr[5];
	can_slot_buf1.byte.data[6] = src_ptr[6];
	can_slot_buf1.byte.data[7] = src_ptr[7];
}

/*****************************************************************************/
/*	Function name : StatusType FncRdCOMMsgDRV								 */
/*					( UINT32 *can_id, UINT8 *dlc, UINT8 *buff ) 			 */
/*---------------------------------------------------------------------------*/
/*	Description :  Mf[^̈n									 */
/*				   s^C~O: C 									 */
/*				   ӎ :|[Ogp݂̂ɗp\B				 */
/*							ƂĂ͔Cӂ̃^C~OŎMf[^		 */
/*							oB							 */
/*							DLC0gǉB								 */
/*---------------------------------------------------------------------------*/
/*	parameter :UINT32: CAN-IDւ̃|C^									 */
/*			   UINT8 : DLCւ̃|C^										 */
/*			   UINT8 : |C^ϐ(f[^̊i[AhX)					 */
/*	result	  :  CAN_E_OK	   : n 								 */
/*				 CAN_E_NG	   : MbZ[WȂ 						 */
/*****************************************************************************/
#if CAN_DRV_POL_RCV == CAN_TRUE    /* |[OgpɗL */
StatusType FncRdCOMMsgDRV( UINT32 *can_id, UINT8 *dlc, UINT8 *buff )
{
	/* ----- ϐ ----- */
	StatusType	m_sts = CAN_E_NG ;
	UINT8  lp_cnt = (UINT8)CAN_CLR	;
	UINT8  m_work = (UINT8)CAN_CLR	;
	UINT8  lp_wait ;
	
	/* ----- ----- */
	/* Xbg and Slot͋ */
	can_ctlr1.bit.banksel = CAN_OFF;
	while( (lp_cnt < CAN_DRV_RCVSLOT_MAX) && (m_sts == CAN_E_NG) )
	{
		/* MXbgݒ and Mf[^ */
		if( (can_mctl[lp_cnt].rec.recreq==CAN_ON)  \
		 && (can_mctl[lp_cnt].rec.newdata==CAN_ON) )
		{
			/* dM̍ēǏoK[h */
			m_work = CAN_OFF ;
			while( m_work == CAN_OFF )
			{
				/* SRAMւ̓]҂ */
				for( lp_wait=(UINT8)CAN_CLR ;
					(can_mctl[lp_cnt].rec.invaldata==CAN_ON) && (lp_wait<WaitCANClk) ;lp_wait++ )
				{
					/* 󏈗wait */
				}
				can_mctl[lp_cnt].rec.newdata = CAN_OFF ;
				can_mctl[lp_cnt].rec.msglost = CAN_OFF ;
				can_sbs.bit.sbs1 = lp_cnt;
				*can_id = (UINT32)( ((UINT16)(can_slot_buf1.byte.sidh) << CAN_DRV_SIDH_SIFT)  \
						  | ((UINT16)(can_slot_buf1.byte.sidl) & CAN_DRV_SIDL_MASK) )	;
				*dlc = can_slot_buf1.byte.dlc ;
				CANDataRd1DRV(buff);
				/* dM̊mF */
				if(can_mctl[lp_cnt].rec.newdata==CAN_OFF)
				{
					m_sts = CAN_E_OK ;
					m_work = CAN_ON ;
				}

			}/* dM̍ēǏoK[h */
		}/* MXbgݒ and Mf[^ */
		/* Mf[^Ȃ */
		else
		{
			lp_cnt++ ;
		}
	}/* Xbg and Slot͋ */

	return m_sts ;

}
#endif	  /* |[OgpɗL */

/*****************************************************************************/
/*	Function name : StatusType FncWrNMMsgDRV								 */
/*					( UINT32 can_id, UINT8 dlc, const UINT8 *buff ) 		 */
/*---------------------------------------------------------------------------*/
/*	Description :  NM֑Mf[^̎󂯓n 								 */
/*				   s^C~O: C 									 */
/*---------------------------------------------------------------------------*/
/*	parameter : UINT32 can_id : CAN-ID										 */
/*				UINT8  dlc	  : DLC 										 */
/*				UINT8 *buff   : f[^i[AhX						 */
/*	result	  : CAN_E_OK	  : f[^̎󂯓n						 */
/*				CAN_E_NG	  : s										 */
/*****************************************************************************/
#if CAN_DRV_NM_SND == CAN_TRUE
StatusType FncWrNMMsgDRV( UINT32 can_id, UINT8 dlc, const UINT8 *buff )
{
	/* ----- ϐ ----- */
	StatusType	m_sts = CAN_E_NG ;
	/* ----- ----- */
	if ( (can_id <= CAN_SID_MAX) && (dlc <= CAN_DRV_DLC_MAX) )
	{
		can_ctlr1.bit.banksel = CAN_OFF;
		if(CAN_DRV_InvalNMDataSts==CAN_OFF)
		{
			can_mctl[CAN_DRV_NMSLOT].byte=(UINT8)CAN_CLR ;
			can_sbs.bit.sbs1 = CAN_DRV_NMSLOT;
			can_slot_buf1.byte.sidh = (UINT8)(can_id >> CAN_DRV_SIDH_SIFT);
			can_slot_buf1.byte.sidl = (UINT8)(can_id & CAN_DRV_SIDL_MASK);
			can_slot_buf1.byte.dlc = dlc;
			CANDataWr1DRV(buff);
			CAN_DRV_InvalNMDataSts = CAN_ON ;
			CAN_DRV_SndNMDataSts = CAN_OFF ;
			
			can_simkr.bit.slot11_simkr = CAN_ON ;
			can_mctl[CAN_DRV_NMSLOT].byte =CAN_DRV_SET_TRM ;
			m_sts = CAN_E_OK;
		}
	}
	return	m_sts ;
}
#endif

/*****************************************************************************/
/*	Function name : StatusType FncWrCOMMsgDRV								 */
/*					( UINT32 can_id, UINT8 dlc, const UINT8 *buff ) 		 */
/*---------------------------------------------------------------------------*/
/*	Description :  COM֑Mf[^̎󂯓n								 */
/*				   s^C~O: C 									 */
/*---------------------------------------------------------------------------*/
/*	parameter : UINT32 can_id : CAN-ID										 */
/*				UINT8  dlc	  : DLC 										 */
/*				UINT8 *buff   : f[^i[AhX						 */
/*	result	  : CAN_E_OK	  : f[^̎󂯓n						 */
/*				CAN_E_NG	  : s										 */
/*****************************************************************************/
#if CAN_DRV_COM_SND == CAN_TRUE
StatusType FncWrCOMMsgDRV( UINT32 can_id, UINT8 dlc, const UINT8 *buff )
{
	/* ----- ϐ ----- */
	StatusType	m_sts = CAN_E_NG ;
	/* ----- ----- */
	if ( (can_id <= CAN_SID_MAX) && (dlc <= CAN_DRV_DLC_MAX) )
	{
		can_ctlr1.bit.banksel = CAN_OFF;
		if(CAN_DRV_InvalCOMDataSts == CAN_OFF)
		{
			can_mctl[CAN_DRV_COMSLOT].byte = (UINT8)CAN_CLR ;
			can_sbs.bit.sbs1 = CAN_DRV_COMSLOT;
			can_slot_buf1.byte.sidh = (UINT8)(can_id >> CAN_DRV_SIDH_SIFT);
			can_slot_buf1.byte.sidl = (UINT8)(can_id & CAN_DRV_SIDL_MASK);
			can_slot_buf1.byte.dlc = dlc;
			CANDataWr1DRV(buff);
			CAN_DRV_InvalCOMDataSts = CAN_ON ;
			CAN_DRV_SndCOMDataSts	= CAN_OFF ;
			
			can_simkr.bit.slot12_simkr = CAN_ON ;
			can_mctl[CAN_DRV_COMSLOT].byte =CAN_DRV_SET_TRM ;
			m_sts =CAN_E_OK;
		}
	}
	return	m_sts ;
}
#endif

/*****************************************************************************/
/*	Function name : void FncGetBusoffStsDRV(UINT8 * m_out_sts)				 */
/*---------------------------------------------------------------------------*/
/*	Description :  CANoXItXe[^Xn								 */
/*				   s^C~O: C 									 */
/*---------------------------------------------------------------------------*/
/*	parameter : UINT8 : oXItʒm										 */
/*						CAN_DRV_NORMAL : oXIto 					 */
/*						CAN_DRV_BUSOFF : oXIto						 */
/*	result	  : none														 */
/*****************************************************************************/
void FncGetBusoffStsDRV(UINT8 * m_out_sts)
{
	/* ----- ----- */
	if(CAN_DRV_CANBusOffSts == CAN_ON)
	{
		*m_out_sts = CAN_DRV_BUSOFF ;
	}
	else
	{
		*m_out_sts = CAN_DRV_NORMAL ;
	}
}

/*****************************************************************************/
/*	Function name :void FncGetNMSndStsDRV( UINT8 *sts ) 					 */
/*---------------------------------------------------------------------------*/
/*	Description :  NMMXe[^Xp֐									 */
/*				   s^C~O: C 									 */
/*---------------------------------------------------------------------------*/
/*	parameter : UINT8 * : Mʒmi[ϐւ̃|C^(Output)			 */
/*						 CAN_DRV_EMPTY	: M						 */
/*						 CAN_DRV_WAIT	: M							 */
/*						 CAN_DRV_COMP	: M							 */
/*	result	  : none														 */
/*****************************************************************************/
#if CAN_DRV_NM_SND == CAN_TRUE
void FncGetNMSndStsDRV( UINT8 *sts )
{
	/* ----- ϐ ----- */
	union  CAN_DRV_Status m_sts;
	/* ----- ----- */
	m_sts.byte = CAN_DRV_STATUS_Flg.byte;
	/* NMf[^M */
	if(m_sts.bit.InvalNM == CAN_ON)
	{
		*sts = CAN_DRV_WAIT;
	}
	else
	{
		/* NMf[^M */
		if(m_sts.bit.SndCompNM == CAN_ON)
		{
			*sts = CAN_DRV_COMP ;
		}
		/* NMM */
		else
		{
			*sts = CAN_DRV_EMPTY ;
		}
	}
}
#endif

/*****************************************************************************/
/*	Function name :void FncGetCOMSndStsDRV( UINT8 *sts )					 */
/*---------------------------------------------------------------------------*/
/*	Description :  COMMXe[^Xp֐									 */
/*				   s^C~O: C 									 */
/*---------------------------------------------------------------------------*/
/*	parameter : UINT8 * : Mʒmi[ϐւ̃|C^(Output)			 */
/*						 CAN_DRV_EMPTY	: M						 */
/*						 CAN_DRV_WAIT	: M							 */
/*						 CAN_DRV_COMP	: M							 */
/*	result	  : none														 */
/*****************************************************************************/
#if CAN_DRV_COM_SND == CAN_TRUE
void FncGetCOMSndStsDRV( UINT8 *sts )
{
	/* ----- ϐ ----- */
	union  CAN_DRV_Status m_sts;
	/* ----- ----- */
	m_sts.byte = CAN_DRV_STATUS_Flg.byte;
	/* COMf[^M */
	if(m_sts.bit.InvalCOM == CAN_ON)
	{
		*sts = CAN_DRV_WAIT;
	}
	else
	{
		/* COMf[^M */
		if(m_sts.bit.SndCompCOM == CAN_ON)
		{
			*sts = CAN_DRV_COMP ;
		}
		/* COMM */
		else
		{
			*sts = CAN_DRV_EMPTY ;
		}
	}
}
#endif

/*****************************************************************************/
/*	Function name :void FncAbtNMSndMsgDRV(void) 							 */
/*---------------------------------------------------------------------------*/
/*	Description :  NMMt[~ 								 */
/*				   s^C~O:	C									 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : none														 */
/*****************************************************************************/
#if CAN_DRV_NM_SND == CAN_TRUE
void FncAbtNMSndMsgDRV(void)
{
	/* ----- ----- */
	can_simkr.bit.slot11_simkr = CAN_OFF ;
	can_ctlr1.bit.banksel = CAN_OFF;
	can_mctl[CAN_DRV_NMSLOT].byte = (UINT8)CAN_CLR ;
	CAN_DRV_InvalNMDataSts = CAN_OFF ;
	CAN_DRV_SndNMDataSts   = CAN_OFF ;
	
}
#endif

/*****************************************************************************/
/*	Function name :void FncAbtCOMSndMsgDRV( void )							 */
/*---------------------------------------------------------------------------*/
/*	Description :  COMMt[~								 */
/*				   s^C~O:	C									 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : none														 */
/*****************************************************************************/
#if CAN_DRV_COM_SND == CAN_TRUE
void FncAbtCOMSndMsgDRV( void )
{
	/* ----- ----- */
	can_simkr.bit.slot12_simkr	   = CAN_OFF;
	can_ctlr1.bit.banksel = CAN_OFF;
	can_mctl[CAN_DRV_COMSLOT].byte = (UINT8)CAN_CLR;
	CAN_DRV_InvalCOMDataSts 	   = CAN_OFF;
	CAN_DRV_SndCOMDataSts		   = CAN_OFF;
}
#endif

/*****************************************************************************/
/*	Function name :void FncAbtAllSndMsgDRV( void )							 */
/*---------------------------------------------------------------------------*/
/*	Description :  NM,COM̑Mt[~							 */
/*				   s^C~O:	NMTwbsLimpHomeԈڍs				 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : none														 */
/*****************************************************************************/
#if (CAN_DRV_NM_SND == CAN_TRUE) || (CAN_DRV_COM_SND == CAN_TRUE)
void FncAbtAllSndMsgDRV( void )
{
	/* ----- ----- */
	can_ctlr1.bit.banksel		   = CAN_OFF;
	
#if CAN_DRV_NM_SND == CAN_TRUE
	can_simkr.bit.slot11_simkr	   = CAN_OFF;
	can_mctl[CAN_DRV_NMSLOT].byte = (UINT8)CAN_CLR;
	CAN_DRV_InvalNMDataSts		  = CAN_OFF ;
	CAN_DRV_SndNMDataSts		  = CAN_OFF;
#endif
#if CAN_DRV_COM_SND == CAN_TRUE
	can_simkr.bit.slot12_simkr	   = CAN_OFF;
	can_mctl[CAN_DRV_COMSLOT].byte = (UINT8)CAN_CLR;
	CAN_DRV_InvalCOMDataSts 	   = CAN_OFF;
	CAN_DRV_SndCOMDataSts		   = CAN_OFF;
#endif
}
#endif

/*****************************************************************************/
/*	Function name : StatusType FncChgModCAN( UINT8 in_m_mode )				 */
/*---------------------------------------------------------------------------*/
/*	Description :  CANRg[샂[hύX							 */
/*				   s^C~O: C 									 */
/*---------------------------------------------------------------------------*/
/*	parameter : UINT8:[hؑ֗v										 */
/*					   CAN_DRV_CAN_SLEEP : CANSle							 */
/*					   CAN_DRV_CAN_RESET : CANZbg[h				 */
/*					   CAN_DRV_CAN_RUN	 : CAN샂[h					 */
/*	result	  : CAN_E_OK	  : 										 */
/*				CAN_E_NG	  : ُ										 */
/*				CAN_E_PARAM   : ُ									 */
/*****************************************************************************/
StatusType FncChgModCAN( UINT8 in_m_mode )
{
	/* ----- ϐ ----- */
	StatusType	m_sts = CAN_E_NG ;
	UINT16	lp_cnt = (UINT16)CAN_CLR ;
	/* ----- ----- */
	/* RUNӰވڍs ( ResetԂ,RUNsꂽRUN{) */
	switch( in_m_mode){
	case CAN_DRV_CAN_RUN:
		if( (can_slpr.bit.sleep == CAN_OFF) \
		 || (can_str.bit.state_reset == CAN_ON) )
		{
			/* CANRg[ */
			if(FncInitCAN() == CAN_E_OK)
			{
				can_ctlr0.word &= CAN_DRV_RUN ;
				while((can_str.bit.state_reset==CAN_ON)&&(lp_cnt<WaitChgMod))
				{
					lp_cnt++ ;
				}
				if(lp_cnt<WaitChgMod)
				{
					m_sts = SetSlotMsgRegDRV();
				}/* if(lp_cnt<WaitChgMod) */
			}
			else
			{
				m_sts = CAN_E_NG ;
			}
		}
		break;
	case CAN_DRV_CAN_RESET:
		can_slpr.bit.sleep = CAN_ON ;
		(void)ClrSlotMsgRegDRV();
		can_ctlr0.word |= CAN_DRV_RESET ;
		while((can_str.bit.state_reset==CAN_OFF)&&(lp_cnt<WaitChgMsg))
		{
			lp_cnt++ ;
		}
		/* ^CAEgH */
		if(lp_cnt<WaitChgMsg)
		{
			CAN_DRV_STATUS_Flg.byte  = (UINT8)CAN_CLR;
			m_sts=CAN_E_OK ;
		}
		break;
#if CAN_DRV_SLEEPMODE == CAN_TRUE
	case CAN_DRV_CAN_SLEEP:
		can_slpr.bit.sleep = CAN_ON ;
		(void)ClrSlotMsgRegDRV();
		can_ctlr0.word |= CAN_DRV_RESET ;
		while((can_str.bit.state_reset==CAN_OFF)&&(lp_cnt<WaitChgMsg))
		{
			lp_cnt++ ;
		}
		if(lp_cnt<WaitChgMsg)
		{
			m_sts=CAN_E_OK ;
			(void)SetCANPortDRV();
			can_slpr.bit.sleep = CAN_OFF ;
		}
		break;
#endif
	default :
		m_sts = CAN_E_PARAM;
		break ;
	}
	return	m_sts ;
}

/*****************************************************************************/
/*	Function name :StatusType FncCANRunDRV(void)							 */
/*---------------------------------------------------------------------------*/
/*	Description :  CANRg[֐									 */
/*				   s^C~O:	C									 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : CAN_E_OK	  : CANRg[ 					 */
/*				CAN_E_NG	  : s										 */
/*****************************************************************************/
StatusType FncCANRunDRV(void)
{
	/* ----- ϐ ----- */
	StatusType	m_sts = CAN_E_NG ;			/* Xe[^Xp 			 */
	/* ----- ----- */
	(void)FncDisCANWkupInt();

	/* CANRg[ */
	if(FncChgModCAN(CAN_DRV_CAN_RUN) == CAN_E_OK)
	{
		(void)FncEnCANSndInt();

#if CAN_DRV_RCVINT == CAN_TRUE
		(void)FncEnCANRcvInt();
#endif

		(void)FncEnCANErrInt();
		m_sts = CAN_E_OK;
	}
	else
	{
		m_sts = CAN_E_NG;
	}
	return	m_sts ;
}

/*****************************************************************************/
/*	Function name :StatusType FncCANSleepDRV(void)							 */
/*---------------------------------------------------------------------------*/
/*	Description :  CANRg[X[v֐								 */
/*				   s^C~O:	C									 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : CAN_E_OK	  : CANRg[X[v 				 */
/*				CAN_E_NG	  : s										 */
/*****************************************************************************/
#if CAN_DRV_SLEEPMODE == CAN_TRUE
StatusType FncCANSleepDRV(void)
{
	/* ----- ϐ ----- */
	StatusType	m_sts = CAN_E_NG ;			/* Xe[^Xp 				 */
	/* ----- ----- */
	(void)FncDisCANSndInt();
	(void)FncDisCANRcvInt();
	(void)FncDisCANErrInt();
	
	/* CANRg[X[v */
	if(FncChgModCAN(CAN_DRV_CAN_SLEEP) == CAN_E_OK)
	{
		(void)FncEnCANWkupInt();
		m_sts = CAN_E_OK;
	}
	else
	{
		m_sts = CAN_E_NG;
	}
	return	m_sts ;
}
#endif

/*****************************************************************************/
/*	Function name :StatusType FncCANResetDRV(void)							 */
/*---------------------------------------------------------------------------*/
/*	Description :  CANRg[Zbg֐								 */
/*				   s^C~O:	C									 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : CAN_E_OK	  : CANRg[Zbg 				 */
/*				CAN_E_NG	  : s										 */
/*****************************************************************************/
StatusType FncCANResetDRV(void)
{
	/* ----- ϐ ----- */
	StatusType	m_sts = CAN_E_NG ;			/* Xe[^Xp 				 */
	/* ----- ----- */
	(void)FncDisCANWkupInt();
	(void)FncDisCANRcvInt();
	(void)FncDisCANSndInt();
	(void)FncDisCANErrInt();

	/* CANRg[Zbg */
	if(FncChgModCAN(CAN_DRV_CAN_RESET) == CAN_E_OK)
	{
		m_sts = CAN_E_OK;
	}
	else
	{
		m_sts = CAN_E_NG;
	}
	return	m_sts ;
}

/*****************************************************************************/
/*	Function name :StatusType FncDisCANRcvInt( void )						 */
/*---------------------------------------------------------------------------*/
/*	Description :  M荞݃xNA 							 */
/*				   s^C~O: C 									 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : CAN_E_OK													 */
/*****************************************************************************/
StatusType FncDisCANRcvInt( void )
{
	/* ----- ----- */
	iio_can0ie.bit.b7 = CAN_OFF;
	return CAN_E_OK ;
}
/*****************************************************************************/
/*	Function name :StatusType FncEnCANRcvInt( void )						 */
/*---------------------------------------------------------------------------*/
/*	Description :  M荞݃xZbg 							 */
/*				   s^C~O: C 									 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : CAN_E_OK													 */
/*****************************************************************************/
StatusType FncEnCANRcvInt( void )
{
	/* ----- ----- */
	iio_can0ir.bit.b7 = CAN_OFF;
	iio_can0ie.bit.b7 = CAN_ON;
	return CAN_E_OK ;
}
/*****************************************************************************/
/*	Function name :StatusType FncDisCANSndInt( void )						 */
/*---------------------------------------------------------------------------*/
/*	Description :  M荞݃xNA 							 */
/*				   s^C~O: C 									 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : CAN_E_OK													 */
/*****************************************************************************/
StatusType FncDisCANSndInt( void )
{
	/* ----- ----- */
	iio_can1ie.bit.b7 = CAN_OFF;
	return CAN_E_OK ;
}
/*****************************************************************************/
/*	Function name :StatusType FncEnCANSndInt( void )						 */
/*---------------------------------------------------------------------------*/
/*	Description :  M荞݃Zbg									 */
/*				   s^C~O: C 									 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : CAN_E_OK													 */
/*****************************************************************************/
StatusType FncEnCANSndInt( void )
{
	/* ----- ----- */
	iio_can1ir.bit.b7 = CAN_OFF;
	iio_can1ie.bit.b7 = CAN_ON;
	return CAN_E_OK ;
	
}
/*****************************************************************************/
/*	Function name :StatusType FncDisCANErrInt( void )						 */
/*---------------------------------------------------------------------------*/
/*	Description :  CANG[荞݃NA									 */
/*				   s^C~O: C 									 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : CAN_E_OK													 */
/*****************************************************************************/
StatusType FncDisCANErrInt( void )
{
	/* ----- ----- */
	iio_can2ie.bit.b7 = CAN_OFF;
	return CAN_E_OK ;
}
/*****************************************************************************/
/*	Function name :StatusType FncEnCANErrInt( void )						 */
/*---------------------------------------------------------------------------*/
/*	Description :  CANG[荞݃Zbg									 */
/*				   s^C~O: C 									 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : CAN_E_OK													 */
/*****************************************************************************/
StatusType FncEnCANErrInt( void )
{
	/* ----- ----- */
	iio_can2ir.bit.b7 = CAN_OFF;
	iio_can2ie.bit.b7 = CAN_ON;
	return CAN_E_OK ;
}
/*****************************************************************************/
/*	Function name :StatusType FncDisCANWkupInt( void )						 */
/*---------------------------------------------------------------------------*/
/*	Description :  CANEF[NAbv荞݃NA							 */
/*				   s^C~O: C 									 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : CAN_E_OK													 */
/*****************************************************************************/
StatusType FncDisCANWkupInt( void )
{
	/* ----- ----- */
#if CAN_PORT_IN == CAN_DRV_USE_P77
	can_tabsr.bit.b3 = CAN_OFF;
	can_ta3mr.byte = (UINT8)CAN_CLR;
	can_ta3.word = (UINT16)CAN_CLR;
	can_trgsr.byte = (UINT8)CAN_CLR;
	can_wkupic.byte =  (UINT8)CAN_CLR ;
#elif CAN_PORT_IN == CAN_DRV_USE_P83
	can_wkupic.byte =  (UINT8)CAN_CLR ;
#elif CAN_PORT_IN == CAN_DRV_USE_P95
	iio_can2ie.bit.b6 = CAN_OFF;
#else
	/* LȊÕ|[gIꂽƂ(Ȃ) */
#endif
	return CAN_E_OK ;
}
/*****************************************************************************/
/*	Function name :StatusType FncEnCANWkupInt( void )						 */
/*---------------------------------------------------------------------------*/
/*	Description :  CANEF[NAbv荞݃xZbg					 */
/*				   s^C~O: C 									 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : CAN_E_OK													 */
/*****************************************************************************/
#if CAN_DRV_SLEEPMODE == CAN_TRUE
StatusType FncEnCANWkupInt( void )
{
	/* ----- ----- */
#if CAN_PORT_IN == CAN_DRV_USE_P77
	can_ta3mr.byte = CAN_WKUP_P77_TA3MR;
	can_ta3.word = CAN_WKUP_P77_TA3;
	can_trgsr.byte &= CAN_WKUP_P77_TRGSR;
	can_wkupic.byte =  (UINT8)CAN_WKUPINT_LEVEL ;
	can_tabsr.bit.b3 = CAN_ON;
#elif CAN_PORT_IN == CAN_DRV_USE_P83
	can_ifsr.bit.b1 = CAN_OFF;
	can_wkupic.byte =  (UINT8)CAN_CLR ;
	can_wkupic.byte =  (UINT8)CAN_WKUPINT_LEVEL ;
#elif CAN_PORT_IN == CAN_DRV_USE_P95
	iio_can2ir.bit.b6 = CAN_OFF;
	iio_can2ie.bit.b6 = CAN_ON;
#else
	/* LȊÕ|[gIꂽƂ(Ȃ) */
#endif
	return CAN_E_OK ;
}
#endif

/*****************************************************************************/
/*	Function name :StatusType FncSetCANIntLVLDRV( void )					 */
/*---------------------------------------------------------------------------*/
/*	Description :  CAN荞݃xZbg									 */
/*				   s^C~O: ECU								 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : CAN_E_OK													 */
/*****************************************************************************/
StatusType FncSetCANIntLVLDRV( void )
{
	/* ----- ----- */
	can0ic.byte = (UINT8)CAN_RCVINT_LEVEL;
	can1ic.byte = (UINT8)CAN_SNDINT_LEVEL;
	can2ic.byte = (UINT8)CAN_ERRINT_LEVEL;
	return CAN_E_OK ;
}

/*   荞݊֐  */
/*****************************************************************************/
/*	Function name :void FncCANErrIntDRV( void ) 							 */
/*---------------------------------------------------------------------------*/
/*	Description :  CANoXIt荞݊֐									 */
/*				   s^C~O:	oXIt							 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : none														 */
/*****************************************************************************/
void FncCANErrIntDRV( void )
{

	iio_can2ir.bit.b7 = CAN_OFF ;
	CAN_DRV_CANBusOffSts = CAN_ON ;
	can_eistr.byte = (UINT8)CAN_CLR;
	
#if CAN_DRV_ERR_CALL == CAN_TRUE /* G[ʒm */
	CallErrIntDRV();
#endif
}

/*****************************************************************************/
/*	Function name :StatusType FncClrBusOffNoticeDRV( void ) 				 */
/*---------------------------------------------------------------------------*/
/*	Description :  CANoXIttONA֐							 */
/*				   s^C~O:	C									 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : CAN_E_OK													 */
/*****************************************************************************/
StatusType FncClrBusOffNoticeDRV( void )
{
	/* ----- ----- */
	CAN_DRV_CANBusOffSts = CAN_OFF;

	return CAN_E_OK;
}

/*****************************************************************************/
/*	Function name :void FncCANRcvIntDRV( void ) 							 */
/*---------------------------------------------------------------------------*/
/*	Description :  M荞݊֐ 										 */
/*				   s^C~O:	CANf[^M 						 */
/*				   ӎ:  slot14Aslot15̎MXbgSĂmFB	 */
/*							  CANM荞ݏŕKR[ĉB	 */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : none														 */
/*****************************************************************************/
#if CAN_DRV_RCVINT == CAN_TRUE
void FncCANRcvIntDRV( void )
{
	/* ----- ϐ ----- */
	UINT8	lp_cnt	  = (UINT8)CAN_CLR ;
	UINT8	lp_wait   = (UINT8)CAN_CLR ;
	UINT8	m_work	  = (UINT8)CAN_CLR ;
	UINT8	m_banksel = (UINT8)CAN_CLR ;
	UINT16	m_can_id  = (UINT16)CAN_CLR; /* CAN-ID쐬p		   */
	UINT8	m_dlc	  = (UINT8)CAN_CLR;  /* DLC쐬p			   */
	UINT8	m_data[CAN_DRV_DLC_MAX];	 /* Xbg̃f[^i[p */
	

	iio_can0ir.bit.b7 = CAN_OFF;
	/* Bankselrbgɂ}XNWX^\Ăꍇ
	   UbZ[W䃌WX^\ɐ؂ւ			 */
	if(can_ctlr1.bit.banksel == CAN_ON)
	{
		m_banksel = CAN_ON;
		can_ctlr1.bit.banksel = CAN_OFF;
	}

	for( lp_cnt = CAN_DRV_SLOT14 ;lp_cnt < CAN_DRV_MAX_SLOTNUM ;lp_cnt++ )
	{
		/* ML f[^t[ */
		if(can_mctl[lp_cnt].rec.newdata == CAN_ON)
		{
			if(can_mctl[lp_cnt].rec.remactive == CAN_OFF)
			{
				/* dM̍ēǏoK[h */
				m_work = CAN_OFF ;
				while( m_work == CAN_OFF )
				{
					/* SRAMւ̓]҂ */
					for( lp_wait =(UINT8)CAN_CLR ;
						(can_mctl[lp_cnt].rec.invaldata==CAN_ON) && (lp_wait<WaitCANClk);
						lp_wait++ )
					{
						/* 󏈗iEGCgj */
					}
					can_mctl[lp_cnt].rec.newdata = CAN_OFF ;
					can_mctl[lp_cnt].rec.msglost = CAN_OFF ;
					can_sbs.bit.sbs0 = lp_cnt;
					
					can_afs.byte.low  = (can_slot_buf0.byte.sidh & (UINT8)CAN_DRV_SIDH_MASK) ;
					can_afs.byte.high = (can_slot_buf0.byte.sidl & (UINT8)CAN_DRV_SIDL_MASK) ;
					
					m_can_id = ((UINT16)(can_slot_buf0.byte.sidh) << CAN_DRV_SIDH_SIFT)
							 | ((UINT16)(can_slot_buf0.byte.sidl) & CAN_DRV_SIDL_MASK);
					m_dlc = can_slot_buf0.byte.dlc;
					CANDataRd0DRV(m_data);
					
					/* i[ɐVȎM͂ */
					if(can_mctl[lp_cnt].rec.newdata == CAN_OFF)
					{
						m_work = CAN_ON;
						
#if (CAN_DRV_NM_RCV == CAN_TRUE) && (CAN_DRV_COM_RCV == CAN_TRUE)
						/* NMbZ[WMASUgp */
						if((CAN_ASU_TABLE_NM[can_afs.byte.low]&can_afs.byte.high) 
							!= (UINT8)CAN_CLR )
						{
							CallNMRcvMsgDRV((UINT32)m_can_id, m_dlc, m_data);
						}
						/* COMbZ[WMASUgp */
						else if((CAN_ASU_TABLE_COM[can_afs.byte.low]&can_afs.byte.high) 
								!= (UINT8)CAN_CLR )
						{
							CallCOMRcvMsgDRV((UINT32)m_can_id, m_dlc, m_data);
						}/* IDe[u */
						/* SKvȂt[M */
						else
						{
						}
#elif CAN_DRV_NM_RCV == CAN_TRUE
						/* NMbZ[WMASUgp */
						if((CAN_ASU_TABLE_NM[can_afs.byte.low]&can_afs.byte.high) 
							!= (UINT8)CAN_CLR )
						{
							CallNMRcvMsgDRV((UINT32)m_can_id, m_dlc, m_data);
						}
#elif CAN_DRV_COM_RCV == CAN_TRUE
						/* COMbZ[WMASUgp */
						if((CAN_ASU_TABLE_COM[can_afs.byte.low]&can_afs.byte.high) 
							!= (UINT8)CAN_CLR )
						{
							CallCOMRcvMsgDRV((UINT32)m_can_id, m_dlc, m_data);
						}
#else

#endif
					}
				}/* dMK[h */
			}/* ML f[^t[ */
			else
			{
				can_mctl[lp_cnt].byte = CAN_DRV_SET_RCV ;
			}
		}
		else
		{
			/* M */
		}
	}
	
	/* BankselrbgύXĂꍇ
	   }XNWX^\ɐ؂ւ  */
	if(m_banksel == CAN_ON)
	{
		can_ctlr1.bit.banksel = CAN_ON;
	}
}
#endif
/*****************************************************************************/
/*	Function name :void FncCANSndIntDRV( void ) 							 */
/*---------------------------------------------------------------------------*/
/*	Description :  M荞݊֐ 										 */
/*				   s^C~O:	CANf[^M 						 */
/*				   ӎ: Av̊荞ݏŕKR[ĉB  */
/*---------------------------------------------------------------------------*/
/*	parameter : none														 */
/*	result	  : none														 */
/*****************************************************************************/
void FncCANSndIntDRV( void )
{
	UINT8	m_banksel = (UINT8)CAN_CLR ;

	iio_can1ir.bit.b7 = CAN_OFF ;
	/* Bankselrbgɂ}XNWX^\Ăꍇ
	   UbZ[W䃌WX^\ɐ؂ւ			 */
	if(can_ctlr1.bit.banksel == CAN_ON)
	{
		m_banksel = CAN_ON;
		can_ctlr1.bit.banksel = CAN_OFF;
	}

#if CAN_DRV_NM_SND == CAN_TRUE
	if( (can_mctl[CAN_DRV_NMSLOT].trm.sentdata == CAN_ON) \
	 && (can_mctl[CAN_DRV_NMSLOT].trm.trmreq   == CAN_ON) )/* NMf[^M	 */
	{
		CAN_DRV_InvalNMDataSts = CAN_OFF ;
		CAN_DRV_SndNMDataSts   = CAN_ON ;
		can_mctl[CAN_DRV_NMSLOT].trm.trmreq = CAN_OFF ;
		can_mctl[CAN_DRV_NMSLOT].byte = (UINT8)CAN_CLR ;
		CallNMSndMsgDRV();
	}
#endif
#if CAN_DRV_COM_SND == CAN_TRUE
	if( (can_mctl[CAN_DRV_COMSLOT].trm.sentdata == CAN_ON) \
	 && (can_mctl[CAN_DRV_COMSLOT].trm.trmreq	== CAN_ON) )/* COMf[^M   */
	{
		CAN_DRV_InvalCOMDataSts = CAN_OFF ;
		CAN_DRV_SndCOMDataSts	= CAN_ON ;
		can_mctl[CAN_DRV_COMSLOT].trm.trmreq = CAN_OFF ;
		can_mctl[CAN_DRV_COMSLOT].byte = (UINT8)CAN_CLR ;
		CallCOMSndMsgDRV();
	}
#endif
	/* BankselrbgύXĂꍇ
	   }XNWX^\ɐ؂ւ  */
	if(m_banksel == CAN_ON)
	{
		can_ctlr1.bit.banksel = CAN_ON;
	}
}
/*  荞݊֐	 */


/**** End of File ************************************************************/