/*
 *	TOPPERS/Non-OS CAN Middleware
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		Non-OS CAN Middleware
 * 
 *	Copyright (C) 2007 Sunny Giken Inc.
 * 
 *	L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *	ɂČ\Ă GNU General Public License  Version 2 ɋL
 *	qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *	ς̂܂ށDȉjgpEEρEĔzziȉC
 *	pƌĂԁj邱Ƃ𖳏ŋD
 *	(1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *		\C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *		XR[hɊ܂܂Ă邱ƁD
 *	(2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *		pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *		҃}jAȂǁjɁCL̒쌠\C̗pщL
 *		̖ۏ؋Kfڂ邱ƁD
 *	(3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *		płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *		ƁD
 *	  (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *		  쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *	  (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *		  񍐂邱ƁD
 *	(4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *		QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *	{\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *	TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *	܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *	ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */
/*
 *@Version 0.01  2007.04.04
 */

#ifndef __CMN_H_INCLUDE__
#define __CMN_H_INCLUDE__

#include <osek.h>

/*---------------------------------------------------------------------------*/
/*  萔`                                                                 */
/*---------------------------------------------------------------------------*/
/* ʒ萔 */
#define CAN_TRUE    (1)                 /* ^                                */
#define CAN_FALSE   (0)                 /* U                                */

#define CAN_ON      (1)                 /* I                              */
#define CAN_OFF     (0)                 /* It                              */

#define CAN_CLR     (0)                 /* NAl                          */
#define CAN_LIMIT8  ((UINT8)(0xFF))     /* 8bitől                        */
#define CAN_LIMIT16 ((UINT16)(0xFFFF))  /* 16bitől                       */

/* StatusTypep萔 */
#define CAN_E_OK        ((StatusType)(0)) /*                             */
#define CAN_E_NG        ((StatusType)(1)) /* ُ                            */
#define CAN_E_PARAM     ((StatusType)(2)) /* ُ                        */

/*---------------------------------------------------------------------------*/
/*  ^`                                                                   */
/*---------------------------------------------------------------------------*/
/* CANbZ[W֘A */
typedef union{
    UINT8     byte[8];
    UINT16    word[4];
}DataType;
typedef struct{
    UINT16        can_id;                 /* CAN-ID                          */
    UINT8         dlc;                    /* DLC                             */
    DataType      data;                   /* f[^                          */
}CANMsgType;

#endif  /* #define __CMN_H_INCLUDE__ */

/**** End of File ************************************************************/
