/*
 *	TOPPERS/Non-OS CAN Middleware DRV
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		Non-OS CAN Middleware DRV
 * 
 *	Copyright (C) 2007 Sunny Giken Inc.
 * 
 *	L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *	ɂČ\Ă GNU General Public License  Version 2 ɋL
 *	qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *	ς̂܂ށDȉjgpEEρEĔzziȉC
 *	pƌĂԁj邱Ƃ𖳏ŋD
 *	(1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *		\C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *		XR[hɊ܂܂Ă邱ƁD
 *	(2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *		pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *		҃}jAȂǁjɁCL̒쌠\C̗pщL
 *		̖ۏ؋Kfڂ邱ƁD
 *	(3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *		płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *		ƁD
 *	  (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *		  쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *	  (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *		  񍐂邱ƁD
 *	(4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *		QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *	{\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *	TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *	܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *	ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */
/*
 *@Version 0.01  2007.04.04
 */

#ifndef __CAN_DRV_EXT_H_INCLUDE__
#define __CAN_DRV_EXT_H_INCLUDE__

/*---------------------------------------------------------------------------*/
/* ft@C`                                                            */
/*---------------------------------------------------------------------------*/
/* hCoԒ萔 */
#define CAN_DRV_EMPTY       ((UINT8)(0))    /* MEM                */
#define CAN_DRV_WAIT        ((UINT8)(1))    /* M or M҂            */
#define CAN_DRV_COMP        ((UINT8)(2))    /* M                      */
#define CAN_DRV_OK          ((UINT8)(3))    /* M                      */

/* CANoXItԒ萔 */
#define CAN_DRV_NORMAL      ((UINT8)(0))    /* CANoXItł͂Ȃ         */
#define CAN_DRV_BUSOFF      ((UINT8)(1))    /* CANoXIt             */

/* CANRg[萔 */
#define CAN_DRV_CAN_RESET   ((UINT8)(0))    /* CANZbgԂɂ       */
#define CAN_DRV_CAN_RUN     ((UINT8)(1))    /* CAN𓮍Ԃɂ           */
#define CAN_DRV_CAN_SLEEP   ((UINT8)(2))    /* CANSleepԂɂ          */

#define CAN_DRV_MAX_SLOTNUM ((UINT8)(16))   /* Xbgő吔                */
#define CAN_DRV_MASKREG_NUM ((UINT8)(3))    /* }XNWX^̐            */
#define CAN_DRV_ASU_MAX     ((UINT16)(256)) /* ASUe[uő吔             */

#define CAN_DRV_NO_USE ((UINT16)(0xFFFF))   /* CANXbggp             */

/*---------------------------------------------------------------------------*/
/*  Oe[u                                                             */
/*---------------------------------------------------------------------------*/
/* DRV Table֘A */
extern const far UINT16 CAN_SLOTID_TABLE[CAN_DRV_MAX_SLOTNUM];
extern const far UINT16 CAN_SLOTMASK_TABLE[CAN_DRV_MASKREG_NUM];
#if CAN_DRV_COM_RCV == CAN_TRUE
extern const far UINT8 CAN_ASU_TABLE_COM[CAN_DRV_ASU_MAX];
#endif
#if CAN_DRV_NM_RCV == CAN_TRUE
extern const far UINT8 CAN_ASU_TABLE_NM[CAN_DRV_ASU_MAX];
#endif

/*---------------------------------------------------------------------------*/
/*  J֐                                                                 */
/*---------------------------------------------------------------------------*/
/* DRIVER֐ */
extern StatusType FncChgModCAN(UINT8);          /* CAN샂[hύXϐ     */

extern StatusType FncSetCANIntLVLDRV(void);     /* 荞݃xZbg֐  */

#if CAN_DRV_POL_RCV == CAN_TRUE
extern StatusType FncRdCOMMsgDRV(UINT32 *, UINT8 *, UINT8 *);
                                                /* Mf[^󂯓n֐    */
#endif

#if CAN_DRV_NM_SND == CAN_TRUE
extern void FncAbtNMSndMsgDRV(void);            /* NMM~֐            */
extern void FncGetNMSndStsDRV( UINT8 * );       /* NMMXe[^X擾֐  */
extern StatusType FncWrNMMsgDRV( UINT32 , UINT8 , const UINT8 * );
                                                /* NMMf[^󂯓n֐  */
#endif
#if CAN_DRV_COM_SND == CAN_TRUE
extern void FncAbtCOMSndMsgDRV(void);           /* COMM~֐           */
extern void FncGetCOMSndStsDRV( UINT8 * );      /* COMMXe[^X擾֐ */
extern StatusType FncWrCOMMsgDRV( UINT32 , UINT8 , const UINT8 * );
                                                /* COMMf[^󂯓n֐ */
#endif
#if (CAN_DRV_NM_SND == CAN_TRUE) || (CAN_DRV_COM_SND == CAN_TRUE)
extern void FncAbtAllSndMsgDRV(void);           /* SMf[^A{[g֐  */
#endif

extern StatusType FncDisCANRcvInt(void);        /* CANMݖ֐     */
extern StatusType FncEnCANRcvInt(void);         /* CANMݗL֐     */
extern StatusType FncDisCANSndInt(void);        /* CANMݖ֐     */
extern StatusType FncEnCANSndInt(void);         /* CANMݗL֐     */
extern StatusType FncDisCANErrInt(void);        /* CANG[ݖ֐   */
extern StatusType FncEnCANErrInt(void);         /* CANG[ݗL֐   */
extern StatusType FncDisCANWkupInt(void);       /* CANWakeUpݖ֐   */

#if CAN_DRV_SLEEPMODE == CAN_TRUE
 extern StatusType FncEnCANWkupInt(void);       /* CANWakeUpݗL֐   */
#endif

extern StatusType FncClrBusOffNoticeDRV(void);  /* oXItNA֐    */


extern void FncGetBusoffStsDRV(UINT8 *);        /* oXItԎ擾֐      */
extern void FncCANErrIntDRV(void) ;             /* CANoXIt荞݊֐   */
#if CAN_DRV_RCVINT == CAN_TRUE
extern void FncCANRcvIntDRV(void) ;             /* CANM荞݊֐   */
#endif
extern void FncCANSndIntDRV(void) ;             /* CANM荞݊֐   */

extern StatusType FncCANRunDRV(void);           /* CANRg[֐   */

#if CAN_DRV_SLEEPMODE == CAN_TRUE
 extern StatusType FncCANSleepDRV(void);    /* CANRg[X[v֐   */
#endif

extern StatusType FncCANResetDRV(void);     /* CANRg[Zbg֐   */

/* API֐ */
#if CAN_DRV_NM_RCV == CAN_TRUE
extern void CallNMRcvMsgDRV(UINT32, UINT8, const UINT8 *);
                                                /* NMMR[obN    */
#endif
#if CAN_DRV_COM_RCV == CAN_TRUE
extern void CallCOMRcvMsgDRV(UINT32, UINT8, const UINT8 *);
                                                /* COMMR[obN   */
#endif
#if CAN_DRV_NM_SND == CAN_TRUE
extern void CallNMSndMsgDRV(void);              /* NMMR[obN    */
#endif
#if CAN_DRV_COM_SND == CAN_TRUE
extern void CallCOMSndMsgDRV(void);             /* COMMR[obN   */
#endif
#if CAN_DRV_ERR_CALL == CAN_TRUE
extern void CallErrIntDRV(void);                /* oXItR[obN  */
#endif

#endif  /* __CAN_DRV_EXT_H_INCLUDE__ */

/****** End of File **********************************************************/
