/*
 *  TOPPERS/OSEK COM
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK COM
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *	OSEK COM WCN[ht@C
 *
 *  AZũ\[Xt@CVXeRtBM[Vt@
 *  C炱̃t@CCN[h鎞́C_MACRO_ONLY `
 *  ƂŁC}N`ȊŐLqƂłD
 *
 *  ̒ŃCN[hĂt@CāC̃CN[ht@
 *  CɈˑĂȂD
 */
#ifndef _COM_H_
#define _COM_H_

#include "osek.h"
#include "msg_types.h"


#ifndef _MACRO_ONLY

/*
 *  COMf[^^̒`
 */
typedef UINT16			MessageIdentifier;		/* bZ[WID */
typedef void			*ApplicationDataRef;	/* f[^i[ꏊւ̃|C^ */
typedef UINT8			COMLengthType;			/* f[^ */
typedef COMLengthType	*LengthRef;				/* COMLengthType^|C^ */
typedef UINT8			FlagValue;				/* tO̒l */
typedef UINT8			COMApplicationModeType;	/* COMAvP[V[h */
typedef UINT8			COMShutdownModeType;	/* COMVbg_E[h */
typedef FlagValue		CalloutReturnType;		/* Callout̕Ԃl */
typedef UINT8			COMServiceIdType;		/* COM̃T[rXAPIID */


/* Ǝ */
typedef UINT8			IPDUType;	/* IPDǓ^ */

#endif /* _MACRO_ONLY */

/*
 *	Xe[^XR[h
 *		Binding 1.4.2 p.10 ACOM̃G[R[h́A32 - 63 ͈̔͂ƂȂ
 *			32 - 47 : WԂl (standard return values)
 *			48 - 63 : Ǝ̒ǉԂl (implementation specific additional errors)
 */
#define E_COM_ID		((StatusType) 32)
#define E_COM_LENGTH	((StatusType) 33)
#define E_COM_LIMIT		((StatusType) 34)
#define E_COM_NOMSG		((StatusType) 35)
/*
 *	Ǝ̒ǉXe[^XR[h
 */
#define	E_COM_SYS_STARTCOMEXT 	((StatusType) 48)	/* StartCOMExtensionŃG[ */
#define E_COM_SYS_CALLEVEL		((StatusType) 49)	/* COMR[x̕s */
#define E_COM_SYS_INTERRUPT		((StatusType) 50)	/* ֎~CALLꂽƂ̃G[ */
#define E_COM_SYS_ERR			((StatusType) 51)	/* ̑G[  ڍׂ̓Op}N`ď擾 */


/*
 *	tO
 */
#define COM_FALSE		((FlagValue) 0)
#define COM_TRUE		((FlagValue) 1)

/*
 *	COMShutdownModeType 
 */
#define COM_SHUTDOWN_IMMEDIATE	((COMShutdownModeType)(1u << 0))	/* StopCOM Ŏwł郂[h */

#define COM_SHUTDOWN			(COM_SHUTDOWN_IMMEDIATE)

/*
 *	COM comcallevel̒l
 */
#define COMCL_STOP			((UINT8)(1u << 0))		/* StopAStartO */
#define COMCL_START			((UINT8)(1u << 1))		/* StartAStopO */
#define COMCL_ERRHOOK		((UINT8)(1u << 2))		/* COMErrorhooks */
/* COMCL_STARTƏԂ̍dlǂݎȂ */
/* #define COMCL_STARTEXT 		((UINT8)(1 << 3))	*/	/* StartCOMExtensions */

#ifndef _MACRO_ONLY

/*
 *  COMT[rXAPI̐錾
 */
extern StatusType StartCOM (COMApplicationModeType mode);
extern StatusType StopCOM (COMShutdownModeType mode);
extern COMApplicationModeType GetCOMApplicationMode(void);
extern StatusType InitMessage (MessageIdentifier msgid, ApplicationDataRef p_data);
extern StatusType StartPeriodic (void);
extern StatusType StopPeriodic (void);
extern StatusType SendMessage(MessageIdentifier msgid,ApplicationDataRef p_data);
extern StatusType ReceiveMessage(MessageIdentifier msgid,ApplicationDataRef p_data);
extern StatusType SendDynamicMessage(MessageIdentifier msgid,ApplicationDataRef p_data,LengthRef p_len);
extern StatusType ReceiveDynamicMessage(MessageIdentifier msgid,ApplicationDataRef p_data,LengthRef p_len);
extern StatusType SendZeroMessage(MessageIdentifier msgid);
extern StatusType GetMessageStatus(MessageIdentifier msgid);

/*
 *  tbN[`̐錾
 */
extern StatusType StartCOMExtension(void);
extern void COMErrorHook(StatusType ercd);

#endif /* _MACRO_ONLY */

/*
 *  COM̃T[rXAPIID
 */
#define COMServiceId_StartCOM				((COMServiceIdType) 0)
#define COMServiceId_StopCOM				((COMServiceIdType) 1)
#define COMServiceId_GetCOMApplicationMode	((COMServiceIdType) 2)
#define COMServiceId_InitMessage			((COMServiceIdType) 3)
#define COMServiceId_StartPeriodic			((COMServiceIdType) 4)
#define COMServiceId_StopPeriodic			((COMServiceIdType) 5)
#define COMServiceId_ReadFlag				((COMServiceIdType) 6)
#define COMServiceId_ResetFlag				((COMServiceIdType) 7)
#define COMServiceId_SendMessage			((COMServiceIdType) 8)
#define COMServiceId_ReceiveMessage			((COMServiceIdType) 9)
#define COMServiceId_SendDynamicMessage		((COMServiceIdType) 10)
#define COMServiceId_ReceiveDynamicMessage	((COMServiceIdType) 11)
#define COMServiceId_SendZeroMessage		((COMServiceIdType) 12)
#define COMServiceId_GetMessageStatus		((COMServiceIdType) 13)
#define COMServiceId_COMErrorGetServiceId	((COMServiceIdType) 14)
#define COMServiceId_StartCOMExtension		((COMServiceIdType) 15)
#define COMServiceId_COMCallout				((COMServiceIdType) 16)
#define COMServiceId_CallCOMSndMsgDRV		((COMServiceIdType) 17)
#define COMServiceId_CallCOMRcvMsgDRV		((COMServiceIdType) 18)

/*
 *  G[tbNɓn̂߂̒`
 *  (COMError_Name1_Name2 p)
 */
#ifndef _MACRO_ONLY

typedef union {
		COMApplicationModeType		m_mode;
		COMShutdownModeType			m_stop_mode;
		MessageIdentifier			m_msgid;
		ApplicationDataRef			m_p_data;
		LengthRef					m_p_len;
	} _COMErrorHook_Par;

extern 	COMServiceIdType	_com_errorhook_svcid;
extern 	_COMErrorHook_Par	_com_errorhook_par1, _com_errorhook_par2, _com_errorhook_par3;

#endif /* _MACRO_ONLY */

/*
 * COMError_Name1_Name2 }N
 */
#define COMError_StartCOM_Mode()					(_com_errorhook_par1.m_mode)
#define COMError_StopCOM_Mode()						(_com_errorhook_par1.m_stop_mode)
#define COMError_InitMessage_Message()				(_com_errorhook_par1.m_msgid)
#define COMError_InitMessage_DataRef()				(_com_errorhook_par2.m_p_data)
#define COMError_SendMessage_Message()				(_com_errorhook_par1.m_msgid)
#define COMError_SendMessage_DataRef()				(_com_errorhook_par2.m_p_data)
#define COMError_ReceiveMessage_Message()			(_com_errorhook_par1.m_msgid)
#define COMError_ReceiveMessage_DataRef()			(_com_errorhook_par2.m_p_data)
#define COMError_SendDynamicMessage_Message()		(_com_errorhook_par1.m_msgid)
#define COMError_SendDynamicMessage_DataRef()		(_com_errorhook_par2.m_p_data)
#define COMError_SendDynamicMessage_LengthRef()		(_com_errorhook_par3.m_p_len)
#define COMError_ReceiveDynamicMessage_Message()	(_com_errorhook_par1.m_msgid)
#define COMError_ReceiveDynamicMessage_DataRef()	(_com_errorhook_par2.m_p_data)
#define COMError_ReceiveDynamicMessage_LengthRef()	(_com_errorhook_par3.m_p_len)
#define COMError_SendZeroMessage_Message()			(_com_errorhook_par1.m_msgid)
#define COMError_GetMessageStatus_Message()			(_com_errorhook_par1.m_msgid)

/*
 *  COMErrorGetServiceId()
 *  (OSɕă}NŎ)
 */
#define COMErrorGetServiceId()						(_com_errorhook_svcid)


/* COMCALLBACKNAME ̃}NWJ */
/* SGo͌ʂCOMĂяo֐ɕύX */
#define COMCALLBACKNAME(COMCallBackName) COMCallback##COMCallBackName
/* dlŌ߂ĂR[obN̏ACOMĂяo֐ɕύX */
#define COMCallback(COMCallBackName) \
			void COMCallback##COMCallBackName(void)

/* R[AEg֐̓WJ */
#define COMCALLOUTNAME(CalloutRoutineName) COMCallout##CalloutRoutineName
#define COMCallout(CalloutRoutineName) \
			CalloutReturnType COMCallout##CalloutRoutineName(void)

/* eݒ̍ől */
#define MAX_MSG		254		/* bZ[WIuWFNg̍ő吔 */
#define MAX_QUESIZE	254		/* L[̃f[^i[̍ől */
#define MAX_COMAPPMODE	8	/* AvP[V[hőݒ萔 */

#define MAX_DATALENGTH	254	/* bZ[Wf[^ő咷 */

#ifndef _MACRO_ONLY

/*
 *  R[AEgf[^QƗpϐ
 */
extern void *_callout_snddata_addr;
extern void *_callout_rcvdata_addr;

#endif /* _MACRO_ONLY */

/*
 *  R[AEgf[^QƗp}N
 */
#define	COMCallout_SendDataPointer		(_callout_snddata_addr)
#define	COMCallout_ReceiveDataPointer	(_callout_rcvdata_addr)

#endif /* _COM_H_ */
