/*
 *  TOPPERS/OSEK Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK Kernel
 * 
 *  Copyright (C) 2006 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *	TvVAIOW[
 */

#include	"hw_serial.h"
#include	"serial.h"


/*
 *  Mpf[^
 */
static UINT8	rx_char;
static BOOL		rx_flag;

/*
 *  VAIOW[
 *
 *  ݋֎~ԂŌďoƁD
 */
void
InitSerial( void )
{
	/*
	 *  MtO
	 */
	rx_flag = FALSE;

	/*
	 *  ˑs
	 */
	InitHwSerial();
}	/* InitSerial	*/

/*
 *  VAIOW[~
 *
 *  o͂Ă邱Ƃ͕ۏႵȂifbhbNh~jD
 *  ReLXgbNďo͂̂ŁCقږȂiŌ̂Q̂݁jD
 *
 *  ݋֎~ԂŌďoƁD
 */
void
TermSerial( void )
{
	/*
	 *  ˑs
	 */
	TermHwSerial();

	/*
	 *  Mf[^
	 */
	rx_flag = FALSE;
}	/* TermSerial	*/

/*
 *  񑗐M
 */
void
SendSerialStr( const UINT8 * str )
{
	/*
	 *  ݋֎~ԂɂāCݒ񑗐Ms
	 */
	SuspendAllInterrupts();
	SendIntSerialStr( str );
	ResumeAllInterrupts();
}	/* SendSerialStr	*/

/*
 *  ݒ񑗐M
 */
void
SendIntSerialStr( const UINT8 * str )
{
	/*
	 *  ˑo͏ɂđSf[^𑗐M
	 */
	while( *str != '\0' ){
		PutHwChar( *str );
		str++;
	}
}	/* SendIntSerialStr	*/

/*
 *  M
 */
void RecvPolSerialChar( UINT8 * character )
{
	if( rx_flag == TRUE ){
	/*
	 *  ݋֎~ɂĎMf[^擾EtONA
	 */
		SuspendAllInterrupts();
		*character = rx_char;
		rx_flag = FALSE;
		ResumeAllInterrupts();
	}
	else{
	/*
	 *  Mf[^Ȃꍇ'\0'Ԃ
	 */
		*character = '\0';
	}
}	/* RecvPolSerialChar	*/

/*
 *  MR[obN֐
 */
void
RxSerialInt( UINT8 character )
{
	/*
	 *  ݋֎~ɂĎMf[^ێEtONA
	 */
	SuspendAllInterrupts();
	rx_char = character;
	rx_flag = TRUE;
	ResumeAllInterrupts();
}	/* RxSerialInt	*/

/*
 *  32bitl -> 10iϊ֐
 */
void
ConvLong2DecStr( UINT8 *dst, UINT32 src )
{
	UINT32	temp;	/* Zope|	*/

	/*
	 *  \Zo
	 */
	temp = src;
	while( ( temp /= 10 ) != 0 ){
		dst++;
	}
	
	dst[1] = '\0';	/* I[R[hݒ	*/

	/*
	 *  ɕϊ
	 */
	do{
		*dst = (UINT8)( ( src % 10 ) + '0' );
		dst--;
	} while( ( src /= 10 ) != 0 );
}	/* ConvLong2DecStr	*/

/*
 *  16bitl -> 10iϊ֐
 */
void
ConvShort2DecStr( UINT8 *dst, UINT16 src )
{
	UINT16	temp;	/* Zope|	*/

	/*
	 *  \Zo
	 */
	temp = src;
	while( ( temp /= 10 ) != 0 ){
		dst++;
	}
	
	dst[1] = '\0';	/* I[R[hݒ	*/

	/*
	 *  ɕϊ
	 */
	do{
		*dst = (UINT8)( ( src % 10 ) + '0' );
		dst--;
	} while( ( src /= 10 ) != 0 );
}	/* ConvShort2DecStr	*/

/*
 *  8bitl -> 10iϊ֐
 */
void
ConvByte2DecStr( UINT8 *dst, UINT8 src )
{
	UINT8	temp;	/* Zope|	*/

	/*
	 *  \Zo
	 */
	temp = src;
	while( ( temp /= 10 ) != 0 ){
		dst++;
	}
	
	dst[1] = '\0';	/* I[R[hݒ	*/

	/*
	 *  ɕϊ
	 */
	do{
		*dst = (UINT8)( ( src % 10 ) + '0' );
		dst--;
	} while( ( src /= 10 ) != 0 );
}	/* ConvByte2DecStr	*/

/*
 *  32bitl -> 16iϊ֐
 *
 *  {֐̏o̓obt@i*dstwj 9Bytei8+I[R[hj
 *  ȏێ邱ƂOƂD
 */
void
ConvLong2HexStr( UINT8 *dst, UINT32 src )
{
	UINT8	mod;
	INT8	idx = 8;
	/*
	 *  80l߂16iɕϊ
	 */

	dst[idx] = '\0';	/* I[R[hݒ	*/
	idx--;

	/*
	 *  16iɕϊ
	 */
	do{
		mod = (UINT8)( src & (UINT32)0x0000000f );
		if( mod < 10 ){
			dst[idx] = (UINT8)( mod + '0' );
			idx--;
		}
		else{
			dst[idx] = (UINT8)( ( mod - 10 ) + 'A' );
			idx--;
		}
	} while( ( src >>= 4 ) != 0 );

	/*
	 *  č0l
	 */
	while( idx >= 0 ){
		dst[idx] = (UINT8)'0';
		idx--;
	}
}	/* ConvLong2HexStr	*/

/*
 *  16bitl -> 16iϊ֐
 *
 *  {֐̏o̓obt@i*dstwj 5Bytei4+I[R[hj
 *  ȏێ邱ƂOƂD
 */
void
ConvShort2HexStr( UINT8 *dst, UINT16 src )
{
	UINT8	mod;
	INT8	idx = 4;
	/*
	 *  40l߂16iɕϊ
	 */

	dst[idx] = '\0';	/* I[R[hݒ	*/
	idx--;

	/*
	 *  16iɕϊ
	 */
	do{
		mod = (UINT8)( src & (UINT16)0x000f );
		if( mod < 10 ){
			dst[idx] = (UINT8)( mod + '0' );
			idx--;
		}
		else{
			dst[idx] = (UINT8)( ( mod - 10 ) + 'A' );
			idx--;
		}
	} while( ( src >>= 4 ) != 0 );

	/*
	 *  č0l
	 */
	while( idx >= 0 ){
		dst[idx] = (UINT8)'0';
		idx--;
	}
}	/* ConvShort2HexStr	*/

/*
 *  8bitl -> 16iϊ֐
 *
 *  {֐̏o̓obt@i*dstwj 3Bytei2+I[R[hj
 *  ȏێ邱ƂOƂD
 */
void
ConvByte2HexStr( UINT8 *dst, UINT8 src )
{
	UINT8	mod;
	INT8	idx = 2;
	/*
	 *  20l߂16iɕϊ
	 */

	dst[idx] = '\0';	/* I[R[hݒ	*/
	idx--;

	/*
	 *  16iɕϊ
	 */
	do{
		mod = (UINT8)( src & (UINT8)0x0f );
		if( mod < 10 ){
			dst[idx] = (UINT8)( mod + '0' );
			idx--;
		}
		else{
			dst[idx] = (UINT8)( ( mod - 10 ) + 'A' );
			idx--;
		}
	} while( ( src >>= 4 ) != 0 );

	/*
	 *  č0l
	 */
	while( idx >= 0 ){
		dst[idx] = (UINT8)'0';
		idx--;
	}
}	/* ConvByte2HexStr	*/


