/*
 *  com_cfg.c
 *  Thu Nov 08 19:35:28 2007
 *  SG Version 2.11
 *  sg.exe .\com_message.oil -oscancom -lj -I ./../../../sg/impl_oil -cpu=m32c
 */
#include "com_cfg.h"
#include "com_interrupt.h"
#include "com_memory.h"
#include "osek_com.h"

#include "com_timer_user.h"

/* COM */

/* MbZ[W */
#define TNUM_RCV_UNQ_NORM 4
#define TNUM_RCV_UNQ_ZERO 0
#define TNUM_RCV_UNQ_DYNA 1
#define TNUM_RCV_QUE_NORM 2
/* MbZ[W */
#define TNUM_SND_IN_NORM 1
#define TNUM_SND_IN_ZERO 0
/* OMbZ[W */
#define TNUM_SND_EX_TRIG_NORM 1
#define TNUM_SND_EX_PEND_NORM 2
#define TNUM_SND_EX_TRIG_ZERO 0
#define TNUM_SND_EX_TRIG_DYNA 1
#define TNUM_SND_EX_PEND_DYNA 0
/* IPDUMbZ[W */
#define TNUM_RCV_IPDU_NORM 3
#define TNUM_RCV_IPDU_ZERO 0
#define TNUM_RCV_IPDU_DYNA 1

/* MbZ[W */
const UINT8 tnum_rcv_unq_norm = (UINT8)TNUM_RCV_UNQ_NORM;
const UINT8 tnum_rcv_unq_zero = (UINT8)TNUM_RCV_UNQ_ZERO;
const UINT8 tnum_rcv_unq_dyna = (UINT8)TNUM_RCV_UNQ_DYNA;
const UINT8 tnum_rcv_que_norm = (UINT8)TNUM_RCV_QUE_NORM;
/* MbZ[W */
const UINT8 tnum_snd_in_norm = (UINT8)TNUM_SND_IN_NORM;
const UINT8 tnum_snd_in_zero = (UINT8)TNUM_SND_IN_ZERO;
/* OMbZ[W */
const UINT8 tnum_snd_ex_trig_norm = (UINT8)TNUM_SND_EX_TRIG_NORM;
const UINT8 tnum_snd_ex_pend_norm = (UINT8)TNUM_SND_EX_PEND_NORM;
const UINT8 tnum_snd_ex_trig_zero = (UINT8)TNUM_SND_EX_TRIG_ZERO;
const UINT8 tnum_snd_ex_trig_dyna = (UINT8)TNUM_SND_EX_TRIG_DYNA;
const UINT8 tnum_snd_ex_pend_dyna = (UINT8)TNUM_SND_EX_PEND_DYNA;
/* IPDUMbZ[W */
const UINT8 tnum_rcv_ipdu_norm = (UINT8)TNUM_RCV_IPDU_NORM;
const UINT8 tnum_rcv_ipdu_zero = (UINT8)TNUM_RCV_IPDU_ZERO;
const UINT8 tnum_rcv_ipdu_dyna = (UINT8)TNUM_RCV_IPDU_DYNA;

/* uL[Lvf[^i[擾pz */
const UINT8 tnum_que_elem[TNUM_RCV_QUE_NORM] = { (UINT8)TNUM_QUE_ELEM_RecvInQuMsg, (UINT8)TNUM_QUE_ELEM_RecvExQuMsg };
InMsgType msgbuf_RecvInQuMsg[TNUM_QUE_ELEM_RecvInQuMsg];
InMsgType msgbuf_RecvInStMsg;
ExMsgType msgbuf_RecvExQuMsg[TNUM_QUE_ELEM_RecvExQuMsg];
ExMsgType msgbuf_RecvExStMsg1;
UINT16 msgbuf_RecvExStMsg2;
UINT16 msgbuf_RecvExStMsg3;
UINT8 msgbuf_RecvExValMsg[10];
COMLengthType msglength_RecvExValMsg;

/* bZ[Wf[^i[obt@ */
const ApplicationDataRef msgbuf_rcv_unq_norm[TNUM_RCV_UNQ_NORM] = { &msgbuf_RecvInStMsg, &msgbuf_RecvExStMsg1, &msgbuf_RecvExStMsg2, &msgbuf_RecvExStMsg3 };
const UINT32 msgsize_rcv_unq_norm[TNUM_RCV_UNQ_NORM] = { sizeof(msgbuf_RecvInStMsg), sizeof(msgbuf_RecvExStMsg1), sizeof(msgbuf_RecvExStMsg2), sizeof(msgbuf_RecvExStMsg3) };

const ApplicationDataRef msgbuf_rcv_unq_zero[TNUM_RCV_UNQ_ZERO + 1] = { NULL };

const ApplicationDataRef msgbuf_rcv_unq_dyna[TNUM_RCV_UNQ_DYNA] = { msgbuf_RecvExValMsg };
const UINT32 msgsize_rcv_unq_dyna[TNUM_RCV_UNQ_DYNA] = { sizeof( msgbuf_RecvExValMsg ) };
const LengthRef msglength_rcv_unq_dyna[TNUM_RCV_UNQ_DYNA] = { &msglength_RecvExValMsg };

const ApplicationDataRef msgbuf_head_que_norm[TNUM_RCV_QUE_NORM] = { msgbuf_RecvInQuMsg, msgbuf_RecvExQuMsg };
const ApplicationDataRef msgbuf_end_que_norm[TNUM_RCV_QUE_NORM] = { &msgbuf_RecvInQuMsg[TNUM_QUE_ELEM_RecvInQuMsg - 1], &msgbuf_RecvExQuMsg[TNUM_QUE_ELEM_RecvExQuMsg - 1] };
const UINT32 msgsize_que_norm[TNUM_RCV_QUE_NORM] = { sizeof( InMsgType ), sizeof( ExMsgType ) };

UINT8 msgque_cnt[TNUM_RCV_QUE_NORM];
ApplicationDataRef msgque_get_addr[TNUM_RCV_QUE_NORM];
ApplicationDataRef msgque_put_addr[TNUM_RCV_QUE_NORM];

const UINT32 msgsize_snd_ex_trig_dyna[TNUM_SND_EX_TRIG_DYNA] = { 10 };

const UINT32 msgsize_snd_ex_pend_dyna[TNUM_SND_EX_PEND_DYNA + 1] = { 0 };

/* Rs[֐ */

static void cpy_ExMsgType( ApplicationDataRef p_dst, ApplicationDataRef p_src );
static void cpy_ExMsgType( ApplicationDataRef p_dst, ApplicationDataRef p_src )
{
	*( (ExMsgType *)p_dst ) = *( (const ExMsgType *)p_src );
}

static void cpy_InMsgType( ApplicationDataRef p_dst, ApplicationDataRef p_src );
static void cpy_InMsgType( ApplicationDataRef p_dst, ApplicationDataRef p_src )
{
	*( (InMsgType *)p_dst ) = *( (const InMsgType *)p_src );
}

static void cpy_UINT16( ApplicationDataRef p_dst, ApplicationDataRef p_src );
static void cpy_UINT16( ApplicationDataRef p_dst, ApplicationDataRef p_src )
{
	*( (UINT16 *)p_dst ) = *( (const UINT16 *)p_src );
}
const COPYFP copyfunc_rcv_unq_norm[TNUM_RCV_UNQ_NORM] = { (COPYFP)cpy_InMsgType, (COPYFP)cpy_ExMsgType, (COPYFP)cpy_UINT16, (COPYFP)cpy_UINT16 };
const COPYFP copyfunc_rcv_que_norm[TNUM_RCV_QUE_NORM] = { (COPYFP)cpy_InMsgType, (COPYFP)cpy_ExMsgType };
const COPYFP copyfunc_snd_ex_trig_norm[TNUM_SND_EX_TRIG_NORM] = { (COPYFP)cpy_ExMsgType };
const COPYFP copyfunc_snd_ex_pend_norm[TNUM_SND_EX_PEND_NORM] = { (COPYFP)cpy_UINT16, (COPYFP)cpy_UINT16 };

UINT8 const msgsize_snd_ex_trig_norm[TNUM_SND_EX_TRIG_NORM] = { sizeof( ExMsgType ) };
UINT8 const msgsize_snd_ex_pend_norm[TNUM_SND_EX_PEND_NORM] = { sizeof( UINT16 ), sizeof( UINT16 ) };

/* UNQUEUEDbZ[Wobt@̏֐ */
void unque_init( void )
{
	(void)com_local_memset( (VP)(&msgbuf_RecvInStMsg), (INT8)0, (UINT32)(sizeof( InMsgType )) );
	(void)com_local_memset( (VP)(&msgbuf_RecvExStMsg1), (INT8)0, (UINT32)(sizeof( ExMsgType )) );
	(void)com_local_memset( (VP)(&msgbuf_RecvExStMsg2), (INT8)0, (UINT32)(sizeof( UINT16 )) );
	(void)com_local_memset( (VP)(&msgbuf_RecvExStMsg3), (INT8)0, (UINT32)(sizeof( UINT16 )) );
}

void init_flags( void )
{
}

extern void COMCALLBACKNAME( NotifyRecvExFix1 )( void );
extern void COMCALLBACKNAME( NotifyRecvExFix2 )( void );
extern void COMCALLBACKNAME( NotifyRecvExFix3 )( void );
extern void COMCALLBACKNAME( NotifyRecvExFix4 )( void );
extern void COMCALLBACKNAME( NotifyRecvExVal )( void );
extern void COMCALLBACKNAME( NotifyRecvInQu )( void );
extern void COMCALLBACKNAME( NotifyRecvInSt )( void );
extern void COMCALLBACKNAME( NotifySendExFix1 )( void );
extern void COMCALLBACKNAME( NotifySendExFix2 )( void );
extern void COMCALLBACKNAME( NotifySendExFix3 )( void );
extern void COMCALLBACKNAME( NotifySendExVal )( void );


static StatusType filter_func_RecvInQuMsg( ApplicationDataRef p_in );
static StatusType filter_func_RecvInQuMsg( ApplicationDataRef p_in )
{
	return E_OK;
}

static StatusType filter_func_RecvInStMsg( ApplicationDataRef p_in );
static StatusType filter_func_RecvInStMsg( ApplicationDataRef p_in )
{
	return E_OK;
}

static StatusType filter_func_SendExFixMsg1( ApplicationDataRef p_in );
static StatusType filter_func_SendExFixMsg1( ApplicationDataRef p_in )
{
	return E_OK;
}

static StatusType filter_func_RecvExQuMsg( ApplicationDataRef p_in );
static StatusType filter_func_RecvExQuMsg( ApplicationDataRef p_in )
{
	return E_OK;
}

static StatusType filter_func_RecvExStMsg1( ApplicationDataRef p_in );
static StatusType filter_func_RecvExStMsg1( ApplicationDataRef p_in )
{
	return E_OK;
}

static StatusType filter_func_SendExFixMsg2( ApplicationDataRef p_in );
static StatusType filter_func_SendExFixMsg2( ApplicationDataRef p_in )
{
	return E_OK;
}

static UINT16 old_value_SendExFixMsg3;
static StatusType filter_func_SendExFixMsg3( ApplicationDataRef p_in );
static StatusType filter_func_SendExFixMsg3( ApplicationDataRef p_in )
{
	StatusType ercd = E_IL_FILTERED;

	if(*(UINT16 *)p_in != old_value_SendExFixMsg3)
	{
		old_value_SendExFixMsg3 = *(UINT16 *)p_in;
		ercd = E_OK;
	}
	return ercd;
}

static void filter_init_func_SendExFixMsg3( ApplicationDataRef p_in );
static void filter_init_func_SendExFixMsg3( ApplicationDataRef p_in )
{
	old_value_SendExFixMsg3 = *(UINT16 *)p_in;
}

static UINT16 old_value_RecvExStMsg2;
static StatusType filter_func_RecvExStMsg2( ApplicationDataRef p_in );
static StatusType filter_func_RecvExStMsg2( ApplicationDataRef p_in )
{
	StatusType ercd = E_IL_FILTERED;

	if(*(UINT16 *)p_in != old_value_RecvExStMsg2)
	{
		old_value_RecvExStMsg2 = *(UINT16 *)p_in;
		ercd = E_OK;
	}
	return ercd;
}

static void filter_init_func_RecvExStMsg2( ApplicationDataRef p_in );
static void filter_init_func_RecvExStMsg2( ApplicationDataRef p_in )
{
	old_value_RecvExStMsg2 = *(UINT16 *)p_in;
}

static StatusType filter_func_RecvExStMsg3( ApplicationDataRef p_in );
static StatusType filter_func_RecvExStMsg3( ApplicationDataRef p_in )
{
	return E_OK;
}

/* tB^O */
const FILTFP filter_rcv_unq_norm[TNUM_RCV_UNQ_NORM] = { filter_func_RecvInStMsg, filter_func_RecvExStMsg1, filter_func_RecvExStMsg2, filter_func_RecvExStMsg3 };
const INIFILTFP filter_init_rcv_unq_norm[TNUM_RCV_UNQ_NORM] = { INIFILTFP_NULL, INIFILTFP_NULL, filter_init_func_RecvExStMsg2, INIFILTFP_NULL };
const FILTFP filter_rcv_que_norm[TNUM_RCV_QUE_NORM] = { filter_func_RecvInQuMsg, filter_func_RecvExQuMsg };
const INIFILTFP filter_init_rcv_que_norm[TNUM_RCV_QUE_NORM] = { INIFILTFP_NULL, INIFILTFP_NULL };

const FILTFP filter_snd_ex_trig_norm[TNUM_SND_EX_TRIG_NORM] = { filter_func_SendExFixMsg1 };
const INIFILTFP filter_init_snd_ex_trig_norm[TNUM_SND_EX_TRIG_NORM] = { INIFILTFP_NULL };
const FILTFP filter_snd_ex_pend_norm[TNUM_SND_EX_PEND_NORM] = { filter_func_SendExFixMsg2, filter_func_SendExFixMsg3 };
const INIFILTFP filter_init_snd_ex_pend_norm[TNUM_SND_EX_PEND_NORM] = { INIFILTFP_NULL, filter_init_func_SendExFixMsg3 };

/* le[u */
const UINT64 initialvalue_rcv_unq_norm[TNUM_RCV_UNQ_NORM] = { 0, 0, 0, 0 };
const UINT64 initialvalue_rcv_unq_dyna[TNUM_RCV_UNQ_DYNA] = { 0 };
const UINT64 initialvalue_rcv_que_norm[TNUM_RCV_QUE_NORM] = { 0, 0 };

const UINT64 initialvalue_snd_ex_trig_norm[TNUM_SND_EX_TRIG_NORM] = { 0 };
const UINT64 initialvalue_snd_ex_pend_norm[TNUM_SND_EX_PEND_NORM] = { 0, 0 };
const UINT64 initialvalue_snd_ex_trig_dyna[TNUM_SND_EX_TRIG_DYNA] = { 0 };
const UINT64 initialvalue_snd_ex_pend_dyna[TNUM_SND_EX_PEND_DYNA + 1] = { 0 };

/* oCgI[_[̗L */
const UINT8 byteorder_snd_ex_trig_norm[TNUM_SND_EX_TRIG_NORM] = { FALSE };
const UINT8 byteorder_snd_ex_pend_norm[TNUM_SND_EX_PEND_NORM] = { TRUE, TRUE };

const IPDUType ipduid_snd_ex_trig_norm[TNUM_SND_EX_TRIG_NORM] = { SendFixDirectIpdu };
const UINT32 bitsize_snd_ex_trig_norm[TNUM_SND_EX_TRIG_NORM] = { 80 };
const UINT32 offset_snd_ex_trig_norm[TNUM_SND_EX_TRIG_NORM] = { 0 };

const IPDUType ipduid_snd_ex_pend_norm[TNUM_SND_EX_PEND_NORM] = { SendFixPeriodicIpdu, SendFixPeriodicIpdu };
const UINT32 bitsize_snd_ex_pend_norm[TNUM_SND_EX_PEND_NORM] = { 16, 16 };
const UINT32 offset_snd_ex_pend_norm[TNUM_SND_EX_PEND_NORM] = { 0, 16 };

const IPDUType ipduid_snd_ex_trig_zero[TNUM_SND_EX_TRIG_ZERO + 1] = { 0 };

const IPDUType ipduid_snd_ex_trig_dyna[TNUM_SND_EX_TRIG_DYNA] = { SendValDirectIpdu };
const UINT32 offset_snd_ex_trig_dyna[TNUM_SND_EX_TRIG_DYNA] = { 0 };
const UINT32 bitsize_snd_ex_trig_dyna[TNUM_SND_EX_TRIG_DYNA] = { 80 };

const IPDUType ipduid_snd_ex_pend_dyna[TNUM_SND_EX_PEND_DYNA + 1] = { 0 };
const UINT32 offset_snd_ex_pend_dyna[TNUM_SND_EX_PEND_DYNA + 1] = { 0 };
const UINT32 bitsize_snd_ex_pend_dyna[TNUM_SND_EX_PEND_DYNA + 1] = { 0 };

/* class1 */
const FP notification1_rcv_unq_norm[TNUM_RCV_UNQ_NORM] = { COMCALLBACKNAME( NotifyRecvInSt ), COMCALLBACKNAME( NotifyRecvExFix2 ), COMCALLBACKNAME( NotifyRecvExFix3 ), COMCALLBACKNAME( NotifyRecvExFix4 ) };
const FP notification1_rcv_unq_zero[TNUM_RCV_UNQ_ZERO + 1] = { FP_NULL };
const FP notification1_rcv_unq_dyna[TNUM_RCV_UNQ_DYNA] = { COMCALLBACKNAME( NotifyRecvExVal ) };
const FP notification1_rcv_que_norm[TNUM_RCV_QUE_NORM] = { COMCALLBACKNAME( NotifyRecvInQu ), COMCALLBACKNAME( NotifyRecvExFix1 ) };

/* class2 */
const FP notification2_snd_ex_trig_norm[TNUM_SND_EX_TRIG_NORM] = { COMCALLBACKNAME( NotifySendExFix1 ) };
const FP notification2_snd_ex_pend_norm[TNUM_SND_EX_PEND_NORM] = { COMCALLBACKNAME( NotifySendExFix2 ), COMCALLBACKNAME( NotifySendExFix3 ) };
const FP notification2_snd_ex_trig_zero[TNUM_SND_EX_TRIG_ZERO + 1] = { FP_NULL };
const FP notification2_snd_ex_trig_dyna[TNUM_SND_EX_TRIG_DYNA] = { COMCALLBACKNAME( NotifySendExVal ) };
const FP notification2_snd_ex_pend_dyna[TNUM_SND_EX_PEND_DYNA + 1] = { FP_NULL };

/* class3 */
const FP notification3_rcv_unq_norm[TNUM_RCV_UNQ_NORM] = { FP_NULL, FP_NULL, FP_NULL, FP_NULL };
const FP notification3_rcv_unq_zero[TNUM_RCV_UNQ_ZERO + 1] = { FP_NULL };
const FP notification3_rcv_unq_dyna[TNUM_RCV_UNQ_DYNA] = { FP_NULL };
const FP notification3_rcv_que_norm[TNUM_RCV_QUE_NORM] = { FP_NULL, FP_NULL };

/* class4 */
const FP notification4_snd_ex_trig_norm[TNUM_SND_EX_TRIG_NORM] = { FP_NULL };
const FP notification4_snd_ex_pend_norm[TNUM_SND_EX_PEND_NORM] = { FP_NULL, FP_NULL };
const FP notification4_snd_ex_trig_zero[TNUM_SND_EX_TRIG_ZERO + 1] = { FP_NULL };
const FP notification4_snd_ex_trig_dyna[TNUM_SND_EX_TRIG_DYNA] = { FP_NULL };
const FP notification4_snd_ex_pend_dyna[TNUM_SND_EX_PEND_DYNA + 1] = { FP_NULL };

const FP resetflag1_rcv_unq_norm[TNUM_RCV_UNQ_NORM] = { FP_NULL, FP_NULL, FP_NULL, FP_NULL };
const FP resetflag1_rcv_unq_zero[TNUM_RCV_UNQ_ZERO + 1] = { FP_NULL };
const FP resetflag1_rcv_unq_dyna[TNUM_RCV_UNQ_DYNA] = { FP_NULL };
const FP resetflag1_rcv_que_norm[TNUM_RCV_QUE_NORM] = { FP_NULL, FP_NULL };

const FP resetflag2_snd_ex_trig_norm[TNUM_SND_EX_TRIG_NORM] = { FP_NULL };
const FP resetflag2_snd_ex_pend_norm[TNUM_SND_EX_PEND_NORM] = { FP_NULL, FP_NULL };
const FP resetflag2_snd_ex_trig_zero[TNUM_SND_EX_TRIG_ZERO + 1] = { FP_NULL };
const FP resetflag2_snd_ex_trig_dyna[TNUM_SND_EX_TRIG_DYNA] = { FP_NULL };
const FP resetflag2_snd_ex_pend_dyna[TNUM_SND_EX_PEND_DYNA + 1] = { FP_NULL };

const FP resetflag3_rcv_unq_norm[TNUM_RCV_UNQ_NORM] = { FP_NULL, FP_NULL, FP_NULL, FP_NULL };
const FP resetflag3_rcv_unq_zero[TNUM_RCV_UNQ_ZERO + 1] = { FP_NULL };
const FP resetflag3_rcv_unq_dyna[TNUM_RCV_UNQ_DYNA] = { FP_NULL };
const FP resetflag3_rcv_que_norm[TNUM_RCV_QUE_NORM] = { FP_NULL, FP_NULL };

const FP resetflag4_snd_ex_trig_norm[TNUM_SND_EX_TRIG_NORM] = { FP_NULL };
const FP resetflag4_snd_ex_pend_norm[TNUM_SND_EX_PEND_NORM] = { FP_NULL, FP_NULL };
const FP resetflag4_snd_ex_trig_zero[TNUM_SND_EX_TRIG_ZERO + 1] = { FP_NULL };
const FP resetflag4_snd_ex_trig_dyna[TNUM_SND_EX_TRIG_DYNA] = { FP_NULL };
const FP resetflag4_snd_ex_pend_dyna[TNUM_SND_EX_PEND_DYNA + 1] = { FP_NULL };

/* CALLOUT */
const CALLOUTFP callout_netorder_snd_ex_trig_norm[TNUM_SND_EX_TRIG_NORM] = { CALLOUTFP_NULL };
const CALLOUTFP callout_cpuorder_snd_ex_trig_norm[TNUM_SND_EX_TRIG_NORM] = { CALLOUTFP_NULL };

const CALLOUTFP callout_netorder_snd_ex_pend_norm[TNUM_SND_EX_PEND_NORM] = { CALLOUTFP_NULL, COMCalloutSendExFixMsgNWCb };
const CALLOUTFP callout_cpuorder_snd_ex_pend_norm[TNUM_SND_EX_PEND_NORM] = { CALLOUTFP_NULL, COMCalloutSendExFixMsgCPUCb };

const CALLOUTFP callout_netorder_snd_ex_trig_zero[TNUM_SND_EX_TRIG_ZERO + 1] = { CALLOUTFP_NULL };
const CALLOUTFP callout_cpuorder_snd_ex_trig_zero[TNUM_SND_EX_TRIG_ZERO + 1] = { CALLOUTFP_NULL };

const CALLOUTFP callout_netorder_snd_ex_trig_dyna[TNUM_SND_EX_TRIG_DYNA] = { CALLOUTFP_NULL };
const CALLOUTFP callout_cpuorder_snd_ex_trig_dyna[TNUM_SND_EX_TRIG_DYNA] = { CALLOUTFP_NULL };

const CALLOUTFP callout_netorder_snd_ex_pend_dyna[TNUM_SND_EX_PEND_DYNA + 1] = { CALLOUTFP_NULL };
const CALLOUTFP callout_cpuorder_snd_ex_pend_dyna[TNUM_SND_EX_PEND_DYNA + 1] = { CALLOUTFP_NULL };

/* zMe[u */
const MessageIdentifier sndlist_snd_in_norm_SendInMsg[] = { RecvInQuMsg, RecvInStMsg, MSG_NULL };
const MessageIdentifier *sndlist_snd_in_norm[TNUM_SND_IN_NORM] = { sndlist_snd_in_norm_SendInMsg };
const MessageIdentifier *sndlist_snd_in_zero[TNUM_SND_IN_ZERO + 1] = { 0 };

const UINT8 bitorder_snd_ex_trig_norm[TNUM_SND_EX_TRIG_NORM] = { COM_BITBIG };
const UINT8 bitorder_snd_ex_pend_norm[TNUM_SND_EX_PEND_NORM] = { COM_BITBIG, COM_BITBIG };
const UINT8 bitorder_snd_ex_trig_dyna[TNUM_SND_EX_TRIG_DYNA] = { COM_BITBIG };
const UINT8 bitorder_snd_ex_pend_dyna[TNUM_SND_EX_PEND_DYNA + 1] = { 0 };

/*** IPDU Object ***/

const CANType can_id_snd[TNUM_SND_CAN] = { 0x0401, 0x0402, 0x0403 };
const UINT8 can_type_snd[TNUM_SND_CAN] = { 0x00, 0x00, 0x00 };
const CANType can_id_rcv[TNUM_RCV_CAN] = { 0x0201, 0x0202, 0x0203 };
const UINT8 can_type_rcv[TNUM_RCV_CAN] = { 0x00, 0x00, 0x00 };

UINT8 ulpdu_rcv_buf_RecvFixNoTimeOutIpdu[10];
UINT8 ulpdu_rcv_buf_RecvFixTimeOutIpdu[4];
UINT8 ulpdu_rcv_buf_RecvValNoTimeOutIpdu[10];

/* ULPDUMobt@AhXz */
UINT8* const ulpdu_rcv_buf_addr[TNUM_RCV_IPDU] = {
	ulpdu_rcv_buf_RecvFixNoTimeOutIpdu,
	ulpdu_rcv_buf_RecvFixTimeOutIpdu,
	ulpdu_rcv_buf_RecvValNoTimeOutIpdu,
};
UINT8 ulpdu_rcv_dlc[TNUM_RCV_IPDU];

UINT8 ipdu_snd_dlc[TNUM_SND_IPDU];

UINT8 ipdubuf_SendFixDirectIpdu[10];
UINT8 ipdubuf_RecvFixNoTimeOutIpdu[10];
UINT8 ipdubuf_SendFixPeriodicIpdu[4];
UINT8 ipdubuf_RecvFixTimeOutIpdu[4];
UINT8 ipdubuf_SendValDirectIpdu[10];
UINT8 ipdubuf_RecvValNoTimeOutIpdu[10];

UINT8* const msgbuf_snd_ipdu[TNUM_SND_IPDU] = { ipdubuf_SendFixDirectIpdu, ipdubuf_SendFixPeriodicIpdu, ipdubuf_SendValDirectIpdu };
UINT8* const msgbuf_rcv_ipdu[TNUM_RCV_IPDU] = { ipdubuf_RecvFixNoTimeOutIpdu, ipdubuf_RecvFixTimeOutIpdu, ipdubuf_RecvValNoTimeOutIpdu };

const UINT8 tnum_snd_ipdu = TNUM_SND_IPDU;
const UINT8 tnum_rcv_ipdu = TNUM_RCV_IPDU;

const MessageIdentifier sndlist_snd_ipdu_SendFixDirectIpdu[] = { SendExFixMsg1, MSG_NULL };
const MessageIdentifier sndlist_rcv_ipdu_RecvFixNoTimeOutIpdu[] = { RecvFixNMsg1, MSG_NULL };
const MessageIdentifier sndlist_snd_ipdu_SendFixPeriodicIpdu[] = { SendExFixMsg2, SendExFixMsg3, MSG_NULL };
const MessageIdentifier sndlist_rcv_ipdu_RecvFixTimeOutIpdu[] = { RecvFixNMsg2, RecvFixNMsg3, MSG_NULL };
const MessageIdentifier sndlist_snd_ipdu_SendValDirectIpdu[] = { SendExValMsg, MSG_NULL };
const MessageIdentifier sndlist_rcv_ipdu_RecvValNoTimeOutIpdu[] = { RecvExValNMsg, MSG_NULL };

const MessageIdentifier *sndlist_snd_ipdu[TNUM_SND_IPDU] = { sndlist_snd_ipdu_SendFixDirectIpdu, sndlist_snd_ipdu_SendFixPeriodicIpdu, sndlist_snd_ipdu_SendValDirectIpdu };
const MessageIdentifier *sndlist_rcv_ipdu[TNUM_RCV_IPDU] = { sndlist_rcv_ipdu_RecvFixNoTimeOutIpdu, sndlist_rcv_ipdu_RecvFixTimeOutIpdu, sndlist_rcv_ipdu_RecvValNoTimeOutIpdu };

const UINT32 bitsize_snd_ipdu[TNUM_SND_IPDU] = { 80, 32, 80 };
const UINT32 bitsize_rcv_ipdu[TNUM_RCV_IPDU] = { 80, 32, 80 };
const UINT32 bytesize_snd_ipdu[TNUM_SND_IPDU] = { 10, 4, 10 };
const UINT32 bytesize_rcv_ipdu[TNUM_RCV_IPDU] = { 10, 4, 10 };

const UINT64 timeperiod_snd_ipdu[TNUM_SND_IPDU] = { 0, 3000, 0 };

const UINT64 timeoffset_snd_ipdu[TNUM_SND_IPDU] = { 0, 1000, 0 };

const UINT64 delaytime_snd_ipdu[TNUM_SND_IPDU] = { 100, 0, 100 };

const UINT64 timeout_snd_ipdu[TNUM_SND_IPDU] = { 1000, 1000, 1000 };
const UINT64 timeout_rcv_ipdu[TNUM_RCV_IPDU] = { 0, 3500, 0 };

const UINT64 firsttimeout_snd_ipdu[TNUM_SND_IPDU] = { 0, 0, 0 };
const UINT64 firsttimeout_rcv_ipdu[TNUM_RCV_IPDU] = { 0, 5000, 0 };

const CALLOUTFP callout_snd_ipdu[TNUM_SND_IPDU] = { CALLOUTFP_NULL, CALLOUTFP_NULL, CALLOUTFP_NULL };
const CALLOUTFP callout_rcv_ipdu[TNUM_RCV_IPDU] = { CALLOUTFP_NULL, CALLOUTFP_NULL, CALLOUTFP_NULL };

const UINT8 *layerused_snd_ipdu[TNUM_SND_IPDU] = { "CAN", "CAN", "CAN" };
const UINT8 *layerused_rcv_ipdu[TNUM_RCV_IPDU] = { "CAN", "CAN", "CAN" };

const UINT8 transmode_snd_ipdu[TNUM_SND_IPDU] = { COM_IPDU_DIRECT, COM_IPDU_PERIODIC, COM_IPDU_DIRECT };

UINT32 msgbuf_snd_tmp[12/4];
UINT32 msgbuf_snd_after_swapbytes[12/4];
const UINT32 bytesize_snd_max = 12;

UINT32 ipdubuf_rcv_tmp[12/4];
UINT32 msgbuf_rcv_after_swapbytes[12/4];
UINT32 msgbuf_rcv_ipdu_tmp[12/4];
const UINT32 bytesize_rcv_max = 12;

UINT8 flg_snd_ipdu[TNUM_SND_IPDU];

TimerType timer_snd_ctrl[TNUM_SND_IPDU] = { timer_snd_ctrl_SendFixDirectIpdu, timer_snd_ctrl_SendFixPeriodicIpdu, timer_snd_ctrl_SendValDirectIpdu };
TimerType timer_snd_periodic[TNUM_SND_IPDU] = { timer_snd_periodic_SendFixDirectIpdu, timer_snd_periodic_SendFixPeriodicIpdu, timer_snd_periodic_SendValDirectIpdu };

TimerType timer_rcv_ctrl[TNUM_RCV_IPDU] = { timer_rcv_ctrl_RecvFixNoTimeOutIpdu, timer_rcv_ctrl_RecvFixTimeOutIpdu, timer_rcv_ctrl_RecvValNoTimeOutIpdu };


const UINT8 tnum_timer = TNUM_TIMER;
const TickCounterType timinib_tickid[TNUM_TIMER] = { COM_TIMETICK, COM_TIMETICK, COM_TIMETICK, COM_TIMETICK, COM_TIMETICK, COM_TIMETICK, COM_TIMETICK, COM_TIMETICK, COM_TIMETICK };
TimerType timcb_next[TNUM_TIMER];
TimerType timcb_prev[TNUM_TIMER];
TimerTickType timcb_timval[TNUM_TIMER];
TimerTickType timcb_cycle[TNUM_TIMER];
TIMFP timcb_cback[TNUM_TIMER];
UINT8 timcb_param[TNUM_TIMER];

UINT8 ulpdu_snd_buf_SendFixDirectIpdu[10];
UINT8 ulpdu_snd_buf_SendFixPeriodicIpdu[4];
UINT8 ulpdu_snd_buf_SendValDirectIpdu[10];

UINT8 *const ulpdu_snd_buf_addr[TNUM_SND_IPDU] = { ulpdu_snd_buf_SendFixDirectIpdu, ulpdu_snd_buf_SendFixPeriodicIpdu, ulpdu_snd_buf_SendValDirectIpdu };

UINT8 ulpdu_snd_dlc[TNUM_SND_IPDU];

const UINT8 tnum_snd_can = TNUM_SND_CAN;
const UINT8 tnum_rcv_can = TNUM_RCV_CAN;

const UINT8 can_snd_msgkind[TNUM_SND_CAN] = { UL_CAN_MSG_DIV_FRAME, UL_CAN_MSG_ONCE_FRAME, UL_CAN_MSG_DIV_FRAME };
const UINT8 can_rcv_msgkind[TNUM_RCV_CAN] = { UL_CAN_MSG_DIV_FRAME, UL_CAN_MSG_ONCE_FRAME, UL_CAN_MSG_DIV_FRAME };
IPDUType ulcan_snd_queue[TNUM_SND_CAN];
ULCANWorkInfo ulcan_rcv_info[TNUM_RCV_CAN];

const ULSndFunc snd_ul_func[TNUM_SND_IPDU] = { snd_ul_can, snd_ul_can, snd_ul_can };
const ULSndCancelFunc snd_cancel_ul_func[TNUM_SND_IPDU] = { snd_ul_can_cancel, snd_ul_can_cancel, snd_ul_can_cancel };
const ULRcvFunc rcv_ul_func[TNUM_RCV_IPDU] = { rcv_ul_can, rcv_ul_can, rcv_ul_can };
const MessageIdentifier sndlist_RecvFixNMsg1[] = { RecvExQuMsg, RecvExStMsg1,  MSG_NULL };
const MessageIdentifier sndlist_RecvFixNMsg2[] = { RecvExStMsg2,  MSG_NULL };
const MessageIdentifier sndlist_RecvFixNMsg3[] = { RecvExStMsg3,  MSG_NULL };
const MessageIdentifier sndlist_RecvExValNMsg[] = { RecvExValMsg,  MSG_NULL};

/* ze[u */
const MessageIdentifier *sndlist_rcv_ipdu_norm[TNUM_RCV_IPDU_NORM] = { sndlist_RecvFixNMsg1, sndlist_RecvFixNMsg2, sndlist_RecvFixNMsg3 };
const MessageIdentifier sndlist_rcv_ipdu_zero[TNUM_RCV_IPDU_ZERO + 1] = { MSG_NULL };
const MessageIdentifier *sndlist_rcv_ipdu_dyna[TNUM_RCV_IPDU_DYNA] = { sndlist_RecvExValNMsg };

const UINT8 bitorder_rcv_ipdu_norm[TNUM_RCV_IPDU_NORM] = { COM_BITBIG, COM_BITBIG, COM_BITBIG };
const UINT8 bitorder_rcv_ipdu_dyna[TNUM_RCV_IPDU_DYNA] = { COM_BITBIG };

const UINT32 bitsize_rcv_ipdu_norm[TNUM_RCV_IPDU_NORM] = { 80, 16, 16 };
const UINT32 bitsize_rcv_ipdu_dyna[TNUM_RCV_IPDU_DYNA] = { 80 };

const UINT32 bytesize_rcv_ipdu_norm[TNUM_RCV_IPDU_NORM] = { 10, 2, 2 };
const UINT32 bytesize_rcv_ipdu_dyna[TNUM_RCV_IPDU_DYNA] = { 10 };

const UINT32 offset_rcv_ipdu_norm[TNUM_RCV_IPDU_NORM] = { 0, 0, 16 };
const UINT32 offset_rcv_ipdu_dyna[TNUM_RCV_IPDU_DYNA] = { 0 };

const UINT8 byteorder_rcv_ipdu_norm[TNUM_RCV_IPDU_NORM] = { FALSE, TRUE, TRUE };

const CALLOUTFP callout_netorder_rcv_ipdu_norm[TNUM_RCV_IPDU_NORM] = { CALLOUTFP_NULL, COMCalloutRecvExStMsgNWCb, CALLOUTFP_NULL };
const CALLOUTFP callout_cpuorder_rcv_ipdu_norm[TNUM_RCV_IPDU_NORM] = { CALLOUTFP_NULL, COMCalloutRecvExStMsgCPUCb, CALLOUTFP_NULL };
const CALLOUTFP callout_netorder_rcv_ipdu_zero[TNUM_RCV_IPDU_ZERO + 1] = { CALLOUTFP_NULL };
const CALLOUTFP callout_cpuorder_rcv_ipdu_zero[TNUM_RCV_IPDU_ZERO + 1] = { CALLOUTFP_NULL };
const CALLOUTFP callout_netorder_rcv_ipdu_dyna[TNUM_RCV_IPDU_DYNA] = { CALLOUTFP_NULL };
const CALLOUTFP callout_cpuorder_rcv_ipdu_dyna[TNUM_RCV_IPDU_DYNA] = { CALLOUTFP_NULL };

asm(".glb _StartCOMExtension");
asm("_StartCOMExtension .equ 0");


