/*
 *  com_cfg.h
 *  Thu Nov 08 19:35:28 2007
 *  SG Version 2.11
 *  sg.exe .\com_message.oil -oscancom -lj -I ./../../../sg/impl_oil -cpu=m32c
 */
#ifndef COM_CFG_H
#define COM_CFG_H

#include "com.h"
#include "msg_types.h"


#define ComNormalMode 	( ( COMApplicationModeType ) ( 1u << 0 ) )

#define USE_COMERRORHOOK

#define COMAPPMODE ( ComNormalMode )

#define TNUM_COMAPPMODE 1
#if ( TNUM_COMAPPMODE > MAX_COMAPPMODE )
#error "Total number of COMApplicationMode exceed the maximal value."
#endif

#define SendInMsg (MessageIdentifier)(0x4000)
#define RecvInQuMsg (MessageIdentifier)(0x0600)
#define RecvInStMsg (MessageIdentifier)(0x0400)
#define SendExFixMsg1 (MessageIdentifier)(0x5000)
#define RecvExQuMsg (MessageIdentifier)(0x0601)
#define RecvExStMsg1 (MessageIdentifier)(0x0401)
#define SendExFixMsg2 (MessageIdentifier)(0x7000)
#define SendExFixMsg3 (MessageIdentifier)(0x7001)
#define RecvExStMsg2 (MessageIdentifier)(0x0402)
#define RecvExStMsg3 (MessageIdentifier)(0x0403)
#define SendExValMsg (MessageIdentifier)(0xd000)
#define RecvExValMsg (MessageIdentifier)(0x0c00)

#define TNUM_MSG 12
#if ( TNUM_MSG > MAX_MSG )
#error "The total number of message objects exceed the maximal value."
#endif /* #if ( TNUM_MSG > MAX_MSG ) */

#define TNUM_QUE_ELEM_RecvInQuMsg 4
#define TNUM_QUE_ELEM_RecvExQuMsg 3

#if ( TNUM_QUE_ELEM_RecvInQuMsg > MAX_QUESIZE || TNUM_QUE_ELEM_RecvExQuMsg > MAX_QUESIZE )
#error "The queue size exceed the maximal value."
#endif

extern COMCallout(RecvExStMsgNWCb);
extern COMCallout(RecvExStMsgCPUCb);
extern COMCallout(SendExFixMsgNWCb);
extern COMCallout(SendExFixMsgCPUCb);


/*** IPDU Object ***/

#define UL_SUPPORT_CAN

#define SendFixDirectIpdu 0
#define SendFixPeriodicIpdu 1
#define SendValDirectIpdu 2
#define RecvFixNoTimeOutIpdu 0
#define RecvFixTimeOutIpdu 1
#define RecvValNoTimeOutIpdu 2

#define TNUM_SND_CAN 3
#define TNUM_RCV_CAN 3
#define TNUM_SND_LIN 0
#define TNUM_RCV_LIN 0

#define OFFSET_SND_IPDU_CAN 0
#define OFFSET_RCV_IPDU_CAN 0
#define OFFSET_SND_IPDU_LIN 3
#define OFFSET_RCV_IPDU_LIN 3

#define CAN_STATIC_ALL_ID

#define TNUM_SND_IPDU 3
#define TNUM_RCV_IPDU 3

#define timer_snd_ctrl_SendFixDirectIpdu 0
#define timer_snd_ctrl_SendFixPeriodicIpdu 1
#define timer_snd_ctrl_SendValDirectIpdu 2
#define timer_snd_periodic_SendFixDirectIpdu 0 + TNUM_SND_IPDU
#define timer_snd_periodic_SendFixPeriodicIpdu 1 + TNUM_SND_IPDU
#define timer_snd_periodic_SendValDirectIpdu 2 + TNUM_SND_IPDU
#define timer_rcv_ctrl_RecvFixNoTimeOutIpdu 0 + ( TNUM_SND_IPDU * 2 )
#define timer_rcv_ctrl_RecvFixTimeOutIpdu 1 + ( TNUM_SND_IPDU * 2 )
#define timer_rcv_ctrl_RecvValNoTimeOutIpdu 2 + ( TNUM_SND_IPDU * 2 )

#define COM_TIMETICK 0

#define TNUM_TIMER 9


/*** NETWORKMESSAGE Object ***/

#define SendFixTrgNMsg (MessageIdentifier)(0x0000)
#define RecvFixNMsg1 (MessageIdentifier)(0x0500)
#define SendFixPndNMsg1 (MessageIdentifier)(0x0001)
#define SendFixPndNMsg2 (MessageIdentifier)(0x0002)
#define RecvFixNMsg2 (MessageIdentifier)(0x0501)
#define RecvFixNMsg3 (MessageIdentifier)(0x0502)
#define SendExValNMsg (MessageIdentifier)(0x0003)
#define RecvExValNMsg (MessageIdentifier)(0x0d00)
#endif	/* ! COM_CFG_H */

