/*
 *  kernel_cfg.c
 *  Thu Nov 08 19:35:27 2007
 *  SG Version 2.11
 *  sg.exe sample_com.oil -template=..\..\..\config\m32c-renesas\s810-clg3-85\m32c85.sgt -I ./../../../sg/impl_oil -os=ECC2
 */
#include "osek_kernel.h"
#include "kernel_id.h"
#include "alarm.h"
#include "interrupt.h"
#include "resource.h"
#include "task.h"

#define __STK_UNIT VP
#define __TCOUNT_STK_UNIT(sz) (((sz) + sizeof(__STK_UNIT) - 1) / sizeof(__STK_UNIT))

#define TNUM_ALARM     1
#define TNUM_COUNTER   2
#define TNUM_ISR2      4
#define TNUM_RESOURCE  2
#define TNUM_TASK      2
#define TNUM_EXTTASK   1

const UINT8 tnum_alarm    = TNUM_ALARM;
const UINT8 tnum_counter  = TNUM_COUNTER;
const UINT8 tnum_isr2     = TNUM_ISR2;
const UINT8 tnum_resource = TNUM_RESOURCE;
const UINT8 tnum_task     = TNUM_TASK;
const UINT8 tnum_exttask  = TNUM_EXTTASK;

 /****** Object OS ******/

 /****** Object TASK ******/

const TaskType MainTask = 0;
const TaskType COMReceiveTask = 1;

extern void TASKNAME( MainTask )( void );
extern void TASKNAME( COMReceiveTask )( void );

static __STK_UNIT _stack_MainTask[__TCOUNT_STK_UNIT(768)];
static __STK_UNIT _stack_priority_12[__TCOUNT_STK_UNIT(768)];

const Priority tinib_inipri[TNUM_TASK] = { TPRI_MINTASK + 10, TPRI_MINTASK + 12, };
const Priority tinib_exepri[TNUM_TASK] = { TPRI_MAXTASK, TPRI_MAXTASK, };
const UINT8 tinib_maxact[TNUM_TASK] = { (1) - 1, (3) - 1, };
const AppModeType tinib_autoact[TNUM_TASK] = { 0x00000001, 0x00000000, };
const FP tinib_task[TNUM_TASK] = { TASKNAME( MainTask ), TASKNAME( COMReceiveTask ), };
const __STK_UNIT tinib_stk[TNUM_TASK] = { (__STK_UNIT)_stack_MainTask, (__STK_UNIT)_stack_priority_12, };
const UINT16 tinib_stksz[TNUM_TASK] = { 768, 768, };

UINT8 tcb_tstat[TNUM_TASK];
Priority tcb_curpri[TNUM_TASK];
DEFINE_CTXB(TNUM_TASK);
TaskType tcb_next[TNUM_TASK];
EventMaskType tcb_curevt[TNUM_EXTTASK];
EventMaskType tcb_waievt[TNUM_EXTTASK];
UINT8 tcb_actcnt[TNUM_TASK];
ResourceType tcb_lastres[TNUM_TASK];

 /****** Object COUNTER ******/

const CounterType SysTimerCnt = 0;
const CounterType SampleCnt = 1;

const TickType cntinib_maxval[TNUM_COUNTER] = { 999, 99, };
const TickType cntinib_maxval2[TNUM_COUNTER] = { 1999, 199, };
const TickType cntinib_tickbase[TNUM_COUNTER] = { 1, 10, };
const TickType cntinib_mincyc[TNUM_COUNTER] = { 1, 10, };

AlarmType cntcb_almque[TNUM_COUNTER];
TickType cntcb_curval[TNUM_COUNTER];

 /****** Object ALARM ******/

const AlarmType MainCycArm = 0;

DeclareTask(MainTask);
DeclareEvent(MainEvt);
static void _setevent_alarm_MainCycArm( void );
static void _setevent_alarm_MainCycArm( void )
{ (void)SetEvent( MainTask, MainEvt ); }

const CounterType alminib_cntid[TNUM_ALARM] = { 0, };
const FP alminib_cback[TNUM_ALARM] = { _setevent_alarm_MainCycArm, };
const AppModeType alminib_autosta[TNUM_ALARM] = { 0x00000001, };
const TickType alminib_almval[TNUM_ALARM] = { 100, };
const TickType alminib_cycle[TNUM_ALARM] = { 100, };

AlarmType almcb_next[TNUM_ALARM];
AlarmType almcb_prev[TNUM_ALARM];
TickType almcb_almval[TNUM_ALARM];
TickType almcb_cycle[TNUM_ALARM];

 /****** Object RESOURCE ******/

const ResourceType COMReceiveRes = 1;

const Priority resinib_ceilpri[TNUM_RESOURCE] = { TPRI_SCHEDULER, TPRI_MINISR + 5, };

Priority rescb_prevpri[TNUM_RESOURCE];
ResourceType rescb_prevres[TNUM_RESOURCE];

 /****** Object EVENT ******/

const EventMaskType MainEvt = (1UL << 0);

 /****** Object ISR ******/

const IsrType SysTimerInt = 0;
const IsrType CANReceiveInt = 1;
const IsrType CANSndInt = 2;
const IsrType COMAlarmTimer = 3;

#define IPL_MAXISR2 5
const IPL ipl_maxisr2 = IPL_MAXISR2;


const Priority isrinib_intpri[TNUM_ISR2] = { TPRI_MINISR + (4), TPRI_MINISR + (5), TPRI_MINISR + (5), TPRI_MINISR + (4), };
ResourceType isrcb_lastres[TNUM_ISR2];

 /****** Object APPMODE ******/

void object_initialize( void )
{
	alarm_initialize();
	interrupt_initialize();
	resource_initialize();
	task_initialize();
}

/*
 *  TOPPERS/OSEK Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK Kernel
 * 
 *  Copyright (C) 2006 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */







/* ݓOQ */
ISR1_EXTERNAL(RxHwSerialInt);
ISR2_EXTERNAL(SysTimerInt);
ISR2_EXTERNAL(CANReceiveInt);
ISR2_EXTERNAL(CANSndInt);
ISR2_EXTERNAL(COMAlarmTimer);


/* ݓ	*/
ISR1_ENTRY(RxHwSerialInt);
ISR2_ENTRY(SysTimerInt,(0));
ISR2_ENTRY(CANReceiveInt,(1));
ISR2_ENTRY(CANSndInt,(2));
ISR2_ENTRY(COMAlarmTimer,(3));


/* xN^e[uo^V{OQ	*/
UNUSED_INT_EXTERNAL();	/* `̊ */
asm("	.glb	_start");	/* Zbg */

/* ݉σxN^e[u	*/
asm("	.section vvector");

UNUSED_INT_SYMBOL(); /*  0, +0x00: BRK	*/
UNUSED_INT_SYMBOL(); /*  1, +0x04: \̈	*/
UNUSED_INT_SYMBOL(); /*  2, +0x08: \̈	*/
UNUSED_INT_SYMBOL(); /*  3, +0x0C: \̈	*/
UNUSED_INT_SYMBOL(); /*  4, +0x10: \̈	*/
UNUSED_INT_SYMBOL(); /*  5, +0x14: \̈	*/
UNUSED_INT_SYMBOL(); /*  6, +0x18: \̈	*/
UNUSED_INT_SYMBOL(); /*  7, +0x1C: \̈	*/
UNUSED_INT_SYMBOL(); /*  8, +0x20: DMA0	*/
UNUSED_INT_SYMBOL(); /*  9, +0x24: DMA1	*/
UNUSED_INT_SYMBOL(); /* 10, +0x28: DMA2	*/
UNUSED_INT_SYMBOL(); /* 11, +0x2C: DMA3	*/
ISR2_SYMBOL(SysTimerInt); /* 12, +0x30: ^C}A0	*/
ISR2_SYMBOL(COMAlarmTimer); /* 13, +0x34: ^C}A1	*/
UNUSED_INT_SYMBOL(); /* 14, +0x38: ^C}A2	*/
UNUSED_INT_SYMBOL(); /* 15, +0x3C: ^C}A3	*/
UNUSED_INT_SYMBOL(); /* 16, +0x40: ^C}A4	*/
UNUSED_INT_SYMBOL(); /* 17, +0x44: UART0M,NACK	*/
UNUSED_INT_SYMBOL(); /* 18, +0x48: UART0M,ACK	*/
UNUSED_INT_SYMBOL(); /* 19, +0x4C: UART1M,NACK	*/
ISR1_SYMBOL(RxHwSerialInt); /* 20, +0x50: UART1M,ACK	*/
UNUSED_INT_SYMBOL(); /* 21, +0x54: ^C}B0	*/
UNUSED_INT_SYMBOL(); /* 22, +0x58: ^C}B1	*/
UNUSED_INT_SYMBOL(); /* 23, +0x5C: ^C}B2	*/
UNUSED_INT_SYMBOL(); /* 24, +0x60: ^C}B3	*/
UNUSED_INT_SYMBOL(); /* 25, +0x64: ^C}B4	*/
UNUSED_INT_SYMBOL(); /* 26, +0x68: O5	*/
UNUSED_INT_SYMBOL(); /* 27, +0x6C: O4	*/
UNUSED_INT_SYMBOL(); /* 28, +0x70: O3	*/
UNUSED_INT_SYMBOL(); /* 29, +0x74: O2	*/
UNUSED_INT_SYMBOL(); /* 30, +0x78: O1	*/
UNUSED_INT_SYMBOL(); /* 31, +0x7C: O0	*/
UNUSED_INT_SYMBOL(); /* 32, +0x80: ^C}B5	*/
UNUSED_INT_SYMBOL(); /* 33, +0x84: UART2M,NACK	*/
UNUSED_INT_SYMBOL(); /* 34, +0x88: UART2M,ACK	*/
UNUSED_INT_SYMBOL(); /* 35, +0x8C: UART3M,NACK	*/
UNUSED_INT_SYMBOL(); /* 36, +0x90: UART3M,ACK	*/
UNUSED_INT_SYMBOL(); /* 37, +0x94: UART4M,NACK	*/
UNUSED_INT_SYMBOL(); /* 38, +0x98: UART4M,ACK	*/
UNUSED_INT_SYMBOL(); /* 39, +0x9C: oXՓˌo/X^[gRfBVo/XgbvRfBVo(UART2)/QG[	*/
UNUSED_INT_SYMBOL(); /* 40, +0xA0: oXՓˌo/X^[gRfBVo/XgbvRfBVo(UART3/UART0)/QG[	*/
UNUSED_INT_SYMBOL(); /* 41, +0xA4: oXՓˌo/X^[gRfBVo/XgbvRfBVo(UART4/UART1)/QG[	*/
UNUSED_INT_SYMBOL(); /* 42, +0xA8: A/Dϊ0	*/
UNUSED_INT_SYMBOL(); /* 43, +0xAC: L[	*/
UNUSED_INT_SYMBOL(); /* 44, +0xB0: CeWFgI/O0,CAN3	*/
UNUSED_INT_SYMBOL(); /* 45, +0xB4: CeWFgI/O1,CAN4	*/
UNUSED_INT_SYMBOL(); /* 46, +0xB8: CeWFgI/O2	*/
UNUSED_INT_SYMBOL(); /* 47, +0xBC: CeWFgI/O3	*/
UNUSED_INT_SYMBOL(); /* 48, +0xC0: CeWFgI/O4	*/
UNUSED_INT_SYMBOL(); /* 49, +0xC4: CAN5	*/
UNUSED_INT_SYMBOL(); /* 50, +0xC8: \̈	*/
UNUSED_INT_SYMBOL(); /* 51, +0xCC: \̈	*/
UNUSED_INT_SYMBOL(); /* 52, +0xD0: CeWFgI/O8	*/
ISR2_SYMBOL(CANReceiveInt); /* 53, +0xD4: CeWFgI/O9,CAN0	*/
ISR2_SYMBOL(CANSndInt); /* 54, +0xD4: CeWFgI/O10,CAN1	*/
UNUSED_INT_SYMBOL(); /* 55, +0xDC: \̈	*/
UNUSED_INT_SYMBOL(); /* 56, +0xE0: \̈	*/
UNUSED_INT_SYMBOL(); /* 57, +0xE8: CAN2	*/
UNUSED_INT_SYMBOL(); /* 58, +0xE8: \̈	*/
UNUSED_INT_SYMBOL(); /* 59, +0xEC: \̈	*/
UNUSED_INT_SYMBOL(); /* 60, +0xF0: \̈	*/
UNUSED_INT_SYMBOL(); /* 61, +0xF4: \̈	*/
UNUSED_INT_SYMBOL(); /* 62, +0xF8: \̈	*/
UNUSED_INT_SYMBOL(); /* 63, +0xFC: \̈	*/

/* ݌ŒxN^e[u	*/
asm("	.section fvector");

UNUSED_INT_SYMBOL(); /* 64, 0xFFFFDC: `	*/
UNUSED_INT_SYMBOL(); /* 65, 0xFFFFE0: I[o[t[	*/
UNUSED_INT_SYMBOL(); /* 66, 0xFFFFE4: BRK	*/
UNUSED_INT_SYMBOL(); /* 67, 0xFFFFE8: AhXv	*/
UNUSED_INT_SYMBOL(); /* 68, 0xFFFFEC: \̈	*/
UNUSED_INT_SYMBOL(); /* 69, 0xFFFFF0: Ď^C}/U~o	*/
UNUSED_INT_SYMBOL(); /* 70, 0xFFFFF4: \̈	*/
UNUSED_INT_SYMBOL(); /* 71, 0xFFFFF8: NMI	*/
asm("	.lword	_start"); /* 72, 0xFFFFFC: Zbg	*/

/* tbN[`	*/
NULL_ERRORHOOK


NULL_PRETASKHOOK
NULL_POSTTASKHOOK




