/*
 *  TOPPERS/OSEK Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK Kernel
 * 
 *  Copyright (C) 2005-2006 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */


/*
 *  SFRwb_t@CiM32C/85pj
 */

#if !defined( _SFR_M32C_85_H_ )				/* d`h~					*/
#define		_SFR_M32C_85_H_					/* d`h~					*/


/********************************************************/
/* doH											*/
/********************************************************/
/*------------------------------------------------------
	Voltage detection register 1
------------------------------------------------------*/
#pragma ADDRESS		vcr1_addr	001bH		/* doWX^1			*/
typedef union {
	struct{
		UINT8	reserved1:3;	/* RW 0Œ									*/
		UINT8	vc13:1;		/* RO dቺj^ 0:Vcc1<Vdet4,1:Vcc1>=Vdet4	*/
		UINT8	reserved2:4;	/* RW 0Œ									*/
	} bit;
	UINT8 byte;
} VCR1_TYPE;	/* Zbgl:0000 1000B									*/
VCR1_TYPE	vcr1_addr;

#define		VC13		vcr1_addr.bit.vc13	/* Voltage down monitor flag	*/

/*------------------------------------------------------
	Voltage detection register 2
------------------------------------------------------*/
#pragma ADDRESS		vcr2_addr	001bH		/* doWX^2			*/
typedef union {
	struct{
		UINT8	reserved:6;		/* RW 0Œ									*/
		UINT8	vc26:1;			/* RW Zbg̈Ď 0:,1:L		*/
		UINT8	vc27:1;			/* RW dቺĎ 0:,1:L			*/
	} bit;
	UINT8 byte;
} VCR2_TYPE;	/* Zbgl:0000 0000B									*/
VCR2_TYPE	vcr2_addr;

#define		VC26		vcr2_addr.bit.vc26	/* Reset level monitor bit		*/
#define		VC27		vcr2_addr.bit.vc27	/* Voltage down monitor bit		*/

/*------------------------------------------------------
	Voltage down detect interrupt register
------------------------------------------------------*/
#pragma ADDRESS		d4int_addr	002FH	/* dቺo荞݃WX^		*/
typedef union {
	struct{
		UINT8	d40:1;		/* RW dቺo荞݋ 0:֎~,1:	*/
		UINT8	d41:1;			/* RW STOP/WAIT 0:,1:L		*/
		UINT8	d42:1;			/* RW dωotO 0:o,1:o	*/
		UINT8	d43:1;		/* RW WDTI[ot[otO 0:o,1:o	*/
		UINT8	df0:1;			/* RW TvONbN(df0,df1Ŏw)	*/
		UINT8	df1:1;			/* 00:f8,01:f16,10:f32,11:f64				*/
		UINT8	reserved:2;		/* RO s									*/
	} bit;
	UINT8 byte;
} D4INT_TYPE;	/* Zbgl:0000 0000B									*/
D4INT_TYPE	d4int_addr;

#define		D40     d4int_addr.bit.d40	/* Voltage down detection interrupt enable bit */
#define		D41     d4int_addr.bit.d41	/* STOP-WAIT mode deactivation control bit */
#define		D42     d4int_addr.bit.d42	/* Voltage change detection flag */
#define		D43     d4int_addr.bit.d43	/* WDT overflow detect flag */
#define		DF0     d4int_addr.bit.df0	/* (b5-b4) Sampling clock select bit */
#define		DF1     d4int_addr.bit.df1

/********************************************************/
/* vZbT[h										*/
/********************************************************/
/*------------------------------------------------------
	Processor mode register 0
------------------------------------------------------*/
#pragma ADDRESS		pm0_addr	0004H	/* vZbT[hWX^0		*/
typedef union {
	struct{
		UINT8	pm00:1;	/* RW vZbT[h(pm00,pm01Ŏw)				*/
		UINT8	pm01:1;	/* RW 00B:VO`bv,01B:g,			*/
						/*    11B:}CNvZbT						*/
		UINT8	pm02:1;	/* RW R/W[hI 0:~RD/~WD/~BHE,1:~RD/~WRH/~WRL	*/
		UINT8	pm03:1;	/* RW \tgEFAZbg 0:ʏ펞,1:Zbg		*/
		UINT8	pm04:1;	/* RW }`vNXoXԑI(pm04,pm05Ŏw)	*/
		UINT8	pm05:1;	/* RW 00B:gp,01B:~CS2Ɋ,					*/
						/*    10B:~CS1Ɋ,11B:~CSSԂɊ		*/
		UINT8	reserved:1;	/* RW 0Œ										*/
		UINT8	pm07:1;	/* RW BCLKo͋@\I 0:BCLKo,					*/
						/* RW 1:o͂Ȃ(CM00/CM0100BƂ邱)		*/
	} bit;
	UINT8 byte;
} PM0_TYPE;	/* Zbgl:1000 0000B(CNVss[qL)/0000 0011(CNVss[qH)	*/
PM0_TYPE	pm0_addr;

#define		PM0			pm0_addr.byte
#define		PM00		pm0_addr.bit.pm00     /* Processor mode bit */
#define		PM01		pm0_addr.bit.pm01     /* Processor mode bit */
#define		PM02		pm0_addr.bit.pm02     /* R/W mode select bit */
#define		PM03		pm0_addr.bit.pm03     /* Software reset bit */
#define		PM04		pm0_addr.bit.pm04     /* Multiplexed bus space select bit */
#define		PM05		pm0_addr.bit.pm05     /* Multiplexed bus space select bit */
#define		PM07		pm0_addr.bit.pm07     /* BCLK output function select bit */

/*------------------------------------------------------
	Processor mode register 1
------------------------------------------------------*/
#pragma ADDRESS		pm1_addr	0005H	/* vZbT[hWX^1		*/
typedef union {
	struct{
		UINT8	pm10:1;		/* RW Ö惂[h(pm10,pm11Ŏw)			*/
		UINT8	pm11:1;		/* RW 00B`11B:[h0`[h3					*/
		UINT8	pm12:1;		/* RW 0B:EFCgȂ,1B:			*/
		UINT8	pm13:1;		/* RW SFR̈EFCg 0B:1EFCg,1B:2			*/
		UINT8	pm14:1;		/* RW ALE[qI(pm14,pm15Ŏw)00B:ALEȂ,	*/
		UINT8	pm15:1;		/* RW 01:P53/BCLK,10B:P56/RAS,11B:P54/HLDA		*/
		UINT8	reserved:2;		/* RW 0Œ									*/
	} bit;
	UINT8 byte;
} PM1_TYPE;						/* Zbgl:0000 0000B					*/
PM1_TYPE	pm1_addr;

#define		PM1			pm1_addr.byte
#define		PM10		pm1_addr.bit.pm10     /* External memory area mode bit */
#define		PM11		pm1_addr.bit.pm11     /* External memory area mode bit */
#define		PM12		pm1_addr.bit.pm12     /* Internal memory wait bit */
#define		PM13		pm1_addr.bit.pm13     /* SFR wait bit */
#define		PM14		pm1_addr.bit.pm14     /* ALE pin select bit */
#define		PM15		pm1_addr.bit.pm15     /* ALE pin select bit */

/********************************************************/
/* oX													*/
/********************************************************/
/*------------------------------------------------------
	External data bus width control register
------------------------------------------------------*/
#pragma ADDRESS		ds_addr		000bH	/* Of[^oX䃌WX^		*/
typedef union {
	struct{
		UINT8	ds0:1;		/* RW Ö0f[^oX 0B:8bit/1B:16bit	*/
		UINT8	ds1:1;		/* RW Ö1f[^oX 0B:8bit/1B:16bit	*/
		UINT8	ds2:1;		/* RW Ö2f[^oX 0B:8bit/1B:16bit	*/
		UINT8	ds3:1;		/* RW Ö3f[^oX 0B:8bit/1B:16bit	*/
		UINT8	no_assign:4;	/*    s ޏꍇ0					*/
	} bit;
	UINT8 byte;
} DS_TYPE;	/* Zbgl:XXXX 1000B(BYTE[qL)/XXXX 0000(BYTE[qH)	*/
DS_TYPE	ds_addr;

#define		DS		ds_addr.byte
#define		DS0		ds_addr.bit.ds0
#define		DS1		ds_addr.bit.ds1
#define		DS2		ds_addr.bit.ds2
#define		DS3		ds_addr.bit.ds3

/*------------------------------------------------------
	External space wait control register 0
------------------------------------------------------*/
#pragma ADDRESS		ewcr0_addr	0048H	/* ÖEGCg䃌WX^ 0	*/
typedef union {
	struct{
		UINT8	ewcr00:1;		/* RW oXTCNI(0`4Ŏw)	*/
		UINT8	ewcr01:1;
		UINT8	ewcr02:1;
		UINT8	ewcr03:1;
		UINT8	ewcr04:1;
		UINT8	no_assign1:1;	/*    s ޏꍇ0					*/
		UINT8	ewcr06:1;		/* RW JoTCN 0B:Ȃ/1B:}		*/
		UINT8	no_assign2:1;	/*    s ޏꍇ0					*/
	} bit;
	UINT8 byte;
} EWCR0_TYPE;	/* Zbgl:X0X0 0011B										*/
EWCR0_TYPE	ewcr0_addr;

#define		EWCR0		ewcr0_addr.byte
#define		EWCR00		ewcr0_addr.bit.ewcr00
#define		EWCR01		ewcr0_addr.bit.ewcr01
#define		EWCR02		ewcr0_addr.bit.ewcr02
#define		EWCR03		ewcr0_addr.bit.ewcr03
#define		EWCR04		ewcr0_addr.bit.ewcr04
#define		EWCR06		ewcr0_addr.bit.ewcr06

/*------------------------------------------------------
	External space wait control register 1
------------------------------------------------------*/
#pragma ADDRESS		ewcr1_addr	0049H	/* ÖEGCg䃌WX^ 1	*/
typedef union {
	struct{
		UINT8	ewcr10:1;		/* RW oXTCNI(0`4Ŏw)	*/
		UINT8	ewcr11:1;
		UINT8	ewcr12:1;
		UINT8	ewcr13:1;
		UINT8	ewcr14:1;
		UINT8	no_assign1:1;	/*    s ޏꍇ0					*/
		UINT8	ewcr16:1;		/* RW JoTCN 0B:Ȃ/1B:}		*/
		UINT8	no_assign2:1;	/*    s ޏꍇ0					*/
	} bit;
	UINT8 byte;
} EWCR1_TYPE;	/* Zbgl:X0X0 0011B										*/
EWCR1_TYPE	ewcr1_addr;

#define		EWCR1		ewcr1_addr.byte
#define		EWCR10		ewcr1_addr.bit.ewcr10
#define		EWCR11		ewcr1_addr.bit.ewcr11
#define		EWCR12		ewcr1_addr.bit.ewcr12
#define		EWCR13		ewcr1_addr.bit.ewcr13
#define		EWCR14		ewcr1_addr.bit.ewcr14
#define		EWCR16		ewcr1_addr.bit.ewcr16

/*------------------------------------------------------
	External space wait control register 2
------------------------------------------------------*/
#pragma ADDRESS		ewcr2_addr	004AH	/* ÖEGCg䃌WX^ 2	*/
typedef union {
	struct{
		UINT8	ewcr20:1;		/* RW oXTCNI(0`4Ŏw)	*/
		UINT8	ewcr21:1;
		UINT8	ewcr22:1;
		UINT8	ewcr23:1;
		UINT8	ewcr24:1;
		UINT8	no_assign1:1;	/*    s ޏꍇ0					*/
		UINT8	ewcr26:1;		/* RW JoTCN 0B:Ȃ/1B:}		*/
		UINT8	no_assign2:1;	/*    s ޏꍇ0					*/
	} bit;
	UINT8 byte;
} EWCR2_TYPE;	/* Zbgl:X0X0 0011B										*/
EWCR2_TYPE	ewcr2_addr;

#define		EWCR2		ewcr2_addr.byte
#define		EWCR20		ewcr2_addr.bit.ewcr20
#define		EWCR21		ewcr2_addr.bit.ewcr21
#define		EWCR22		ewcr2_addr.bit.ewcr22
#define		EWCR23		ewcr2_addr.bit.ewcr23
#define		EWCR24		ewcr2_addr.bit.ewcr24
#define		EWCR26		ewcr2_addr.bit.ewcr26

/*------------------------------------------------------
	External space wait control register 3
------------------------------------------------------*/
#pragma ADDRESS		ewcr3_addr	004BH	/* ÖEGCg䃌WX^ 3	*/
typedef union {
	struct{
		UINT8	ewcr30:1;		/* RW oXTCNI(0`4Ŏw)	*/
		UINT8	ewcr31:1;
		UINT8	ewcr32:1;
		UINT8	ewcr33:1;
		UINT8	ewcr34:1;
		UINT8	no_assign1:1;	/*    s ޏꍇ0					*/
		UINT8	ewcr36:1;		/* RW JoTCN 0B:Ȃ/1B:}		*/
		UINT8	no_assign2:1;	/*    s ޏꍇ0					*/
	} bit;
	UINT8 byte;
} EWCR3_TYPE;	/* Zbgl:X0X0 0011B										*/
EWCR3_TYPE	ewcr3_addr;

#define		EWCR3		ewcr3_addr.byte
#define		EWCR30		ewcr3_addr.bit.ewcr30
#define		EWCR31		ewcr3_addr.bit.ewcr31
#define		EWCR32		ewcr3_addr.bit.ewcr32
#define		EWCR33		ewcr3_addr.bit.ewcr33
#define		EWCR34		ewcr3_addr.bit.ewcr34
#define		EWCR36		ewcr3_addr.bit.ewcr36

/********************************************************/
/* NbNH										*/
/********************************************************/
/*------------------------------------------------------
	System clock control register 0
------------------------------------------------------*/
#pragma ADDRESS		cm0_addr	0006H	/* VXeNbN䃌WX^0	*/
typedef union {
	struct{
		UINT8	cm00:1;	/* RW NbNo͋@\I(cm00,cm01Ŏw)			*/
		UINT8	cm01:1;	/* RW 00B:P53,01B:fc,10B:f8,11B:f32					*/
		UINT8	cm02:1;	/* RW EFCƃ[hӋ@\NbN~			*/
						/*    0B:~Ȃ,1B:~						*/
		UINT8	cm03:1;	/* RW Xcin-out쓮\͑I 0B:Low,1B:Hi				*/
		UINT8	cm04:1;	/* RW |[gXc؂ւ 0B:o̓|[g,1B:Xcin-out	*/
		UINT8	cm05:1;	/* RW CNbN~ 0B:U,1B:~			*/
		UINT8	cm06:1;	/* RW Ď^C}@\I 0B:,1B:Zbg		*/
		UINT8	cm07:1;	/* RW VXeNbNI 0B:Xin-out,1B:Xcin-out	*/
	} bit;
	UINT8 byte;
} CM0_TYPE;						/* Zbgl:0000 1000B					*/
CM0_TYPE	cm0_addr;

#define		CM0		cm0_addr.byte
#define		CM00	cm0_addr.bit.cm00
#define		CM01	cm0_addr.bit.cm01
#define		CM02	cm0_addr.bit.cm02
#define		CM03	cm0_addr.bit.cm03
#define		CM04	cm0_addr.bit.cm04
#define		CM05	cm0_addr.bit.cm05
#define		CM06	cm0_addr.bit.cm06
#define		CM07	cm0_addr.bit.cm07

/*------------------------------------------------------
	System clock control register 1
------------------------------------------------------*/
#pragma ADDRESS		cm1_addr	0007H	/* VXeNbN䃌WX^1	*/
typedef union {
	struct{
		UINT8	cm10:1;			/* RW SNbN~ 0B:M,1B:~	*/
		UINT8	reserved1:4;	/* RW 0Œ									*/
		UINT8	reserved2:1;	/* RW 1Œ									*/
		UINT8	reserved3:1;	/* RW 0Œ									*/
		UINT8	cm17:1;			/* RW CPUNbN؂ւ 0B:C,1B:PLL	*/
	} bit;
	UINT8 byte;
} CM1_TYPE;						/* Zbgl:0010 0000B					*/
CM1_TYPE	cm1_addr;

#define		CM1		cm1_addr.byte
#define		CM10	cm1_addr.bit.cm10
#define		CM17	cm1_addr.bit.cm17

/*------------------------------------------------------
	Main clock division register
------------------------------------------------------*/
#pragma ADDRESS		mcd_addr	000cH	/* CNbNWX^		*/
typedef union {
	struct{
		UINT8	mcd0:1;		/* RW CNbNI(0`4Ŏw)		*/
		UINT8	mcd1:1;
		UINT8	mcd2:1;
		UINT8	mcd3:1;
		UINT8	mcd4:1;
		UINT8	reserved:3;	/* RO s										*/
	} bit;
	UINT8 byte;
} MCD_TYPE;						/* Zbgl:XXX0 1000B					*/
MCD_TYPE	mcd_addr;

#define		MCD			mcd_addr.byte
#define		MCD0		mcd_addr.bit.mcd0
#define		MCD1		mcd_addr.bit.mcd1
#define		MCD2		mcd_addr.bit.mcd2
#define		MCD3		mcd_addr.bit.mcd3
#define		MCD4		mcd_addr.bit.mcd4

/*------------------------------------------------------
	Oscillation stop detect register
------------------------------------------------------*/
#pragma ADDRESS		cm2_addr	000dH	/* VXeNbN䃌WX^2	*/
typedef union {
	struct{
		UINT8	cm20:1;		/* RW M~o 0B:,1B:L			*/
		UINT8	cm21:1;		/* RW CPUNbNI 0B:CM17,1B:IV[^		*/
		UINT8	cm22:1;		/* RW M~otO 0B:~,1B:~o	*/
		UINT8	cm23:1;		/* RO CNbNj^ 0B:M,1B:~		*/
		UINT8	reserved:4;		/* RW 0Œ									*/
	} bit;
	UINT8 byte;
} CM2_TYPE;						/* Zbgl:0000 0000B					*/
CM2_TYPE	cm2_addr;

#define		CM2			cm2_addr.byte
#define		CM20		cm2_addr.bit.cm20
#define		CM21		cm2_addr.bit.cm21
#define		CM22		cm2_addr.bit.cm22
#define		CM23		cm2_addr.bit.cm23

/*------------------------------------------------------
	Count source prescaler register
------------------------------------------------------*/
#pragma ADDRESS		tcspr_addr	035fH	/* JEg\[XvXP[WX^	*/
typedef union {
	struct{
		UINT8	cnt0:1;
		UINT8	cnt1:1;
		UINT8	cnt2:1;
		UINT8	cnt3:1;
		UINT8	reserved:3;	/* RO s										*/
		UINT8	cst:1;
	} bit;
	 UINT8 byte;
} TCSPR_TYPE;
TCSPR_TYPE	tcspr_addr;

#define		TCSPR		tcspr_addr.byte

#define		CNT0		tcspr_addr.bit.cnt0
#define		CNT1		tcspr_addr.bit.cnt1
#define		CNT2		tcspr_addr.bit.cnt2
#define		CNT3		tcspr_addr.bit.cnt3
#define		CST			tcspr_addr.bit.cst

/*------------------------------------------------------
    Clock prescaler reset flag
------------------------------------------------------*/
#pragma ADDRESS		cpsrf_addr	0341H	/* vpvXP[ZbgtO	*/
typedef union {
	struct{
		UINT8	no_assign:7;	/*    s ޏꍇ0					*/
		UINT8	cpsr:1;
	} bit;
	 UINT8 byte;
} CPSRF_TYPE;
CPSRF_TYPE	cpsrf_addr;

#define		CPSRF		cpsrf_addr.byte

#define		CPSR		cpsrf_addr.bit.cpsr

/*------------------------------------------------------
    PLL Control Register 0
------------------------------------------------------*/
#pragma ADDRESS		plc0_addr	0026H		/* PLL䃌WX^0				*/
typedef union {
	struct{
		UINT8	plc00:1;
		UINT8	plc01:1;
		UINT8	plc02:1;
		UINT8	reserved1:1;	/* RO s									*/
		UINT8	reserved2:1;	/* RW 1Œ									*/
		UINT8	reserved3:1;	/* RW 0Œ									*/
		UINT8	reserved4:1;	/* RW 1Œ									*/
		UINT8	plc07:1;
	} bit;
	UINT8 byte;
} PLC0_TYPE;					/* Zbgl:0001 X010B					*/
PLC0_TYPE	plc0_addr;

#define		PLC0		plc0_addr.byte
#define		PLC00		plc0_addr.bit.plc00
#define		PLC01		plc0_addr.bit.plc01
#define		PLC02		plc0_addr.bit.plc02
#define		PLC07		plc0_addr.bit.plc07

/*------------------------------------------------------
    PLL Control Register 1
------------------------------------------------------*/
#pragma ADDRESS		plc1_addr	0027H		/* PLL䃌WX^1				*/
typedef union {
	struct{
		UINT8	reserved1:1;	/* RW 0Œ									*/
		UINT8	reserved2:1;	/* RW 1Œ									*/
		UINT8	plc12:1;
		UINT8	reserved3:1;	/* RW 0Œ									*/
		UINT8	reserved4:1;	/* RO s									*/
		UINT8	reserved5:3;	/* RW 0Œ									*/
	} bit;
	UINT8 byte;
} PLC1_TYPE;					/* Zbgl:000X 0000B					*/
PLC1_TYPE	plc1_addr;

#define		PLC1		plc1_addr.byte
#define		PLC12		plc1_addr.bit.plc12

/*------------------------------------------------------
	Processor mode register 2
------------------------------------------------------*/
#pragma ADDRESS		pm2_addr	0013H	/* vZbT[hWX^2		*/
typedef union {
	struct{
		UINT8	reserved1:1;	/* RW 0Œ									*/
		UINT8	pm21:1;
		UINT8	pm22:1;
		UINT8	reserved2:1;	/* RW 0Œ									*/
		UINT8	pm24:1;
		UINT8	pm25:1;
		UINT8	pm26:1;
		UINT8	pm27:1;
	} bit;
	UINT8 byte;
} PM2_TYPE;						/* Zbgl:0000 0000B					*/
PM2_TYPE	pm2_addr;

#define		PM2			pm2_addr.byte
#define		PM21		pm2_addr.bit.pm21
#define		PM22		pm2_addr.bit.pm22
#define		PM24		pm2_addr.bit.pm24
#define		PM25		pm2_addr.bit.pm25
#define		PM26		pm2_addr.bit.pm26
#define		PM27		pm2_addr.bit.pm27

/********************************************************/
/* veNg											*/
/********************************************************/
/*------------------------------------------------------
    Protect register
------------------------------------------------------*/
#pragma ADDRESS		prcr_addr	000aH		/* veNgWX				 */
typedef union {
	struct{
		UINT8	prcr0:1;
		UINT8	prcr1:1;
		UINT8	prcr2:1;
		UINT8	prcr3:1;
		UINT8	no_assign:4;	
	} bit;
	UINT8 byte;
} PRCR_TYPE;
PRCR_TYPE	prcr_addr;

#define		PRCR		prcr_addr.byte
#define		PRC0		prcr_addr.bit.prcr0    /* Enables writing to system clock control register 0 and 1 */
#define		PRC1		prcr_addr.bit.prcr1    /* Enables writing to processor mode register 0 and 1 */
#define		PRC2		prcr_addr.bit.prcr2    /* Enables writing to port P9 direction register and function select register A3 */
#define		PRC3		prcr_addr.bit.prcr3	/* Enables writing VDC control register and PLL VDC control register */

/********************************************************/
/* 荞												*/
/********************************************************/
/*------------------------------------------------------
	interrupt control register 1
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	ilvl0:1;            /* Interrupt priority level select bit */
		UINT8	ilvl1:1;            /* Interrupt priority level select bit */
		UINT8	ilvl2:1;            /* Interrupt priority level select bit */
		UINT8	ir:1;               /* Interrupt request bit */
		UINT8	no_assign:4;  
	} bit;
	UINT8	byte;
} ICR1_TYPE;

/*------------------------------------------------------
     ta0ic
------------------------------------------------------*/
#pragma ADDRESS     ta0ic_addr  006cH       /* Timer A0 interrupt control register */
ICR1_TYPE	ta0ic_addr;

#define		TA0IC      	ta0ic_addr.byte
#define		ILVL0_TA0IC ta0ic_addr.bit.ilvl0
#define		ILVL1_TA0IC ta0ic_addr.bit.ilvl1
#define		ILVL2_TA0IC ta0ic_addr.bit.ilvl2
#define		IR_TA0IC	ta0ic_addr.bit.ir

/*------------------------------------------------------
     ta1ic
------------------------------------------------------*/
#pragma ADDRESS     ta1ic_addr  008cH       /* Timer A1 interrupt control register */
ICR1_TYPE	ta1ic_addr;

#define		TA1IC      	ta1ic_addr.byte
#define		ILVL0_TA1IC ta1ic_addr.bit.ilvl0
#define		ILVL1_TA1IC ta1ic_addr.bit.ilvl1
#define		ILVL2_TA1IC ta1ic_addr.bit.ilvl2
#define		IR_TA1IC	ta1ic_addr.bit.ir

/*------------------------------------------------------
     ta2ic
------------------------------------------------------*/
#pragma ADDRESS     ta2ic_addr  006eH       /* Timer A2 interrupt control register */
ICR1_TYPE	ta2ic_addr;

#define		TA2IC      	ta2ic_addr.byte
#define		ILVL0_TA2IC ta2ic_addr.bit.ilvl0
#define		ILVL1_TA2IC ta2ic_addr.bit.ilvl1
#define		ILVL2_TA2IC ta2ic_addr.bit.ilvl2
#define		IR_TA2IC	ta2ic_addr.bit.ir

/*------------------------------------------------------
     ta3ic
------------------------------------------------------*/
#pragma ADDRESS     ta3ic_addr  008eH       /* Timer A3 interrupt control register */
ICR1_TYPE	ta3ic_addr;

#define		TA3IC      	ta3ic_addr.byte
#define		ILVL0_TA3IC ta3ic_addr.bit.ilvl0
#define		ILVL1_TA3IC ta3ic_addr.bit.ilvl1
#define		ILVL2_TA3IC ta3ic_addr.bit.ilvl2
#define		IR_TA3IC	ta3ic_addr.bit.ir

/*------------------------------------------------------
     ta4ic
------------------------------------------------------*/
#pragma ADDRESS     ta4ic_addr  0070H       /* Timer A4 interrupt control register */
ICR1_TYPE	ta4ic_addr;

#define		TA4IC      		ta4ic_addr.byte
#define		ILVL0_TA4IC 	ta4ic_addr.bit.ilvl0
#define		ILVL1_TA4IC 	ta4ic_addr.bit.ilvl1
#define		ILVL2_TA4IC 	ta4ic_addr.bit.ilvl2
#define		IR_TA4IC		ta4ic_addr.bit.ir

/*------------------------------------------------------
     tb0ic
------------------------------------------------------*/
#pragma ADDRESS     tb0ic_addr  0094H       /* Timer B0 interrupt control register */
ICR1_TYPE	tb0ic_addr;

#define		TB0IC       	tb0ic_addr.byte
#define		ILVL0_TB0IC 	tb0ic_addr.bit.ilvl0
#define		ILVL1_TB0IC 	tb0ic_addr.bit.ilvl1
#define		ILVL2_TB0IC 	tb0ic_addr.bit.ilvl2
#define		IR_TB0IC    	tb0ic_addr.bit.ir

/*------------------------------------------------------
     tb1ic
------------------------------------------------------*/
#pragma ADDRESS     tb1ic_addr  0076H       /* Timer B1 interrupt control register */
ICR1_TYPE	tb1ic_addr;

#define		TB1IC       	tb1ic_addr.byte
#define		ILVL0_TB1IC 	tb1ic_addr.bit.ilvl0
#define		ILVL1_TB1IC 	tb1ic_addr.bit.ilvl1
#define		ILVL2_TB1IC 	tb1ic_addr.bit.ilvl2
#define		IR_TB1IC    	tb1ic_addr.bit.ir

/*------------------------------------------------------
     tb2ic
------------------------------------------------------*/
#pragma ADDRESS     tb2ic_addr  0096H       /* Timer B2 interrupt control register */
ICR1_TYPE	tb2ic_addr;

#define		TB2IC       	tb2ic_addr.byte
#define		ILVL0_TB2IC 	tb2ic_addr.bit.ilvl0
#define		ILVL1_TB2IC 	tb2ic_addr.bit.ilvl1
#define		ILVL2_TB2IC 	tb2ic_addr.bit.ilvl2
#define		IR_TB2IC    	tb2ic_addr.bit.ir

/*------------------------------------------------------
     tb3ic
------------------------------------------------------*/
#pragma ADDRESS     tb3ic_addr  0078H       /* Timer B3 interrupt control register */
ICR1_TYPE	tb3ic_addr;

#define		TB3IC       	tb3ic_addr.byte
#define		ILVL0_TB3IC 	tb3ic_addr.bit.ilvl0
#define		ILVL1_TB3IC 	tb3ic_addr.bit.ilvl1
#define		ILVL2_TB3IC 	tb3ic_addr.bit.ilvl2
#define		IR_TB3IC    	tb3ic_addr.bit.ir

/*------------------------------------------------------
     tb4ic
------------------------------------------------------*/
#pragma ADDRESS     tb4ic_addr  0098H       /* Timer B4 interrupt control register */
ICR1_TYPE	tb4ic_addr;

#define		TB4IC       	tb4ic_addr.byte
#define		ILVL0_TB4IC 	tb4ic_addr.bit.ilvl0
#define		ILVL1_TB4IC 	tb4ic_addr.bit.ilvl1
#define		ILVL2_TB4IC 	tb4ic_addr.bit.ilvl2
#define		IR_TB4IC    	tb4ic_addr.bit.ir

/*------------------------------------------------------
     tb5ic
------------------------------------------------------*/
#pragma ADDRESS     tb5ic_addr  0069H       /* Timer B5 interrupt register */
ICR1_TYPE	tb5ic_addr;

#define		TB5IC       tb5ic_addr.byte
#define		ILVL0_TB5IC tb5ic_addr.bit.ilvl0
#define		ILVL1_TB5IC tb5ic_addr.bit.ilvl1
#define		ILVL2_TB5IC tb5ic_addr.bit.ilvl2
#define		IR_TB5IC    tb5ic_addr.bit.ir

/*------------------------------------------------------
     s0tic
------------------------------------------------------*/
#pragma ADDRESS     s0tic_addr  0090H       /* UART0 transmit interrupt control register */
ICR1_TYPE	s0tic_addr;

#define		S0TIC       	s0tic_addr.byte
#define		ILVL0_S0TIC 	s0tic_addr.bit.ilvl0
#define		ILVL1_S0TIC 	s0tic_addr.bit.ilvl1
#define		ILVL2_S0TIC 	s0tic_addr.bit.ilvl2
#define		IR_S0TIC	 	s0tic_addr.bit.ir

/*------------------------------------------------------
     s1tic
------------------------------------------------------*/
#pragma ADDRESS     s1tic_addr  0092H       /* UART1 transmit interrupt control register */
ICR1_TYPE	s1tic_addr;

#define		S1TIC       	s1tic_addr.byte
#define		ILVL0_S1TIC 	s1tic_addr.bit.ilvl0
#define		ILVL1_S1TIC 	s1tic_addr.bit.ilvl1
#define		ILVL2_S1TIC 	s1tic_addr.bit.ilvl2
#define		IR_S1TIC	 	s1tic_addr.bit.ir

/*------------------------------------------------------
     s2tic
------------------------------------------------------*/
#pragma ADDRESS     s2tic_addr  0089H       /* UART2 transmit/nack interrupt control register */
ICR1_TYPE	s2tic_addr;

#define		S2TIC       	s2tic_addr.byte
#define		ILVL0_S2TIC 	s2tic_addr.bit.ilvl0
#define		ILVL1_S2TIC 	s2tic_addr.bit.ilvl1
#define		ILVL2_S2TIC 	s2tic_addr.bit.ilvl2
#define		IR_S2TIC	 	s2tic_addr.bit.ir

/*------------------------------------------------------
     s3tic
------------------------------------------------------*/
#pragma ADDRESS     s3tic_addr  008bH       /* UART3 transmit/nack interrupt control register */
ICR1_TYPE	s3tic_addr;

#define		S3TIC       	s3tic_addr.byte
#define		ILVL0_S3TIC 	s3tic_addr.bit.ilvl0
#define		ILVL1_S3TIC 	s3tic_addr.bit.ilvl1
#define		ILVL2_S3TIC 	s3tic_addr.bit.ilvl2
#define		IR_S3TIC	 	s3tic_addr.bit.ir

/*------------------------------------------------------
     s4tic
------------------------------------------------------*/
#pragma ADDRESS     s4tic_addr  008dH       /* UART4 transmit/nack interrupt control register */
ICR1_TYPE	s4tic_addr;

#define		S4TIC       	s4tic_addr.byte
#define		ILVL0_S4TIC 	s4tic_addr.bit.ilvl0
#define		ILVL1_S4TIC 	s4tic_addr.bit.ilvl1
#define		ILVL2_S4TIC 	s4tic_addr.bit.ilvl2
#define		IR_S4TIC	 	s4tic_addr.bit.ir

/*------------------------------------------------------
     s0ric
------------------------------------------------------*/
#pragma ADDRESS     s0ric_addr  0072H       /* UART0 receive interrupt control register */
ICR1_TYPE	s0ric_addr;

#define		S0RIC       	s0ric_addr.byte
#define		ILVL0_S0RIC 	s0ric_addr.bit.ilvl0
#define		ILVL1_S0RIC 	s0ric_addr.bit.ilvl1
#define		ILVL2_S0RIC 	s0ric_addr.bit.ilvl2
#define		IR_S0RIC    	s0ric_addr.bit.ir

/*------------------------------------------------------
     s1ric
------------------------------------------------------*/
#pragma ADDRESS     s1ric_addr  0074H       /* UART1 receive interrupt control register */
ICR1_TYPE	s1ric_addr;

#define		S1RIC       	s1ric_addr.byte
#define		ILVL0_S1RIC 	s1ric_addr.bit.ilvl0
#define		ILVL1_S1RIC 	s1ric_addr.bit.ilvl1
#define		ILVL2_S1RIC 	s1ric_addr.bit.ilvl2
#define		IR_S1RIC    	s1ric_addr.bit.ir

/*------------------------------------------------------
     s2ric
------------------------------------------------------*/
#pragma ADDRESS     s2ric_addr  006bH       /* UART2 receive/ack interrupt control register */
ICR1_TYPE	s2ric_addr;

#define		S2RIC       	s2ric_addr.byte
#define		ILVL0_S2RIC 	s2ric_addr.bit.ilvl0
#define		ILVL1_S2RIC 	s2ric_addr.bit.ilvl1
#define		ILVL2_S2RIC 	s2ric_addr.bit.ilvl2
#define		IR_S2RIC    	s2ric_addr.bit.ir

/*------------------------------------------------------
     s3ric
------------------------------------------------------*/
#pragma ADDRESS     s3ric_addr  006dH       /* UART3 receive/ack interrupt control register */
ICR1_TYPE	s3ric_addr;

#define		S3RIC       s3ric_addr.byte
#define		ILVL0_S3RIC s3ric_addr.bit.ilvl0
#define		ILVL1_S3RIC s3ric_addr.bit.ilvl1
#define		ILVL2_S3RIC s3ric_addr.bit.ilvl2
#define		IR_S3RIC    s3ric_addr.bit.ir

/*------------------------------------------------------
     s4ric
------------------------------------------------------*/
#pragma ADDRESS     s4ric_addr  006fH       /* UART4 receive/ack interrupt control register */
ICR1_TYPE	s4ric_addr;

#define		S4RIC       s4ric_addr.byte
#define		ILVL0_S4RIC s4ric_addr.bit.ilvl0
#define		ILVL1_S4RIC s4ric_addr.bit.ilvl1
#define		ILVL2_S4RIC s4ric_addr.bit.ilvl2
#define		IR_S4RIC    s4ric_addr.bit.ir

/*------------------------------------------------------
     bcn0ic
------------------------------------------------------*/
#pragma ADDRESS		bcn0ic_addr 0071H		/* Bus collision (UART0) interrupt control register */
ICR1_TYPE	bcn0ic_addr;

#define		BCN0IC       	 bcn0ic_addr.byte
#define		ILVL0_BCN0IC 	 bcn0ic_addr.bit.ilvl0
#define		ILVL1_BCN0IC	 bcn0ic_addr.bit.ilvl1
#define		ILVL2_BCN0IC 	 bcn0ic_addr.bit.ilvl2
#define		IR_BCN0IC    	 bcn0ic_addr.bit.ir

/*------------------------------------------------------
     bcn1ic
------------------------------------------------------*/
#pragma ADDRESS		bcn1ic_addr 0091H		/* Bus collision (UART1) interrupt control register*/
ICR1_TYPE	bcn1ic_addr;

#define		BCN1IC       	 bcn1ic_addr.byte
#define		ILVL0_BCN1IC 	 bcn1ic_addr.bit.ilvl0
#define		ILVL1_BCN1IC	 bcn1ic_addr.bit.ilvl1
#define		ILVL2_BCN1IC 	 bcn1ic_addr.bit.ilvl2
#define		IR_BCN1IC    	 bcn1ic_addr.bit.ir

/*------------------------------------------------------
     bcn2ic
------------------------------------------------------*/
#pragma ADDRESS     bcn2ic_addr 008fH       /* Bus collision (UART2) interrupt control register */
ICR1_TYPE	bcn2ic_addr;

#define		BCN2IC       	 bcn2ic_addr.byte
#define		ILVL0_BCN2IC 	 bcn2ic_addr.bit.ilvl0
#define		ILVL1_BCN2IC	 bcn2ic_addr.bit.ilvl1
#define		ILVL2_BCN2IC 	 bcn2ic_addr.bit.ilvl2
#define		IR_BCN2IC    	 bcn2ic_addr.bit.ir

/*------------------------------------------------------
     bcn3ic
------------------------------------------------------*/
#pragma ADDRESS     bcn3ic_addr 0071H       /* Bus collision (UART3) interrupt control register */
ICR1_TYPE	bcn3ic_addr;

#define		BCN3IC       	 bcn3ic_addr.byte
#define		ILVL0_BCN3IC 	 bcn3ic_addr.bit.ilvl0
#define		ILVL1_BCN3IC	 bcn3ic_addr.bit.ilvl1
#define		ILVL2_BCN3IC 	 bcn3ic_addr.bit.ilvl2
#define		IR_BCN3IC    	 bcn3ic_addr.bit.ir

/*------------------------------------------------------
     bcn4ic
------------------------------------------------------*/
#pragma ADDRESS     bcn4ic_addr 0091H       /* Bus collision (UART4) interrupt control register */
ICR1_TYPE	bcn4ic_addr;

#define		BCN4IC       	 bcn4ic_addr.byte
#define		ILVL0_BCN4IC 	 bcn4ic_addr.bit.ilvl0
#define		ILVL1_BCN4IC	 bcn4ic_addr.bit.ilvl1
#define		ILVL2_BCN4IC 	 bcn4ic_addr.bit.ilvl2
#define		IR_BCN4IC    	 bcn4ic_addr.bit.ir

/*------------------------------------------------------
     dm0ic
------------------------------------------------------*/
#pragma ADDRESS     dm0ic_addr	0068H       /* DMA0 interrupt control register */
ICR1_TYPE	dm0ic_addr;

#define		DM0IC       dm0ic_addr.byte
#define		ILVL0_DM0IC dm0ic_addr.bit.ilvl0
#define		ILVL1_DM0IC	dm0ic_addr.bit.ilvl1
#define		ILVL2_DM0IC dm0ic_addr.bit.ilvl2
#define		IR_DM0IC    dm0ic_addr.bit.ir

/*------------------------------------------------------
     dm1ic
------------------------------------------------------*/
#pragma ADDRESS     dm1ic_addr  0088H       /* DMA1 interrupt control register */
ICR1_TYPE	dm1ic_addr;

#define		DM1IC  		dm1ic_addr.byte    
#define		ILVL0_DM1IC    dm1ic_addr.bit.ilvl0
#define		ILVL1_DM1IC    dm1ic_addr.bit.ilvl1
#define		ILVL2_DM1IC    dm1ic_addr.bit.ilvl2
#define		IR_DM1IC    	dm1ic_addr.bit.ir

/*------------------------------------------------------
     dm2ic
------------------------------------------------------*/
#pragma ADDRESS     dm2ic_addr  006aH       /* DMA2 interrupt register */
ICR1_TYPE	dm2ic_addr;


#define		DM2IC  		dm2ic_addr.byte    
#define		ILVL0_DM2IC    dm2ic_addr.bit.ilvl0
#define		ILVL1_DM2IC    dm2ic_addr.bit.ilvl1
#define		ILVL2_DM2IC    dm2ic_addr.bit.ilvl2
#define		IR_DM2IC    	dm2ic_addr.bit.ir

/*------------------------------------------------------
     dm3ic
------------------------------------------------------*/
#pragma ADDRESS     dm3ic_addr  008aH       /* DMA3 interrupt control register */
ICR1_TYPE	dm3ic_addr;

#define		DM3IC  		dm3ic_addr.byte    
#define		ILVL0_DM3IC    dm3ic_addr.bit.ilvl0
#define		ILVL1_DM3IC    dm3ic_addr.bit.ilvl1
#define		ILVL2_DM3IC    dm3ic_addr.bit.ilvl2
#define		IR_DM3IC    	dm3ic_addr.bit.ir

/*------------------------------------------------------
     ad0ic
------------------------------------------------------*/
#pragma ADDRESS     ad0ic_addr  0073H       /* A-D0 conversion interrupt control register */
ICR1_TYPE	ad0ic_addr;

#define		AD0IC       	ad0ic_addr.byte
#define		ILVL0_AD0IC 	ad0ic_addr.bit.ilvl0
#define		ILVL1_AD0IC		ad0ic_addr.bit.ilvl1
#define		ILVL2_AD0IC 	ad0ic_addr.bit.ilvl2
#define		IR_AD0IC    	ad0ic_addr.bit.ir

/*------------------------------------------------------
     kupic
------------------------------------------------------*/
#pragma ADDRESS     kupic_addr  0093H       /* Key input interrupt control register */
ICR1_TYPE	kupic_addr;

#define		KUPIC      	kupic_addr.byte
#define		ILVL0_KUPIC kupic_addr.bit.ilvl0
#define		ILVL1_KUPIC kupic_addr.bit.ilvl1
#define		ILVL2_KUPIC kupic_addr.bit.ilvl2
#define		IR_KUPIC	kupic_addr.bit.ir

/*------------------------------------------------------
     iio0ic
------------------------------------------------------*/
#pragma ADDRESS     iio0ic_addr 0075H       /* Intelligent I/O interrupt control register 0 */
ICR1_TYPE	iio0ic_addr;

#define		IIO0IC       iio0ic_addr.byte
#define		ILVL0_IIO0IC iio0ic_addr.bit.ilvl0
#define		ILVL1_IIO0IC iio0ic_addr.bit.ilvl1
#define		ILVL2_IIO0IC iio0ic_addr.bit.ilvl2
#define		IR_IIO0IC    iio0ic_addr.bit.ir

/*------------------------------------------------------
     iio1ic
------------------------------------------------------*/
#pragma ADDRESS     iio1ic_addr 0095H       /* Intelligent I/O interrupt control register 1 */
ICR1_TYPE	iio1ic_addr;

#define		IIO1IC       iio1ic_addr.byte
#define		ILVL0_IIO1IC iio1ic_addr.bit.ilvl0
#define		ILVL1_IIO1IC iio1ic_addr.bit.ilvl1
#define		ILVL2_IIO1IC iio1ic_addr.bit.ilvl2
#define		IR_IIO1IC    iio1ic_addr.bit.ir

/*------------------------------------------------------
     iio2ic
------------------------------------------------------*/
#pragma ADDRESS     iio2ic_addr 0077H       /* Intelligent I/O interrupt control register 2 */
ICR1_TYPE	iio2ic_addr;

#define		IIO2IC       iio2ic_addr.byte
#define		ILVL0_IIO2IC iio2ic_addr.bit.ilvl0
#define		ILVL1_IIO2IC iio2ic_addr.bit.ilvl1
#define		ILVL2_IIO2IC iio2ic_addr.bit.ilvl2
#define		IR_IIO2IC    iio2ic_addr.bit.ir

/*------------------------------------------------------
     iio3ic
------------------------------------------------------*/
#pragma ADDRESS     iio3ic_addr 0097H       /* Intelligent I/O interrupt control register 3 */
ICR1_TYPE	iio3ic_addr;

#define		IIO3IC       iio3ic_addr.byte
#define		ILVL0_IIO3IC iio3ic_addr.bit.ilvl0
#define		ILVL1_IIO3IC iio3ic_addr.bit.ilvl1
#define		ILVL2_IIO3IC iio3ic_addr.bit.ilvl2
#define		IR_IIO3IC    iio3ic_addr.bit.ir

/*------------------------------------------------------
     iio4ic
------------------------------------------------------*/
#pragma ADDRESS     iio4ic_addr 0079H       /* Intelligent I/O interrupt control register 4 */
ICR1_TYPE	iio4ic_addr;

#define		IIO4IC       iio4ic_addr.byte
#define		ILVL0_IIO4IC iio4ic_addr.bit.ilvl0
#define		ILVL1_IIO4IC iio4ic_addr.bit.ilvl1
#define		ILVL2_IIO4IC iio4ic_addr.bit.ilvl2
#define		IR_IIO4IC    iio4ic_addr.bit.ir

/*------------------------------------------------------
     iio8ic
------------------------------------------------------*/
#pragma ADDRESS     iio8ic_addr 007dH       /* Intelligent I/O interrupt control register 8 */
ICR1_TYPE	iio8ic_addr;

#define		IIO8IC       iio8ic_addr.byte
#define		ILVL0_IIO8IC iio8ic_addr.bit.ilvl0
#define		ILVL1_IIO8IC iio8ic_addr.bit.ilvl1
#define		ILVL2_IIO8IC iio8ic_addr.bit.ilvl2
#define		IR_IIO8IC    iio8ic_addr.bit.ir

/*------------------------------------------------------
     iio9ic
------------------------------------------------------*/
#pragma ADDRESS     iio9ic_addr 009dH       /* Intelligent I/O interrupt control register 9 */
ICR1_TYPE	iio9ic_addr;

#define		IIO9IC       	iio9ic_addr.byte
#define		ILVL0_IIO9IC 	iio9ic_addr.bit.ilvl0
#define		ILVL1_IIO9IC 	iio9ic_addr.bit.ilvl1
#define		ILVL2_IIO9IC 	iio9ic_addr.bit.ilvl2
#define		IR_IIO9IC    	iio9ic_addr.bit.ir

/*------------------------------------------------------
     iio10ic
------------------------------------------------------*/
#pragma ADDRESS     iio10ic_addr 007fH      /* Intelligent I/O interrupt control register 10 */
ICR1_TYPE	iio10ic_addr;

#define		IIO10IC       	iio10ic_addr.byte
#define		ILVL0_IIO10IC 	iio10ic_addr.bit.ilvl0
#define		ILVL1_IIO10IC 	iio10ic_addr.bit.ilvl1
#define		ILVL2_IIO10IC 	iio10ic_addr.bit.ilvl2
#define		IR_IIO10IC    	iio10ic_addr.bit.ir

/*------------------------------------------------------
	CAN0 Interrupt Control Register
------------------------------------------------------*/
#pragma ADDRESS		can0ic_addr 009dH		/* CAN0 Interrupt Control Register*/
ICR1_TYPE	can0ic_addr;

#define		CAN0IC       	can0ic_addr.byte
#define		ILVL0_CAN0IC 	can0ic_addr.bit.ilvl0
#define		ILVL1_CAN0IC 	can0ic_addr.bit.ilvl1
#define		ILVL2_CAN0IC 	can0ic_addr.bit.ilvl2
#define		IR_CAN0IC		can0ic_addr.bit.ir

/*------------------------------------------------------
	CAN1 Interrupt Control Register
------------------------------------------------------*/
#pragma ADDRESS		can1ic_addr	007fH		/* CAN1 Interrupt Control Register	*/
ICR1_TYPE	can1ic_addr;

#define		CAN1IC       	can1ic_addr.byte
#define		ILVL0_CAN1IC 	can1ic_addr.bit.ilvl0
#define		ILVL1_CAN1IC 	can1ic_addr.bit.ilvl1
#define		ILVL2_CAN1IC 	can1ic_addr.bit.ilvl2
#define		IR_CAN1IC		can1ic_addr.bit.ir

/*------------------------------------------------------
	CAN2 Interrupt Control Register
------------------------------------------------------*/
#pragma ADDRESS     can2ic_addr 0081H      /* CAN2 Interrupt Control Register	*/
ICR1_TYPE	can2ic_addr;

#define		CAN2IC       	can2ic_addr.byte
#define		ILVL0_CAN2IC 	can2ic_addr.bit.ilvl0
#define		ILVL1_CAN2IC 	can2ic_addr.bit.ilvl1
#define		ILVL2_CAN2IC 	can2ic_addr.bit.ilvl2
#define		IR_CAN2IC    	can2ic_addr.bit.ir

/*------------------------------------------------------
	CAN3 Interrupt Control Register
------------------------------------------------------*/
#pragma ADDRESS     can3ic_addr 0075H      /* CAN3 Interrupt Control Register	*/
ICR1_TYPE	can3ic_addr;

#define		CAN3IC       	can3ic_addr.byte
#define		ILVL0_CAN3IC 	can3ic_addr.bit.ilvl0
#define		ILVL1_CAN3IC 	can3ic_addr.bit.ilvl1
#define		ILVL2_CAN3IC 	can3ic_addr.bit.ilvl2
#define		IR_CAN3IC    	can3ic_addr.bit.ir

/*------------------------------------------------------
	CAN4 Interrupt Control Register
------------------------------------------------------*/
#pragma ADDRESS     can4ic_addr 0095H      /* CAN4 Interrupt Control Register	*/
ICR1_TYPE	can4ic_addr;

#define		CAN4IC       	can4ic_addr.byte
#define		ILVL0_CAN4IC 	can4ic_addr.bit.ilvl0
#define		ILVL1_CAN4IC 	can4ic_addr.bit.ilvl1
#define		ILVL2_CAN4IC 	can4ic_addr.bit.ilvl2
#define		IR_CAN4IC    	can4ic_addr.bit.ir

/*------------------------------------------------------
	CAN5 Interrupt Control Register
------------------------------------------------------*/
#pragma ADDRESS     can5ic_addr 0099H      /* CAN5 Interrupt Control Register	*/
ICR1_TYPE	can5ic_addr;

#define		CAN5IC       	can5ic_addr.byte
#define		ILVL0_CAN5IC 	can5ic_addr.bit.ilvl0
#define		ILVL1_CAN5IC 	can5ic_addr.bit.ilvl1
#define		ILVL2_CAN5IC 	can5ic_addr.bit.ilvl2
#define		IR_CAN5IC    	can5ic_addr.bit.ir

/*------------------------------------------------------
	Interrupt Control Register 2
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	ilvl0:1;            /* Interrupt priority level select bit */
		UINT8	ilvl1:1;            /* Interrupt priority level select bit */
		UINT8	ilvl2:1;            /* Interrupt priority level select bit */
		UINT8	ir:1;               /* Interrupt request bit */
		UINT8	pol:1;              /* Polarity select bit */
		UINT8	lvs:1;
		UINT8	no_assign:2;  
	} bit;
	UINT8	byte;
} ICR2_TYPE;

/*------------------------------------------------------
	int0ic
------------------------------------------------------*/
#pragma ADDRESS     int0ic_addr 009eH       /* INT0~ interrupt control register */
ICR2_TYPE	int0ic_addr;

#define		INT0IC      	int0ic_addr.byte
#define		ILVL0_INT0IC    int0ic_addr.bit.ilvl0
#define		ILVL1_INT0IC    int0ic_addr.bit.ilvl1
#define		ILVL2_INT0IC    int0ic_addr.bit.ilvl2
#define		IR_INT0IC  		int0ic_addr.bit.ir
#define		POL_INT0IC  	int0ic_addr.bit.pol
#define		LVS_INT0IC  	int0ic_addr.bit.lvs

/*------------------------------------------------------
	int1ic
------------------------------------------------------*/
#pragma ADDRESS     int1ic_addr 007eH       /* INT1~ interrupt control register */
ICR2_TYPE	int1ic_addr;

#define		INT1IC      	int1ic_addr.byte
#define		ILVL0_INT1IC    int1ic_addr.bit.ilvl0
#define		ILVL1_INT1IC    int1ic_addr.bit.ilvl1
#define		ILVL2_INT1IC    int1ic_addr.bit.ilvl2
#define		IR_INT1IC  		int1ic_addr.bit.ir
#define		POL_INT1IC  	int1ic_addr.bit.pol
#define		LVS_INT1IC  	int1ic_addr.bit.lvs

/*------------------------------------------------------
	int2ic
------------------------------------------------------*/
#pragma ADDRESS     int2ic_addr 009cH       /* INT2~ interrupt control register */
ICR2_TYPE	int2ic_addr;

#define		INT2IC      	int2ic_addr.byte
#define		ILVL0_INT2IC    int2ic_addr.bit.ilvl0
#define		ILVL1_INT2IC    int2ic_addr.bit.ilvl1
#define		ILVL2_INT2IC    int2ic_addr.bit.ilvl2
#define		IR_INT2IC  		int2ic_addr.bit.ir
#define		POL_INT2IC  	int2ic_addr.bit.pol
#define		LVS_INT2IC  	int2ic_addr.bit.lvs

/*------------------------------------------------------
	int3ic
------------------------------------------------------*/
#pragma ADDRESS     int3ic_addr 007cH       /* INT3~ interrupt control register */
ICR2_TYPE	int3ic_addr;

#define		INT3IC      	int3ic_addr.byte
#define		ILVL0_INT3IC    int3ic_addr.bit.ilvl0
#define		ILVL1_INT3IC    int3ic_addr.bit.ilvl1
#define		ILVL2_INT3IC    int3ic_addr.bit.ilvl2
#define		IR_INT3IC  		int3ic_addr.bit.ir
#define		POL_INT3IC  	int3ic_addr.bit.pol
#define		LVS_INT3IC  	int3ic_addr.bit.lvs

/*------------------------------------------------------
	int4ic
------------------------------------------------------*/
#pragma ADDRESS     int4ic_addr 009aH       /* INT4~ interrupt control register */
ICR2_TYPE	int4ic_addr;

#define		INT4IC      	int4ic_addr.byte
#define		ILVL0_INT4IC    int4ic_addr.bit.ilvl0
#define		ILVL1_INT4IC    int4ic_addr.bit.ilvl1
#define		ILVL2_INT4IC    int4ic_addr.bit.ilvl2
#define		IR_INT4IC  		int4ic_addr.bit.ir
#define		POL_INT4IC  	int4ic_addr.bit.pol
#define		LVS_INT4IC  	int4ic_addr.bit.lvs

/*------------------------------------------------------
	int5ic
------------------------------------------------------*/
#pragma ADDRESS     int5ic_addr 007aH       /* INT5~ interrupt control register */
ICR2_TYPE	int5ic_addr;

#define		INT5IC      	int5ic_addr.byte
#define		ILVL0_INT5IC    int5ic_addr.bit.ilvl0
#define		ILVL1_INT5IC    int5ic_addr.bit.ilvl1
#define		ILVL2_INT5IC    int5ic_addr.bit.ilvl2
#define		IR_INT5IC  		int5ic_addr.bit.ir
#define		POL_INT5IC  	int5ic_addr.bit.pol
#define		LVS_INT5IC  	int5ic_addr.bit.lvs

/*------------------------------------------------------
	Exit priority register
------------------------------------------------------*/
#pragma ADDRESS		rlvl_addr	009fH	/* ApD揇ʃWX^	*/
typedef union {
	struct{
		UINT8	rlvl0:1;  
		UINT8	rlvl1:1;  
		UINT8	rlvl2:1;  
		UINT8	fsit:1;  
		UINT8	no_assign1:1;  
		UINT8	dmaii:1;  
		UINT8	no_assign2:2;  
	} bit;
	UINT8 byte;
} RLVL_TYPE;
RLVL_TYPE	rlvl_addr;

#define		RLVL		rlvl_addr.byte
#define		RLVL0		rlvl_addr.bit.rlvl0
#define		RLVL1		rlvl_addr.bit.rlvl1
#define		RLVL2		rlvl_addr.bit.rlvl2
#define		FSIT		rlvl_addr.bit.fsit
#define		DMAII		rlvl_addr.bit.dmaii

/*------------------------------------------------------
	Interrupt cause select register
------------------------------------------------------*/
#pragma ADDRESS		ifsr_addr	031fH	/* O荞ݗvIWX^	*/
typedef union {
	struct{
		UINT8	ifsr0:1;
		UINT8	ifsr1:1;
		UINT8	ifsr2:1;
		UINT8	ifsr3:1;
		UINT8	ifsr4:1;
		UINT8	ifsr5:1;
		UINT8	ifsr6:1;
		UINT8	ifsr7:1;
	} bit;
	 UINT8 byte;
} IFSR_TYPE;
IFSR_TYPE	ifsr_addr;

#define		IFSR		ifsr_addr.byte

#define		IFSR0		ifsr_addr.bit.ifsr0
#define		IFSR1		ifsr_addr.bit.ifsr1
#define		IFSR2		ifsr_addr.bit.ifsr2
#define		IFSR3		ifsr_addr.bit.ifsr3
#define		IFSR4		ifsr_addr.bit.ifsr4
#define		IFSR5		ifsr_addr.bit.ifsr5
#define		IFSR6		ifsr_addr.bit.ifsr6
#define		IFSR7		ifsr_addr.bit.ifsr7

/*------------------------------------------------------
	Address match interrupt enable register
------------------------------------------------------*/
#pragma ADDRESS		aier_addr	0009H	/* AhXv荞݋WX^ */
typedef union {
	struct{
		UINT8	aier0:1;	/* RW AhXv荞0 0B:֎~,1B:	*/
		UINT8	aier1:1;	/* RW AhXv荞1 0B:֎~,1B:	*/
		UINT8	aier2:1;	/* RW AhXv荞2 0B:֎~,1B:	*/
		UINT8	aier3:1;	/* RW AhXv荞3 0B:֎~,1B:	*/
		UINT8	aier4:1;	/* RW AhXv荞4 0B:֎~,1B:	*/
		UINT8	aier5:1;	/* RW AhXv荞5 0B:֎~,1B:	*/
		UINT8	aier6:1;	/* RW AhXv荞6 0B:֎~,1B:	*/
		UINT8	aier7:1;	/* RW AhXv荞7 0B:֎~,1B:	*/
	} bit;
	UINT8 byte;
} AIER_TYPE;
AIER_TYPE	aier_addr;

#define		AIER		aier_addr.byte
#define		AIER0		aier_addr.bit.aier0
#define		AIER1		aier_addr.bit.aier1
#define		AIER2		aier_addr.bit.aier2
#define		AIER3		aier_addr.bit.aier3
#define		AIER4		aier_addr.bit.aier4
#define		AIER5		aier_addr.bit.aier5
#define		AIER6		aier_addr.bit.aier6
#define		AIER7		aier_addr.bit.aier7

/*------------------------------------------------------
	Address match interrupt register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	rmad_low;		/* RW AhXݒ 8bit					*/
		UINT8	rmad_mid;		/* RW AhXݒ 8bit					*/
		UINT8	rmad_high;		/* RW AhXݒ 8bit					*/
		UINT8	reserved;		/* ANZX֎~ SFR̈					*/
	} byte;
	struct{
		UINT16	rmad_low;		/* RW AhXݒ 16bit				*/
		UINT16	rmad_high;		/* RW AhXݒ 16bit ŏ8bit̓}XNKv	*/
	} word;
    UINT32   dword;		/* RW AhXݒ 32bit ŏ8bit̓}XNKv	*/
} RMAD_TYPE;

/*------------------------------------------------------
	Address match interrupt register 0
------------------------------------------------------*/
#pragma ADDRESS		rmad0_addr	0010H	/* AhXv荞݃WX^0	*/
RMAD_TYPE	rmad0_addr;

/*#define		RMAD0		rmad0_addr.dword*/
#define		RMAD0WL		rmad0_addr.word.rmad_low
/*#define		RMAD0WH		rmad0_addr.word.rmad_high*/
#define		RMAD0BL		rmad0_addr.byte.rmad_low
#define		RMAD0BM		rmad0_addr.byte.rmad_mid
#define		RMAD0BH		rmad0_addr.byte.rmad_high
/* 32bitANZXя16bitANZXɂẮCSFR̈ANZX	*/
/* ܂߁CRgAEgƂD										*/

/*------------------------------------------------------
	Address match interrupt register 1
------------------------------------------------------*/
#pragma ADDRESS		rmad1_addr	0014H	/* AhXv荞݃WX^1	*/
RMAD_TYPE	rmad1_addr;

/*#define		RMAD1		rmad1_addr.dword*/
#define		RMAD1WL		rmad1_addr.word.rmad_low
/*#define		RMAD1WH		rmad1_addr.word.rmad_high*/
#define		RMAD1BL		rmad1_addr.byte.rmad_low
#define		RMAD1BM		rmad1_addr.byte.rmad_mid
#define		RMAD1BH		rmad1_addr.byte.rmad_high
/* 32bitANZXя16bitANZXɂẮCSFR̈ANZX	*/
/* ܂߁CRgAEgƂD										*/

/*------------------------------------------------------
	Address match interrupt register 2
------------------------------------------------------*/
#pragma ADDRESS		rmad2_addr	0018H	/* AhXv荞݃WX^2	*/
RMAD_TYPE	rmad2_addr;

/*#define		RMAD2		rmad2_addr.dword*/
#define		RMAD2WL		rmad2_addr.word.rmad_low
/*#define		RMAD2WH		rmad2_addr.word.rmad_high*/
#define		RMAD2BL		rmad2_addr.byte.rmad_low
#define		RMAD2BM		rmad2_addr.byte.rmad_mid
#define		RMAD2BH		rmad2_addr.byte.rmad_high
/* 32bitANZXя16bitANZXɂẮCSFR̈ANZX	*/
/* ܂߁CRgAEgƂD										*/

/*------------------------------------------------------
	Address match interrupt register 3
------------------------------------------------------*/
#pragma ADDRESS		rmad3_addr	001cH	/* AhXv荞݃WX^3	*/
RMAD_TYPE	rmad3_addr;

/*#define		RMAD3		rmad3_addr.dword*/
#define		RMAD3WL		rmad3_addr.word.rmad_low
/*#define		RMAD3WH		rmad3_addr.word.rmad_high*/
#define		RMAD3BL		rmad3_addr.byte.rmad_low
#define		RMAD3BM		rmad3_addr.byte.rmad_mid
#define		RMAD3BH		rmad3_addr.byte.rmad_high
/* 32bitANZXя16bitANZXɂẮCSFR̈ANZX	*/
/* ܂߁CRgAEgƂD										*/

/*------------------------------------------------------
	Address match interrupt register 4
------------------------------------------------------*/
#pragma ADDRESS		rmad4_addr	0028H	/* AhXv荞݃WX^4	*/
RMAD_TYPE	rmad4_addr;

/*#define		RMAD4		rmad4_addr.dword*/
#define		RMAD4WL		rmad4_addr.word.rmad_low
/*#define		RMAD4WH		rmad4_addr.word.rmad_high*/
#define		RMAD4BL		rmad4_addr.byte.rmad_low
#define		RMAD4BM		rmad4_addr.byte.rmad_mid
#define		RMAD4BH		rmad4_addr.byte.rmad_high
/* 32bitANZXя16bitANZXɂẮCSFR̈ANZX	*/
/* ܂߁CRgAEgƂD										*/

/*------------------------------------------------------
	Address match interrupt register 5
------------------------------------------------------*/
#pragma ADDRESS		rmad5_addr	002cH	/* AhXv荞݃WX^5	*/
RMAD_TYPE	rmad5_addr;

/*#define		RMAD5		rmad5_addr.dword*/
#define		RMAD5WL		rmad5_addr.word.rmad_low
/*#define		RMAD5WH		rmad5_addr.word.rmad_high*/
#define		RMAD5BL		rmad5_addr.byte.rmad_low
#define		RMAD5BM		rmad5_addr.byte.rmad_mid
#define		RMAD5BH		rmad5_addr.byte.rmad_high
/* 32bitANZXя16bitANZXɂẮCSFR̈ANZX	*/
/* ܂߁CRgAEgƂD										*/

/*------------------------------------------------------
	Address match interrupt register 6
------------------------------------------------------*/
#pragma ADDRESS		rmad6_addr	0038H	/* AhXv荞݃WX^6	*/
RMAD_TYPE	rmad6_addr;

/*#define		RMAD6		rmad6_addr.dword*/
#define		RMAD6WL		rmad6_addr.word.rmad_low
/*#define		RMAD6WH		rmad6_addr.word.rmad_high*/
#define		RMAD6BL		rmad6_addr.byte.rmad_low
#define		RMAD6BM		rmad6_addr.byte.rmad_mid
#define		RMAD6BH		rmad6_addr.byte.rmad_high
/* 32bitANZXя16bitANZXɂẮCSFR̈ANZX	*/
/* ܂߁CRgAEgƂD										*/

/*------------------------------------------------------
	Address match interrupt register 7
------------------------------------------------------*/
#pragma ADDRESS		rmad7_addr	003cH	/* AhXv荞݃WX^7	*/
RMAD_TYPE	rmad7_addr;

/*#define		RMAD7		rmad7_addr.dword*/
#define		RMAD7WL		rmad7_addr.word.rmad_low
/*#define		RMAD7WH		rmad7_addr.word.rmad_high*/
#define		RMAD7BL		rmad7_addr.byte.rmad_low
#define		RMAD7BM		rmad7_addr.byte.rmad_mid
#define		RMAD7BH		rmad7_addr.byte.rmad_high
/* 32bitANZXя16bitANZXɂẮCSFR̈ANZX	*/
/* ܂߁CRgAEgƂD										*/

/*------------------------------------------------------
	Intelligent I/O Interrupt request register 0
------------------------------------------------------*/
#pragma ADDRESS		iio0ir_addr	00a0H	/* CeWFgI/O荞ݗvWX^0	*/
typedef union {
	struct{
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	reserved1:1;	/* RW s ޏꍇ0					*/
		UINT8	tm13r_po13r:1;
		UINT8	reserved2:1;	/* RW s ޏꍇ0					*/
		UINT8	g0rir:1;
		UINT8	sio0rr:1;
		UINT8	reserved3:1;	/* RW s ޏꍇ0					*/
		UINT8	can10r:1;
	} bit;
	UINT8	byte;
} IIO0IR_TYPE;
IIO0IR_TYPE	iio0ir_addr;

#define		IIO0IR      iio0ir_addr.byte
#define		TM13R		iio0ir_addr.bit.tm13r_po13r
#define		PO13R		iio0ir_addr.bit.tm13r_po13r
#define		G0RIR		iio0ir_addr.bit.g0rir
#define		SIO0RR		iio0ir_addr.bit.sio0rr
#define		CAN10R		iio0ir_addr.bit.can10r

/*------------------------------------------------------
	Intelligent I/O Interrupt request register 1
------------------------------------------------------*/
#pragma ADDRESS		iio1ir_addr	00a1H	/* CeWFgI/O荞ݗvWX^1	*/
typedef union {
	struct{
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	reserved1:1;	/* RW s ޏꍇ0					*/
		UINT8	tm14r_po14r:1;
		UINT8	reserved2:1;	/* RW s ޏꍇ0					*/
		UINT8	g0tor:1;
		UINT8	sio0tr:1;
		UINT8	reserved3:1;	/* RW s ޏꍇ0					*/
		UINT8	can11r:1;
	} bit;
	UINT8	byte;
} IIO1IR_TYPE;
IIO1IR_TYPE	iio1ir_addr;

#define		IIO1IR      iio1ir_addr.byte
#define		TM14R		iio1ir_addr.bit.tm14r_po14r
#define		PO14R		iio1ir_addr.bit.tm14r_po14r
#define		G0TOR		iio1ir_addr.bit.g0tor
#define		SIO0TR		iio1ir_addr.bit.sio0tr
#define		CAN11R		iio1ir_addr.bit.can11r

/*------------------------------------------------------
	Intelligent I/O Interrupt request register 2
------------------------------------------------------*/
#pragma ADDRESS		iio2ir_addr	00a2H	/* CeWFgI/O荞ݗvWX^2	*/
typedef union {
	struct{
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	reserved1:1;	/* RW s ޏꍇ0					*/
		UINT8	tm12r_po12r:1;
		UINT8	reserved2:1;	/* RW s ޏꍇ0					*/
		UINT8	g1rir:1;
		UINT8	sio1rr:1;
		UINT8	reserved3:2;	/* RW s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} IIO2IR_TYPE;
IIO2IR_TYPE	iio2ir_addr;

#define		IIO2IR		iio2ir_addr.byte
#define		TM12R		iio2ir_addr.bit.tm12r_po12r
#define		PO12R		iio2ir_addr.bit.tm12r_po12r
#define		G1RIR		iio2ir_addr.bit.g1rir
#define		SIO1RR		iio2ir_addr.bit.sio1rr

/*------------------------------------------------------
	Intelligent I/O Interrupt request register 3
------------------------------------------------------*/
#pragma ADDRESS		iio3ir_addr	00a3H	/* CeWFgI/O荞ݗvWX^3	*/
typedef union {
	struct{
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	reserved1:1;	/* RW s ޏꍇ0					*/
		UINT8	tm10r_po10r:1;
		UINT8	reserved2:1;	/* RW s ޏꍇ0					*/
		UINT8	g1tor:1;
		UINT8	sio1tr:1;        
		UINT8	reserved3:2;	/* RW s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} IIO3IR_TYPE;
IIO3IR_TYPE	iio3ir_addr;

#define		IIO3IR		iio3ir_addr.byte
#define		TM10R		iio3ir_addr.bit.tm10r_po10r
#define		PO10R		iio3ir_addr.bit.tm10r_po10r
#define		G1TOR		iio3ir_addr.bit.g1tor
#define		SIO1TR		iio3ir_addr.bit.sio1tr

/*------------------------------------------------------
	Intelligent I/O Interrupt request register 4
------------------------------------------------------*/
#pragma ADDRESS		iio4ir_addr	00a4H	/* CeWFgI/O荞ݗvWX^4	*/
typedef union {
	struct{
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	reserved1:1;	/* RW s ޏꍇ0					*/
		UINT8	tm17r_po17r:1;
		UINT8	reserved2:1;	/* RW s ޏꍇ0					*/
		UINT8	bt1r:1;
		UINT8	reserved3:1;	/* RW s ޏꍇ0					*/
		UINT8	srt1r:1;
		UINT8	srt0r:1;
	} bit;
	UINT8	byte;
} IIO4IR_TYPE;
IIO4IR_TYPE	iio4ir_addr;

#define		IIO4IR		iio4ir_addr.byte
#define		TM17R		iio4ir_addr.bit.tm17r_po17r
#define		PO17R		iio4ir_addr.bit.tm17r_po17r
#define		BT1R		iio4ir_addr.bit.bt1r
#define		SRT1R		iio4ir_addr.bit.srt1r
#define		SRT0R		iio4ir_addr.bit.srt0r

/*------------------------------------------------------
	Intelligent I/O Interrupt request register 5
------------------------------------------------------*/
#pragma ADDRESS		iio5ir_addr	00a5H	/* CeWFgI/O荞ݗvWX^5	*/
typedef union {
	struct{
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	reserved:5;		/* RW s ޏꍇ0					*/
		UINT8	can1wur:1;
		UINT8	can12r:1;
	} bit;
	UINT8	byte;
} IIO5IR_TYPE;
IIO5IR_TYPE	iio5ir_addr;

#define		IIO5IR		iio5ir_addr.byte
#define		CAN1WUR		iio5ir_addr.bit.can1wur
#define		CAN12R		iio5ir_addr.bit.can12r

/*------------------------------------------------------
	Intelligent I/O Interrupt request register 8
------------------------------------------------------*/
#pragma ADDRESS		iio8ir_addr	00a8H	/* CeWFgI/O荞ݗvWX^8	*/
typedef union {
	struct{
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	tm11r_po11r:1;
		UINT8	reserved:6;		/* RW s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} IIO8IR_TYPE;
IIO8IR_TYPE	iio8ir_addr;

#define		IIO8IR		iio8ir_addr.byte
#define		TM11R		iio8ir_addr.bit.tm11r_po11r
#define		PO11R		iio8ir_addr.bit.tm11r_po11r

/*------------------------------------------------------
	Intelligent I/O Interrupt request register 9
------------------------------------------------------*/
#pragma ADDRESS		iio9ir_addr	00a9H	/* CeWFgI/O荞ݗvWX^9	*/
typedef union {
	struct{
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	tm15r_po15r:1;
		UINT8	reserved:5;		/* RW s ޏꍇ0					*/
		UINT8	can00r:1;
	} bit;
	UINT8	byte;
} IIO9IR_TYPE;
IIO9IR_TYPE	iio9ir_addr;

#define		IIO9IR		iio9ir_addr.byte
#define		TM15R		iio9ir_addr.bit.tm15r_po15r
#define		PO15R		iio9ir_addr.bit.tm15r_po15r
#define		CAN00R		iio9ir_addr.bit.can00r

/*------------------------------------------------------
	Intelligent I/O Interrupt request register 10
------------------------------------------------------*/
#pragma ADDRESS		iio10ir_addr	00aaH	/* CeWFgI/O荞ݗvWX^10	*/
typedef union {
	struct{
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	tm16r_po16r:1;
		UINT8	reserved:5;		/* RW s ޏꍇ0					*/
		UINT8	can01r:1;
	} bit;
	UINT8	byte;
} IIO10IR_TYPE;
IIO10IR_TYPE	iio10ir_addr;

#define		IIO10IR		iio10ir_addr.byte
#define		TM16R		iio10ir_addr.bit.tm16r_po16r
#define		PO16R		iio10ir_addr.bit.tm16r_po16r
#define		CAN01R		iio10ir_addr.bit.can01r

/*------------------------------------------------------
	Intelligent I/O Interrupt request register 11
------------------------------------------------------*/
#pragma ADDRESS		iio11ir_addr	00abH	/* CeWFgI/O荞ݗvWX^11	*/
typedef union {
	struct{
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	reserved:6;		/* RW s ޏꍇ0					*/
		UINT8	can02r:1;
	} bit;
	UINT8	byte;
} IIO11IR_TYPE;
IIO11IR_TYPE	iio11ir_addr;

#define		IIO11IR		iio11ir_addr.byte
#define		CAN02R		iio11ir_addr.bit.can02r

/*------------------------------------------------------
	Intelligent I/O Interrupt enable register 0
------------------------------------------------------*/
#pragma ADDRESS		iio0ie_addr	00b0H	/* CeWFgI/O荞݋WX^0	*/
typedef union {
	struct{
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	reserved1:1;	/* RW s ޏꍇ0					*/
		UINT8	tm13e_po13e:1;
		UINT8	reserved2:1;	/* RW s ޏꍇ0					*/
		UINT8	g0rie:1;
		UINT8	sio0re:1;
		UINT8	reserved3:1;	/* RW s ޏꍇ0					*/
		UINT8	can10e:1;
	} bit;
	UINT8	byte;
} IIO0IE_TYPE;
IIO0IE_TYPE	iio0ie_addr;

#define		IIO0IE      iio0ie_addr.byte
#define		TM13E		iio0ie_addr.bit.tm13e_po13e
#define		PO13E		iio0ie_addr.bit.tm13e_po13e
#define		G0RIE		iio0ie_addr.bit.g0rie
#define		SIO0RE		iio0ie_addr.bit.sio0re
#define		CAN10E		iio0ie_addr.bit.can10e

/*------------------------------------------------------
	Intelligent I/O Interrupt enable register 1
------------------------------------------------------*/
#pragma ADDRESS		iio1ie_addr	00b1H	/* CeWFgI/O荞݋WX^1	*/
typedef union {
	struct{
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	reserved1:1;	/* RW s ޏꍇ0					*/
		UINT8	tm14e_po14e:1;
		UINT8	reserved2:1;	/* RW s ޏꍇ0					*/
		UINT8	g0toe:1;
		UINT8	sio0te:1;
		UINT8	reserved3:1;	/* RW s ޏꍇ0					*/
		UINT8	can11e:1;
	} bit;
	UINT8	byte;
} IIO1IE_TYPE;
IIO1IE_TYPE	iio1ie_addr;

#define		IIO1IE      iio1ie_addr.byte
#define		TM14E		iio1ie_addr.bit.tm14e_po14e
#define		PO14E		iio1ie_addr.bit.tm14e_po14e
#define		G0TOE		iio1ie_addr.bit.g0toe
#define		SIO0TE		iio1ie_addr.bit.sio0te
#define		CAN11E		iio1ie_addr.bit.can11e

/*------------------------------------------------------
	Intelligent I/O Interrupt enable register 2
------------------------------------------------------*/
#pragma ADDRESS		iio2ie_addr	00b2H	/* CeWFgI/O荞݋WX^2	*/
typedef union {
	struct{
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	reserved1:1;	/* RW s ޏꍇ0					*/
		UINT8	tm12e_po12e:1;
		UINT8	reserved2:1;	/* RW s ޏꍇ0					*/
		UINT8	g1rie:1;
		UINT8	sio1re:1;
		UINT8	reserved3:2;	/* RW s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} IIO2IE_TYPE;
IIO2IE_TYPE	iio2ie_addr;

#define		IIO2IE		iio2ie_addr.byte
#define		TM12E		iio2ie_addr.bit.tm12e_po12e
#define		PO12E		iio2ie_addr.bit.tm12e_po12e
#define		G1RIE		iio2ie_addr.bit.g1rie
#define		SIO1RE		iio2ie_addr.bit.sio1re

/*------------------------------------------------------
	Intelligent I/O Interrupt enable register 3
------------------------------------------------------*/
#pragma ADDRESS		iio3ie_addr	00b3H	/* CeWFgI/O荞݋WX^3	*/
typedef union {
	struct{
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	reserved1:1;	/* RW s ޏꍇ0					*/
		UINT8	tm10e_po10e:1;
		UINT8	reserved2:1;	/* RW s ޏꍇ0					*/
		UINT8	g1toe:1;
		UINT8	sio1te:1;        
		UINT8	reserved3:2;	/* RW s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} IIO3IE_TYPE;
IIO3IE_TYPE	iio3ie_addr;

#define		IIO3IE		iio3ie_addr.byte
#define		TM10E		iio3ie_addr.bit.tm10e_po10e
#define		PO10E		iio3ie_addr.bit.tm10e_po10e
#define		G1TOE		iio3ie_addr.bit.g1toe
#define		SIO1TE		iio3ie_addr.bit.sio1te

/*------------------------------------------------------
	Intelligent I/O Interrupt enable register 4
------------------------------------------------------*/
#pragma ADDRESS		iio4ie_addr	00b4H	/* CeWFgI/O荞݋WX^4	*/
typedef union {
	struct{
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	reserved1:1;	/* RW s ޏꍇ0					*/
		UINT8	tm17e_po17e:1;
		UINT8	reserved2:1;	/* RW s ޏꍇ0					*/
		UINT8	bt1e:1;
		UINT8	reserved3:1;	/* RW s ޏꍇ0					*/
		UINT8	srt1e:1;
		UINT8	srt0e:1;
	} bit;
	UINT8	byte;
} IIO4IE_TYPE;
IIO4IE_TYPE	iio4ie_addr;

#define		IIO4IE		iio4ie_addr.byte
#define		TM17E		iio4ie_addr.bit.tm17e_po17e
#define		PO17E		iio4ie_addr.bit.tm17e_po17e
#define		BT1E		iio4ie_addr.bit.bt1e
#define		SRT1E		iio4ie_addr.bit.srt1e
#define		SRT0E		iio4ie_addr.bit.srt0e

/*------------------------------------------------------
	Intelligent I/O Interrupt enable register 5
------------------------------------------------------*/
#pragma ADDRESS		iio5ie_addr	00b5H	/* CeWFgI/O荞݋WX^5	*/
typedef union {
	struct{
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	reserved:5;		/* RW s ޏꍇ0					*/
		UINT8	can1wue:1;
		UINT8	can12e:1;
	} bit;
	UINT8	byte;
} IIO5IE_TYPE;
IIO5IE_TYPE	iio5ie_addr;

#define		IIO5IE		iio5ie_addr.byte
#define		CAN1WUE		iio5ie_addr.bit.can1wue
#define		CAN12E		iio5ie_addr.bit.can12e

/*------------------------------------------------------
	Intelligent I/O Interrupt enable register 8
------------------------------------------------------*/
#pragma ADDRESS		iio8ie_addr	00b8H	/* CeWFgI/O荞݋WX^8	*/
typedef union {
	struct{
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	tm11e_po11e:1;
		UINT8	reserved:6;		/* RW s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} IIO8IE_TYPE;
IIO8IE_TYPE	iio8ie_addr;

#define		IIO8IE		iio8ie_addr.byte
#define		TM11E		iio8ie_addr.bit.tm11e_po11e
#define		PO11E		iio8ie_addr.bit.tm11e_po11e

/*------------------------------------------------------
	Intelligent I/O Interrupt enable register 9
------------------------------------------------------*/
#pragma ADDRESS		iio9ie_addr	00b9H	/* CeWFgI/O荞݋WX^9	*/
typedef union {
	struct{
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	tm15e_po15e:1;
		UINT8	reserved:5;		/* RW s ޏꍇ0					*/
		UINT8	can00e:1;
	} bit;
	UINT8	byte;
} IIO9IE_TYPE;
IIO9IE_TYPE	iio9ie_addr;

#define		IIO9IE		iio9ie_addr.byte
#define		TM15E		iio9ie_addr.bit.tm15e_po15e
#define		PO15E		iio9ie_addr.bit.tm15e_po15e
#define		CAN00E		iio9ie_addr.bit.can00e

/*------------------------------------------------------
	Intelligent I/O Interrupt enable register 10
------------------------------------------------------*/
#pragma ADDRESS		iio10ie_addr	00baH	/* CeWFgI/O荞݋WX^10	*/
typedef union {
	struct{
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	tm16e_po16e:1;
		UINT8	reserved:5;		/* RW s ޏꍇ0					*/
		UINT8	can01e:1;
	} bit;
	UINT8	byte;
} IIO10IE_TYPE;
IIO10IE_TYPE	iio10ie_addr;

#define		IIO10IE		iio10ie_addr.byte
#define		TM16E		iio10ie_addr.bit.tm16e_po16e
#define		PO16E		iio10ie_addr.bit.tm16e_po16e
#define		CAN01E		iio10ie_addr.bit.can01e

/*------------------------------------------------------
	Intelligent I/O Interrupt enable register 11
------------------------------------------------------*/
#pragma ADDRESS		iio11ie_addr	00bbH	/* CeWFgI/O荞݋WX^11	*/
typedef union {
	struct{
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	reserved:6;		/* RW s ޏꍇ0					*/
		UINT8	can02e:1;
	} bit;
	UINT8	byte;
} IIO11IE_TYPE;
IIO11IE_TYPE	iio11ie_addr;

#define		IIO11IE		iio11ie_addr.byte
#define		CAN02E		iio11ie_addr.bit.can02e

/********************************************************/
/* EHb`hbO^C}									*/
/********************************************************/
/*------------------------------------------------------
	Watchdog timer control register
------------------------------------------------------*/
#pragma ADDRESS		wdc_addr	000fH	/* EHb`hbO^C}䃌WX^	*/
typedef union {
	struct{
		UINT8	wdt_high:5;		/* RO EHb`hbO^C}̏ʃrbg		*/
		UINT8	wdc5:1;
		UINT8	reserved:1;		/* RW 0Œ									*/
		UINT8	wdc7:1;
	} bit;
	UINT8 byte;
} WDC_TYPE;
WDC_TYPE	wdc_addr;

#define		WDC     wdc_addr.byte
#define		WDC5    wdc_addr.bit.wdc5
#define		WDC7    wdc_addr.bit.wdc7     /* Prescaler select bit */

/*------------------------------------------------------
	Watchdog timer start register
------------------------------------------------------*/
#pragma ADDRESS		wdts_addr	000eH	/* EHb`hbO^C}X^[gWX^	*/
UINT8	wdts_addr;

#define		WDTS		wdts_addr

/********************************************************/
/* DMAC													*/
/********************************************************/
/*------------------------------------------------------
	DMA request cause register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	dsel0:1;		/* DMA request cause select bit */
		UINT8	dsel1:1;		/* DMA request cause select bit */
		UINT8	dsel2:1;		/* DMA request cause select bit */
		UINT8	dsel3:1;		/* DMA request cause select bit */
		UINT8	dsel4:1;		/* DMA request cause select bit */
		UINT8	dsr:1;			/* Software DMA request bit */
		UINT8	reserved:1;		/* RW s									*/
		UINT8	drq:1;			/* DMA request bit */
	} bit;
	UINT8	byte;
} DMSL_TYPE;

/*------------------------------------------------------
	DMA0 request cause register
------------------------------------------------------*/
#pragma ADDRESS		dm0sl_addr	0378H	/* DMA0vIWX^				*/
DMSL_TYPE	dm0sl_addr;

#define		DM0SL		dm0sl_addr.byte
#define		DSEL0_DM0SL	dm0sl_addr.bit.dsel0    /* DMA request cause select bit */
#define		DSEL1_DM0SL	dm0sl_addr.bit.dsel1    /* DMA request cause select bit */
#define		DSEL2_DM0SL	dm0sl_addr.bit.dsel2    /* DMA request cause select bit */
#define		DSEL3_DM0SL	dm0sl_addr.bit.dsel3    /* DMA request cause select bit */
#define		DSEL4_DM0SL	dm0sl_addr.bit.dsel4    /* DMA request cause select bit */
#define		DSR_DM0SL	dm0sl_addr.bit.dsr      /* Software DMA request bit */
#define		DRQ_DM0SL	dm0sl_addr.bit.drq      /* DMA request bit */

/*------------------------------------------------------
	DMA1 request cause register
------------------------------------------------------*/
#pragma ADDRESS		dm1sl_addr	0379H	/* DMA1vIWX^				*/
DMSL_TYPE	dm1sl_addr;

#define		DM1SL		dm1sl_addr.byte
#define		DSEL0_DM1SL	dm1sl_addr.bit.dsel0    /* DMA request cause select bit */
#define		DSEL1_DM1SL	dm1sl_addr.bit.dsel1    /* DMA request cause select bit */
#define		DSEL2_DM1SL	dm1sl_addr.bit.dsel2    /* DMA request cause select bit */
#define		DSEL3_DM1SL	dm1sl_addr.bit.dsel3    /* DMA request cause select bit */
#define		DSEL4_DM1SL	dm1sl_addr.bit.dsel4    /* DMA request cause select bit */
#define		DSR_DM1SL	dm1sl_addr.bit.dsr      /* Software DMA request bit */
#define		DRQ_DM1SL	dm1sl_addr.bit.drq      /* DMA request bit */

/*------------------------------------------------------
	DMA2 request cause register
------------------------------------------------------*/
#pragma ADDRESS		dm2sl_addr	037aH	/* DMA2vIWX^				*/
DMSL_TYPE	dm2sl_addr;

#define		DM2SL		dm2sl_addr.byte
#define		DSEL0_DM2SL	dm2sl_addr.bit.dsel0    /* DMA request cause select bit */
#define		DSEL1_DM2SL	dm2sl_addr.bit.dsel1    /* DMA request cause select bit */
#define		DSEL2_DM2SL	dm2sl_addr.bit.dsel2    /* DMA request cause select bit */
#define		DSEL3_DM2SL	dm2sl_addr.bit.dsel3    /* DMA request cause select bit */
#define		DSEL4_DM2SL	dm2sl_addr.bit.dsel4    /* DMA request cause select bit */
#define		DSR_DM2SL	dm2sl_addr.bit.dsr      /* Software DMA request bit */
#define		DRQ_DM2SL	dm2sl_addr.bit.drq      /* DMA request bit */

/*------------------------------------------------------
	DMA3 request cause register
------------------------------------------------------*/
#pragma ADDRESS		dm3sl_addr	037bH	/* DMA3vIWX^				*/
DMSL_TYPE	dm3sl_addr;

#define		DM3SL		dm3sl_addr.byte
#define		DSEL0_DM3SL	dm3sl_addr.bit.dsel0    /* DMA request cause select bit */
#define		DSEL1_DM3SL	dm3sl_addr.bit.dsel1    /* DMA request cause select bit */
#define		DSEL2_DM3SL	dm3sl_addr.bit.dsel2    /* DMA request cause select bit */
#define		DSEL3_DM3SL	dm3sl_addr.bit.dsel3    /* DMA request cause select bit */
#define		DSEL4_DM3SL	dm3sl_addr.bit.dsel4    /* DMA request cause select bit */
#define		DSR_DM3SL	dm3sl_addr.bit.dsr      /* Software DMA request bit */
#define		DRQ_DM3SL	dm3sl_addr.bit.drq      /* DMA request bit */

/********************************************************/
/* ^C}												*/
/********************************************************/
/*---------------------------------------------------------------------
	Timer A0 registers ; Read and write to this register in 16-bit units.
-----------------------------------------------------------------------*/
#pragma ADDRESS		ta0_addr	0346H		/* ^C}A0WX^				*/
UINT16		ta0_addr;		/* Timer A0 register	*/

#define		TA0		ta0_addr

/*---------------------------------------------------------------------
	Timer A1 registers ; Read and write to this register in 16-bit units.
-----------------------------------------------------------------------*/
#pragma ADDRESS		ta1_addr	0348H		/* ^C}A1WX^				*/
UINT16		ta1_addr;              /* Timer A1 register */

#define		TA1		ta1_addr

/*---------------------------------------------------------------------
	Timer A2 registers ; Read and write to this register in 16-bit units.
-----------------------------------------------------------------------*/
#pragma ADDRESS		ta2_addr	034aH		/* ^C}A2WX^				*/
UINT16		ta2_addr;              /* Timer A2 register */

#define		TA2		ta2_addr

/*---------------------------------------------------------------------
	Timer A3 registers ; Read and write to this register in 16-bit units.
-----------------------------------------------------------------------*/
#pragma ADDRESS		ta3_addr	034cH		/* ^C}A3WX^				*/
UINT16		ta3_addr;              /* Timer A3 register */

#define		TA3		ta3_addr

/*---------------------------------------------------------------------
	Timer A4 registers ; Read and write to this register in 16-bit units.
-----------------------------------------------------------------------*/
#pragma ADDRESS		ta4_addr	034eH		/* ^C}A4WX^				*/
UINT16		ta4_addr;              /* Timer A4 register */

#define		TA4		ta4_addr

/*------------------------------------------------------
	Timer A mode registers
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	tmod0:1;        /* Operation mode select bit */
		UINT8	tmod1:1;        /* Operation mode select bit */
		UINT8	reserved:1;		/* RW 0Œ									*/
		UINT8	mr1:1;
		UINT8	mr2:1;
		UINT8	mr3:1;
		UINT8	tck0:1;         /* Count source select bit */
		UINT8	tck1:1;         /* Count source select bit */
	} bit;
	UINT8	byte;
} TAMR_TYPE;

/*------------------------------------------------------
	Timer A0 mode registers
------------------------------------------------------*/
#pragma ADDRESS		ta0mr_addr	0356H	/* ^C}A0[hWX^			*/
TAMR_TYPE	ta0mr_addr;

#define		TA0MR		ta0mr_addr.byte
#define		TMOD0_TA0MR	ta0mr_addr.bit.tmod0    /* Operation mode select bit */
#define		TMOD1_TA0MR	ta0mr_addr.bit.tmod1    /* Operation mode select bit */
#define		MR1_TA0MR	ta0mr_addr.bit.mr1
#define		MR2_TA0MR	ta0mr_addr.bit.mr2
#define		MR3_TA0MR	ta0mr_addr.bit.mr3
#define		TCK0_TA0MR	ta0mr_addr.bit.tck0 /* Count source select bit */
#define		TCK1_TA0MR	ta0mr_addr.bit.tck1 /* Count source select bit */

/*------------------------------------------------------
	Timer A1 mode registers
------------------------------------------------------*/
#pragma ADDRESS		ta1mr_addr	0357H	/* ^C}A1[hWX^			*/
TAMR_TYPE	ta1mr_addr;

#define		TA1MR		ta1mr_addr.byte
#define		TMOD0_TA1MR	ta1mr_addr.bit.tmod0    /* Operation mode select bit */
#define		TMOD1_TA1MR	ta1mr_addr.bit.tmod1    /* Operation mode select bit */
#define		MR1_TA1MR	ta1mr_addr.bit.mr1
#define		MR2_TA1MR	ta1mr_addr.bit.mr2
#define		MR3_TA1MR	ta1mr_addr.bit.mr3
#define		TCK0_TA1MR	ta1mr_addr.bit.tck0 /* Count source select bit */
#define		TCK1_TA1MR	ta1mr_addr.bit.tck1 /* Count source select bit */

/*------------------------------------------------------
	Timer A2 mode registers
------------------------------------------------------*/
#pragma ADDRESS		ta2mr_addr	0358H	/* ^C}A2[hWX^			*/
TAMR_TYPE	ta2mr_addr;

#define		TA2MR		ta2mr_addr.byte
#define		TMOD0_TA2MR	ta2mr_addr.bit.tmod0    /* Operation mode select bit */
#define		TMOD1_TA2MR	ta2mr_addr.bit.tmod1    /* Operation mode select bit */
#define		MR1_TA2MR	ta2mr_addr.bit.mr1
#define		MR2_TA2MR	ta2mr_addr.bit.mr2
#define		MR3_TA2MR	ta2mr_addr.bit.mr3
#define		TCK0_TA2MR	ta2mr_addr.bit.tck0 /* Count source select bit */
#define		TCK1_TA2MR	ta2mr_addr.bit.tck1 /* Count source select bit */

/*------------------------------------------------------
	Timer A3 mode registers
------------------------------------------------------*/
#pragma ADDRESS		ta3mr_addr	0359H	/* ^C}A3[hWX^			*/
TAMR_TYPE	ta3mr_addr;

#define		TA3MR		ta3mr_addr.byte
#define		TMOD0_TA3MR	ta3mr_addr.bit.tmod0    /* Operation mode select bit */
#define		TMOD1_TA3MR	ta3mr_addr.bit.tmod1    /* Operation mode select bit */
#define		MR1_TA3MR	ta3mr_addr.bit.mr1
#define		MR2_TA3MR	ta3mr_addr.bit.mr2
#define		MR3_TA3MR	ta3mr_addr.bit.mr3
#define		TCK0_TA3MR	ta3mr_addr.bit.tck0 /* Count source select bit */
#define		TCK1_TA3MR	ta3mr_addr.bit.tck1 /* Count source select bit */

/*------------------------------------------------------
	Timer A4 mode registers
------------------------------------------------------*/
#pragma ADDRESS		ta4mr_addr	035aH	/* ^C}A4[hWX^			*/
TAMR_TYPE	ta4mr_addr;

#define		TA4MR		ta4mr_addr.byte
#define		TMOD0_TA4MR	ta4mr_addr.bit.tmod0    /* Operation mode select bit */
#define		TMOD1_TA4MR	ta4mr_addr.bit.tmod1    /* Operation mode select bit */
#define		MR1_TA4MR	ta4mr_addr.bit.mr1
#define		MR2_TA4MR	ta4mr_addr.bit.mr2
#define		MR3_TA4MR	ta4mr_addr.bit.mr3
#define		TCK0_TA4MR	ta4mr_addr.bit.tck0 /* Count source select bit */
#define		TCK1_TA4MR	ta4mr_addr.bit.tck1 /* Count source select bit */

/*------------------------------------------------------
	Count start flag
------------------------------------------------------*/
#pragma ADDRESS		tabsr_addr	0340H	/* JEgJntO				*/
typedef union {
	struct{
		UINT8	ta0s:1;
		UINT8	ta1s:1;
		UINT8	ta2s:1;
		UINT8	ta3s:1;
		UINT8	ta4s:1;
		UINT8	tb0s:1;
		UINT8	tb1s:1;
		UINT8	tb2s:1;
	} bit;
	 UINT8 byte;
} TABSR_TYPE;
TABSR_TYPE	tabsr_addr;

#define		TABSR		tabsr_addr.byte
#define		TA0S		tabsr_addr.bit.ta0s
#define		TA1S		tabsr_addr.bit.ta1s
#define		TA2S		tabsr_addr.bit.ta2s
#define		TA3S		tabsr_addr.bit.ta3s
#define		TA4S		tabsr_addr.bit.ta4s
#define		TB0S		tabsr_addr.bit.tb0s
#define		TB1S		tabsr_addr.bit.tb1s
#define		TB2S		tabsr_addr.bit.tb2s

/*------------------------------------------------------
	Up Down Flag
------------------------------------------------------*/
#pragma ADDRESS		udf_addr	0344H	/* Abv_EtO				*/
typedef union {
	struct{
		UINT8	ta0ud:1;
		UINT8	ta1ud:1;
		UINT8	ta2ud:1;
		UINT8	ta3ud:1;
		UINT8	ta4ud:1;
		UINT8	ta2p:1;
		UINT8	ta3p:1;
		UINT8	ta4p:1;
	} bit;
	 UINT8 byte;
} UDF_TYPE;
UDF_TYPE	udf_addr;

#define		UDF			udf_addr.byte
#define		TA0UD		udf_addr.bit.ta0ud
#define		TA1UD		udf_addr.bit.ta1ud
#define		TA2UD		udf_addr.bit.ta2ud
#define		TA3UD		udf_addr.bit.ta3ud
#define		TA4UD		udf_addr.bit.ta4ud
#define		TA2P		udf_addr.bit.ta2p
#define		TA3P		udf_addr.bit.ta3p
#define		TA4P		udf_addr.bit.ta4p

/*------------------------------------------------------
	One-shot start flag
------------------------------------------------------*/
#pragma ADDRESS		onsf_addr	0342H	/* VbgJntO			*/
typedef union {
	struct{
		UINT8	ta0os:1;
		UINT8	ta1os:1;
		UINT8	ta2os:1;
		UINT8	ta3os:1;
		UINT8	ta4os:1;
		UINT8	tazie:1;
		UINT8	ta0tgl:1;
		UINT8	ta0tgh:1;
	} bit;
	 UINT8 byte;
} ONSF_TYPE;
ONSF_TYPE	onsf_addr;

#define		ONSF		onsf_addr.byte
#define		TA0OS		onsf_addr.bit.ta0os
#define		TA1OS		onsf_addr.bit.ta1os
#define		TA2OS		onsf_addr.bit.ta2os
#define		TA3OS		onsf_addr.bit.ta3os
#define		TA4OS		onsf_addr.bit.ta4os
#define		TAZIE		onsf_addr.bit.tazie
#define		TA0TGL		onsf_addr.bit.ta0tgl
#define		TA0TGH		onsf_addr.bit.ta0tgh

/*------------------------------------------------------
	Trigger select register
------------------------------------------------------*/
#pragma ADDRESS		trgsr_addr	0343H	/* gKIWX^				*/
typedef union {
	struct{
		UINT8	ta1tgl:1;
		UINT8	ta1tgh:1;
		UINT8	ta2tgl:1;
		UINT8	ta2tgh:1;
		UINT8	ta3tgl:1;
		UINT8	ta3tgh:1;
		UINT8	ta4tgl:1;
		UINT8	ta4tgh:1;
	} bit;
	 UINT8 byte;
} TRGSR_TYPE;
TRGSR_TYPE	trgsr_addr;

#define		TRGSR		trgsr_addr.byte
#define		TA1TGL		trgsr_addr.bit.ta1tgl
#define		TA1TGH		trgsr_addr.bit.ta1tgh
#define		TA2TGL		trgsr_addr.bit.ta2tgl
#define		TA2TGH		trgsr_addr.bit.ta2tgh
#define		TA3TGL		trgsr_addr.bit.ta3tgl
#define		TA3TGH		trgsr_addr.bit.ta3tgh
#define		TA4TGL		trgsr_addr.bit.ta4tgl
#define		TA4TGH		trgsr_addr.bit.ta4tgh

/*---------------------------------------------------------------------
	Timer B0 registers ; Read and write to this register in 16-bit units.
-----------------------------------------------------------------------*/
#pragma ADDRESS		tb0_addr	0350H	/* ^C}B0WX^					*/
UINT16		tb0_addr;              /* Timer B0 register */

#define		TB0		tb0_addr

/*---------------------------------------------------------------------
	Timer B1 registers ; Read and write to this register in 16-bit units.
-----------------------------------------------------------------------*/
#pragma ADDRESS		tb1_addr	0352H	/* ^C}B1WX^					*/
UINT16		tb1_addr;              /* Timer B1 register */

#define		TB1		tb1_addr

/*---------------------------------------------------------------------
	Timer B2 registers ; Read and write to this register in 16-bit units.
-----------------------------------------------------------------------*/
#pragma ADDRESS		tb2_addr	0354H	/* ^C}B2WX^					*/
UINT16		tb2_addr;              /* Timer B2 register */

#define		TB2		tb2_addr

/*---------------------------------------------------------------------
	Timer B3 registers ; Read and write to this register in 16-bit units.
-----------------------------------------------------------------------*/
#pragma ADDRESS		tb3_addr	0310H	/* ^C}B3WX^					*/
UINT16		tb3_addr;              /* Timer B3 register */

#define		TB3		tb3_addr

/*---------------------------------------------------------------------
	Timer B4 registers ; Read and write to this register in 16-bit units.
-----------------------------------------------------------------------*/
#pragma ADDRESS		tb4_addr	0312H	/* ^C}B4WX^					*/
UINT16		tb4_addr;              /* Timer B4 register */

#define		TB4		tb4_addr

/*---------------------------------------------------------------------
	Timer B5 registers ; Read and write to this register in 16-bit units.
-----------------------------------------------------------------------*/
#pragma ADDRESS		tb5_addr	0314H	/* ^C}B5WX^					*/
UINT16		tb5_addr;              /* Timer B5 register */

#define		TB5		tb5_addr

/*------------------------------------------------------
	Timer B mode registers
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	tmod0:1;        /* Operation mode select bit */
		UINT8	tmod1:1;        /* Operation mode select bit */
		UINT8	mr0:1;
		UINT8	mr1:1;
		UINT8	mr2:1;
		UINT8	mr3:1;
		UINT8	tck0:1;         /* Count source select bit */
		UINT8	tck1:1;         /* Count source select bit */
	} bit;
	UINT8	byte;
} TBMR_TYPE;

/*------------------------------------------------------
	Timer B0 mode registers
------------------------------------------------------*/
#pragma ADDRESS		tb0mr_addr	035bH	/* ^C}B0[hWX^			*/
TBMR_TYPE	tb0mr_addr;

#define		TB0MR		tb0mr_addr.byte
#define		TMOD0_TB0MR	tb0mr_addr.bit.tmod0    /* Operation mode select bit */
#define		TMOD1_TB0MR	tb0mr_addr.bit.tmod1    /* Operation mode select bit */
#define		MR0_TB0MR	tb0mr_addr.bit.mr0
#define		MR1_TB0MR	tb0mr_addr.bit.mr1
#define		MR2_TB0MR	tb0mr_addr.bit.mr2
#define		MR3_TB0MR	tb0mr_addr.bit.mr3
#define		TCK0_TB0MR	tb0mr_addr.bit.tck0 /* Count source select bit */
#define		TCK1_TB0MR	tb0mr_addr.bit.tck1 /* Count source select bit */

/*------------------------------------------------------
	Timer B1 mode registers
------------------------------------------------------*/
#pragma ADDRESS		tb1mr_addr	035cH	/* ^C}B1[hWX^			*/
TBMR_TYPE	tb1mr_addr;

#define		TB1MR		tb1mr_addr.byte
#define		TMOD0_TB1MR	tb1mr_addr.bit.tmod0    /* Operation mode select bit */
#define		TMOD1_TB1MR	tb1mr_addr.bit.tmod1    /* Operation mode select bit */
#define		MR0_TB1MR	tb1mr_addr.bit.mr0
#define		MR1_TB1MR	tb1mr_addr.bit.mr1
#define		MR2_TB1MR	tb1mr_addr.bit.mr2
#define		MR3_TB1MR	tb1mr_addr.bit.mr3
#define		TCK0_TB1MR	tb1mr_addr.bit.tck0 /* Count source select bit */
#define		TCK1_TB1MR	tb1mr_addr.bit.tck1 /* Count source select bit */

/*------------------------------------------------------
	Timer B2 mode registers
------------------------------------------------------*/
#pragma ADDRESS		tb2mr_addr	035dH	/* ^C}B2[hWX^			*/
TBMR_TYPE	tb2mr_addr;

#define		TB2MR		tb2mr_addr.byte
#define		TMOD0_TB2MR	tb2mr_addr.bit.tmod0    /* Operation mode select bit */
#define		TMOD1_TB2MR	tb2mr_addr.bit.tmod1    /* Operation mode select bit */
#define		MR0_TB2MR	tb2mr_addr.bit.mr0
#define		MR1_TB2MR	tb2mr_addr.bit.mr1
#define		MR2_TB2MR	tb2mr_addr.bit.mr2
#define		MR3_TB2MR	tb2mr_addr.bit.mr3
#define		TCK0_TB2MR	tb2mr_addr.bit.tck0 /* Count source select bit */
#define		TCK1_TB2MR	tb2mr_addr.bit.tck1 /* Count source select bit */

/*------------------------------------------------------
	Timer B3 mode registers
------------------------------------------------------*/
#pragma ADDRESS		tb3mr_addr	031bH	/* ^C}B3[hWX^			*/
TBMR_TYPE	tb3mr_addr;

#define		TB3MR		tb3mr_addr.byte
#define		TMOD0_TB3MR	tb3mr_addr.bit.tmod0    /* Operation mode select bit */
#define		TMOD1_TB3MR	tb3mr_addr.bit.tmod1    /* Operation mode select bit */
#define		MR0_TB3MR	tb3mr_addr.bit.mr0
#define		MR1_TB3MR	tb3mr_addr.bit.mr1
#define		MR2_TB3MR	tb3mr_addr.bit.mr2
#define		MR3_TB3MR	tb3mr_addr.bit.mr3
#define		TCK0_TB3MR	tb3mr_addr.bit.tck0 /* Count source select bit */
#define		TCK1_TB3MR	tb3mr_addr.bit.tck1 /* Count source select bit */

/*------------------------------------------------------
	Timer B4 mode registers
------------------------------------------------------*/
#pragma ADDRESS		tb4mr_addr	031cH	/* ^C}B4[hWX^			*/
TBMR_TYPE	tb4mr_addr;

#define		TB4MR		tb4mr_addr.byte
#define		TMOD0_TB4MR	tb4mr_addr.bit.tmod0    /* Operation mode select bit */
#define		TMOD1_TB4MR	tb4mr_addr.bit.tmod1    /* Operation mode select bit */
#define		MR0_TB4MR	tb4mr_addr.bit.mr0
#define		MR1_TB4MR	tb4mr_addr.bit.mr1
#define		MR2_TB4MR	tb4mr_addr.bit.mr2
#define		MR3_TB4MR	tb4mr_addr.bit.mr3
#define		TCK0_TB4MR	tb4mr_addr.bit.tck0 /* Count source select bit */
#define		TCK1_TB4MR	tb4mr_addr.bit.tck1 /* Count source select bit */

/*------------------------------------------------------
	Timer B5 mode registers
------------------------------------------------------*/
#pragma ADDRESS		tb5mr_addr	031dH	/* ^C}B5[hWX^			*/
TBMR_TYPE	tb5mr_addr;

#define		TB5MR		tb5mr_addr.byte
#define		TMOD0_TB5MR	tb5mr_addr.bit.tmod0    /* Operation mode select bit */
#define		TMOD1_TB5MR	tb5mr_addr.bit.tmod1    /* Operation mode select bit */
#define		MR0_TB5MR	tb5mr_addr.bit.mr0
#define		MR1_TB5MR	tb5mr_addr.bit.mr1
#define		MR2_TB5MR	tb5mr_addr.bit.mr2
#define		MR3_TB5MR	tb5mr_addr.bit.mr3
#define		TCK0_TB5MR	tb5mr_addr.bit.tck0 /* Count source select bit */
#define		TCK1_TB5MR	tb5mr_addr.bit.tck1 /* Count source select bit */

/*------------------------------------------------------
	Timer B3,4,5 count start flag
------------------------------------------------------*/
#pragma ADDRESS		tbsr_addr	0300H	/* ^C}B3,B4,B5JEgJntO	*/
typedef union {
	struct{
		UINT8	no_assign:5;	/*    s ޏꍇ0					*/
		UINT8	tb3s:1;
		UINT8	tb4s:1;
		UINT8	tb5s:1;
	} bit;
	UINT8	byte;
} TBSR_TYPE;
TBSR_TYPE	tbsr_addr;

#define		TBSR		tbsr_addr.byte
#define		TB3S		tbsr_addr.bit.tb3s
#define		TB4S		tbsr_addr.bit.tb4s
#define		TB5S		tbsr_addr.bit.tb5s

/********************************************************/
/* O[^p^C}@\							*/
/********************************************************/
/*------------------------------------------------------
	Three-phase PWM control regester 0
------------------------------------------------------*/
#pragma ADDRESS		invc0_addr	0308H	/* OPWM䃌WX^0				*/
typedef union {
	struct{
		UINT8	inv00:1;
		UINT8	inv01:1;
		UINT8	inv02:1;
		UINT8	inv03:1;
		UINT8	inv04:1;
		UINT8	inv05:1;
		UINT8	inv06:1;
		UINT8	inv07:1;
	} bit;
	UINT8	byte;
} INVC0_TYPE;
INVC0_TYPE	invc0_addr;

#define		INVC0		invc0_addr.byte
#define		INV00		invc0_addr.bit.inv00
#define		INV01		invc0_addr.bit.inv01
#define		INV02		invc0_addr.bit.inv02
#define		INV03		invc0_addr.bit.inv03
#define		INV04		invc0_addr.bit.inv04
#define		INV05		invc0_addr.bit.inv05
#define		INV06		invc0_addr.bit.inv06
#define		INV07		invc0_addr.bit.inv07

/*------------------------------------------------------
	Three-phase PWM control regester 1
------------------------------------------------------*/
#pragma ADDRESS		invc1_addr	0309H	/* OPWM䃌WX^1				*/
typedef union {
	struct{
		UINT8	inv10:1;
		UINT8	inv11:1;
		UINT8	inv12:1;
		UINT8	inv13:1;
		UINT8	inv14:1;
		UINT8	inv15:1;
		UINT8	inv16:1;
		UINT8	reserved:1;		/* RW 0Œ									*/
	} bit;
	UINT8	byte;
} INVC1_TYPE;
INVC1_TYPE	invc1_addr;

#define		INVC1		invc1_addr.byte
#define		INV10		invc1_addr.bit.inv10
#define		INV11		invc1_addr.bit.inv11
#define		INV12		invc1_addr.bit.inv12
#define		INV13		invc1_addr.bit.inv13
#define		INV14		invc1_addr.bit.inv14
#define		INV15		invc1_addr.bit.inv15
#define		INV16		invc1_addr.bit.inv16

/*------------------------------------------------------
	Three-phase output buffer register 0
------------------------------------------------------*/
#pragma ADDRESS		idb0_addr	030aH	/* Oo̓obt@WX^0		*/
typedef union {
	struct{
		UINT8	du0:1;
		UINT8	dub0:1;
		UINT8	dv0:1;
		UINT8	dvb0:1;
		UINT8	dw0:1;
		UINT8	dwb0:1;
		UINT8	reserved:2;		/* RO s									*/
	} bit;
	UINT8	byte;
} IDB0_TYPE;
IDB0_TYPE	idb0_addr;

#define		IDB0		idb0_addr.byte
#define		DU0			idb0_addr.bit.du0
#define		DUB0		idb0_addr.bit.dub0
#define		DV0			idb0_addr.bit.dv0
#define		DVB0		idb0_addr.bit.dvb0
#define		DW0			idb0_addr.bit.dw0
#define		DWB0		idb0_addr.bit.dwb0

/*------------------------------------------------------
	Three-phase output buffer register 1
------------------------------------------------------*/
#pragma ADDRESS		idb1_addr	030bH	/* Oo̓obt@WX^1		*/
typedef union {
	struct{
		UINT8	du1:1;
		UINT8	dub1:1;
		UINT8	dv1:1;
		UINT8	dvb1:1;
		UINT8	dw1:1;
		UINT8	dwb1:1;
		UINT8	reserved:2;		/* RO s									*/
	} bit;
	UINT8	byte;
} IDB1_TYPE;
IDB1_TYPE	idb1_addr;

#define		IDB1		idb1_addr.byte
#define		DU1			idb1_addr.bit.du1
#define		DUB1		idb1_addr.bit.dub1
#define		DV1			idb1_addr.bit.dv1
#define		DVB1		idb1_addr.bit.dvb1
#define		DW1			idb1_addr.bit.dw1
#define		DWB1		idb1_addr.bit.dwb1

/*------------------------------------------------------
	Dead time timer ; Use "MOV" instruction when writing to this register.
------------------------------------------------------*/
#pragma ADDRESS		dtt_addr	030cH	/* Zh~^C}	*/
typedef union {
	struct{
		UINT8	b0:1;
		UINT8	b1:1;
		UINT8	b2:1;
		UINT8	b3:1;
		UINT8	b4:1;
		UINT8	b5:1;
		UINT8	b6:1;
		UINT8	b7:1;
	} bit;
	UINT8	byte;
} DTT_TYPE;
DTT_TYPE	dtt_addr;

#define		DTT			dtt_addr.byte

/*------------------------------------------------------
	Timer B2 interrupt occurrences frequency set counter ; Use "MOV" instruction when writing to this register.
------------------------------------------------------*/
#pragma ADDRESS		ictb2_addr	030dH	/* ^C}B2荞ݔpxݒJE^	*/
typedef union {
	struct{
		UINT8	b0:1;
		UINT8	b1:1;
		UINT8	b2:1;
		UINT8	b3:1;
		UINT8	no_assign:4;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} ICTB2_TYPE;
ICTB2_TYPE	ictb2_addr;

#define		ICTB2		ictb2_addr.byte

/*---------------------------------------------------------------------
	Timer A1-1 registers ; Read and write to this register in 16-bit units.
-----------------------------------------------------------------------*/
#pragma ADDRESS		ta11_addr	0302H	/* ^C}A1-1WX^				*/
UINT16		ta11_addr;             /* Timer A1-1 register */

#define		TA11		ta11_addr

/*---------------------------------------------------------------------
	Timer A2-1 registers ; Read and write to this register in 16-bit units.
-----------------------------------------------------------------------*/
#pragma ADDRESS		ta21_addr	0304H	/* ^C}A2-1WX^				*/
UINT16		ta21_addr;             /* Timer A2-1 register */

#define		TA21		ta21_addr

/*---------------------------------------------------------------------
	Timer A4-1 registers ; Read and write to this register in 16-bit units.
-----------------------------------------------------------------------*/
#pragma ADDRESS		ta41_addr	0306H	/* ^C}A4-1WX^				*/
UINT16		ta41_addr;             /* Timer A4-1 register */

#define		TA41		ta41_addr

/*------------------------------------------------------
	Timer B2 special mode register
------------------------------------------------------*/
#pragma ADDRESS		tb2sc_addr	035eH	/* ^C}B2ꃂ[hWX^		*/
typedef union {
	struct{
		UINT8	pwcon:1;
		UINT8	no_assign:7;	/*    0Œ									*/
	} bit;
	UINT8	byte;
} TB2SC_TYPE;
TB2SC_TYPE	tb2sc_addr;

#define		TB2SC		tb2sc_addr.byte
#define		PWCON		tb2sc_addr.bit.pwcon

/********************************************************/
/* VAI/O											*/
/********************************************************/
/*------------------------------------------------------
	UART transmit buffer register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	b0:1;
		UINT8	b1:1;
		UINT8	b2:1;
		UINT8	b3:1;
		UINT8	b4:1;
		UINT8	b5:1;
		UINT8	b6:1;
		UINT8	b7:1;
		UINT8	b8:1;
		UINT8	no_assign:7;	/*    s ޏꍇ0					*/
	} bit;
	struct{
		UINT8	low;                /* low  8 bit */
		UINT8	high;               /* high 8 bit */
	} byte;
	UINT16	word;
} UTB_TYPE;

/*------------------------------------------------------
	UART0 transmit buffer register
------------------------------------------------------*/
#pragma ADDRESS		u0tb_addr	036aH	/* UART0Mobt@WX^		*/
UTB_TYPE	u0tb_addr;

#define		U0TB	u0tb_addr.word          /* UART0 Transmit buffer register 16 bit ; Use "MOV" instruction when writing to this register. */
#define		U0TBL	u0tb_addr.byte.low          /* UART0 Transmit buffer register low  8 bit */
#define		U0TBH	u0tb_addr.byte.high         /* UART0 Transmit buffer register high 8 bit */

/*------------------------------------------------------
	UART1 transmit buffer register
------------------------------------------------------*/
#pragma ADDRESS		u1tb_addr	02eaH	/* UART1Mobt@WX^		*/
UTB_TYPE	u1tb_addr;

#define		U1TB	u1tb_addr.word          /* UART1 Transmit buffer register 16 bit ; Use "MOV" instruction when writing to this register. */
#define		U1TBL	u1tb_addr.byte.low          /* UART1 Transmit buffer register low  8 bit */
#define		U1TBH	u1tb_addr.byte.high         /* UART1 Transmit buffer register high 8 bit */

/*------------------------------------------------------
	UART2 transmit buffer register
------------------------------------------------------*/
#pragma ADDRESS		u2tb_addr	033aH	/* UART2Mobt@WX^		*/
UTB_TYPE	u2tb_addr;

#define		U2TB	u2tb_addr.word          /* UART2 Transmit buffer register 16 bit ; Use "MOV" instruction when writing to this register. */
#define		U2TBL	u2tb_addr.byte.low          /* UART2 Transmit buffer register low  8 bit */
#define		U2TBH	u2tb_addr.byte.high         /* UART2 Transmit buffer register high 8 bit */

/*------------------------------------------------------
	UART3 transmit buffer register
------------------------------------------------------*/
#pragma ADDRESS		u3tb_addr	032aH	/* UART3Mobt@WX^		*/
UTB_TYPE	u3tb_addr;

#define		U3TB	u3tb_addr.word          /* UART3 Transmit buffer register 16 bit ; Use "MOV" instruction when writing to this register. */
#define		U3TBL	u3tb_addr.byte.low          /* UART3 Transmit buffer register low  8 bit */
#define		U3TBH	u3tb_addr.byte.high         /* UART3 Transmit buffer register high 8 bit */

/*------------------------------------------------------
	UART4 transmit buffer register
------------------------------------------------------*/
#pragma ADDRESS		u4tb_addr	02faH	/* UART4Mobt@WX^		*/
UTB_TYPE	u4tb_addr;

#define		U4TB	u4tb_addr.word          /* UART4 Transmit buffer register 16 bit ; Use "MOV" instruction when writing to this register. */
#define		U4TBL	u4tb_addr.byte.low          /* UART4 Transmit buffer register low  8 bit */
#define		U4TBH	u4tb_addr.byte.high         /* UART4 Transmit buffer register high 8 bit */

/*------------------------------------------------------
	UART receive buffer register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	b0:1;
		UINT8	b1:1;
		UINT8	b2:1;
		UINT8	b3:1;
		UINT8	b4:1;
		UINT8	b5:1;
		UINT8	b6:1;
		UINT8	b7:1;
		UINT8	b8:1;
		UINT8	no_assign:2;	/*    0Œ									*/
		UINT8	abt:1;              /* Arbitration lost detecting flag */
		UINT8	oer:1;              /* Overrun error flag */
		UINT8	fer:1;              /* Framing error flag */
		UINT8	per:1;              /* Parity error flag */
		UINT8	sum:1;              /* Error sum flag */
	} bit;
	struct{
		UINT8    low;                /* Low  8 bit */
		UINT8    high;               /* High 8 bit */
	} byte;
	UINT16  word;
} URB_TYPE;

/*------------------------------------------------------
	UART0 receive buffer register
------------------------------------------------------*/
#pragma ADDRESS		u0rb_addr	036eH	/* UART0Mobt@WX^		*/
URB_TYPE	u0rb_addr;

#define		U0RB		u0rb_addr.word
#define		U0RBL		u0rb_addr.byte.low
#define		U0RBH		u0rb_addr.byte.high
#define		ABT_U0RB	u0rb_addr.bit.abt   /* Arbitration lost detecting flag */
#define		OER_U0RB	u0rb_addr.bit.oer   /* Overrun error flag */
#define		FER_U0RB	u0rb_addr.bit.fer   /* Framing error flag */
#define		PER_U0RB	u0rb_addr.bit.per   /* Parity error flag */
#define		SUM_U0RB	u0rb_addr.bit.sum   /* Error sum flag */

/*------------------------------------------------------
	UART1 receive buffer register
------------------------------------------------------*/
#pragma ADDRESS		u1rb_addr	02eeH	/* UART1Mobt@WX^		*/
URB_TYPE	u1rb_addr;

#define		U1RB		u1rb_addr.word
#define		U1RBL		u1rb_addr.byte.low
#define		U1RBH		u1rb_addr.byte.high
#define		ABT_U1RB	u1rb_addr.bit.abt   /* Arbitration lost detecting flag */
#define		OER_U1RB	u1rb_addr.bit.oer   /* Overrun error flag */
#define		FER_U1RB	u1rb_addr.bit.fer   /* Framing error flag */
#define		PER_U1RB	u1rb_addr.bit.per   /* Parity error flag */
#define		SUM_U1RB	u1rb_addr.bit.sum   /* Error sum flag */

/*------------------------------------------------------
	UART2 receive buffer register
------------------------------------------------------*/
#pragma ADDRESS		u2rb_addr	033eH	/* UART2Mobt@WX^		*/
URB_TYPE	u2rb_addr;

#define		U2RB		u2rb_addr.word
#define		U2RBL		u2rb_addr.byte.low
#define		U2RBH		u2rb_addr.byte.high
#define		ABT_U2RB	u2rb_addr.bit.abt   /* Arbitration lost detecting flag */
#define		OER_U2RB	u2rb_addr.bit.oer   /* Overrun error flag */
#define		FER_U2RB	u2rb_addr.bit.fer   /* Framing error flag */
#define		PER_U2RB	u2rb_addr.bit.per   /* Parity error flag */
#define		SUM_U2RB	u2rb_addr.bit.sum   /* Error sum flag */

/*------------------------------------------------------
	UART3 receive buffer register
------------------------------------------------------*/
#pragma ADDRESS		u3rb_addr	032eH	/* UART3Mobt@WX^		*/
URB_TYPE	u3rb_addr;

#define		U3RB		u3rb_addr.word
#define		U3RBL		u3rb_addr.byte.low
#define		U3RBH		u3rb_addr.byte.high
#define		ABT_U3RB	u3rb_addr.bit.abt   /* Arbitration lost detecting flag */
#define		OER_U3RB	u3rb_addr.bit.oer   /* Overrun error flag */
#define		FER_U3RB	u3rb_addr.bit.fer   /* Framing error flag */
#define		PER_U3RB	u3rb_addr.bit.per   /* Parity error flag */
#define		SUM_U3RB	u3rb_addr.bit.sum   /* Error sum flag */

/*------------------------------------------------------
	UART4 receive buffer register
------------------------------------------------------*/
#pragma ADDRESS		u4rb_addr	02feH	/* UART4Mobt@WX^		*/
URB_TYPE	u4rb_addr;

#define		U4RB		u4rb_addr.word
#define		U4RBL		u4rb_addr.byte.low
#define		U4RBH		u4rb_addr.byte.high
#define		ABT_U4RB	u4rb_addr.bit.abt   /* Arbitration lost detecting flag */
#define		OER_U4RB	u4rb_addr.bit.oer   /* Overrun error flag */
#define		FER_U4RB	u4rb_addr.bit.fer   /* Framing error flag */
#define		PER_U4RB	u4rb_addr.bit.per   /* Parity error flag */
#define		SUM_U4RB	u4rb_addr.bit.sum   /* Error sum flag */

/*------------------------------------------------------
	UART0 bit rate generators ; Use "MOV" instruction when writing to these registers.
------------------------------------------------------*/
#pragma ADDRESS		u0brg_addr	0369H	/* UART0]xWX^			*/
UINT8	u0brg_addr;

#define		U0BRG		u0brg_addr

/*------------------------------------------------------
	UART1 bit rate generators ; Use "MOV" instruction when writing to these registers.
------------------------------------------------------*/
#pragma ADDRESS		u1brg_addr	02e9H	/* UART1]xWX^			*/
UINT8	u1brg_addr;

#define		U1BRG		u1brg_addr

/*------------------------------------------------------
	UART2 bit rate generators ; Use "MOV" instruction when writing to these registers.
------------------------------------------------------*/
#pragma ADDRESS		u2brg_addr	0339H	/* UART2]xWX^			*/
UINT8	u2brg_addr;

#define		U2BRG		u2brg_addr

/*------------------------------------------------------
	UART3 bit rate generators ; Use "MOV" instruction when writing to these registers.
------------------------------------------------------*/
#pragma ADDRESS		u3brg_addr	0329H	/* UART3]xWX^			*/
UINT8	u3brg_addr;

#define		U3BRG		u3brg_addr

/*------------------------------------------------------
	UART4 bit rate generators ; Use "MOV" instruction when writing to these registers.
------------------------------------------------------*/
#pragma ADDRESS		u4brg_addr	02f9H	/* UART4]xWX^			*/
UINT8	u4brg_addr;

#define		U4BRG		u4brg_addr

/*------------------------------------------------------
	UART transmit/receive mode registers
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	smd0:1;             /* Serial I/O mode select bit */
		UINT8	smd1:1;             /* Serial I/O mode select bit */
		UINT8	smd2:1;             /* Serial I/O mode select bit */
		UINT8	ckdir:1;            /* Internal/external clock select bit */
		UINT8	stps:1;             /* Stop bit length select bit */
		UINT8	pry:1;              /* Odd/even parity select bit */
		UINT8	prye:1;             /* Parity enable bit */
		UINT8	iopol:1;            /* TxD RxD I/O polarity reverse bit */
	} bit;
	UINT8	byte;
} UMR_TYPE;

/*------------------------------------------------------
	UART0 transmit/receive mode registers
------------------------------------------------------*/
#pragma ADDRESS		u0mr_addr	0368H	/* UART0M[hWX^		*/
UMR_TYPE	u0mr_addr;

#define		U0MR		u0mr_addr.byte
#define		SMD0_U0MR	u0mr_addr.bit.smd0  /* Serial I/O mode select bit */
#define		SMD1_U0MR	u0mr_addr.bit.smd1  /* Serial I/O mode select bit */
#define		SMD2_U0MR	u0mr_addr.bit.smd2  /* Serial I/O mode select bit */
#define		CKDIR_U0MR	u0mr_addr.bit.ckdir /* Internal/external clock select bit */
#define		STPS_U0MR	u0mr_addr.bit.stps  /* Stop bit length select bit */
#define		PRY_U0MR	u0mr_addr.bit.pry   /* Odd/even parity select bit */
#define		PRYE_U0MR	u0mr_addr.bit.prye  /* Parity enable bit */
#define		IOPOL_U0MR	u0mr_addr.bit.iopol  /* TxD RxD I/O polarity reverse bit */

/*------------------------------------------------------
	UART1 transmit/receive mode registers
------------------------------------------------------*/
#pragma ADDRESS		u1mr_addr	02e8H	/* UART1M[hWX^		*/
UMR_TYPE	u1mr_addr;

#define		U1MR		u1mr_addr.byte

#define		SMD0_U1MR	u1mr_addr.bit.smd0  /* Serial I/O mode select bit */
#define		SMD1_U1MR	u1mr_addr.bit.smd1  /* Serial I/O mode select bit */
#define		SMD2_U1MR	u1mr_addr.bit.smd2  /* Serial I/O mode select bit */
#define		CKDIR_U1MR	u1mr_addr.bit.ckdir /* Internal/external clock select bit */
#define		STPS_U1MR	u1mr_addr.bit.stps  /* Stop bit length select bit */
#define		PRY_U1MR	u1mr_addr.bit.pry   /* Odd/even parity select bit */
#define		PRYE_U1MR	u1mr_addr.bit.prye  /* Parity enable bit */
#define		IOPOL_U1MR	u1mr_addr.bit.iopol  /* TxD RxD I/O polarity reverse bit */

/*------------------------------------------------------
	UART2 transmit/receive mode registers
------------------------------------------------------*/
#pragma ADDRESS		u2mr_addr	0338H	/* UART2M[hWX^		*/
UMR_TYPE	u2mr_addr;

#define		U2MR		u2mr_addr.byte
#define		SMD0_U2MR	u2mr_addr.bit.smd0  /* Serial I/O mode select bit */
#define		SMD1_U2MR	u2mr_addr.bit.smd1  /* Serial I/O mode select bit */
#define		SMD2_U2MR	u2mr_addr.bit.smd2  /* Serial I/O mode select bit */
#define		CKDIR_U2MR	u2mr_addr.bit.ckdir /* Internal/external clock select bit */
#define		STPS_U2MR	u2mr_addr.bit.stps  /* Stop bit length select bit */
#define		PRY_U2MR	u2mr_addr.bit.pry   /* Odd/even parity select bit */
#define		PRYE_U2MR	u2mr_addr.bit.prye  /* Parity enable bit */
#define		IOPOL_U2MR	u2mr_addr.bit.iopol  /* TxD RxD I/O polarity reverse bit */

/*------------------------------------------------------
	UART3 transmit/receive mode registers
------------------------------------------------------*/
#pragma ADDRESS		u3mr_addr	0328H	/* UART3M[hWX^		*/
UMR_TYPE	u3mr_addr;

#define		U3MR		u3mr_addr.byte
#define		SMD0_U3MR	u3mr_addr.bit.smd0  /* Serial I/O mode select bit */
#define		SMD1_U3MR	u3mr_addr.bit.smd1  /* Serial I/O mode select bit */
#define		SMD2_U3MR	u3mr_addr.bit.smd2  /* Serial I/O mode select bit */
#define		CKDIR_U3MR	u3mr_addr.bit.ckdir /* Internal/external clock select bit */
#define		STPS_U3MR	u3mr_addr.bit.stps  /* Stop bit length select bit */
#define		PRY_U3MR	u3mr_addr.bit.pry   /* Odd/even parity select bit */
#define		PRYE_U3MR	u3mr_addr.bit.prye  /* Parity enable bit */
#define		IOPOL_U3MR	u3mr_addr.bit.iopol  /* TxD RxD I/O polarity reverse bit */

/*------------------------------------------------------
	UART4 transmit/receive mode registers
------------------------------------------------------*/
#pragma ADDRESS		u4mr_addr	02f8H	/* UART4M[hWX^		*/
UMR_TYPE	u4mr_addr;

#define		U4MR		u4mr_addr.byte
#define		SMD0_U4MR	u4mr_addr.bit.smd0  /* Serial I/O mode select bit */
#define		SMD1_U4MR	u4mr_addr.bit.smd1  /* Serial I/O mode select bit */
#define		SMD2_U4MR	u4mr_addr.bit.smd2  /* Serial I/O mode select bit */
#define		CKDIR_U4MR	u4mr_addr.bit.ckdir /* Internal/external clock select bit */
#define		STPS_U4MR	u4mr_addr.bit.stps  /* Stop bit length select bit */
#define		PRY_U4MR	u4mr_addr.bit.pry   /* Odd/even parity select bit */
#define		PRYE_U4MR	u4mr_addr.bit.prye  /* Parity enable bit */
#define		IOPOL_U4MR	u4mr_addr.bit.iopol  /* TxD RxD I/O polarity reverse bit */

/*------------------------------------------------------
	UART transmit/receive control register 0
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	clk0:1;         /* BRG count source select bit */
		UINT8	clk1:1;         /* BRG count source select bit */
		UINT8	crs:1;          /* CTS~/RTS~ function select bit */
		UINT8	txept:1;        /* Transmit register empty flag */
		UINT8	crd:1;          /* CTS~/RTS~ disable bit */
		UINT8	nch:1;          /* Data output select bit */
		UINT8	ckpol:1;        /* CLK polarity select bit */
		UINT8	uform:1;        /* Transfer format select bit */
	} bit;
	UINT8	byte;
} UC0_TYPE;

/*------------------------------------------------------
	UART0 transmit/receive control register 0
------------------------------------------------------*/
#pragma ADDRESS		u0c0_addr	036cH	/* UART0M䃌WX^0			*/
UC0_TYPE	u0c0_addr;

#define		U0C0		u0c0_addr.byte
#define		CLK0_U0C0	u0c0_addr.bit.clk0  /* BRG count source select bit */
#define		CLK1_U0C0	u0c0_addr.bit.clk1  /* BRG count source select bit */
#define		CRS_U0C0	u0c0_addr.bit.crs   /* CTS~/RTS~ function select bit */
#define		TXEPT_U0C0	u0c0_addr.bit.txept /* Transmit register empty flag */
#define		CRD_U0C0	u0c0_addr.bit.crd   /* CTS~/RTS~ disable bit */
#define		NCH_U0C0	u0c0_addr.bit.nch   /* Data output select bit */
#define		CKPOL_U0C0	u0c0_addr.bit.ckpol /* CLK polarity select bit */
#define		UFORM_U0C0	u0c0_addr.bit.uform /* Transfer format select bit */

/*------------------------------------------------------
	UART1 transmit/receive control register 0
------------------------------------------------------*/
#pragma ADDRESS		u1c0_addr	02ecH	/* UART1M䃌WX^0			*/
UC0_TYPE	u1c0_addr;

#define		U1C0		u1c0_addr.byte
#define		CLK0_U1C0	u1c0_addr.bit.clk0  /* BRG count source select bit */
#define		CLK1_U1C0	u1c0_addr.bit.clk1  /* BRG count source select bit */
#define		CRS_U1C0	u1c0_addr.bit.crs   /* CTS~/RTS~ function select bit */
#define		TXEPT_U1C0	u1c0_addr.bit.txept /* Transmit register empty flag */
#define		CRD_U1C0	u1c0_addr.bit.crd   /* CTS~/RTS~ disable bit */
#define		NCH_U1C0	u1c0_addr.bit.nch   /* Data output select bit */
#define		CKPOL_U1C0	u1c0_addr.bit.ckpol /* CLK polarity select bit */
#define		UFORM_U1C0	u1c0_addr.bit.uform /* Transfer format select bit */

/*------------------------------------------------------
	UART2 transmit/receive control register 0
------------------------------------------------------*/
#pragma ADDRESS		u2c0_addr	033cH	/* UART2M䃌WX^0			*/
UC0_TYPE	u2c0_addr;

#define		U2C0		u2c0_addr.byte
#define		CLK0_U2C0	u2c0_addr.bit.clk0  /* BRG count source select bit */
#define		CLK1_U2C0	u2c0_addr.bit.clk1  /* BRG count source select bit */
#define		CRS_U2C0	u2c0_addr.bit.crs   /* CTS~/RTS~ function select bit */
#define		TXEPT_U2C0	u2c0_addr.bit.txept /* Transmit register empty flag */
#define		CRD_U2C0	u2c0_addr.bit.crd   /* CTS~/RTS~ disable bit */
#define		CKPOL_U2C0	u2c0_addr.bit.ckpol /* CLK polarity select bit */
#define		UFORM_U2C0	u2c0_addr.bit.uform /* Transfer format select bit */

/*------------------------------------------------------
	UART3 transmit/receive control register 0
------------------------------------------------------*/
#pragma ADDRESS		u3c0_addr	032cH	/* UART3M䃌WX^0			*/
UC0_TYPE	u3c0_addr;

#define		U3C0		u3c0_addr.byte
#define		CLK0_U3C0	u3c0_addr.bit.clk0  /* BRG count source select bit */
#define		CLK1_U3C0	u3c0_addr.bit.clk1  /* BRG count source select bit */
#define		CRS_U3C0	u3c0_addr.bit.crs   /* CTS~/RTS~ function select bit */
#define		TXEPT_U3C0	u3c0_addr.bit.txept /* Transmit register empty flag */
#define		CRD_U3C0	u3c0_addr.bit.crd   /* CTS~/RTS~ disable bit */
#define		NCH_U3C0	u3c0_addr.bit.nch   /* Data output select bit */
#define		CKPOL_U3C0	u3c0_addr.bit.ckpol /* CLK polarity select bit */
#define		UFORM_U3C0	u3c0_addr.bit.uform /* Transfer format select bit */

/*------------------------------------------------------
	UART4 transmit/receive control register 0
------------------------------------------------------*/
#pragma ADDRESS		u4c0_addr	02fcH	/* UART4M䃌WX^0			*/
UC0_TYPE	u4c0_addr;

#define		U4C0		u4c0_addr.byte
#define		CLK0_U4C0	u4c0_addr.bit.clk0  /* BRG count source select bit */
#define		CLK1_U4C0	u4c0_addr.bit.clk1  /* BRG count source select bit */
#define		CRS_U4C0	u4c0_addr.bit.crs   /* CTS~/RTS~ function select bit */
#define		TXEPT_U4C0	u4c0_addr.bit.txept /* Transmit register empty flag */
#define		CRD_U4C0	u4c0_addr.bit.crd   /* CTS~/RTS~ disable bit */
#define		NCH_U4C0	u4c0_addr.bit.nch   /* Data output select bit */
#define		CKPOL_U4C0	u4c0_addr.bit.ckpol /* CLK polarity select bit */
#define		UFORM_U4C0	u4c0_addr.bit.uform /* Transfer format select bit */

/*------------------------------------------------------
	UART transmit/receive control register 1
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	te:1;
		UINT8	ti:1;
		UINT8	re:1;
		UINT8	ri:1;
		UINT8	uiirs:1;
		UINT8	uirrm:1;
		UINT8	uilch:1;
		UINT8	sclkstpb_uiere:1;
	} bit;
	UINT8	byte;
} UC1_TYPE;

/*------------------------------------------------------
	UART0 transmit/receive control register 1
------------------------------------------------------*/
#pragma ADDRESS		u0c1_addr	036dH	/* UART0M䃌WX^1			*/
UC1_TYPE	u0c1_addr;

#define		U0C1		u0c1_addr.byte
#define		TE_U0C1		u0c1_addr.bit.te
#define		TI_U0C1		u0c1_addr.bit.ti
#define		RE_U0C1		u0c1_addr.bit.re
#define		RI_U0C1		u0c1_addr.bit.ri
#define		U0IRS		u0c1_addr.bit.uiirs
#define		U0RRM		u0c1_addr.bit.uirrm
#define		U0LCH		u0c1_addr.bit.uilch
#define		SCLKSTPB_U0C1	u0c1_addr.bit.sclkstpb_uiere
#define		U0ERE		u0c1_addr.bit.sclkstpb_uiere

/*------------------------------------------------------
	UART1 transmit/receive control register 1
------------------------------------------------------*/
#pragma ADDRESS		u1c1_addr	02edH	/* UART1M䃌WX^1			*/
UC1_TYPE	u1c1_addr;

#define		U1C1		u1c1_addr.byte
#define		TE_U1C1		u1c1_addr.bit.te
#define		TI_U1C1		u1c1_addr.bit.ti
#define		RE_U1C1		u1c1_addr.bit.re
#define		RI_U1C1		u1c1_addr.bit.ri
#define		U1IRS		u1c1_addr.bit.uiirs
#define		U1RRM		u1c1_addr.bit.uirrm
#define		U1LCH		u1c1_addr.bit.uilch
#define		SCLKSTPB_U1C1	u1c1_addr.bit.sclkstpb_uiere
#define		U1ERE		u1c1_addr.bit.sclkstpb_uiere

/*------------------------------------------------------
	UART2 transmit/receive control register 1
------------------------------------------------------*/
#pragma ADDRESS		u2c1_addr	033dH	/* UART2M䃌WX^1			*/
UC1_TYPE	u2c1_addr;

#define		U2C1		u2c1_addr.byte
#define		TE_U2C1		u2c1_addr.bit.te
#define		TI_U2C1		u2c1_addr.bit.ti
#define		RE_U2C1		u2c1_addr.bit.re
#define		RI_U2C1		u2c1_addr.bit.ri
#define		U2IRS		u2c1_addr.bit.uiirs
#define		U2RRM		u2c1_addr.bit.uirrm
#define		U2LCH		u2c1_addr.bit.uilch
#define		SCLKSTPB_U2C1	u2c1_addr.bit.sclkstpb_uiere
#define		U2ERE		u2c1_addr.bit.sclkstpb_uiere

/*------------------------------------------------------
	UART3 transmit/receive control register 1
------------------------------------------------------*/
#pragma ADDRESS		u3c1_addr	032dH	/* UART3M䃌WX^1			*/
UC1_TYPE	u3c1_addr;

#define		U3C1		u3c1_addr.byte
#define		TE_U3C1		u3c1_addr.bit.te
#define		TI_U3C1		u3c1_addr.bit.ti
#define		RE_U3C1		u3c1_addr.bit.re
#define		RI_U3C1		u3c1_addr.bit.ri
#define		U3IRS		u3c1_addr.bit.uiirs
#define		U3RRM		u3c1_addr.bit.uirrm
#define		U3LCH		u3c1_addr.bit.uilch
#define		SCLKSTPB_U3C1	u3c1_addr.bit.sclkstpb_uiere
#define		U3ERE		u3c1_addr.bit.sclkstpb_uiere

/*------------------------------------------------------
	UART4 transmit/receive control register 1
------------------------------------------------------*/
#pragma ADDRESS		u4c1_addr	02fdH	/* UART4M䃌WX^1			*/
UC1_TYPE	u4c1_addr;

#define		U4C1		u4c1_addr.byte
#define		TE_U4C1		u4c1_addr.bit.te
#define		TI_U4C1		u4c1_addr.bit.ti
#define		RE_U4C1		u4c1_addr.bit.re
#define		RI_U4C1		u4c1_addr.bit.ri
#define		U4IRS		u4c1_addr.bit.uiirs
#define		U4RRM		u4c1_addr.bit.uirrm
#define		U4LCH		u4c1_addr.bit.uilch
#define		SCLKSTPB_U4C1	u4c1_addr.bit.sclkstpb_uiere
#define		U4ERE		u4c1_addr.bit.sclkstpb_uiere

/*------------------------------------------------------
	UART special mode registers
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	iicm:1;
		UINT8	abc:1;
		UINT8	bbs:1;
		UINT8	lsyn:1;
		UINT8	abscs:1;
		UINT8	acse:1;
		UINT8	sss:1;
		UINT8	sclkdiv:1;
	} bit;
	UINT8	byte;
} USMR_TYPE;

/*------------------------------------------------------
	UART0 special mode registers
------------------------------------------------------*/
#pragma ADDRESS		u0smr_addr	0367H	/* UART0ꃂ[hWX^			*/
USMR_TYPE	u0smr_addr;

#define		U0SMR		u0smr_addr.byte
#define		IICM_U0SMR	u0smr_addr.bit.iicm 
#define		ABC_U0SMR	u0smr_addr.bit.abc
#define		BBS_U0SMR	u0smr_addr.bit.bbs
#define		LSYN_U0SMR	u0smr_addr.bit.lsyn
#define		ABSCS_U0SMR	u0smr_addr.bit.abscs
#define		ACSE_U0SMR	u0smr_addr.bit.acse
#define		SSS_U0SMR	u0smr_addr.bit.sss
#define		SCLKDIV_U0SMR	u0smr_addr.bit.sclkdiv

/*------------------------------------------------------
	UART1 special mode registers
------------------------------------------------------*/
#pragma ADDRESS		u1smr_addr	02e7H	/* UART1ꃂ[hWX^			*/
USMR_TYPE	u1smr_addr;

#define		U1SMR		u1smr_addr.byte
#define		IICM_U1SMR	u1smr_addr.bit.iicm 
#define		ABC_U1SMR	u1smr_addr.bit.abc
#define		BBS_U1SMR	u1smr_addr.bit.bbs
#define		LSYN_U1SMR	u1smr_addr.bit.lsyn
#define		ABSCS_U1SMR	u1smr_addr.bit.abscs
#define		ACSE_U1SMR	u1smr_addr.bit.acse
#define		SSS_U1SMR	u1smr_addr.bit.sss
#define		SCLKDIV_U1SMR	u1smr_addr.bit.sclkdiv

/*------------------------------------------------------
	UART2 special mode registers
------------------------------------------------------*/
#pragma ADDRESS		u2smr_addr	0337H	/* UART2ꃂ[hWX^			*/
USMR_TYPE	u2smr_addr;

#define		U2SMR		u2smr_addr.byte
#define		IICM_U2SMR	u2smr_addr.bit.iicm 
#define		ABC_U2SMR	u2smr_addr.bit.abc
#define		BBS_U2SMR	u2smr_addr.bit.bbs
#define		LSYN_U2SMR	u2smr_addr.bit.lsyn
#define		ABSCS_U2SMR	u2smr_addr.bit.abscs
#define		ACSE_U2SMR	u2smr_addr.bit.acse
#define		SSS_U2SMR	u2smr_addr.bit.sss
#define		SCLKDIV_U2SMR	u2smr_addr.bit.sclkdiv

/*------------------------------------------------------
	UART3 special mode registers
------------------------------------------------------*/
#pragma ADDRESS		u3smr_addr	02e7H	/* UART3ꃂ[hWX^			*/
USMR_TYPE	u3smr_addr;

#define		U3SMR		u3smr_addr.byte
#define		IICM_U3SMR	u3smr_addr.bit.iicm
#define		ABC_U3SMR	u3smr_addr.bit.abc
#define		BBS_U3SMR	u3smr_addr.bit.bbs
#define		LSYN_U3SMR	u3smr_addr.bit.lsyn
#define		ABSCS_U3SMR	u3smr_addr.bit.abscs
#define		ACSE_U3SMR	u3smr_addr.bit.acse
#define		SSS_U3SMR	u3smr_addr.bit.sss
#define		SCLKDIV_U3SMR	u3smr_addr.bit.sclkdiv

/*------------------------------------------------------
	UART4 special mode registers
------------------------------------------------------*/
#pragma ADDRESS		u4smr_addr	02f7H	/* UART4ꃂ[hWX^			*/
USMR_TYPE	u4smr_addr;

#define		U4SMR		u4smr_addr.byte
#define		IICM_U4SMR	u4smr_addr.bit.iicm
#define		ABC_U4SMR	u4smr_addr.bit.abc
#define		BBS_U4SMR	u4smr_addr.bit.bbs
#define		LSYN_U4SMR	u4smr_addr.bit.lsyn
#define		ABSCS_U4SMR	u4smr_addr.bit.abscs
#define		ACSE_U4SMR	u4smr_addr.bit.acse
#define		SSS_U4SMR	u4smr_addr.bit.sss
#define		SCLKDIV_U4SMR	u4smr_addr.bit.sclkdiv

/*------------------------------------------------------
	UART special mode register 2
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	iicm2:1;
		UINT8	csc:1;
		UINT8	swc:1;
		UINT8	als:1;
		UINT8	stc:1;
		UINT8	swc2:1;
		UINT8	sdhi:1;
		UINT8	shtc:1;
	} bit;
	UINT8	byte;
} USMR2_TYPE;

/*------------------------------------------------------
	UART0 special mode register 2
------------------------------------------------------*/
#pragma ADDRESS		u0smr2_addr	0366H	/* UART0ꃂ[hWX^2			*/
USMR2_TYPE	u0smr2_addr;

#define		U0SMR2		u0smr2_addr.byte
#define		IICM2_U0SMR2	u0smr2_addr.bit.iicm2
#define		CSC_U0SMR2	u0smr2_addr.bit.csc
#define		SWC_U0SMR2	u0smr2_addr.bit.swc
#define		ALS_U0SMR2	u0smr2_addr.bit.als
#define		STC_U0SMR2	u0smr2_addr.bit.stc 
#define		SWC2_U0SMR2	u0smr2_addr.bit.swc2
#define		SDHI_U0SMR2	u0smr2_addr.bit.sdhi
#define		SU1HIM_U0SMR2	u0smr2_addr.bit.shtc

/*------------------------------------------------------
	UART1 special mode register 2
------------------------------------------------------*/
#pragma ADDRESS		u1smr2_addr	02e6H	/* UART1ꃂ[hWX^2			*/
USMR2_TYPE	u1smr2_addr;

#define		U1SMR2		u1smr2_addr.byte
#define		IICM2_U1SMR2	u1smr2_addr.bit.iicm2
#define		CSC_U1SMR2	u1smr2_addr.bit.csc
#define		SWC_U1SMR2	u1smr2_addr.bit.swc
#define		ALS_U1SMR2	u1smr2_addr.bit.als
#define		STC_U1SMR2	u1smr2_addr.bit.stc 
#define		SWC2_U1SMR2	u1smr2_addr.bit.swc2
#define		SDHI_U1SMR2	u1smr2_addr.bit.sdhi
#define		SU1HIM_U1SMR2	u1smr2_addr.bit.shtc

/*------------------------------------------------------
	UART2 special mode register 2
------------------------------------------------------*/
#pragma ADDRESS		u2smr2_addr	0336H	/* UART2ꃂ[hWX^2			*/
USMR2_TYPE	u2smr2_addr;

#define		U2SMR2		u2smr2_addr.byte
#define		IICM2_U2SMR2	u2smr2_addr.bit.iicm2
#define		CSC_U2SMR2	u2smr2_addr.bit.csc
#define		SWC_U2SMR2	u2smr2_addr.bit.swc
#define		ALS_U2SMR2	u2smr2_addr.bit.als
#define		STC_U2SMR2	u2smr2_addr.bit.stc 
#define		SWC2_U2SMR2	u2smr2_addr.bit.swc2
#define		SDHI_U2SMR2	u2smr2_addr.bit.sdhi
#define		SU1HIM_U2SMR2	u2smr2_addr.bit.shtc

/*------------------------------------------------------
	UART3 special mode register 2
------------------------------------------------------*/
#pragma ADDRESS		u3smr2_addr	0326H	/* UART3ꃂ[hWX^2			*/
USMR2_TYPE	u3smr2_addr;

#define		U3SMR2		u3smr2_addr.byte
#define		IICM2_U3SMR2	u3smr2_addr.bit.iicm2
#define		CSC_U3SMR2	u3smr2_addr.bit.csc
#define		SWC_U3SMR2	u3smr2_addr.bit.swc
#define		ALS_U3SMR2	u3smr2_addr.bit.als
#define		STC_U3SMR2	u3smr2_addr.bit.stc
#define		SWC2_U3SMR2	u3smr2_addr.bit.swc2
#define		SDHI_U3SMR2	u3smr2_addr.bit.sdhi
#define		SU1HIM_U3SMR2	u3smr2_addr.bit.shtc

/*------------------------------------------------------
	UART4 special mode register 2
------------------------------------------------------*/
#pragma ADDRESS		u4smr2_addr	02f6H	/* UART4ꃂ[hWX^2			*/
USMR2_TYPE	u4smr2_addr;

#define		U4SMR2		u4smr2_addr.byte
#define		IICM2_U4SMR2	u4smr2_addr.bit.iicm2
#define		CSC_U4SMR2	u4smr2_addr.bit.csc
#define		SWC_U4SMR2	u4smr2_addr.bit.swc
#define		ALS_U4SMR2	u4smr2_addr.bit.als
#define		STC_U4SMR2	u4smr2_addr.bit.stc
#define		SWC2_U4SMR2	u4smr2_addr.bit.swc2
#define		SDHI_U4SMR2	u4smr2_addr.bit.sdhi
#define		SU1HIM_U4SMR2	u4smr2_addr.bit.shtc

/*------------------------------------------------------
	UART special mode register 3
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	sse:1;
		UINT8	ckph:1;
		UINT8	dinc:1;
		UINT8	nodc:1;
		UINT8	err:1;
		UINT8	dl0:1;
		UINT8	dl1:1;
		UINT8	dl2:1;
	} bit;
	UINT8	byte;
} USMR3_TYPE;

/*------------------------------------------------------
	UART0 special mode register 3
------------------------------------------------------*/
#pragma ADDRESS		u0smr3_addr	0365H	/* UART0ꃂ[hWX^3			*/ 
USMR3_TYPE	u0smr3_addr;

#define		U0SMR3		u0smr3_addr.byte
#define		SSE_U0SMR3	u0smr3_addr.bit.sse
#define		CKPH_U0SMR3	u0smr3_addr.bit.ckph
#define		DINC_U0SMR3	u0smr3_addr.bit.dinc
#define		NODC_U0SMR3	u0smr3_addr.bit.nodc
#define		ERR_U0SMR3	u0smr3_addr.bit.err
#define		DL0_U0SMR3	u0smr3_addr.bit.dl0
#define		DL1_U0SMR3	u0smr3_addr.bit.dl1
#define		DL2_U0SMR3	u0smr3_addr.bit.dl2

/*------------------------------------------------------
	UART1 special mode register 3
------------------------------------------------------*/
#pragma ADDRESS		u1smr3_addr	02e5H	/* UART1ꃂ[hWX^3			*/ 
USMR3_TYPE	u1smr3_addr;

#define		U1SMR3		u1smr3_addr.byte
#define		SSE_U1SMR3	u1smr3_addr.bit.sse
#define		CKPH_U1SMR3	u1smr3_addr.bit.ckph
#define		DINC_U1SMR3	u1smr3_addr.bit.dinc
#define		NODC_U1SMR3	u1smr3_addr.bit.nodc
#define		ERR_U1SMR3	u1smr3_addr.bit.err
#define		DL0_U1SMR3	u1smr3_addr.bit.dl0
#define		DL1_U1SMR3	u1smr3_addr.bit.dl1
#define		DL2_U1SMR3	u1smr3_addr.bit.dl2

/*------------------------------------------------------
	UART2 special mode register 3
------------------------------------------------------*/
#pragma ADDRESS		u2smr3_addr	0335H	/* UART2ꃂ[hWX^3			*/ 
USMR3_TYPE	u2smr3_addr;

#define		U2SMR3		u2smr3_addr.byte
#define		SSE_U2SMR3	u2smr3_addr.bit.sse
#define		CKPH_U2SMR3	u2smr3_addr.bit.ckph
#define		DINC_U2SMR3	u2smr3_addr.bit.dinc
#define		NODC_U2SMR3	u2smr3_addr.bit.nodc
#define		ERR_U2SMR3	u2smr3_addr.bit.err
#define		DL0_U2SMR3	u2smr3_addr.bit.dl0
#define		DL1_U2SMR3	u2smr3_addr.bit.dl1
#define		DL2_U2SMR3	u2smr3_addr.bit.dl2

/*------------------------------------------------------
	UART3 special mode register 3
------------------------------------------------------*/
#pragma ADDRESS		u3smr3_addr	0325H	/* UART3ꃂ[hWX^3			*/ 
USMR3_TYPE	u3smr3_addr;

#define		U3SMR3		u3smr3_addr.byte
#define		SSE_U3SMR3	u3smr3_addr.bit.sse
#define		CKPH_U3SMR3	u3smr3_addr.bit.ckph
#define		DINC_U3SMR3	u3smr3_addr.bit.dinc
#define		NODC_U3SMR3	u3smr3_addr.bit.nodc
#define		ERR_U3SMR3	u3smr3_addr.bit.err
#define		DL0_U3SMR3	u3smr3_addr.bit.dl0
#define		DL1_U3SMR3	u3smr3_addr.bit.dl1
#define		DL2_U3SMR3	u3smr3_addr.bit.dl2

/*------------------------------------------------------
	UART4 special mode register 3
------------------------------------------------------*/
#pragma ADDRESS		u4smr3_addr	02f5H	/* UART4ꃂ[hWX^3			*/ 
USMR3_TYPE	u4smr3_addr;

#define		U4SMR3		u4smr3_addr.byte
#define		SSE_U4SMR3	u4smr3_addr.bit.sse
#define		CKPH_U4SMR3	u4smr3_addr.bit.ckph
#define		DINC_U4SMR3	u4smr3_addr.bit.dinc
#define		NODC_U4SMR3	u4smr3_addr.bit.nodc
#define		ERR_U4SMR3	u4smr3_addr.bit.err
#define		DL0_U4SMR3	u4smr3_addr.bit.dl0
#define		DL1_U4SMR3	u4smr3_addr.bit.dl1
#define		DL2_U4SMR3	u4smr3_addr.bit.dl2

/*------------------------------------------------------
	UART special mode register 4
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	stareq:1;
		UINT8	rstareq:1;
		UINT8	stpreq:1;
		UINT8	stspsel:1;
		UINT8	ackd:1;
		UINT8	ackc:1;
		UINT8	sclhi:1;
		UINT8	swc9:1;
	} bit;
	UINT8	byte;
} USMR4_TYPE;

/*------------------------------------------------------
	UART0 special mode register 4
------------------------------------------------------*/
#pragma ADDRESS		u0smr4_addr	0364H	/* UART0ꃂ[hWX^4			*/ 
USMR4_TYPE	u0smr4_addr;

#define		U0SMR4			u0smr4_addr.byte
#define		STAREQ_U0SMR4	u0smr4_addr.bit.stareq
#define		RSTAREQ_U0SMR4	u0smr4_addr.bit.rstareq
#define		STPREQ_U0SMR4	u0smr4_addr.bit.stpreq
#define		STSPSEL_U0SMR4	u0smr4_addr.bit.stspsel
#define		ACKD_U0SMR4		u0smr4_addr.bit.ackd
#define		ACKC_U0SMR4		u0smr4_addr.bit.ackc
#define		SCLHI_U0SMR4	u0smr4_addr.bit.sclhi
#define		SWC9_U0SMR4		u0smr4_addr.bit.swc9

/*------------------------------------------------------
	UART1 special mode register 4
------------------------------------------------------*/
#pragma ADDRESS		u1smr4_addr	02e4H	/* UART1ꃂ[hWX^4			*/ 
USMR4_TYPE	u1smr4_addr;

#define		U1SMR4			u1smr4_addr.byte
#define		STAREQ_U1SMR4	u1smr4_addr.bit.stareq
#define		RSTAREQ_U1SMR4	u1smr4_addr.bit.rstareq
#define		STPREQ_U1SMR4	u1smr4_addr.bit.stpreq
#define		STSPSEL_U1SMR4	u1smr4_addr.bit.stspsel
#define		ACKD_U1SMR4		u1smr4_addr.bit.ackd
#define		ACKC_U1SMR4		u1smr4_addr.bit.ackc
#define		SCLHI_U1SMR4	u1smr4_addr.bit.sclhi
#define		SWC9_U1SMR4		u1smr4_addr.bit.swc9

/*------------------------------------------------------
	UART2 special mode register 4
------------------------------------------------------*/
#pragma ADDRESS		u2smr4_addr	0334H	/* UART2ꃂ[hWX^4			*/ 
USMR4_TYPE	u2smr4_addr;

#define		U2SMR4			u2smr4_addr.byte
#define		STAREQ_U2SMR4	u2smr4_addr.bit.stareq
#define		RSTAREQ_U2SMR4	u2smr4_addr.bit.rstareq
#define		STPREQ_U2SMR4	u2smr4_addr.bit.stpreq
#define		STSPSEL_U2SMR4	u2smr4_addr.bit.stspsel
#define		ACKD_U2SMR4		u2smr4_addr.bit.ackd
#define		ACKC_U2SMR4		u2smr4_addr.bit.ackc
#define		SCLHI_U2SMR4	u2smr4_addr.bit.sclhi
#define		SWC9_U2SMR4		u2smr4_addr.bit.swc9

/*------------------------------------------------------
	UART3 special mode register 4
------------------------------------------------------*/
#pragma ADDRESS		u3smr4_addr	0324H	/* UART3ꃂ[hWX^4			*/ 
USMR4_TYPE	u3smr4_addr;

#define		U3SMR4			u3smr4_addr.byte
#define		STAREQ_U3SMR4	u3smr4_addr.bit.stareq
#define		RSTAREQ_U3SMR4	u3smr4_addr.bit.rstareq
#define		STPREQ_U3SMR4	u3smr4_addr.bit.stpreq
#define		STSPSEL_U3SMR4	u3smr4_addr.bit.stspsel
#define		ACKD_U3SMR4		u3smr4_addr.bit.ackd
#define		ACKC_U3SMR4		u3smr4_addr.bit.ackc
#define		SCLHI_U3SMR4	u3smr4_addr.bit.sclhi
#define		SWC9_U3SMR4		u3smr4_addr.bit.swc9

/*------------------------------------------------------
	UART4 special mode register 4
------------------------------------------------------*/
#pragma ADDRESS		u4smr4_addr	02f4H	/* UART4ꃂ[hWX^4			*/ 
USMR4_TYPE	u4smr4_addr;

#define		U4SMR4			u4smr4_addr.byte
#define		STAREQ_U4SMR4	u4smr4_addr.bit.stareq
#define		RSTAREQ_U4SMR4	u4smr4_addr.bit.rstareq
#define		STPREQ_U4SMR4	u4smr4_addr.bit.stpreq
#define		STSPSEL_U4SMR4	u4smr4_addr.bit.stspsel
#define		ACKD_U4SMR4		u4smr4_addr.bit.ackd
#define		ACKC_U4SMR4		u4smr4_addr.bit.ackc
#define		SCLHI_U4SMR4	u4smr4_addr.bit.sclhi
#define		SWC9_U4SMR4		u4smr4_addr.bit.swc9

/********************************************************/
/* A/DRo[^										*/
/********************************************************/
/*------------------------------------------------------
	A-D0 control register 0
------------------------------------------------------*/
#pragma ADDRESS		ad0con0_addr	0396H	/* A/D0䃌WX^0			*/
typedef union {
	struct{
		UINT8	ch0:1;
		UINT8	ch1:1;
		UINT8	ch2:1;
		UINT8	md0:1;
		UINT8	md1:1;
		UINT8	trg:1;
		UINT8	adst:1;
		UINT8	cks0:1;
	} bit;
	 UINT8	byte;
} AD0CON0_TYPE;
AD0CON0_TYPE	ad0con0_addr;

#define		AD0CON0			ad0con0_addr.byte
#define		CH0_AD0CON0		ad0con0_addr.bit.ch0
#define		CH1_AD0CON0		ad0con0_addr.bit.ch1
#define		CH2_AD0CON0		ad0con0_addr.bit.ch2
#define		MD0_AD0CON0		ad0con0_addr.bit.md0
#define		MD1_AD0CON0		ad0con0_addr.bit.md1
#define		TRG_AD0CON0		ad0con0_addr.bit.trg
#define		ADST_AD0CON0	ad0con0_addr.bit.adst
#define		CKS0_AD0CON0	ad0con0_addr.bit.cks0

/*------------------------------------------------------
	A-D0 control register 1
------------------------------------------------------*/
#pragma ADDRESS		ad0con1_addr	0397H	/* A/D0䃌WX^1			*/
typedef union {
	struct{
		UINT8	scan0:1;
		UINT8	scan1:1;
		UINT8	md2:1;
		UINT8	bits:1;
		UINT8	cks1:1;
		UINT8	vcut:1;
		UINT8	opa0:1;
		UINT8	opa1:1;
	} bit;
	 UINT8 byte;
} AD0CON1_TYPE;
AD0CON1_TYPE	ad0con1_addr;

#define		AD0CON1			ad0con1_addr.byte
#define		SCAN0_AD0CON1	ad0con1_addr.bit.scan0
#define		SCAN1_AD0CON1	ad0con1_addr.bit.scan1
#define		MD2_AD0CON1		ad0con1_addr.bit.md2
#define		BITS_AD0CON1	ad0con1_addr.bit.bits
#define		CKS1_AD0CON1	ad0con1_addr.bit.cks1
#define		VCUT_AD0CON1	ad0con1_addr.bit.vcut
#define		OPA0_AD0CON1	ad0con1_addr.bit.opa0
#define		OPA1_AD0CON1	ad0con1_addr.bit.opa1

/*------------------------------------------------------
	A-D0 control register 2
------------------------------------------------------*/
#pragma ADDRESS		ad0con2_addr	0394H	/* A/D0䃌WX^2			*/
typedef union {
	struct{
		UINT8	smp:1;
		UINT8	aps0:1;
		UINT8	aps1:1;
		UINT8	no_assign:2;	/*    s ޏꍇ0					*/
		UINT8	trg0:1;
		UINT8	reserved:2;		/* RW s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} AD0CON2_TYPE;
AD0CON2_TYPE	ad0con2_addr;

#define		AD0CON2			ad0con2_addr.byte
#define		SMP_AD0CON2		ad0con2_addr.bit.smp
#define		APS0_AD0CON2	ad0con2_addr.bit.aps0
#define		APS1_AD0CON2	ad0con2_addr.bit.aps1
#define		TRG0_AD0CON2	ad0con2_addr.bit.trg0

/*------------------------------------------------------
	A-D0 control register 3
------------------------------------------------------*/
#pragma ADDRESS		ad0con3_addr	0395H	/* A/D0䃌WX^3			*/
typedef union {
	struct{
		UINT8	dus:1;
		UINT8	mss:1;
		UINT8	cks2:1;
		UINT8	msf0:1;
		UINT8	msf1:1;
		UINT8	reserved:3;		/* RW s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} AD0CON3_TYPE;
AD0CON3_TYPE	ad0con3_addr;

#define		AD0CON3			ad0con3_addr.byte
#define		DUS_AD0CON3		ad0con3_addr.bit.dus
#define		MSS_AD0CON3		ad0con3_addr.bit.mss
#define		CKS2_AD0CON3	ad0con3_addr.bit.cks2
#define		MSF0_AD0CON3	ad0con3_addr.bit.msf0
#define		MSF1_AD0CON3	ad0con3_addr.bit.msf1

/*------------------------------------------------------
	A-D0 control register 4
------------------------------------------------------*/
#pragma ADDRESS		ad0con4_addr	0392H	/* A/D0䃌WX^4			*/
typedef union {
	struct{
		UINT8	reserved1:2;	/* RW s ޏꍇ0					*/
		UINT8	mps10:1;
		UINT8	mps11:1;
		UINT8	reserved2:4;	/* RW s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} AD0CON4_TYPE;
AD0CON4_TYPE	ad0con4_addr;

#define		AD0CON4			ad0con4_addr.byte
#define		MPS10_AD0CON4	ad0con4_addr.bit.mps10
#define		MPS11_AD0CON4	ad0con4_addr.bit.mps11

/*------------------------------------------------------
	A-D0 register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	b0:1;			/* RO A/Dϊʂ̃rbg0					*/
		UINT8	b1:1;			/* RO A/Dϊʂ̃rbg1					*/
		UINT8	b2:1;			/* RO A/Dϊʂ̃rbg2					*/
		UINT8	b3:1;			/* RO A/Dϊʂ̃rbg3					*/
		UINT8	b4:1;			/* RO A/Dϊʂ̃rbg4					*/
		UINT8	b5:1;			/* RO A/Dϊʂ̃rbg5					*/
		UINT8	b6:1;			/* RO A/Dϊʂ̃rbg6					*/
		UINT8	b7:1;			/* RO A/Dϊʂ̃rbg7					*/
		UINT8	b8:1;	/* RO A/Dϊʂ̃rbg8(8bit[hł͕sl)	*/
		UINT8	b9:1;	/* RO A/Dϊʂ̃rbg9(8bit[hł͕sl)	*/
		UINT8	reserved:6;		/* RO s									*/
	} bit;
	struct{
		UINT8	low;			/* RO A/Dϊʂ̉8rbg				*/
		UINT8	high;			/* RO A/Dϊʂ̏2rbgѕsl	*/
	} byte;
	UINT16	word;
} AD0_TYPE;

/*------------------------------------------------------
	A-D0 register 0
------------------------------------------------------*/
#pragma ADDRESS		ad00_addr	0380H	/* A/D0WX^0					*/
AD0_TYPE	ad00_addr;

#define		AD00	ad00_addr.word           /* A-D0 register 0 16 bit */
#define		AD00L	ad00_addr.byte.low           /* A-D0 register 0 low  8 bit */
#define		AD00H	ad00_addr.byte.high          /* A-D0 register 0 high 8 bit */

/*------------------------------------------------------
	A-D0 register 1
------------------------------------------------------*/
#pragma ADDRESS		ad01_addr	0382H	/* A/D0WX^1					*/
AD0_TYPE	ad01_addr;

#define		AD01	ad01_addr.word           /* A-D0 register 1 16 bit */
#define		AD01L	ad01_addr.byte.low           /* A-D0 register 1 low  8 bit */
#define		AD01H	ad01_addr.byte.high          /* A-D0 register 1 high 8 bit */

/*------------------------------------------------------
	A-D0 register 2
------------------------------------------------------*/
#pragma ADDRESS		ad02_addr	0384H	/* A/D0WX^2					*/
AD0_TYPE	ad02_addr;

#define		AD02	ad02_addr.word           /* A-D0 register 2 16 bit */
#define		AD02L	ad02_addr.byte.low           /* A-D0 register 2 low  8 bit */
#define		AD02H	ad02_addr.byte.high          /* A-D0 register 2 high 8 bit */

/*------------------------------------------------------
	A-D0 register 3
------------------------------------------------------*/
#pragma ADDRESS		ad03_addr	0386H	/* A/D0WX^3					*/
AD0_TYPE	ad03_addr;

#define		AD03	ad03_addr.word           /* A-D0 register 3 16 bit */
#define		AD03L	ad03_addr.byte.low           /* A-D0 register 3 low  8 bit */
#define		AD03H	ad03_addr.byte.high          /* A-D0 register 3 high 8 bit */

/*------------------------------------------------------
	A-D0 register 4
------------------------------------------------------*/
#pragma ADDRESS		ad04_addr	0388H	/* A/D0WX^4					*/
AD0_TYPE	ad04_addr;

#define		AD04	ad04_addr.word           /* A-D0 register 4 16 bit */
#define		AD04L	ad04_addr.byte.low           /* A-D0 register 4 low  8 bit */
#define		AD04H	ad04_addr.byte.high          /* A-D0 register 4 high 8 bit */

/*------------------------------------------------------
	A-D0 register 5
------------------------------------------------------*/
#pragma ADDRESS		ad05_addr	038aH	/* A/D0WX^5					*/
AD0_TYPE	ad05_addr;

#define		AD05	ad05_addr.word           /* A-D0 register 5 16 bit */
#define		AD05L	ad05_addr.byte.low           /* A-D0 register 5 low  8 bit */
#define		AD05H	ad05_addr.byte.high          /* A-D0 register 5 high 8 bit */

/*------------------------------------------------------
	A-D0 register 6
------------------------------------------------------*/
#pragma ADDRESS		ad06_addr	038cH	/* A/D0WX^6					*/
AD0_TYPE	ad06_addr;

#define		AD06	ad06_addr.word           /* A-D0 register 6 16 bit */
#define		AD06L	ad06_addr.byte.low           /* A-D0 register 6 low  8 bit */
#define		AD06H	ad06_addr.byte.high          /* A-D0 register 6 high 8 bit */

/*------------------------------------------------------
	A-D0 register 7
------------------------------------------------------*/
#pragma ADDRESS		ad07_addr	038eH	/* A/D0WX^7					*/
AD0_TYPE	ad07_addr;

#define		AD07	ad07_addr.word           /* A-D0 register 7 16 bit */
#define		AD07L	ad07_addr.byte.low           /* A-D0 register 7 low  8 bit */
#define		AD07H	ad07_addr.byte.high          /* A-D0 register 7 high 8 bit */

/********************************************************/
/* D/ARo[^										*/
/********************************************************/
/*------------------------------------------------------
	D-A control register
------------------------------------------------------*/
#pragma ADDRESS		dacon_addr	039cH	/* D/A䃌WX^					*/
typedef union {
	struct{
		UINT8	da0e:1;
		UINT8	da1e:1;
		UINT8	no_assign:6;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} DACON_TYPE;
DACON_TYPE	dacon_addr;

#define		DACON		dacon_addr.byte
#define		DA0E		dacon_addr.bit.da0e
#define		DA1E		dacon_addr.bit.da1e

/*------------------------------------------------------
	D-A register 0
------------------------------------------------------*/
#pragma ADDRESS		da0_addr	0398H	/* D/AWX^0						*/
UINT8	da0_addr;               /* D-A register 0 */

#define		DA0		da0_addr

/*------------------------------------------------------
	D-A register 1
------------------------------------------------------*/
#pragma ADDRESS		da1_addr	039aH	/* D/AWX^1						*/
UINT8	da1_addr;               /* D-A register 1 */

#define		DA1		da1_addr

/********************************************************/
/* CRCZ												*/
/********************************************************/
/*------------------------------------------------------
	CRC data register
------------------------------------------------------*/
#pragma ADDRESS		crcd_addr	037cH	/* CRCf[^WX^				*/
typedef union {
	struct{
		UINT8	b0:1;
		UINT8	b1:1;
		UINT8	b2:1;
		UINT8	b3:1;
		UINT8	b4:1;
		UINT8	b5:1;
		UINT8	b6:1;
		UINT8	b7:1;
		UINT8	b8:1;
		UINT8	b9:1;
		UINT8	b10:1;
		UINT8	b11:1;
		UINT8	b12:1;
		UINT8	b13:1;
		UINT8	b14:1;
		UINT8	b15:1;
	} bit;
	struct{
		UINT8	low;                /* low  8 bit */
		UINT8	high;               /* high 8 bit */
	} byte;
	UINT16	word;
} CRCD_TYPE;
CRCD_TYPE	crcd_addr;

#define		CRCD	crcd_addr.word          /* CRC data register 16 bit */
#define		CRCDL	crcd_addr.byte.low          /* CRC data register low  8 bit */
#define		CRCDH	crcd_addr.byte.high         /* CRC data register high 8 bit */

/*------------------------------------------------------
	CRC input register
------------------------------------------------------*/
#pragma ADDRESS		crcin_addr	037eH	/* CRCCvbgWX^			*/
typedef union {
	struct{
		UINT8	b0:1;
		UINT8	b1:1;
		UINT8	b2:1;
		UINT8	b3:1;
		UINT8	b4:1;
		UINT8	b5:1;
		UINT8	b6:1;
		UINT8	b7:1;
	} bit;
	UINT8	byte;
} CRCIN_TYPE;
CRCIN_TYPE	crcin_addr;

#define		CRCIN		crcin_addr.byte

/********************************************************/
/* X/Yϊ												*/
/********************************************************/
/*------------------------------------------------------
	X-Y control register
------------------------------------------------------*/
#pragma ADDRESS		xyc_addr	02e0H	/* X/Y䃌WX^					*/
typedef union {
	struct{
		UINT8	xyc0:1;
		UINT8	xyc1:1;
		UINT8	no_assign:6;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} XYC_TYPE;
XYC_TYPE	xyc_addr;

#define		XYC			xyc_addr.byte
#define		XYC0		xyc_addr.bit.xyc0
#define		XYC1		xyc_addr.bit.xyc1

/*------------------------------------------------------
	X register(0`15)
------------------------------------------------------*/
#pragma ADDRESS		xr_addr		02c0H	/* XWX^(0`15)					*/
UINT16	xr_addr[16];

#define		X0R		xr_addr[0]
#define		X1R		xr_addr[1]
#define		X2R		xr_addr[2]
#define		X3R		xr_addr[3]
#define		X4R		xr_addr[4]
#define		X5R		xr_addr[5]
#define		X6R		xr_addr[6]
#define		X7R		xr_addr[7]
#define		X8R		xr_addr[8]
#define		X9R		xr_addr[9]
#define		X10R	xr_addr[10]
#define		X11R	xr_addr[11]
#define		X12R	xr_addr[12]
#define		X13R	xr_addr[13]
#define		X14R	xr_addr[14]
#define		X15R	xr_addr[15]

/*------------------------------------------------------
	Y register(0`15)
------------------------------------------------------*/
#pragma ADDRESS		yr_addr		02c0H	/* YWX^(0`15)					*/
UINT16	yr_addr[16];

#define		Y0R		yr_addr[0]
#define		Y1R		yr_addr[1]
#define		Y2R		yr_addr[2]
#define		Y3R		yr_addr[3]
#define		Y4R		yr_addr[4]
#define		Y5R		yr_addr[5]
#define		Y6R		yr_addr[6]
#define		Y7R		yr_addr[7]
#define		Y8R		yr_addr[8]
#define		Y9R		yr_addr[9]
#define		Y10R	yr_addr[10]
#define		Y11R	yr_addr[11]
#define		Y12R	yr_addr[12]
#define		Y13R	yr_addr[13]
#define		Y14R	yr_addr[14]
#define		Y15R	yr_addr[15]

/********************************************************/
/* CeWFgI/O									*/
/********************************************************/
/*------------------------------------------------------
	Base timer register 1
------------------------------------------------------*/
#pragma ADDRESS		g1bt_addr	0120H	/* x[X^C}WX^1			*/
typedef union {
	struct{
		UINT8    g1bt_low;                /* Low  8 bit */
		UINT8    g1bt_high;               /* High 8 bit */
	} byte;
	UINT16  word;
} G1BT_TYPE;
G1BT_TYPE	g1bt_addr;

#define		G1BT		g1bt_addr.word      /* Group 1 base timer register	*/
#define		G1BTL		g1bt_addr.byte.g1bt_low
#define		G1BTH		g1bt_addr.byte.g1bt_high

/*------------------------------------------------------
	Base timer control register 10
------------------------------------------------------*/
#pragma ADDRESS		g1bcr0_addr	0122H	/* x[X^C}䃌WX^10		*/
typedef union {
	struct{
		UINT8	bck0:1;  
		UINT8	bck1:1;  
		UINT8	div0:1;  
		UINT8	div1:1;  
		UINT8	div2:1;  
		UINT8	div3:1;  
		UINT8  	div4:1;
		UINT8	it:1;  
	} bit;
	UINT8	byte;
} G1BCR0_TYPE;
G1BCR0_TYPE	g1bcr0_addr;

#define		G1BCR0	g1bcr0_addr.byte
#define		BCK0	g1bcr0_addr.bit.bck0
#define		BCK1	g1bcr0_addr.bit.bck1
#define		DIV0	g1bcr0_addr.bit.div0
#define		DIV1	g1bcr0_addr.bit.div1
#define		DIV2	g1bcr0_addr.bit.div2
#define		DIV3	g1bcr0_addr.bit.div3
#define		DIV4	g1bcr0_addr.bit.div4
#define		IT		g1bcr0_addr.bit.it

/*------------------------------------------------------
	Base timer control register 11
------------------------------------------------------*/
#pragma ADDRESS     g1bcr1_addr  0123H      /* x[X^C}䃌WX^11	*/
typedef union {
	struct{
		UINT8	no_assign1:1;	/*    s ޏꍇ0					*/
		UINT8	rst1:1;  
		UINT8	rst2:1;  
		UINT8	reserved:1;		/*    0Œ									*/
		UINT8	bts:1;  
		UINT8	ud0:1;  
		UINT8  	ud1:1;
		UINT8	no_assign2:1;	/*    s ޏꍇ0					*/
	} bit;
	UINT8 byte;
} G1BCR1_TYPE;
G1BCR1_TYPE	g1bcr1_addr;

#define		G1BCR1	g1bcr1_addr.byte
#define		RST1	g1bcr1_addr.bit.rst1
#define		RST2	g1bcr1_addr.bit.rst2
#define		BTS		g1bcr1_addr.bit.bts
#define		UD0		g1bcr1_addr.bit.ud0
#define		UD1		g1bcr1_addr.bit.ud1

/*------------------------------------------------------
	Time measurement control register 1
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	cts0:1;  
		UINT8	cts1:1;  
		UINT8	df0:1;  
		UINT8	df1:1;  
		UINT8	gt:1;  
		UINT8	goc:1;  
		UINT8  	gsc:1;
		UINT8	pr:1;  
	} bit;
	UINT8	byte;
} G1TMCR_TYPE;

/*------------------------------------------------------
	Time measurement control register 10
------------------------------------------------------*/
#pragma ADDRESS		g1tmcr0_addr	0118H	/* Ԍv䃌WX^10		*/
G1TMCR_TYPE		g1tmcr0_addr;

#define		G1TMCR0			g1tmcr0_addr.byte
#define		CTS0_G1TMCR0	g1tmcr0_addr.bit.cts0
#define		CTS1_G1TMCR0	g1tmcr0_addr.bit.cts1
#define		DF0_G1TMCR0		g1tmcr0_addr.bit.df0
#define		DF1_G1TMCR0		g1tmcr0_addr.bit.df1
#define		GT_G1TMCR0		g1tmcr0_addr.bit.gt
#define		GOC_G1TMCR0		g1tmcr0_addr.bit.goc
#define		GSC_G1TMCR0		g1tmcr0_addr.bit.gsc
#define		PR_G1TMCR0		g1tmcr0_addr.bit.pr
	

/*------------------------------------------------------
	Time measurement control register 11
------------------------------------------------------*/
#pragma ADDRESS		g1tmcr1_addr	0119H	/* Ԍv䃌WX^11		*/
G1TMCR_TYPE		g1tmcr1_addr;

#define		G1TMCR1	 		g1tmcr1_addr.byte
#define		CTS0_G1TMCR1	g1tmcr1_addr.bit.cts0
#define		CTS1_G1TMCR1	g1tmcr1_addr.bit.cts1
#define		DF0_G1TMCR1		g1tmcr1_addr.bit.df0
#define		DF1_G1TMCR1		g1tmcr1_addr.bit.df1
#define		GT_G1TMCR1		g1tmcr1_addr.bit.gt
#define		GOC_G1TMCR1		g1tmcr1_addr.bit.goc
#define		GSC_G1TMCR1		g1tmcr1_addr.bit.gsc
#define		PR_G1TMCR1		g1tmcr1_addr.bit.pr

/*------------------------------------------------------
	Time measurement control register 12
------------------------------------------------------*/
#pragma ADDRESS		g1tmcr2_addr	011aH	/* Ԍv䃌WX^12		*/
G1TMCR_TYPE		g1tmcr2_addr;

#define		G1TMCR2	 		g1tmcr2_addr.byte
#define		CTS0_G1TMCR2	g1tmcr2_addr.bit.cts0
#define		CTS1_G1TMCR2	g1tmcr2_addr.bit.cts1
#define		DF0_G1TMCR2		g1tmcr2_addr.bit.df0
#define		DF1_G1TMCR2		g1tmcr2_addr.bit.df1
#define		GT_G1TMCR2		g1tmcr2_addr.bit.gt
#define		GOC_G1TMCR2		g1tmcr2_addr.bit.goc
#define		GSC_G1TMCR2		g1tmcr2_addr.bit.gsc
#define		PR_G1TMCR2		g1tmcr2_addr.bit.pr

/*------------------------------------------------------
	Time measurement control register 13
------------------------------------------------------*/
#pragma ADDRESS		g1tmcr3_addr	011bH	/* Ԍv䃌WX^13		*/
G1TMCR_TYPE		g1tmcr3_addr;

#define		G1TMCR3	 		g1tmcr3_addr.byte
#define		CTS0_G1TMCR3	g1tmcr3_addr.bit.cts0
#define		CTS1_G1TMCR3	g1tmcr3_addr.bit.cts1
#define		DF0_G1TMCR3		g1tmcr3_addr.bit.df0
#define		DF1_G1TMCR3		g1tmcr3_addr.bit.df1
#define		GT_G1TMCR3		g1tmcr3_addr.bit.gt
#define		GOC_G1TMCR3		g1tmcr3_addr.bit.goc
#define		GSC_G1TMCR3		g1tmcr3_addr.bit.gsc
#define		PR_G1TMCR3		g1tmcr3_addr.bit.pr

/*------------------------------------------------------
	Time measurement control register 14
------------------------------------------------------*/
#pragma ADDRESS		g1tmcr4_addr	011cH	/* Ԍv䃌WX^14		*/
G1TMCR_TYPE		g1tmcr4_addr;

#define		G1TMCR	 		g1tmcr4_addr.byte
#define		CTS0_G1TMCR4	g1tmcr4_addr.bit.cts0
#define		CTS1_G1TMCR4	g1tmcr4_addr.bit.cts1
#define		DF0_G1TMCR4		g1tmcr4_addr.bit.df0
#define		DF1_G1TMCR4		g1tmcr4_addr.bit.df1
#define		GT_G1TMCR4		g1tmcr4_addr.bit.gt
#define		GOC_G1TMCR4		g1tmcr4_addr.bit.goc
#define		GSC_G1TMCR4		g1tmcr4_addr.bit.gsc
#define		PR_G1TMCR4		g1tmcr4_addr.bit.pr

/*------------------------------------------------------
	Time measurement control register 15
------------------------------------------------------*/
#pragma ADDRESS		g1tmcr5_addr	011dH	/* Ԍv䃌WX^15		*/
G1TMCR_TYPE		g1tmcr5_addr;

#define		G1TMCR5	 		g1tmcr5_addr.byte
#define		CTS0_G1TMCR5	g1tmcr5_addr.bit.cts0
#define		CTS1_G1TMCR5	g1tmcr5_addr.bit.cts1
#define		DF0_G1TMCR5		g1tmcr5_addr.bit.df0
#define		DF1_G1TMCR5		g1tmcr5_addr.bit.df1
#define		GT_G1TMCR5		g1tmcr5_addr.bit.gt
#define		GOC_G1TMCR5		g1tmcr5_addr.bit.goc
#define		GSC_G1TMCR5		g1tmcr5_addr.bit.gsc
#define		PR_G1TMCR5		g1tmcr5_addr.bit.pr

/*------------------------------------------------------
	Time measurement control register 16
------------------------------------------------------*/
#pragma ADDRESS		g1tmcr6_addr	011eH	/* Ԍv䃌WX^16		*/
G1TMCR_TYPE		g1tmcr6_addr;

#define		G1TMCR6	 		g1tmcr6_addr.byte
#define		CTS0_G1TMCR6	g1tmcr6_addr.bit.cts0
#define		CTS1_G1TMCR6	g1tmcr6_addr.bit.cts1
#define		DF0_G1TMCR6		g1tmcr6_addr.bit.df0
#define		DF1_G1TMCR6		g1tmcr6_addr.bit.df1
#define		GT_G1TMCR6		g1tmcr6_addr.bit.gt
#define		GOC_G1TMCR6		g1tmcr6_addr.bit.goc
#define		GSC_G1TMCR6		g1tmcr6_addr.bit.gsc
#define		PR_G1TMCR6		g1tmcr6_addr.bit.pr

/*------------------------------------------------------
	Time measurement control register 17
------------------------------------------------------*/
#pragma ADDRESS		g1tmcr7_addr	011fH	/* Ԍv䃌WX^17		*/
G1TMCR_TYPE		g1tmcr7_addr;

#define		G1TMCR7	 		g1tmcr7_addr.byte
#define		CTS0_G1TMCR7	g1tmcr7_addr.bit.cts0
#define		CTS1_G1TMCR7	g1tmcr7_addr.bit.cts1
#define		DF0_G1TMCR7		g1tmcr7_addr.bit.df0
#define		DF1_G1TMCR7		g1tmcr7_addr.bit.df1
#define		GT_G1TMCR7		g1tmcr7_addr.bit.gt
#define		GOC_G1TMCR7		g1tmcr7_addr.bit.goc
#define		GSC_G1TMCR7		g1tmcr7_addr.bit.gsc
#define		PR_G1TMCR7		g1tmcr7_addr.bit.pr

/*------------------------------------------------------
	Time measurement prescaler register 16
------------------------------------------------------*/
#pragma ADDRESS		g1tpr6_addr	0124H	/* ԌvvXP[WX^16	*/
UINT8	g1tpr6_addr;

#define		G1TPR6	g1tpr6_addr.byte

/*------------------------------------------------------
	Time measurement prescaler register 17
------------------------------------------------------*/
#pragma ADDRESS		g1tpr7_addr	0125H	/* ԌvvXP[WX^17	*/
UINT8	g1tpr7_addr;

#define		G1TPR7	g1tpr7_addr.byte

/*------------------------------------------------------
	Time measurement register 1
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	low;                /* Low  8 bit */
		UINT8	high;               /* High 8 bit */
	} byte;
	UINT16	word;
} G1TM_TYPE;

/*------------------------------------------------------
	Time measurement register 10
------------------------------------------------------*/
#pragma ADDRESS		g1tm0_addr	0100H	/* ԌvWX^10				*/
G1TM_TYPE	g1tm0_addr;

#define		G1TM0	g1tm0_addr.word      /* Group 1 time measurement register 0 */
#define		G1TM0L	g1tm0_addr.byte.low
#define		G1TM0H	g1tm0_addr.byte.high

/*------------------------------------------------------
	Time measurement register 11
------------------------------------------------------*/
#pragma ADDRESS		g1tm1_addr	0102H	/* ԌvWX^11				*/
G1TM_TYPE	g1tm1_addr;

#define		G1TM1	g1tm1_addr.word      /* Group 1 time measurement register 1 */
#define		G1TM1L	g1tm1_addr.byte.low
#define		G1TM1H	g1tm1_addr.byte.high

/*------------------------------------------------------
	Time measurement register 12
------------------------------------------------------*/
#pragma ADDRESS		g1tm2_addr	0104H	/* ԌvWX^12				*/
G1TM_TYPE	g1tm2_addr;

#define		G1TM2	g1tm2_addr.word      /* Group 1 time measurement register 2 */
#define		G1TM2L	g1tm2_addr.byte.low
#define		G1TM2H	g1tm2_addr.byte.high

/*------------------------------------------------------
	Time measurement register 13
------------------------------------------------------*/
#pragma ADDRESS		g1tm3_addr	0106H	/* ԌvWX^13				*/
G1TM_TYPE	g1tm3_addr;

#define		G1TM3	g1tm3_addr.word      /* Group 1 time measurement register 3 */
#define		G1TM3L	g1tm3_addr.byte.low
#define		G1TM3H	g1tm3_addr.byte.high

/*------------------------------------------------------
	Time measurement register 14
------------------------------------------------------*/
#pragma ADDRESS		g1tm4_addr	0108H	/* ԌvWX^14				*/
G1TM_TYPE	g1tm4_addr;

#define		G1TM4	g1tm4_addr.word      /* Group 1 time measurement register 4 */
#define		G1TM4L	g1tm4_addr.byte.low
#define		G1TM4H	g1tm4_addr.byte.high

/*------------------------------------------------------
	Time measurement register 15
------------------------------------------------------*/
#pragma ADDRESS		g1tm5_addr	010aH	/* ԌvWX^15				*/
G1TM_TYPE	g1tm5_addr;

#define		G1TM5	g1tm5_addr.word      /* Group 1 time measurement register 5 */
#define		G1TM5L	g1tm5_addr.byte.low
#define		G1TM5H	g1tm5_addr.byte.high

/*------------------------------------------------------
	Time measurement register 16
------------------------------------------------------*/
#pragma ADDRESS		g1tm6_addr	010cH	/* ԌvWX^16				*/
G1TM_TYPE	g1tm6_addr;

#define		G1TM6	g1tm6_addr.word      /* Group 1 time measurement register 6 */
#define		G1TM6L	g1tm6_addr.byte.low
#define		G1TM6H	g1tm6_addr.byte.high

/*------------------------------------------------------
	Time measurement register 17
------------------------------------------------------*/
#pragma ADDRESS		g1tm7_addr	010eH	/* ԌvWX^17				*/
G1TM_TYPE	g1tm7_addr;

#define		G1TM7	g1tm7_addr.word      /* Group 1 time measurement register 7 */
#define		G1TM7L	g1tm7_addr.byte.low
#define		G1TM7H	g1tm7_addr.byte.high

/*------------------------------------------------------
	Waveform generate control register 1
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	mod0:1;  
		UINT8	mod1:1;  
		UINT8	mod2:1;  
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	ivl:1;  
		UINT8	rld:1;  
		UINT8	btre:1;
		UINT8	inv:1;  
	} bit;
	UINT8 byte;
} G1POCR_TYPE;

/*------------------------------------------------------
	Waveform generate control register 10
------------------------------------------------------*/
#pragma ADDRESS		g1pocr0_addr	0110H	/* g`䃌WX^10		*/
G1POCR_TYPE		g1pocr0_addr;

#define		G1POCR0			g1pocr0_addr.byte
#define		MOD0_G1POCR0	g1pocr0_addr.bit.mod0
#define		MOD1_G1POCR0	g1pocr0_addr.bit.mod1
#define		MOD2_G1POCR0	g1pocr0_addr.bit.mod2
#define		IVL_G1POCR0		g1pocr0_addr.bit.ivl
#define		RLD_G1POCR0		g1pocr0_addr.bit.rld
#define		BTRE_G1POCR0	g1pocr0_addr.bit.btre
#define		INV_G1POCR0		g1pocr0_addr.bit.inv

/*------------------------------------------------------
	Waveform generate control register 11
------------------------------------------------------*/
#pragma ADDRESS		g1pocr1_addr	0111H	/* g`䃌WX^11		*/
G1POCR_TYPE		g1pocr1_addr;

#define		G1POCR1			g1pocr1_addr.byte
#define		MOD0_G1POCR1	g1pocr1_addr.bit.mod0
#define		MOD1_G1POCR1	g1pocr1_addr.bit.mod1
#define		MOD2_G1POCR1	g1pocr1_addr.bit.mod2
#define		IVL_G1POCR1		g1pocr1_addr.bit.ivl
#define		RLD_G1POCR1		g1pocr1_addr.bit.rld
#define		BTRE_G1POCR1	g1pocr1_addr.bit.btre
#define		INV_G1POCR1		g1pocr1_addr.bit.inv

/*------------------------------------------------------
	Waveform generate control register 12
------------------------------------------------------*/
#pragma ADDRESS		g1pocr2_addr	0112H	/* g`䃌WX^12		*/
G1POCR_TYPE		g1pocr2_addr;

#define		G1POCR2				g1pocr2_addr.byte
#define		MOD0_G1POCR2	g1pocr2_addr.bit.mod0
#define		MOD1_G1POCR2	g1pocr2_addr.bit.mod1
#define		MOD2_G1POCR2	g1pocr2_addr.bit.mod2
#define		IVL_G1POCR2		g1pocr2_addr.bit.ivl
#define		RLD_G1POCR2		g1pocr2_addr.bit.rld
#define		BTRE_G1POCR2	g1pocr2_addr.bit.btre
#define		INV_G1POCR2		g1pocr2_addr.bit.inv

/*------------------------------------------------------
	Waveform generate control register 13
------------------------------------------------------*/
#pragma ADDRESS		g1pocr3_addr	0113H	/* g`䃌WX^13		*/
G1POCR_TYPE		g1pocr3_addr;

#define		G1POCR3			g1pocr3_addr.byte
#define		MOD0_G1POCR3	g1pocr3_addr.bit.mod0
#define		MOD1_G1POCR3	g1pocr3_addr.bit.mod1
#define		MOD2_G1POCR3	g1pocr3_addr.bit.mod2
#define		IVL_G1POCR3		g1pocr3_addr.bit.ivl
#define		RLD_G1POCR3		g1pocr3_addr.bit.rld
#define		BTRE_G1POCR3	g1pocr3_addr.bit.btre
#define		INV_G1POCR3		g1pocr3_addr.bit.inv

/*------------------------------------------------------
	Waveform generate control register 14
------------------------------------------------------*/
#pragma ADDRESS		g1pocr4_addr	0114H	/* g`䃌WX^14		*/
G1POCR_TYPE		g1pocr4_addr;

#define		G1POCR4			g1pocr4_addr.byte
#define		MOD0_G1POCR4	g1pocr4_addr.bit.mod0
#define		MOD1_G1POCR4	g1pocr4_addr.bit.mod1
#define		MOD2_G1POCR4	g1pocr4_addr.bit.mod2
#define		IVL_G1POCR4		g1pocr4_addr.bit.ivl
#define		RLD_G1POCR4		g1pocr4_addr.bit.rld
#define		BTRE_G1POCR4	g1pocr4_addr.bit.btre
#define		INV_G1POCR4		g1pocr4_addr.bit.inv

/*------------------------------------------------------
	Waveform generate control register 15
------------------------------------------------------*/
#pragma ADDRESS		g1pocr5_addr	0115H	/* g`䃌WX^15		*/
G1POCR_TYPE		g1pocr5_addr;

#define		G1POCR5			g1pocr5_addr.byte
#define		MOD0_G1POCR5	g1pocr5_addr.bit.mod0
#define		MOD1_G1POCR5	g1pocr5_addr.bit.mod1
#define		MOD2_G1POCR5	g1pocr5_addr.bit.mod2
#define		IVL_G1POCR5		g1pocr5_addr.bit.ivl
#define		RLD_G1POCR5		g1pocr5_addr.bit.rld
#define		BTRE_G1POCR5	g1pocr5_addr.bit.btre
#define		INV_G1POCR5		g1pocr5_addr.bit.inv

/*------------------------------------------------------
	Waveform generate control register 16
------------------------------------------------------*/
#pragma ADDRESS		g1pocr6_addr	0116H	/* g`䃌WX^16		*/
G1POCR_TYPE		g1pocr6_addr;

#define		G1POCR6			g1pocr6_addr.byte
#define		MOD0_G1POCR6	g1pocr6_addr.bit.mod0
#define		MOD1_G1POCR6	g1pocr6_addr.bit.mod1
#define		MOD2_G1POCR6	g1pocr6_addr.bit.mod2
#define		IVL_G1POCR6		g1pocr6_addr.bit.ivl
#define		RLD_G1POCR6		g1pocr6_addr.bit.rld
#define		BTRE_G1POCR6	g1pocr6_addr.bit.btre
#define		INV_G1POCR6		g1pocr6_addr.bit.inv

/*------------------------------------------------------
	Waveform generate control register 17
------------------------------------------------------*/
#pragma ADDRESS		g1pocr7_addr	0117H	/* g`䃌WX^17		*/
G1POCR_TYPE		g1pocr7_addr;

#define		G1POCR7			g1pocr7_addr.byte
#define		MOD0_G1POCR7	g1pocr7_addr.bit.mod0
#define		MOD1_G1POCR7	g1pocr7_addr.bit.mod1
#define		MOD2_G1POCR7	g1pocr7_addr.bit.mod2
#define		IVL_G1POCR7		g1pocr7_addr.bit.ivl
#define		RLD_G1POCR7		g1pocr7_addr.bit.rld
#define		BTRE_G1POCR7	g1pocr7_addr.bit.btre
#define		INV_G1POCR7		g1pocr7_addr.bit.inv

/*------------------------------------------------------
	Waveform generate register 1
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	low;                /* Low  8 bit */
		UINT8	high;               /* High 8 bit */
	} byte;
	UINT16  word;
} G1PO_TYPE;

/*------------------------------------------------------
	Waveform generate register 10
------------------------------------------------------*/
#pragma ADDRESS		g1po0_addr	0100H	/* g`WX^10				*/
G1PO_TYPE	g1po0_addr;

#define		G1PO0	g1po0_addr.word      /* Group 1 waveform generate register 0 */
#define		G1PO0L	g1po0_addr.byte.low
#define		G1PO0H	g1po0_addr.byte.high

/*------------------------------------------------------
	Waveform generate register 11
------------------------------------------------------*/
#pragma ADDRESS		g1po1_addr	0102H	/* g`WX^11				*/
G1PO_TYPE	g1po1_addr;

#define		G1PO1	g1po1_addr.word      /* Group 1 waveform generate register 1 */
#define		G1PO1L	g1po1_addr.byte.low
#define		G1PO1H	g1po1_addr.byte.high

/*------------------------------------------------------
	Waveform generate register 12
------------------------------------------------------*/
#pragma ADDRESS		g1po2_addr	0104H	/* g`WX^12				*/
G1PO_TYPE	g1po2_addr;

#define		G1PO2	g1po2_addr.word      /* Group 1 waveform generate register 2 */
#define		G1PO2L	g1po2_addr.byte.low
#define		G1PO2H	g1po2_addr.byte.high

/*------------------------------------------------------
	Waveform generate register 13
------------------------------------------------------*/
#pragma ADDRESS		g1po3_addr	0106H	/* g`WX^13				*/
G1PO_TYPE	g1po3_addr;

#define		G1PO3	g1po3_addr.word      /* Group 1 waveform generate register 3 */
#define		G1PO3L	g1po3_addr.byte.low
#define		G1PO3H	g1po3_addr.byte.high

/*------------------------------------------------------
	Waveform generate register 14
------------------------------------------------------*/
#pragma ADDRESS		g1po4_addr	0108H	/* g`WX^14				*/
G1PO_TYPE	g1po4_addr;

#define		G1PO4	g1po4_addr.word      /* Group 1 waveform generate register 4 */
#define		G1PO4L	g1po4_addr.byte.low
#define		G1PO4H	g1po4_addr.byte.high

/*------------------------------------------------------
	Waveform generate register 15
------------------------------------------------------*/
#pragma ADDRESS		g1po5_addr	010aH	/* g`WX^15				*/
G1PO_TYPE	g1po5_addr;

#define		G1PO5	g1po5_addr.word      /* Group 1 waveform generate register 5 */
#define		G1PO5L	g1po5_addr.byte.low
#define		G1PO5H	g1po5_addr.byte.high

/*------------------------------------------------------
	Waveform generate register 16
------------------------------------------------------*/
#pragma ADDRESS		g1po6_addr	010cH	/* g`WX^16				*/
G1PO_TYPE	g1po6_addr;

#define		G1PO6	g1po6_addr.word      /* Group 1 waveform generate register 6 */
#define		G1PO6L	g1po6_addr.byte.low
#define		G1PO6H	g1po6_addr.byte.high

/*------------------------------------------------------
	Waveform generate register 17
------------------------------------------------------*/
#pragma ADDRESS		g1po7_addr	010eH	/* g`WX^17				*/
G1PO_TYPE	g1po7_addr;

#define		G1PO7	g1po7_addr.word      /* Group 1 waveform generate register 7 */
#define		G1PO7L	g1po7_addr.byte.low
#define		G1PO7H	g1po7_addr.byte.high

/*------------------------------------------------------
	Function select register 1
------------------------------------------------------*/
#pragma ADDRESS		g1fs_addr	0127H	/* @\IWX^1				*/
typedef union {
	struct{
		UINT8	fsc0:1;
		UINT8	fsc1:1;
		UINT8	fsc2:1;
		UINT8	fsc3:1;
		UINT8	fsc4:1;
		UINT8	fsc5:1;
		UINT8	fsc6:1;
		UINT8	fsc7:1;
	} bit;
	UINT8	byte;
} G1FS_TYPE;
G1FS_TYPE	g1fs_addr;

#define		G1FS	g1fs_addr.byte
#define		FSC0	g1fs_addr.bit.fsc0
#define		FSC1	g1fs_addr.bit.fsc1
#define		FSC2	g1fs_addr.bit.fsc2
#define		FSC3	g1fs_addr.bit.fsc3
#define		FSC4	g1fs_addr.bit.fsc4
#define		FSC5	g1fs_addr.bit.fsc5
#define		FSC6	g1fs_addr.bit.fsc6
#define		FSC7	g1fs_addr.bit.fsc7

/*------------------------------------------------------
	Function enable register 1
------------------------------------------------------*/
#pragma ADDRESS		g1fe_addr	0126H	/* @\WX^1				*/
typedef union {
	struct{
		UINT8	ife0:1;
		UINT8	ife1:1;
		UINT8	ife2:1;
		UINT8	ife3:1;
		UINT8	ife4:1;
		UINT8	ife5:1;
		UINT8	ife6:1;
		UINT8	ife7:1;
	} bit;
	UINT8	byte;
} G1FE_TYPE;
G1FE_TYPE	g1fe_addr;

#define		G1FE	g1fe_addr.byte
#define		IFE0	g1fe_addr.bit.ife0
#define		IFE1	g1fe_addr.bit.ife1
#define		IFE2	g1fe_addr.bit.ife2
#define		IFE3	g1fe_addr.bit.ife3
#define		IFE4	g1fe_addr.bit.ife4
#define		IFE5	g1fe_addr.bit.ife5
#define		IFE6	g1fe_addr.bit.ife6
#define		IFE7	g1fe_addr.bit.ife7

/*------------------------------------------------------
	Receive input register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	b0:1;
		UINT8	b1:1;
		UINT8	b2:1;
		UINT8	b3:1;
		UINT8	b4:1;
		UINT8	b5:1;
		UINT8	b6:1;
		UINT8	b7:1;
	} bit;
	UINT8	byte;
} GRI_TYPE;

/*------------------------------------------------------
	Receive input register 0
------------------------------------------------------*/
#pragma ADDRESS		g0ri_addr	00ecH	/* M̓WX^0				*/
GRI_TYPE	g0ri_addr;

#define		G0RI		g0ri_addr.byte

/*------------------------------------------------------
	Receive input register 1
------------------------------------------------------*/
#pragma ADDRESS		g1ri_addr	012cH	/* M̓WX^1				*/
GRI_TYPE	g1ri_addr;

#define		G1RI		g1ri_addr.byte

/*------------------------------------------------------
	Transmit output register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	b0:1;
		UINT8	b1:1;
		UINT8	b2:1;
		UINT8	b3:1;
		UINT8	b4:1;
		UINT8	b5:1;
		UINT8	b6:1;
		UINT8	b7:1;
	} bit;
	UINT8	byte;
} GTO_TYPE;

/*------------------------------------------------------
	Transmit output register 0
------------------------------------------------------*/
#pragma ADDRESS		g0to_addr	00eeH	/* Mo̓WX^0				*/
GTO_TYPE	g0to_addr;

#define		G0TO		g0to_addr.byte

/*------------------------------------------------------
	Transmit output register 1
------------------------------------------------------*/
#pragma ADDRESS		g1to_addr	012eH	/* Mo̓WX^1				*/
GTO_TYPE	g1to_addr;

#define		G1TO		g1to_addr.byte

/*------------------------------------------------------
	SI/O communication control register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	ti:1;
		UINT8	txept:1;
		UINT8	ri:1;
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	te:1;
		UINT8	re:1;
		UINT8	ipol:1;
		UINT8	opol:1;
	} bit;
	 UINT8 byte;
} GCR_TYPE;

/*------------------------------------------------------
	SI/O communication control register 0
------------------------------------------------------*/
#pragma ADDRESS		g0cr_addr	00efH	/* SI/OʐM䃌WX^0			*/
GCR_TYPE	g0cr_addr;

#define		G0CR			g0cr_addr.byte
#define		TI_G0CR			g0cr_addr.bit.ti
#define		TXEPT_G0CR		g0cr_addr.bit.txept
#define		RI_G0CR			g0cr_addr.bit.ri
#define		TE_G0CR			g0cr_addr.bit.te
#define		RE_G0CR			g0cr_addr.bit.re
#define		IPOL_G0CR		g0cr_addr.bit.ipol
#define		OPOL_G0CR		g0cr_addr.bit.opol

/*------------------------------------------------------
	SI/O communication control register 1
------------------------------------------------------*/
#pragma ADDRESS		g1cr_addr	012fH	/* SI/OʐM䃌WX^1			*/
GCR_TYPE	g1cr_addr;

#define		G1CR			g1cr_addr.byte
#define		TI_G1CR			g1cr_addr.bit.ti
#define		TXEPT_G1CR		g1cr_addr.bit.txept
#define		RI_G1CR			g1cr_addr.bit.ri
#define		TE_G1CR			g1cr_addr.bit.te
#define		RE_G1CR			g1cr_addr.bit.re
#define		IPOL_G1CR		g1cr_addr.bit.ipol
#define		OPOL_G1CR		g1cr_addr.bit.opol

/*------------------------------------------------------
	SI/O receive buffer register 0
------------------------------------------------------*/
#pragma ADDRESS		g0rb_addr	00e8H	/* SI/OMobt@WX^0		*/
typedef union {
	struct{
		UINT8	b0:1;
		UINT8	b1:1;
		UINT8	b2:1;
		UINT8	b3:1;
		UINT8	b4:1;
		UINT8	b5:1;
		UINT8	b6:1;
		UINT8	b7:1;
		UINT8	no_assign1:4;	/*    s									*/
		UINT8	oer:1;              /* Overrun error flag */
		UINT8	no_assign2:3;	/*    s									*/
	} bit;
	struct{
		UINT8	low;                /* Low  8 bit */
		UINT8	high;               /* High 8 bit */
	} byte;
	UINT16	word;
} G0RB_TYPE;
G0RB_TYPE	g0rb_addr;

#define		G0RB		g0rb_addr.word
#define		G0RBL		g0rb_addr.byte.low
#define		G0RBH		g0rb_addr.byte.high
#define		OER_G0RB   	g0rb_addr.bit.oer   /* Overrun error flag */

/*------------------------------------------------------
	SI/O receive buffer register 1
------------------------------------------------------*/
#pragma ADDRESS		g1rb_addr	0128H	/* SI/OMobt@WX^1		*/
typedef union {
	struct{
		UINT8	b0:1;
		UINT8	b1:1;
		UINT8	b2:1;
		UINT8	b3:1;
		UINT8	b4:1;
		UINT8	b5:1;
		UINT8	b6:1;
		UINT8	b7:1;
		UINT8	no_assign1:4;	/*    s									*/
		UINT8	oer:1;              /* Overrun error flag */
		UINT8	fer:1;              /* Framing error flag */
		UINT8	per:1;              /* Parity error flag */
		UINT8	no_assign2:1;	/*    s									*/
	} bit;
	struct{
		UINT8	low;                /* Low  8 bit */
		UINT8	high;               /* High 8 bit */
	} byte;
	UINT16	word;
} G1RB_TYPE;
G1RB_TYPE	g1rb_addr;

#define		G1RB		g1rb_addr.word
#define		G1RBL		g1rb_addr.byte.low
#define		G1RBH		g1rb_addr.byte.high
#define		OER_G1RB	g1rb_addr.bit.oer   /* Overrun error flag */
#define		FER_G1RB	g1rb_addr.bit.fer   /* Framing error flag */
#define		PER_G1RB	g1rb_addr.bit.per   /* Parity error flag */

/*------------------------------------------------------
	SI/O communication control register 0
------------------------------------------------------*/
#pragma ADDRESS		g0mr_addr	00edH	/* SI/OʐM[hWX^0			*/
typedef union {
	struct{
		UINT8	gmd0:1;  
		UINT8	gmd1:1;  
		UINT8	ckdir:1;  
		UINT8	reserved:3;		/* RW 0Œ									*/
		UINT8	uform:1;
		UINT8	irs:1;  
	} bit;
	UINT8	byte;
} G0MR_TYPE;
G0MR_TYPE	g0mr_addr;

#define		G0MR		g0mr_addr.byte
#define		GMD0_G0MR	g0mr_addr.bit.gmd0
#define		GMD1_G0MR	g0mr_addr.bit.gmd1
#define		CKDIR_G0MR	g0mr_addr.bit.ckdir
#define		UFORM_G0MR	g0mr_addr.bit.uform
#define		IRS_G0MR	g0mr_addr.bit.irs

/*------------------------------------------------------
	SI/O communication control register 1
------------------------------------------------------*/
#pragma ADDRESS		g1mr_addr	012dH	/* SI/OʐM[hWX^1			*/
typedef union {
	struct{
		UINT8	gmd0:1;
		UINT8	gmd1:1;
		UINT8	ckdir:1;
		UINT8	stps:1;
		UINT8	pry:1;
		UINT8	prye:1;
		UINT8	uform:1;
		UINT8	irs:1;
	} bit;
	UINT8	byte;
} G1MR_TYPE;
G1MR_TYPE	g1mr_addr;

#define		G1MR		g1mr_addr.byte
#define		GMD0_G1MR	g1mr_addr.bit.gmd0
#define		GMD1_G1MR	g1mr_addr.bit.gmd1
#define		CKDIR_G1MR	g1mr_addr.bit.ckdir
#define		STPS_G1MR	g1mr_addr.bit.stps
#define		PRY_G1MR	g1mr_addr.bit.pry
#define		PRYE_G1MR	g1mr_addr.bit.prye
#define		UFORM_G1MR	g1mr_addr.bit.uform
#define		IRS_G1MR	g1mr_addr.bit.irs

/*------------------------------------------------------
	SI/O expansion mode register 0
------------------------------------------------------*/
#pragma ADDRESS		g0emr_addr	00fcH	/* SI/Og[hWX^0			*/
typedef union {
	struct{
		UINT8	reserved:1;		/* RW 0Œ									*/
		UINT8	crcv:1;  
		UINT8	acrc:1;  
		UINT8	bsint:1;  
		UINT8	rxsl:1;  
		UINT8	txsl:1;  
		UINT8	crc0:1;
		UINT8	crc1:1;  
	} bit;
	UINT8	byte;
} G0EMR_TYPE;
G0EMR_TYPE	g0emr_addr;

#define		G0EMR			g0emr_addr.byte
#define		CRCV_G0EMR		g0emr_addr.bit.crcv
#define		ACRC_G0EMR		g0emr_addr.bit.acrc
#define		BSINT_G0EMR		g0emr_addr.bit.bsint
#define		RXSL_G0EMR		g0emr_addr.bit.rxsl
#define		TXSL_G0EMR		g0emr_addr.bit.txsl
#define		CRC0_G0EMR		g0emr_addr.bit.crc0
#define		CRC1_G0EMR		g0emr_addr.bit.crc1

/*------------------------------------------------------
	SI/O expansion mode register 1
------------------------------------------------------*/
#pragma ADDRESS		g1emr_addr	013cH	/* SI/Og[hWX^1			*/
typedef union {
	struct{
		UINT8	smode:1;
		UINT8	crcv:1;
		UINT8	acrc:1;
		UINT8	bsint:1;
		UINT8	rxsl:1;
		UINT8	txsl:1;
		UINT8	crc0:1;
		UINT8	crc1:1;
	} bit;
	UINT8	byte;
} G1EMR_TYPE;
G1EMR_TYPE	g1emr_addr;

#define		G1EMR			g1emr_addr.byte
#define		SMODE_G1EMR		g1emr_addr.bit.smode
#define		CRCV_G1EMR		g1emr_addr.bit.crcv
#define		ACRC_G1EMR		g1emr_addr.bit.acrc
#define		BSINT_G1EMR		g1emr_addr.bit.bsint
#define		RXSL_G1EMR		g1emr_addr.bit.rxsl
#define		TXSL_G1EMR		g1emr_addr.bit.txsl
#define		CRC0_G1EMR		g1emr_addr.bit.crc0
#define		CRC1_G1EMR		g1emr_addr.bit.crc1

/*------------------------------------------------------
	SI/O expansion transmit control register 0
------------------------------------------------------*/
#pragma ADDRESS		g0etc_addr	00ffH	/* SI/OgM䃌WX^0		*/
typedef union {
	struct{
		UINT8	reserved1:4;	/*    0Œ									*/
		UINT8	tcrce:1;  
		UINT8	reserved2:1;	/* RW 0Œ									*/
		UINT8	tbsf0:1;
		UINT8	tbsf1:1;  
	} bit;
	UINT8	byte;
} G0ETC_TYPE;
G0ETC_TYPE	g0etc_addr;

#define		G0ETC			g0etc_addr.byte
#define		TCRCE_G0ETC		g0etc_addr.bit.tcrce
#define		TBSF0_G0ETC		g0etc_addr.bit.tbsf0
#define		TBSF1_G0ETC		g0etc_addr.bit.tbsf1

/*------------------------------------------------------
	SI/O expansion transmit control register 1
------------------------------------------------------*/
#pragma ADDRESS		g1etc_addr	013fH	/* SI/OgM䃌WX^1		*/
typedef union {
	struct{
		UINT8	reserved:3;		/* RO s									*/
		UINT8	sof:1;
		UINT8	tcrce:1;
		UINT8	abte:1;
		UINT8	tbsf0:1;
		UINT8	tbsf1:1;
	} bit;
	UINT8	byte;
} G1ETC_TYPE;
G1ETC_TYPE	g1etc_addr;

#define		G1ETC			g1etc_addr.byte
#define		SOF_G1ETC		g1etc_addr.bit.sof
#define		TCRCE_G1ETC		g1etc_addr.bit.tcrce
#define		ABTE_G1ETC		g1etc_addr.bit.abte
#define		TBSF0_G1ETC		g1etc_addr.bit.tbsf0
#define		TBSF1_G1ETC		g1etc_addr.bit.tbsf1

/*------------------------------------------------------
	SI/O expansion receive control register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	cmp0e:1;  
		UINT8	cmp1e:1;  
		UINT8	cmp2e:1;  
		UINT8	cmp3e:1;  
		UINT8	rcrce:1;  
		UINT8	rshte:1;  
		UINT8	rbsf0:1;
		UINT8	rbsf1:1;  
	} bit;
	UINT8	byte;
} GERC_TYPE;

/*------------------------------------------------------
	SI/O expansion receive control register 0
------------------------------------------------------*/
#pragma ADDRESS		g0erc_addr	00fdH	/* SI/OgM䃌WX^0		*/
GERC_TYPE	g0erc_addr;

#define		G0ERC			g0erc_addr.byte
#define		CMP0E_G0ERC		g0erc_addr.bit.cmp0e
#define		CMP1E_G0ERC		g0erc_addr.bit.cmp1e
#define		CMP2E_G0ERC		g0erc_addr.bit.cmp2e
#define		CMP3E_G0ERC		g0erc_addr.bit.cmp3e
#define		RCRCE_G0ERC		g0erc_addr.bit.rcrce
#define		RSHTE_G0ERC		g0erc_addr.bit.rshte
#define		RBSF0_G0ERC		g0erc_addr.bit.rbsf0
#define		RBSF1_G0ERC		g0erc_addr.bit.rbsf1

/*------------------------------------------------------
	SI/O expansion receive control register 1
------------------------------------------------------*/
#pragma ADDRESS		g1erc_addr	013dH	/* SI/OgM䃌WX^1		*/
GERC_TYPE	g1erc_addr;

#define		G1ERC			g1erc_addr.byte
#define		CMP0E_G1ERC		g1erc_addr.bit.cmp0e
#define		CMP1E_G1ERC		g1erc_addr.bit.cmp1e
#define		CMP2E_G1ERC		g1erc_addr.bit.cmp2e
#define		CMP3E_G1ERC		g1erc_addr.bit.cmp3e
#define		RCRCE_G1ERC		g1erc_addr.bit.rcrce
#define		RSHTE_G1ERC		g1erc_addr.bit.rshte
#define		RBSF0_G1ERC		g1erc_addr.bit.rbsf0
#define		RBSF1_G1ERC		g1erc_addr.bit.rbsf1

/*------------------------------------------------------
	SI/O special communication interrupt detect register 0
------------------------------------------------------*/
#pragma ADDRESS		g0irf_addr	00feH	/* SI/OʐM荞ݔʃWX^0	*/
typedef union {
	struct{
		UINT8	reserved1:2;	/* RW 0Œ									*/
		UINT8	bserr:1;  
		UINT8	reserved2:1;	/* RW 0Œ									*/
		UINT8	irf0:1;  
		UINT8	irf1:1;  
		UINT8  	irf2:1;
		UINT8	irf3:1;  
	} bit;
	UINT8	byte;
} G0IRF_TYPE;
G0IRF_TYPE	g0irf_addr;

#define		G0IRF			g0irf_addr.byte
#define		BSERR_G0IRF		g0irf_addr.bit.bserr
#define		IRF0_G0IRF		g0irf_addr.bit.irf0
#define		IRF1_G0IRF		g0irf_addr.bit.irf1
#define		IRF2_G0IRF		g0irf_addr.bit.irf2
#define		IRF3_G0IRF		g0irf_addr.bit.irf3

/*------------------------------------------------------
	SI/O special communication interrupt detect register 1
------------------------------------------------------*/
#pragma ADDRESS		g1irf_addr	013eH	/* SI/OʐM荞ݔʃWX^1	*/
typedef union {
	struct{
		UINT8	reserved:2;		/* RW 0Œ									*/
		UINT8	bserr:1;
		UINT8	abt:1;
		UINT8	irf0:1;
		UINT8	irf1:1;
		UINT8	irf2:1;
		UINT8	irf3:1;
	} bit;
	UINT8	byte;
} G1IRF_TYPE;
G1IRF_TYPE	g1irf_addr;

#define		G1IRF			g1irf_addr.byte
#define		BSERR_G1IRF		g1irf_addr.bit.bserr
#define		ABT_G1IRF		g1irf_addr.bit.abt
#define		IRF0_G1IRF		g1irf_addr.bit.irf0
#define		IRF1_G1IRF		g1irf_addr.bit.irf1
#define		IRF2_G1IRF		g1irf_addr.bit.irf2
#define		IRF3_G1IRF		g1irf_addr.bit.irf3

/*------------------------------------------------------
	Transmit buffer register 0
------------------------------------------------------*/
#pragma ADDRESS		g0tb_addr	00eaH	/* Mobt@WX^0			*/
UINT8	g0tb_addr;

#define		G0TB		 g0tb_addr

/*------------------------------------------------------
	Receive data register 0
------------------------------------------------------*/
#pragma ADDRESS		g0dr_addr	00eaH	/* Mf[^WX^0				*/
UINT8	g0dr_addr;

#define		G0DR		g0dr_addr

/*------------------------------------------------------
	Transmit buffer register 1
------------------------------------------------------*/
#pragma ADDRESS		g1tb_addr	012aH	/* Mobt@WX^1			*/
UINT8	g1tb_addr;

#define		G1TB		g1tb_addr

/*------------------------------------------------------
	Receive data register 1
------------------------------------------------------*/
#pragma ADDRESS		g1dr_addr	012aH	/* Mf[^WX^1				*/
UINT8	g1dr_addr;

#define		G1DR		g1dr_addr

/*------------------------------------------------------
	Data compare register 00
------------------------------------------------------*/
#pragma ADDRESS		g0cmp0_addr	00f0H	/* f[^rWX^00				*/
UINT8	g0cmp0_addr;

#define		G0CMP0		g0cmp0_addr

/*------------------------------------------------------
	Data compare register 01
------------------------------------------------------*/
#pragma ADDRESS		g0cmp1_addr	00f1H	/* f[^rWX^01				*/
UINT8	g0cmp1_addr;

#define		G0CMP1		g0cmp1_addr

/*------------------------------------------------------
	Data compare register 02
------------------------------------------------------*/
#pragma ADDRESS		g0cmp2_addr	00f2H	/* f[^rWX^02				*/
UINT8	g0cmp2_addr;

#define		G0CMP2		g0cmp2_addr

/*------------------------------------------------------
	Data compare register 03
------------------------------------------------------*/
#pragma ADDRESS		g0cmp3_addr	00f3H	/* f[^rWX^03				*/
UINT8	g0cmp3_addr;

#define		G0CMP3		g0cmp3_addr

/*------------------------------------------------------
	Data compare register 10
------------------------------------------------------*/
#pragma ADDRESS		g1cmp0_addr	0130H	/* f[^rWX^10				*/
UINT8	g1cmp0_addr;

#define		G1CMP0		g1cmp0_addr

/*------------------------------------------------------
	Data compare register 11
------------------------------------------------------*/
#pragma ADDRESS		g1cmp1_addr	0131H	/* f[^rWX^11				*/
UINT8	g1cmp1_addr;

#define		G1CMP1		g1cmp1_addr

/*------------------------------------------------------
	Data compare register 12
------------------------------------------------------*/
#pragma ADDRESS		g1cmp2_addr	0132H	/* f[^rWX^12				*/
UINT8	g1cmp2_addr;

#define		G1CMP2		g1cmp2_addr

/*------------------------------------------------------
	Data compare register 13
------------------------------------------------------*/
#pragma ADDRESS		g1cmp3_addr	0133H	/* f[^rWX^13				*/
UINT8	g1cmp3_addr;

#define		G1CMP3		g1cmp3_addr

/*------------------------------------------------------
	Data mask register 00
------------------------------------------------------*/
#pragma ADDRESS		g0msk0_addr	00f4H	/* f[^}XNWX^00			*/
UINT8	g0msk0_addr;

#define		G0MSK0		g0msk0_addr

/*------------------------------------------------------
	Data mask register 01
------------------------------------------------------*/
#pragma ADDRESS		g0msk1_addr	00f5H	/* f[^}XNWX^01			*/
UINT8	g0msk1_addr;

#define		G0MSK1		g0msk1_addr

/*------------------------------------------------------
	Data mask register 10
------------------------------------------------------*/
#pragma ADDRESS		g1msk0_addr	0134H	/* f[^}XNWX^10			*/
UINT8	g1msk0_addr;

#define		G1MSK0		g1msk0_addr

/*------------------------------------------------------
	Data mask register 11
------------------------------------------------------*/
#pragma ADDRESS		g1msk1_addr	0135H	/* f[^}XNWX^11			*/
UINT8	g1msk1_addr;

#define		G1MSK1		g1msk1_addr

/*------------------------------------------------------
	Transmit CRC code register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	low;                /* Low  8 bit */
		UINT8	high;               /* High 8 bit */
	} byte;
	UINT16	word;
} GTCRC_TYPE;

/*------------------------------------------------------
	Transmit CRC code register 0
------------------------------------------------------*/
#pragma ADDRESS		g0tcrc_addr	00faH	/* MCRCR[hWX^0			*/
GTCRC_TYPE	g0tcrc_addr;

#define		G0TCRC		g0tcrc_addr.word      /* Group 0 transmit CRC code register */
#define		G0TCRCL		g0tcrc_addr.byte.low
#define		G0TCRCH		g0tcrc_addr.byte.high

/*------------------------------------------------------
	Transmit CRC code register 1
------------------------------------------------------*/
#pragma ADDRESS		g1tcrc_addr	013aH	/* MCRCR[hWX^1			*/
GTCRC_TYPE	g1tcrc_addr;

#define		G1TCRC		g1tcrc_addr.word      /* Group 1 transmit CRC code register */
#define		G1TCRCL		g1tcrc_addr.byte.low
#define		G1TCRCH		g1tcrc_addr.byte.high

/*------------------------------------------------------
	Receive CRC code register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	low;                /* Low  8 bit */
		UINT8	high;               /* High 8 bit */
	} byte;
	UINT16	word;
} GRCRC_TYPE;

/*------------------------------------------------------
	Receive CRC code register 0
------------------------------------------------------*/
#pragma ADDRESS		g0rcrc_addr	00f8H	/* MCRCR[hWX^0			*/
GRCRC_TYPE	g0rcrc_addr;

#define		G0RCRC		g0rcrc_addr.word      /* Group 0 receive CRC code register */
#define		G0RCRCL		g0rcrc_addr.byte.low
#define		G0RCRCH		g0rcrc_addr.byte.high

/*------------------------------------------------------
	Receive CRC code register 1
------------------------------------------------------*/
#pragma ADDRESS		g1rcrc_addr	0138H	/* MCRCR[hWX^1			*/
GRCRC_TYPE	g1rcrc_addr;

#define		G1RCRC		g1rcrc_addr.word       /* Group 1 receive CRC code register */
#define		G1RCRCL		g1rcrc_addr.byte.low
#define		G1RCRCH		g1rcrc_addr.byte.high

/*------------------------------------------------------
	Communication clock select register
------------------------------------------------------*/
#pragma ADDRESS		ccs_addr	00f6H	/* ʐMNbNIWX^			*/
typedef union {
	struct{
		UINT8	ccs0:1;			/* RW ʐM0NbNI(ccs0,ccs1Ŏw)	*/
		UINT8	ccs1:1;			/* 00b:ݒs,01b:f1,10b:f2n,11b:f8		*/
		UINT8	ccs2:1;			/* RW ʐM1NbNI(ccs2,ccs3Ŏw)	*/
		UINT8	ccs3:1;			/* 00b:`li,01b:f1,10b:f2n,11b:f8	*/
		UINT8	no_assign:4;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} CCS_TYPE;
CCS_TYPE	ccs_addr;

#define		CCS			ccs_addr.byte
#define		CCS0		ccs_addr.bit.ccs0
#define		CCS1		ccs_addr.bit.ccs1
#define		CCS2		ccs_addr.bit.ccs2
#define		CCS3		ccs_addr.bit.ccs3

/********************************************************/
/* CANW[										*/
/********************************************************/
/*------------------------------------------------------
	CAN Control Register 0
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	reset0:1;
		UINT8	loopback:1;
		UINT8	no_assign1:1;	/*    s ޏꍇ0					*/
		UINT8	basiccan:1;
		UINT8	reset1:1;
		UINT8	reserved:1;		/* RW 0Œ									*/
		UINT8	no_assign2:2;	/*    s ޏꍇ0					*/
		UINT8	tspre0:1;
		UINT8	tspre1:1;
		UINT8	tsreset:1;
		UINT8	ecreset:1;
		UINT8	no_assign3:4;	/*    s ޏꍇ0					*/
	} bit;
	struct{
		UINT8	low;                /* low  8 bit */
		UINT8	high;               /* high 8 bit */
	} byte;
	UINT16	word;
} CCTLR0_TYPE;

/*------------------------------------------------------
	CAN0 Control Register 0
------------------------------------------------------*/
#pragma ADDRESS		c0ctlr0_addr	0200H	/* CAN0䃌WX^0			*/
CCTLR0_TYPE		c0ctlr0_addr;

#define		C0CTLR0				c0ctlr0_addr.word
#define		C0CTLR0L			c0ctlr0_addr.byte.low
#define		C0CTLR0H			c0ctlr0_addr.byte.high
#define		RESET0_C0CTLR0		c0ctlr0_addr.bit.reset0
#define		LOOPBACK_C0CTLR0	c0ctlr0_addr.bit.loopback
#define		BASICCAN_C0CTLR0	c0ctlr0_addr.bit.basiccan
#define		RESET1_C0CTLR0		c0ctlr0_addr.bit.reset1
#define		TSPRE0_C0CTLR0		c0ctlr0_addr.bit.tspre0
#define		TSPRE1_C0CTLR0		c0ctlr0_addr.bit.tspre1
#define		TSRESET_C0CTLR0		c0ctlr0_addr.bit.tsreset
#define		ECRESET_C0CTLR0		c0ctlr0_addr.bit.ecreset

/*------------------------------------------------------
	CAN1 Control Register 0
------------------------------------------------------*/
#pragma ADDRESS		c1ctlr0_addr	0280H	/* CAN1䃌WX^0			*/
CCTLR0_TYPE		c1ctlr0_addr;

#define		C1CTLR0				c1ctlr0_addr.word
#define		C1CTLR0L			c1ctlr0_addr.byte.low
#define		C1CTLR0H			c1ctlr0_addr.byte.high
#define		RESET0_C1CTLR0		c1ctlr0_addr.bit.reset0
#define		LOOPBACK_C1CTLR0	c1ctlr0_addr.bit.loopback
#define		BASICCAN_C1CTLR0	c1ctlr0_addr.bit.basiccan
#define		RESET1_C1CTLR0		c1ctlr0_addr.bit.reset1
#define		TSPRE0_C1CTLR0		c1ctlr0_addr.bit.tspre0
#define		TSPRE1_C1CTLR0		c1ctlr0_addr.bit.tspre1
#define		TSRESET_C1CTLR0		c1ctlr0_addr.bit.tsreset
#define		ECRESET_C1CTLR0		c1ctlr0_addr.bit.ecreset

/*------------------------------------------------------
	CAN Control Register 1	
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	no_assign1:2;	/*    s ޏꍇ0					*/
		UINT8	reserved1:1;	/* RW 0Œ									*/
		UINT8	banksel:1;
		UINT8	reserved2:2;	/* RW 0Œ									*/
		UINT8	intsel:1;
		UINT8	no_assign2:1;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} CCTLR1_TYPE;

/*------------------------------------------------------
	CAN0 Control Register 1	
------------------------------------------------------*/
#pragma ADDRESS		c0ctlr1_addr	0241H	/* CAN0䃌WX^1			*/
CCTLR1_TYPE		c0ctlr1_addr;

#define		C0CTLR1			c0ctlr1_addr.byte
#define		BANKSEL_C0CTLR1	c0ctlr1_addr.bit.banksel
#define		INTSEL_C0CTLR1	c0ctlr1_addr.bit.intsel

/*------------------------------------------------------
	CAN1 Control Register 1	
------------------------------------------------------*/
#pragma ADDRESS		c1ctlr1_addr	0251H	/* CAN1䃌WX^1			*/
CCTLR1_TYPE		c1ctlr1_addr;

#define		C1CTLR1			c1ctlr1_addr.byte
#define		BANKSEL_C1CTLR1	c1ctlr1_addr.bit.banksel
#define		INTSEL_C1CTLR1	c1ctlr1_addr.bit.intsel

/*------------------------------------------------------
	CAN Sleep Control Register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	sleep:1;
		UINT8	no_assign:7;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} CSLPR_TYPE;

/*------------------------------------------------------
	CAN0 Sleep Control Register
------------------------------------------------------*/
#pragma ADDRESS		c0slpr_addr		0242H	/* CAN0X[v䃌WX^		*/
CSLPR_TYPE	c0slpr_addr;

#define		C0SLPR			c0slpr_addr.byte
#define		SLEEP_C0SLPR	c0slpr_addr.bit.sleep

/*------------------------------------------------------
	CAN1 Sleep Control Register
------------------------------------------------------*/
#pragma ADDRESS		c1slpr_addr		0252H	/* CAN1X[v䃌WX^		*/
CSLPR_TYPE	c1slpr_addr;

#define		C1SLPR			c1slpr_addr.byte
#define		SLEEP_C1SLPR	c1slpr_addr.bit.sleep

/*------------------------------------------------------
	CAN Status Register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	mbox0:1;
		UINT8	mbox1:1;
		UINT8	mbox2:1;
		UINT8	mbox3:1;
		UINT8	trmsucc:1;
		UINT8	recsucc:1;
		UINT8	trmstate:1;
		UINT8	recstate:1;
		UINT8	state_reset:1;
		UINT8	state_loopback:1;
		UINT8	no_assign1:1;	/*    s ޏꍇ0					*/
		UINT8	state_basiccan:1;
		UINT8	state_buserror:1;
		UINT8	state_errpas:1;
		UINT8	state_busoff:1;
		UINT8	no_assign2:1;	/*    s ޏꍇ0					*/
	} bit;
	struct{
		UINT8	low;                /* low  8 bit */
		UINT8	high;               /* high 8 bit */
	} byte;
	UINT16	word;
} CSTR_TYPE;

/*------------------------------------------------------
	CAN0 Status Register
------------------------------------------------------*/
#pragma ADDRESS		c0str_addr		0202H	/* CAN0Xe[^XWX^		*/
CSTR_TYPE	c0str_addr;

#define		C0STR					c0str_addr.word
#define		C0STRL					c0str_addr.byte.low
#define		C0STRH					c0str_addr.byte.high
#define		MBOX0_C0STR				c0str_addr.bit.mbox0
#define		MBOX1_C0STR				c0str_addr.bit.mbox1
#define		MBOX2_C0STR				c0str_addr.bit.mbox2
#define		MBOX3_C0STR				c0str_addr.bit.mbox3
#define		TRMSUCC_C0STR			c0str_addr.bit.trmsucc
#define		RECSUCC_C0STR			c0str_addr.bit.recsucc
#define		TRMSTATE_C0STR			c0str_addr.bit.trmstate
#define		RECSTATE_C0STR			c0str_addr.bit.recstate
#define		STATE_RESET_C0STR		c0str_addr.bit.state_reset
#define		STATE_LOOPBACK_C0STR	c0str_addr.bit.state_loopback
#define		STATE_BASICCAN_C0STR	c0str_addr.bit.state_basiccan
#define		STATE_BUSERROR_C0STR	c0str_addr.bit.state_buserror
#define		STATE_ERRPAS_C0STR		c0str_addr.bit.state_errpas
#define		STATE_BUSOFF_C0STR		c0str_addr.bit.state_busoff

/*------------------------------------------------------
	CAN1 Status Register
------------------------------------------------------*/
#pragma ADDRESS		c1str_addr		0282H	/* CAN1Xe[^XWX^		*/
CSTR_TYPE	c1str_addr;

#define		C1STR					c1str_addr.word
#define		C1STRL					c1str_addr.byte.low
#define		C1STRH					c1str_addr.byte.high
#define		MBOX0_C1STR				c1str_addr.bit.mbox0
#define		MBOX1_C1STR				c1str_addr.bit.mbox1
#define		MBOX2_C1STR				c1str_addr.bit.mbox2
#define		MBOX3_C1STR				c1str_addr.bit.mbox3
#define		TRMSUCC_C1STR			c1str_addr.bit.trmsucc
#define		RECSUCC_C1STR			c1str_addr.bit.recsucc
#define		TRMSTATE_C1STR			c1str_addr.bit.trmstate
#define		RECSTATE_C1STR			c1str_addr.bit.recstate
#define		STATE_RESET_C1STR		c1str_addr.bit.state_reset
#define		STATE_LOOPBACK_C1STR	c1str_addr.bit.state_loopback
#define		STATE_BASICCAN_C1STR	c1str_addr.bit.state_basiccan
#define		STATE_BUSERROR_C1STR	c1str_addr.bit.state_buserror
#define		STATE_ERRPAS_C1STR		c1str_addr.bit.state_errpas
#define		STATE_BUSOFF_C1STR		c1str_addr.bit.state_busoff

/*------------------------------------------------------
	CAN Extended ID Register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	ide15:1;
		UINT8	ide14:1;
		UINT8	ide13:1;
		UINT8	ide12:1;
		UINT8	ide11:1;
		UINT8	ide10:1;
		UINT8	ide9:1;
		UINT8	ide8:1;
		UINT8	ide7:1;
		UINT8	ide6:1;
		UINT8	ide5:1;
		UINT8	ide4:1;
		UINT8	ide3:1;
		UINT8	ide2:1;
		UINT8	ide1:1;
		UINT8	ide0:1;
	} bit;
	struct{
		UINT8	low;                /* low  8 bit */
		UINT8	high;               /* high 8 bit */
	} byte;
	UINT16	word;
} CIDR_TYPE;

/*------------------------------------------------------
	CAN0 Extended ID Register
------------------------------------------------------*/
#pragma ADDRESS		c0idr_addr		0204H	/* CAN0gIDWX^			*/
CIDR_TYPE	c0idr_addr;

#define		C0IDR			c0idr_addr.word
#define		C0IDRL			c0idr_addr.byte.low
#define		C0IDRH			c0idr_addr.byte.high
#define		IDE15_C0IDR		c0idr_addr.bit.ide15
#define		IDE14_C0IDR		c0idr_addr.bit.ide14
#define		IDE13_C0IDR		c0idr_addr.bit.ide13
#define		IDE12_C0IDR		c0idr_addr.bit.ide12
#define		IDE11_C0IDR		c0idr_addr.bit.ide11
#define		IDE10_C0IDR		c0idr_addr.bit.ide10
#define		IDE9_C0IDR		c0idr_addr.bit.ide9
#define		IDE8_C0IDR		c0idr_addr.bit.ide8
#define		IDE7_C0IDR		c0idr_addr.bit.ide7
#define		IDE6_C0IDR		c0idr_addr.bit.ide6
#define		IDE5_C0IDR		c0idr_addr.bit.ide5
#define		IDE4_C0IDR		c0idr_addr.bit.ide4
#define		IDE3_C0IDR		c0idr_addr.bit.ide3
#define		IDE2_C0IDR		c0idr_addr.bit.ide2
#define		IDE1_C0IDR		c0idr_addr.bit.ide1
#define		IDE0_C0IDR		c0idr_addr.bit.ide0

/*------------------------------------------------------
	CAN1 Extended ID Register
------------------------------------------------------*/
#pragma ADDRESS		c1idr_addr		0284H	/* CAN1gIDWX^			*/
CIDR_TYPE	c1idr_addr;

#define		C1IDR			c1idr_addr.word
#define		C1IDRL			c1idr_addr.byte.low
#define		C1IDRH			c1idr_addr.byte.high
#define		IDE15_C1IDR		c1idr_addr.bit.ide15
#define		IDE14_C1IDR		c1idr_addr.bit.ide14
#define		IDE13_C1IDR		c1idr_addr.bit.ide13
#define		IDE12_C1IDR		c1idr_addr.bit.ide12
#define		IDE11_C1IDR		c1idr_addr.bit.ide11
#define		IDE10_C1IDR		c1idr_addr.bit.ide10
#define		IDE9_C1IDR		c1idr_addr.bit.ide9
#define		IDE8_C1IDR		c1idr_addr.bit.ide8
#define		IDE7_C1IDR		c1idr_addr.bit.ide7
#define		IDE6_C1IDR		c1idr_addr.bit.ide6
#define		IDE5_C1IDR		c1idr_addr.bit.ide5
#define		IDE4_C1IDR		c1idr_addr.bit.ide4
#define		IDE3_C1IDR		c1idr_addr.bit.ide3
#define		IDE2_C1IDR		c1idr_addr.bit.ide2
#define		IDE1_C1IDR		c1idr_addr.bit.ide1
#define		IDE0_C1IDR		c1idr_addr.bit.ide0

/*------------------------------------------------------
	CAN Configuration Register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	sam:1;
		UINT8	pts0:1;
		UINT8	pts1:1;
		UINT8	pts2:1;
		UINT8	pbs10:1;
		UINT8	pbs11:1;
		UINT8	pbs12:1;
		UINT8	pbs20:1;
		UINT8	pbs21:1;
		UINT8	pbs22:1;
		UINT8	sjw0:1;
		UINT8	sjw1:1;
	} bit;
	struct{
		UINT8	low;                /* low  8 bit */
		UINT8	high;               /* high 8 bit */
	} byte;
	UINT16	word;
} CCONR_TYPE;

/*------------------------------------------------------
	CAN0 Configuration Register
------------------------------------------------------*/
#pragma ADDRESS		c0conr_addr	0206H	/* CAN0RtBO[VWX^	*/
CCONR_TYPE	c0conr_addr;

#define		C0CONR			c0conr_addr.word
#define		C0CONRL			c0conr_addr.byte.low
#define		C0CONRH			c0conr_addr.byte.high
#define		SAM_C0CONR		c0conr_addr.bit.sam
#define		PTS0_C0CONR		c0conr_addr.bit.pts0
#define		PTS1_C0CONR		c0conr_addr.bit.pts1
#define		PTS2_C0CONR		c0conr_addr.bit.pts2
#define		PBS10_C0CONR	c0conr_addr.bit.pbs10
#define		PBS11_C0CONR	c0conr_addr.bit.pbs11
#define		PBS12_C0CONR	c0conr_addr.bit.pbs12
#define		PBS20_C0CONR	c0conr_addr.bit.pbs20
#define		PBS21_C0CONR	c0conr_addr.bit.pbs21
#define		PBS22_C0CONR	c0conr_addr.bit.pbs22
#define		SJW0_C0CONR		c0conr_addr.bit.sjw0
#define		SJW1_C0CONR		c0conr_addr.bit.sjw1

/*------------------------------------------------------
	CAN1 Configuration Register
------------------------------------------------------*/
#pragma ADDRESS		c1conr_addr	0286H	/* CAN1RtBO[VWX^	*/
CCONR_TYPE	c1conr_addr;

#define		C1CONR			c1conr_addr.word
#define		C1CONRL			c1conr_addr.byte.low
#define		C1CONRH			c1conr_addr.byte.high
#define		SAM_C1CONR		c1conr_addr.bit.sam
#define		PTS0_C1CONR		c1conr_addr.bit.pts0
#define		PTS1_C1CONR		c1conr_addr.bit.pts1
#define		PTS2_C1CONR		c1conr_addr.bit.pts2
#define		PBS10_C1CONR	c1conr_addr.bit.pbs10
#define		PBS11_C1CONR	c1conr_addr.bit.pbs11
#define		PBS12_C1CONR	c1conr_addr.bit.pbs12
#define		PBS20_C1CONR	c1conr_addr.bit.pbs20
#define		PBS21_C1CONR	c1conr_addr.bit.pbs21
#define		PBS22_C1CONR	c1conr_addr.bit.pbs22
#define		SJW0_C1CONR		c1conr_addr.bit.sjw0
#define		SJW1_C1CONR		c1conr_addr.bit.sjw1

/*------------------------------------------------------
	CAN Baud Rate Prescaler
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	b0:1;
		UINT8	b1:1;
		UINT8	b2:1;
		UINT8	b3:1;
		UINT8	b4:1;
		UINT8	b5:1;
		UINT8	b6:1;
		UINT8	b7:1;
	} bit;
	UINT8	byte;
} CBRP_TYPE;

/*------------------------------------------------------
	CAN0 Baud Rate Prescaler
------------------------------------------------------*/
#pragma ADDRESS		c0brp_addr		0217H	/* CAN0{[[gvXP[	*/
CBRP_TYPE	c0brp_addr;

#define		C0BRP		c0brp_addr.byte

/*------------------------------------------------------
	CAN1 Baud Rate Prescaler
------------------------------------------------------*/
#pragma ADDRESS		c1brp_addr		0297H	/* CAN1{[[gvXP[	*/
CBRP_TYPE	c1brp_addr;

#define		C1BRP		c1brp_addr.byte

/*------------------------------------------------------
	CAN Time Stamp Register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	b0:1;
		UINT8	b1:1;
		UINT8	b2:1;
		UINT8	b3:1;
		UINT8	b4:1;
		UINT8	b5:1;
		UINT8	b6:1;
		UINT8	b7:1;
		UINT8	b8:1;
		UINT8	b9:1;
		UINT8	b10:1;
		UINT8	b11:1;
		UINT8	b12:1;
		UINT8	b13:1;
		UINT8	b14:1;
		UINT8	b15:1;
	} bit;
	struct{
		UINT8	low;                /* low  8 bit */
		UINT8	high;               /* high 8 bit */
	} byte;
	UINT16	word;
} CTSR_TYPE;

/*------------------------------------------------------
	CAN0 Time Stamp Register
------------------------------------------------------*/
#pragma ADDRESS		c0tsr_addr		0208H	/* CAN0^CX^vWX^	*/
CTSR_TYPE	c0tsr_addr;

#define		C0TSR		c0tsr_addr.word
#define		C0TSRL		c0tsr_addr.byte.low
#define		C0TSRH		c0tsr_addr.byte.high

/*------------------------------------------------------
	CAN1 Time Stamp Register
------------------------------------------------------*/
#pragma ADDRESS		c1tsr_addr		0288H	/* CAN1^CX^vWX^	*/
CTSR_TYPE	c1tsr_addr;

#define		C1TSR		c1tsr_addr.word
#define		C1TSRL		c1tsr_addr.byte.low
#define		C1TSRH		c1tsr_addr.byte.high

/*------------------------------------------------------
	CAN Transmit Error Counter
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	b0:1;
		UINT8	b1:1;
		UINT8	b2:1;
		UINT8	b3:1;
		UINT8	b4:1;
		UINT8	b5:1;
		UINT8	b6:1;
		UINT8	b7:1;
	} bit;
	UINT8	byte;
} CTEC_TYPE;

/*------------------------------------------------------
	CAN0 Transmit Error Counter
------------------------------------------------------*/
#pragma ADDRESS		c0tec_addr	020aH	/* CAN0MG[JEgWX^	*/
CTEC_TYPE	c0tec_addr;

#define		C0TEC		c0tec_addr.byte

/*------------------------------------------------------
	CAN1 Transmit Error Counter
------------------------------------------------------*/
#pragma ADDRESS		c1tec_addr	028aH	/* CAN1MG[JEgWX^	*/
CTEC_TYPE	c1tec_addr;

#define		C1TEC		c1tec_addr.byte

/*------------------------------------------------------
	CAN Receive Error Counter
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	b0:1;
		UINT8	b1:1;
		UINT8	b2:1;
		UINT8	b3:1;
		UINT8	b4:1;
		UINT8	b5:1;
		UINT8	b6:1;
		UINT8	b7:1;
	} bit;
	UINT8	byte;
} CREC_TYPE;

/*------------------------------------------------------
	CAN0 Receive Error Counter
------------------------------------------------------*/
#pragma ADDRESS		c0rec_addr	020bH	/* CAN0MG[JEgWX^	*/
CREC_TYPE	c0rec_addr;

#define		C0REC		c0rec_addr.byte

/*------------------------------------------------------
	CAN1 Receive Error Counter
------------------------------------------------------*/
#pragma ADDRESS		c1rec_addr	028bH	/* CAN1MG[JEgWX^	*/
CREC_TYPE	c1rec_addr;

#define		C1REC		c1rec_addr.byte

/*------------------------------------------------------
	CAN Slot Interrupt Status Register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	sis15:1;
		UINT8	sis14:1;
		UINT8	sis13:1;
		UINT8	sis12:1;
		UINT8	sis11:1;
		UINT8	sis10:1;
		UINT8	sis9:1;
		UINT8	sis8:1;
		UINT8	sis7:1;
		UINT8	sis6:1;
		UINT8	sis5:1;
		UINT8	sis4:1;
		UINT8	sis3:1;
		UINT8	sis2:1;
		UINT8	sis1:1;
		UINT8	sis0:1;
	} bit;
	struct{
		UINT8	low;                /* low  8 bit */
		UINT8	high;               /* high 8 bit */
	} byte;
	UINT16	word;
} CSISTR_TYPE;

/*------------------------------------------------------
	CAN0 Slot Interrupt Status Register
------------------------------------------------------*/
#pragma ADDRESS		c0sistr_addr	020cH	/* CAN0Xbg荞݃Xe[^XWX^	*/
CSISTR_TYPE		c0sistr_addr;

#define		C0SISTR			c0sistr_addr.word
#define		C0SISTRL		c0sistr_addr.byte.low
#define		C0SISTRH		c0sistr_addr.byte.high
#define		SIS15_C0SISTR	c0sistr_addr.bit.sis15
#define		SIS14_C0SISTR	c0sistr_addr.bit.sis14
#define		SIS13_C0SISTR	c0sistr_addr.bit.sis13
#define		SIS12_C0SISTR	c0sistr_addr.bit.sis12
#define		SIS11_C0SISTR	c0sistr_addr.bit.sis11
#define		SIS10_C0SISTR	c0sistr_addr.bit.sis10
#define		SIS9_C0SISTR	c0sistr_addr.bit.sis9
#define		SIS8_C0SISTR	c0sistr_addr.bit.sis8
#define		SIS7_C0SISTR	c0sistr_addr.bit.sis7
#define		SIS6_C0SISTR	c0sistr_addr.bit.sis6
#define		SIS5_C0SISTR	c0sistr_addr.bit.sis5
#define		SIS4_C0SISTR	c0sistr_addr.bit.sis4
#define		SIS3_C0SISTR	c0sistr_addr.bit.sis3
#define		SIS2_C0SISTR	c0sistr_addr.bit.sis2
#define		SIS1_C0SISTR	c0sistr_addr.bit.sis1
#define		SIS0_C0SISTR	c0sistr_addr.bit.sis0

/*------------------------------------------------------
	CAN1 Slot Interrupt Status Register
------------------------------------------------------*/
#pragma ADDRESS		c1sistr_addr	028cH	/* CAN1Xbg荞݃Xe[^XWX^	*/
CSISTR_TYPE		c1sistr_addr;

#define		C1SISTR			c1sistr_addr.word
#define		C1SISTRL		c1sistr_addr.byte.low
#define		C1SISTRH		c1sistr_addr.byte.high
#define		SIS15_C1SISTR	c1sistr_addr.bit.sis15
#define		SIS14_C1SISTR	c1sistr_addr.bit.sis14
#define		SIS13_C1SISTR	c1sistr_addr.bit.sis13
#define		SIS12_C1SISTR	c1sistr_addr.bit.sis12
#define		SIS11_C1SISTR	c1sistr_addr.bit.sis11
#define		SIS10_C1SISTR	c1sistr_addr.bit.sis10
#define		SIS9_C1SISTR	c1sistr_addr.bit.sis9
#define		SIS8_C1SISTR	c1sistr_addr.bit.sis8
#define		SIS7_C1SISTR	c1sistr_addr.bit.sis7
#define		SIS6_C1SISTR	c1sistr_addr.bit.sis6
#define		SIS5_C1SISTR	c1sistr_addr.bit.sis5
#define		SIS4_C1SISTR	c1sistr_addr.bit.sis4
#define		SIS3_C1SISTR	c1sistr_addr.bit.sis3
#define		SIS2_C1SISTR	c1sistr_addr.bit.sis2
#define		SIS1_C1SISTR	c1sistr_addr.bit.sis1
#define		SIS0_C1SISTR	c1sistr_addr.bit.sis0

/*------------------------------------------------------
	CAN Slot Interrupt Mask Register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	sim15:1;
		UINT8	sim14:1;
		UINT8	sim13:1;
		UINT8	sim12:1;
		UINT8	sim11:1;
		UINT8	sim10:1;
		UINT8	sim9:1;
		UINT8	sim8:1;
		UINT8	sim7:1;
		UINT8	sim6:1;
		UINT8	sim5:1;
		UINT8	sim4:1;
		UINT8	sim3:1;
		UINT8	sim2:1;
		UINT8	sim1:1;
		UINT8	sim0:1;
	} bit;
	struct{
		UINT8	low;                /* low  8 bit */
		UINT8	high;               /* high 8 bit */
	} byte;
	UINT16	word;
} CSIMKR_TYPE;

/*------------------------------------------------------
	CAN0 Slot Interrupt Mask Register
------------------------------------------------------*/
#pragma ADDRESS		c0simkr_addr	0210H	/* CAN0Xbg荞݃}XNWX^	*/
CSIMKR_TYPE		c0simkr_addr;

#define		C0SIMKR			c0simkr_addr.word
#define		C0SIMKRL		c0simkr_addr.byte.low
#define		C0SIMKRH		c0simkr_addr.byte.high
#define		SIM15_C0SIMKR	c0simkr_addr.bit.sim15
#define		SIM14_C0SIMKR	c0simkr_addr.bit.sim14
#define		SIM13_C0SIMKR	c0simkr_addr.bit.sim13
#define		SIM12_C0SIMKR	c0simkr_addr.bit.sim12
#define		SIM11_C0SIMKR	c0simkr_addr.bit.sim11
#define		SIM10_C0SIMKR	c0simkr_addr.bit.sim10
#define		SIM9_C0SIMKR	c0simkr_addr.bit.sim9
#define		SIM8_C0SIMKR	c0simkr_addr.bit.sim8
#define		SIM7_C0SIMKR	c0simkr_addr.bit.sim7
#define		SIM6_C0SIMKR	c0simkr_addr.bit.sim6
#define		SIM5_C0SIMKR	c0simkr_addr.bit.sim5
#define		SIM4_C0SIMKR	c0simkr_addr.bit.sim4
#define		SIM3_C0SIMKR	c0simkr_addr.bit.sim3
#define		SIM2_C0SIMKR	c0simkr_addr.bit.sim2
#define		SIM1_C0SIMKR	c0simkr_addr.bit.sim1
#define		SIM0_C0SIMKR	c0simkr_addr.bit.sim0

/*------------------------------------------------------
	CAN1 Slot Interrupt Mask Register
------------------------------------------------------*/
#pragma ADDRESS		c1simkr_addr	0290H	/* CAN1Xbg荞݃}XNWX^	*/
CSIMKR_TYPE		c1simkr_addr;

#define		C1SIMKR			c1simkr_addr.word
#define		C1SIMKRL		c1simkr_addr.byte.low
#define		C1SIMKRH		c1simkr_addr.byte.high
#define		SIM15_C1SIMKR	c1simkr_addr.bit.sim15
#define		SIM14_C1SIMKR	c1simkr_addr.bit.sim14
#define		SIM13_C1SIMKR	c1simkr_addr.bit.sim13
#define		SIM12_C1SIMKR	c1simkr_addr.bit.sim12
#define		SIM11_C1SIMKR	c1simkr_addr.bit.sim11
#define		SIM10_C1SIMKR	c1simkr_addr.bit.sim10
#define		SIM9_C1SIMKR	c1simkr_addr.bit.sim9
#define		SIM8_C1SIMKR	c1simkr_addr.bit.sim8
#define		SIM7_C1SIMKR	c1simkr_addr.bit.sim7
#define		SIM6_C1SIMKR	c1simkr_addr.bit.sim6
#define		SIM5_C1SIMKR	c1simkr_addr.bit.sim5
#define		SIM4_C1SIMKR	c1simkr_addr.bit.sim4
#define		SIM3_C1SIMKR	c1simkr_addr.bit.sim3
#define		SIM2_C1SIMKR	c1simkr_addr.bit.sim2
#define		SIM1_C1SIMKR	c1simkr_addr.bit.sim1
#define		SIM0_C1SIMKR	c1simkr_addr.bit.sim0

/*------------------------------------------------------
	CAN Error Interrupt Mask Register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	boim:1;
		UINT8	epim:1;
		UINT8	beim:1;
		UINT8	no_assign:5;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} CEIMKR_TYPE;

/*------------------------------------------------------
	CAN0 Error Interrupt Mask Register
------------------------------------------------------*/
#pragma ADDRESS		c0eimkr_addr	0214H	/* CAN0G[荞݃}XNWX^	*/
CEIMKR_TYPE		c0eimkr_addr;

#define		C0EIMKR			c0eimkr_addr.byte
#define		BOIM_C0EIMKR	c0eimkr_addr.bit.boim
#define		EPIM_C0EIMKR	c0eimkr_addr.bit.epim
#define		BEIM_C0EIMKR	c0eimkr_addr.bit.beim

/*------------------------------------------------------
	CAN1 Error Interrupt Mask Register
------------------------------------------------------*/
#pragma ADDRESS		c1eimkr_addr	0294H	/* CAN1G[荞݃}XNWX^	*/
CEIMKR_TYPE		c1eimkr_addr;

#define		C1EIMKR			c1eimkr_addr.byte
#define		BOIM_C1EIMKR	c1eimkr_addr.bit.boim
#define		EPIM_C1EIMKR	c1eimkr_addr.bit.epim
#define		BEIM_C1EIMKR	c1eimkr_addr.bit.beim

/*------------------------------------------------------
	CAN Error Interrupt Status Register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	bois:1;
		UINT8	epis:1;
		UINT8	beis:1;
		UINT8	no_assign:5;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} CEISTR_TYPE;

/*------------------------------------------------------
	CAN0 Error Interrupt Status Register
------------------------------------------------------*/
#pragma ADDRESS		c0eistr_addr	0215H	/* CAN0G[荞݃Xe[^XWX^	*/
CEISTR_TYPE		c0eistr_addr;

#define		C0EISTR			c0eistr_addr.byte
#define		BOIS_C0EISTR	c0eistr_addr.bit.bois
#define		EPIS_C0EISTR	c0eistr_addr.bit.epis
#define		BEIS_C0EISTR	c0eistr_addr.bit.beis

/*------------------------------------------------------
	CAN1 Error Interrupt Status Register
------------------------------------------------------*/
#pragma ADDRESS		c1eistr_addr	0295H	/* CAN1G[荞݃Xe[^XWX^	*/
CEISTR_TYPE		c1eistr_addr;

#define		C1EISTR			c1eistr_addr.byte
#define		BOIS_C1EISTR	c1eistr_addr.bit.bois
#define		EPIS_C1EISTR	c1eistr_addr.bit.epis
#define		BEIS_C1EISTR	c1eistr_addr.bit.beis

/*------------------------------------------------------
	CAN Error Factor Register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	acke:1;
		UINT8	crce:1;
		UINT8	forme:1;
		UINT8	stfe:1;
		UINT8	bite0:1;
		UINT8	bite1:1;
		UINT8	rcve:1;
		UINT8	tre:1;
	} bit;
	UINT8	byte;
} CEFR_TYPE;

/*------------------------------------------------------
	CAN0 Error Factor Register
------------------------------------------------------*/
#pragma ADDRESS		c0efr_addr	0216H	/* CAN0G[vWX^			*/
CEFR_TYPE		c0efr_addr;

#define		C0EFR			c0efr_addr.byte
#define		ACKE_C0EFR		c0efr_addr.bit.acke
#define		CRCE_C0EFR		c0efr_addr.bit.crce
#define		FORME_C0EFR		c0efr_addr.bit.forme
#define		STFE_C0EFR		c0efr_addr.bit.stfe
#define		BITE0_C0EFR		c0efr_addr.bit.bite0
#define		BITE1_C0EFR		c0efr_addr.bit.bite1
#define		RCVE_C0EFR		c0efr_addr.bit.rcve
#define		TRE_C0EFR		c0efr_addr.bit.tre

/*------------------------------------------------------
	CAN1 Error Factor Register
------------------------------------------------------*/
#pragma ADDRESS		c1efr_addr	0296H	/* CAN1G[vWX^			*/
CEFR_TYPE		c1efr_addr;

#define		C1EFR			c1efr_addr.byte
#define		ACKE_C1EFR		c1efr_addr.bit.acke
#define		CRCE_C1EFR		c1efr_addr.bit.crce
#define		FORME_C1EFR		c1efr_addr.bit.forme
#define		STFE_C1EFR		c1efr_addr.bit.stfe
#define		BITE0_C1EFR		c1efr_addr.bit.bite0
#define		BITE1_C1EFR		c1efr_addr.bit.bite1
#define		RCVE_C1EFR		c1efr_addr.bit.rcve
#define		TRE_C1EFR		c1efr_addr.bit.tre

/*------------------------------------------------------
	CAN Mode Register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	cmod0:1;
		UINT8	cmod1:1;
		UINT8	no_assign:6;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} CMDR_TYPE;

/*------------------------------------------------------
	CAN0 Mode Register
------------------------------------------------------*/
#pragma ADDRESS		c0mdtr_addr		0219H	/* CAN0[hWX^			*/
CMDR_TYPE		c0mdtr_addr;

#define		C0MDR			c0mdtr_addr.byte
#define		CMOD0_C0MDR		c0mdtr_addr.bit.cmod0
#define		CMOD1_C0MDR		c0mdtr_addr.bit.cmod1

/*------------------------------------------------------
	CAN1 Mode Register
------------------------------------------------------*/
#pragma ADDRESS		c1mdtr_addr		0299H	/* CAN1[hWX^			*/
CMDR_TYPE		c1mdtr_addr;

#define		C1MDR			c1mdtr_addr.byte
#define		CMOD0_C1MDR		c1mdtr_addr.bit.cmod0
#define		CMOD1_C1MDR		c1mdtr_addr.bit.cmod1

/*------------------------------------------------------
	CAN Single Shot Control Register(BANK0)
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	ssc15:1;
		UINT8	ssc14:1;
		UINT8	ssc13:1;
		UINT8	ssc12:1;
		UINT8	ssc11:1;
		UINT8	ssc10:1;
		UINT8	ssc9:1;
		UINT8	ssc8:1;
		UINT8	ssc7:1;
		UINT8	ssc6:1;
		UINT8	ssc5:1;
		UINT8	ssc4:1;
		UINT8	ssc3:1;
		UINT8	ssc2:1;
		UINT8	ssc1:1;
		UINT8	ssc0:1;
	} bit;
	struct{
		UINT8	low;                /* low  8 bit */
		UINT8	high;               /* high 8 bit */
	} byte;
	UINT16	word;
} CSSCTLR_TYPE;

/*------------------------------------------------------
	CAN0 Single Shot Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c0ssctlr_addr	0220H	/* CAN0VOVbg䃌WX^	*/
CSSCTLR_TYPE	c0ssctlr_addr;

#define		C0SSCTLR		c0ssctlr_addr.word
#define		C0SSCTLRL		c0ssctlr_addr.byte.low
#define		C0SSCTLRH		c0ssctlr_addr.byte.high
#define		SSC15_C0SSCTLR	c0ssctlr_addr.bit.ssc15
#define		SSC14_C0SSCTLR	c0ssctlr_addr.bit.ssc14
#define		SSC13_C0SSCTLR	c0ssctlr_addr.bit.ssc13
#define		SSC12_C0SSCTLR	c0ssctlr_addr.bit.ssc12
#define		SSC11_C0SSCTLR	c0ssctlr_addr.bit.ssc11
#define		SSC10_C0SSCTLR	c0ssctlr_addr.bit.ssc10
#define		SSC9_C0SSCTLR	c0ssctlr_addr.bit.ssc9
#define		SSC8_C0SSCTLR	c0ssctlr_addr.bit.ssc8
#define		SSC7_C0SSCTLR	c0ssctlr_addr.bit.ssc7
#define		SSC6_C0SSCTLR	c0ssctlr_addr.bit.ssc6
#define		SSC5_C0SSCTLR	c0ssctlr_addr.bit.ssc5
#define		SSC4_C0SSCTLR	c0ssctlr_addr.bit.ssc4
#define		SSC3_C0SSCTLR	c0ssctlr_addr.bit.ssc3
#define		SSC2_C0SSCTLR	c0ssctlr_addr.bit.ssc2
#define		SSC1_C0SSCTLR	c0ssctlr_addr.bit.ssc1
#define		SSC0_C0SSCTLR	c0ssctlr_addr.bit.ssc0

/*------------------------------------------------------
	CAN1 Single Shot Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c1ssctlr_addr	02a0H	/* CAN1VOVbg䃌WX^	*/
CSSCTLR_TYPE	c1ssctlr_addr;

#define		C1SSCTLR		c1ssctlr_addr.word
#define		C1SSCTLRL		c1ssctlr_addr.byte.low
#define		C1SSCTLRH		c1ssctlr_addr.byte.high
#define		SSC15_C1SSCTLR	c1ssctlr_addr.bit.ssc15
#define		SSC14_C1SSCTLR	c1ssctlr_addr.bit.ssc14
#define		SSC13_C1SSCTLR	c1ssctlr_addr.bit.ssc13
#define		SSC12_C1SSCTLR	c1ssctlr_addr.bit.ssc12
#define		SSC11_C1SSCTLR	c1ssctlr_addr.bit.ssc11
#define		SSC10_C1SSCTLR	c1ssctlr_addr.bit.ssc10
#define		SSC9_C1SSCTLR	c1ssctlr_addr.bit.ssc9
#define		SSC8_C1SSCTLR	c1ssctlr_addr.bit.ssc8
#define		SSC7_C1SSCTLR	c1ssctlr_addr.bit.ssc7
#define		SSC6_C1SSCTLR	c1ssctlr_addr.bit.ssc6
#define		SSC5_C1SSCTLR	c1ssctlr_addr.bit.ssc5
#define		SSC4_C1SSCTLR	c1ssctlr_addr.bit.ssc4
#define		SSC3_C1SSCTLR	c1ssctlr_addr.bit.ssc3
#define		SSC2_C1SSCTLR	c1ssctlr_addr.bit.ssc2
#define		SSC1_C1SSCTLR	c1ssctlr_addr.bit.ssc1
#define		SSC0_C1SSCTLR	c1ssctlr_addr.bit.ssc0

/*------------------------------------------------------
	CAN Single Shot Status Register(BANK0)
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	sss15:1;
		UINT8	sss14:1;
		UINT8	sss13:1;
		UINT8	sss12:1;
		UINT8	sss11:1;
		UINT8	sss10:1;
		UINT8	sss9:1;
		UINT8	sss8:1;
		UINT8	sss7:1;
		UINT8	sss6:1;
		UINT8	sss5:1;
		UINT8	sss4:1;
		UINT8	sss3:1;
		UINT8	sss2:1;
		UINT8	sss1:1;
		UINT8	sss0:1;
	} bit;
	struct{
		UINT8	low;                /* low  8 bit */
		UINT8	high;               /* high 8 bit */
	} byte;
	UINT16	word;
} CSSSTR_TYPE;

/*------------------------------------------------------
	CAN0 Single Shot Status Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c0ssstr_addr	0224H	/* CAN0VOVbgXe[^XWX^	*/
CSSSTR_TYPE		c0ssstr_addr;

#define		C0SSSTR			c0ssstr_addr.word
#define		C0SSSTRL		c0ssstr_addr.byte.low
#define		C0SSSTRH		c0ssstr_addr.byte.high
#define		SSC15_C0SSSTR	c0ssstr_addr.bit.sss15
#define		SSC14_C0SSSTR	c0ssstr_addr.bit.sss14
#define		SSC13_C0SSSTR	c0ssstr_addr.bit.sss13
#define		SSC12_C0SSSTR	c0ssstr_addr.bit.sss12
#define		SSC11_C0SSSTR	c0ssstr_addr.bit.sss11
#define		SSC10_C0SSSTR	c0ssstr_addr.bit.sss10
#define		SSC9_C0SSSTR	c0ssstr_addr.bit.sss9
#define		SSC8_C0SSSTR	c0ssstr_addr.bit.sss8
#define		SSC7_C0SSSTR	c0ssstr_addr.bit.sss7
#define		SSC6_C0SSSTR	c0ssstr_addr.bit.sss6
#define		SSC5_C0SSSTR	c0ssstr_addr.bit.sss5
#define		SSC4_C0SSSTR	c0ssstr_addr.bit.sss4
#define		SSC3_C0SSSTR	c0ssstr_addr.bit.sss3
#define		SSC2_C0SSSTR	c0ssstr_addr.bit.sss2
#define		SSC1_C0SSSTR	c0ssstr_addr.bit.sss1
#define		SSC0_C0SSSTR	c0ssstr_addr.bit.sss0

/*------------------------------------------------------
	CAN1 Single Shot Status Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c1ssstr_addr	02a4H	/* CAN1VOVbgXe[^XWX^	*/
CSSSTR_TYPE		c1ssstr_addr;

#define		C1SSSTR			c1ssstr_addr.word
#define		C1SSSTRL		c1ssstr_addr.byte.low
#define		C1SSSTRH		c1ssstr_addr.byte.high
#define		SSC15_C1SSSTR	c1ssstr_addr.bit.sss15
#define		SSC14_C1SSSTR	c1ssstr_addr.bit.sss14
#define		SSC13_C1SSSTR	c1ssstr_addr.bit.sss13
#define		SSC12_C1SSSTR	c1ssstr_addr.bit.sss12
#define		SSC11_C1SSSTR	c1ssstr_addr.bit.sss11
#define		SSC10_C1SSSTR	c1ssstr_addr.bit.sss10
#define		SSC9_C1SSSTR	c1ssstr_addr.bit.sss9
#define		SSC8_C1SSSTR	c1ssstr_addr.bit.sss8
#define		SSC7_C1SSSTR	c1ssstr_addr.bit.sss7
#define		SSC6_C1SSSTR	c1ssstr_addr.bit.sss6
#define		SSC5_C1SSSTR	c1ssstr_addr.bit.sss5
#define		SSC4_C1SSSTR	c1ssstr_addr.bit.sss4
#define		SSC3_C1SSSTR	c1ssstr_addr.bit.sss3
#define		SSC2_C1SSSTR	c1ssstr_addr.bit.sss2
#define		SSC1_C1SSSTR	c1ssstr_addr.bit.sss1
#define		SSC0_C1SSSTR	c1ssstr_addr.bit.sss0

/*------------------------------------------------------
	CAN Mask Register 0(Standard ID0)(BANK1)
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	sid6m:1;
		UINT8	sid7m:1;
		UINT8	sid8m:1;
		UINT8	sid9m:1;
		UINT8	sid10m:1;
		UINT8	no_assign:3;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} CMR0_TYPE;

/*------------------------------------------------------
	CAN0 Global Mask Register 0(Standard ID0)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c0gmr0_addr		0228H	/* CAN0O[o}XNWX^WID0	*/
CMR0_TYPE	c0gmr0_addr;

#define		C0GMR0			c0gmr0_addr.byte
#define		SID6M_C0GMR0	c0gmr0_addr.bit.sid6m
#define		SID7M_C0GMR0	c0gmr0_addr.bit.sid7m
#define		SID8M_C0GMR0	c0gmr0_addr.bit.sid8m
#define		SID9M_C0GMR0	c0gmr0_addr.bit.sid9m
#define		SID10M_C0GMR0	c0gmr0_addr.bit.sid10m

/*------------------------------------------------------
	CAN0 Local Mask Register A 0(Standard ID0)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c0lmar0_addr	0230H	/* CAN0[J}XNWX^AWID0	*/
CMR0_TYPE	c0lmar0_addr;

#define		C0LMAR0			c0lmar0_addr.byte
#define		SID6M_C0LMAR0	c0lmar0_addr.bit.sid6m
#define		SID7M_C0LMAR0	c0lmar0_addr.bit.sid7m
#define		SID8M_C0LMAR0	c0lmar0_addr.bit.sid8m
#define		SID9M_C0LMAR0	c0lmar0_addr.bit.sid9m
#define		SID10M_C0LMAR0	c0lmar0_addr.bit.sid10m

/*------------------------------------------------------
	CAN0 Local Mask Register B 0(Standard ID0)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c0lmbr0_addr	0238H	/* CAN0[J}XNWX^BWID0	*/
CMR0_TYPE	c0lmbr0_addr;

#define		C0LMBR0			c0lmbr0_addr.byte
#define		SID6M_C0LMBR0	c0lmbr0_addr.bit.sid6m
#define		SID7M_C0LMBR0	c0lmbr0_addr.bit.sid7m
#define		SID8M_C0LMBR0	c0lmbr0_addr.bit.sid8m
#define		SID9M_C0LMBR0	c0lmbr0_addr.bit.sid9m
#define		SID10M_C0LMBR0	c0lmbr0_addr.bit.sid10m

/*------------------------------------------------------
	CAN1 Global Mask Register 0(Standard ID0)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c1gmr0_addr		02a8H	/* CAN1O[o}XNWX^WID0	*/
CMR0_TYPE	c1gmr0_addr;

#define		C1GMR0			c1gmr0_addr.byte
#define		SID6M_C1GMR0	c1gmr0_addr.bit.sid6m
#define		SID7M_C1GMR0	c1gmr0_addr.bit.sid7m
#define		SID8M_C1GMR0	c1gmr0_addr.bit.sid8m
#define		SID9M_C1GMR0	c1gmr0_addr.bit.sid9m
#define		SID10M_C1GMR0	c1gmr0_addr.bit.sid10m

/*------------------------------------------------------
	CAN1 Local Mask Register A 0(Standard ID0)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c1lmar0_addr	02b0H	/* CAN1[J}XNWX^AWID0	*/
CMR0_TYPE	c1lmar0_addr;

#define		C1LMAR0			c1lmar0_addr.byte
#define		SID6M_C1LMAR0	c1lmar0_addr.bit.sid6m
#define		SID7M_C1LMAR0	c1lmar0_addr.bit.sid7m
#define		SID8M_C1LMAR0	c1lmar0_addr.bit.sid8m
#define		SID9M_C1LMAR0	c1lmar0_addr.bit.sid9m
#define		SID10M_C1LMAR0	c1lmar0_addr.bit.sid10m

/*------------------------------------------------------
	CAN1 Local Mask Register B 0(Standard ID0)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c1lmbr0_addr	02b8H	/* CAN1[J}XNWX^BWID0	*/
CMR0_TYPE	c1lmbr0_addr;

#define		C1LMBR0			c1lmbr0_addr.byte
#define		SID6M_C1LMBR0	c1lmbr0_addr.bit.sid6m
#define		SID7M_C1LMBR0	c1lmbr0_addr.bit.sid7m
#define		SID8M_C1LMBR0	c1lmbr0_addr.bit.sid8m
#define		SID9M_C1LMBR0	c1lmbr0_addr.bit.sid9m
#define		SID10M_C1LMBR0	c1lmbr0_addr.bit.sid10m

/*------------------------------------------------------
	CAN Mask Register 1(Standard ID1)(BANK1)
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	sid0m:1;
		UINT8	sid1m:1;
		UINT8	sid2m:1;
		UINT8	sid3m:1;
		UINT8	sid4m:1;
		UINT8	sid5m:1;
		UINT8	no_assign:2;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} CMR1_TYPE;

/*------------------------------------------------------
	CAN0 Global Mask Register 1(Standard ID1)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c0gmr1_addr		0229H	/* CAN0O[o}XNWX^WID1	*/
CMR1_TYPE	c0gmr1_addr;

#define		C0GMR1			c0gmr1_addr.byte
#define		SID0M_C0GMR1	c0gmr1_addr.bit.sid0m
#define		SID1M_C0GMR1	c0gmr1_addr.bit.sid1m
#define		SID2M_C0GMR1	c0gmr1_addr.bit.sid2m
#define		SID3M_C0GMR1	c0gmr1_addr.bit.sid3m
#define		SID4M_C0GMR1	c0gmr1_addr.bit.sid4m
#define		SID5M_C0GMR1	c0gmr1_addr.bit.sid5m

/*------------------------------------------------------
	CAN0 Local Mask Register A 1(Standard ID1)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c0lmar1_addr	0231H	/* CAN0[J}XNWX^AWID1	*/
CMR1_TYPE	c0lmar1_addr;

#define		C0LMAR1			c0lmar1_addr.byte
#define		SID0M_C0LMAR1	c0lmar1_addr.bit.sid0m
#define		SID1M_C0LMAR1	c0lmar1_addr.bit.sid1m
#define		SID2M_C0LMAR1	c0lmar1_addr.bit.sid2m
#define		SID3M_C0LMAR1	c0lmar1_addr.bit.sid3m
#define		SID4M_C0LMAR1	c0lmar1_addr.bit.sid4m
#define		SID5M_C0LMAR1	c0lmar1_addr.bit.sid5m

/*------------------------------------------------------
	CAN0 Local Mask Register B 1(Standard ID1)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c0lmbr1_addr	0239H	/* CAN0[J}XNWX^BWID1	*/
CMR1_TYPE	c0lmbr1_addr;

#define		C0LMBR1			c0lmbr1_addr.byte
#define		SID0M_C0LMBR1	c0lmbr1_addr.bit.sid0m
#define		SID1M_C0LMBR1	c0lmbr1_addr.bit.sid1m
#define		SID2M_C0LMBR1	c0lmbr1_addr.bit.sid2m
#define		SID3M_C0LMBR1	c0lmbr1_addr.bit.sid3m
#define		SID4M_C0LMBR1	c0lmbr1_addr.bit.sid4m
#define		SID5M_C0LMBR1	c0lmbr1_addr.bit.sid5m

/*------------------------------------------------------
	CAN1 Global Mask Register 1(Standard ID1)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c1gmr1_addr		02a9H	/* CAN1O[o}XNWX^WID1	*/
CMR1_TYPE	c1gmr1_addr;

#define		C1GMR1			c1gmr1_addr.byte
#define		SID0M_C1GMR1	c1gmr1_addr.bit.sid0m
#define		SID1M_C1GMR1	c1gmr1_addr.bit.sid1m
#define		SID2M_C1GMR1	c1gmr1_addr.bit.sid2m
#define		SID3M_C1GMR1	c1gmr1_addr.bit.sid3m
#define		SID4M_C1GMR1	c1gmr1_addr.bit.sid4m
#define		SID5M_C1GMR1	c1gmr1_addr.bit.sid5m

/*------------------------------------------------------
	CAN1 Local Mask Register A 1(Standard ID1)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c1lmar1_addr	02b1H	/* CAN1[J}XNWX^AWID1	*/
CMR1_TYPE	c1lmar1_addr;

#define		C1LMAR1			c1lmar1_addr.byte
#define		SID0M_C1LMAR1	c1lmar1_addr.bit.sid0m
#define		SID1M_C1LMAR1	c1lmar1_addr.bit.sid1m
#define		SID2M_C1LMAR1	c1lmar1_addr.bit.sid2m
#define		SID3M_C1LMAR1	c1lmar1_addr.bit.sid3m
#define		SID4M_C1LMAR1	c1lmar1_addr.bit.sid4m
#define		SID5M_C1LMAR1	c1lmar1_addr.bit.sid5m

/*------------------------------------------------------
	CAN1 Local Mask Register B 1(Standard ID1)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c1lmbr1_addr	02b9H	/* CAN1[J}XNWX^BWID1	*/
CMR1_TYPE	c1lmbr1_addr;

#define		C1LMBR1			c1lmbr1_addr.byte
#define		SID0M_C1LMBR1	c1lmbr1_addr.bit.sid0m
#define		SID1M_C1LMBR1	c1lmbr1_addr.bit.sid1m
#define		SID2M_C1LMBR1	c1lmbr1_addr.bit.sid2m
#define		SID3M_C1LMBR1	c1lmbr1_addr.bit.sid3m
#define		SID4M_C1LMBR1	c1lmbr1_addr.bit.sid4m
#define		SID5M_C1LMBR1	c1lmbr1_addr.bit.sid5m

/*------------------------------------------------------
	CAN Mask Register 2(Extended ID0)(BANK1)
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	eid14m:1;
		UINT8	eid15m:1;
		UINT8	eid16m:1;
		UINT8	eid17m:1;
		UINT8	no_assign:4;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} CMR2_TYPE;

/*------------------------------------------------------
	CAN0 Global Mask Register 2(Extended ID0)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c0gmr2_addr		022aH	/* CAN0O[o}XNWX^gID0	*/
CMR2_TYPE	c0gmr2_addr;

#define		C0GMR2			c0gmr2_addr.byte
#define		EID14M_C0GMR2	c0gmr2_addr.bit.eid14m
#define		EID15M_C0GMR2	c0gmr2_addr.bit.eid15m
#define		EID16M_C0GMR2	c0gmr2_addr.bit.eid16m
#define		EID17M_C0GMR2	c0gmr2_addr.bit.eid17m

/*------------------------------------------------------
	CAN0 Local Mask Register A 2(Extended ID0)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c0lmar2_addr	0232H	/* CAN0[J}XNWX^AgID0	*/
CMR2_TYPE	c0lmar2_addr;

#define		C0LMAR2			c0lmar2_addr.byte
#define		EID14M_C0LMAR2	c0lmar2_addr.bit.eid14m
#define		EID15M_C0LMAR2	c0lmar2_addr.bit.eid15m
#define		EID16M_C0LMAR2	c0lmar2_addr.bit.eid16m
#define		EID17M_C0LMAR2	c0lmar2_addr.bit.eid17m

/*------------------------------------------------------
	CAN0 Local Mask Register B 2(Extended ID0)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c0lmbr2_addr	023aH	/* CAN0[J}XNWX^BgID0	*/
CMR2_TYPE	c0lmbr2_addr;

#define		C0LMBR2			c0lmbr2_addr.byte
#define		EID14M_C0LMBR2	c0lmbr2_addr.bit.eid14m
#define		EID15M_C0LMBR2	c0lmbr2_addr.bit.eid15m
#define		EID16M_C0LMBR2	c0lmbr2_addr.bit.eid16m
#define		EID17M_C0LMBR2	c0lmbr2_addr.bit.eid17m

/*------------------------------------------------------
	CAN1 Global Mask Register 2(Extended ID0)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c1gmr2_addr		02aaH	/* CAN1O[o}XNWX^gID0	*/
CMR2_TYPE	c1gmr2_addr;

#define		C1GMR2			c1gmr2_addr.byte
#define		EID14M_C1GMR2	c1gmr2_addr.bit.eid14m
#define		EID15M_C1GMR2	c1gmr2_addr.bit.eid15m
#define		EID16M_C1GMR2	c1gmr2_addr.bit.eid16m
#define		EID17M_C1GMR2	c1gmr2_addr.bit.eid17m

/*------------------------------------------------------
	CAN1 Local Mask Register A 2(Extended ID0)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c1lmar2_addr	02b2H	/* CAN1[J}XNWX^AgID0	*/
CMR2_TYPE	c1lmar2_addr;

#define		C1LMAR2			c1lmar2_addr.byte
#define		EID14M_C1LMAR2	c1lmar2_addr.bit.eid14m
#define		EID15M_C1LMAR2	c1lmar2_addr.bit.eid15m
#define		EID16M_C1LMAR2	c1lmar2_addr.bit.eid16m
#define		EID17M_C1LMAR2	c1lmar2_addr.bit.eid17m

/*------------------------------------------------------
	CAN1 Local Mask Register B 2(Extended ID0)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c1lmbr2_addr	02baH	/* CAN1[J}XNWX^BgID0	*/
CMR2_TYPE	c1lmbr2_addr;

#define		C1LMBR2			c1lmbr2_addr.byte
#define		EID14M_C1LMBR2	c1lmbr2_addr.bit.eid14m
#define		EID15M_C1LMBR2	c1lmbr2_addr.bit.eid15m
#define		EID16M_C1LMBR2	c1lmbr2_addr.bit.eid16m
#define		EID17M_C1LMBR2	c1lmbr2_addr.bit.eid17m

/*------------------------------------------------------
	CAN Mask Register 3(Extended ID1)(BANK1)
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	eid6m:1;
		UINT8	eid7m:1;
		UINT8	eid8m:1;
		UINT8	eid9m:1;
		UINT8	eid10m:1;
		UINT8	eid11m:1;
		UINT8	eid12m:1;
		UINT8	eid13m:1;
	} bit;
	UINT8	byte;
} CMR3_TYPE;

/*------------------------------------------------------
	CAN0 Global Mask Register 3(Extended ID1)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c0gmr3_addr		022bH	/* CAN0O[o}XNWX^gID1	*/
CMR3_TYPE	c0gmr3_addr;

#define		C0GMR3			c0gmr3_addr.byte
#define		EID6M_C0GMR3	c0gmr3_addr.bit.eid6m
#define		EID7M_C0GMR3	c0gmr3_addr.bit.eid7m
#define		EID8M_C0GMR3	c0gmr3_addr.bit.eid8m
#define		EID9M_C0GMR3	c0gmr3_addr.bit.eid9m
#define		EID10M_C0GMR3	c0gmr3_addr.bit.eid10m
#define		EID11M_C0GMR3	c0gmr3_addr.bit.eid11m
#define		EID12M_C0GMR3	c0gmr3_addr.bit.eid12m
#define		EID13M_C0GMR3	c0gmr3_addr.bit.eid13m

/*------------------------------------------------------
	CAN0 Local Mask Register A 3(Extended ID1)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c0lmar3_addr	0233H	/* CAN0[J}XNWX^AgID1	*/
CMR3_TYPE	c0lmar3_addr;

#define		C0LMAR3			c0lmar3_addr.byte
#define		EID6M_C0LMAR3	c0lmar3_addr.bit.eid6m
#define		EID7M_C0LMAR3	c0lmar3_addr.bit.eid7m
#define		EID8M_C0LMAR3	c0lmar3_addr.bit.eid8m
#define		EID9M_C0LMAR3	c0lmar3_addr.bit.eid9m
#define		EID10M_C0LMAR3	c0lmar3_addr.bit.eid10m
#define		EID11M_C0LMAR3	c0lmar3_addr.bit.eid11m
#define		EID12M_C0LMAR3	c0lmar3_addr.bit.eid12m
#define		EID13M_C0LMAR3	c0lmar3_addr.bit.eid13m

/*------------------------------------------------------
	CAN0 Local Mask Register B 3(Extended ID1)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c0lmbr3_addr	023bH	/* CAN0[J}XNWX^BgID1	*/
CMR3_TYPE	c0lmbr3_addr;

#define		C0LMBR3			c0lmbr3_addr.byte
#define		EID6M_C0LMBR3	c0lmbr3_addr.bit.eid6m
#define		EID7M_C0LMBR3	c0lmbr3_addr.bit.eid7m
#define		EID8M_C0LMBR3	c0lmbr3_addr.bit.eid8m
#define		EID9M_C0LMBR3	c0lmbr3_addr.bit.eid9m
#define		EID10M_C0LMBR3	c0lmbr3_addr.bit.eid10m
#define		EID11M_C0LMBR3	c0lmbr3_addr.bit.eid11m
#define		EID12M_C0LMBR3	c0lmbr3_addr.bit.eid12m
#define		EID13M_C0LMBR3	c0lmbr3_addr.bit.eid13m

/*------------------------------------------------------
	CAN1 Global Mask Register 3(Extended ID1)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c1gmr3_addr		02abH	/* CAN1O[o}XNWX^gID1	*/
CMR3_TYPE	c1gmr3_addr;

#define		C1GMR3			c1gmr3_addr.byte
#define		EID6M_C1GMR3	c1gmr3_addr.bit.eid6m
#define		EID7M_C1GMR3	c1gmr3_addr.bit.eid7m
#define		EID8M_C1GMR3	c1gmr3_addr.bit.eid8m
#define		EID9M_C1GMR3	c1gmr3_addr.bit.eid9m
#define		EID10M_C1GMR3	c1gmr3_addr.bit.eid10m
#define		EID11M_C1GMR3	c1gmr3_addr.bit.eid11m
#define		EID12M_C1GMR3	c1gmr3_addr.bit.eid12m
#define		EID13M_C1GMR3	c1gmr3_addr.bit.eid13m

/*------------------------------------------------------
	CAN1 Local Mask Register A 3(Extended ID1)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c1lmar3_addr	02b3H	/* CAN1[J}XNWX^AgID1	*/
CMR3_TYPE	c1lmar3_addr;

#define		C1LMAR3			c1lmar3_addr.byte
#define		EID6M_C1LMAR3	c1lmar3_addr.bit.eid6m
#define		EID7M_C1LMAR3	c1lmar3_addr.bit.eid7m
#define		EID8M_C1LMAR3	c1lmar3_addr.bit.eid8m
#define		EID9M_C1LMAR3	c1lmar3_addr.bit.eid9m
#define		EID10M_C1LMAR3	c1lmar3_addr.bit.eid10m
#define		EID11M_C1LMAR3	c1lmar3_addr.bit.eid11m
#define		EID12M_C1LMAR3	c1lmar3_addr.bit.eid12m
#define		EID13M_C1LMAR3	c1lmar3_addr.bit.eid13m

/*------------------------------------------------------
	CAN1 Local Mask Register B 3(Extended ID1)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c1lmbr3_addr	02bbH	/* CAN1[J}XNWX^BgID1	*/
CMR3_TYPE	c1lmbr3_addr;

#define		C1LMBR3			c1lmbr3_addr.byte
#define		EID6M_C1LMBR3	c1lmbr3_addr.bit.eid6m
#define		EID7M_C1LMBR3	c1lmbr3_addr.bit.eid7m
#define		EID8M_C1LMBR3	c1lmbr3_addr.bit.eid8m
#define		EID9M_C1LMBR3	c1lmbr3_addr.bit.eid9m
#define		EID10M_C1LMBR3	c1lmbr3_addr.bit.eid10m
#define		EID11M_C1LMBR3	c1lmbr3_addr.bit.eid11m
#define		EID12M_C1LMBR3	c1lmbr3_addr.bit.eid12m
#define		EID13M_C1LMBR3	c1lmbr3_addr.bit.eid13m

/*------------------------------------------------------
	CAN Mask Register 4(Extended ID2)(BANK1)
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	eid0m:1;
		UINT8	eid1m:1;
		UINT8	eid2m:1;
		UINT8	eid3m:1;
		UINT8	eid4m:1;
		UINT8	eid5m:1;
		UINT8	no_assign:2;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} CMR4_TYPE;

/*------------------------------------------------------
	CAN0 Global Mask Register 4(Extended ID2)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c0gmr4_addr		022cH	/* CAN0O[o}XNWX^gID2	*/
CMR4_TYPE	c0gmr4_addr;

#define		C0GMR4			c0gmr4_addr.byte
#define		EID0M_C0GMR4	c0gmr4_addr.bit.eid0m
#define		EID1M_C0GMR4	c0gmr4_addr.bit.eid1m
#define		EID2M_C0GMR4	c0gmr4_addr.bit.eid2m
#define		EID3M_C0GMR4	c0gmr4_addr.bit.eid3m
#define		EID4M_C0GMR4	c0gmr4_addr.bit.eid4m
#define		EID5M_C0GMR4	c0gmr4_addr.bit.eid5m

/*------------------------------------------------------
	CAN0 Local Mask Register A 4(Extended ID2)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c0lmar4_addr	0234H	/* CAN0[J}XNWX^AgID2	*/
CMR4_TYPE	c0lmar4_addr;

#define		C0LMAR4			c0lmar4_addr.byte
#define		EID0M_C0LMAR4	c0lmar4_addr.bit.eid0m
#define		EID1M_C0LMAR4	c0lmar4_addr.bit.eid1m
#define		EID2M_C0LMAR4	c0lmar4_addr.bit.eid2m
#define		EID3M_C0LMAR4	c0lmar4_addr.bit.eid3m
#define		EID4M_C0LMAR4	c0lmar4_addr.bit.eid4m
#define		EID5M_C0LMAR4	c0lmar4_addr.bit.eid5m

/*------------------------------------------------------
	CAN0 Local Mask Register B 4(Extended ID2)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c0lmbr4_addr	023cH	/* CAN0[J}XNWX^BgID2	*/
CMR4_TYPE	c0lmbr4_addr;

#define		C0LMBR4			c0lmbr4_addr.byte
#define		EID0M_C0LMBR4	c0lmbr4_addr.bit.eid0m
#define		EID1M_C0LMBR4	c0lmbr4_addr.bit.eid1m
#define		EID2M_C0LMBR4	c0lmbr4_addr.bit.eid2m
#define		EID3M_C0LMBR4	c0lmbr4_addr.bit.eid3m
#define		EID4M_C0LMBR4	c0lmbr4_addr.bit.eid4m
#define		EID5M_C0LMBR4	c0lmbr4_addr.bit.eid5m

/*------------------------------------------------------
	CAN1 Global Mask Register 4(Extended ID2)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c1gmr4_addr		02acH	/* CAN1O[o}XNWX^gID2	*/
CMR4_TYPE	c1gmr4_addr;

#define		C1GMR4			c1gmr4_addr.byte
#define		EID0M_C1GMR4	c1gmr4_addr.bit.eid0m
#define		EID1M_C1GMR4	c1gmr4_addr.bit.eid1m
#define		EID2M_C1GMR4	c1gmr4_addr.bit.eid2m
#define		EID3M_C1GMR4	c1gmr4_addr.bit.eid3m
#define		EID4M_C1GMR4	c1gmr4_addr.bit.eid4m
#define		EID5M_C1GMR4	c1gmr4_addr.bit.eid5m

/*------------------------------------------------------
	CAN1 Local Mask Register A 4(Extended ID2)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c1lmar4_addr	02b4H	/* CAN1[J}XNWX^AgID2	*/
CMR4_TYPE	c1lmar4_addr;

#define		C1LMAR4			c1lmar4_addr.byte
#define		EID0M_C1LMAR4	c1lmar4_addr.bit.eid0m
#define		EID1M_C1LMAR4	c1lmar4_addr.bit.eid1m
#define		EID2M_C1LMAR4	c1lmar4_addr.bit.eid2m
#define		EID3M_C1LMAR4	c1lmar4_addr.bit.eid3m
#define		EID4M_C1LMAR4	c1lmar4_addr.bit.eid4m
#define		EID5M_C10LMAR4	c1lmar4_addr.bit.eid5m

/*------------------------------------------------------
	CAN1 Local Mask Register B 4(Extended ID2)(BANK1)
------------------------------------------------------*/
#pragma ADDRESS		c1lmbr4_addr	02bcH	/* CAN1[J}XNWX^BgID2	*/
CMR4_TYPE	c1lmbr4_addr;

#define		C1LMBR4			c1lmbr4_addr.byte
#define		EID0M_C1LMBR4	c1lmbr4_addr.bit.eid0m
#define		EID1M_C1LMBR4	c1lmbr4_addr.bit.eid1m
#define		EID2M_C1LMBR4	c1lmbr4_addr.bit.eid2m
#define		EID3M_C1LMBR4	c1lmbr4_addr.bit.eid3m
#define		EID4M_C1LMBR4	c1lmbr4_addr.bit.eid4m
#define		EID5M_C1LMBR4	c1lmbr4_addr.bit.eid5m

/*------------------------------------------------------
	CAN Message Slot Control Register(BANK0)
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	sentdata_newdata:1;
		UINT8	trmactive_invaldata:1;
		UINT8	msglost:1;
		UINT8	remactive:1;
		UINT8	rsplock:1;
		UINT8	remote:1;
		UINT8	recreq:1;
		UINT8	trmreq:1;
	} bit;
	UINT8	byte;
} CMCTL_TYPE;

/*------------------------------------------------------
	CAN0 Message Slot0 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c0mctl0_addr	0230H	/* CAN0bZ[WXbg0䃌WX^	*/
CMCTL_TYPE	c0mctl0_addr;

#define		C0MCTL0				c0mctl0_addr.byte
#define		SENTDATA_C0MCTL0	c0mctl0_addr.bit.sentdata_newdata
#define		NEWDATA_C0MCTL0		c0mctl0_addr.bit.sentdata_newdata
#define		TRMACTIVE_C0MCTL0	c0mctl0_addr.bit.trmactive_invaldata
#define		INVALDATA_C0MCTL0	c0mctl0_addr.bit.trmactive_invaldata
#define		MSGLOST_C0MCTL0		c0mctl0_addr.bit.msglost
#define		REMACTIVE_C0MCTL0	c0mctl0_addr.bit.remactive
#define		RSPLOCK_C0MCTL0		c0mctl0_addr.bit.rsplock
#define		REMOTE_C0MCTL0		c0mctl0_addr.bit.remote
#define		RECREQ_C0MCTL0		c0mctl0_addr.bit.recreq
#define		TRMREQ_C0MCTL0		c0mctl0_addr.bit.trmreq

/*------------------------------------------------------
	CAN0 Message Slot1 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c0mctl1_addr	0231H	/* CAN0bZ[WXbg1䃌WX^	*/
CMCTL_TYPE	c0mctl1_addr;

#define		C0MCTL1				c0mctl1_addr.byte
#define		SENTDATA_C0MCTL1	c0mctl1_addr.bit.sentdata_newdata
#define		NEWDATA_C0MCTL1		c0mctl1_addr.bit.sentdata_newdata
#define		TRMACTIVE_C0MCTL1	c0mctl1_addr.bit.trmactive_invaldata
#define		INVALDATA_C0MCTL1	c0mctl1_addr.bit.trmactive_invaldata
#define		MSGLOST_C0MCTL1		c0mctl1_addr.bit.msglost
#define		REMACTIVE_C0MCTL1	c0mctl1_addr.bit.remactive
#define		RSPLOCK_C0MCTL1		c0mctl1_addr.bit.rsplock
#define		REMOTE_C0MCTL1		c0mctl1_addr.bit.remote
#define		RECREQ_C0MCTL1		c0mctl1_addr.bit.recreq
#define		TRMREQ_C0MCTL1		c0mctl1_addr.bit.trmreq

/*------------------------------------------------------
	CAN0 Message Slot2 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c0mctl2_addr	0232H	/* CAN0bZ[WXbg2䃌WX^	*/
CMCTL_TYPE	c0mctl2_addr;

#define		C0MCTL2				c0mctl2_addr.byte
#define		SENTDATA_C0MCTL2	c0mctl2_addr.bit.sentdata_newdata
#define		NEWDATA_C0MCTL2		c0mctl2_addr.bit.sentdata_newdata
#define		TRMACTIVE_C0MCTL2	c0mctl2_addr.bit.trmactive_invaldata
#define		INVALDATA_C0MCTL2	c0mctl2_addr.bit.trmactive_invaldata
#define		MSGLOST_C0MCTL2		c0mctl2_addr.bit.msglost
#define		REMACTIVE_C0MCTL2	c0mctl2_addr.bit.remactive
#define		RSPLOCK_C0MCTL2		c0mctl2_addr.bit.rsplock
#define		REMOTE_C0MCTL2		c0mctl2_addr.bit.remote
#define		RECREQ_C0MCTL2		c0mctl2_addr.bit.recreq
#define		TRMREQ_C0MCTL2		c0mctl2_addr.bit.trmreq

/*------------------------------------------------------
	CAN0 Message Slot3 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c0mctl3_addr	0233H	/* CAN0bZ[WXbg3䃌WX^	*/
CMCTL_TYPE	c0mctl3_addr;

#define		C0MCTL3				c0mctl3_addr.byte
#define		SENTDATA_C0MCTL3	c0mctl3_addr.bit.sentdata_newdata
#define		NEWDATA_C0MCTL3		c0mctl3_addr.bit.sentdata_newdata
#define		TRMACTIVE_C0MCTL3	c0mctl3_addr.bit.trmactive_invaldata
#define		INVALDATA_C0MCTL3	c0mctl3_addr.bit.trmactive_invaldata
#define		MSGLOST_C0MCTL3		c0mctl3_addr.bit.msglost
#define		REMACTIVE_C0MCTL3	c0mctl3_addr.bit.remactive
#define		RSPLOCK_C0MCTL3		c0mctl3_addr.bit.rsplock
#define		REMOTE_C0MCTL3		c0mctl3_addr.bit.remote
#define		RECREQ_C0MCTL3		c0mctl3_addr.bit.recreq
#define		TRMREQ_C0MCTL3		c0mctl3_addr.bit.trmreq

/*------------------------------------------------------
	CAN0 Message Slot4 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c0mctl4_addr	0234H	/* CAN0bZ[WXbg4䃌WX^	*/
CMCTL_TYPE	c0mctl4_addr;

#define		C0MCTL4				c0mctl4_addr.byte
#define		SENTDATA_C0MCTL4	c0mctl4_addr.bit.sentdata_newdata
#define		NEWDATA_C0MCTL4		c0mctl4_addr.bit.sentdata_newdata
#define		TRMACTIVE_C0MCTL4	c0mctl4_addr.bit.trmactive_invaldata
#define		INVALDATA_C0MCTL4	c0mctl4_addr.bit.trmactive_invaldata
#define		MSGLOST_C0MCTL4		c0mctl4_addr.bit.msglost
#define		REMACTIVE_C0MCTL4	c0mctl4_addr.bit.remactive
#define		RSPLOCK_C0MCTL4		c0mctl4_addr.bit.rsplock
#define		REMOTE_C0MCTL4		c0mctl4_addr.bit.remote
#define		RECREQ_C0MCTL4		c0mctl4_addr.bit.recreq
#define		TRMREQ_C0MCTL4		c0mctl4_addr.bit.trmreq

/*------------------------------------------------------
	CAN0 Message Slot5 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c0mctl5_addr	0235H	/* CAN0bZ[WXbg5䃌WX^	*/
CMCTL_TYPE	c0mctl5_addr;

#define		C0MCTL5				c0mctl5_addr.byte
#define		SENTDATA_C0MCTL5	c0mctl5_addr.bit.sentdata_newdata
#define		NEWDATA_C0MCTL5		c0mctl5_addr.bit.sentdata_newdata
#define		TRMACTIVE_C0MCTL5	c0mctl5_addr.bit.trmactive_invaldata
#define		INVALDATA_C0MCTL5	c0mctl5_addr.bit.trmactive_invaldata
#define		MSGLOST_C0MCTL5		c0mctl5_addr.bit.msglost
#define		REMACTIVE_C0MCTL5	c0mctl5_addr.bit.remactive
#define		RSPLOCK_C0MCTL5		c0mctl5_addr.bit.rsplock
#define		REMOTE_C0MCTL5		c0mctl5_addr.bit.remote
#define		RECREQ_C0MCTL5		c0mctl5_addr.bit.recreq
#define		TRMREQ_C0MCTL5		c0mctl5_addr.bit.trmreq

/*------------------------------------------------------
	CAN0 Message Slot6 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c0mctl6_addr	0236H	/* CAN0bZ[WXbg6䃌WX^	*/
CMCTL_TYPE	c0mctl6_addr;

#define		C0MCTL6				c0mctl6_addr.byte
#define		SENTDATA_C0MCTL6	c0mctl6_addr.bit.sentdata_newdata
#define		NEWDATA_C0MCTL6		c0mctl6_addr.bit.sentdata_newdata
#define		TRMACTIVE_C0MCTL6	c0mctl6_addr.bit.trmactive_invaldata
#define		INVALDATA_C0MCTL6	c0mctl6_addr.bit.trmactive_invaldata
#define		MSGLOST_C0MCTL6		c0mctl6_addr.bit.msglost
#define		REMACTIVE_C0MCTL6	c0mctl6_addr.bit.remactive
#define		RSPLOCK_C0MCTL6		c0mctl6_addr.bit.rsplock
#define		REMOTE_C0MCTL6		c0mctl6_addr.bit.remote
#define		RECREQ_C0MCTL6		c0mctl6_addr.bit.recreq
#define		TRMREQ_C0MCTL6		c0mctl6_addr.bit.trmreq

/*------------------------------------------------------
	CAN0 Message Slot7 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c0mctl7_addr	0237H	/* CAN0bZ[WXbg7䃌WX^	*/
CMCTL_TYPE	c0mctl7_addr;

#define		C0MCTL7				c0mctl7_addr.byte
#define		SENTDATA_C0MCTL7	c0mctl7_addr.bit.sentdata_newdata
#define		NEWDATA_C0MCTL7		c0mctl7_addr.bit.sentdata_newdata
#define		TRMACTIVE_C0MCTL7	c0mctl7_addr.bit.trmactive_invaldata
#define		INVALDATA_C0MCTL7	c0mctl7_addr.bit.trmactive_invaldata
#define		MSGLOST_C0MCTL7		c0mctl7_addr.bit.msglost
#define		REMACTIVE_C0MCTL7	c0mctl7_addr.bit.remactive
#define		RSPLOCK_C0MCTL7		c0mctl7_addr.bit.rsplock
#define		REMOTE_C0MCTL7		c0mctl7_addr.bit.remote
#define		RECREQ_C0MCTL7		c0mctl7_addr.bit.recreq
#define		TRMREQ_C0MCTL7		c0mctl7_addr.bit.trmreq

/*------------------------------------------------------
	CAN0 Message Slot8 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c0mctl8_addr	0238H	/* CAN0bZ[WXbg8䃌WX^	*/
CMCTL_TYPE	c0mctl8_addr;

#define		C0MCTL8				c0mctl8_addr.byte
#define		SENTDATA_C0MCTL8	c0mctl8_addr.bit.sentdata_newdata
#define		NEWDATA_C0MCTL8		c0mctl8_addr.bit.sentdata_newdata
#define		TRMACTIVE_C0MCTL8	c0mctl8_addr.bit.trmactive_invaldata
#define		INVALDATA_C0MCTL8	c0mctl8_addr.bit.trmactive_invaldata
#define		MSGLOST_C0MCTL8		c0mctl8_addr.bit.msglost
#define		REMACTIVE_C0MCTL8	c0mctl8_addr.bit.remactive
#define		RSPLOCK_C0MCTL8		c0mctl8_addr.bit.rsplock
#define		REMOTE_C0MCTL8		c0mctl8_addr.bit.remote
#define		RECREQ_C0MCTL8		c0mctl8_addr.bit.recreq
#define		TRMREQ_C0MCTL8		c0mctl8_addr.bit.trmreq

/*------------------------------------------------------
	CAN0 Message Slot9 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c0mctl9_addr	0239H	/* CAN0bZ[WXbg9䃌WX^	*/
CMCTL_TYPE	c0mctl9_addr;

#define		C0MCTL9				c0mctl9_addr.byte
#define		SENTDATA_C0MCTL9	c0mctl9_addr.bit.sentdata_newdata
#define		NEWDATA_C0MCTL9		c0mctl9_addr.bit.sentdata_newdata
#define		TRMACTIVE_C0MCTL9	c0mctl9_addr.bit.trmactive_invaldata
#define		INVALDATA_C0MCTL9	c0mctl9_addr.bit.trmactive_invaldata
#define		MSGLOST_C0MCTL9		c0mctl9_addr.bit.msglost
#define		REMACTIVE_C0MCTL9	c0mctl9_addr.bit.remactive
#define		RSPLOCK_C0MCTL9		c0mctl9_addr.bit.rsplock
#define		REMOTE_C0MCTL9		c0mctl9_addr.bit.remote
#define		RECREQ_C0MCTL9		c0mctl9_addr.bit.recreq
#define		TRMREQ_C0MCTL9		c0mctl9_addr.bit.trmreq

/*------------------------------------------------------
	CAN0 Message Slot10 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c0mctl10_addr	023aH	/* CAN0bZ[WXbg10䃌WX^	*/
CMCTL_TYPE	c0mctl10_addr;

#define		C0MCTL10			c0mctl10_addr.byte
#define		SENTDATA_C0MCTL10	c0mctl10_addr.bit.sentdata_newdata
#define		NEWDATA_C0MCTL10	c0mctl10_addr.bit.sentdata_newdata
#define		TRMACTIVE_C0MCTL10	c0mctl10_addr.bit.trmactive_invaldata
#define		INVALDATA_C0MCTL10	c0mctl10_addr.bit.trmactive_invaldata
#define		MSGLOST_C0MCTL10	c0mctl10_addr.bit.msglost
#define		REMACTIVE_C0MCTL10	c0mctl10_addr.bit.remactive
#define		RSPLOCK_C0MCTL10	c0mctl10_addr.bit.rsplock
#define		REMOTE_C0MCTL10		c0mctl10_addr.bit.remote
#define		RECREQ_C0MCTL10		c0mctl10_addr.bit.recreq
#define		TRMREQ_C0MCTL10		c0mctl10_addr.bit.trmreq

/*------------------------------------------------------
	CAN0 Message Slot11 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c0mctl11_addr	023bH	/* CAN0bZ[WXbg11䃌WX^	*/
CMCTL_TYPE	c0mctl11_addr;

#define		C0MCTL11			c0mctl11_addr.byte
#define		SENTDATA_C0MCTL11	c0mctl11_addr.bit.sentdata_newdata
#define		NEWDATA_C0MCTL11	c0mctl11_addr.bit.sentdata_newdata
#define		TRMACTIVE_C0MCTL11	c0mctl11_addr.bit.trmactive_invaldata
#define		INVALDATA_C0MCTL11	c0mctl11_addr.bit.trmactive_invaldata
#define		MSGLOST_C0MCTL11	c0mctl11_addr.bit.msglost
#define		REMACTIVE_C0MCTL11	c0mctl11_addr.bit.remactive
#define		RSPLOCK_C0MCTL11	c0mctl11_addr.bit.rsplock
#define		REMOTE_C0MCTL11		c0mctl11_addr.bit.remote
#define		RECREQ_C0MCTL11		c0mctl11_addr.bit.recreq
#define		TRMREQ_C0MCTL11		c0mctl11_addr.bit.trmreq

/*------------------------------------------------------
	CAN0 Message Slot12 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c0mctl12_addr	023cH	/* CAN0bZ[WXbg12䃌WX^	*/
CMCTL_TYPE	c0mctl12_addr;

#define		C0MCTL12			c0mctl12_addr.byte
#define		SENTDATA_C0MCTL12	c0mctl12_addr.bit.sentdata_newdata
#define		NEWDATA_C0MCTL12	c0mctl12_addr.bit.sentdata_newdata
#define		TRMACTIVE_C0MCTL12	c0mctl12_addr.bit.trmactive_invaldata
#define		INVALDATA_C0MCTL12	c0mctl12_addr.bit.trmactive_invaldata
#define		MSGLOST_C0MCTL12	c0mctl12_addr.bit.msglost
#define		REMACTIVE_C0MCTL12	c0mctl12_addr.bit.remactive
#define		RSPLOCK_C0MCTL12	c0mctl12_addr.bit.rsplock
#define		REMOTE_C0MCTL12		c0mctl12_addr.bit.remote
#define		RECREQ_C0MCTL12		c0mctl12_addr.bit.recreq
#define		TRMREQ_C0MCTL12		c0mctl12_addr.bit.trmreq

/*------------------------------------------------------
	CAN0 Message Slot13 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c0mctl13_addr	023dH	/* CAN0bZ[WXbg13䃌WX^	*/
CMCTL_TYPE	c0mctl13_addr;

#define		C0MCTL13			c0mctl13_addr.byte
#define		SENTDATA_C0MCTL13	c0mctl13_addr.bit.sentdata_newdata
#define		NEWDATA_C0MCTL13	c0mctl13_addr.bit.sentdata_newdata
#define		TRMACTIVE_C0MCTL13	c0mctl13_addr.bit.trmactive_invaldata
#define		INVALDATA_C0MCTL13	c0mctl13_addr.bit.trmactive_invaldata
#define		MSGLOST_C0MCTL13	c0mctl13_addr.bit.msglost
#define		REMACTIVE_C0MCTL13	c0mctl13_addr.bit.remactive
#define		RSPLOCK_C0MCTL13	c0mctl13_addr.bit.rsplock
#define		REMOTE_C0MCTL13		c0mctl13_addr.bit.remote
#define		RECREQ_C0MCTL13		c0mctl13_addr.bit.recreq
#define		TRMREQ_C0MCTL13		c0mctl13_addr.bit.trmreq

/*------------------------------------------------------
	CAN0 Message Slot14 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c0mctl14_addr	023eH	/* CAN0bZ[WXbg14䃌WX^	*/
CMCTL_TYPE	c0mctl14_addr;

#define		C0MCTL14			c0mctl14_addr.byte
#define		SENTDATA_C0MCTL14	c0mctl14_addr.bit.sentdata_newdata
#define		NEWDATA_C0MCTL14	c0mctl14_addr.bit.sentdata_newdata
#define		TRMACTIVE_C0MCTL14	c0mctl14_addr.bit.trmactive_invaldata
#define		INVALDATA_C0MCTL14	c0mctl14_addr.bit.trmactive_invaldata
#define		MSGLOST_C0MCTL14	c0mctl14_addr.bit.msglost
#define		REMACTIVE_C0MCTL14	c0mctl14_addr.bit.remactive
#define		RSPLOCK_C0MCTL14	c0mctl14_addr.bit.rsplock
#define		REMOTE_C0MCTL14		c0mctl14_addr.bit.remote
#define		RECREQ_C0MCTL14		c0mctl14_addr.bit.recreq
#define		TRMREQ_C0MCTL14		c0mctl14_addr.bit.trmreq

/*------------------------------------------------------
	CAN0 Message Slot15 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c0mctl15_addr	023fH	/* CAN0bZ[WXbg15䃌WX^	*/
CMCTL_TYPE	c0mctl15_addr;

#define		C0MCTL15			c0mctl15_addr.byte
#define		SENTDATA_C0MCTL15	c0mctl15_addr.bit.sentdata_newdata
#define		NEWDATA_C0MCTL15	c0mctl15_addr.bit.sentdata_newdata
#define		TRMACTIVE_C0MCTL15	c0mctl15_addr.bit.trmactive_invaldata
#define		INVALDATA_C0MCTL15	c0mctl15_addr.bit.trmactive_invaldata
#define		MSGLOST_C0MCTL15	c0mctl15_addr.bit.msglost
#define		REMACTIVE_C0MCTL15	c0mctl15_addr.bit.remactive
#define		RSPLOCK_C0MCTL15	c0mctl15_addr.bit.rsplock
#define		REMOTE_C0MCTL15		c0mctl15_addr.bit.remote
#define		RECREQ_C0MCTL15		c0mctl15_addr.bit.recreq
#define		TRMREQ_C0MCTL15		c0mctl15_addr.bit.trmreq

/*------------------------------------------------------
	CAN1 Message Slot0 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c1mctl0_addr	02b0H	/* CAN1bZ[WXbg0䃌WX^	*/
CMCTL_TYPE	c1mctl0_addr;

#define		C1MCTL0				c1mctl0_addr.byte
#define		SENTDATA_C1MCTL0	c1mctl0_addr.bit.sentdata_newdata
#define		NEWDATA_C1MCTL0		c1mctl0_addr.bit.sentdata_newdata
#define		TRMACTIVE_C1MCTL0	c1mctl0_addr.bit.trmactive_invaldata
#define		INVALDATA_C1MCTL0	c1mctl0_addr.bit.trmactive_invaldata
#define		MSGLOST_C1MCTL0		c1mctl0_addr.bit.msglost
#define		REMACTIVE_C1MCTL0	c1mctl0_addr.bit.remactive
#define		RSPLOCK_C1MCTL0		c1mctl0_addr.bit.rsplock
#define		REMOTE_C1MCTL0		c1mctl0_addr.bit.remote
#define		RECREQ_C1MCTL0		c1mctl0_addr.bit.recreq
#define		TRMREQ_C1MCTL0		c1mctl0_addr.bit.trmreq

/*------------------------------------------------------
	CAN1 Message Slot1 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c1mctl1_addr	02b1H	/* CAN1bZ[WXbg1䃌WX^	*/
CMCTL_TYPE	c1mctl1_addr;

#define		C1MCTL1				c1mctl1_addr.byte
#define		SENTDATA_C1MCTL1	c1mctl1_addr.bit.sentdata_newdata
#define		NEWDATA_C1MCTL1		c1mctl1_addr.bit.sentdata_newdata
#define		TRMACTIVE_C1MCTL1	c1mctl1_addr.bit.trmactive_invaldata
#define		INVALDATA_C1MCTL1	c1mctl1_addr.bit.trmactive_invaldata
#define		MSGLOST_C1MCTL1		c1mctl1_addr.bit.msglost
#define		REMACTIVE_C1MCTL1	c1mctl1_addr.bit.remactive
#define		RSPLOCK_C1MCTL1		c1mctl1_addr.bit.rsplock
#define		REMOTE_C1MCTL1		c1mctl1_addr.bit.remote
#define		RECREQ_C1MCTL1		c1mctl1_addr.bit.recreq
#define		TRMREQ_C1MCTL1		c1mctl1_addr.bit.trmreq

/*------------------------------------------------------
	CAN1 Message Slot2 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c1mctl2_addr	02b2H	/* CAN1bZ[WXbg2䃌WX^	*/
CMCTL_TYPE	c1mctl2_addr;

#define		C1MCTL2				c1mctl2_addr.byte
#define		SENTDATA_C1MCTL2	c1mctl2_addr.bit.sentdata_newdata
#define		NEWDATA_C1MCTL2		c1mctl2_addr.bit.sentdata_newdata
#define		TRMACTIVE_C1MCTL2	c1mctl2_addr.bit.trmactive_invaldata
#define		INVALDATA_C1MCTL2	c1mctl2_addr.bit.trmactive_invaldata
#define		MSGLOST_C1MCTL2		c1mctl2_addr.bit.msglost
#define		REMACTIVE_C1MCTL2	c1mctl2_addr.bit.remactive
#define		RSPLOCK_C1MCTL2		c1mctl2_addr.bit.rsplock
#define		REMOTE_C1MCTL2		c1mctl2_addr.bit.remote
#define		RECREQ_C1MCTL2		c1mctl2_addr.bit.recreq
#define		TRMREQ_C1MCTL2		c1mctl2_addr.bit.trmreq

/*------------------------------------------------------
	CAN1 Message Slot3 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c1mctl3_addr	02b3H	/* CAN1bZ[WXbg3䃌WX^	*/
CMCTL_TYPE	c1mctl3_addr;

#define		C1MCTL3				c1mctl3_addr.byte
#define		SENTDATA_C1MCTL3	c1mctl3_addr.bit.sentdata_newdata
#define		NEWDATA_C1MCTL3		c1mctl3_addr.bit.sentdata_newdata
#define		TRMACTIVE_C1MCTL3	c1mctl3_addr.bit.trmactive_invaldata
#define		INVALDATA_C1MCTL3	c1mctl3_addr.bit.trmactive_invaldata
#define		MSGLOST_C1MCTL3		c1mctl3_addr.bit.msglost
#define		REMACTIVE_C1MCTL3	c1mctl3_addr.bit.remactive
#define		RSPLOCK_C1MCTL3		c1mctl3_addr.bit.rsplock
#define		REMOTE_C1MCTL3		c1mctl3_addr.bit.remote
#define		RECREQ_C1MCTL3		c1mctl3_addr.bit.recreq
#define		TRMREQ_C1MCTL3		c1mctl3_addr.bit.trmreq

/*------------------------------------------------------
	CAN1 Message Slot4 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c1mctl4_addr	02b4H	/* CAN1bZ[WXbg4䃌WX^	*/
CMCTL_TYPE	c1mctl4_addr;

#define		C1MCTL4				c1mctl4_addr.byte
#define		SENTDATA_C1MCTL4	c1mctl4_addr.bit.sentdata_newdata
#define		NEWDATA_C1MCTL4		c1mctl4_addr.bit.sentdata_newdata
#define		TRMACTIVE_C1MCTL4	c1mctl4_addr.bit.trmactive_invaldata
#define		INVALDATA_C1MCTL4	c1mctl4_addr.bit.trmactive_invaldata
#define		MSGLOST_C1MCTL4		c1mctl4_addr.bit.msglost
#define		REMACTIVE_C1MCTL4	c1mctl4_addr.bit.remactive
#define		RSPLOCK_C1MCTL4		c1mctl4_addr.bit.rsplock
#define		REMOTE_C1MCTL4		c1mctl4_addr.bit.remote
#define		RECREQ_C1MCTL4		c1mctl4_addr.bit.recreq
#define		TRMREQ_C1MCTL4		c1mctl4_addr.bit.trmreq

/*------------------------------------------------------
	CAN1 Message Slot5 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c1mctl5_addr	02b5H	/* CAN1bZ[WXbg5䃌WX^	*/
CMCTL_TYPE	c1mctl5_addr;

#define		C1MCTL5				c1mctl5_addr.byte
#define		SENTDATA_C1MCTL5	c1mctl5_addr.bit.sentdata_newdata
#define		NEWDATA_C1MCTL5		c1mctl5_addr.bit.sentdata_newdata
#define		TRMACTIVE_C1MCTL5	c1mctl5_addr.bit.trmactive_invaldata
#define		INVALDATA_C1MCTL5	c1mctl5_addr.bit.trmactive_invaldata
#define		MSGLOST_C1MCTL5		c1mctl5_addr.bit.msglost
#define		REMACTIVE_C1MCTL5	c1mctl5_addr.bit.remactive
#define		RSPLOCK_C1MCTL5		c1mctl5_addr.bit.rsplock
#define		REMOTE_C1MCTL5		c1mctl5_addr.bit.remote
#define		RECREQ_C1MCTL5		c1mctl5_addr.bit.recreq
#define		TRMREQ_C1MCTL5		c1mctl5_addr.bit.trmreq

/*------------------------------------------------------
	CAN1 Message Slot6 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c1mctl6_addr	02b6H	/* CAN1bZ[WXbg6䃌WX^	*/
CMCTL_TYPE	c1mctl6_addr;

#define		C1MCTL6				c1mctl6_addr.byte
#define		SENTDATA_C1MCTL6	c1mctl6_addr.bit.sentdata_newdata
#define		NEWDATA_C1MCTL6		c1mctl6_addr.bit.sentdata_newdata
#define		TRMACTIVE_C1MCTL6	c1mctl6_addr.bit.trmactive_invaldata
#define		INVALDATA_C1MCTL6	c1mctl6_addr.bit.trmactive_invaldata
#define		MSGLOST_C1MCTL6		c1mctl6_addr.bit.msglost
#define		REMACTIVE_C1MCTL6	c1mctl6_addr.bit.remactive
#define		RSPLOCK_C1MCTL6		c1mctl6_addr.bit.rsplock
#define		REMOTE_C1MCTL6		c1mctl6_addr.bit.remote
#define		RECREQ_C1MCTL6		c1mctl6_addr.bit.recreq
#define		TRMREQ_C1MCTL6		c1mctl6_addr.bit.trmreq

/*------------------------------------------------------
	CAN1 Message Slot7 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c1mctl7_addr	02b7H	/* CAN1bZ[WXbg7䃌WX^	*/
CMCTL_TYPE	c1mctl7_addr;

#define		C1MCTL7				c1mctl7_addr.byte
#define		SENTDATA_C1MCTL7	c1mctl7_addr.bit.sentdata_newdata
#define		NEWDATA_C1MCTL7		c1mctl7_addr.bit.sentdata_newdata
#define		TRMACTIVE_C1MCTL7	c1mctl7_addr.bit.trmactive_invaldata
#define		INVALDATA_C1MCTL7	c1mctl7_addr.bit.trmactive_invaldata
#define		MSGLOST_C1MCTL7		c1mctl7_addr.bit.msglost
#define		REMACTIVE_C1MCTL7	c1mctl7_addr.bit.remactive
#define		RSPLOCK_C1MCTL7		c1mctl7_addr.bit.rsplock
#define		REMOTE_C1MCTL7		c1mctl7_addr.bit.remote
#define		RECREQ_C1MCTL7		c1mctl7_addr.bit.recreq
#define		TRMREQ_C1MCTL7		c1mctl7_addr.bit.trmreq

/*------------------------------------------------------
	CAN1 Message Slot8 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c1mctl8_addr	02b8H	/* CAN1bZ[WXbg8䃌WX^	*/
CMCTL_TYPE	c1mctl8_addr;

#define		C1MCTL8				c1mctl8_addr.byte
#define		SENTDATA_C1MCTL8	c1mctl8_addr.bit.sentdata_newdata
#define		NEWDATA_C1MCTL8		c1mctl8_addr.bit.sentdata_newdata
#define		TRMACTIVE_C1MCTL8	c1mctl8_addr.bit.trmactive_invaldata
#define		INVALDATA_C1MCTL8	c1mctl8_addr.bit.trmactive_invaldata
#define		MSGLOST_C1MCTL8		c1mctl8_addr.bit.msglost
#define		REMACTIVE_C1MCTL8	c1mctl8_addr.bit.remactive
#define		RSPLOCK_C1MCTL8		c1mctl8_addr.bit.rsplock
#define		REMOTE_C1MCTL8		c1mctl8_addr.bit.remote
#define		RECREQ_C1MCTL8		c1mctl8_addr.bit.recreq
#define		TRMREQ_C1MCTL8		c1mctl8_addr.bit.trmreq

/*------------------------------------------------------
	CAN1 Message Slot9 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c1mctl9_addr	02b9H	/* CAN1bZ[WXbg9䃌WX^	*/
CMCTL_TYPE	c1mctl9_addr;

#define		C1MCTL9				c1mctl9_addr.byte
#define		SENTDATA_C1MCTL9	c1mctl9_addr.bit.sentdata_newdata
#define		NEWDATA_C1MCTL9		c1mctl9_addr.bit.sentdata_newdata
#define		TRMACTIVE_C1MCTL9	c1mctl9_addr.bit.trmactive_invaldata
#define		INVALDATA_C1MCTL9	c1mctl9_addr.bit.trmactive_invaldata
#define		MSGLOST_C1MCTL9		c1mctl9_addr.bit.msglost
#define		REMACTIVE_C1MCTL9	c1mctl9_addr.bit.remactive
#define		RSPLOCK_C1MCTL9		c1mctl9_addr.bit.rsplock
#define		REMOTE_C1MCTL9		c1mctl9_addr.bit.remote
#define		RECREQ_C1MCTL9		c1mctl9_addr.bit.recreq
#define		TRMREQ_C1MCTL9		c1mctl9_addr.bit.trmreq

/*------------------------------------------------------
	CAN1 Message Slot10 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c1mctl10_addr	02baH	/* CAN1bZ[WXbg10䃌WX^	*/
CMCTL_TYPE	c1mctl10_addr;

#define		C1MCTL10			c1mctl10_addr.byte
#define		SENTDATA_C1MCTL10	c1mctl10_addr.bit.sentdata_newdata
#define		NEWDATA_C1MCTL10	c1mctl10_addr.bit.sentdata_newdata
#define		TRMACTIVE_C1MCTL10	c1mctl10_addr.bit.trmactive_invaldata
#define		INVALDATA_C1MCTL10	c1mctl10_addr.bit.trmactive_invaldata
#define		MSGLOST_C1MCTL10	c1mctl10_addr.bit.msglost
#define		REMACTIVE_C1MCTL10	c1mctl10_addr.bit.remactive
#define		RSPLOCK_C1MCTL10	c1mctl10_addr.bit.rsplock
#define		REMOTE_C1MCTL10		c1mctl10_addr.bit.remote
#define		RECREQ_C1MCTL10		c1mctl10_addr.bit.recreq
#define		TRMREQ_C1MCTL10		c1mctl10_addr.bit.trmreq

/*------------------------------------------------------
	CAN1 Message Slot11 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c1mctl11_addr	02bbH	/* CAN1bZ[WXbg11䃌WX^	*/
CMCTL_TYPE	c1mctl11_addr;

#define		C1MCTL11			c1mctl11_addr.byte
#define		SENTDATA_C1MCTL11	c1mctl11_addr.bit.sentdata_newdata
#define		NEWDATA_C1MCTL11	c1mctl11_addr.bit.sentdata_newdata
#define		TRMACTIVE_C1MCTL11	c1mctl11_addr.bit.trmactive_invaldata
#define		INVALDATA_C1MCTL11	c1mctl11_addr.bit.trmactive_invaldata
#define		MSGLOST_C1MCTL11	c1mctl11_addr.bit.msglost
#define		REMACTIVE_C1MCTL11	c1mctl11_addr.bit.remactive
#define		RSPLOCK_C1MCTL11	c1mctl11_addr.bit.rsplock
#define		REMOTE_C1MCTL11		c1mctl11_addr.bit.remote
#define		RECREQ_C1MCTL11		c1mctl11_addr.bit.recreq
#define		TRMREQ_C1MCTL11		c1mctl11_addr.bit.trmreq

/*------------------------------------------------------
	CAN1 Message Slot12 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c1mctl12_addr	02bcH	/* CAN1bZ[WXbg12䃌WX^	*/
CMCTL_TYPE	c1mctl12_addr;

#define		C1MCTL12			c1mctl12_addr.byte
#define		SENTDATA_C1MCTL12	c1mctl12_addr.bit.sentdata_newdata
#define		NEWDATA_C1MCTL12	c1mctl12_addr.bit.sentdata_newdata
#define		TRMACTIVE_C1MCTL12	c1mctl12_addr.bit.trmactive_invaldata
#define		INVALDATA_C1MCTL12	c1mctl12_addr.bit.trmactive_invaldata
#define		MSGLOST_C1MCTL12	c1mctl12_addr.bit.msglost
#define		REMACTIVE_C1MCTL12	c1mctl12_addr.bit.remactive
#define		RSPLOCK_C1MCTL12	c1mctl12_addr.bit.rsplock
#define		REMOTE_C1MCTL12		c1mctl12_addr.bit.remote
#define		RECREQ_C1MCTL12		c1mctl12_addr.bit.recreq
#define		TRMREQ_C1MCTL12		c1mctl12_addr.bit.trmreq

/*------------------------------------------------------
	CAN1 Message Slot13 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c1mctl13_addr	02bdH	/* CAN1bZ[WXbg13䃌WX^	*/
CMCTL_TYPE	c1mctl13_addr;

#define		C1MCTL13			c1mctl13_addr.byte
#define		SENTDATA_C1MCTL13	c1mctl13_addr.bit.sentdata_newdata
#define		NEWDATA_C1MCTL13	c1mctl13_addr.bit.sentdata_newdata
#define		TRMACTIVE_C1MCTL13	c1mctl13_addr.bit.trmactive_invaldata
#define		INVALDATA_C1MCTL13	c1mctl13_addr.bit.trmactive_invaldata
#define		MSGLOST_C1MCTL13	c1mctl13_addr.bit.msglost
#define		REMACTIVE_C1MCTL13	c1mctl13_addr.bit.remactive
#define		RSPLOCK_C1MCTL13	c1mctl13_addr.bit.rsplock
#define		REMOTE_C1MCTL13		c1mctl13_addr.bit.remote
#define		RECREQ_C1MCTL13		c1mctl13_addr.bit.recreq
#define		TRMREQ_C1MCTL13		c1mctl13_addr.bit.trmreq

/*------------------------------------------------------
	CAN1 Message Slot14 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c1mctl14_addr	02beH	/* CAN1bZ[WXbg14䃌WX^	*/
CMCTL_TYPE	c1mctl14_addr;

#define		C1MCTL14			c1mctl14_addr.byte
#define		SENTDATA_C1MCTL14	c1mctl14_addr.bit.sentdata_newdata
#define		NEWDATA_C1MCTL14	c1mctl14_addr.bit.sentdata_newdata
#define		TRMACTIVE_C1MCTL14	c1mctl14_addr.bit.trmactive_invaldata
#define		INVALDATA_C1MCTL14	c1mctl14_addr.bit.trmactive_invaldata
#define		MSGLOST_C1MCTL14	c1mctl14_addr.bit.msglost
#define		REMACTIVE_C1MCTL14	c1mctl14_addr.bit.remactive
#define		RSPLOCK_C1MCTL14	c1mctl14_addr.bit.rsplock
#define		REMOTE_C1MCTL14		c1mctl14_addr.bit.remote
#define		RECREQ_C1MCTL14		c1mctl14_addr.bit.recreq
#define		TRMREQ_C1MCTL14		c1mctl14_addr.bit.trmreq

/*------------------------------------------------------
	CAN1 Message Slot15 Control Register(BANK0)
------------------------------------------------------*/
#pragma ADDRESS		c1mctl15_addr	02bfH	/* CAN1bZ[WXbg15䃌WX^	*/
CMCTL_TYPE	c1mctl15_addr;

#define		C1MCTL15			c1mctl15_addr.byte
#define		SENTDATA_C1MCTL15	c1mctl15_addr.bit.sentdata_newdata
#define		NEWDATA_C1MCTL15	c1mctl15_addr.bit.sentdata_newdata
#define		TRMACTIVE_C1MCTL15	c1mctl15_addr.bit.trmactive_invaldata
#define		INVALDATA_C1MCTL15	c1mctl15_addr.bit.trmactive_invaldata
#define		MSGLOST_C1MCTL15	c1mctl15_addr.bit.msglost
#define		REMACTIVE_C1MCTL15	c1mctl15_addr.bit.remactive
#define		RSPLOCK_C1MCTL15	c1mctl15_addr.bit.rsplock
#define		REMOTE_C1MCTL15		c1mctl15_addr.bit.remote
#define		RECREQ_C1MCTL15		c1mctl15_addr.bit.recreq
#define		TRMREQ_C1MCTL15		c1mctl15_addr.bit.trmreq

/*------------------------------------------------------
	CAN Slot Buffer Select Register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	sbs00:1;
		UINT8	sbs01:1;
		UINT8	sbs02:1;
		UINT8	sbs03:1;
		UINT8	sbs10:1;
		UINT8	sbs11:1;
		UINT8	sbs12:1;
		UINT8	sbs13:1;
	} bit;
	UINT8	byte;
} CSBS_TYPE;

/*------------------------------------------------------
	CAN0 Slot Buffer Select Register
------------------------------------------------------*/
#pragma ADDRESS		c0sbs_addr		0240H	/* CAN0Xbgobt@IWX^	*/
CSBS_TYPE	c0sbs_addr;

#define		C0SBS			c0sbs_addr.byte
#define		SBS00_C0SBS		c0sbs_addr.bit.sbs00
#define		SBS01_C0SBS		c0sbs_addr.bit.sbs01
#define		SBS02_C0SBS		c0sbs_addr.bit.sbs02
#define		SBS03_C0SBS		c0sbs_addr.bit.sbs03
#define		SBS10_C0SBS		c0sbs_addr.bit.sbs10
#define		SBS11_C0SBS		c0sbs_addr.bit.sbs11
#define		SBS12_C0SBS		c0sbs_addr.bit.sbs12
#define		SBS13_C0SBS		c0sbs_addr.bit.sbs13

/*------------------------------------------------------
	CAN1 Slot Buffer Select Register
------------------------------------------------------*/
#pragma ADDRESS		c1sbs_addr		0250H	/* CAN1Xbgobt@IWX^	*/
CSBS_TYPE	c1sbs_addr;

#define		C1SBS			c1sbs_addr.byte
#define		SBS00_C1SBS		c1sbs_addr.bit.sbs00
#define		SBS01_C1SBS		c1sbs_addr.bit.sbs01
#define		SBS02_C1SBS		c1sbs_addr.bit.sbs02
#define		SBS03_C1SBS		c1sbs_addr.bit.sbs03
#define		SBS10_C1SBS		c1sbs_addr.bit.sbs10
#define		SBS11_C1SBS		c1sbs_addr.bit.sbs11
#define		SBS12_C1SBS		c1sbs_addr.bit.sbs12
#define		SBS13_C1SBS		c1sbs_addr.bit.sbs13

/*------------------------------------------------------
	CAN0 Message Slot Buffer
------------------------------------------------------*/
typedef union {
	struct{
		union {
			struct{
				UINT8	sid6:1;
				UINT8	sid7:1;
				UINT8	sid8:1;
				UINT8	sid9:1;
				UINT8	sid10:1;
				UINT8	no_assign:3;	/*    s ޏꍇ0			*/
			} bit;
			UINT8	byte;                   /* Standard-ID register [10:6] */
		} sidh;
		union {
			struct{
				UINT8	sid0:1;
				UINT8	sid1:1;
				UINT8	sid2:1;
				UINT8	sid3:1;
				UINT8	sid4:1;
				UINT8	sid5:1;
				UINT8	no_assign:2;	/*    s ޏꍇ0			*/
			} bit;
			UINT8	byte;                   /* Standard-ID register [5:0] */
		} sidl;
		union {
			struct{
				UINT8	eid14:1;
				UINT8	eid15:1;
				UINT8	eid16:1;
				UINT8	eid17:1;
				UINT8	no_assign:4;	/*    s ޏꍇ0			*/
			} bit;
			UINT8	byte;                   /* Extended-ID register [17:14] */
		} eidh;
		union {
			struct{
				UINT8	eid6:1;
				UINT8	eid7:1;
				UINT8	eid8:1;
				UINT8	eid9:1;
				UINT8	eid10:1;
				UINT8	eid11:1;
				UINT8	eid12:1;
				UINT8	eid13:1;
			} bit;
			UINT8	byte;                   /* Extended-ID register [13:6] */
		} eidm;
		union {
			struct{
				UINT8	eid0:1;
				UINT8	eid1:1;
				UINT8	eid2:1;
				UINT8	eid3:1;
				UINT8	eid4:1;
				UINT8	eid5:1;
				UINT8	no_assign:2;	/*    s ޏꍇ0			*/
			} bit;
			UINT8	byte;                   /* Extended-ID register [5:0] */
		} eidl;
		union {
			struct{
				UINT8	dlc0:1;
				UINT8	dlc1:1;
				UINT8	dlc2:1;
				UINT8	dlc3:1;
				UINT8	no_assign:4;	/*    s ޏꍇ0			*/
			} bit;
			UINT8	byte;                    /* Data length code */
		} dlc;
		UINT8	data[8];                /* Data(8byte) */
		UINT8	tsh;                    /* Time stamp register(High) */
		UINT8	tsl;                    /* Time stamp register(Low) */
	} mnb;
	UINT8	slot[16];
} CSLOT_TYPE;

/*------------------------------------------------------
	CAN0 Message Slot Buffer 0
------------------------------------------------------*/
#pragma ADDRESS		c0slot0_addr	01e0H	/* CAN0bZ[WXbgobt@0	*/
CSLOT_TYPE	c0slot0_addr;

/* CAN0bZ[WXbgobt@0擪f[^			*/
#define		C0SLOT0			c0slot0_addr.slot[0]
/* CAN0bZ[WXbgobt@0WID0				*/
#define		SIDH_C0SLOT0	c0slot0_addr.mnb.sidh.byte
#define		SID6_C0SLOT0	c0slot0_addr.mnb.sidh.bit.sid6
#define		SID7_C0SLOT0	c0slot0_addr.mnb.sidh.bit.sid7
#define		SID8_C0SLOT0	c0slot0_addr.mnb.sidh.bit.sid8
#define		SID9_C0SLOT0	c0slot0_addr.mnb.sidh.bit.sid9
#define		SID10_C0SLOT0	c0slot0_addr.mnb.sidh.bit.sid10
/* CAN0bZ[WXbgobt@0WID1				*/
#define		SIDL_C0SLOT0	c0slot0_addr.mnb.sidl.byte
#define		SID0_C0SLOT0	c0slot0_addr.mnb.sidl.bit.sid0
#define		SID1_C0SLOT0	c0slot0_addr.mnb.sidl.bit.sid1
#define		SID2_C0SLOT0	c0slot0_addr.mnb.sidl.bit.sid2
#define		SID3_C0SLOT0	c0slot0_addr.mnb.sidl.bit.sid3
#define		SID4_C0SLOT0	c0slot0_addr.mnb.sidl.bit.sid4
#define		SID5_C0SLOT0	c0slot0_addr.mnb.sidl.bit.sid5
/* CAN0bZ[WXbgobt@0gID0				*/
#define		EIDH_C0SLOT0	c0slot0_addr.mnb.eidh.byte
#define		EID14_C0SLOT0	c0slot0_addr.mnb.eidh.bit.eid14
#define		EID15_C0SLOT0	c0slot0_addr.mnb.eidh.bit.eid15
#define		EID16_C0SLOT0	c0slot0_addr.mnb.eidh.bit.eid16
#define		EID17_C0SLOT0	c0slot0_addr.mnb.eidh.bit.eid17
/* CAN0bZ[WXbgobt@0gID1				*/
#define		EIDM_C0SLOT0	c0slot0_addr.mnb.eidm.byte
#define		EID6_C0SLOT0	c0slot0_addr.mnb.eidm.bit.eid6
#define		EID7_C0SLOT0	c0slot0_addr.mnb.eidm.bit.eid7
#define		EID8_C0SLOT0	c0slot0_addr.mnb.eidm.bit.eid8
#define		EID9_C0SLOT0	c0slot0_addr.mnb.eidm.bit.eid9
#define		EID10_C0SLOT0	c0slot0_addr.mnb.eidm.bit.eid10
#define		EID11_C0SLOT0	c0slot0_addr.mnb.eidm.bit.eid11
#define		EID12_C0SLOT0	c0slot0_addr.mnb.eidm.bit.eid12
#define		EID13_C0SLOT0	c0slot0_addr.mnb.eidm.bit.eid13
/* CAN0bZ[WXbgobt@0gID2				*/
#define		EIDL_C0SLOT0	c0slot0_addr.mnb.eidl.byte
#define		EID0_C0SLOT0	c0slot0_addr.mnb.eidl.bit.eid0
#define		EID1_C0SLOT0	c0slot0_addr.mnb.eidl.bit.eid1
#define		EID2_C0SLOT0	c0slot0_addr.mnb.eidl.bit.eid2
#define		EID3_C0SLOT0	c0slot0_addr.mnb.eidl.bit.eid3
#define		EID4_C0SLOT0	c0slot0_addr.mnb.eidl.bit.eid4
#define		EID5_C0SLOT0	c0slot0_addr.mnb.eidl.bit.eid5
/* CAN0bZ[WXbgobt@0f[^R[h		*/
#define		DLC_C0SLOT0		c0slot0_addr.mnb.dlc.byte
#define		DLC0_C0SLOT0	c0slot0_addr.mnb.dlc.bit.dlc0
#define		DLC1_C0SLOT0	c0slot0_addr.mnb.dlc.bit.dlc1
#define		DLC2_C0SLOT0	c0slot0_addr.mnb.dlc.bit.dlc2
#define		DLC3_C0SLOT0	c0slot0_addr.mnb.dlc.bit.dlc3
/* CAN0bZ[WXbgobt@0f[^0`7			*/
#define		DATA0_C0SLOT0	c0slot0_addr.mnb.data[0]
#define		DATA1_C0SLOT0	c0slot0_addr.mnb.data[1]
#define		DATA2_C0SLOT0	c0slot0_addr.mnb.data[2]
#define		DATA3_C0SLOT0	c0slot0_addr.mnb.data[3]
#define		DATA4_C0SLOT0	c0slot0_addr.mnb.data[4]
#define		DATA5_C0SLOT0	c0slot0_addr.mnb.data[5]
#define		DATA6_C0SLOT0	c0slot0_addr.mnb.data[6]
#define		DATA7_C0SLOT0	c0slot0_addr.mnb.data[7]
/* CAN0bZ[WXbgobt@0^CX^v	*/
#define		TSH_C0SLOT0		c0slot0_addr.mnb.tsh
/* CAN0bZ[WXbgobt@0^CX^v	*/
#define		TSL_C0SLOT0		c0slot0_addr.mnb.tsl

/*------------------------------------------------------
	CAN0 Message Slot Buffer 1
------------------------------------------------------*/
#pragma ADDRESS		c0slot1_addr	01f0H	/* CAN0bZ[WXbgobt@1	*/
CSLOT_TYPE	c0slot1_addr;

/* CAN0bZ[WXbgobt@1擪f[^			*/
#define		C0SLOT1			c0slot1_addr.slot[0]
/* CAN0bZ[WXbgobt@1WID0				*/
#define		SIDH_C0SLOT1	c0slot1_addr.mnb.sidh.byte
#define		SID6_C0SLOT1	c0slot1_addr.mnb.sidh.bit.sid6
#define		SID7_C0SLOT1	c0slot1_addr.mnb.sidh.bit.sid7
#define		SID8_C0SLOT1	c0slot1_addr.mnb.sidh.bit.sid8
#define		SID9_C0SLOT1	c0slot1_addr.mnb.sidh.bit.sid9
#define		SID10_C0SLOT1	c0slot1_addr.mnb.sidh.bit.sid10
/* CAN0bZ[WXbgobt@1WID1				*/
#define		SIDL_C0SLOT1	c0slot1_addr.mnb.sidl.byte
#define		SID0_C0SLOT1	c0slot1_addr.mnb.sidl.bit.sid0
#define		SID1_C0SLOT1	c0slot1_addr.mnb.sidl.bit.sid1
#define		SID2_C0SLOT1	c0slot1_addr.mnb.sidl.bit.sid2
#define		SID3_C0SLOT1	c0slot1_addr.mnb.sidl.bit.sid3
#define		SID4_C0SLOT1	c0slot1_addr.mnb.sidl.bit.sid4
#define		SID5_C0SLOT1	c0slot1_addr.mnb.sidl.bit.sid5
/* CAN0bZ[WXbgobt@1gID0				*/
#define		EIDH_C0SLOT1	c0slot1_addr.mnb.eidh.byte
#define		EID14_C0SLOT1	c0slot1_addr.mnb.eidh.bit.eid14
#define		EID15_C0SLOT1	c0slot1_addr.mnb.eidh.bit.eid15
#define		EID16_C0SLOT1	c0slot1_addr.mnb.eidh.bit.eid16
#define		EID17_C0SLOT1	c0slot1_addr.mnb.eidh.bit.eid17
/* CAN0bZ[WXbgobt@1gID1				*/
#define		EIDM_C0SLOT1	c0slot1_addr.mnb.eidm.byte
#define		EID6_C0SLOT1	c0slot1_addr.mnb.eidm.bit.eid6
#define		EID7_C0SLOT1	c0slot1_addr.mnb.eidm.bit.eid7
#define		EID8_C0SLOT1	c0slot1_addr.mnb.eidm.bit.eid8
#define		EID9_C0SLOT1	c0slot1_addr.mnb.eidm.bit.eid9
#define		EID10_C0SLOT1	c0slot1_addr.mnb.eidm.bit.eid10
#define		EID11_C0SLOT1	c0slot1_addr.mnb.eidm.bit.eid11
#define		EID12_C0SLOT1	c0slot1_addr.mnb.eidm.bit.eid12
#define		EID13_C0SLOT1	c0slot1_addr.mnb.eidm.bit.eid13
/* CAN0bZ[WXbgobt@1gID2				*/
#define		EIDL_C0SLOT1	c0slot1_addr.mnb.eidl.byte
#define		EID0_C0SLOT1	c0slot1_addr.mnb.eidl.bit.eid0
#define		EID1_C0SLOT1	c0slot1_addr.mnb.eidl.bit.eid1
#define		EID2_C0SLOT1	c0slot1_addr.mnb.eidl.bit.eid2
#define		EID3_C0SLOT1	c0slot1_addr.mnb.eidl.bit.eid3
#define		EID4_C0SLOT1	c0slot1_addr.mnb.eidl.bit.eid4
#define		EID5_C0SLOT1	c0slot1_addr.mnb.eidl.bit.eid5
/* CAN0bZ[WXbgobt@1f[^R[h		*/
#define		DLC_C0SLOT1		c0slot1_addr.mnb.dlc.byte
#define		DLC0_C0SLOT1	c0slot1_addr.mnb.dlc.bit.dlc0
#define		DLC1_C0SLOT1	c0slot1_addr.mnb.dlc.bit.dlc1
#define		DLC2_C0SLOT1	c0slot1_addr.mnb.dlc.bit.dlc2
#define		DLC3_C0SLOT1	c0slot1_addr.mnb.dlc.bit.dlc3
/* CAN0bZ[WXbgobt@1f[^0`7			*/
#define		DATA0_C0SLOT1	c0slot1_addr.mnb.data[0]
#define		DATA1_C0SLOT1	c0slot1_addr.mnb.data[1]
#define		DATA2_C0SLOT1	c0slot1_addr.mnb.data[2]
#define		DATA3_C0SLOT1	c0slot1_addr.mnb.data[3]
#define		DATA4_C0SLOT1	c0slot1_addr.mnb.data[4]
#define		DATA5_C0SLOT1	c0slot1_addr.mnb.data[5]
#define		DATA6_C0SLOT1	c0slot1_addr.mnb.data[6]
#define		DATA7_C0SLOT1	c0slot1_addr.mnb.data[7]
/* CAN0bZ[WXbgobt@1^CX^v	*/
#define		TSH_C0SLOT1		c0slot1_addr.mnb.tsh
/* CAN0bZ[WXbgobt@1^CX^v	*/
#define		TSL_C0SLOT1		c0slot1_addr.mnb.tsl

/*------------------------------------------------------
	CAN1 Message Slot Buffer 0
------------------------------------------------------*/
#pragma ADDRESS		c1slot0_addr	0260H	/* CAN1bZ[WXbgobt@0	*/
CSLOT_TYPE	c1slot0_addr;

/* CAN1bZ[WXbgobt@0擪f[^			*/
#define		C1SLOT0			c1slot0_addr.slot[0]
/* CAN1bZ[WXbgobt@0WID0				*/
#define		SIDH_C1SLOT0	c1slot0_addr.mnb.sidh.byte
#define		SID6_C1SLOT0	c1slot0_addr.mnb.sidh.bit.sid6
#define		SID7_C1SLOT0	c1slot0_addr.mnb.sidh.bit.sid7
#define		SID8_C1SLOT0	c1slot0_addr.mnb.sidh.bit.sid8
#define		SID9_C1SLOT0	c1slot0_addr.mnb.sidh.bit.sid9
#define		SID10_C1SLOT0	c1slot0_addr.mnb.sidh.bit.sid10
/* CAN1bZ[WXbgobt@0WID1				*/
#define		SIDL_C1SLOT0	c1slot0_addr.mnb.sidl.byte
#define		SID0_C1SLOT0	c1slot0_addr.mnb.sidl.bit.sid0
#define		SID1_C1SLOT0	c1slot0_addr.mnb.sidl.bit.sid1
#define		SID2_C1SLOT0	c1slot0_addr.mnb.sidl.bit.sid2
#define		SID3_C1SLOT0	c1slot0_addr.mnb.sidl.bit.sid3
#define		SID4_C1SLOT0	c1slot0_addr.mnb.sidl.bit.sid4
#define		SID5_C1SLOT0	c1slot0_addr.mnb.sidl.bit.sid5
/* CAN1bZ[WXbgobt@0gID0				*/
#define		EIDH_C1SLOT0	c1slot0_addr.mnb.eidh.byte
#define		EID14_C1SLOT0	c1slot0_addr.mnb.eidh.bit.eid14
#define		EID15_C1SLOT0	c1slot0_addr.mnb.eidh.bit.eid15
#define		EID16_C1SLOT0	c1slot0_addr.mnb.eidh.bit.eid16
#define		EID17_C1SLOT0	c0slot0_addr.mnb.eidh.bit.eid17
/* CAN1bZ[WXbgobt@0gID1				*/
#define		EIDM_C1SLOT0	c1slot0_addr.mnb.eidm.byte
#define		EID6_C1SLOT0	c1slot0_addr.mnb.eidm.bit.eid6
#define		EID7_C1SLOT0	c1slot0_addr.mnb.eidm.bit.eid7
#define		EID8_C1SLOT0	c1slot0_addr.mnb.eidm.bit.eid8
#define		EID9_C1SLOT0	c1slot0_addr.mnb.eidm.bit.eid9
#define		EID10_C1SLOT0	c1slot0_addr.mnb.eidm.bit.eid10
#define		EID11_C1SLOT0	c1slot0_addr.mnb.eidm.bit.eid11
#define		EID12_C1SLOT0	c1slot0_addr.mnb.eidm.bit.eid12
#define		EID13_C1SLOT0	c1slot0_addr.mnb.eidm.bit.eid13
/* CAN1bZ[WXbgobt@0gID2				*/
#define		EIDL_C1SLOT0	c1slot0_addr.mnb.eidl.byte
#define		EID0_C1SLOT0	c1slot0_addr.mnb.eidl.bit.eid0
#define		EID1_C1SLOT0	c1slot0_addr.mnb.eidl.bit.eid1
#define		EID2_C1SLOT0	c1slot0_addr.mnb.eidl.bit.eid2
#define		EID3_C1SLOT0	c1slot0_addr.mnb.eidl.bit.eid3
#define		EID4_C1SLOT0	c1slot0_addr.mnb.eidl.bit.eid4
#define		EID5_C1SLOT0	c1slot0_addr.mnb.eidl.bit.eid5
/* CAN1bZ[WXbgobt@0f[^R[h		*/
#define		DLC_C1SLOT0		c1slot0_addr.mnb.dlc.byte
#define		DLC0_C1SLOT0	c1slot0_addr.mnb.dlc.bit.dlc0
#define		DLC1_C1SLOT0	c1slot0_addr.mnb.dlc.bit.dlc1
#define		DLC2_C1SLOT0	c1slot0_addr.mnb.dlc.bit.dlc2
#define		DLC3_C1SLOT0	c1slot0_addr.mnb.dlc.bit.dlc3
/* CAN1bZ[WXbgobt@0f[^0`7			*/
#define		DATA0_C1SLOT0	c1slot0_addr.mnb.data[0]
#define		DATA1_C1SLOT0	c1slot0_addr.mnb.data[1]
#define		DATA2_C1SLOT0	c1slot0_addr.mnb.data[2]
#define		DATA3_C1SLOT0	c1slot0_addr.mnb.data[3]
#define		DATA4_C1SLOT0	c1slot0_addr.mnb.data[4]
#define		DATA5_C1SLOT0	c1slot0_addr.mnb.data[5]
#define		DATA6_C1SLOT0	c1slot0_addr.mnb.data[6]
#define		DATA7_C1SLOT0	c1slot0_addr.mnb.data[7]
/* CAN1bZ[WXbgobt@0^CX^v	*/
#define		TSH_C1SLOT0		c1slot0_addr.mnb.tsh
/* CAN1bZ[WXbgobt@0^CX^v	*/
#define		TSL_C1SLOT0		c1slot0_addr.mnb.tsl

/*------------------------------------------------------
	CAN1 Message Slot Buffer 1
------------------------------------------------------*/
#pragma ADDRESS		c1slot1_addr	0270H	/* CAN1bZ[WXbgobt@1	*/
CSLOT_TYPE	c1slot1_addr;

/* CAN1bZ[WXbgobt@1擪f[^			*/
#define		C1SLOT1			c1slot1_addr.slot[0]
/* CAN1bZ[WXbgobt@1WID0				*/
#define		SIDH_C1SLOT1	c1slot1_addr.mnb.sidh.byte
#define		SID6_C1SLOT1	c1slot1_addr.mnb.sidh.bit.sid6
#define		SID7_C1SLOT1	c1slot1_addr.mnb.sidh.bit.sid7
#define		SID8_C1SLOT1	c1slot1_addr.mnb.sidh.bit.sid8
#define		SID9_C1SLOT1	c1slot1_addr.mnb.sidh.bit.sid9
#define		SID10_C1SLOT1	c1slot1_addr.mnb.sidh.bit.sid10
/* CAN1bZ[WXbgobt@1WID1				*/
#define		SIDL_C1SLOT1	c1slot1_addr.mnb.sidl.byte
#define		SID0_C1SLOT1	c1slot1_addr.mnb.sidl.bit.sid0
#define		SID1_C1SLOT1	c1slot1_addr.mnb.sidl.bit.sid1
#define		SID2_C1SLOT1	c1slot1_addr.mnb.sidl.bit.sid2
#define		SID3_C1SLOT1	c1slot1_addr.mnb.sidl.bit.sid3
#define		SID4_C1SLOT1	c1slot1_addr.mnb.sidl.bit.sid4
#define		SID5_C1SLOT1	c1slot1_addr.mnb.sidl.bit.sid5
/* CAN1bZ[WXbgobt@1gID0				*/
#define		EIDH_C1SLOT1	c1slot1_addr.mnb.eidh.byte
#define		EID14_C1SLOT1	c1slot1_addr.mnb.eidh.bit.eid14
#define		EID15_C1SLOT1	c1slot1_addr.mnb.eidh.bit.eid15
#define		EID16_C1SLOT1	c1slot1_addr.mnb.eidh.bit.eid16
#define		EID17_C1SLOT1	c1slot1_addr.mnb.eidh.bit.eid17
/* CAN1bZ[WXbgobt@1gID1				*/
#define		EIDM_C1SLOT1	c1slot1_addr.mnb.eidm.byte
#define		EID6_C1SLOT1	c1slot1_addr.mnb.eidm.bit.eid6
#define		EID7_C1SLOT1	c1slot1_addr.mnb.eidm.bit.eid7
#define		EID8_C1SLOT1	c1slot1_addr.mnb.eidm.bit.eid8
#define		EID9_C1SLOT1	c1slot1_addr.mnb.eidm.bit.eid9
#define		EID10_C1SLOT1	c1slot1_addr.mnb.eidm.bit.eid10
#define		EID11_C1SLOT1	c1slot1_addr.mnb.eidm.bit.eid11
#define		EID12_C1SLOT1	c1slot1_addr.mnb.eidm.bit.eid12
#define		EID13_C1SLOT1	c1slot1_addr.mnb.eidm.bit.eid13
/* CAN1bZ[WXbgobt@1gID2				*/
#define		EIDL_C1SLOT1	c1slot1_addr.mnb.eidl.byte
#define		EID0_C1SLOT1	c1slot1_addr.mnb.eidl.bit.eid0
#define		EID1_C1SLOT1	c1slot1_addr.mnb.eidl.bit.eid1
#define		EID2_C1SLOT1	c1slot1_addr.mnb.eidl.bit.eid2
#define		EID3_C1SLOT1	c1slot1_addr.mnb.eidl.bit.eid3
#define		EID4_C1SLOT1	c1slot1_addr.mnb.eidl.bit.eid4
#define		EID5_C1SLOT1	c1slot1_addr.mnb.eidl.bit.eid5
/* CAN1bZ[WXbgobt@1f[^R[h		*/
#define		DLC_C1SLOT1		c1slot1_addr.mnb.dlc.byte
#define		DLC0_C1SLOT1	c1slot1_addr.mnb.dlc.bit.dlc0
#define		DLC1_C1SLOT1	c1slot1_addr.mnb.dlc.bit.dlc1
#define		DLC2_C1SLOT1	c1slot1_addr.mnb.dlc.bit.dlc2
#define		DLC3_C1SLOT1	c1slot1_addr.mnb.dlc.bit.dlc3
/* CAN1bZ[WXbgobt@1f[^0`7			*/
#define		DATA0_C1SLOT1	c1slot1_addr.mnb.data[0]
#define		DATA1_C1SLOT1	c1slot1_addr.mnb.data[1]
#define		DATA2_C1SLOT1	c1slot1_addr.mnb.data[2]
#define		DATA3_C1SLOT1	c1slot1_addr.mnb.data[3]
#define		DATA4_C1SLOT1	c1slot1_addr.mnb.data[4]
#define		DATA5_C1SLOT1	c1slot1_addr.mnb.data[5]
#define		DATA6_C1SLOT1	c1slot1_addr.mnb.data[6]
#define		DATA7_C1SLOT1	c1slot1_addr.mnb.data[7]
/* CAN1bZ[WXbgobt@1^CX^v	*/
#define		TSH_C1SLOT1		c1slot1_addr.mnb.tsh
/* CAN1bZ[WXbgobt@1^CX^v	*/
#define		TSL_C1SLOT1		c1slot1_addr.mnb.tsl

/*------------------------------------------------------
	CAN Acceptance Filter Support Register
------------------------------------------------------*/
typedef union {
	struct{
		UINT8	low;                /* Low  8 bit */
		UINT8	high;               /* High 8 bit */
	} byte;
	UINT16	word;
} CAFS_TYPE;

/*------------------------------------------------------
	CAN0 Acceptance Filter Support Register
------------------------------------------------------*/
#pragma ADDRESS		c0afs_addr		0244H	/* CAN0ANZv^XtB^T|[gWX^	*/
CAFS_TYPE	c0afs_addr;

#define		C0AFS		c0afs_addr.word
#define		C0AFSL		c0afs_addr.byte.low
#define		C0AFSH		c0afs_addr.byte.high

/*------------------------------------------------------
	CAN1 Acceptance Filter Support Register
------------------------------------------------------*/
#pragma ADDRESS		c1afs_addr		0254H	/* CAN1ANZv^XtB^T|[gWX^	*/
CAFS_TYPE	c1afs_addr;

#define		C1AFS		c1afs_addr.word
#define		C1AFSL		c1afs_addr.byte.low
#define		C1AFSH		c1afs_addr.byte.high

/********************************************************/
/* vO}uo̓|[g							*/
/********************************************************/
/*------------------------------------------------------
	Port P0 direction register
------------------------------------------------------*/
#pragma ADDRESS		pd0_addr	03e2H	/* |[gP0WX^				*/
typedef union {
	struct{
		UINT8	pd0_0:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd0_1:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd0_2:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd0_3:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd0_4:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd0_5:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd0_6:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd0_7:1;	/* RW [q@\()I 0B:/1B:o		*/
	} bit;
	UINT8	byte;
} PD0_TYPE;
PD0_TYPE	pd0_addr;

#define		PD0			pd0_addr.byte
#define		PD0_0		pd0_addr.bit.pd0_0
#define		PD0_1		pd0_addr.bit.pd0_1
#define		PD0_2		pd0_addr.bit.pd0_2
#define		PD0_3		pd0_addr.bit.pd0_3
#define		PD0_4		pd0_addr.bit.pd0_4
#define		PD0_5		pd0_addr.bit.pd0_5
#define		PD0_6		pd0_addr.bit.pd0_6
#define		PD0_7		pd0_addr.bit.pd0_7

/*------------------------------------------------------
	Port P1 direction register
------------------------------------------------------*/
#pragma ADDRESS		pd1_addr	03e3H	/* |[gP1WX^				*/
typedef union {
	struct{
		UINT8	pd1_0:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd1_1:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd1_2:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd1_3:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd1_4:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd1_5:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd1_6:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd1_7:1;	/* RW [q@\()I 0B:/1B:o		*/
	} bit;
	UINT8	byte;
} PD1_TYPE;
PD1_TYPE	pd1_addr;

#define		PD1			pd1_addr.byte
#define		PD1_0		pd1_addr.bit.pd1_0
#define		PD1_1		pd1_addr.bit.pd1_1
#define		PD1_2		pd1_addr.bit.pd1_2
#define		PD1_3		pd1_addr.bit.pd1_3
#define		PD1_4		pd1_addr.bit.pd1_4
#define		PD1_5		pd1_addr.bit.pd1_5
#define		PD1_6		pd1_addr.bit.pd1_6
#define		PD1_7		pd1_addr.bit.pd1_7

/*------------------------------------------------------
	Port P2 direction register
------------------------------------------------------*/
#pragma ADDRESS		pd2_addr	03e6H	/* |[gP2WX^				*/
typedef union {
	struct{
		UINT8	pd2_0:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd2_1:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd2_2:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd2_3:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd2_4:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd2_5:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd2_6:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd2_7:1;	/* RW [q@\()I 0B:/1B:o		*/
	} bit;
	UINT8	byte;
} PD2_TYPE;
PD2_TYPE	pd2_addr;

#define		PD2			pd2_addr.byte
#define		PD2_0		pd2_addr.bit.pd2_0
#define		PD2_1		pd2_addr.bit.pd2_1
#define		PD2_2		pd2_addr.bit.pd2_2
#define		PD2_3		pd2_addr.bit.pd2_3
#define		PD2_4		pd2_addr.bit.pd2_4
#define		PD2_5		pd2_addr.bit.pd2_5
#define		PD2_6		pd2_addr.bit.pd2_6
#define		PD2_7		pd2_addr.bit.pd2_7

/*------------------------------------------------------
	Port P3 direction register
------------------------------------------------------*/
#pragma ADDRESS		pd3_addr	03e7H	/* |[gP3WX^				*/
typedef union {
	struct{
		UINT8	pd3_0:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd3_1:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd3_2:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd3_3:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd3_4:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd3_5:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd3_6:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd3_7:1;	/* RW [q@\()I 0B:/1B:o		*/
	} bit;
	UINT8	byte;
} PD3_TYPE;
PD3_TYPE	pd3_addr;

#define		PD3			pd3_addr.byte
#define		PD3_0		pd3_addr.bit.pd3_0
#define		PD3_1		pd3_addr.bit.pd3_1
#define		PD3_2		pd3_addr.bit.pd3_2
#define		PD3_3		pd3_addr.bit.pd3_3
#define		PD3_4		pd3_addr.bit.pd3_4
#define		PD3_5		pd3_addr.bit.pd3_5
#define		PD3_6		pd3_addr.bit.pd3_6
#define		PD3_7		pd3_addr.bit.pd3_7

/*------------------------------------------------------
	Port P4 direction register
------------------------------------------------------*/
#pragma ADDRESS		pd4_addr	03eaH	/* |[gP4WX^				*/
typedef union {
	struct{
		UINT8	pd4_0:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd4_1:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd4_2:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd4_3:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd4_4:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd4_5:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd4_6:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd4_7:1;	/* RW [q@\()I 0B:/1B:o		*/
	} bit;
	UINT8	byte;
} PD4_TYPE;
PD4_TYPE	pd4_addr;

#define		PD4			pd4_addr.byte
#define		PD4_0		pd4_addr.bit.pd4_0
#define		PD4_1		pd4_addr.bit.pd4_1
#define		PD4_2		pd4_addr.bit.pd4_2
#define		PD4_3		pd4_addr.bit.pd4_3
#define		PD4_4		pd4_addr.bit.pd4_4
#define		PD4_5		pd4_addr.bit.pd4_5
#define		PD4_6		pd4_addr.bit.pd4_6
#define		PD4_7		pd4_addr.bit.pd4_7

/*------------------------------------------------------
	Port P5 direction register
------------------------------------------------------*/
#pragma ADDRESS		pd5_addr	03ebH	/* |[gP5WX^				*/
typedef union {
	struct{
		UINT8	pd5_0:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd5_1:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd5_2:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd5_3:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd5_4:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd5_5:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd5_6:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd5_7:1;	/* RW [q@\()I 0B:/1B:o		*/
	} bit;
	UINT8	byte;
} PD5_TYPE;
PD5_TYPE	pd5_addr;

#define		PD5			pd5_addr.byte
#define		PD5_0		pd5_addr.bit.pd5_0
#define		PD5_1		pd5_addr.bit.pd5_1
#define		PD5_2		pd5_addr.bit.pd5_2
#define		PD5_3		pd5_addr.bit.pd5_3
#define		PD5_4		pd5_addr.bit.pd5_4
#define		PD5_5		pd5_addr.bit.pd5_5
#define		PD5_6		pd5_addr.bit.pd5_6
#define		PD5_7		pd5_addr.bit.pd5_7

/*------------------------------------------------------
	Port P6 direction register
------------------------------------------------------*/
#pragma ADDRESS		pd6_addr	03c2H	/* |[gP6WX^				*/
typedef union {
	struct{
		UINT8	pd6_0:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd6_1:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd6_2:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd6_3:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd6_4:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd6_5:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd6_6:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd6_7:1;	/* RW [q@\()I 0B:/1B:o		*/
	} bit;
	UINT8	byte;
} PD6_TYPE;
PD6_TYPE	pd6_addr;

#define		PD6			pd6_addr.byte
#define		PD6_0		pd6_addr.bit.pd6_0
#define		PD6_1		pd6_addr.bit.pd6_1
#define		PD6_2		pd6_addr.bit.pd6_2
#define		PD6_3		pd6_addr.bit.pd6_3
#define		PD6_4		pd6_addr.bit.pd6_4
#define		PD6_5		pd6_addr.bit.pd6_5
#define		PD6_6		pd6_addr.bit.pd6_6
#define		PD6_7		pd6_addr.bit.pd6_7

/*------------------------------------------------------
	Port P7 direction register
------------------------------------------------------*/
#pragma ADDRESS		pd7_addr	03c3H	/* |[gP7WX^				*/
typedef union {
	struct{
		UINT8	pd7_0:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd7_1:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd7_2:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd7_3:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd7_4:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd7_5:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd7_6:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd7_7:1;	/* RW [q@\()I 0B:/1B:o		*/
	} bit;
	UINT8	byte;
} PD7_TYPE;
PD7_TYPE	pd7_addr;

#define		PD7			pd7_addr.byte
#define		PD7_0		pd7_addr.bit.pd7_0
#define		PD7_1		pd7_addr.bit.pd7_1
#define		PD7_2		pd7_addr.bit.pd7_2
#define		PD7_3		pd7_addr.bit.pd7_3
#define		PD7_4		pd7_addr.bit.pd7_4
#define		PD7_5		pd7_addr.bit.pd7_5
#define		PD7_6		pd7_addr.bit.pd7_6
#define		PD7_7		pd7_addr.bit.pd7_7

/*------------------------------------------------------
	Port P8 direction register
------------------------------------------------------*/
#pragma ADDRESS		pd8_addr	03c6H	/* |[gP8WX^				*/
typedef union {
	struct{
		UINT8	pd8_0:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd8_1:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd8_2:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd8_3:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd8_4:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	pd8_6:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd8_7:1;	/* RW [q@\()I 0B:/1B:o		*/
	} bit;
	UINT8	byte;
} PD8_TYPE;
PD8_TYPE	pd8_addr;

#define		PD8			pd8_addr.byte
#define		PD8_0		pd8_addr.bit.pd8_0
#define		PD8_1		pd8_addr.bit.pd8_1
#define		PD8_2		pd8_addr.bit.pd8_2
#define		PD8_3		pd8_addr.bit.pd8_3
#define		PD8_4		pd8_addr.bit.pd8_4
#define		PD8_6		pd8_addr.bit.pd8_6
#define		PD8_7		pd8_addr.bit.pd8_7

/*------------------------------------------------------
	Port P9 direction register
------------------------------------------------------*/
#pragma ADDRESS		pd9_addr	03c7H	/* |[gP9WX^				*/
typedef union {
	struct{
		UINT8	pd9_0:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd9_1:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd9_2:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd9_3:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd9_4:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd9_5:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd9_6:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd9_7:1;	/* RW [q@\()I 0B:/1B:o		*/
	} bit;
	UINT8	byte;
} PD9_TYPE;
PD9_TYPE	pd9_addr;

#define		PD9			pd9_addr.byte
#define		PD9_0		pd9_addr.bit.pd9_0
#define		PD9_1		pd9_addr.bit.pd9_1
#define		PD9_2		pd9_addr.bit.pd9_2
#define		PD9_3		pd9_addr.bit.pd9_3
#define		PD9_4		pd9_addr.bit.pd9_4
#define		PD9_5		pd9_addr.bit.pd9_5
#define		PD9_6		pd9_addr.bit.pd9_6
#define		PD9_7		pd9_addr.bit.pd9_7

/*------------------------------------------------------
	Port P10 direction register
------------------------------------------------------*/
#pragma ADDRESS		pd10_addr	03caH	/* |[gP10WX^			*/
typedef union {
	struct{
		UINT8	pd10_0:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd10_1:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd10_2:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd10_3:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd10_4:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd10_5:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd10_6:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd10_7:1;	/* RW [q@\()I 0B:/1B:o		*/
	} bit;
	UINT8	byte;
} PD10_TYPE;
PD10_TYPE	pd10_addr;

#define		PD10		pd10_addr.byte
#define		PD10_0		pd10_addr.bit.pd10_0
#define		PD10_1		pd10_addr.bit.pd10_1
#define		PD10_2		pd10_addr.bit.pd10_2
#define		PD10_3		pd10_addr.bit.pd10_3
#define		PD10_4		pd10_addr.bit.pd10_4
#define		PD10_5		pd10_addr.bit.pd10_5
#define		PD10_6		pd10_addr.bit.pd10_6
#define		PD10_7		pd10_addr.bit.pd10_7

/*------------------------------------------------------
	Port P11 direction register
------------------------------------------------------*/
#pragma ADDRESS		pd11_addr	03cbH	/* |[gP11WX^			*/
typedef union {
	struct{
		UINT8	pd11_0:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd11_1:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd11_2:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd11_3:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd11_4:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	no_assign:3;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} PD11_TYPE;
PD11_TYPE	pd11_addr;

#define		PD11		pd11_addr.byte
#define		PD11_0		pd11_addr.bit.pd11_0
#define		PD11_1		pd11_addr.bit.pd11_1
#define		PD11_2		pd11_addr.bit.pd11_2
#define		PD11_3		pd11_addr.bit.pd11_3
#define		PD11_4		pd11_addr.bit.pd11_4

/*------------------------------------------------------
	Port P12 direction register
------------------------------------------------------*/
#pragma ADDRESS		pd12_addr	03ceH	/* |[gP12WX^			*/
typedef union {
	struct{
		UINT8	pd12_0:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd12_1:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd12_2:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd12_3:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd12_4:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd12_5:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd12_6:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd12_7:1;	/* RW [q@\()I 0B:/1B:o		*/
	} bit;
	UINT8	byte;
} PD12_TYPE;
PD12_TYPE	pd12_addr;

#define		PD12		pd12_addr.byte
#define		PD12_0		pd12_addr.bit.pd12_0
#define		PD12_1		pd12_addr.bit.pd12_1
#define		PD12_2		pd12_addr.bit.pd12_2
#define		PD12_3		pd12_addr.bit.pd12_3
#define		PD12_4		pd12_addr.bit.pd12_4
#define		PD12_5		pd12_addr.bit.pd12_5
#define		PD12_6		pd12_addr.bit.pd12_6
#define		PD12_7		pd12_addr.bit.pd12_7

/*------------------------------------------------------
	Port P13 direction register
------------------------------------------------------*/
#pragma ADDRESS		pd13_addr	03cfH	/* |[gP13WX^			*/
typedef union {
	struct{
		UINT8	pd13_0:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd13_1:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd13_2:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd13_3:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd13_4:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd13_5:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd13_6:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd13_7:1;	/* RW [q@\()I 0B:/1B:o		*/
	} bit;
	UINT8	byte;
} PD13_TYPE;
PD13_TYPE	pd13_addr;

#define		PD13		pd13_addr.byte
#define		PD13_0		pd13_addr.bit.pd13_0
#define		PD13_1		pd13_addr.bit.pd13_1
#define		PD13_2		pd13_addr.bit.pd13_2
#define		PD13_3		pd13_addr.bit.pd13_3
#define		PD13_4		pd13_addr.bit.pd13_4
#define		PD13_5		pd13_addr.bit.pd13_5
#define		PD13_6		pd13_addr.bit.pd13_6
#define		PD13_7		pd13_addr.bit.pd13_7

/*------------------------------------------------------
	Port P14 direction register
------------------------------------------------------*/
#pragma ADDRESS		pd14_addr	03d2H	/* |[gP14WX^			*/
typedef union {
	struct{
		UINT8	pd14_0:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd14_1:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd14_2:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd14_3:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd14_4:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd14_5:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd14_6:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} PD14_TYPE;
PD14_TYPE	pd14_addr;

#define		PD14		pd14_addr.byte
#define		PD14_0		pd14_addr.bit.pd14_0
#define		PD14_1		pd14_addr.bit.pd14_1
#define		PD14_2		pd14_addr.bit.pd14_2
#define		PD14_3		pd14_addr.bit.pd14_3
#define		PD14_4		pd14_addr.bit.pd14_4
#define		PD14_5		pd14_addr.bit.pd14_5
#define		PD14_6		pd14_addr.bit.pd14_6

/*------------------------------------------------------
	Port P15 direction register
------------------------------------------------------*/
#pragma ADDRESS		pd15_addr	03d3H	/* |[gP15WX^			*/
typedef union {
	struct{
		UINT8	pd15_0:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd15_1:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd15_2:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd15_3:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd15_4:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd15_5:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd15_6:1;	/* RW [q@\()I 0B:/1B:o		*/
		UINT8	pd15_7:1;	/* RW [q@\()I 0B:/1B:o		*/
	} bit;
	UINT8	byte;
} PD15_TYPE;
PD15_TYPE	pd15_addr;

#define		PD15		pd15_addr.byte
#define		PD15_0		pd15_addr.bit.pd15_0
#define		PD15_1		pd15_addr.bit.pd15_1
#define		PD15_2		pd15_addr.bit.pd15_2
#define		PD15_3		pd15_addr.bit.pd15_3
#define		PD15_4		pd15_addr.bit.pd15_4
#define		PD15_5		pd15_addr.bit.pd15_5
#define		PD15_6		pd15_addr.bit.pd15_6
#define		PD15_7		pd15_addr.bit.pd15_7

/*------------------------------------------------------
	Port P0 register
------------------------------------------------------*/
#pragma ADDRESS		p0_addr		03e0H	/* |[gP0WX^					*/
typedef union {
	struct{
		UINT8	p0_0:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p0_1:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p0_2:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p0_3:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p0_4:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p0_5:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p0_6:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p0_7:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
	} bit;
	UINT8	byte;
} P0_TYPE;
P0_TYPE		p0_addr;

#define		P0			p0_addr.byte
#define		P0_0		p0_addr.bit.p0_0
#define		P0_1		p0_addr.bit.p0_1
#define		P0_2		p0_addr.bit.p0_2
#define		P0_3		p0_addr.bit.p0_3
#define		P0_4		p0_addr.bit.p0_4
#define		P0_5		p0_addr.bit.p0_5
#define		P0_6		p0_addr.bit.p0_6
#define		P0_7		p0_addr.bit.p0_7

/*------------------------------------------------------
	Port P1 register
------------------------------------------------------*/
#pragma ADDRESS		p1_addr		03e1H	/* |[gP1WX^					*/
typedef union {
	struct{
		UINT8	p1_0:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p1_1:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p1_2:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p1_3:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p1_4:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p1_5:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p1_6:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p1_7:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
	} bit;
	UINT8	byte;
} P1_TYPE;
P1_TYPE		p1_addr;

#define		P1			p1_addr.byte
#define		P1_0		p1_addr.bit.p1_0
#define		P1_1		p1_addr.bit.p1_1
#define		P1_2		p1_addr.bit.p1_2
#define		P1_3		p1_addr.bit.p1_3
#define		P1_4		p1_addr.bit.p1_4
#define		P1_5		p1_addr.bit.p1_5
#define		P1_6		p1_addr.bit.p1_6
#define		P1_7		p1_addr.bit.p1_7

/*------------------------------------------------------
	Port P2 register
------------------------------------------------------*/
#pragma ADDRESS		p2_addr		03e4H	/* |[gP2WX^					*/
typedef union {
	struct{
		UINT8	p2_0:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p2_1:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p2_2:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p2_3:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p2_4:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p2_5:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p2_6:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p2_7:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
	} bit;
	UINT8	byte;
} P2_TYPE;
P2_TYPE		p2_addr;

#define		P2			p2_addr.byte
#define		P2_0		p2_addr.bit.p2_0
#define		P2_1		p2_addr.bit.p2_1
#define		P2_2		p2_addr.bit.p2_2
#define		P2_3		p2_addr.bit.p2_3
#define		P2_4		p2_addr.bit.p2_4
#define		P2_5		p2_addr.bit.p2_5
#define		P2_6		p2_addr.bit.p2_6
#define		P2_7		p2_addr.bit.p2_7

/*------------------------------------------------------
	Port P3 register
------------------------------------------------------*/
#pragma ADDRESS		p3_addr		03e5H	/* |[gP3WX^					*/
typedef union {
	struct{
		UINT8	p3_0:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p3_1:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p3_2:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p3_3:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p3_4:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p3_5:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p3_6:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p3_7:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
	} bit;
	UINT8	byte;
} P3_TYPE;
P3_TYPE		p3_addr;

#define		P3			p3_addr.byte
#define		P3_0		p3_addr.bit.p3_0
#define		P3_1		p3_addr.bit.p3_1
#define		P3_2		p3_addr.bit.p3_2
#define		P3_3		p3_addr.bit.p3_3
#define		P3_4		p3_addr.bit.p3_4
#define		P3_5		p3_addr.bit.p3_5
#define		P3_6		p3_addr.bit.p3_6
#define		P3_7		p3_addr.bit.p3_7

/*------------------------------------------------------
	Port P4 register
------------------------------------------------------*/
#pragma ADDRESS		p4_addr		03e8H	/* |[gP4WX^					*/
typedef union {
	struct{
		UINT8	p4_0:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p4_1:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p4_2:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p4_3:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p4_4:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p4_5:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p4_6:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p4_7:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
	} bit;
	UINT8	byte;
} P4_TYPE;
P4_TYPE		p4_addr;

#define		P4			p4_addr.byte
#define		P4_0		p4_addr.bit.p4_0
#define		P4_1		p4_addr.bit.p4_1
#define		P4_2		p4_addr.bit.p4_2
#define		P4_3		p4_addr.bit.p4_3
#define		P4_4		p4_addr.bit.p4_4
#define		P4_5		p4_addr.bit.p4_5
#define		P4_6		p4_addr.bit.p4_6
#define		P4_7		p4_addr.bit.p4_7

/*------------------------------------------------------
	Port P5 register
------------------------------------------------------*/
#pragma ADDRESS		p5_addr		03e9H	/* |[gP5WX^					*/
typedef union {
	struct{
		UINT8	p5_0:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p5_1:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p5_2:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p5_3:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p5_4:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p5_5:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p5_6:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p5_7:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
	} bit;
	UINT8	byte;
} P5_TYPE;
P5_TYPE		p5_addr;

#define		P5			p5_addr.byte
#define		P5_0		p5_addr.bit.p5_0
#define		P5_1		p5_addr.bit.p5_1
#define		P5_2		p5_addr.bit.p5_2
#define		P5_3		p5_addr.bit.p5_3
#define		P5_4		p5_addr.bit.p5_4
#define		P5_5		p5_addr.bit.p5_5
#define		P5_6		p5_addr.bit.p5_6
#define		P5_7		p5_addr.bit.p5_7

/*------------------------------------------------------
	Port P6 register
------------------------------------------------------*/
#pragma ADDRESS		p6_addr		03c0H	/* |[gP6WX^					*/
typedef union {
	struct{
		UINT8	p6_0:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p6_1:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p6_2:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p6_3:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p6_4:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p6_5:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p6_6:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p6_7:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
	} bit;
	UINT8	byte;
} P6_TYPE;
P6_TYPE		p6_addr;

#define		P6			p6_addr.byte
#define		P6_0		p6_addr.bit.p6_0
#define		P6_1		p6_addr.bit.p6_1
#define		P6_2		p6_addr.bit.p6_2
#define		P6_3		p6_addr.bit.p6_3
#define		P6_4		p6_addr.bit.p6_4
#define		P6_5		p6_addr.bit.p6_5
#define		P6_6		p6_addr.bit.p6_6
#define		P6_7		p6_addr.bit.p6_7

/*------------------------------------------------------
	Port P7 register
------------------------------------------------------*/
#pragma ADDRESS		p7_addr		03c1H	/* |[gP7WX^					*/
typedef union {
	struct{
		UINT8	p7_0:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p7_1:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p7_2:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p7_3:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p7_4:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p7_5:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p7_6:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p7_7:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
	} bit;
	UINT8	byte;
} P7_TYPE;
P7_TYPE		p7_addr;

#define		P7			p7_addr.byte
#define		P7_0		p7_addr.bit.p7_0
#define		P7_1		p7_addr.bit.p7_1
#define		P7_2		p7_addr.bit.p7_2
#define		P7_3		p7_addr.bit.p7_3
#define		P7_4		p7_addr.bit.p7_4
#define		P7_5		p7_addr.bit.p7_5
#define		P7_6		p7_addr.bit.p7_6
#define		P7_7		p7_addr.bit.p7_7

/*------------------------------------------------------
	Port P8 register
------------------------------------------------------*/
#pragma ADDRESS		p8_addr		03c4H	/* |[gP8WX^					*/
typedef union {
	struct{
		UINT8	p8_0:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p8_1:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p8_2:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p8_3:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p8_4:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p8_5:1;		/* RO ͒[q̃x 0B:Low/1B:High			*/
		UINT8	p8_6:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p8_7:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
	} bit;
	UINT8	byte;
} P8_TYPE;
P8_TYPE		p8_addr;

#define		P8			p8_addr.byte
#define		P8_0		p8_addr.bit.p8_0
#define		P8_1		p8_addr.bit.p8_1
#define		P8_2		p8_addr.bit.p8_2
#define		P8_3		p8_addr.bit.p8_3
#define		P8_4		p8_addr.bit.p8_4
#define		P8_5		p8_addr.bit.p8_5
#define		P8_6		p8_addr.bit.p8_6
#define		P8_7		p8_addr.bit.p8_7

/*------------------------------------------------------
	Port P9 register
------------------------------------------------------*/
#pragma ADDRESS		p9_addr		03c5H	/* |[gP9WX^					*/
typedef union {
	struct{
		UINT8	p9_0:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p9_1:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p9_2:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p9_3:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p9_4:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p9_5:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p9_6:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p9_7:1;		/* RW /o͒[q̃x 0B:Low/1B:High		*/
	} bit;
	UINT8	byte;
} P9_TYPE;
P9_TYPE		p9_addr;

#define		P9			p9_addr.byte
#define		P9_0		p9_addr.bit.p9_0
#define		P9_1		p9_addr.bit.p9_1
#define		P9_2		p9_addr.bit.p9_2
#define		P9_3		p9_addr.bit.p9_3
#define		P9_4		p9_addr.bit.p9_4
#define		P9_5		p9_addr.bit.p9_5
#define		P9_6		p9_addr.bit.p9_6
#define		P9_7		p9_addr.bit.p9_7

/*------------------------------------------------------
	Port P10 register
------------------------------------------------------*/
#pragma ADDRESS		p10_addr	03c8H	/* |[gP10WX^				*/
typedef union {
	struct{
		UINT8	p10_0:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p10_1:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p10_2:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p10_3:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p10_4:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p10_5:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p10_6:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p10_7:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
	} bit;
	UINT8	byte;
} P10_TYPE;
P10_TYPE	p10_addr;

#define		P10			p10_addr.byte
#define		P10_0		p10_addr.bit.p10_0
#define		P10_1		p10_addr.bit.p10_1
#define		P10_2		p10_addr.bit.p10_2
#define		P10_3		p10_addr.bit.p10_3
#define		P10_4		p10_addr.bit.p10_4
#define		P10_5		p10_addr.bit.p10_5
#define		P10_6		p10_addr.bit.p10_6
#define		P10_7		p10_addr.bit.p10_7

/*------------------------------------------------------
	Port P11 register
------------------------------------------------------*/
#pragma ADDRESS		p11_addr	03c9H	/* |[gP11WX^				*/
typedef union {
	struct{
		UINT8	p11_0:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p11_1:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p11_2:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p11_3:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p11_4:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	no_assign:3;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} P11_TYPE;
P11_TYPE	p11_addr;

#define		P11			p11_addr.byte
#define		P11_0		p11_addr.bit.p11_0
#define		P11_1		p11_addr.bit.p11_1
#define		P11_2		p11_addr.bit.p11_2
#define		P11_3		p11_addr.bit.p11_3
#define		P11_4		p11_addr.bit.p11_4

/*------------------------------------------------------
	Port P12 register
------------------------------------------------------*/
#pragma ADDRESS		p12_addr	03ccH	/* |[gP12WX^				*/
typedef union {
	struct{
		UINT8	p12_0:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p12_1:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p12_2:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p12_3:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p12_4:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p12_5:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p12_6:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p12_7:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
	} bit;
	UINT8	byte;
} P12_TYPE;
P12_TYPE	p12_addr;

#define		P12			p12_addr.byte
#define		P12_0		p12_addr.bit.p12_0
#define		P12_1		p12_addr.bit.p12_1
#define		P12_2		p12_addr.bit.p12_2
#define		P12_3		p12_addr.bit.p12_3
#define		P12_4		p12_addr.bit.p12_4
#define		P12_5		p12_addr.bit.p12_5
#define		P12_6		p12_addr.bit.p12_6
#define		P12_7		p12_addr.bit.p12_7

/*------------------------------------------------------
	Port P13 register
------------------------------------------------------*/
#pragma ADDRESS		p13_addr	03cdH	/* |[gP13WX^				*/
typedef union {
	struct{
		UINT8	p13_0:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p13_1:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p13_2:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p13_3:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p13_4:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p13_5:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p13_6:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p13_7:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
	} bit;
	UINT8	byte;
} P13_TYPE;
P13_TYPE	p13_addr;

#define		P13			p13_addr.byte
#define		P13_0		p13_addr.bit.p13_0
#define		P13_1		p13_addr.bit.p13_1
#define		P13_2		p13_addr.bit.p13_2
#define		P13_3		p13_addr.bit.p13_3
#define		P13_4		p13_addr.bit.p13_4
#define		P13_5		p13_addr.bit.p13_5
#define		P13_6		p13_addr.bit.p13_6
#define		P13_7		p13_addr.bit.p13_7

/*------------------------------------------------------
	Port P14 register
------------------------------------------------------*/
#pragma ADDRESS		p14_addr	03d0H	/* |[gP14WX^				*/
typedef union {
	struct{
		UINT8	p14_0:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p14_1:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p14_2:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p14_3:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p14_4:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p14_5:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p14_6:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} P14_TYPE;
P14_TYPE	p14_addr;

#define		P14			p14_addr.byte
#define		P14_0		p14_addr.bit.p14_0
#define		P14_1		p14_addr.bit.p14_1
#define		P14_2		p14_addr.bit.p14_2
#define		P14_3		p14_addr.bit.p14_3
#define		P14_4		p14_addr.bit.p14_4
#define		P14_5		p14_addr.bit.p14_5
#define		P14_6		p14_addr.bit.p14_6

/*------------------------------------------------------
	Port P15 register
------------------------------------------------------*/
#pragma ADDRESS		p15_addr	03d1H	/* |[gP15WX^				*/
typedef union {
	struct{
		UINT8	p15_0:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p15_1:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p15_2:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p15_3:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p15_4:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p15_5:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p15_6:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
		UINT8	p15_7:1;	/* RW /o͒[q̃x 0B:Low/1B:High		*/
	} bit;
	UINT8	byte;
} P15_TYPE;
P15_TYPE	p15_addr;

#define		P15			p15_addr.byte
#define		P15_0		p15_addr.bit.p15_0
#define		P15_1		p15_addr.bit.p15_1
#define		P15_2		p15_addr.bit.p15_2
#define		P15_3		p15_addr.bit.p15_3
#define		P15_4		p15_addr.bit.p15_4
#define		P15_5		p15_addr.bit.p15_5
#define		P15_6		p15_addr.bit.p15_6
#define		P15_7		p15_addr.bit.p15_7

/*------------------------------------------------------
	Function select register A0
------------------------------------------------------*/
#pragma ADDRESS		ps0_addr	03b0H	/* @\IWX^A0				*/
typedef union {
	struct{
		UINT8	ps0_0:1;
		UINT8	ps0_1:1;
		UINT8	ps0_2:1;
		UINT8	ps0_3:1;
		UINT8	ps0_4:1;
		UINT8	ps0_5:1;
		UINT8	ps0_6:1;
		UINT8	ps0_7:1;
	} bit;
	UINT8	byte;
} PS0_TYPE;
PS0_TYPE	ps0_addr;

#define		PS0			ps0_addr.byte
#define		PS0_0		ps0_addr.bit.ps0_0
#define		PS0_1		ps0_addr.bit.ps0_1
#define		PS0_2		ps0_addr.bit.ps0_2
#define		PS0_3		ps0_addr.bit.ps0_3
#define		PS0_4		ps0_addr.bit.ps0_4
#define		PS0_5		ps0_addr.bit.ps0_5
#define		PS0_6		ps0_addr.bit.ps0_6
#define		PS0_7		ps0_addr.bit.ps0_7

/*------------------------------------------------------
	Function select register A1
------------------------------------------------------*/
#pragma ADDRESS		ps1_addr	03b1H	/* @\IWX^A1				*/
typedef union {
	struct{
		UINT8	ps1_0:1;
		UINT8	ps1_1:1;
		UINT8	ps1_2:1;
		UINT8	ps1_3:1;
		UINT8	ps1_4:1;
		UINT8	ps1_5:1;
		UINT8	ps1_6:1;
		UINT8	ps1_7:1;
	} bit;
	UINT8	byte;
} PS1_TYPE;
PS1_TYPE	ps1_addr;

#define		PS1			ps1_addr.byte
#define		PS1_0		ps1_addr.bit.ps1_0
#define		PS1_1		ps1_addr.bit.ps1_1
#define		PS1_2		ps1_addr.bit.ps1_2
#define		PS1_3		ps1_addr.bit.ps1_3
#define		PS1_4		ps1_addr.bit.ps1_4
#define		PS1_5		ps1_addr.bit.ps1_5
#define		PS1_6		ps1_addr.bit.ps1_6
#define		PS1_7		ps1_addr.bit.ps1_7

/*------------------------------------------------------
	Function select register A2
------------------------------------------------------*/
#pragma ADDRESS		ps2_addr	03b4H	/* @\IWX^A2				*/
typedef union {
	struct{
		UINT8	ps2_0:1;
		UINT8	ps2_1:1;
		UINT8	ps2_2:1;
		UINT8	reserved1:2;	/* RW 0Œ									*/
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	reserved2:2;	/* RW 0Œ									*/
	} bit;
	UINT8	byte;
} PS2_TYPE;
PS2_TYPE	ps2_addr;

#define		PS2			ps2_addr.byte
#define		PS2_0		ps2_addr.bit.ps2_0
#define		PS2_1		ps2_addr.bit.ps2_1
#define		PS2_2		ps2_addr.bit.ps2_2

/*------------------------------------------------------
	Function select register A3
------------------------------------------------------*/
#pragma ADDRESS		ps3_addr	03b5H	/* @\IWX^A3				*/
typedef union {
	struct{
		UINT8	ps3_0:1;
		UINT8	ps3_1:1;
		UINT8	ps3_2:1;
		UINT8	ps3_3:1;
		UINT8	ps3_4:1;
		UINT8	ps3_5:1;
		UINT8	ps3_6:1;
		UINT8	ps3_7:1;
	} bit;
	UINT8	byte;
} PS3_TYPE;
PS3_TYPE	ps3_addr;

#define		PS3			ps3_addr.byte
#define		PS3_0		ps3_addr.bit.ps3_0
#define		PS3_1		ps3_addr.bit.ps3_1
#define		PS3_2		ps3_addr.bit.ps3_2
#define		PS3_3		ps3_addr.bit.ps3_3
#define		PS3_4		ps3_addr.bit.ps3_4
#define		PS3_5		ps3_addr.bit.ps3_5
#define		PS3_6		ps3_addr.bit.ps3_6
#define		PS3_7		ps3_addr.bit.ps3_7

/*------------------------------------------------------
	Function select register A5
------------------------------------------------------*/
#pragma ADDRESS		ps5_addr	03b9H	/* @\IWX^A5				*/
typedef union {
	struct{
		UINT8	ps5_0:1;
		UINT8	ps5_1:1;
		UINT8	ps5_2:1;
		UINT8	ps5_3:1;
		UINT8	reserved:1;		/* RW 0Œ									*/
		UINT8	no_assign:3;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} PS5_TYPE;
PS5_TYPE	ps5_addr;

#define		PS5			ps5_addr.byte
#define		PS5_0		ps5_addr.bit.ps5_0
#define		PS5_1		ps5_addr.bit.ps5_1
#define		PS5_2		ps5_addr.bit.ps5_2
#define		PS5_3		ps5_addr.bit.ps5_3

/*------------------------------------------------------
	Function select register A8
------------------------------------------------------*/
#pragma ADDRESS		ps8_addr	03a0H	/* @\IWX^A8				*/
typedef union {
	struct{
		UINT8	ps8_0:1;
		UINT8	ps8_1:1;
		UINT8	ps8_2:1;
		UINT8	ps8_3:1;
		UINT8	reserved:3;		/* RW 0Œ									*/
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} PS8_TYPE;
PS8_TYPE	ps8_addr;

#define		PS8			ps8_addr.byte
#define		PS8_0		ps8_addr.bit.ps8_0
#define		PS8_1		ps8_addr.bit.ps8_1
#define		PS8_2		ps8_addr.bit.ps8_2
#define		PS8_3		ps8_addr.bit.ps8_3

/*------------------------------------------------------
	Function select register A9
------------------------------------------------------*/
#pragma ADDRESS		ps9_addr	03a1H	/* @\IWX^A9				*/
typedef union {
	struct{
		UINT8	ps9_0:1;
		UINT8	ps9_1:1;
		UINT8	reserved:6;		/* RW 0Œ									*/
	} bit;
	UINT8	byte;
} PS9_TYPE;
PS9_TYPE	ps9_addr;

#define		PS9			ps9_addr.byte
#define		PS9_0		ps9_addr.bit.ps9_0
#define		PS9_1		ps9_addr.bit.ps9_1

/*------------------------------------------------------
	Function select register B0
------------------------------------------------------*/
#pragma ADDRESS		psl0_addr	03b2H	/* @\IWX^B0				*/
typedef union {
	struct{
		UINT8	reserved1:2;	/* RW 0Œ									*/
		UINT8	psl0_2:1;
		UINT8	reserved2:1;	/* RW 0Œ									*/
		UINT8	psl0_4:1;
		UINT8	reserved3:1;	/* RW 0Œ									*/
		UINT8	psl0_6:1;
		UINT8	reserved4:1;	/* RW 0Œ									*/
	} bit;
	UINT8	byte;
} PSL0_TYPE;
PSL0_TYPE	psl0_addr;

#define		PSL0		psl0_addr.byte
#define		PSL0_2		psl0_addr.bit.psl0_2
#define		PSL0_4		psl0_addr.bit.psl0_4
#define		PSL0_6		psl0_addr.bit.psl0_6

/*------------------------------------------------------
	Function select register B1
------------------------------------------------------*/
#pragma ADDRESS		psl1_addr	03b3H	/* @\IWX^B1				*/
typedef union {
	struct{
		UINT8	psl1_0:1;
		UINT8	psl1_1:1;
		UINT8	psl1_2:1;
		UINT8	psl1_3:1;
		UINT8	psl1_4:1;
		UINT8	psl1_5:1;
		UINT8	psl1_6:1;
		UINT8	psl1_7:1;
	} bit;
	UINT8	byte;
} PSL1_TYPE;
PSL1_TYPE	psl1_addr;

#define		PSL1		psl1_addr.byte
#define		PSL1_0		psl1_addr.bit.psl1_0
#define		PSL1_1		psl1_addr.bit.psl1_1
#define		PSL1_2		psl1_addr.bit.psl1_2
#define		PSL1_3		psl1_addr.bit.psl1_3
#define		PSL1_4		psl1_addr.bit.psl1_4
#define		PSL1_5		psl1_addr.bit.psl1_5
#define		PSL1_6		psl1_addr.bit.psl1_6
#define		PSL1_7		psl1_addr.bit.psl1_7

/*------------------------------------------------------
	Function select register B2
------------------------------------------------------*/
#pragma ADDRESS		psl2_addr	03b6H	/* @\IWX^B2				*/
typedef union {
	struct{
		UINT8	psl2_0:1;
		UINT8	psl2_1:1;
		UINT8	psl2_2:1;
		UINT8	reserved1:2;	/* RW 0Œ									*/
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	reserved2:2;	/* RW 0Œ									*/
	} bit;
	UINT8	byte;
} PSL2_TYPE;
PSL2_TYPE	psl2_addr;

#define		PSL2		psl2_addr.byte
#define		PSL2_0		psl2_addr.bit.psl2_0
#define		PSL2_1		psl2_addr.bit.psl2_1
#define		PSL2_2		psl2_addr.bit.psl2_2

/*------------------------------------------------------
	Function select register B3
------------------------------------------------------*/
#pragma ADDRESS		psl3_addr	03b7H	/* @\IWX^B3				*/
typedef union {
	struct{
		UINT8	reserved:2;		/* RW 0Œ									*/
		UINT8	psl3_1:1;
		UINT8	psl3_2:1;
		UINT8	psl3_3:1;
		UINT8	psl3_4:1;
		UINT8	psl3_5:1;
		UINT8	psl3_6:1;
		UINT8	psl3_7:1;
	} bit;
	UINT8	byte;
} PSL3_TYPE;
PSL3_TYPE	psl3_addr;

#define		PSL3		psl3_addr.byte
#define		PSL3_1		psl3_addr.bit.psl3_1
#define		PSL3_2		psl3_addr.bit.psl3_2
#define		PSL3_3		psl3_addr.bit.psl3_3
#define		PSL3_4		psl3_addr.bit.psl3_4
#define		PSL3_5		psl3_addr.bit.psl3_5
#define		PSL3_6		psl3_addr.bit.psl3_6
#define		PSL3_7		psl3_addr.bit.psl3_7

/*------------------------------------------------------
	Function select register C
------------------------------------------------------*/
#pragma ADDRESS		psc_addr	03afH	/* @\IWX^C				*/
typedef union {
	struct{
		UINT8	psc_0:1;
		UINT8	psc_1:1;
		UINT8	psc_2:1;
		UINT8	psc_3:1;
		UINT8	psc_4:1;
		UINT8	no_assign:1;	/*    s ޏꍇ0					*/
		UINT8	psc_6:1;
		UINT8	psc_7:1;
	} bit;
	UINT8	byte;
} PSC_TYPE;
PSC_TYPE	psc_addr;

#define		PSC			psc_addr.byte
#define		PSC_0		psc_addr.bit.psc_0
#define		PSC_1		psc_addr.bit.psc_1
#define		PSC_2		psc_addr.bit.psc_2
#define		PSC_3		psc_addr.bit.psc_3
#define		PSC_4		psc_addr.bit.psc_4
#define		PSC_6		psc_addr.bit.psc_6
#define		PSC_7		psc_addr.bit.psc_7

/*------------------------------------------------------
	Function select register C2
------------------------------------------------------*/
#pragma ADDRESS		psc2_addr	03acH	/* @\IWX^C2				*/
typedef union {
	struct{
		UINT8	no_assign1:1;	/*    s ޏꍇ0					*/
		UINT8	psc2_1:1;
		UINT8	psc2_2:1;
		UINT8	no_assign2:5;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} PSC2_TYPE;
PSC2_TYPE	psc2_addr;

#define		PSC2		psc2_addr.byte
#define		PSC2_1		psc2_addr.bit.psc2_1
#define		PSC2_2		psc2_addr.bit.psc2_2

/*------------------------------------------------------
	Function select register C3
------------------------------------------------------*/
#pragma ADDRESS		psc3_addr	03adH	/* @\IWX^C3				*/
typedef union {
	struct{
		UINT8	no_assign1:6;	/*    s ޏꍇ0					*/
		UINT8	psc3_6:1;
		UINT8	no_assign2:1;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} PSC3_TYPE;
PSC3_TYPE	psc3_addr;

#define		PSC3		psc3_addr.byte
#define		PSC3_6		psc3_addr.bit.psc3_6

/*------------------------------------------------------
	Function select register D1
------------------------------------------------------*/
#pragma ADDRESS		psd1_addr	03a7H	/* @\IWX^D1				*/
typedef union {
	struct{
		UINT8	psd1_0:1;
		UINT8	psd1_1:1;
		UINT8	no_assign1:4;	/*    s ޏꍇ0					*/
		UINT8	psd1_6:1;
		UINT8	no_assign2:1;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} PSD1_TYPE;
PSD1_TYPE	psd1_addr;

#define		PSD1		psd1_addr.byte
#define		PSD1_0		psd1_addr.bit.psd1_0
#define		PSD1_1		psd1_addr.bit.psd1_1
#define		PSD1_6		psd1_addr.bit.psd1_6

/*------------------------------------------------------
	Pull-up control register 0
------------------------------------------------------*/
#pragma ADDRESS		pur0_addr	03f0H	/* vAbv䃌WX^0			*/
typedef union {
	struct{
		UINT8	pu00:1;
		UINT8	pu01:1;
		UINT8	pu02:1;
		UINT8	pu03:1;
		UINT8	pu04:1;
		UINT8	pu05:1;
		UINT8	pu06:1;
		UINT8	pu07:1;
	} bit;
	UINT8	byte;
} PUR0_TYPE;
PUR0_TYPE	pur0_addr;

#define		PUR0		pur0_addr.byte
#define		PU00		pur0_addr.bit.pu00
#define		PU01		pur0_addr.bit.pu01
#define		PU02		pur0_addr.bit.pu02
#define		PU03		pur0_addr.bit.pu03
#define		PU04		pur0_addr.bit.pu04
#define		PU05		pur0_addr.bit.pu05
#define		PU06		pur0_addr.bit.pu06
#define		PU07		pur0_addr.bit.pu07

/*------------------------------------------------------
	Pull-up control register 1
------------------------------------------------------*/
#pragma ADDRESS		pur1_addr	03f1H	/* vAbv䃌WX^1			*/
typedef union {
	struct{
		UINT8	pu10:1;
		UINT8	pu11:1;
		UINT8	pu12:1;
		UINT8	pu13:1;
		UINT8	no_assign:4;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} PUR1_TYPE;
PUR1_TYPE	pur1_addr;

#define		PUR1		pur1_addr.byte
#define		PU10		pur1_addr.bit.pu10
#define		PU11		pur1_addr.bit.pu11
#define		PU12		pur1_addr.bit.pu12
#define		PU13		pur1_addr.bit.pu13

/*------------------------------------------------------
	Pull-up control register 2
------------------------------------------------------*/
#pragma ADDRESS		pur2_addr	03daH	/* vAbv䃌WX^2			*/
typedef union {
	struct{
		UINT8	pu20:1;
		UINT8	pu21:1;
		UINT8	pu22:1;
		UINT8	pu23:1;
		UINT8	pu24:1;
		UINT8	pu25:1;
		UINT8	pu26:1;
		UINT8	pu27:1;
	} bit;
	UINT8	byte;
} PUR2_TYPE;
PUR2_TYPE	pur2_addr;

#define		PUR2		pur2_addr.byte
#define		PU20		pur2_addr.bit.pu20
#define		PU21		pur2_addr.bit.pu21
#define		PU22		pur2_addr.bit.pu22
#define		PU23		pur2_addr.bit.pu23
#define		PU24		pur2_addr.bit.pu24
#define		PU25		pur2_addr.bit.pu25
#define		PU26		pur2_addr.bit.pu26
#define		PU27		pur2_addr.bit.pu27

/*------------------------------------------------------
	Pull-up control register 3
------------------------------------------------------*/
#pragma ADDRESS		pur3_addr	03dbH	/* vAbv䃌WX^3			*/
typedef union {
	struct{
		UINT8	pu30:1;
		UINT8	pu31:1;
		UINT8	pu32:1;
		UINT8	pu33:1;
		UINT8	pu34:1;
		UINT8	pu35:1;
		UINT8	pu36:1;
		UINT8	pu37:1;
	} bit;
	UINT8	byte;
} PUR3_TYPE;
PUR3_TYPE	pur3_addr;

#define		PUR3		pur3_addr.byte
#define		PU30		pur3_addr.bit.pu30
#define		PU31		pur3_addr.bit.pu31
#define		PU32		pur3_addr.bit.pu32
#define		PU33		pur3_addr.bit.pu33
#define		PU34		pur3_addr.bit.pu34
#define		PU35		pur3_addr.bit.pu35
#define		PU36		pur3_addr.bit.pu36
#define		PU37		pur3_addr.bit.pu37

/*------------------------------------------------------
	Pull-up control register 4
------------------------------------------------------*/
#pragma ADDRESS		pur4_addr	03dcH	/* vAbv䃌WX^4			*/
typedef union {
	struct{
		UINT8	pu40:1;
		UINT8	pu41:1;
		UINT8	pu42:1;
		UINT8	pu43:1;
		UINT8	no_assign:4;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} PUR4_TYPE;
PUR4_TYPE	pur4_addr;

#define		PUR4		pur4_addr.byte
#define		PU40		pur4_addr.bit.pu40
#define		PU41		pur4_addr.bit.pu41
#define		PU42		pur4_addr.bit.pu42
#define		PU43		pur4_addr.bit.pu43

/*------------------------------------------------------
	Port control register
------------------------------------------------------*/
#pragma ADDRESS		pcr_addr	03ffH	/* |[g䃌WX^				*/
typedef union {
	struct{
		UINT8	pcr0:1;
		UINT8	reserved:2;		/* RW 0Œ									*/
		UINT8	no_assign:5;	/*    s ޏꍇ0					*/
	} bit;
	UINT8	byte;
} PCR_TYPE;
PCR_TYPE	pcr_addr;

#define		PCR			pcr_addr.byte
#define		PCR0		pcr_addr.bit.pcr0

/*------------------------------------------------------
	Input function select register
------------------------------------------------------*/
#pragma ADDRESS		ips_addr	0178H	/* ͋@\IWX^				*/
typedef union {
	struct{
		UINT8	ips0:1;
		UINT8	ips1:1;
		UINT8	ips2:1;
		UINT8	ips3:1;
		UINT8	reserved:4;		/* RW 0Œ									*/
	} bit;
	UINT8	byte;
} IPS_TYPE;
IPS_TYPE	ips_addr;

#define		IPS			ips_addr.byte
#define		IPS0		ips_addr.bit.ips0
#define		IPS1		ips_addr.bit.ips1
#define		IPS2		ips_addr.bit.ips2
#define		IPS3		ips_addr.bit.ips3

/*------------------------------------------------------
	Input function select register A
------------------------------------------------------*/
#pragma ADDRESS		ipsa_addr	0179H	/* ͋@\IWX^A			*/
typedef union {
	struct{
		UINT8	ipsa0:1;
		UINT8	reserved1:2;	/* RW 0Œ									*/
		UINT8	ipsa3:1;
		UINT8	reserved2:4;	/* RW 0Œ									*/
	} bit;
	UINT8	byte;
} IPSA_TYPE;
IPSA_TYPE	ipsa_addr;

#define		IPSA		ipsa_addr.byte
#define		IPSA0		ipsa_addr.bit.ipsa0
#define		IPSA3		ipsa_addr.bit.ipsa3

/********************************************************/
/* tbV									*/
/********************************************************/
/*------------------------------------------------------
	Flash memory control register 0
------------------------------------------------------*/
#pragma ADDRESS		fmr0_addr	0057H	/* tbV䃌WX^0	*/
typedef union {
	struct{
		UINT8	fmr00:1;  
		UINT8	fmr01:1;  
		UINT8	fmr02:1;  
		UINT8	fmr03:1;  
		UINT8	reserved:1;		/* RW 0Œ									*/
		UINT8	fmr05:1;  
		UINT8	fmr06:1;  
		UINT8	fmr07:1;  
	} bit;
	UINT8	byte;
} FMR0_TYPE;
FMR0_TYPE	fmr0_addr;

#define		FMR0		fmr0_addr.byte
#define		FMR00		fmr0_addr.bit.fmr00
#define		FMR01		fmr0_addr.bit.fmr01
#define		FMR02		fmr0_addr.bit.fmr02
#define		FMR03		fmr0_addr.bit.fmr03
#define		FMR05		fmr0_addr.bit.fmr05
#define		FMR06		fmr0_addr.bit.fmr06
#define		FMR07		fmr0_addr.bit.fmr07

/*------------------------------------------------------
	Flash memory control register 1
------------------------------------------------------*/
#pragma ADDRESS		fmr1_addr	0055H	/* tbV䃌WX^1	*/
typedef union {
	struct{
		UINT8	reserved1:1;	/* RO s									*/
		UINT8	fmr11:1;
		UINT8	reserved2:2;	/* RO s									*/
		UINT8	reserved3:2;	/* RW 0Œ									*/
		UINT8	fmr16:1;
		UINT8	reserved4:1;	/* RW 0Œ									*/
	} bit;
	UINT8	byte;
} FMR1_TYPE;
FMR1_TYPE	fmr1_addr;

#define		FMR1		fmr1_addr.byte
#define		FMR11		fmr1_addr.bit.fmr11
#define		FMR16		fmr1_addr.bit.fmr16

#endif	/* _SFR_M32C_85_H_	*/

